# Documenter

*A documentation generator for Julia.*

| **Documentation**                                                               | **Build Status**                                                                                |
|:-------------------------------------------------------------------------------:|:-----------------------------------------------------------------------------------------------:|
| [![][docs-stable-img]][docs-stable-url] [![][docs-dev-img]][docs-dev-url] | [![][GHA-img]][GHA-url] [![][regressions-img]][regressions-url] [![][codecov-img]][codecov-url] [![PkgEval][pkgeval-img]][pkgeval-url] |


## Installation

The package can be installed with the Julia package manager.
From the Julia REPL, type `]` to enter the Pkg REPL mode and run:

```
pkg> add Documenter
```

Or, equivalently, via the `Pkg` API:

```julia
julia> import Pkg; Pkg.add("Documenter")
```

## Documentation

- [**STABLE**][docs-stable-url] &mdash; **documentation of the most recently tagged version.**
- [**DEVEL**][docs-dev-url] &mdash; *documentation of the in-development version.*

## Project Status

The package is tested against, and being developed for, Julia `1.6` and above on Linux, macOS, and Windows.

## Questions and Contributions

Usage questions can be posted on the [Julia Discourse forum][discourse-tag-url] under the `documenter` tag, in the #documentation channel of the [Julia Slack](https://julialang.org/community/) and/or in the [JuliaDocs Gitter chat room][gitter-url].

Contributions are very welcome, as are feature requests and suggestions. Please open an [issue][issues-url] if you encounter any problems. The [contributing page][contrib-url] has a few guidelines that should be followed when opening pull requests and contributing code.

## Related packages

There are several packages that extend Documenter in different ways. The JuliaDocs organization maintains:

* [DocumenterCitations.jl](https://github.com/JuliaDocs/DocumenterCitations.jl)
* [DocumenterInterLinks.jl](https://github.com/JuliaDocs/DocumenterInterLinks.jl)
* [DocumenterMarkdown.jl](https://github.com/JuliaDocs/DocumenterMarkdown.jl)
* [DocumenterTools.jl](https://github.com/JuliaDocs/DocumenterTools.jl)
* [LiveServer.jl](https://github.com/JuliaDocs/LiveServer.jl)

Other third-party packages that can be combined with Documenter include:

* [DemoCards.jl](https://github.com/JuliaDocs/DemoCards.jl)
* [Literate.jl](https://github.com/fredrikekre/Literate.jl)
* [QuizQuestions.jl](https://github.com/jverzani/QuizQuestions.jl)
* [DocumenterMermaid.jl](https://github.com/JuliaDocs/DocumenterMermaid.jl)
* [DocumenterDiagrams.jl](https://github.com/pedromxavier/DocumenterDiagrams.jl)

Finally, there are also a few other packages in the Julia ecosystem that are similar to Documenter, but fill a slightly different niche:

* [Franklin.jl](https://github.com/tlienart/Franklin.jl)
* [Publish.jl](https://github.com/MichaelHatherly/Publish.jl)
* [Weave.jl](https://github.com/JunoLab/Weave.jl)

[contrib-url]: https://documenter.juliadocs.org/dev/contributing/
[discourse-tag-url]: https://discourse.julialang.org/tags/documenter
[gitter-url]: https://gitter.im/juliadocs/users

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://documenter.juliadocs.org/dev

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://documenter.juliadocs.org/stable

[GHA-img]: https://github.com/JuliaDocs/Documenter.jl/actions/workflows/CI.yml/badge.svg
[GHA-url]: https://github.com/JuliaDocs/Documenter.jl/actions/workflows/CI.yml

[regressions-img]: https://github.com/JuliaDocs/Documenter.jl/actions/workflows/regression-tests.yml/badge.svg
[regressions-url]: https://github.com/JuliaDocs/Documenter.jl/actions/workflows/regression-tests.yml

[codecov-img]: https://codecov.io/gh/JuliaDocs/Documenter.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaDocs/Documenter.jl

[issues-url]: https://github.com/JuliaDocs/Documenter.jl/issues

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/D/Documenter.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/D/Documenter.html

# Notes on the Documenter test suite


## Regenerating / 'fixing' tests

Several of the tests run Documenter on some sample inputs and then compare the
output to a reference document, to check that nothing changed. Sometimes
however it is necessary to update the reference document to deliberate
changes; e.g. when new content was added to one of the inputs.

To update or "fix" the reference documents, simple make sure the
`DOCUMENTER_FIXTESTS` environment variable is set before running the tests.

However, this is not meant to "paper over" regressions. Please carefully check
that result of such a "fixtest" run.

# Search Edge Case Test Suite

This directory contains a dedicated test suite for Documenter.jl's search functionality.
The purpose of this suite is to provide a controlled environment for testing edge cases
that may not be present in the main documentation.

## Adding New Test Cases

To add a new test case, create a new `.md` file in the `src/` directory. Then, add
the file to the `pages` array in `make.jl`.

import JSON

"""
    DeployConfig

Abstract type which new deployment configs should be subtypes of.
"""
abstract type DeployConfig end

"""
    DeployDecision(; kwargs...)

Struct containing information about the decision to deploy or not deploy.

# Arguments

- `all_ok::Bool` - Should documentation be deployed?
- `branch::String` - The branch to which documentation should be pushed
- `is_preview::Bool` - Is this documentation build a pull request?
- `repo::String` - The repo to which documentation should be pushed
- `subfolder::String` - The subfolder to which documentation should be pushed
"""
Base.@kwdef struct DeployDecision
    all_ok::Bool
    branch::String = ""
    is_preview::Bool = false
    repo::String = ""
    subfolder::String = ""
end

"""
    Documenter.documenter_key(cfg::DeployConfig)

Return the Base64-encoded SSH private key for the repository.
Defaults to reading the `DOCUMENTER_KEY` environment variable.

This method must be supported by configs that push with SSH, see
[`Documenter.authentication_method`](@ref).
"""
function documenter_key(::DeployConfig)
    return ENV["DOCUMENTER_KEY"]
end

"""
    Documenter.documenter_key_previews(cfg::DeployConfig)

Return the Base64-encoded SSH private key for the repository.
Uses the `DOCUMENTER_KEY_PREVIEWS` environment variable if it is defined,
otherwise uses the `DOCUMENTER_KEY` environment variable.

This method must be supported by configs that push with SSH, see
[`Documenter.authentication_method`](@ref).
"""
function documenter_key_previews(cfg::DeployConfig)
    return get(ENV, "DOCUMENTER_KEY_PREVIEWS", documenter_key(cfg))
end

function _decode_key_content(keycontent)
    # If `keycontent` contains both `-----BEGIN` AND `-----END`, then we assume that it is
    # a plaintext private key, and we don't try to Base64-decode it.
    #
    # Otherwise, we conclude that it must be a Base64-encoded private key, and we try to
    # Base64-decode it.
    is_plaintext_key = occursin("-----BEGIN", keycontent) && occursin("-----END", keycontent)
    if is_plaintext_key
        @debug "This looks like a plaintext private key, so we won't try to Base64-decode it"
        # The private key file must end in a trailing newline
        return keycontent * '\n'
    else
        @debug "We conclude that this must be a Base64-encoded private key"
        return base64decode(keycontent)
    end
end

"""
    Documenter.deploy_folder(
        cfg::DeployConfig; repo, devbranch, push_preview, devurl,
        tag_prefix, kwargs...
    )

Return a `DeployDecision`.
This function is called with the `repo`, `devbranch`, `push_preview`, `tag_prefix`,
and `devurl` arguments from [`deploydocs`](@ref).

!!! note
    Implementations of this function should accept trailing `kwargs...` for
    compatibility with future Documenter releases which may pass additional
    keyword arguments.
"""
function deploy_folder(cfg::DeployConfig; kwargs...)
    @warn "Documenter.deploy_folder(::$(typeof(cfg)); kwargs...) not implemented. Skipping deployment."
    return DeployDecision(; all_ok = false)
end
function deploy_folder(::Nothing; kwargs...)
    @warn "Documenter could not auto-detect the building environment. Skipping deployment."
    return DeployDecision(; all_ok = false)
end

@enum AuthenticationMethod SSH HTTPS

"""
    Documenter.authentication_method(::DeployConfig)

Return enum instance `SSH` or `HTTPS` depending on push method to be used.

Configs returning `SSH` should support [`Documenter.documenter_key`](@ref).
Configs returning `HTTPS` should support [`Documenter.authenticated_repo_url`](@ref).
"""
authentication_method(::DeployConfig) = SSH

"""
    Documenter.authenticated_repo_url(cfg::DeployConfig)

Return an authenticated URL to the upstream repository.

This method must be supported by configs that push with HTTPS, see
[`Documenter.authentication_method`](@ref).
"""
function authenticated_repo_url end

post_status(cfg::Union{DeployConfig, Nothing}; kwargs...) = nothing

marker(x) = x ? "✔" : "✘"

env_nonempty(key) = !isempty(get(ENV, key, ""))

#############
# Travis CI #
#############

"""
    Travis <: DeployConfig

Default implementation of `DeployConfig`.

The following environment variables influence the build
when using the `Travis` configuration:

 - `DOCUMENTER_KEY`: must contain the Base64-encoded SSH private key for the repository.
   This variable should be set in the Travis settings for the repository. Make sure this
   variable is marked **NOT** to be displayed in the build log.

 - `TRAVIS_PULL_REQUEST`: must be set to `false`.
   This avoids deployment on pull request builds.

 - `TRAVIS_REPO_SLUG`: must match the value of the `repo` keyword to [`deploydocs`](@ref).

 - `TRAVIS_EVENT_TYPE`: may not be set to `cron`. This avoids re-deployment of existing
   docs on builds that were triggered by a Travis cron job.

 - `TRAVIS_BRANCH`: unless `TRAVIS_TAG` is non-empty, this must have the same value as
   the `devbranch` keyword to [`deploydocs`](@ref). This makes sure that only the
   development branch (commonly, the `master` branch) will deploy the "dev" documentation
   (deployed into a directory specified by the `devurl` keyword to [`deploydocs`](@ref)).

 - `TRAVIS_TAG`: if set, a tagged version deployment is performed instead; the value
   must be a valid version number (i.e. match `Base.VERSION_REGEX`). The documentation for
   a package version tag gets deployed to a directory named after the version number in
   `TRAVIS_TAG` instead.

The `TRAVIS_*` variables are set automatically on Travis. More information on how Travis
sets the `TRAVIS_*` variables can be found in the
[Travis documentation](https://docs.travis-ci.com/user/environment-variables/#default-environment-variables).
"""
struct Travis <: DeployConfig
    travis_branch::String
    travis_pull_request::String
    travis_repo_slug::String
    travis_tag::String
    travis_event_type::String
end
function Travis()
    travis_branch = get(ENV, "TRAVIS_BRANCH", "")
    travis_pull_request = get(ENV, "TRAVIS_PULL_REQUEST", "")
    travis_repo_slug = get(ENV, "TRAVIS_REPO_SLUG", "")
    travis_tag = get(ENV, "TRAVIS_TAG", "")
    travis_event_type = get(ENV, "TRAVIS_EVENT_TYPE", "")
    return Travis(
        travis_branch, travis_pull_request,
        travis_repo_slug, travis_tag, travis_event_type
    )
end

# Check criteria for deployment
function deploy_folder(
        cfg::Travis;
        repo,
        repo_previews = nothing,
        deploy_repo = nothing,
        branch = "gh-pages",
        branch_previews = branch,
        devbranch,
        push_preview,
        devurl,
        tag_prefix = "",
        kwargs...
    )
    io = IOBuffer()
    all_ok = true
    ## Determine build type; release, devbranch or preview
    if cfg.travis_pull_request != "false"
        build_type = :preview
    elseif !isempty(cfg.travis_tag)
        build_type = :release
    else
        build_type = :devbranch
    end
    println(io, "Deployment criteria for deploying $(build_type) build from Travis:")
    ## The deploydocs' repo should match TRAVIS_REPO_SLUG
    repo_ok = occursin(cfg.travis_repo_slug, repo)
    all_ok &= repo_ok
    println(io, "- $(marker(repo_ok)) ENV[\"TRAVIS_REPO_SLUG\"]=\"$(cfg.travis_repo_slug)\" occurs in repo=\"$(repo)\"")
    if build_type === :release
        ## Do not deploy for PRs
        pr_ok = cfg.travis_pull_request == "false"
        println(io, "- $(marker(pr_ok)) ENV[\"TRAVIS_PULL_REQUEST\"]=\"$(cfg.travis_pull_request)\" is \"false\"")
        all_ok &= pr_ok
        tag_nobuild = version_tag_strip_build(cfg.travis_tag; tag_prefix)
        ## If a tag exist it should be a valid VersionNumber
        tag_ok = tag_nobuild !== nothing
        all_ok &= tag_ok
        println(io, "- $(marker(tag_ok)) ENV[\"TRAVIS_TAG\"] contains a valid VersionNumber")
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
        is_preview = false
        ## Deploy to folder according to the tag
        subfolder = tag_nobuild
    elseif build_type === :devbranch
        ## Do not deploy for PRs
        pr_ok = cfg.travis_pull_request == "false"
        println(io, "- $(marker(pr_ok)) ENV[\"TRAVIS_PULL_REQUEST\"]=\"$(cfg.travis_pull_request)\" is \"false\"")
        all_ok &= pr_ok
        ## deploydocs' devbranch should match TRAVIS_BRANCH
        branch_ok = !isempty(cfg.travis_tag) || cfg.travis_branch == devbranch
        all_ok &= branch_ok
        println(io, "- $(marker(branch_ok)) ENV[\"TRAVIS_BRANCH\"] matches devbranch=\"$(devbranch)\"")
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
        is_preview = false
        ## Deploy to deploydocs devurl kwarg
        subfolder = devurl
    else # build_type === :preview
        pr_number = tryparse(Int, cfg.travis_pull_request)
        pr_ok = pr_number !== nothing
        all_ok &= pr_ok
        println(io, "- $(marker(pr_ok)) ENV[\"TRAVIS_PULL_REQUEST\"]=\"$(cfg.travis_pull_request)\" is a number")
        btype_ok = push_preview
        all_ok &= btype_ok
        println(io, "- $(marker(btype_ok)) `push_preview` keyword argument to deploydocs is `true`")
        deploy_branch = branch_previews
        deploy_repo = something(repo_previews, deploy_repo, repo)
        is_preview = true
        ## deploy to previews/PR
        subfolder = "previews/PR$(something(pr_number, 0))"
    end
    ## DOCUMENTER_KEY should exist (just check here and extract the value later)
    key_ok = env_nonempty("DOCUMENTER_KEY")
    all_ok &= key_ok
    println(io, "- $(marker(key_ok)) ENV[\"DOCUMENTER_KEY\"] exists and is non-empty")
    ## Cron jobs should not deploy
    type_ok = cfg.travis_event_type != "cron"
    all_ok &= type_ok
    println(io, "- $(marker(type_ok)) ENV[\"TRAVIS_EVENT_TYPE\"]=\"$(cfg.travis_event_type)\" is not \"cron\"")
    print(io, "Deploying: $(marker(all_ok))")
    @info String(take!(io))
    if build_type === :devbranch && !branch_ok && devbranch == "master" && cfg.travis_branch == "main"
        @warn """
        Possible deploydocs() misconfiguration: main vs master
        Documenter's configured primary development branch (`devbranch`) is "master", but the
        current branch (\$TRAVIS_BRANCH) is "main". This can happen because Documenter uses
        GitHub's old default primary branch name as the default value for `devbranch`.

        If your primary development branch is 'main', you must explicitly pass `devbranch = "main"`
        to deploydocs.

        See #1443 for more discussion: https://github.com/JuliaDocs/Documenter.jl/issues/1443
        """
    end
    if all_ok
        return DeployDecision(;
            all_ok = true,
            branch = deploy_branch,
            is_preview = is_preview,
            repo = deploy_repo,
            subfolder = subfolder
        )
    else
        return DeployDecision(; all_ok = false)
    end
end


##################
# GitHub Actions #
##################

"""
    GitHubActions <: DeployConfig

Implementation of `DeployConfig` for deploying from GitHub Actions.

The following environment variables influence the build
when using the `GitHubActions` configuration:

 - `GITHUB_EVENT_NAME`: must be set to `push`, `workflow_dispatch`, or `schedule`.
   This avoids deployment on pull request builds.

 - `GITHUB_REPOSITORY`: must match the value of the `repo` keyword to [`deploydocs`](@ref).

 - `GITHUB_REF`: must match the `devbranch` keyword to [`deploydocs`](@ref), alternatively
   correspond to a git tag.

 - `GITHUB_TOKEN` or `DOCUMENTER_KEY`: used for authentication with GitHub,
   see the manual section for [GitHub Actions](@ref) for more information.

The `GITHUB_*` variables are set automatically on GitHub Actions, see the
[documentation](https://docs.github.com/en/actions/reference/workflows-and-actions/variables#default-environment-variables).
"""
struct GitHubActions <: DeployConfig
    github_repository::String
    github_event_name::String
    github_ref::String
end
function GitHubActions()
    github_repository = get(ENV, "GITHUB_REPOSITORY", "") # "JuliaDocs/Documenter.jl"
    github_event_name = get(ENV, "GITHUB_EVENT_NAME", "") # "push", "pull_request" or "cron" (?)
    github_ref = get(ENV, "GITHUB_REF", "") # "refs/heads/$(branchname)" for branch, "refs/tags/$(tagname)" for tags
    return GitHubActions(github_repository, github_event_name, github_ref)
end

# Check criteria for deployment
function deploy_folder(
        cfg::GitHubActions;
        repo,
        repo_previews = nothing,
        deploy_repo = nothing,
        branch = "gh-pages",
        branch_previews = branch,
        devbranch,
        push_preview,
        devurl,
        tag_prefix = "",
        kwargs...
    )
    io = IOBuffer()
    all_ok = true
    ## Determine build type
    if cfg.github_event_name == "pull_request"
        build_type = :preview
    elseif occursin(r"^refs\/tags\/(.*)$", cfg.github_ref)
        build_type = :release
    else
        build_type = :devbranch
    end
    println(io, "Deployment criteria for deploying $(build_type) build from GitHub Actions:")
    ## The deploydocs' repo should match GITHUB_REPOSITORY
    repo_ok = occursin(cfg.github_repository, repo)
    all_ok &= repo_ok
    println(io, "- $(marker(repo_ok)) ENV[\"GITHUB_REPOSITORY\"]=\"$(cfg.github_repository)\" occurs in repo=\"$(repo)\"")
    if build_type === :release
        ## Do not deploy for PRs
        event_ok = in(cfg.github_event_name, ["push", "workflow_dispatch", "schedule", "release"])
        all_ok &= event_ok
        println(io, "- $(marker(event_ok)) ENV[\"GITHUB_EVENT_NAME\"]=\"$(cfg.github_event_name)\" is \"push\", \"workflow_dispatch\", \"schedule\" or \"release\"")
        ## If a tag exist it should be a valid VersionNumber
        m = match(r"^refs\/tags\/(.*)$", cfg.github_ref)
        tag_nobuild = version_tag_strip_build(m.captures[1]; tag_prefix)
        tag_ok = tag_nobuild !== nothing
        all_ok &= tag_ok
        println(io, "- $(marker(tag_ok)) ENV[\"GITHUB_REF\"]=\"$(cfg.github_ref)\" contains a valid VersionNumber")
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
        is_preview = false
        ## Deploy to folder according to the tag
        subfolder = m === nothing ? nothing : tag_nobuild
    elseif build_type === :devbranch
        ## Do not deploy for PRs
        event_ok = in(cfg.github_event_name, ["push", "workflow_dispatch", "schedule"])
        all_ok &= event_ok
        println(io, "- $(marker(event_ok)) ENV[\"GITHUB_EVENT_NAME\"]=\"$(cfg.github_event_name)\" is \"push\", \"workflow_dispatch\" or \"schedule\"")
        ## deploydocs' devbranch should match the current branch
        m = match(r"^refs\/heads\/(.*)$", cfg.github_ref)
        branch_ok = m === nothing ? false : String(m.captures[1]) == devbranch
        all_ok &= branch_ok
        println(io, "- $(marker(branch_ok)) ENV[\"GITHUB_REF\"] matches devbranch=\"$(devbranch)\"")
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
        is_preview = false
        ## Deploy to deploydocs devurl kwarg
        subfolder = devurl
    else # build_type === :preview
        m = match(r"refs\/pull\/(\d+)\/merge", cfg.github_ref)
        pr_number = tryparse(Int, m === nothing ? "" : m.captures[1])
        pr_ok = pr_number !== nothing
        all_ok &= pr_ok
        println(io, "- $(marker(pr_ok)) ENV[\"GITHUB_REF\"] corresponds to a PR number")
        if pr_ok
            pr_origin_matches_repo = verify_github_pull_repository(cfg.github_repository, pr_number)
            all_ok &= pr_origin_matches_repo
            println(io, "- $(marker(pr_origin_matches_repo)) PR originates from the same repository")
        end
        btype_ok = push_preview
        all_ok &= btype_ok
        println(io, "- $(marker(btype_ok)) `push_preview` keyword argument to deploydocs is `true`")
        deploy_branch = branch_previews
        deploy_repo = something(repo_previews, deploy_repo, repo)
        is_preview = true
        ## deploydocs to previews/PR
        subfolder = "previews/PR$(something(pr_number, 0))"
    end
    ## GITHUB_ACTOR should exist (just check here and extract the value later)
    actor_ok = env_nonempty("GITHUB_ACTOR")
    all_ok &= actor_ok
    println(io, "- $(marker(actor_ok)) ENV[\"GITHUB_ACTOR\"] exists and is non-empty")
    ## GITHUB_TOKEN or DOCUMENTER_KEY should exist (just check here and extract the value later)
    token_ok = env_nonempty("GITHUB_TOKEN")
    key_ok = env_nonempty("DOCUMENTER_KEY")
    auth_ok = token_ok | key_ok
    all_ok &= auth_ok
    if key_ok
        println(io, "- $(marker(key_ok)) ENV[\"DOCUMENTER_KEY\"] exists and is non-empty")
    elseif token_ok
        println(io, "- $(marker(token_ok)) ENV[\"GITHUB_TOKEN\"] exists and is non-empty")
    else
        println(io, "- $(marker(auth_ok)) ENV[\"DOCUMENTER_KEY\"] or ENV[\"GITHUB_TOKEN\"] exists and is non-empty")
    end
    print(io, "Deploying: $(marker(all_ok))")
    @info String(take!(io))
    if build_type === :devbranch && !branch_ok && devbranch == "master" && cfg.github_ref == "refs/heads/main"
        @warn """
        Possible deploydocs() misconfiguration: main vs master
        Documenter's configured primary development branch (`devbranch`) is "master", but the
        current branch (from \$GITHUB_REF) is "main". This can happen because Documenter uses
        GitHub's old default primary branch name as the default value for `devbranch`.

        If your primary development branch is 'main', you must explicitly pass `devbranch = "main"`
        to deploydocs.

        See #1443 for more discussion: https://github.com/JuliaDocs/Documenter.jl/issues/1443
        """
    end
    if all_ok
        return DeployDecision(;
            all_ok = true,
            branch = deploy_branch,
            is_preview = is_preview,
            repo = deploy_repo,
            subfolder = subfolder
        )
    else
        return DeployDecision(; all_ok = false)
    end
end

authentication_method(::GitHubActions) = env_nonempty("DOCUMENTER_KEY") ? SSH : HTTPS
function authenticated_repo_url(cfg::GitHubActions)
    return "https://$(ENV["GITHUB_ACTOR"]):$(ENV["GITHUB_TOKEN"])@github.com/$(cfg.github_repository).git"
end

function version_tag_strip_build(tag; tag_prefix = "")
    startswith(tag, tag_prefix) || return nothing
    tag = replace(tag, tag_prefix => ""; count = 1)
    m = match(Base.VERSION_REGEX, tag)
    m === nothing && return nothing
    s0 = startswith(tag, 'v') ? "v" : ""
    s1 = m[1] # major
    s2 = m[2] === nothing ? "" : ".$(m[2])" # minor
    s3 = m[3] === nothing ? "" : ".$(m[3])" # patch
    s4 = m[5] === nothing ? "" : m[5] # pre-release (starting with -)
    # m[7] is the build, which we want to discard
    return "$s0$s1$s2$s3$s4"
end

function post_status(gha::GitHubActions; type, repo::String, subfolder = nothing, kwargs...)
    try # make this non-fatal and silent
        # If we got this far it usually means everything is in
        # order so no need to check everything again.
        # In particular this is only called after we have
        # determined to deploy.
        sha = nothing
        if get(ENV, "GITHUB_EVENT_NAME", nothing) == "pull_request"
            event_path = get(ENV, "GITHUB_EVENT_PATH", nothing)
            event_path === nothing && return
            event = JSON.parsefile(event_path)
            if haskey(event, "pull_request") &&
                    haskey(event["pull_request"], "head") &&
                    haskey(event["pull_request"]["head"], "sha")
                sha = event["pull_request"]["head"]["sha"]
            end
        elseif get(ENV, "GITHUB_EVENT_NAME", nothing) == "push"
            sha = get(ENV, "GITHUB_SHA", nothing)
        end
        sha === nothing && return
        return post_github_status(type, gha.github_repository, repo, sha, subfolder)
    catch
        @debug "Failed to post status"
    end
end

function post_github_status(type::S, source::S, deploydocs_repo::S, sha::S, subfolder = nothing) where {S <: String}
    try
        Sys.which("curl") === nothing && return
        ## Extract owner and repository names
        source_owner, source_repo = split(source, '/')
        m = match(r"^github.com\/(.+?)\/(.+?)(.git)?$", deploydocs_repo)
        m === nothing && return
        deploy_owner = String(m.captures[1])
        deploy_repo = String(m.captures[2])

        ## Need an access token for this
        auth = get(ENV, "GITHUB_TOKEN", nothing)
        auth === nothing && return
        # construct the curl call
        cmd = `curl -sX POST`
        push!(cmd.exec, "-H", "Authorization: token $(auth)")
        push!(cmd.exec, "-H", "User-Agent: Documenter.jl")
        push!(cmd.exec, "-H", "Content-Type: application/json")
        json = Dict{String, Any}("context" => "documenter/deploy", "state" => type)
        if type == "pending"
            json["description"] = "Documentation build in progress"
        elseif type == "success"
            json["description"] = "Documentation build succeeded"
            target_url = "https://$(deploy_owner).github.io/$(deploy_repo)/"
            if subfolder !== nothing
                target_url *= "$(subfolder)/"
            end
            json["target_url"] = target_url
        elseif type == "error"
            json["description"] = "Documentation build errored"
        elseif type == "failure"
            json["description"] = "Documentation build failed"
        else
            error("unsupported type: $type")
        end
        push!(cmd.exec, "-d", JSON.json(json))
        push!(cmd.exec, "https://api.github.com/repos/$(source_owner)/$(source_repo)/statuses/$(sha)")
        # Run the command (silently)
        io = IOBuffer()
        res = run(pipeline(cmd; stdout = io, stderr = devnull))
        @debug "Response of curl POST request" response = String(take!(io))
    catch
        @debug "Failed to post status"
    end
    return nothing
end

function verify_github_pull_repository(repo, prnr)
    github_token = get(ENV, "GITHUB_TOKEN", nothing)
    if github_token === nothing
        @warn "GITHUB_TOKEN is missing, unable to verify if PR comes from destination repository -- assuming it doesn't."
        return false
    end
    # Construct the curl call
    cmd = `curl -s`
    push!(cmd.exec, "-H", "Authorization: token $(github_token)")
    push!(cmd.exec, "-H", "User-Agent: Documenter.jl")
    push!(cmd.exec, "--fail")
    push!(cmd.exec, "https://api.github.com/repos/$(repo)/pulls/$(prnr)")
    try
        # Run the command (silently)
        response = run_and_capture(cmd)
        response = JSON.parse(response.stdout)
        pr_head_repo = response["head"]["repo"]["full_name"]
        @debug "pr_head_repo = '$pr_head_repo' vs repo = '$repo'"
        return pr_head_repo == repo
    catch e
        @warn "Unable to verify if PR comes from destination repository -- assuming it doesn't."
        @debug "Running CURL led to an exception:" exception = (e, catch_backtrace())
        return false
    end
end

function run_and_capture(cmd)
    stdout_buffer, stderr_buffer = IOBuffer(), IOBuffer()
    run(pipeline(cmd; stdout = stdout_buffer, stderr = stderr_buffer))
    stdout, stderr = String(take!(stdout_buffer)), String(take!(stderr_buffer))
    return (; stdout = stdout, stderr = stderr)
end

##########
# GitLab #
##########

"""
    GitLab <: DeployConfig

GitLab implementation of `DeployConfig`.

The following environment variables influence the build when using the
`GitLab` configuration:

 - `DOCUMENTER_KEY`: must contain the Base64-encoded SSH private key for the
   repository. This variable should be set in the GitLab settings. Make sure this
   variable is marked **NOT** to be displayed in the build log.

 - `CI_COMMIT_BRANCH`: the name of the commit branch.

 - `CI_EXTERNAL_PULL_REQUEST_IID`: Pull Request ID from GitHub if the pipelines
   are for external pull requests.

 - `CI_PROJECT_PATH_SLUG`: The namespace with project name. All letters
   lowercased and non-alphanumeric characters replaced with `-`.

 - `CI_COMMIT_TAG`: The commit tag name. Present only when building tags.

 - `CI_PIPELINE_SOURCE`: Indicates how the pipeline was triggered.

The `CI_*` variables are set automatically on GitLab. More information on how GitLab
sets the `CI_*` variables can be found in the
[GitLab documentation](https://docs.gitlab.com/ci/variables/predefined_variables/).
"""
struct GitLab <: DeployConfig
    commit_branch::String
    pull_request_iid::String
    repo_slug::String
    commit_tag::String
    pipeline_source::String
end

function GitLab()
    commit_branch = get(ENV, "CI_COMMIT_BRANCH", "")
    pull_request_iid = get(ENV, "CI_EXTERNAL_PULL_REQUEST_IID", "")
    repo_slug = get(ENV, "CI_PROJECT_PATH_SLUG", "")
    commit_tag = get(ENV, "CI_COMMIT_TAG", "")
    pipeline_source = get(ENV, "CI_PIPELINE_SOURCE", "")
    return GitLab(commit_branch, pull_request_iid, repo_slug, commit_tag, pipeline_source)
end

function deploy_folder(
        cfg::GitLab;
        repo,
        repo_previews = nothing,
        deploy_repo = nothing,
        devbranch,
        push_preview,
        devurl,
        branch = "gh-pages",
        branch_previews = branch,
        tag_prefix = "",
        kwargs...,
    )
    io = IOBuffer()
    all_ok = true

    println(io, "\nGitLab config:")
    println(io, "  Commit branch: \"", cfg.commit_branch, "\"")
    println(io, "  Pull request IID: \"", cfg.pull_request_iid, "\"")
    println(io, "  Repo slug: \"", cfg.repo_slug, "\"")
    println(io, "  Commit tag: \"", cfg.commit_tag, "\"")
    println(io, "  Pipeline source: \"", cfg.pipeline_source, "\"")

    build_type = if cfg.pull_request_iid != ""
        :preview
    elseif cfg.commit_tag != ""
        :release
    else
        :devbranch
    end

    println(io, "Detected build type: ", build_type)

    if build_type == :release
        tag_nobuild = version_tag_strip_build(cfg.commit_tag; tag_prefix)
        ## If a tag exist it should be a valid VersionNumber
        tag_ok = tag_nobuild !== nothing

        println(
            io,
            "- $(marker(tag_ok)) ENV[\"CI_COMMIT_TAG\"] contains a valid VersionNumber",
        )
        all_ok &= tag_ok

        is_preview = false
        subfolder = tag_nobuild
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
    elseif build_type == :preview
        pr_number = tryparse(Int, cfg.pull_request_iid)
        pr_ok = pr_number !== nothing
        all_ok &= pr_ok
        println(
            io,
            "- $(marker(pr_ok)) ENV[\"CI_EXTERNAL_PULL_REQUEST_IID\"]=\"$(cfg.pull_request_iid)\" is a number",
        )
        btype_ok = push_preview
        all_ok &= btype_ok
        is_preview = true
        println(
            io,
            "- $(marker(btype_ok)) `push_preview` keyword argument to deploydocs is `true`",
        )
        ## deploy to previews/PR
        subfolder = "previews/PR$(something(pr_number, 0))"
        deploy_branch = branch_previews
        deploy_repo = something(repo_previews, deploy_repo, repo)
    else
        branch_ok = !isempty(cfg.commit_tag) || cfg.commit_branch == devbranch
        all_ok &= branch_ok
        println(
            io,
            "- $(marker(branch_ok)) ENV[\"CI_COMMIT_BRANCH\"] matches devbranch=\"$(devbranch)\"",
        )
        is_preview = false
        subfolder = devurl
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
    end

    key_ok = env_nonempty("DOCUMENTER_KEY")
    println(io, "- $(marker(key_ok)) ENV[\"DOCUMENTER_KEY\"] exists and is non-empty")
    all_ok &= key_ok

    print(io, "Deploying to folder $(repr(subfolder)): $(marker(all_ok))")
    @info String(take!(io))

    if all_ok
        return DeployDecision(;
            all_ok = true,
            branch = deploy_branch,
            repo = deploy_repo,
            subfolder = subfolder,
            is_preview = is_preview,
        )
    else
        return DeployDecision(; all_ok = false)
    end
end

authentication_method(::GitLab) = Documenter.SSH

documenter_key(::GitLab) = ENV["DOCUMENTER_KEY"]

#############
# Buildkite #
#############

"""
    Buildkite <: DeployConfig

Buildkite implementation of `DeployConfig`.

The following environment variables influence the build when using the
`Buildkite` configuration:

 - `DOCUMENTER_KEY`: must contain the Base64-encoded SSH private key for the
   repository. This variable should be somehow set in the CI environment, e.g.,
   provisioned by an agent environment plugin.

 - `BUILDKITE_BRANCH`: the name of the commit branch.

 - `BUILDKITE_PULL_REQUEST`: Pull Request ID from GitHub if the pipelines
   are for external pull requests.

 - `BUILDKITE_TAG`: The commit tag name. Present only when building tags.

The `BUILDKITE_*` variables are set automatically on Buildkite. More information on how
Buildkite sets the `BUILDKITE_*` variables can be found in the
[Buildkite documentation](https://buildkite.com/docs/pipelines/configure/environment-variables).
"""
struct Buildkite <: DeployConfig
    commit_branch::String
    pull_request::String
    commit_tag::String
end

function Buildkite()
    commit_branch = get(ENV, "BUILDKITE_BRANCH", "")
    pull_request = get(ENV, "BUILDKITE_PULL_REQUEST", "false")
    commit_tag = get(ENV, "BUILDKITE_TAG", "")
    return Buildkite(commit_branch, pull_request, commit_tag)
end

function deploy_folder(
        cfg::Buildkite;
        repo,
        repo_previews = nothing,
        deploy_repo = nothing,
        devbranch,
        push_preview,
        devurl,
        branch = "gh-pages",
        branch_previews = branch,
        tag_prefix = "",
        kwargs...,
    )
    io = IOBuffer()
    all_ok = true

    println(io, "\nBuildkite config:")
    println(io, "  Commit branch: \"", cfg.commit_branch, "\"")
    println(io, "  Pull request: \"", cfg.pull_request, "\"")
    println(io, "  Commit tag: \"", cfg.commit_tag, "\"")

    build_type = if cfg.pull_request != "false"
        :preview
    elseif cfg.commit_tag != ""
        :release
    else
        :devbranch
    end

    println(io, "Detected build type: ", build_type)

    if build_type == :release
        tag_nobuild = version_tag_strip_build(cfg.commit_tag; tag_prefix)
        ## If a tag exist it should be a valid VersionNumber
        tag_ok = tag_nobuild !== nothing

        println(
            io,
            "- $(marker(tag_ok)) ENV[\"BUILDKITE_TAG\"] contains a valid VersionNumber",
        )
        all_ok &= tag_ok

        is_preview = false
        subfolder = tag_nobuild
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
    elseif build_type == :preview
        pr_number = tryparse(Int, cfg.pull_request)
        pr_ok = pr_number !== nothing
        all_ok &= pr_ok
        println(
            io,
            "- $(marker(pr_ok)) ENV[\"BUILDKITE_PULL_REQUEST\"]=\"$(cfg.pull_request)\" is a number",
        )
        btype_ok = push_preview
        all_ok &= btype_ok
        is_preview = true
        println(
            io,
            "- $(marker(btype_ok)) `push_preview` keyword argument to deploydocs is `true`",
        )
        ## deploy to previews/PR
        subfolder = "previews/PR$(something(pr_number, 0))"
        deploy_branch = branch_previews
        deploy_repo = something(repo_previews, deploy_repo, repo)
    else
        branch_ok = !isempty(cfg.commit_tag) || cfg.commit_branch == devbranch
        all_ok &= branch_ok
        println(
            io,
            "- $(marker(branch_ok)) ENV[\"BUILDKITE_BRANCH\"] matches devbranch=\"$(devbranch)\"",
        )
        is_preview = false
        subfolder = devurl
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
    end

    key_ok = env_nonempty("DOCUMENTER_KEY")
    println(io, "- $(marker(key_ok)) ENV[\"DOCUMENTER_KEY\"] exists and is non-empty")
    all_ok &= key_ok

    print(io, "Deploying to folder $(repr(subfolder)): $(marker(all_ok))")
    @info String(take!(io))
    if build_type === :devbranch && !branch_ok && devbranch == "master" && cfg.commit_branch == "main"
        @warn """
        Possible deploydocs() misconfiguration: main vs master
        Documenter's configured primary development branch (`devbranch`) is "master", but the
        current branch (\$BUILDKITE_BRANCH) is "main". This can happen because Documenter uses
        GitHub's old default primary branch name as the default value for `devbranch`.

        If your primary development branch is 'main', you must explicitly pass `devbranch = "main"`
        to deploydocs.

        See #1443 for more discussion: https://github.com/JuliaDocs/Documenter.jl/issues/1443
        """
    end

    if all_ok
        return DeployDecision(;
            all_ok = true,
            branch = deploy_branch,
            repo = deploy_repo,
            subfolder = subfolder,
            is_preview = is_preview,
        )
    else
        return DeployDecision(; all_ok = false)
    end
end

authentication_method(::Buildkite) = Documenter.SSH

documenter_key(::Buildkite) = ENV["DOCUMENTER_KEY"]

#################
# Woodpecker CI #
#################
"""
    Woodpecker <: DeployConfig

Implementation of `DeployConfig` for deploying from Woodpecker CI.

## Woodpecker 1.0.0 and onwards

The following environment variables are built in to the Woodpecker pipeline and
influence how `Documenter` works.

 - `CI_REPO`: must match the full name of the repository, `<owner>/<name>`, e.g. `JuliaDocs/Documenter.jl`
 - `CI_PIPELINE_EVENT`: must be set to `push`, `tag`, `pull_request`, or `deployment`
 - `CI_COMMIT_REF`: must match the `devbranch` keyword to [`deploydocs`](@ref), alternatively correspond to a git tag.
 - `CI_COMMIT_TAG`: must match a tag.
 - `CI_COMMIT_PULL_REQUEST`: must return the PR number.
 - `CI_FORGE_URL`: used to build the URL for authentication.

## Woodpecker 0.15.x and pre-1.0.0

The following environment variables are built in to the Woodpecker pipeline and
influence how `Documenter` works:
 - `CI_REPO`: must match the full name of the repository, `<owner>/<name>`, e.g. `JuliaDocs/Documenter.jl`
 - `CI_REPO_LINK`: must match the full link to the project repo
 - `CI_BUILD_EVENT`: must be set to `push`, `tag`, `pull_request`, or `deployment`
 - `CI_COMMIT_REF`: must match the `devbranch` keyword to [`deploydocs`](@ref), alternatively correspond to a git tag.
 - `CI_COMMIT_TAG`: must match a tag.
 - `CI_COMMIT_PULL_REQUEST`: must return the PR number.
## Documenter-Specific Environment Variables

 - `DOCUMENTER_KEY`: must contain the Base64-encoded SSH private key for the
   repository. This variable should be somehow set in the CI environment, e.g.,
   provisioned by an agent environment plugin.

Lastly, another environment variable used for authentication is
`PROJECT_ACCESS_TOKEN`, which is an access token you define on
the forge you use, e.g. GitHub, GitLab, Codeberg, and other Gitea
instances. Check their documentation on how to create an access token.
This access token should be then added as a secret as documented in
<https://woodpecker-ci.org/docs/usage/secrets>.

# Example Pipeline Syntax

## 1.0.0 and onwards

```yaml
labels:
  platform: linux/amd64

steps:
  docs:
    when:
      branch:
        - main
    image: opensuse/tumbleweed
    commands:
      - zypper --non-interactive install openssh juliaup git
      - /usr/bin/julia --project=docs/ --startup-file=no --history-file=no -e "import Pkg; Pkg.instantiate()"
      - /usr/bin/julia --project=docs/ --startup-file=no --history-file=no -e docs/make.jl
    secrets: [ documenter_key, project_access_token ]
```

## 0.15.x and pre-1.0.0

```yaml
platforms: linux/amd64

pipeline:
  docs:
    when:
      branch:
        - main
    image: opensuse/tumbleweed
    commands:
      - zypper --non-interactive install openssh juliaup git
      - /usr/bin/julia --project=docs/ --startup-file=no --history-file=no -e "import Pkg; Pkg.instantiate()"
      - /usr/bin/julia --project=docs/ --startup-file=no --history-file=no -e docs/make.jl
    secrets: [ documenter_key, project_access_token ]
```

More about pipeline syntax is documented here:
- 0.15.x: <https://github.com/woodpecker-ci/woodpecker/blob/release/v0.15/docs/docs/20-usage/20-pipeline-syntax.md>
- 1.0.0 and onwards: <https://github.com/woodpecker-ci/woodpecker/blob/release/v1.0/docs/docs/20-usage/20-pipeline-syntax.md>
- 2.0.0 and onwards: <https://woodpecker-ci.org/docs/usage/workflow-syntax>
"""
struct Woodpecker <: DeployConfig
    woodpecker_ci_version::VersionNumber
    woodpecker_forge_url::String
    woodpecker_repo::String
    woodpecker_tag::String
    woodpecker_event_name::String
    woodpecker_ref::String
end

"""
    Woodpecker()

Initialize Woodpecker environment variables. Further info on the
environment variables used is at <https://woodpecker-ci.org/docs/usage/environment>
"""
function Woodpecker()
    m = match(r"(next)?-*", ENV["CI_SYSTEM_VERSION"])
    if !isnothing(m.captures[1])
        @warn """You are currently using an unreleased version of Woodpecker
        CI. Creating dummy version to temporarily resolve the issue."""
        woodpecker_ci_version = v"1000"
    else
        woodpecker_ci_version = VersionNumber(ENV["CI_SYSTEM_VERSION"])
        @warn "Current Woodpecker version is $(woodpecker_ci_version). Make sure this is correct."
        if ENV["CI"] == "drone" && (v"1.0.0" > VersionNumber(ENV["CI_SYSTEM_VERSION"]) >= v"0.15.0")
            @warn """Woodpecker prior to version 1.0.0 is backward compatible with Drone
            but *there will be breaking changes in the future*. Please update
            to a newer version."""
        end
    end

    # Woodpecker skipped 0.16.x and went to 1.0.0 and onwards
    # Woodpecker integration on Documenter.jl started with Woodpecker 0.15.0
    if v"1.0.0" > woodpecker_ci_version >= v"0.15.0"
        woodpecker_repo_link = get(ENV, "CI_REPO_LINK", "")
        m = match(r"(https?:\/\/?:.+\.)*(.+\..+?)\/", woodpecker_repo_link)
        woodpecker_forge_url = !isnothing(m) ? m.captures[2] : ""
        woodpecker_tag = get(ENV, "CI_COMMIT_TAG", "")
        woodpecker_repo = get(ENV, "CI_REPO", "")
        woodpecker_event_name = get(ENV, "CI_BUILD_EVENT", "")
        woodpecker_ref = get(ENV, "CI_COMMIT_REF", "")
        return Woodpecker(woodpecker_ci_version, woodpecker_forge_url, woodpecker_repo, woodpecker_tag, woodpecker_event_name, woodpecker_ref)
    else
        woodpecker_forge_url = get(ENV, "CI_FORGE_URL", "")
        woodpecker_tag = get(ENV, "CI_COMMIT_TAG", "")
        woodpecker_repo = get(ENV, "CI_REPO", "")  # repository full name <owner>/<name>
        woodpecker_event_name = get(ENV, "CI_PIPELINE_EVENT", "")  # build event (push, pull_request, tag, deployment)
        woodpecker_ref = get(ENV, "CI_COMMIT_REF", "")  # commit ref
        return Woodpecker(woodpecker_ci_version, woodpecker_forge_url, woodpecker_repo, woodpecker_tag, woodpecker_event_name, woodpecker_ref)
    end
end

function deploy_folder(
        cfg::Woodpecker;
        repo,
        repo_previews = nothing,
        deploy_repo = nothing,
        branch = "pages",
        branch_previews = branch,
        devbranch,
        push_preview,
        devurl,
        tag_prefix = "",
        kwargs...
    )
    io = IOBuffer()
    all_ok = true
    if cfg.woodpecker_event_name == "pull_request"
        build_type = :preview
    elseif occursin(r"^refs\/tags\/(.*)$", cfg.woodpecker_ref)
        build_type = :release
    else
        build_type = :devbranch
    end

    println(io, "Deployment criteria for deploying $(build_type) build from Woodpecker-CI")
    ## The deploydocs' repo should match CI_REPO

    forge_url_ok = !isempty(cfg.woodpecker_forge_url)  # if the forge url is an empty string, it is not a valid url
    all_ok &= forge_url_ok

    repo_ok = occursin(cfg.woodpecker_repo, repo)
    all_ok &= repo_ok
    println(io, "- $(marker(repo_ok)) ENV[\"CI_REPO\"]=\"$(cfg.woodpecker_repo)\" occursin in repo=\"$(repo)\"")

    ci_event_env_name = if haskey(ENV, "CI_PIPELINE_EVENT")
        "ENV[\"CI_PIPELINE_EVENT\"]"
    elseif haskey(ENV, "CI_BUILD_EVENT")
        "ENV[\"CI_BUILD_EVENT\"]"
    end

    if build_type === :release
        event_ok = in(cfg.woodpecker_event_name, ["push", "pull_request", "deployment", "tag"])
        all_ok &= event_ok
        println(io, "- $(marker(event_ok)) $(ci_event_env_name)=\"$(cfg.woodpecker_event_name)\" is \"push\", \"deployment\" or \"tag\"")
        tag_nobuild = version_tag_strip_build(cfg.woodpecker_tag; tag_prefix)
        tag_ok = tag_nobuild !== nothing
        all_ok &= tag_ok
        println(io, "- $(marker(tag_ok)) ENV[\"CI_COMMIT_TAG\"]=\"$(cfg.woodpecker_tag)\" contains a valid VersionNumber")
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
        is_preview = false
        ## Deploy to folder according to the tag
        subfolder = tag_nobuild
    elseif build_type === :devbranch
        ## Do not deploy for PRs
        event_ok = in(cfg.woodpecker_event_name, ["push", "pull_request", "deployment", "tag"])
        all_ok &= event_ok
        println(io, "- $(marker(event_ok)) $(ci_event_env_name)=\"$(cfg.woodpecker_event_name)\" is \"push\", \"deployment\", or \"tag\"")
        ## deploydocs' devbranch should match the current branch
        m = match(r"^refs\/heads\/(.*)$", cfg.woodpecker_ref)
        branch_ok = (m === nothing) ? false : String(m.captures[1]) == devbranch
        all_ok &= branch_ok
        println(io, "- $(marker(branch_ok)) ENV[\"CI_COMMIT_REF\"] matches devbranch=\"$(devbranch)\"")
        deploy_branch = branch
        deploy_repo = something(deploy_repo, repo)
        is_preview = false
        ## Deploy to deploydocs devurl kwarg
        subfolder = devurl
    else # build_type === :preview
        m = match(r"refs\/pull\/(\d+)\/merge", cfg.woodpecker_ref)
        pr_number1 = tryparse(Int, (m === nothing) ? "" : m.captures[1])
        pr_number2 = tryparse(Int, get(ENV, "CI_COMMIT_PULL_REQUEST", nothing) === nothing ? "" : ENV["CI_COMMIT_PULL_REQUEST"])
        # Check if both are Ints. If both are Ints, then check if they are equal, otherwise, return false
        pr_numbers_ok = all(x -> x isa Int, [pr_number1, pr_number2]) ? (pr_number1 == pr_number2) : false
        is_pull_request_ok = cfg.woodpecker_event_name == "pull_request"
        pr_ok = pr_numbers_ok == is_pull_request_ok
        all_ok &= pr_ok
        println(io, "- $(marker(pr_numbers_ok)) ENV[\"CI_COMMIT_REF\"] corresponds to a PR")
        println(io, "- $(marker(is_pull_request_ok)) $(ci_event_env_name) matches built type: `pull_request`")
        btype_ok = push_preview
        all_ok &= btype_ok
        println(io, "- $(marker(btype_ok)) `push_preview` keyword argument to deploydocs is `true`")
        deploy_branch = branch_previews
        deploy_repo = something(repo_previews, deploy_repo, repo)
        is_preview = true
        ## deploydocs to previews/PR
        subfolder = "previews/PR$(something(pr_number1, 0))"
    end

    token_ok = env_nonempty("PROJECT_ACCESS_TOKEN")
    key_ok = env_nonempty("DOCUMENTER_KEY")
    auth_ok = token_ok | key_ok
    all_ok &= auth_ok

    if key_ok
        println(io, "- $(marker(key_ok)) ENV[\"DOCUMENTER_KEY\"] exists and is non-empty")
    elseif token_ok
        println(io, "- $(marker(token_ok)) ENV[\"PROJECT_ACCESS_TOKEN\"] exists and is non-empty")
    else
        println(io, "- $(marker(auth_ok)) ENV[\"DOCUMENTER_KEY\"] or ENV[\"PROJECT_ACCESS_TOKEN\"] exists and is non-empty")
    end

    print(io, "Deploying: $(marker(all_ok))")
    @info String(take!(io))
    if build_type === :devbranch && !branch_ok && devbranch == "master" && cfg.woodpecker_ref == "refs/heads/main"
        @warn """
        Possible deploydocs() misconfiguration: main vs master. Current branch (from \$CI_COMMIT_REF) is "main".
        """
    end

    if all_ok
        return DeployDecision(;
            all_ok = true,
            branch = deploy_branch,
            is_preview = is_preview,
            repo = deploy_repo,
            subfolder = subfolder
        )
    else
        return DeployDecision(; all_ok = false)
    end
end

authentication_method(::Woodpecker) = env_nonempty("DOCUMENTER_KEY") ? SSH : HTTPS
function authenticated_repo_url(cfg::Woodpecker)
    # https://codeberg.org -> codeberg.org
    forge_domain = split(cfg.woodpecker_forge_url, r"https?://")[2]
    return "https://$(ENV["PROJECT_ACCESS_TOKEN"])@$(forge_domain)/$(cfg.woodpecker_repo).git"
end

##################
# Auto-detection #
##################
function auto_detect_deploy_system()
    if haskey(ENV, "TRAVIS_REPO_SLUG")
        return Travis()
    elseif haskey(ENV, "GITHUB_REPOSITORY")
        return GitHubActions()
    elseif haskey(ENV, "GITLAB_CI")
        return GitLab()
    elseif haskey(ENV, "BUILDKITE")
        return Buildkite()
    elseif get(ENV, "CI", "") in ["woodpecker", "drone"]
        return Woodpecker()
    else
        return nothing
    end
end

# Tests for doctest = :fix
#
# DOCUMENTER_TEST_DEBUG= JULIA_DEBUG=all julia test/doctests/fix/tests.jl
#
module DocTestFixTest
using Documenter: Documenter
using Test
include("../../TestUtilities.jl"); using Main.TestUtilities: @quietly

# Type to reliably show() objects across Julia versions:
@eval Main begin
    struct ShowWrap
        s::String
    end
    Base.show(io::IO, x::ShowWrap) = write(io, x.s)
    const DocTestFixArray_1234 = Main.ShowWrap("4×1×1 Array{Int64,3}:\n[:, :, 1] =\n 1\n 2\n 3\n 4")
    const DocTestFixArray_2468 = Main.ShowWrap("4×1×1 Array{Int64,3}:\n[:, :, 1] =\n 2\n 4\n 6\n 8")
end

mktempdir_nocleanup(dir) = mktempdir(dir, cleanup = false)

function normalize_line_endings(filename)
    s = read(filename, String)
    return replace(s, "\r\n" => "\n")
end

# 1.12 introduced stricter world age requirements, so we need to do some Base.invokelatest
# shenanigans to make sure that we are passing the updated Foo module to makedocs.
_Foo() = Base.invokelatest(getfield, @__MODULE__, :Foo)
makedocs(args...; kwargs...) = Base.invokelatest(Documenter.makedocs, args...; kwargs...)

function test_doctest_fix(dir)
    srcdir = mktempdir_nocleanup(dir)
    builddir = mktempdir_nocleanup(dir)
    @debug "Testing doctest = :fix" srcdir builddir

    # Pkg.add changes permission of files to read-only,
    # so instead of copying them we read + write.
    src_jl = joinpath(srcdir, "src.jl")
    index_md = joinpath(srcdir, "index.md")
    write(index_md, normalize_line_endings(joinpath(@__DIR__, "broken.md")))
    write(src_jl, normalize_line_endings(joinpath(@__DIR__, "broken.jl")))

    # fix up
    include(joinpath(srcdir, "src.jl")); @eval import .Foo
    @debug "Running doctest/fix doctests with doctest=:fix"
    @quietly makedocs(sitename = "-", modules = [_Foo()], source = srcdir, build = builddir, doctest = :fix)

    # check that the doctests are passing now
    include(joinpath(srcdir, "src.jl")); @eval import .Foo
    @debug "Running doctest/fix doctests with doctest=true"
    @quietly makedocs(sitename = "-", modules = [_Foo()], source = srcdir, build = builddir)

    # Load the expected results and adapt to various Julia versions:
    md_result = normalize_line_endings(joinpath(@__DIR__, "fixed.md"))
    if VERSION < v"1.11"
        # 1.11 Starts printing "in `Main`", so we remove that from the expected output.
        md_result = replace(md_result, r"UndefVarError: `([^`]*)` not defined in `Main`" => s"UndefVarError: `\1` not defined")
    end
    if VERSION < v"1.11"
        # 1.11 started printing the 'Suggestion: check for spelling errors or missing imports.' messages
        # for UndefVarError, so we remove them from the expected output.
        md_result = replace(md_result, r"UndefVarError: `([^`]*)` not defined\nSuggestion: .+" => s"UndefVarError: `\1` not defined")
    end
    if VERSION < v"1.7"
        # The UndefVarError prints the backticks around the variable name in 1.7+, so we need to remove them.
        md_result = replace(md_result, r"UndefVarError: `([^`]*)` not defined" => s"UndefVarError: \1 not defined")
    end

    # test that we obtain the expected output
    @test normalize_line_endings(index_md) == md_result
    return @test normalize_line_endings(src_jl) == normalize_line_endings(joinpath(@__DIR__, "fixed.jl"))
end

@testset "doctest fixing" begin
    if haskey(ENV, "DOCUMENTER_TEST_DEBUG")
        # in this mode the directories remain
        test_doctest_fix(mktempdir_nocleanup(@__DIR__))
    else
        mktempdir(test_doctest_fix, @__DIR__)
    end
end

end # module

module DummyModule

"""
    func1(x)

This is the docstring for `func1`. It references [`func2`](@ref).
"""
func1(x) = x

"""
    func2(y)

This is the docstring for `func2`.
"""
func2(y) = y

"""
    MyType

A custom type.
"""
struct MyType
    x::Int
end

end

using Documenter: Documenter, deploydocs, git
using DocInventories: DocInventories, Inventory
using Test
include("TestUtilities.jl"); using Main.TestUtilities

struct TestDeployConfig <: Documenter.DeployConfig
    repo_path::String
    subfolder::String
end
function Documenter.deploy_folder(c::TestDeployConfig; branch, repo, kwargs...)
    return Documenter.DeployDecision(; all_ok = true, subfolder = c.subfolder, branch, repo)
end
Documenter.authentication_method(::TestDeployConfig) = Documenter.HTTPS
Documenter.authenticated_repo_url(c::TestDeployConfig) = c.repo_path

@testset "deploydocs" begin
    mktempdir() do dir
        cd(dir) do
            mkdir("repo")
            run(`$(git()) -C repo init -q --bare`)
            full_repo_path = joinpath(pwd(), "repo")
            # Pseudo makedocs products in build/
            mkdir("build")
            write("build/page.html", "...")
            inventory = Inventory(project = "test", version = "")
            objects_inv = joinpath("build", "objects.inv")
            DocInventories.save(objects_inv, inventory)
            # Create gh-pages and deploy dev/
            @quietly deploydocs(
                root = pwd(),
                cname = "www.example.com",
                deploy_config = TestDeployConfig(full_repo_path, "dev"),
                repo = full_repo_path,
                devbranch = "master",
            )
            # Deploy 1.0.0 tag
            @quietly deploydocs(
                root = pwd(),
                deploy_config = TestDeployConfig(full_repo_path, "1.0.0"),
                repo = full_repo_path,
                devbranch = "master",
            )
            # Deploy 1.1.0 tag
            # (note that the inventory still declares 1.0.0 as the version, so
            # this implicitly tests that `deploydocs` overwrites it with the
            # correct version)
            @quietly deploydocs(
                root = pwd(),
                deploy_config = TestDeployConfig(full_repo_path, "1.1.0"),
                repo = full_repo_path,
                devbranch = "master",
            )
            # Deploy 2.0.0 tag, but into an archive (so nothing pushed to gh-pages)
            DocInventories.save(objects_inv, Inventory(project = "test", version = "2.0.0"))
            @quietly deploydocs(
                root = pwd(),
                deploy_config = TestDeployConfig(full_repo_path, "2.0.0"),
                repo = full_repo_path,
                devbranch = "master",
                archive = joinpath(pwd(), "ghpages.tar.gz"),
            )
            # Deploy 3.0.0 tag with a tag_prefix---which does not change deployment behavior
            DocInventories.save(objects_inv, Inventory(project = "test", version = "3.0.0"))
            @quietly deploydocs(;
                root = pwd(),
                deploy_config = TestDeployConfig(full_repo_path, "3.0"),
                repo = full_repo_path,
                devbranch = "master",
                tag_prefix = "MySubPackage-",
            )
            # Check what we have in gh-pages now:
            run(`$(git()) clone -q -b gh-pages $(full_repo_path) worktree`)
            @test isfile(joinpath("worktree", "index.html"))
            @test isfile(joinpath("worktree", "versions.js"))
            for d in ["dev", "v1.0.0", "v1.1.0", "v3.0.0"]
                @test isfile(joinpath("worktree", d, "page.html"))
                @test isfile(joinpath("worktree", d, "siteinfo.js"))
            end
            @test isfile(joinpath("worktree", "CNAME"))
            @test islink(joinpath("worktree", "v1"))
            @test islink(joinpath("worktree", "v1.0"))
            @test islink(joinpath("worktree", "v1.1"))
            @test islink(joinpath("worktree", "stable"))
            # And make sure that archived option didn't modify gh-pages
            @test !ispath(joinpath("worktree", "2.0.0"))
            @test !ispath(joinpath("worktree", "v2.0"))
            @test !ispath(joinpath("worktree", "v2"))
            @test isfile("ghpages.tar.gz")
            @test islink(joinpath("worktree", "v3"))
            @test islink(joinpath("worktree", "v3.0"))
            @test islink(joinpath("worktree", "v3.0.0"))
            inv_v11 = Inventory(joinpath("worktree", "v1.1", "objects.inv"))
            @test inv_v11.version == "1.1.0"
            inv_v30 = Inventory(joinpath("worktree", "v3.0", "objects.inv"))
            @test inv_v30.version == "3.0.0"
            inv_stable = Inventory(joinpath("worktree", "stable", "objects.inv"))
            @test inv_stable.version == "3.0.0"
            inv_dev = Inventory(joinpath("worktree", "dev", "objects.inv"))
            @test inv_dev.version == ""

            # key_prefix does not affect/is not present in worktree directories
            @test issetequal(
                [
                    ".git", "1.0.0", "1.1.0", "3.0", "CNAME", "dev", "index.html",
                    "stable", "v1", "v1.0", "v1.0.0", "v1.1", "v1.1.0",
                    "v3", "v3.0", "v3.0.0", "versions.js",
                ], readdir("worktree")
            )
        end
    end
end

@testset "deploydocs for monorepo" begin
    mktempdir() do dir
        cd(dir) do
            mkdir("repo")
            run(`$(git()) -C repo init -q --bare`)
            full_repo_path = joinpath(pwd(), "repo")
            # Pseudo makedocs products: top level repo...
            top_level_doc_dir = mkpath(joinpath("docs", "build"))
            write(joinpath(top_level_doc_dir, "page.html"), "...")

            # ...and subpackage.
            subpackage_doc_dir = joinpath("PackageA.jl", "docs", "build")
            mkpath(joinpath("PackageA.jl", "docs", "build"))
            write(joinpath(subpackage_doc_dir, "page.html"), "...")

            # Use different versions for each set of docs to make it easier to see
            # where the version has been deployed.
            # Deploy 1.0.0 tag - top level repo
            @quietly deploydocs(
                root = pwd(),
                deploy_config = TestDeployConfig(full_repo_path, "1.0.0"),
                repo = full_repo_path,
                devbranch = "master",
            )
            # Deploy 2.0.0 tag - subpackage
            # Note: setting the `tag_prefix here is not actually necessary or used
            # BECAUSE we're using a TestDeployConfig, but we're setting it here
            # anyway so that this example can be used to model true implementation.
            @quietly deploydocs(
                root = pwd(),
                deploy_config = TestDeployConfig(full_repo_path, "2.0.0"),
                repo = full_repo_path,
                devbranch = "master",
                dirname = "PackageA.jl",
                tag_prefix = "PackageA-",
            )

            # Check what we have in worktree:
            run(`$(git()) clone -q -b gh-pages $(full_repo_path) worktree`)

            @test isdir("worktree/1.0.0") # top level
            @test !isdir("worktree/2.0.0") # top level
            @test isdir("worktree/PackageA.jl/2.0.0") # subpackage
            @test !isdir("worktree/PackageA.jl/1.0.0") # subpackage

            # Check what we have in gh-pages:
            @test isfile(joinpath("worktree", "index.html"))
            @test isfile(joinpath("worktree", "versions.js"))
            @test isfile(joinpath("worktree", "PackageA.jl", "index.html"))
            @test isfile(joinpath("worktree", "PackageA.jl", "versions.js"))

            # ...and check that (because only one release per package) the versions
            # are identical except for the (intentional) version number
            top_versions = readlines(joinpath("worktree", "versions.js"))
            subpackage_versions = readlines(joinpath("worktree", "PackageA.jl", "versions.js"))
            for (i, (t_line, s_line)) in enumerate(zip(top_versions, subpackage_versions))
                if i in [3, 5]
                    @test contains(s_line, "2.0")
                    @test isequal(t_line, replace(s_line, "2.0" => "1.0"))
                else
                    @test isequal(t_line, s_line)
                end
            end
        end
    end
end

"""
Provides a consistent interface to retrieving `DocStr` objects from the Julia
docsystem in both `0.4` and `0.5`.
"""
module DocSystem

using DocStringExtensions: SIGNATURES
import Markdown
import Base.Docs: MultiDoc, DocStr

## Bindings ##

"""
Converts an object to a `Base.Docs.Binding` object.

$(SIGNATURES)

Supported inputs are:

- `Binding`
- `DataType`
- `Function`
- `Module`
- `Symbol`

Note that unsupported objects will throw an `ArgumentError`.
"""
binding(any::Any) = throw(ArgumentError("cannot convert `$(repr(any))` to a `Binding`."))

#
# The simple definitions.
#
binding(b::Docs.Binding) = binding(b.mod, b.var)
binding(d::DataType) = binding(parentmodule(d), nameof(d))
binding(m::Module) = binding(m, nameof(m))
binding(s::Symbol) = binding(Main, s)
binding(f::Function) = binding(parentmodule(f), nameof(f))

#
# We need a lookup table for `IntrinsicFunction`s since they do not track their
# own name and defining module.
#
# Note that `IntrinsicFunction` is exported from `Base` in `0.4`, but not in `0.5`.
#
let INTRINSICS = Dict(map(s -> getfield(Core.Intrinsics, s) => s, names(Core.Intrinsics, all = true)))
    global binding(i::Core.IntrinsicFunction) = binding(Core.Intrinsics, INTRINSICS[i]::Symbol)
end

#
# Normalise the parent module.
#
# This is done within the `Binding` constructor on `0.5`, but not on `0.4`.
#
function binding(m::Module, v::Symbol)
    m = nameof(m) === v ? parentmodule(m) : m
    return Docs.Binding(m, v)
end

#
# Pseudo-eval of `Expr`s to find their equivalent `Binding`.
#
binding(m::Module, x::Expr) =
    Meta.isexpr(x, :.) ? binding(getmod(m, x.args[1]), x.args[2].value) :
    Meta.isexpr(x, [:call, :macrocall, :curly]) ? binding(m, x.args[1]) :
    Meta.isexpr(x, :where) ? binding(m, x.args[1].args[1]) :
    error("`binding` cannot understand expression `$x`.")

# Helper methods for the above `binding` method.
getmod(m::Module, x::Expr) = getfield(getmod(m, x.args[1]), x.args[2].value)
getmod(m::Module, s::Symbol) = getfield(m, s)

binding(m::Module, q::QuoteNode) = binding(Main, q.value)

binding(m::Module, λ::Any) = binding(λ)

## Signatures. ##

function signature(x, str::AbstractString)
    ts = Base.Docs.signature(x)
    return (Meta.isexpr(x, :macrocall, 2) && !endswith(strip(str), "()")) ? :(Union{}) : ts
end

## Docstring containers. ##


"""
Construct a `MultiDoc` object from the provided argument.

Valid inputs are:

- `Markdown.MD`
- `Docs.FuncDoc`
- `Docs.TypeDoc`

"""
function multidoc end

function multidoc(markdown::Markdown.MD)
    md = MultiDoc()
    sig = Union{}
    push!(md.order, sig)
    md.docs[sig] = docstr(markdown)
    return md
end


"""
$(SIGNATURES)

Construct a `DocStr` object from a `Markdown.MD` object.

The optional keyword arguments are used to add new data to the `DocStr`'s
`.data` dictionary.
"""
function docstr(md::Markdown.MD; kws...)
    data = Dict{Symbol, Any}(
        :path => md.meta[:path],
        :module => md.meta[:module],
        :linenumber => 0,
    )
    doc = DocStr(Core.svec(), md, data)
    for (key, value) in kws
        doc.data[key] = value
    end
    return doc
end
docstr(other) = other


## Formatting `DocStr`s. ##


## Converting docstring caches. ##

"""
$(SIGNATURES)

Converts a `0.4`-style docstring cache into a `0.5` one.

The original docstring cache is not modified.
"""
function convertmeta(meta::IdDict{Any, Any})
    if !haskey(CACHED, meta)
        docs = IdDict{Any, Any}()
        for (k, v) in meta
            if !isa(k, Union{Number, AbstractString, IdDict{Any, Any}})
                docs[binding(k)] = multidoc(v)
            end
        end
        CACHED[meta] = docs
    end
    return CACHED[meta]::IdDict{Any, Any}
end
const CACHED = IdDict{Any, Any}()


## Get docs from modules.

"""
$(SIGNATURES)

Find all `DocStr` objects that match the provided arguments exactly.
- `binding`: the name of the object.
- `typesig`: the signature of the object. Default: `Union{}`.
- `compare`: how to compare signatures? (`==` (default), `<:` or `>:`)
- `modules`: which modules to search through. Default: *all modules*.

Return a `Vector{DocStr}` ordered by definition order.
"""
function getspecificdocs(
        binding::Docs.Binding,
        typesig::Type = Union{},
        compare = (==),
        modules = Docs.modules,
    )
    # Fall back to searching all modules if user provides no modules.
    modules = isempty(modules) ? Docs.modules : modules
    # Keywords are special-cased within the docsystem. Handle those first.
    iskeyword(binding) && return [docstr(Base.Docs.keywords[binding.var])]
    # Handle all the other possible bindings.
    results = DocStr[]
    for mod in modules
        meta = getmeta(mod)
        if haskey(meta, binding)
            multidoc = meta[binding]::MultiDoc
            for signature in multidoc.order
                if compare(typesig, signature)
                    doc = multidoc.docs[signature]
                    doc.data[:binding] = binding
                    doc.data[:typesig] = signature
                    push!(results, doc)
                end
            end
        end
    end
    return results
end

"""
$(SIGNATURES)

Find all `DocStr` objects that somehow match the provided arguments.
That is, if [`getspecificdocs`](@ref) fails, get docs for aliases of
`binding` (unless `aliases` is set to `false`). For `compare` being `==` also
try getting docs for `<:`.
"""
function getdocs(
        binding::Docs.Binding,
        typesig::Type = Union{};
        compare = (==),
        modules = Docs.modules,
        aliases = true,
    )
    # First, we try to find the docs that _exactly_ match the binding. If you
    # have aliases, you can have a separate docstring attached to the alias.
    results = getspecificdocs(binding, typesig, compare, modules)
    # If we don't find anything, we'll loosen the function signature comparison
    # to allow for subtypes, to find any signatures that would get called in
    # dispatch for this method (i.e. supertype signatures).
    if isempty(results) && compare == (==)
        results = getspecificdocs(binding, typesig, (<:), modules)
    end
    # If we still can't find anything, `aliases` is set, and this binding is
    # indeed an alias, we'll fetch the docstrings for the original object, first
    # as an exact match (if relevant) and then also falling back to a subtype
    # search.
    if isempty(results) && aliases && (b = aliasof(binding)) != binding
        results = getspecificdocs(b, typesig, compare, modules)
        if isempty(results) && compare == (==)
            results = getspecificdocs(b, typesig, (<:), modules)
        end
    end
    return results
end

"""
$(SIGNATURES)

Accepts objects of any type and tries to convert them to `Binding`s before
searching for the `Binding` in the docsystem.

Note that when conversion fails this method returns an empty `Vector{DocStr}`.
"""
function getdocs(object::Any, typesig::Type = Union{}; kws...)
    binding = aliasof(object, object)
    return binding === object ? DocStr[] : getdocs(binding, typesig; kws...)
end

#
# Helper methods used by the `getdocs` function above.
#

getmeta(m::Module) = Docs.meta(m)

import Base.Docs: aliasof, resolve, defined


aliasof(s::Symbol, b) = binding(s)

iskeyword(b::Docs.Binding) = b.mod === Main && haskey(Base.Docs.keywords, b.var)
ismacro(b::Docs.Binding) = startswith(string(b.var), '@')


function category(b::Docs.Binding)
    if iskeyword(b)
        return :keyword
    elseif ismacro(b)
        return :macro
    else
        return category(resolve(b))
    end
end
category(::Function) = :function
category(::DataType) = :type
category(x::UnionAll) = category(Base.unwrap_unionall(x))
category(::Module) = :module
category(::Any) = :constant

"""
    DocSystem.parsedoc(docstr::DocStr) -> Markdown.MD

Thin internal wrapper around `Base.Docs.parsedoc` which prints additional debug information
in case `Base.Docs.parsedoc` fails with an exception.
"""
function parsedoc(docstr::DocStr)
    md = try
        Base.Docs.parsedoc(docstr)::Markdown.MD
    catch exception
        @error """
        parsedoc failed to parse a docstring into Markdown. This indicates a problem with the docstring.
        """ exception docstr.data collect(docstr.text) docstr.object
        # Note: collect is there because svec does not print as nicely as a vector
        rethrow(exception)
    end
    # Normally, the docsystem double wraps the docstrings in Markdown.MD, and so we need to unwrap
    # it. _However_, if the MD object is attached directly with the @doc macro, which can happen,
    # for example, when using the @doc_str macro, i.e.
    #
    #   @doc doc"""
    #   ...
    #   """ function foo end
    #
    # Then it does _not_ get double wrapped. So what we promise here is that DocSystem.parsedoc
    # will return the unwrapped Markdown.MD object, which we can e.g. pass to MarkdownAST conversion
    # directly. But we need to check if it actually is double wrapped or not.
    #
    # This heuristic should work for checking the double wrapping:
    while length(md.content) == 1 && isa(first(md.content), Markdown.MD)
        inner_md = only(md.content)
        # The docstring's outer Markdown.MD contains necessary metadata, however, so we need to
        # retain it.
        inner_md.meta = md.meta
        md = inner_md
    end
    return md
end

struct APIStatus
    binding::Docs.Binding
    isdefined::Bool
    ispublic::Bool
    isexported::Bool

    function APIStatus(mod::Module, sym::Symbol)
        isdefined = Base.isdefined(mod, sym)
        ispublic = @static if isdefined(Base, :ispublic) # Julia v1.11 and later
            Base.ispublic(mod, sym)
        else
            Base.isexported(mod, sym)
        end
        isexported = Base.isexported(mod, sym)
        return new(Docs.Binding(mod, sym), isdefined, ispublic, isexported)
    end
end

APIStatus(binding::Docs.Binding) = APIStatus(binding.mod, binding.var)

"""
This error message is reused in duplicate docstring warnings when we detect
the case when a duplicate docstring in a non-explored public name.
"""
function public_unexported_msg(apistatus::APIStatus)
    return if apistatus.ispublic && !apistatus.isexported
        """\n
        Note: this binding is marked `public`, but not exported. Starting from Documenter 1.9.0,
        such bindings are now included in `@autodocs` blocks that list public APIs (blocks with `Public = true`),
        but in older Documenter versions they would not have been. This may cause a previously
        succeeding documentation build to fail because of duplicate docstrings, without any changes to your code. To fix this,
        ensure that the same docstring is not included anywhere else (e.g. by an explicit `@docs`
        block).
        """
    else
        ""
    end
end

end

"""
Provides the [`mdflatten`](@ref) function that can "flatten" Markdown objects into
a string, with formatting etc. stripped.

Note that the tests in `test/mdflatten.jl` should be considered to be the spec
for the output (number of newlines, indents, formatting, etc.).
"""
module MDFlatten

export mdflatten

using MarkdownAST: MarkdownAST, Node

"""
Convert a Markdown object to a `String` of only text (i.e. not formatting info).

It drops most of the extra information (e.g. language of a code block, URLs)
and formatting (e.g. emphasis, headers). This "flattened" representation can
then be used as input for search engines.
"""
mdflatten(node) = sprint(mdflatten, node)

mdflatten(io, node::Node) = mdflatten(io, node, node.element)
mdflatten(io, nodes::Vector{T}) where {T <: Node} = foreach(n -> mdflatten(io, n), nodes)
function mdflatten(io, children::MarkdownAST.NodeChildren)
    # this special case separates top level blocks with newlines
    newlines = isa(children.parent.element, MarkdownAST.Document)
    for child in children
        mdflatten(io, child)
        newlines && print(io, "\n\n")
    end
    return
end

mdflatten(io, node::Node, e::MarkdownAST.AbstractElement) = error("Unimplemented element for mdflatten: $(typeof(e))")

# Most block and inline (container) elements just reduce down to printing out their
# child nodes.
function mdflatten(io, node::Node, ::T) where {
        T <: Union{
            MarkdownAST.Document, MarkdownAST.Heading, MarkdownAST.Paragraph,
            MarkdownAST.BlockQuote, MarkdownAST.Link, MarkdownAST.Strong, MarkdownAST.Emph,
            MarkdownAST.Strikethrough,
        },
    }
    return mdflatten(io, node.children)
end

function mdflatten(io, node::Node, list::MarkdownAST.List)
    for (idx, li) in enumerate(node.children)
        for (jdx, x) in enumerate(li.children)
            mdflatten(io, x)
            jdx == length(li.children) || print(io, '\n')
        end
        idx == length(node.children) || print(io, '\n')
    end
    return
end
function mdflatten(io, node::Node, t::MarkdownAST.Table)
    rows = collect(Iterators.flatten(thtb.children for thtb in node.children))
    for (idx, row) in enumerate(rows)
        for (jdx, x) in enumerate(row.children)
            mdflatten(io, x.children)
            jdx == length(row.children) || print(io, ' ')
        end
        idx == length(rows) || print(io, '\n')
    end
    return
end

# Inline nodes
mdflatten(io, node::Node, e::MarkdownAST.Text) = print(io, e.text)
function mdflatten(io, node::Node, e::MarkdownAST.Image)
    print(io, "(Image: ")
    mdflatten(io, node.children)
    print(io, ")")
    return
end

mdflatten(io, node::Node, html::MarkdownAST.HTMLBlock) = print(io, replace(html.html, r"<[^>]+>" => ""))
mdflatten(io, node::Node, html::MarkdownAST.HTMLInline) = print(io, replace(html.html, r"<[^>]+>" => ""))

mdflatten(io, node::Node, m::Union{MarkdownAST.InlineMath, MarkdownAST.DisplayMath}) = print(io, replace(m.math, r"[^()+\-*^=\w\s]" => ""))
mdflatten(io, node::Node, e::MarkdownAST.LineBreak) = print(io, '\n')
mdflatten(io, node::Node, ::MarkdownAST.ThematicBreak) = nothing

# Is both inline and block
mdflatten(io, node::Node, c::Union{MarkdownAST.Code, MarkdownAST.CodeBlock}) = print(io, c.code)

# Special (inline) "node" -- due to JuliaMark's interpolations
mdflatten(io, node::Node, value::MarkdownAST.JuliaValue) = print(io, value.ref)

mdflatten(io, node::Node, f::MarkdownAST.FootnoteLink) = print(io, "[$(f.id)]")
function mdflatten(io, node::Node, f::MarkdownAST.FootnoteDefinition)
    print(io, "[$(f.id)]: ")
    return mdflatten(io, node.children)
end

function mdflatten(io, node::Node, a::MarkdownAST.Admonition)
    println(io, "$(a.category): $(a.title)")
    return mdflatten(io, node.children)
end

end

"Provides a namespace for remote dependencies."
module RD
using JSON: JSON
using ....Documenter.JSDependencies: RemoteLibrary, Snippet, RequireJS, jsescape, json_jsescape
using ..HTMLWriter: KaTeX, MathJax, MathJax2, MathJax3

const requirejs_cdn = "https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.6/require.min.js"
const lato = "https://cdnjs.cloudflare.com/ajax/libs/lato-font/3.0.0/css/lato-font.min.css"
const juliamono = "https://cdnjs.cloudflare.com/ajax/libs/juliamono/0.63.2/juliamono.min.css"
const fontawesome_version = "6.4.2"
const fontawesome_css = [
    "https://cdnjs.cloudflare.com/ajax/libs/font-awesome/$(fontawesome_version)/css/fontawesome.min.css",
    "https://cdnjs.cloudflare.com/ajax/libs/font-awesome/$(fontawesome_version)/css/solid.min.css",
    "https://cdnjs.cloudflare.com/ajax/libs/font-awesome/$(fontawesome_version)/css/brands.min.css",
]

const jquery = RemoteLibrary("jquery", "https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js")
const jqueryui = RemoteLibrary("jqueryui", "https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.13.2/jquery-ui.min.js")
const lodash = RemoteLibrary("lodash", "https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.21/lodash.min.js")

# headroom
const headroom_version = "0.12.0"
const headroom = RemoteLibrary("headroom", "https://cdnjs.cloudflare.com/ajax/libs/headroom/$(headroom_version)/headroom.min.js")
const headroom_jquery = RemoteLibrary(
    "headroom-jquery",
    "https://cdnjs.cloudflare.com/ajax/libs/headroom/$(headroom_version)/jQuery.headroom.min.js",
    deps = ["jquery", "headroom"],
)

# highlight.js
"Add the highlight.js dependencies and snippet to a [`RequireJS`](@ref) declaration."
function highlightjs!(r::RequireJS, languages = String[])
    # NOTE: the CSS themes for highlightjs are compiled into the Documenter CSS
    # When updating this dependency, it is also necessary to update the CSS
    # files in assets/html/scss/highlightjs
    hljs_version = "11.8.0"
    push!(
        r,
        RemoteLibrary(
            "highlight",
            "https://cdnjs.cloudflare.com/ajax/libs/highlight.js/$(hljs_version)/highlight.min.js"
        )
    )
    languages = ["julia", "julia-repl", languages...]
    for language in languages
        language = jsescape(language)
        push!(
            r,
            RemoteLibrary(
                "highlight-$(language)",
                "https://cdnjs.cloudflare.com/ajax/libs/highlight.js/$(hljs_version)/languages/$(language).min.js",
                deps = ["highlight"]
            )
        )
    end
    push!(
        r,
        Snippet(
            vcat(["jquery", "highlight"], ["highlight-$(jsescape(language))" for language in languages]),
            ["\$"],
            raw"""
            $(document).ready(function() {
                hljs.highlightAll();
            })
            """
        )
    )
    return
end

# MathJax & KaTeX
const katex_version = "0.16.8"
const katex_css = "https://cdnjs.cloudflare.com/ajax/libs/KaTeX/$(katex_version)/katex.min.css"
function mathengine!(r::RequireJS, engine::KaTeX)
    push!(
        r,
        RemoteLibrary(
            "katex",
            "https://cdnjs.cloudflare.com/ajax/libs/KaTeX/$(katex_version)/katex.min.js"
        )
    )
    push!(
        r,
        RemoteLibrary(
            "katex-auto-render",
            "https://cdnjs.cloudflare.com/ajax/libs/KaTeX/$(katex_version)/contrib/auto-render.min.js",
            deps = ["katex"],
        )
    )
    push!(
        r,
        Snippet(
            ["jquery", "katex", "katex-auto-render"],
            ["\$", "katex", "renderMathInElement"],
            """
            \$(document).ready(function() {
              renderMathInElement(
                document.body,
                $(json_jsescape(engine.config, 2))
              );
            })
            """
        )
    )
    return
end
function mathengine!(r::RequireJS, engine::MathJax2)
    url = isempty(engine.url) ? "https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-AMS_HTML" : engine.url
    push!(
        r,
        RemoteLibrary("mathjax", url, exports = "MathJax")
    )
    push!(
        r,
        Snippet(
            ["mathjax"], ["MathJax"],
            """
            MathJax.Hub.Config($(json_jsescape(engine.config, 2)));
            """
        )
    )
    return
end
function mathengine!(r::RequireJS, engine::MathJax3)
    url = isempty(engine.url) ? "https://cdnjs.cloudflare.com/ajax/libs/mathjax/3.2.2/es5/tex-svg-full.js" : engine.url
    push!(
        r,
        Snippet(
            [], [],
            """
            window.MathJax = $(json_jsescape(engine.config, 2));

            (function () {
                var script = document.createElement('script');
                script.src = '$url';
                script.async = true;
                document.head.appendChild(script);
            })();
            """
        )
    )
    return
end
mathengine(::RequireJS, ::Nothing) = nothing
end

# This string is defined in a separate file so that VS Code would not
# complain (or even accidentally "fix") the weird character we want
# to have present every time you open utilities.jl.
const U2028_STRING = "policy to  delete."

using Test
import JSON
using DocInventories: DocInventories, Inventory
import Base64

# DOCUMENTER_TEST_EXAMPLES can be used to control which builds are performed in
# make.jl. But for the tests we need to make sure that all the relevant builds
# ran.
haskey(ENV, "DOCUMENTER_TEST_EXAMPLES") && error("DOCUMENTER_TEST_EXAMPLES env. variable is set")

# When the file is run separately we need to include make.jl which actually builds
# the docs and defines a few modules that are referred to in the docs. The make.jl
# has to be expected in the context of the Main module.
if (@__MODULE__) === Main && !@isdefined examples_root
    include("make.jl")
elseif (@__MODULE__) !== Main && isdefined(Main, :examples_root)
    using Documenter
    const examples_root = Main.examples_root
elseif (@__MODULE__) !== Main && !isdefined(Main, :examples_root)
    error("examples/make.jl has not been loaded into Main.")
end

function latex_filename(doc::Documenter.Documenter.Document)
    @test length(doc.user.format) == 1
    settings = first(doc.user.format)
    @test settings isa Documenter.LaTeX
    fileprefix = Documenter.LaTeXWriter.latex_fileprefix(doc, settings)
    return "$(fileprefix).tex"
end

# Diffing of output TeX files:
using Documenter.TextDiff: Diff, Lines
function onormalize_tex(s)
    # We strip hyperlink hashes, since those may change over time
    s = replace(s, r"\\(hyperlink|hypertarget|label|hyperlinkref){[0-9]+}" => s"\\\1{}")
    # We also write the current Julia version into the TeX file
    s = replace(s, r"\\newcommand{\\JuliaVersion}{[A-Za-z0-9+.-]+}" => "\\newcommand{\\JuliaVersion}{}")
    # Remove CR parts of newlines, to make Windows happy
    s = replace(s, '\r' => "")
    return s
end
function printdiff(s1, s2)
    # We fall back: colordiff -> diff -> Documenter's TextDiff
    diff_cmd = Sys.which("colordiff")
    isnothing(diff_cmd) && (diff_cmd = Sys.which("diff"))
    return if isnothing(diff_cmd)
        show(Diff{Lines}(s1, s2))
    else
        mktempdir() do path
            a, b = joinpath(path, "a"), joinpath(path, "b")
            write(a, s1); write(b, s2)
            run(ignorestatus(`$(diff_cmd) $a $b`))
        end
    end
end
function resolve_tex_reference(path::AbstractString)
    nightly_path = joinpath(dirname(path), "nightly", basename(path))
    if VERSION >= v"1.14.0-DEV" && isfile(nightly_path)
        return nightly_path
    end
    return path
end
function compare_files(a, b)
    reference = resolve_tex_reference(b)
    if haskey(ENV, "DOCUMENTER_FIXTESTS")
        @info "Updating reference file: $(reference)"
        cp(a, reference, force = true)
    end
    a_str, b_str = read(a, String), read(reference, String)
    a_str_normalized, b_str_normalized = onormalize_tex(a_str), onormalize_tex(b_str)
    a_str_normalized == b_str_normalized && return true
    @error "Generated files did not agree with reference, diff follows." a reference
    printdiff(a_str_normalized, b_str_normalized)
    println('='^40, " end of diff ", '='^40)
    return false
end

all_md_files_in_src = let srcdir = joinpath(@__DIR__, "src"), mdfiles = String[]
    for (root, _, pages) in walkdir(srcdir)
        rootdir = relpath(root, srcdir)
        rootdir == "." && (rootdir = "")
        for page in pages
            endswith(page, ".md") || continue
            push!(mdfiles, joinpath(rootdir, page))
        end
    end
    mdfiles
end
@test length(all_md_files_in_src) == 29

@testset "Examples" begin
    @testset "HTML: deploy/$name" for (doc, name) in [
            (Main.examples_html_doc, "html"),
            (Main.examples_html_meta_custom_doc, "html-meta-custom"),
            (Main.examples_html_mathjax2_custom_doc, "html-mathjax2-custom"),
            (Main.examples_html_mathjax3_doc, "html-mathjax3"),
            (Main.examples_html_mathjax3_custom_doc, "html-mathjax3-custom"),
        ]
        @test isa(doc, Documenter.Documenter.Document)

        let build_dir = joinpath(examples_root, "builds", name)
            # Make sure that each .md file has a corresponding generated HTML file
            @testset "md: $mdfile" for mdfile in all_md_files_in_src
                dir, filename = splitdir(mdfile)
                filename, _ = splitext(filename)
                htmlpath = (filename == "index") ? joinpath(build_dir, dir, "index.html") :
                    joinpath(build_dir, dir, filename, "index.html")
                @test isfile(htmlpath)
            end

            # Test existence of some HTML elements
            man_style_html = String(read(joinpath(build_dir, "man", "style", "index.html")))
            @test occursin("is-category-myadmonition", man_style_html)
            @test occursin(Documenter.HTMLWriter.OUTDATED_VERSION_ATTR, man_style_html)

            index_html = read(joinpath(build_dir, "index.html"), String)
            @test occursin(Documenter.HTMLWriter.OUTDATED_VERSION_ATTR, index_html)
            @test occursin("documenter-example-output", index_html)
            @test occursin("1392-test-language", index_html)
            @test !occursin("1392-extra-info", index_html)
            index_html_normalized = replace(index_html, r"\s+" => " ")
            @test occursin(
                raw"<p>I will pay <span>$</span>1 if <span>$x^2$</span> is displayed correctly. People may also write <span>$</span>s or even money bag<span>$</span><span>$</span>.</p>",
                index_html_normalized,
            )

            example_output_html = read(joinpath(build_dir, "example-output", "index.html"), String)
            @test occursin("documenter-example-output", example_output_html)

            # Test for existence of meta tags
            @test occursin("<meta property=\"og:title\"", index_html)
            @test occursin("<meta property=\"twitter:title\"", index_html)
            @test occursin("<meta property=\"og:url\" content=\"https://example.com/stable/\"/>", index_html)
            @test occursin("<meta property=\"twitter:url\" content=\"https://example.com/stable/\"/>", index_html)
            if name == "html-meta-custom"
                @test occursin("<meta name=\"description\" content=\"Example site-wide description.\"/>", index_html)
                @test occursin("<meta property=\"og:description\" content=\"Example site-wide description.\"/>", index_html)
                @test occursin("<meta property=\"twitter:description\" content=\"Example site-wide description.\"/>", index_html)
                @test occursin("<meta property=\"og:image\" content=\"https://example.com/stable/assets/preview.png\"/>", index_html)
                @test occursin("<meta property=\"twitter:image\" content=\"https://example.com/stable/assets/preview.png\"/>", index_html)
                @test occursin("<meta property=\"twitter:card\" content=\"summary_large_image\"/>", index_html)
            else
                @test occursin("<meta name=\"description\" content=\"Documentation for Documenter example.\"/>", index_html)
                @test occursin("<meta property=\"og:description\" content=\"Documentation for Documenter example.\"/>", index_html)
                @test occursin("<meta property=\"twitter:description\" content=\"Documentation for Documenter example.\"/>", index_html)
                @test !occursin("<meta property=\"og:image\"", index_html)
                @test !occursin("<meta property=\"twitter:image\"", index_html)
                @test !occursin("<meta property=\"twitter:card\"", index_html)
            end

            # Assets
            @test joinpath(build_dir, "assets", "documenter.js") |> isfile
            documenter_js = read(joinpath(build_dir, "assets", "documenter.js"), String)
            if name == "html-mathjax3"
                @test occursin("https://cdnjs.cloudflare.com/ajax/libs/mathjax/3", documenter_js)
            elseif name == "html-mathjax2-custom"
                @test occursin("https://cdn.jsdelivr.net/npm/mathjax@2/MathJax", documenter_js)
            elseif name == "html-mathjax3-custom"
                @test occursin("script.src = 'https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js';", documenter_js)
            else # name == "html", uses MathJax2
                @test occursin("https://cdnjs.cloudflare.com/ajax/libs/mathjax/2", documenter_js)
            end

            # This build includes erlang and erlang-repl highlighting
            documenterjs = String(read(joinpath(build_dir, "assets", "documenter.js")))
            @test occursin("languages/julia.min", documenterjs)
            @test occursin("languages/julia-repl.min", documenterjs)
            @test occursin("languages/erlang-repl.min", documenterjs)
            @test occursin("languages/erlang.min", documenterjs)

            # Issue 491
            @test isfile(joinpath(build_dir, "issue491", "index.html"))
            issue_491 = read(joinpath(build_dir, "issue491", "index.html"), String)

            @test occursin("julia&gt; item", issue_491)
            @test occursin("julia&gt; item_item", issue_491)
            @test occursin("julia&gt; admonition", issue_491)
            @test occursin("julia&gt; admonition_blockquote", issue_491)

            @test occursin("expanded_eval", issue_491)
            @test occursin("expanded_example", issue_491)
            @test occursin("expanded_setup", issue_491)
            @test occursin("<p>expanded_raw</p>", issue_491)

            # CollapsedDocStrings
            if name == "html"
                # The `index.md` page does not have `CollapsedDocStrings` in
                # its `@meta` block, ...
                @test !occursin("<div data-docstringscollapsed=\"true\">", index_html)
                # but the `lib/functions.md` page does, ...
                functions_html = read(joinpath(build_dir, "lib", "functions", "index.html"), String)
                # so it should have the JS that clicks the toggle button.
                @test occursin("<div data-docstringscollapsed=\"true\">", functions_html)
            end

            # .documenter-siteinfo.json
            @testset ".documenter-siteinfo.json" begin
                siteinfo_json_file = joinpath(build_dir, ".documenter-siteinfo.json")
                @test isfile(siteinfo_json_file)
                siteinfo_json = JSON.parse(read(siteinfo_json_file, String); dicttype = Dict{String, Any})
                @test haskey(siteinfo_json, "documenter")
                @test siteinfo_json["documenter"] isa Dict
                @test haskey(siteinfo_json["documenter"], "documenter_version")
                @test haskey(siteinfo_json["documenter"], "julia_version")
                @test haskey(siteinfo_json["documenter"], "generation_timestamp")
            end

            # inventory
            @testset "inventory" begin
                objects_inv = joinpath(build_dir, "objects.inv")
                @test isfile(objects_inv)
                if isfile(objects_inv)
                    inv = Inventory(objects_inv; root_url = "")
                    @test inv.project == "Documenter example"
                    if name == "html"
                        @test inv.version == "$(Documenter.DOCUMENTER_VERSION)+test"
                        @test length(inv("Anonymous function declaration")) == 1
                        if length(inv("Anonymous function declaration")) == 1
                            item = inv("Anonymous function declaration")[1]
                            @test item.domain == "std"
                            @test item.role == "label"
                            @test item.dispname == "Anonymous function declaration"
                            @test item.name == "Anonymous-function-declaration"
                            @test item.uri == "#\$"
                            @test item.priority == -1
                            @test DocInventories.uri(item) == "#Anonymous-function-declaration"
                        end
                        item = inv[":std:label:`xreftarget`"]
                        @test !isnothing(item)
                        if !isnothing(item)
                            @test item.name == "xreftarget"
                            @test item.dispname == "X-ref target with id"
                            @test DocInventories.uri(item) == "xrefs/#xreftarget"
                        end
                        # Inline `[content](@id name)` anchor on non-header content (#745)
                        item = inv[":std:label:`inline-anchor-target`"]
                        @test !isnothing(item)
                        if !isnothing(item)
                            @test item.name == "inline-anchor-target"
                            @test item.dispname == "an anchored phrase"
                            @test DocInventories.uri(item) == "xrefs/#inline-anchor-target"
                        end
                        item = inv[":std:label:`Markdown-files-with-spaces`"]
                        @test !isnothing(item)
                        if !isnothing(item)
                            @test item.name == "Markdown-files-with-spaces"
                            @test item.dispname == "Markdown files with spaces"
                            @test item.uri == "man/page%20with%20space/#\$"
                            @test DocInventories.uri(item) == "man/page%20with%20space/#Markdown-files-with-spaces"
                        end
                        @test length(inv(":doc:`man/style`")) == 1
                        if length(inv(":doc:`man/style`")) == 1
                            item = inv(":doc:`man/style`")[1]
                            @test item.domain == "std"
                            @test item.role == "doc"
                            @test item.dispname == "Style demos"
                            @test item.name == "man/style"
                            @test item.uri == "man/style/"
                            @test item.priority == -1
                            @test DocInventories.uri(item) == "man/style/"
                        end
                        item = inv[":std:doc:`man/page with space`"]
                        @test !isnothing(item)
                        if !isnothing(item)
                            @test item.name == "man/page with space"
                            @test item.dispname == "Markdown files with spaces"
                            @test item.uri == "man/page%20with%20space/"
                            @test DocInventories.uri(item) == "man/page%20with%20space/"
                        end
                        jl_roles = Set(item.role for item in inv if item.domain == "jl")
                        @test jl_roles == Set(
                            [
                                "constant",
                                "keyword",
                                "function",
                                "method",
                                "macro",
                                "module",
                                "type",
                            ]
                        )
                        @test length(inv(":jl:constant:`Main.AutoDocs.K`")) == 1
                        if length(inv(":jl:constant:`Main.AutoDocs.K`")) == 1
                            item = inv[":jl:constant:`Main.AutoDocs.K`"]
                            @test item.domain == "jl"
                            @test item.role == "constant"
                            @test item.name == "Main.AutoDocs.K"
                            @test item.uri == "lib/functions/#\$"
                            @test item.priority == 1
                            @test DocInventories.uri(item) == "lib/functions/#Main.AutoDocs.K"
                        end
                        @test length(inv(":jl:keyword:`while`")) == 1
                        if length(inv(":jl:keyword:`while`")) == 1
                            item = inv[":jl:keyword:`while`"]
                            @test item.domain == "jl"
                            @test item.role == "keyword"
                            @test item.name == "while"
                            @test item.uri == "lib/functions/#\$"
                            @test item.priority == 1
                            @test DocInventories.uri(item) == "lib/functions/#while"
                        end
                        @test length(inv("Documenter.hide")) == 1
                        if length(inv("Documenter.hide")) == 1
                            item = inv("Documenter.hide")[1]
                            @test item.domain == "jl"
                            @test item.role == "function"
                            @test item.name == "Documenter.hide"
                            @test item.uri == "hidden/#\$"
                            @test item.priority == 1
                            @test DocInventories.uri(item) == "hidden/#Documenter.hide"
                        end
                        @test length(inv("AutoDocs.Pages.f-Tuple{Any, Any, Any}")) == 1
                        if length(inv("AutoDocs.Pages.f-Tuple{Any, Any, Any}")) == 1
                            item = inv("AutoDocs.Pages.f-Tuple{Any, Any, Any}")[1]
                            @test item.domain == "jl"
                            @test item.role == "method"
                            @test item.name == "Main.AutoDocs.Pages.f-Tuple{Any, Any, Any}"
                            @test item.uri == "lib/functions/#Main.AutoDocs.Pages.f-Tuple%7BAny%2C%20Any%2C%20Any%7D"
                            @test item.priority == 1
                        end
                        @test length(inv(".A.@m")) == 1
                        if length(inv(".A.@m")) == 1
                            item = inv(".A.@m")[1]
                            @test item.domain == "jl"
                            @test item.role == "macro"
                            @test item.name == "Main.AutoDocs.A.@m-Tuple{}"
                            @test item.uri == "lib/functions/#Main.AutoDocs.A.%40m-Tuple%7B%7D"
                            @test item.priority == 1
                        end
                        @test length(inv(":module:`AutoDocs`")) == 1
                        if length(inv(":module:`AutoDocs`")) == 1
                            item = inv(":module:`AutoDocs`")[1]
                            @test item.domain == "jl"
                            @test item.role == "module"
                            @test item.name == "AutoDocs"
                            @test item.uri == "lib/functions/#\$"
                            @test item.priority == 1
                            @test DocInventories.uri(item) == "lib/functions/#AutoDocs"
                        end
                        @test length(inv("AutoDocs.T")) == 1
                        if length(inv("AutoDocs.T")) == 1
                            item = inv("AutoDocs.T")[1]
                            @test item.domain == "jl"
                            @test item.role == "type"
                            @test item.name == "Main.AutoDocs.T"
                            @test item.uri == "lib/functions/#\$"
                            @test item.priority == 1
                            @test DocInventories.uri(item) == "lib/functions/#Main.AutoDocs.T"
                        end
                    end
                end
            end

            @testset "at-example outputs: $fmt/$size" for ((fmt, size), data) in AT_EXAMPLE_FILES
                if size === :tiny
                    encoded_data = Base64.base64encode(data.bytes)
                    @test occursin(encoded_data, read(joinpath(build_dir, "index.html"), String))
                    @test occursin(encoded_data, read(joinpath(build_dir, "example-output", "index.html"), String))
                    @test occursin(encoded_data, read(joinpath(build_dir, "outputs", "index.html"), String))
                    @test occursin(encoded_data, read(joinpath(build_dir, "outputs", "outputs", "index.html"), String))
                else # size === :big
                    # From src/index.md
                    @test isfile(joinpath(build_dir, "index-$(data.hash_slug).$(fmt)"))
                    @test read(joinpath(build_dir, "index-$(data.hash_slug).$(fmt)")) == data.bytes
                    # From src/example-output.md
                    @test isfile(joinpath(build_dir, "example-output", "$(data.hash_slug).$(fmt)"))
                    @test read(joinpath(build_dir, "example-output", "$(data.hash_slug).$(fmt)")) == data.bytes
                    # From src/outputs/index.md
                    @test isfile(joinpath(build_dir, "outputs", "index-$(data.hash_slug).$(fmt)"))
                    @test read(joinpath(build_dir, "outputs", "index-$(data.hash_slug).$(fmt)")) == data.bytes
                    # From src/outputs/outputs.md
                    @test isfile(joinpath(build_dir, "outputs", "outputs", "$(data.hash_slug).$(fmt)"))
                    @test read(joinpath(build_dir, "outputs", "outputs", "$(data.hash_slug).$(fmt)")) == data.bytes
                end
            end
            # SVG on src/example-output.md
            @test isfile(joinpath(build_dir, "example-output", "$(SVG_BIG.hash_slug).svg"))
            @test read(joinpath(build_dir, "example-output", "$(SVG_BIG.hash_slug).svg")) == SVG_BIG.bytes
            # SVG on src/example-output.md, from Main.SVG_MULTI
            @test isfile(joinpath(build_dir, "example-output", "$(SVG_BIG.hash_slug)-001.svg"))
            @test read(joinpath(build_dir, "example-output", "$(SVG_BIG.hash_slug).svg")) == SVG_BIG.bytes
            # .. but, crucially, Main.SVG_HTML did _not_ get written out.
            @test !isfile(joinpath(build_dir, "example-output", "$(SVG_BIG.hash_slug)-002.svg"))
        end

        # Testing linkcheck_useragent default
        @test doc.user.linkcheck_useragent == Documenter._LINKCHECK_DEFAULT_USERAGENT
    end

    @testset "HTML: local" begin
        doc = Main.examples_html_local_doc

        @test isa(doc, Documenter.Documenter.Document)

        let build_dir = joinpath(examples_root, "builds", "html-local")

            index_html = read(joinpath(build_dir, "index.html"), String)
            @test occursin("<strong>bold</strong> output from MarkdownOnly", index_html)
            @test occursin("documenter-example-output", index_html)

            # Make sure that each .md file has a corresponding generated HTML file
            @testset "md: $mdfile" for mdfile in all_md_files_in_src
                dir, filename = splitdir(mdfile)
                filename, _ = splitext(filename)
                htmlpath = joinpath(build_dir, dir, "$(filename).html")
                @test isfile(htmlpath)
            end

            # Assets
            @test joinpath(build_dir, "assets", "documenter.js") |> isfile
            documenterjs = String(read(joinpath(build_dir, "assets", "documenter.js")))
            @test occursin("languages/julia.min", documenterjs)
            @test occursin("languages/julia-repl.min", documenterjs)
            let
                example_output_html = read(joinpath(build_dir, "example-output.html"), String)
                example_head = match(r"<head>(.*?)</head>"ms, example_output_html).captures[1]
                @test occursin("<script>console.log('hello from head content! 🌸')</script>", example_head)
            end

            @testset "at-example outputs: $fmt/$size" for ((fmt, size), data) in AT_EXAMPLE_FILES
                if size === :tiny
                    encoded_data = Base64.base64encode(data.bytes)
                    @test occursin(encoded_data, read(joinpath(build_dir, "index.html"), String))
                    @test occursin(encoded_data, read(joinpath(build_dir, "example-output.html"), String))
                    @test occursin(encoded_data, read(joinpath(build_dir, "outputs", "index.html"), String))
                    @test occursin(encoded_data, read(joinpath(build_dir, "outputs", "outputs.html"), String))
                else # size === :big
                    # From src/index.md
                    @test isfile(joinpath(build_dir, "index-$(data.hash_slug).$(fmt)"))
                    @test read(joinpath(build_dir, "index-$(data.hash_slug).$(fmt)")) == data.bytes
                    # From src/example-output.md
                    @test isfile(joinpath(build_dir, "example-output-$(data.hash_slug).$(fmt)"))
                    @test read(joinpath(build_dir, "example-output-$(data.hash_slug).$(fmt)")) == data.bytes
                    # From src/outputs/index.md
                    @test isfile(joinpath(build_dir, "outputs", "index-$(data.hash_slug).$(fmt)"))
                    @test read(joinpath(build_dir, "outputs", "index-$(data.hash_slug).$(fmt)")) == data.bytes
                    # From src/outputs/outputs.md
                    @test isfile(joinpath(build_dir, "outputs", "outputs-$(data.hash_slug).$(fmt)"))
                    @test read(joinpath(build_dir, "outputs", "outputs-$(data.hash_slug).$(fmt)")) == data.bytes
                end
            end
            # SVG on src/example-output.md
            @test isfile(joinpath(build_dir, "example-output-$(SVG_BIG.hash_slug).svg"))
            @test read(joinpath(build_dir, "example-output-$(SVG_BIG.hash_slug).svg")) == SVG_BIG.bytes
            # SVG on src/example-output.md, from Main.SVG_MULTI
            @test isfile(joinpath(build_dir, "example-output-$(SVG_BIG.hash_slug)-001.svg"))
            @test read(joinpath(build_dir, "example-output-$(SVG_BIG.hash_slug).svg")) == SVG_BIG.bytes
            # .. but, crucially, Main.SVG_HTML did _not_ get written out.
            @test !isfile(joinpath(build_dir, "example-output-$(SVG_BIG.hash_slug)-002.svg"))
        end

        # It doesn't actually test that the user agent was used correctly, but at least it tests that
        # the option go set.
        @test doc.user.linkcheck_useragent == "Documenter/1"
    end

    @testset "HTML: pagesonly" begin
        doc = Main.examples_html_pagesonly_doc

        @test isa(doc, Documenter.Documenter.Document)

        let build_dir = joinpath(examples_root, "builds", "html-pagesonly")
            # Make sure that each .md file has a corresponding generated HTML file
            @testset "md: $mdfile" for mdfile in all_md_files_in_src
                dir, filename = splitdir(mdfile)
                filename, _ = splitext(filename)
                htmlpath = (filename == "index") ? joinpath(build_dir, dir, "index.html") :
                    joinpath(build_dir, dir, filename, "index.html")
                if mdfile ∈ ("index.md", joinpath("man", "tutorial.md"), joinpath("man", "style.md"))
                    @test isfile(htmlpath)
                else
                    @test !ispath(htmlpath)
                end
            end

            # Assets
            @test joinpath(build_dir, "assets", "documenter.js") |> isfile
            documenterjs = String(read(joinpath(build_dir, "assets", "documenter.js")))
            @test occursin("languages/julia.min", documenterjs)
            @test occursin("languages/julia-repl.min", documenterjs)
        end
    end

    @testset "HTML: repo-*" begin
        @test examples_html_repo_git_doc.user.remote === Remotes.GitHub("JuliaDocs", "Documenter.jl")
        @test examples_html_repo_nothing_doc.user.remote === nothing
        @test examples_html_repo_error_doc.user.remote === nothing
    end

    @testset "HTML: sizethreshold" begin
        @test examples_html_sizethreshold_defaults_fail_doc isa Documenter.HTMLWriter.HTMLSizeThresholdError
        @test examples_html_sizethreshold_success_doc isa Documenter.Document
        @test examples_html_sizethreshold_ignore_success_doc isa Documenter.Document
        @test examples_html_sizethreshold_override_fail_doc isa Documenter.HTMLWriter.HTMLSizeThresholdError
        @test examples_html_sizethreshold_ignore_success_doc isa Documenter.Document
        @test examples_html_sizethreshold_ignore_fail_doc isa Documenter.HTMLWriter.HTMLSizeThresholdError
    end

    @testset "PDF/LaTeX: TeX only" begin
        doc = Main.examples_latex_texonly_doc
        @test isa(doc, Documenter.Documenter.Document)
        let build_dir = joinpath(examples_root, "builds", "latex_texonly")
            @test joinpath(build_dir, latex_filename(doc)) |> isfile
            @test joinpath(build_dir, "documenter.sty") |> isfile
        end
    end

    @testset "PDF/LaTeX: simple (TeX only)" begin
        doc = Main.examples_latex_simple_texonly_doc
        @test isa(doc, Documenter.Documenter.Document)
        let build_dir = joinpath(examples_root, "builds", "latex_simple_texonly")
            @test joinpath(build_dir, "documenter.sty") |> isfile
            texfile = joinpath(build_dir, latex_filename(doc))
            @test isfile(texfile)
            @test compare_files(texfile, joinpath(@__DIR__, "references", "latex_simple.tex"))
        end
    end

    @testset "PDF/LaTeX: showcase (TeX only)" begin
        doc = Main.examples_latex_showcase_texonly_doc
        @test isa(doc, Documenter.Documenter.Document)
        let build_dir = joinpath(examples_root, "builds", "latex_showcase_texonly")
            @test joinpath(build_dir, "documenter.sty") |> isfile
            texfile = joinpath(build_dir, latex_filename(doc))
            @test isfile(texfile)
            @test compare_files(texfile, joinpath(@__DIR__, "references", "latex_showcase.tex"))
        end
    end

    @testset "CrossReferences" begin
        xref_file = joinpath(examples_root, "builds", "html", "xrefs", "index.html")
        @test isfile(xref_file)
        xref_file_html = read(xref_file, String)
        # Make sure that all the cross-reference links were updated:
        @test !occursin("@ref", xref_file_html)
    end
end

using Base.Meta
import Base: isdeprecated, Docs.Binding
using DocStringExtensions: SIGNATURES, TYPEDSIGNATURES
import Markdown, MarkdownAST
import Base64: stringmime


using .Remotes: Remote, repourl, repofile
# These imports are here to support code that still assumes that these names are defined
# in the Utilities module.
using .Remotes: RepoHost, RepoGithub, RepoBitbucket, RepoGitlab, RepoAzureDevOps,
    RepoUnknown, format_commit, format_line, repo_host_from_url, LineRangeFormatting

const original_pwd = Ref{String}()  # for printing relative paths in error messages


"""
    @docerror(doc, tag, msg, exs...)

Add `tag` to the `doc.internal.errors` array and log the message `msg` as an
error (if `tag` matches the `doc.user.strict` setting) or warning.

- `doc` must be the instance of `Document` used for the Documenter run
- `tag` must be one of the `Symbol`s in `ERROR_NAMES`
- `msg` is the explanation of the issue to the user
- `exs...` are additional expressions that will be included with the message;
  see `@error` and `@warn`
"""
macro docerror(doc, tag, msg, exs...)
    isa(tag, QuoteNode) && isa(tag.value, Symbol) || error("invalid call of @docerror: tag=$tag")
    tag.value ∈ ERROR_NAMES || throw(ArgumentError("tag $(tag) is not a valid Documenter error"))
    doc, msg = esc(doc), esc(msg)
    # The `exs` portion can contain variable name / label overrides, i.e. `foo = bar()`
    # We don't want to apply esc() on new labels, since they get printed as expressions then.
    exs = map(exs) do ex
        if isa(ex, Expr) && ex.head == :(=) && ex.args[1] isa Symbol
            ex.args[2:end] .= esc.(ex.args[2:end])
            ex
        else
            esc(ex)
        end
    end
    return quote
        let doc = $(doc)
            push!(doc.internal.errors, $(tag))
            if is_strict(doc, $(tag))
                @error $(msg) $(exs...)
            else
                @warn $(msg) $(exs...)
            end
        end
    end
end

# escape characters that has a meaning in regex
regex_escape(str) = sprint(escape_string, str, "\\^\$.|?*+()[{")

# helper to display linerange for error printing
function find_block_in_file(code, file)
    source_file = Base.find_source_file(file)
    source_file === nothing && return nothing
    isfile(source_file) || return nothing
    content = read(source_file, String)
    content = replace(content, "\r\n" => "\n")
    # make a regex of the code that matches leading whitespace
    rcode = "\\h*" * replace(regex_escape(code), "\\n" => "\\n\\h*")
    blockidx = findfirst(Regex(rcode), content)
    blockidx === nothing && return nothing
    startline = countlines(IOBuffer(content[1:prevind(content, first(blockidx))]))
    endline = startline + countlines(IOBuffer(code)) + 1 # +1 to include the closing ```
    return startline => endline
end

# Pretty-printing locations
function locrepr(file::String, lines::Union{Nothing, Pair{Int, Int}} = nothing)
    basedir = isassigned(original_pwd) ? original_pwd[] : currentdir()
    file = abspath(file)
    str = Base.contractuser(relpath(file, basedir))
    lines !== nothing && (str = str * ":$(lines.first)-$(lines.second)")
    return str
end

function locrepr(doc, page, lines::Union{Nothing, Pair{Int, Int}} = nothing)
    file = joinpath(doc.user.root, page.source)
    return locrepr(file, lines)
end

# Directory paths.

"""
Returns the current directory.
"""
function currentdir()
    d = Base.source_dir()
    return d === nothing ? pwd() : d
end

"""
Returns the path to the Documenter `assets` directory.
"""
assetsdir() = normpath(joinpath(dirname(@__FILE__), "..", "..", "assets"))

"""
Find the path of a file relative to the `source` directory. `root` is the path
to the directory containing the file `file`.

It is meant to be used with `walkdir(source)`.
"""
srcpath(source, root, file) = normpath(joinpath(relpath(root, source), file))

# Slugify text.

"""
Slugify a string into a suitable URL.
"""
function slugify(s::AbstractString)
    s = replace(s, r"\s+" => "-")
    s = replace(s, r"&" => "-and-")
    s = replace(s, r"[^\p{L}\p{P}\d\-]+" => "")
    s = strip(replace(s, r"\-\-+" => "-"), '-')
    return s
end
slugify(object) = string(object) # Non-string slugifying doesn't do anything.

# Render doc bindings with syntax that can be copy-pasted as valid Julia code.
# Workaround for <https://github.com/JuliaDocs/Documenter.jl/issues/2844>: in
# the Julia documentation, `Base.:(:)` was being displayed as `Base.::`. This
# has been fixed in <https://github.com/JuliaLang/julia/pull/61043> but until
# this fix is available in Julia versions, we replace calls to `string` on
# bindings by `Documenter.bindingstring`. In the future, we may be able to
# get rid of this again.
function bindingstring(binding::Binding)
    if VERSION < v"1.14.0-DEV.1731"
        s = string(binding)
        op_prefix = string(binding.mod, ".:")
        return startswith(s, op_prefix) ? string(binding.mod, ".", sprint(show, binding.var)) : s
    else
        return string(binding)
    end
end

# Parse code blocks.

"""
Returns a vector of parsed expressions and their corresponding raw strings.

Returns a `Vector` of tuples `(expr, code)`, where `expr` is the corresponding expression
(e.g. a `Expr` or `Symbol` object) and `code` is the string of code the expression was
parsed from.

The keyword argument `skip = N` drops the leading `N` lines from the input string.

If `raise=false` is passed, the `Meta.parse` does not raise an exception on parse errors,
but instead returns an expression that will raise an error when evaluated. `parseblock`
returns this expression normally and it must be handled appropriately by the caller.

The `linenumbernode` can be passed as a `LineNumberNode` to give information about filename
and starting line number of the block (requires Julia 1.6 or higher).

The `syntax_version` can be passed as a `VersionNumber` to parse the code using a specific
Julia syntax version. This requires Julia 1.14 or higher.

The `mod` can be passed as a `Module` to use that module's parser (via `Meta.parser_for_module`).
If not specified, the default parser is used. When both `syntax_version` and `mod` are specified,
`syntax_version` takes precedence.
"""
function parseblock(
        code::AbstractString, doc, file; skip = 0, keywords = true, raise = true,
        linenumbernode = nothing, lines = nothing, syntax_version = nothing, mod = nothing
    )
    # Drop `skip` leading lines from the code block. Needed for deprecated `{docs}` syntax.
    code = string(code, '\n')
    code = last(split(code, '\n', limit = skip + 1))
    endofstr = lastindex(code)
    results = []
    cursor = 1
    # Determine which parser to use:
    # 1. If syntax_version is specified and VersionedParse exists, use versioned parser
    # 2. Otherwise, use the module's parser via parser_for_module (defaults to Core._parse)
    _parse = if syntax_version !== nothing && isdefined(Base, :VersionedParse)
        Base.VersionedParse(syntax_version)
    elseif isdefined(Meta, :parser_for_module)
        Meta.parser_for_module(mod)
    else
        nothing
    end
    while cursor < endofstr
        # Check for keywords first since they will throw parse errors if we `parse` them.
        line = match(r"^(.*)\r?\n"m, SubString(code, cursor)).match
        keyword = Symbol(strip(line))
        (ex, ncursor) =
        if keywords && haskey(Docs.keywords, keyword)
            (QuoteNode(keyword), cursor + lastindex(line))
        else
            try
                if _parse !== nothing
                    Meta.parse(code, cursor; raise = raise, _parse = _parse)
                else
                    Meta.parse(code, cursor; raise = raise)
                end
            catch err
                @docerror(doc, :parse_error, "failed to parse code block in $(locrepr(file, lines))", exception = err)
                return []
            end
        end
        str = SubString(code, cursor, prevind(code, ncursor))
        if !isempty(strip(str)) && ex !== nothing
            push!(results, (ex, str))
        end
        cursor = ncursor
    end
    if linenumbernode isa LineNumberNode
        parseall_kwargs = _parse !== nothing ? (; filename = linenumbernode.file, _parse = _parse) : (; filename = linenumbernode.file)
        exs = Meta.parseall(code; parseall_kwargs...).args
        if isempty(results) && length(exs) == 1 && exs[1] isa LineNumberNode
            # block was empty or consisted of just comments
            empty!(exs)
        end
        @assert length(exs) == 2 * length(results) "Issue at $linenumbernode:\n$code"
        for (i, ex) in enumerate(Iterators.partition(exs, 2))
            @assert ex[1] isa LineNumberNode
            expr = Expr(:toplevel, ex...) # LineNumberNode + expression
            # in the REPL each evaluation is considered a new file, e.g.
            # REPL[1], REPL[2], ..., so try to mimic that by incrementing
            # the counter for each sub-expression in this code block
            if linenumbernode.file === Symbol("REPL")
                newfile = "REPL[$i]"
                # to reset the line counter for each new "file"
                lineshift = 1 - ex[1].line
                update_linenumbernodes!(expr, newfile, lineshift)
            else
                update_linenumbernodes!(expr, linenumbernode.file, linenumbernode.line)
            end
            results[i] = (expr, results[i][2])
        end
    end
    return results
end
isassign(x) = isexpr(x, :(=), 2) && isa(x.args[1], Symbol)

function update_linenumbernodes!(x::Expr, newfile, lineshift)
    for i in 1:length(x.args)
        x.args[i] = update_linenumbernodes!(x.args[i], newfile, lineshift)
    end
    return x
end
update_linenumbernodes!(x::Any, newfile, lineshift) = x
function update_linenumbernodes!(x::LineNumberNode, newfile, lineshift)
    return LineNumberNode(x.line + lineshift, newfile)
end


# Finding submodules.

"""
Returns the set of submodules of a given root module/s.
"""
function submodules(modules::Vector{Module}; ignore = Set{Module}())
    out = Set{Module}()
    for each in modules
        submodules(each, out; ignore = ignore)
    end
    return out
end
function submodules(root::Module, seen = Set{Module}(); ignore = Set{Module}())
    push!(seen, root)
    for name in names(root, all = true)
        if Base.isidentifier(name) && isdefined(root, name) && !isdeprecated(root, name)
            object = getfield(root, name)
            if isa(object, Module) && !(object in seen) && !(object in ignore) && parentmodule(object::Module) == root
                submodules(object, seen)
            end
        end
    end
    return seen
end


## objects
## =======


"""
Represents an object stored in the docsystem by its binding and signature.
"""
struct Object
    binding::Binding
    signature::Type
    noncanonical_extra::Union{String, Nothing}

    function Object(b::Binding, signature::Type, noncanonical_extra = nothing)
        m = nameof(b.mod) === b.var ? parentmodule(b.mod) : b.mod
        return new(Binding(m, b.var), signature, noncanonical_extra)
    end
end

is_canonical(o::Object) = o.noncanonical_extra === nothing

function splitexpr(x::Expr)
    return isexpr(x, :macrocall) ? splitexpr(x.args[1]) :
        isexpr(x, :.) ? (x.args[1], x.args[2]) :
        error("Invalid @var syntax `$x`.")
end
splitexpr(s::Symbol) = :(Main), quot(s)
splitexpr(other) = error("Invalid @var syntax `$other`.")

"""
    object(ex, str)

Returns a expression that, when evaluated, returns an [`Object`](@ref) representing `ex`.
"""
function object(ex::Union{Symbol, Expr}, str::AbstractString)
    binding = Expr(:call, Binding, splitexpr(Docs.namify(ex))...)
    signature = Base.Docs.signature(ex)
    isexpr(ex, :macrocall, 2) && !endswith(str, "()") && (signature = :(Union{}))
    return Expr(:call, Object, binding, signature)
end

function object(qn::QuoteNode, str::AbstractString)
    if haskey(Base.Docs.keywords, qn.value)
        binding = Expr(:call, Binding, Main, qn)
        return Expr(:call, Object, binding, Union{})
    else
        error("'$(qn.value)' is not a documented keyword.")
    end
end

function Base.print(io::IO, obj::Object)
    print(io, bindingstring(obj.binding))
    print_signature(io, obj.signature)
    print_extra(io, obj.noncanonical_extra)
    return
end
print_extra(io::IO, noncanonical_extra::Nothing) = nothing
print_extra(io::IO, noncanonical_extra::String) = print(io, "-", noncanonical_extra)
print_signature(io::IO, signature::Union{Union, Type{Union{}}}) = nothing
print_signature(io::IO, signature) = print(io, '-', signature)

## docs
## ====

"""
    docs(ex, str)

Returns an expression that, when evaluated, returns the docstrings associated with `ex`.
"""
function docs end

# Macro representation changed between 0.4 and 0.5.
function docs(ex::Union{Symbol, Expr}, str::AbstractString)
    isexpr(ex, :macrocall, 2) && !endswith(rstrip(str), "()") && (ex = quot(ex))
    return :(Base.Docs.@doc $ex)
end
docs(qn::QuoteNode, str::AbstractString) = :(Base.Docs.@doc $(qn.value))

"""
Returns the category name of the provided [`Object`](@ref).
"""
doccat(obj::Object) = startswith(string(obj.binding.var), '@') ?
    "Macro" : doccat(obj.binding, obj.signature)

function doccat(b::Binding, ::Union{Union, Type{Union{}}})
    if b.mod === Main && haskey(Base.Docs.keywords, b.var)
        return "Keyword"
    elseif startswith(string(b.var), '@')
        return "Macro"
    else
        return doccat(getfield(b.mod, b.var))
    end
end

doccat(b::Binding, ::Type) = "Method"

doccat(::Function) = "Function"
doccat(::Type) = "Type"
doccat(x::UnionAll) = doccat(Base.unwrap_unionall(x))
doccat(::Module) = "Module"
doccat(::Any) = "Constant"

"""
    $(SIGNATURES)

Tries to determine the "root" of the directory hierarchy containing `path`.
Returns the absolute path to the root directory or `nothing` if no root was found.
If `path` is a directory, it may itself already be a root.

The predicate `f` gets called with absolute paths to directories and must return `true`
if the directory is a "root". An example predicate is `is_git_repo_root` that checks if
the directory is a Git repository root.

The `dbdir` keyword argument specifies the name of the directory we are searching for to
determine if this is a repository or not. If there is a file called `dbdir`, then it's
contents is checked under the assumption that it is a Git worktree or a submodule.
"""
function find_root_parent(f, path)
    ispath(path) || throw(ArgumentError("find_root_parent called with non-existent path\n path: $path"))
    path = realpath(path)
    parent_dir = isdir(path) ? path : dirname(path)
    parent_dir_last = ""
    while parent_dir != parent_dir_last
        f(parent_dir) && return parent_dir
        parent_dir, parent_dir_last = dirname(parent_dir), parent_dir
    end
    return nothing
end

"""
    $(SIGNATURES)

Check is `directory` is a Git repository root.

The `dbdir` keyword argument specifies the name of the directory we are searching for to
determine if this is a repository or not. If there is a file called `dbdir`, then it's
contents is checked under the assumption that it is a Git worktree or a submodule.
"""
function is_git_repo_root(directory::AbstractString; dbdir = ".git")
    isdir(directory) || error("is_git_repo_root called with non-directory path: $directory")
    dbdir_path = joinpath(directory, dbdir)
    isdir(dbdir_path) && return true
    if isfile(dbdir_path)
        contents = chomp(read(dbdir_path, String))
        if startswith(contents, "gitdir: ")
            if isdir(joinpath(directory, contents[9:end]))
                return true
            end
        end
    end
    return false
end

struct RepoCommitError <: Exception
    directory::String
    msg::String
    err_bt::Union{Tuple{Any, Any}, Nothing}
    RepoCommitError(directory::AbstractString, msg::AbstractString) = new(directory, msg, nothing)
    RepoCommitError(directory::AbstractString, msg::AbstractString, e, bt) = new(directory, msg, (e, bt))
end

function repo_commit(repository_root::AbstractString)
    isdir(repository_root) || throw(RepoCommitError(repository_root, "repository_root not a directory"))
    return cd(repository_root) do
        try
            toplevel = readchomp(`$(git()) rev-parse --show-toplevel`)
            if !ispath(toplevel)
                throw(RepoCommitError(repository_root, "`git rev-parse --show-toplevel` returned invalid path: $toplevel"))
            end
            if realpath(toplevel) != realpath(repository_root)
                throw(
                    RepoCommitError(
                        repository_root,
                        """
                        repository_root is not the top-level of the repository
                          `git rev-parse --show-toplevel`: $toplevel
                          repository_root: $repository_root
                        """
                    )
                )
            end
        catch e
            isa(e, RepoCommitError) && rethrow(e)
            throw(RepoCommitError(repository_root, "`git rev-parse --show-toplevel` failed", e, catch_backtrace()))
        end
        try
            readchomp(`$(git()) rev-parse HEAD`)
        catch e
            throw(RepoCommitError(repository_root, "`git rev-parse HEAD` failed", e, catch_backtrace()))
        end
    end
end

"""
A [`Remote`](@ref) corresponding to the main Julia language repository.
"""
const julia_remote = Remotes.GitHub("JuliaLang", "julia")

"""
Stores the memoized results of [`getremote`](@ref).
"""
const GIT_REMOTE_CACHE = Dict{String, Union{Remotes.Remote, Nothing}}()

# Borrowed from LibGit2 in JuliaLang/julia (MIT)
# https://github.com/JuliaLang/julia/blob/f033630cf08fe20818ee2be7fce2839fce12ec43/stdlib/LibGit2/src/LibGit2.jl#L18-L19
const GITHUB_REGEX =
    r"^(?:(?:ssh://)?git@|git://|https://(?:[\w\.\+\-]+@)?)github.com[:/](([^/].+)/(.+?))(?:\.git)?$"i

function parse_remote_url(remote::AbstractString)
    # TODO: we only match for GitHub repositories automatically. Could we engineer a
    # system where, if there is a user-created Remote, the user could also define a
    # matching function here that tries to interpret other URLs?
    m = match(GITHUB_REGEX, remote)
    isnothing(m) && return nothing
    return Remotes.GitHub(m[2], m[3])
end

"""
$(TYPEDSIGNATURES)

Determines the GitHub remote of a directory by checking `remote.origin.url` of the
repository. Returns a [`Remotes.GitHub`](@ref), or `nothing` is something has gone wrong
(e.g. it's run on a directory not in a Git repo, or `origin.url` points to a non-GitHub
remote).

The results for a given directory are memoized in [`GIT_REMOTE_CACHE`](@ref), since calling
`git` is expensive and it is often called on the same directory over and over again.
"""
function getremote(dir::AbstractString)
    isdir(dir) || return nothing
    return get!(GIT_REMOTE_CACHE, dir) do
        remote = try
            readchomp(setenv(`$(git()) config --get remote.origin.url`; dir = dir))
        catch e
            @debug "git config --get remote.origin.url failed" exception = (e, catch_backtrace())
            ""
        end
        return parse_remote_url(remote)
    end
end

function inbase(m::Module)
    if m ≡ Base
        return true
    else
        parent = parentmodule(m)
        return parent ≡ m ? false : inbase(parent)
    end
end

# Find line numbers.
# ------------------

linerange(doc) = linerange(doc.text, doc.data[:linenumber])

function linerange(text, from)
    # text is assumed to be a Core.SimpleVector (svec) from the .text field of a Docs.DocStr object.
    # Hence, we need to be careful when summing over an empty svec below.
    #
    # Also, the isodd logic _appears_ to be there to handle variable interpolation into docstrings. In that case,
    # the .text field seems to become longer than just 1 element and every even element is the interpolated object,
    # and only the odd ones actually contain the docstring text as a string.
    lines = sum(Int[isodd(n) ? newlines(s) : 0 for (n, s) in enumerate(text)])
    return lines > 0 ? (from:(from + lines + 1)) : (from:from)
end

newlines(s::AbstractString) = count(c -> c === '\n', s)
newlines(other) = 0


"""
    isabsurl(url)

Checks whether `url` is an absolute URL (as opposed to a relative one).
"""
isabsurl(url) = occursin(ABSURL_REGEX, url)
const ABSURL_REGEX = r"^[[:alpha:]+-.]+://"

"""
    mdparse(s::AbstractString; mode=:single)

Parses the given string as Markdown using `Markdown.parse`, but strips away the surrounding
layers, such as the outermost `Markdown.MD`. What exactly is returned depends on the `mode`
keyword. The resulting Markdown AST is converted into an array of `MarkdownAST.Node`s.

The `mode` keyword argument can be one of the following:

* `:single` (default) -- returns a single block-level object (e.g. `Markdown.Paragraph` or
  `Markdown.Admonition`) and errors if the string parses into multiple blocks.
* `:blocks` -- the function returns a `Vector{Any}` of Markdown blocks.
* `:span` -- Returns a `Vector{Any}` of span-level items, stripping away the outer block.
  This requires the string to parse into a single `Markdown.Paragraph`, the contents of
  which gets returned.
"""
function mdparse(s::AbstractString; mode = :single)::Vector{MarkdownAST.Node{Nothing}}
    mode in [:single, :blocks, :span] || throw(ArgumentError("Invalid mode keyword $(mode)"))
    mdast = convert(MarkdownAST.Node, Markdown.parse(s))
    if mode == :blocks
        return MarkdownAST.unlink!.(mdast.children)
    elseif length(mdast.children) == 0
        # case where s == "". We'll just return an empty string / paragraph.
        if mode == :single
            return [
                MarkdownAST.@ast(
                    MarkdownAST.Paragraph() do
                        ""
                    end
                ),
            ]
        else
            # If we're in span mode we return a single Text node
            [MarkdownAST.@ast("")]
        end
    elseif (mode == :single || mode == :span) && length(mdast.children) > 1
        @error "mode == :$(mode) requires the Markdown string to parse into a single block" s mdast
        throw(ArgumentError("Unsuitable string for mode=:$(mode)"))
    else
        @assert length(mdast.children) == 1
        childnode = first(mdast.children)
        @assert mode == :span || mode == :single
        if mode == :span && !isa(childnode.element, MarkdownAST.Paragraph)
            @error "mode == :$(mode) requires the Markdown string to parse into a MarkdownAST.Paragraph" s mdast
            throw(ArgumentError("Unsuitable string for mode=:$(mode)"))
        end
        (mode == :single) ? [MarkdownAST.unlink!(childnode)] : MarkdownAST.unlink!.(childnode.children)
    end
end

# Capturing output in different representations similar to IJulia.jl
function limitstringmime(m::MIME"text/plain", x; context = nothing)
    io = IOBuffer()
    ioc = IOContext(context === nothing ? io : IOContext(io, context), :limit => true)
    show(ioc, m, x)
    return String(take!(io))
end
function display_dict(x; context = nothing)
    out = Dict{MIME, Any}()
    x === nothing && return out
    # Always generate text/plain
    out[MIME"text/plain"()] = limitstringmime(MIME"text/plain"(), x, context = context)
    for m in [
            MIME"text/html"(), MIME"image/svg+xml"(), MIME"image/png"(),
            MIME"image/webp"(), MIME"image/gif"(), MIME"image/jpeg"(),
            MIME"text/latex"(), MIME"text/markdown"(),
        ]
        showable(m, x) && (out[m] = stringmime(m, x, context = context))
    end
    return out
end

"""
    struct Default{T}

Internal wrapper type that is meant to be used in situations where it is necessary to
distinguish whether the user explicitly passed the same value as the default value to a
keyword argument, or whether the keyword argument was not passed at all.

```julia
function foo(; kwarg = Default("default value"))
    if isa(kwarg, Default)
        # User did not explicitly pass a value for kwarg
    else kwarg === "default value"
        # User passed "default value" explicitly
    end
end
```
"""
struct Default{T}
    value::T
end
Base.getindex(default::Default) = default.value

"""
    $(SIGNATURES)

Extracts the language identifier from the info string of a Markdown code block.
"""
function codelang(infostring::AbstractString)
    m = match(r"^\s*(\S*)", infostring)
    return m[1]
end

function get_sandbox_module!(meta, prefix, name = nothing; share_default_module = false)
    sym = if name === nothing || isempty(name)
        if share_default_module
            Symbol("__", prefix, "__share_default_module__")
        else
            Symbol("__", prefix, "__", lstrip(string(gensym()), '#'))
        end
    else
        Symbol("__", prefix, "__named__", name)
    end
    # Either fetch and return an existing sandbox from the meta dictionary (based on the generated name),
    # or initialize a new clean one, which gets stored in meta for future re-use.
    return get!(meta, sym) do
        # If the module does not exist already, we need to construct a new one.
        # We create a baremodule so that we can insert a custom `include` method
        # that is closer to the one in Main, in that it works relative to the
        # current working directory, not relative to the module.
        m = Core.eval(
            Main, :(
                baremodule $sym
                using Base
                eval(x) = Core.eval($sym, x)
                include(x) = Base.include($sym, abspath(x))
                end
            )
        )
        return m
    end
end

"""
Calls `git remote show \$(remotename)` to try to determine the main (development) branch
of the remote repository. Returns `master` and prints a warning if it was unable to figure
it out automatically.

`root` is the the directory where `git` gets run. `varname` is just informational and used
to construct the warning messages.
"""
function git_remote_head_branch(varname, root; remotename = "origin", fallback = "master")
    gitcmd = git(nothrow = true)
    if gitcmd === nothing
        @warn """
        Unable to determine $(varname) from remote HEAD branch, defaulting to "$(fallback)".
        Unable to find the `git` binary. Unless this is due to a configuration error, the
        relevant variable should be set explicitly.
        """
        return fallback
    end
    # We need to do addenv() here to merge the new variables with the environment set by
    # Git_jll and the git() function.
    cmd = addenv(
        setenv(`$gitcmd remote show $(remotename)`, dir = root),
        "GIT_TERMINAL_PROMPT" => "0",
        "GIT_SSH_COMMAND" => get(ENV, "GIT_SSH_COMMAND", "ssh -o \"BatchMode yes\""),
    )
    stderr_output = IOBuffer()
    git_remote_output = try
        read(pipeline(cmd; stderr = stderr_output), String)
    catch e
        @warn """
        Unable to determine $(varname) from remote HEAD branch, defaulting to "$(fallback)".
        Calling `git remote` failed with an exception. Set JULIA_DEBUG=Documenter to see the error.
        Unless this is due to a configuration error, the relevant variable should be set explicitly.
        """
        @debug "Command: $cmd" exception = (e, catch_backtrace()) stderr = String(take!(stderr_output))
        return fallback
    end
    m = match(r"^\s*HEAD branch:\s*(.*)$"m, git_remote_output)
    if m === nothing
        @warn """
        Unable to determine $(varname) from remote HEAD branch, defaulting to "$(fallback)".
        Failed to parse the `git remote` output. Set JULIA_DEBUG=Documenter to see the output.
        Unless this is due to a configuration error, the relevant variable should be set explicitly.
        """
        @debug """
        stdout from $cmd:
        $(git_remote_output)
        """
        return fallback
    else
        return String(m[1])
    end
end

# Check global draft setting
is_draft(doc) = doc.user.draft
# Check if the page is built with draft mode
function is_draft(doc, page)::Bool
    # Check both Draft and draft from @meta block
    return get(page.globals.meta, :Draft, get(page.globals.meta, :draft, is_draft(doc)))
end

function git(; nothrow = false, kwargs...)
    # DOCUMENTER_KEY etc are never needed for git operations
    cmd = addenv(Git.git(), NO_KEY_ENV)
    if Sys.iswindows()
        cmd = addenv(
            cmd,
            # For deploydocs() in particular, we need to use symlinks, but it looks like those
            # need to be explicitly force-enabled on Windows. So we make sure that we configure
            # core.symlinks=true via environment variables on that platform.
            "GIT_CONFIG_COUNT" => "1",
            "GIT_CONFIG_KEY_0" => "core.symlinks",
            "GIT_CONFIG_VALUE_0" => "true",
            # Previously we used to set GIT_TEMPLATE_DIR=/usr/share/git-core/templates on all platforms.
            # This was so that we wouldn't pick up the user's Git configuration. Git.jl, however, points
            # the GIT_TEMPLATE_DIR to the artifact directory, and so we're mostly fine without setting
            # now.. _except_ on Windows, where it doesn't set it. So we still set the environment variable
            # on Windows, just in case.
            "GIT_TEMPLATE_DIR" => "/usr/share/git-core/templates",
        )
    end
    return cmd
end

function remove_common_backtrace(bt, reference_bt = backtrace())
    cutoff = nothing
    # We'll start from the top of the backtrace (end of the array) and go down, checking
    # if the backtraces agree
    for ridx in 1:length(bt)
        # Cancel search if we run out the reference BT or find a non-matching one frames:
        if ridx > length(reference_bt) || bt[length(bt) - ridx + 1] != reference_bt[length(reference_bt) - ridx + 1]
            cutoff = length(bt) - ridx + 1
            break
        end
    end
    # It's possible that the loop does not find anything, i.e. that all BT elements are in
    # the reference_BT too. In that case we'll just return an empty BT.
    return bt[1:(cutoff === nothing ? 0 : cutoff)]
end

module PluginsTestModule

# Test the documented behavior of `Plugin` and `getplugin`.

using Documenter, Test


# Flag whether the runner should do testing
mutable struct _RunPluginTests <: Documenter.Plugin
    enabled::Bool
    _RunPluginTests(enabled = false) = new(enabled)
end


mutable struct _TestPluginA <: Documenter.Plugin
    processed::Bool
    # no empty constructor: must be passed as object
end

mutable struct _TestPluginB <: Documenter.Plugin
    processed::Bool
    _TestPluginB() = new(false)
    # empty constructor: can be instantiated on demand
end

mutable struct _TestPluginC <: Documenter.Plugin
    processed::Bool
    # no empty constructor: for checking error behavior
end


# Pipeline step for testing all of the above dummy plugins
abstract type _TestPlugins <: Documenter.Builder.DocumentPipeline end

# Run the pipeline early within DocumentPipeline (not that it really matters)
Documenter.Selectors.order(::Type{_TestPlugins}) = 0.001


function Documenter.Selectors.runner(::Type{_TestPlugins}, doc)

    # Not sure if this runner might hook itself into other tests as a
    # side-effect. Thus, we don't do anything unless the test was explicitly
    # enabled.
    return if Documenter.getplugin(doc, _RunPluginTests).enabled

        @info "_TestPlugins: testing plugin API"
        @show doc.plugins  # type => object or type, as passed to `makedocs`

        # Plugin with passed object
        @test _TestPluginA in keys(doc.plugins)
        A = Documenter.getplugin(doc, _TestPluginA)
        @test !(A.processed)
        A.processed = true
        @test A isa _TestPluginA

        # plugin with empty constructor (no object passed)
        @test !(_TestPluginB in keys(doc.plugins))
        B = Documenter.getplugin(doc, _TestPluginB)
        @test !(B.processed)
        B.processed = true
        @test B isa _TestPluginB

        # subsequent calls to getplugin() should return the same object
        B2 = Documenter.getplugin(doc, _TestPluginB)
        @test B2.processed
        @test B2 === B

        # Missing object (no empty constructor)
        @test !(_TestPluginC in keys(doc.plugins))
        @test_throws MethodError begin
            # getplugin is going to try to instantiate `_TestPluginC()`
            C = Documenter.getplugin(doc, _TestPluginC)
        end

    end

end


A = _TestPluginA(false)
@test !(A.processed)
@test !(_TestPluginB().processed)
@test makedocs(;
    plugins = [_RunPluginTests(true), A],
    sitename = "-", modules = [PluginsTestModule], warnonly = false
) === nothing
@test A.processed


# Errors


# The documentation for Plugin/getplugin made it sound like passing a Plugin
# class instead of a plugin object to `makedocs` was a possibility. This was
# never true, and we check here the specific error that is being thrown if
# someone were to try it.
err_msg = "DataType in `plugins=` is not a subtype of `Documenter.Plugin`."
@test_throws ArgumentError(err_msg) begin
    makedocs(;
        plugins = [_RunPluginTests(false), _TestPluginB],
        sitename = "-", modules = [PluginsTestModule], warnonly = false
    )
end


# Only one instance of any given Plugin can be passed.
try  # Use try-catch get get around @test_throws limitations in Julia 1.6
    makedocs(;
        plugins = [_RunPluginTests(false), _TestPluginA(true), _TestPluginA(false)],
        sitename = "-", modules = [PluginsTestModule], warnonly = false
    )
    @test false  # makedocs should have thrown an ArgumentError
catch exc
    @test exc isa ArgumentError
    @test occursin(r"only one copy of .*_TestPluginA may be passed", exc.msg)
end


# Doctests  - the `doctest` function must also be able to process plugins

A = _TestPluginA(false)
@test !(A.processed)
doctest(
    joinpath(@__DIR__, "src"),
    [PluginsTestModule];
    plugins = [_RunPluginTests(true), A]
)
@test A.processed

end

module MDFlattenTests

using Test

import Markdown
using MarkdownAST: MarkdownAST, @ast
using Documenter.MDFlatten

parse(s) = convert(MarkdownAST.Node, Markdown.parse(s))

struct UnsupportedElement <: MarkdownAST.AbstractElement end

@testset "MDFlatten" begin
    @test mdflatten(
        @ast(
            MarkdownAST.Paragraph() do;
                "..."
            end
        )
    ) == "..."
    @test mdflatten(
        @ast(
            MarkdownAST.Heading(1) do;
                "..."
            end
        )
    ) == "..."

    # a simple test for blocks in top-level (each gets two newline appended to it)
    @test mdflatten(parse("# Test\nTest")) == "Test\n\nTest\n\n"
    block_md = parse(
        """
        # MDFlatten test


        ^^^ Ignoring extra whitespace.

        ```markdown
        code
        is forwarded as **is**
        ```
        """
    )
    block_text = """
    MDFlatten test

    ^^^ Ignoring extra whitespace.

    code
    is forwarded as **is**

    """
    @test mdflatten(block_md) == block_text

    # blocks
    @test mdflatten(parse("> Test\n> Test\n\n> Test")) in ["Test Test\n\nTest\n\n", "Test\nTest\n\nTest\n\n"]
    @test mdflatten(parse("HRs\n\n---\n\nto whitespace")) == "HRs\n\n\n\nto whitespace\n\n"
    @test mdflatten(parse("HRs\n\n---\n\nto whitespace")) == "HRs\n\n\n\nto whitespace\n\n"
    @test mdflatten(parse("HRs\n\n---\n\nto whitespace")) == "HRs\n\n\n\nto whitespace\n\n"

    # test some inline blocks
    @test mdflatten(parse("`code` *em* normal **strong**")) == "code em normal strong\n\n"
    @test mdflatten(parse("[link text *parsed*](link/itself/ignored)")) == "link text parsed\n\n"
    @test mdflatten(parse("- a\n- b\n- c")) == "a\nb\nc\n\n"
    @test mdflatten(parse("A | B\n---|---\naa|bb\ncc | dd")) == "A B\naa bb\ncc dd\n\n"

    # Math
    @test mdflatten(parse("\$e=mc^2\$")) == "e=mc^2\n\n"
    # backticks and blocks for math only in 0.5, i.e. these fail on 0.4
    @test mdflatten(parse("``e=mc^2``")) == "e=mc^2\n\n"
    @test mdflatten(parse("```math\n\\(m+n)(m-n)\nx=3\\sin(x)\n```")) == "(m+n)(m-n)\nx=3sin(x)\n\n"

    # symbols in markdown
    @test mdflatten(parse("A \$B C")) == "A B C\n\n"

    strikethrough = MarkdownAST.Node(MarkdownAST.Strikethrough())
    push!(strikethrough.children, MarkdownAST.Node(MarkdownAST.Text("deleted")))
    @test mdflatten(strikethrough) == "deleted"

    htmlinline = MarkdownAST.Node(MarkdownAST.HTMLInline("<span>inline</span>"))
    @test mdflatten(htmlinline) == "inline"

    htmlblock = MarkdownAST.Node(MarkdownAST.HTMLBlock("<div>block <b>html</b></div>"))
    @test mdflatten(htmlblock) == "block html"

    # linebreaks
    @test mdflatten(parse("A\\\nB")) == "A\nB\n\n"

    # footnotes
    @test mdflatten(parse("[^name]")) == "[name]\n\n"
    @test mdflatten(parse("[^name]:**Strong** text.")) == "[name]: Strong text.\n\n"

    # admonitions
    @test mdflatten(parse("!!! note \"Admonition Title\"\n    Test")) == "note: Admonition Title\nTest\n\n"

    @test mdflatten([@ast("x"), @ast("y"), @ast("z")]) == "xyz"
    @test_throws Exception mdflatten(@ast(UnsupportedElement()))
end

end

module WarningTests

# Test warnings
# see https://github.com/JuliaDocs/Documenter.jl/issues/2805

using Test
using Documenter
using IOCapture

isdefined(Main, :Documenter) || @eval Main import Documenter

function run_warnings_test(name::String)
    captured = IOCapture.capture() do
        makedocs(;
            sitename = name,
            pages = ["index.md", "$name.md"],
            pagesonly = true,
            warnonly = true,
            format = Documenter.HTML(
                prettyurls = false,
                inventory_version = "",
            ),
        )
    end
    @assert isnothing(captured.value)

    # sanitize the output
    output = captured.output
    output = replace(output, r"\@ Documenter.*" => "@ Documenter")
    output = replace(output, "src\\" => "src/")
    return print(output)
end

###########################################################################################

# the `filter` below adjusts for minor output difference between Julia 1.10 and 1.12
# for the UndefVarError
@doc raw"""
```jldoctest; setup=:(using ..WarningTests), filter = r".*(exception =|UndefVarError|spelling errors).*\n"
julia> WarningTests.run_warnings_test("at-docs")
[ Info: SetupBuildDirectory: setting up build directory.
[ Info: Doctest: running doctests.
[ Info: ExpandTemplates: expanding markdown templates.
┌ Warning: undefined binding 'Base.nonsenseBindingThatDoesNotExist' in `@docs` block in src/at-docs.md:4-6
│ ```@docs
│ Base.nonsenseBindingThatDoesNotExist()
│ ```
└ @ Documenter
┌ Warning: no docs found for 'Base.sin()' in `@docs` block in src/at-docs.md:9-11
│ ```@docs
│ Base.sin()
│ ```
└ @ Documenter
┌ Warning: failed to evaluate `Base.sin(::NonsenseTypeThatDoesNotExist)` in `@docs` block in src/at-docs.md:14-16
│ ```@docs
│ Base.sin(::NonsenseTypeThatDoesNotExist)
│ ```
│   exception =
│    UndefVarError: `NonsenseTypeThatDoesNotExist` not defined in `Main`
│    Suggestion: check for spelling errors or missing imports.
└ @ Documenter
┌ Warning: failed to parse code block in src/at-docs.md:19-21
│   exception =
│    ParseError:
│    # Error @ none:1:2
│    1 !in 2
│    #└────┘ ── extra tokens after end of expression
└ @ Documenter
[ Info: CrossReferences: building cross-references.
[ Info: CheckDocument: running document checks.
[ Info: Populate: populating indices.
[ Info: RenderDocument: rendering document.
[ Info: HTMLWriter: rendering HTML pages.
```
"""
module AtDocsWarningTests end

###########################################################################################

@doc raw"""
    dummyFunctionWithUnbalancedDollar()

It is possible to create pseudo-interpolations with the `Markdown` parser: $quux.

$([0 1 ; 2 3])

They do not get evaluated.
"""
function dummyFunctionWithUnbalancedDollar end

@doc raw"""
```jldoctest; setup=:(using ..WarningTests)
julia> WarningTests.run_warnings_test("at-eval")
[ Info: SetupBuildDirectory: setting up build directory.
[ Info: Doctest: running doctests.
[ Info: ExpandTemplates: expanding markdown templates.
┌ Warning: failed to parse code block in src/at-eval.md:13-15
│   exception =
│    ParseError:
│    # Error @ none:1:2
│    1 !in 2
│    #└────┘ ── extra tokens after end of expression
└ @ Documenter
┌ Warning: Invalid type of object in @eval in src/at-eval.md:19-21
│ ```@eval
│ "expanded_"*"eval"
│ ```
│ Evaluated to `String`, but should be one of
│  - Nothing
│  - Markdown.MD
│ Falling back to textual code block representation.
│
│ If you are seeing this warning/error after upgrading Documenter and this used to work,
│ please open an issue on the Documenter issue tracker.
└ @ Documenter
[ Info: CrossReferences: building cross-references.
[ Info: CheckDocument: running document checks.
[ Info: Populate: populating indices.
[ Info: RenderDocument: rendering document.
[ Info: HTMLWriter: rendering HTML pages.
```
"""
module AtEvalWarningTests end

###########################################################################################

@doc raw"""
```jldoctest; setup=:(using ..WarningTests)
julia> WarningTests.run_warnings_test("at-example")
[ Info: SetupBuildDirectory: setting up build directory.
[ Info: Doctest: running doctests.
[ Info: ExpandTemplates: expanding markdown templates.
┌ Warning: failed to parse code block in src/at-example.md:13-15
│   exception =
│    ParseError:
│    # Error @ none:1:2
│    1 !in 2
│    #└────┘ ── extra tokens after end of expression
└ @ Documenter
[ Info: CrossReferences: building cross-references.
[ Info: CheckDocument: running document checks.
[ Info: Populate: populating indices.
[ Info: RenderDocument: rendering document.
[ Info: HTMLWriter: rendering HTML pages.
```
"""
module AtExampleWarningTests end

###########################################################################################

@doc raw"""
```jldoctest; setup=:(using ..WarningTests)
julia> WarningTests.run_warnings_test("at-meta")
[ Info: SetupBuildDirectory: setting up build directory.
[ Info: Doctest: running doctests.
[ Info: ExpandTemplates: expanding markdown templates.
[ Info: CrossReferences: building cross-references.
[ Info: CheckDocument: running document checks.
[ Info: Populate: populating indices.
[ Info: RenderDocument: rendering document.
[ Info: HTMLWriter: rendering HTML pages.
```
"""
module AtMetaWarningTests end

###########################################################################################

@doc raw"""
```jldoctest; setup=:(using ..WarningTests)
julia> WarningTests.run_warnings_test("at-repl")
[ Info: SetupBuildDirectory: setting up build directory.
[ Info: Doctest: running doctests.
[ Info: ExpandTemplates: expanding markdown templates.
┌ Warning: failed to parse code block in src/at-repl.md:13-15
│   exception =
│    ParseError:
│    # Error @ none:1:2
│    1 !in 2
│    #└────┘ ── extra tokens after end of expression
└ @ Documenter
[ Info: CrossReferences: building cross-references.
[ Info: CheckDocument: running document checks.
[ Info: Populate: populating indices.
[ Info: RenderDocument: rendering document.
[ Info: HTMLWriter: rendering HTML pages.
```
"""
module AtReplWarningTests end

###########################################################################################

@doc raw"""
```jldoctest; setup=:(using ..WarningTests)
julia> WarningTests.run_warnings_test("at-setup")
[ Info: SetupBuildDirectory: setting up build directory.
[ Info: Doctest: running doctests.
[ Info: ExpandTemplates: expanding markdown templates.
┌ Warning: failed to run `@setup` block in src/at-setup.md:9-11
│ ```@setup
│ 1 !in 2
│ ```
│   exception =
│    LoadError: ParseError:
│    # Error @ string:1:2
│    1 !in 2
│    #└────┘ ── extra tokens after end of expression
│    in expression starting at string:1
└ @ Documenter
[ Info: CrossReferences: building cross-references.
[ Info: CheckDocument: running document checks.
[ Info: Populate: populating indices.
[ Info: RenderDocument: rendering document.
[ Info: HTMLWriter: rendering HTML pages.
```
"""
module AtSetupWarningTests end

###########################################################################################

@doc raw"""
````jldoctest; setup=:(using ..WarningTests)
julia> WarningTests.run_warnings_test("doctest")
[ Info: SetupBuildDirectory: setting up build directory.
[ Info: Doctest: running doctests.
┌ Warning: Unable to to evaluate doctest in src/doctest.md:4-8
│ No empty lines are allowed before first `julia>` prompt.
│
│ ```jldoctest
│
│ julia> 1+1
│ 2
│ ```
└ @ Documenter
┌ Warning: Unable to to evaluate doctest in src/doctest.md:11-15
│ Consecutive `julia>` prompts must be separated by an empty line.
│
│ ```jldoctest
│ julia> a=1;
│ julia> a+1
│ 2
│ ```
└ @ Documenter
[ Info: ExpandTemplates: expanding markdown templates.
[ Info: CrossReferences: building cross-references.
[ Info: CheckDocument: running document checks.
[ Info: Populate: populating indices.
[ Info: RenderDocument: rendering document.
[ Info: HTMLWriter: rendering HTML pages.
````
"""
module DoctestWarningTests end

###########################################################################################

@doc raw"""
```jldoctest; setup=:(using ..WarningTests)
julia> WarningTests.run_warnings_test("dollar")
[ Info: SetupBuildDirectory: setting up build directory.
[ Info: Doctest: running doctests.
[ Info: ExpandTemplates: expanding markdown templates.
[ Info: CrossReferences: building cross-references.
[ Info: CheckDocument: running document checks.
[ Info: Populate: populating indices.
[ Info: RenderDocument: rendering document.
[ Info: HTMLWriter: rendering HTML pages.
┌ Warning: Unexpected Julia interpolation in the Markdown. This probably means that you have an
│ unbalanced or un-escaped $ in the text.
│
│ To write the dollar sign, escape it with `\$`
│
│ This is in file src/dollar.md, and we were given the value:
│
│ `foo` which is of type `Symbol`
└ @ Documenter
┌ Warning: Unexpected Julia interpolation in the Markdown. This probably means that you have an
│ unbalanced or un-escaped $ in the text.
│
│ To write the dollar sign, escape it with `\$`
│
│ This is in file src/dollar.md, and we were given the value:
│
│ `[1 2 3; 4 5 6]` which is of type `Expr`
└ @ Documenter
┌ Warning: Unexpected Julia interpolation in the Markdown. This probably means that you have an
│ unbalanced or un-escaped $ in the text.
│
│ To write the dollar sign, escape it with `\$`
│
│ This is in file src/dollar.md, and we were given the value:
│
│ `quux` which is of type `Symbol`
└ @ Documenter
┌ Warning: Unexpected Julia interpolation in the Markdown. This probably means that you have an
│ unbalanced or un-escaped $ in the text.
│
│ To write the dollar sign, escape it with `\$`
│
│ This is in file src/dollar.md, and we were given the value:
│
│ `[0 1; 2 3]` which is of type `Expr`
└ @ Documenter
```
"""
module UnbalancedDollarWarningTests end

###########################################################################################

fixtests = haskey(ENV, "DOCUMENTER_FIXTESTS")

# run the doctests in Julia >= 1.10 (some outputs have minor difference in
# older Julia versions, and it just doesn't seem worth the trouble of coping
# with that "properly")
VERSION >= v"1.10" && makedocs(;
    sitename = "",
    pages = ["index.md"],
    pagesonly = true,
    doctest = fixtests ? :fix : :only,
    modules = [WarningTests],
    remotes = nothing,
)

end

using Documenter, Test
import NodeJS_16_jll

function read_assets()
    path = joinpath(@__DIR__, "build", "assets", "documenter.js")
    return read(path, String)
end
function read_index()
    path = joinpath(@__DIR__, "build", "index.html")
    return read(path, String)
end

@testset "prerender with NodeJS" begin

    # Regular makedocs
    makedocs(;
        sitename = "Prerendering code blocks",
        format = Documenter.HTML(
            highlights = ["llvm"],
        ),
    )
    assets = read_assets()
    @test occursin("'highlight-julia'", assets)
    @test occursin("/languages/julia.min", assets)
    @test occursin("'highlight-julia-repl'", assets)
    @test occursin("/languages/julia-repl.min", assets)
    @test occursin("'highlight-llvm'", assets)
    @test occursin("/languages/llvm.min", assets)
    index = read_index()
    @test occursin("<code class=\"language-julia hljs\">function f()", index)
    @test occursin("<code class=\"language-julia-repl hljs\">julia&gt; function f()", index)
    @test occursin("<code class=\"language-llvm hljs\">;  @ int.jl:87 within", index)

    # With prerender
    HLJSFILES = Documenter.HTMLWriter.HLJSFILES
    for _ in 1:2 # test with and without highlightjs file given
        makedocs(;
            sitename = "Prerendering code blocks",
            format = Documenter.HTML(
                highlights = ["llvm"],
                prerender = true,
                node = NodeJS_16_jll.node(),
                highlightjs = length(HLJSFILES) == 0 ? nothing : last(first(HLJSFILES)),
            ),
        )
        local assets = read_assets()
        @test !occursin("'highlight-julia'", assets)
        @test !occursin("/languages/julia.min", assets)
        @test !occursin("'highlight-julia-repl'", assets)
        @test !occursin("/languages/julia-repl.min", assets)
        @test !occursin("'highlight-llvm'", assets)
        @test !occursin("/languages/llvm.min", assets)
        local index = read_index()
        @test !occursin("<code class=\"language-julia hljs\">function f()", index)
        @test !occursin("<code class=\"language-julia-repl hljs\">julia&gt; function f()", index)
        @test !occursin("<code class=\"language-llvm hljs\">;  @ int.jl:87 within", index)
        @test occursin("<code class=\"language-julia hljs\"><span class=\"hljs-keyword\">function</span> f()", index)
        @test occursin("<code class=\"language-julia-repl hljs\"><span class=\"hljs-meta prompt_\">julia&gt;</span>", index)
        @test occursin("<code class=\"language-llvm hljs\"><span class=\"hljs-comment\">;  @ int.jl:87", index)
        @test length(HLJSFILES) == 1
    end

    ## missing language (llvm)
    @test_logs (:error, "HTMLWriter: prerendering failed") match_mode = :any begin
        makedocs(;
            sitename = "Prerendering code blocks",
            format = Documenter.HTML(
                prerender = true,
                node = NodeJS_16_jll.node(),
            ),
        )
    end
    assets = read_assets()
    @test !occursin("'highlight-julia'", assets)
    @test !occursin("/languages/julia.min", assets)
    @test !occursin("'highlight-julia-repl'", assets)
    @test !occursin("/languages/julia-repl.min", assets)
    @test !occursin("'highlight-llvm'", assets)
    @test !occursin("/languages/llvm.min", assets)
    index = read_index()
    @test !occursin("<code class=\"language-julia hljs\">function f()", index)
    @test !occursin("<code class=\"language-julia-repl hljs\">julia&gt; function f()", index)
    @test occursin("<code class=\"language-llvm hljs\">;  @ int.jl:87 within", index)
    @test occursin("<code class=\"language-julia hljs\"><span class=\"hljs-keyword\">function</span> f()", index)
    @test occursin("<code class=\"language-julia-repl hljs\"><span class=\"hljs-meta prompt_\">julia&gt;</span>", index)
    @test !occursin("<code class=\"language-llvm hljs\"><span class=\"hljs-comment\">;  @ int.jl:87", index)

    @test length(HLJSFILES) == 2

    # Some failure modes
    @test_throws Base.IOError makedocs(;
        sitename = "Prerendering code blocks",
        format = Documenter.HTML(
            prerender = true,
            node = "nope",
        ),
    )

end # testset

# Implements doctest()

"""
    doctest(package::Module; kwargs...)

Convenience method that runs and checks all the doctests for a given Julia package.
`package` must be the `Module` object corresponding to the top-level module of the package.
Behaves like an `@testset` call, returning a testset if all the doctests are successful or
throwing a `TestSetException` if there are any failures. Can be included in other testsets.

# Keywords

**`manual`** controls how manual pages are handled. By default (`manual = true`), `doctest`
assumes that manual pages are located under `docs/src`. If that is not the case, the
`manual` keyword argument can be passed to specify the directory. Setting `manual = false`
will skip doctesting of manual pages altogether.

Additional keywords are passed on to the main [`doctest`](@ref) method.
"""
function doctest(package::Module; manual = true, testset = nothing, kwargs...)
    if pathof(package) === nothing
        throw(ArgumentError("$(package) is not a top-level package module."))
    end
    source = nothing
    if manual === true
        source = normpath(joinpath(dirname(pathof(package)), "..", "docs", "src"))
        if !isdir(source)
            msg = """
            Package $(package) does not have a documentation source directory at standard location.
            Searched at: $(source)
            If the manual pages are elsewhere, pass their directory as the `manual` keyword
            argument, or `manual = false` to skip doctesting them.
            """
            throw(ArgumentError(msg))
        end
    end
    testset = (testset === nothing) ? "Doctests: $(package)" : testset
    return doctest(source, [package]; testset = testset, kwargs...)
end

"""
    doctest(source, modules; kwargs...)

Runs all the doctests in the given modules and on manual pages under the `source` directory.
Behaves like an `@testset` call, returning a testset if all the doctests are successful or
throwing a `TestSetException` if there are any failures. Can be included in other testsets.

The manual pages are searched recursively in subdirectories of `source` too. Doctesting of
manual pages can be disabled if `source` is set to `nothing`.

# Keywords

**`testset`** specifies the name of the testset (default `"Doctests"`).

**`doctestfilters`** is a vector of regexes or regex/substitution pairs to filter tests (see the manual on [Filtering Doctests](@ref))

**`fix`**, if set to `true`, updates all the doctests that fail with the correct output
(default `false`).

**`plugins`** is a list of [`Documenter.Plugin`](@ref) objects to be forwarded to
[`makedocs`](@ref). Use as directed by the documentation of a third-party plugin.

**`meta`** can be used to provide default values for the `@meta` blocks of every page, in
the same way as the `meta` keyword of [`makedocs`](@ref). For example
`meta = Dict(:DocTestSetup => :(using MyPackage))` sets `DocTestSetup` for every doctest,
complementing [`DocMeta.setdocmeta!`](@ref) which only applies to docstrings.

!!! warning
    When running `doctest(...; fix=true)`, Documenter will modify the Markdown and Julia
    source files. It is strongly recommended that you only run it on packages in Pkg's
    develop mode and commit any staged changes. You should also review all the changes made
    by `doctest` before committing them, as there may be edge cases when the automatic
    fixing fails.
"""
function doctest(
        source::Union{AbstractString, Nothing},
        modules::AbstractVector{Module};
        fix = false,
        testset = "Doctests",
        doctestfilters = Regex[],
        plugins = Plugin[],
        meta::Dict{Symbol} = Dict{Symbol, Any}(),
    )
    function all_doctests()
        dir = mktempdir()
        try
            @debug "Doctesting in temporary directory: $(dir)" modules
            if source === nothing
                source = joinpath(dir, "src")
                mkdir(source)
            end
            makedocs(;
                root = dir,
                source = source,
                sitename = "",
                doctest = fix ? :fix : :only,
                modules = modules,
                doctestfilters = doctestfilters,
                # When doctesting, we don't really want to get bogged down with issues
                # related to determining the remote repositories for edit URLs and such
                remotes = nothing,
                plugins = plugins,
                meta = meta,
            )
            return true
        catch err
            @error "Doctesting failed" exception = (err, catch_backtrace())
            return false
        finally
            try
                rm(dir; recursive = true)
            catch e
                @warn "Documenter was unable to clean up the temporary directory $(dir)" exception = e
            end
        end
    end
    return @testset "$testset" begin
        @test all_doctests()
    end
end

module PipeLineTests
using Test

@testset "Builder: lt_page" begin
    using Documenter: lt_page
    # Checks to make sure that only exactly one of a<b, a==b and a>b is true for given a & b
    iscorrectisless(a, b) = sum([lt_page(a, b), a == b, lt_page(b, a)]) == 1
    # Test equal strings:
    for a in ["index.md", "foo/index.md", "foo.md", "bar/foo.md", "foo/bar/baz/qux", "", "α", "α/β", "α/index.md"]
        @test !lt_page(a, a)
        @test iscorrectisless(a, a)
    end
    # Test less thans
    for (a, b) in [
            ("a", "b"), ("α", "β"), ("b", "α"),
            # index.md takes precedence
            ("index.md", "a"),
            ("index.md", "index.mm"),
            ("index.md", "foo.md"),
            ("index.md", "bar/foo.md"),
            # Also in subdirectories:
            ("foo/index.md", "foo/a"),
            ("foo/index.md", "foo/index.mm"),
            ("foo/index.md", "foo/foo.md"),
            ("foo/index.md", "foo/bar/foo.md"),
            # But not over stuff that is outside of the subdirectory
            ("a", "foo/index.md"),
            ("α", "α/index.md"),
            ("foo/index.md", "g"),
            ("bar/index.md", "foo/index.md"),
            ("bar/qux/index.md", "foo/index.md"),
        ]
        @test lt_page(a, b)
        @test iscorrectisless(a, b)
    end

    @test sort(["foo", "bar"], lt = lt_page) == ["bar", "foo"]
    @test sort(["foo", "foo/bar"], lt = lt_page) == ["foo", "foo/bar"]
    @test sort(["foo", "f/bar"], lt = lt_page) == ["f/bar", "foo"]
    @test sort(["foo", "index.md"], lt = lt_page) == ["index.md", "foo"]
    @test sort(["foo.md", "foo/index.md", "index.md", "foo/foo.md"], lt = lt_page) == ["index.md", "foo.md", "foo/index.md", "foo/foo.md"]
    @test sort(["foo.md", "ϕωω/index.md", "index.md", "foo/foo.md"], lt = lt_page) == ["index.md", "foo.md", "foo/foo.md", "ϕωω/index.md"]
end

# Docstring signature syntax highlighting tests.
module HighlightSig
    using Test
    import Markdown
    using MarkdownAST: @ast, Node, Document, CodeBlock, ThematicBreak
    import Documenter: highlightsig!

    @testset "highlightsig!" begin
        s = """
            foo(bar::Baz)
        ---
            foo(bar::Baz)
        """
        md = convert(Node, Markdown.parse(s))
        @test md == @ast Document() do
            CodeBlock("", "foo(bar::Baz)")
            ThematicBreak()
            CodeBlock("", "foo(bar::Baz)")
        end
        highlightsig!(md)
        @test md == @ast Document() do
            CodeBlock("julia", "foo(bar::Baz)")
            ThematicBreak()
            CodeBlock("", "foo(bar::Baz)")
        end

        s = """
        ```lang
         foo(bar::Baz)
        ```
        """
        md = convert(Node, Markdown.parse(s))
        @test md == @ast Document() do
            CodeBlock("lang", " foo(bar::Baz)")
        end
        highlightsig!(md)
        @test md == @ast Document() do
            CodeBlock("lang", " foo(bar::Baz)")
        end
    end
end

end

println("Running benchmarks for test_queries.jl...")
run(`julia --project=$(@__DIR__) $(@__DIR__)/run_benchmarks.jl $(@__DIR__)/../../docs/build/search_index.js $(@__DIR__)/test_queries.jl all_test_queries`)

println("Running benchmarks for edge_case_queries.jl...")
run(`julia --project=$(@__DIR__) $(@__DIR__)/run_benchmarks.jl $(@__DIR__)/../search_edge_cases/build/search_index.js $(@__DIR__)/edge_case_queries.jl all_edge_case_queries`)

using Test

# DOCUMENTER_TEST_EXAMPLES can be used to control which builds are performed in
# make.jl, and we need to set it to the relevant LaTeX builds.
if Sys.iswindows() && get(ENV, "GITHUB_ACTIONS", nothing) == "true"
    ENV["DOCUMENTER_TEST_EXAMPLES"] = "latex_simple_nondocker latex_simple_tectonic"
else
    ENV["DOCUMENTER_TEST_EXAMPLES"] =
        "latex latex_simple latex_cover_page latex_toc_style latex_simple_nondocker latex_simple_tectonic " *
        "latex_showcase"
end
# When the file is run separately we need to include make.jl which actually builds
# the docs and defines a few modules that are referred to in the docs. The make.jl
# has to be expected in the context of the Main module.
if (@__MODULE__) === Main && !@isdefined examples_root
    include("make.jl")
elseif (@__MODULE__) !== Main && isdefined(Main, :examples_root)
    using Documenter
    const examples_root = Main.examples_root
elseif (@__MODULE__) !== Main && !isdefined(Main, :examples_root)
    error("examples/make.jl has not been loaded into Main.")
end

# This gets appended to the filename if we're building a tag (i.e. TRAVIS_TAG is set)
tagsuffix = if occursin(Base.VERSION_REGEX, get(ENV, "TRAVIS_TAG", ""))
    v = VersionNumber(ENV["TRAVIS_TAG"])
    "-$(v.major).$(v.minor).$(v.patch)"
else
    ""
end

@testset "Examples/LaTeX" begin
    if !(Sys.iswindows() && get(ENV, "GITHUB_ACTIONS", nothing) == "true")
        @testset "PDF/LaTeX: simple" begin
            doc = Main.examples_latex_simple_doc
            @test isa(doc, Documenter.Documenter.Document)
            let build_dir = joinpath(examples_root, "builds", "latex_simple")
                @test joinpath(build_dir, "DocumenterLaTeXSimple-1.2.3.pdf") |> isfile
            end
        end

        @testset "PDF/LaTeX" begin
            doc = Main.examples_latex_doc
            @test isa(doc, Documenter.Documenter.Document)
            let build_dir = joinpath(examples_root, "builds", "latex")
                @test joinpath(build_dir, "DocumenterLaTeX$(tagsuffix).pdf") |> isfile
            end
        end

        @testset "PDF/LaTeX: Custom Cover Page" begin
            doc = Main.examples_latex_cover_page
            @test isa(doc, Documenter.Documenter.Document)
            let build_dir = joinpath(examples_root, "builds", "latex_cover_page")
                @test joinpath(build_dir, "DocumenterLaTeX$(tagsuffix).pdf") |> isfile
            end
        end

        @testset "PDF/LaTeX: Custom TOC Style" begin
            doc = Main.examples_latex_toc_style
            @test isa(doc, Documenter.Documenter.Document)
            let build_dir = joinpath(examples_root, "builds", "latex_toc_style")
                @test joinpath(build_dir, "DocumenterLaTeX$(tagsuffix).pdf") |> isfile
            end
        end

        @testset "PDF/LaTeX: showcase" begin
            doc = Main.examples_latex_showcase_doc
            @test isa(doc, Documenter.Documenter.Document)
            let build_dir = joinpath(examples_root, "builds", "latex_showcase")
                @test joinpath(build_dir, "DocumenterLaTeXShowcase-1.2.3.pdf") |> isfile
            end
        end
    end

    @testset "PDF/LaTeX: tectonic" begin
        doc = Main.examples_latex_simple_tectonic_doc
        @test isa(doc, Documenter.Documenter.Document)
        let build_dir = joinpath(examples_root, "builds", "latex_simple_tectonic")
            @test joinpath(build_dir, "DocumenterLaTeXSimpleTectonic-1.2.3.pdf") |> isfile
        end
    end

    @testset "PDF/LaTeX: native" begin
        doc = Main.examples_latex_simple_nondocker_doc
        @test isa(doc, Documenter.Documenter.Document)
        let build_dir = joinpath(examples_root, "builds", "latex_simple_nondocker")
            @test joinpath(build_dir, "DocumenterLaTeXSimpleNon-Docker-1.2.3.pdf") |> isfile
        end
    end
end

using Documenter, Logging

with_logger(NullLogger()) do
    makedocs(
        sitename = "TestPkg",
        pages = Any[
            "Home" => "index.md",
        ],
        build = mktempdir(),
        remotes = nothing,
    )
end

# Provides the [`doctest`](@ref) function that makes sure that the `jldoctest` code blocks
# in the documents and docstrings run and are up to date.

# Julia code block testing.
# -------------------------

struct DocTestContext
    file::String
    doc::Documenter.Document
    meta::Dict{Symbol, Any}
    mod::Union{Module, Nothing}
    DocTestContext(file::String, doc::Documenter.Document, mod::Union{Module, Nothing} = nothing) = new(file, doc, copy(doc.user.meta), mod)
end

"""
$(SIGNATURES)

Traverses the pages and modules in the documenter blueprint, searching and
executing doctests.

Will abort the document generation when an error is thrown. Use `doctest = false`
keyword in [`Documenter.makedocs`](@ref) to disable doctesting.
"""
function _doctest(blueprint::Documenter.DocumentBlueprint, doc::Documenter.Document)
    @debug "Running doctests."
    # find all the doctest blocks in the pages
    for (src, page) in blueprint.pages
        if Documenter.is_draft(doc, page)
            @debug "Skipping page-doctests in draft mode" page.source
            continue
        end
        _doctest(page, doc)
    end

    if Documenter.is_draft(doc)
        @debug "Skipping docstring-doctests in draft mode"
        return
    end

    # find all the doctest block in all the docstrings (within specified modules)
    for mod in blueprint.modules
        for (binding, multidoc) in DocSystem.getmeta(mod)
            for signature in multidoc.order
                _doctest(multidoc.docs[signature], mod, doc)
            end
        end
    end
    return
end

mutable struct MutablePrefix
    content::String
    MutablePrefix() = new("")
end

function _doctest(page::Documenter.Page, doc::Documenter.Document)
    ctx = DocTestContext(page.source, doc) # FIXME
    ctx.meta[:CurrentFile] = page.source
    return _doctest(ctx, page.mdast)
end

function _doctest(docstr::Docs.DocStr, mod::Module, doc::Documenter.Document)
    md::Markdown.MD = DocSystem.parsedoc(docstr)
    mdast = try
        convert(MarkdownAST.Node, md)
    catch err
        @error """
        MarkdownAST conversion error for a docstring in $(mod).
        This is a bug — please report this on the Documenter issue tracker
        """ docstr.data
        rethrow(err)
    end
    ctx = DocTestContext(docstr.data[:path], doc, mod)
    merge!(ctx.meta, DocMeta.getdocmeta(mod))
    ctx.meta[:CurrentFile] = get(docstr.data, :path, nothing)
    return _doctest(ctx, mdast)
end

function parse_metablock(ctx::DocTestContext, block::MarkdownAST.CodeBlock)
    @assert startswith(block.info, "@meta")
    meta = Dict{Symbol, Any}()
    for (ex, str) in Documenter.parseblock(block.code, ctx.doc, ctx.file)
        if Documenter.isassign(ex)
            try
                meta[ex.args[1]] = Core.eval(Main, ex.args[2])
            catch err
                @docerror(ctx.doc, :meta_block, "Failed to evaluate `$(strip(str))` in `@meta` block.", exception = err)
            end
        end
    end
    return meta
end

function _doctest(ctx::DocTestContext, mdast::MarkdownAST.Node)
    for node in AbstractTrees.Leaves(mdast)
        isa(node.element, MarkdownAST.CodeBlock) || continue
        if startswith(node.element.info, "jldoctest")
            _doctest(ctx, node.element)
        elseif startswith(node.element.info, "@meta")
            merge!(ctx.meta, parse_metablock(ctx, node.element))
        end
    end
    return
end

function _doctest(ctx::DocTestContext, block::MarkdownAST.CodeBlock)
    lang = block.info
    if startswith(lang, "jldoctest")
        # Define new module or reuse an old one from this page if we have a named doctest.
        name = match(r"jldoctest[ ]?(.*)$", split(lang, ';', limit = 2)[1])[1]
        sandbox = Documenter.get_sandbox_module!(ctx.meta, "doctest", name)

        # Normalise line endings.
        block.code = replace(block.code, "\r\n" => "\n")

        # parse keyword arguments to doctest
        d = Dict()
        idx = findfirst(c -> c == ';', lang)
        if idx !== nothing
            kwargs = try
                Meta.parse("($(lang[nextind(lang, idx):end]),)")
            catch e
                e isa Meta.ParseError || rethrow(e)
                file = ctx.meta[:CurrentFile]
                lines = Documenter.find_block_in_file(block.code, file)
                @docerror(
                    ctx.doc, :doctest,
                    """
                    Unable to parse doctest keyword arguments in $(Documenter.locrepr(file, lines))
                    Use ```jldoctest name; key1 = value1, key2 = value2

                    ```$(lang)
                    $(block.code)
                    ```
                    """, parse_error = e
                )
                return false
            end
            for kwarg in kwargs.args
                if !(isa(kwarg, Expr) && kwarg.head === :(=) && isa(kwarg.args[1], Symbol))
                    file = ctx.meta[:CurrentFile]
                    lines = Documenter.find_block_in_file(block.code, file)
                    @docerror(
                        ctx.doc, :doctest,
                        """
                        invalid syntax for doctest keyword arguments in $(Documenter.locrepr(file, lines))
                        Use ```jldoctest name; key1 = value1, key2 = value2

                        ```$(lang)
                        $(block.code)
                        ```
                        """
                    )
                    return false
                end
                d[kwarg.args[1]] = Core.eval(sandbox, kwarg.args[2])
            end
        end
        ctx.meta[:LocalDocTestArguments] = d

        for expr in [get(ctx.meta, :DocTestSetup, []); get(ctx.meta[:LocalDocTestArguments], :setup, [])]
            Meta.isexpr(expr, :block) && (expr.head = :toplevel)
            try
                Core.eval(sandbox, expr)
            catch e
                push!(ctx.doc.internal.errors, :doctest)
                @error(
                    "could not evaluate expression from doctest setup.",
                    expression = expr, exception = e
                )
                return false
            end
        end
        # Extract syntax version: per-block syntax= takes precedence over global DocTestSyntax
        syntax_version = get(d, :syntax, get(ctx.meta, :DocTestSyntax, nothing))

        # Check if syntax versioning is supported (requires Julia 1.14+)
        if syntax_version !== nothing && !isdefined(Base, :VersionedParse)
            if syntax_version >= v"1.14"
                file = ctx.meta[:CurrentFile]
                lines = Documenter.find_block_in_file(block.code, file)
                @warn "Skipping doctest in $(Documenter.locrepr(file, lines)): syntax version $syntax_version requires Julia 1.14 or later (running on Julia $VERSION)"
                return true  # Skip this doctest but don't treat as error
            end
            # For syntax versions < 1.14, we can proceed normally since the syntax should be compatible
            syntax_version = nothing
        end

        if occursin(r"^julia> "m, block.code)
            eval_repl(block, sandbox, ctx.meta, ctx.doc, ctx.file; syntax_version = syntax_version, mod = ctx.mod)
        elseif occursin(r"^# output$"m, block.code)
            eval_script(block, sandbox, ctx.meta, ctx.doc, ctx.file; syntax_version = syntax_version, mod = ctx.mod)
        elseif occursin(r"^# output\s+$"m, block.code)
            file = ctx.meta[:CurrentFile]
            lines = Documenter.find_block_in_file(block.code, file)
            @docerror(
                ctx.doc, :doctest,
                """
                invalid doctest block in $(Documenter.locrepr(file, lines))
                Requires `# output` without trailing whitespace

                ```$(lang)
                $(block.code)
                ```
                """
            )
        else
            file = ctx.meta[:CurrentFile]
            lines = Documenter.find_block_in_file(block.code, file)
            @docerror(
                ctx.doc, :doctest,
                """
                invalid doctest block in $(Documenter.locrepr(file, lines))
                Requires `julia> ` or `# output`

                ```$(lang)
                $(block.code)
                ```
                """
            )
        end
        for expr in [get(ctx.meta, :DocTestTeardown, []); get(ctx.meta[:LocalDocTestArguments], :teardown, [])]
            Meta.isexpr(expr, :block) && (expr.head = :toplevel)
            try
                Core.eval(sandbox, expr)
            catch e
                push!(ctx.doc.internal.errors, :doctest)
                @error(
                    "could not evaluate expression from doctest teardown.",
                    expression = expr, exception = e
                )
                return false
            end
        end
        delete!(ctx.meta, :LocalDocTestArguments)
    end
    return false
end
_doctest(ctx::DocTestContext, block) = true

# Doctest evaluation.

mutable struct Result
    block::MarkdownAST.CodeBlock # The entire code block that is being tested.
    raw_input::String # Part of `block.code` representing the current input.
    # Part of `block.code` representing the current input
    # without leading repl prompts and spaces.
    input::String
    output::String # Part of `block.code` representing the current expected output.
    file::String # File in which the doctest is written. Either `.md` or `.jl`.
    value::Any # The value returned when evaluating `input`.
    hide::Bool # Semi-colon suppressing the output?
    stdout::IOBuffer # Redirected stdout/stderr gets sent here.
    bt::Vector # Backtrace when an error is thrown.

    function Result(block, input, output, file)
        return new(block, input, input, rstrip(output, '\n'), file, nothing, false, IOBuffer())
    end
    function Result(block, raw_input, input, output, file)
        return new(block, raw_input, input, rstrip(output, '\n'), file, nothing, false, IOBuffer())
    end
end


function eval_repl(block::MarkdownAST.CodeBlock, sandbox, meta::Dict, doc::Documenter.Document, page; syntax_version = nothing, mod = nothing)
    file = meta[:CurrentFile]
    src_lines = Documenter.find_block_in_file(block.code, file)
    (prefix, split) = repl_splitter(block.code, doc, file, src_lines)
    for (raw_input, input, output) in split
        result = Result(block, raw_input, input, output, file)
        for (ex, str) in Documenter.parseblock(input, doc, page; keywords = false, raise = false, syntax_version = syntax_version, mod = mod)
            # Input containing a semi-colon gets suppressed in the final output.
            @debug "Evaluating REPL line from doctest at $(Documenter.locrepr(result.file, src_lines))" unparsed_string = str parsed_expression = ex
            result.hide = REPL.ends_with_semicolon(str)
            # Use the REPL softscope for REPL jldoctests,
            # see https://github.com/JuliaLang/julia/pull/33864
            ex = REPL.softscope(ex)
            c = IOCapture.capture(rethrow = InterruptException) do
                Core.eval(sandbox, ex)
            end
            Core.eval(sandbox, Expr(:global, Expr(:(=), :ans, QuoteNode(c.value))))
            result.value = c.value
            print(result.stdout, c.output)
            if c.error
                result.bt = c.backtrace
            end
            # don't evaluate further if there is a parse error
            isa(ex, Expr) && ex.head === :error && break
        end
        checkresult(sandbox, result, meta, doc; prefix)
    end
    return
end

function eval_script(block::MarkdownAST.CodeBlock, sandbox, meta::Dict, doc::Documenter.Document, page; syntax_version = nothing, mod = nothing)
    # TODO: decide whether to keep `# output` syntax for this. It's a bit ugly.
    #       Maybe use double blank lines, i.e.
    #
    #
    #       to mark `input`/`output` separation.
    input, output = split(block.code, r"^# output$"m, limit = 2)
    input = rstrip(input, '\n')
    output = lstrip(output, '\n')
    result = Result(block, input, output, meta[:CurrentFile])
    for (ex, str) in Documenter.parseblock(input, doc, page; keywords = false, raise = false, syntax_version = syntax_version, mod = mod)
        c = IOCapture.capture(rethrow = InterruptException) do
            Core.eval(sandbox, ex)
        end
        result.value = c.value
        print(result.stdout, c.output)
        if c.error
            result.bt = c.backtrace
            break
        end
    end
    return checkresult(sandbox, result, meta, doc)
end

function filter_doctests(filters, strings)
    for rs in filters
        # If a doctest filter is just a string or regex, everything that matches gets
        # removed before comparing the inputs and outputs of a doctest. However, it can
        # also be a regex => substitution pair in which case the match gets replaced by
        # the substitution string.
        r, s = if isa(rs, Pair{Regex, T} where {T <: AbstractString})
            rs
        elseif isa(rs, Regex) || isa(rs, AbstractString)
            rs, ""
        else
            error("Invalid doctest filter:\n$rs :: $(typeof(rs))")
        end
        if all(occursin.((r,), strings))
            strings = replace.(strings, (r => s,))
        end
    end
    return strings
end

# Regex used here to replace gensym'd module names could probably use improvements.
function checkresult(sandbox::Module, result::Result, meta::Dict, doc::Documenter.Document; prefix::MutablePrefix = MutablePrefix())
    sandbox_name = nameof(sandbox)
    mod_regex = Regex("(Main\\.)?(Symbol\\(\"$(sandbox_name)\"\\)|$(sandbox_name))[,.]")
    mod_regex_nodot = Regex(("(Main\\.)?$(sandbox_name)"))
    outio = IOContext(result.stdout, :module => sandbox)
    filters = collect_doctest_filters(doc, meta)
    if isdefined(result, :bt) # An error was thrown and we have a backtrace.
        # To avoid dealing with path/line number issues in backtraces we use `[...]` to
        # mark ignored output from an error message. Only the text prior to it is used to
        # test for doctest success/failure.
        head = replace(split(result.output, "\n[...]"; limit = 2)[1], mod_regex => "")
        head = replace(head, mod_regex_nodot => "Main")
        str = error_to_string(outio, result.value, result.bt)
        str = replace(str, mod_regex => "")
        str = replace(str, mod_regex_nodot => "Main")
        filteredstr, filteredhead = filter_doctests(filters, (str, head))
        @debug debug_report(
            result = result, filters = filters, expected_filtered = filteredhead,
            evaluated = rstrip(str), evaluated_filtered = filteredstr
        )
        # Since checking for the prefix of an error won't catch the empty case we need
        # to check that manually with `isempty`.
        # In the doc.user.doctest === :fix we need actual equality of
        # filteredstr and filteredhead, otherwise this needs to get repaired.
        if isempty(head) || !startswith(filteredstr, filteredhead) ||
                (doc.user.doctest === :fix && filteredstr != filteredhead)
            if doc.user.doctest === :fix
                # special case: if everything matched prior to filtering, except for a
                # trailing "[...]" in the reference string, then don't "fix" this but
                # rather assume this is intentionally cutting off part of the output
                # resp. stacktrace
                if !(startswith(str, head) && endswith(result.output, "[...]"))
                    fix_doctest(result, str, doc; prefix)
                end
            else
                report(result, str, doc)
                @debug "Doctest metadata" meta
                push!(doc.internal.errors, :doctest)
            end
        else
            # Prefix was not modified, unless output was different.
            prefix.content *= result.raw_input * "\n"
            if str != ""
                prefix.content *= str * "\n"
            end
            prefix.content *= "\n"
        end
    else
        value = result.hide ? nothing : result.value # `;` hides output.
        output = replace(rstrip(sanitise(IOBuffer(result.output))), mod_regex => "")
        str = replace(result_to_string(outio, value), mod_regex => "")
        # Replace a standalone module name with `Main`.
        str = rstrip(replace(str, mod_regex_nodot => "Main"))
        filteredstr, filteredoutput = filter_doctests(filters, (str, output))
        @debug debug_report(
            result = result, filters = filters, expected_filtered = filteredoutput,
            evaluated = rstrip(str), evaluated_filtered = filteredstr
        )
        if filteredstr != filteredoutput
            if doc.user.doctest === :fix
                fix_doctest(result, str, doc; prefix)
            else
                report(result, str, doc)
                @debug "Doctest metadata" meta
                push!(doc.internal.errors, :doctest)
            end
        else
            # Prefix was not modified, unless output was different.
            prefix.content *= result.raw_input * "\n"
            if str != ""
                prefix.content *= str * "\n"
            end
            prefix.content *= "\n"
        end
    end
    return nothing
end

function debug_report(; result, expected_filtered, evaluated, evaluated_filtered, filters)
    lines = Documenter.find_block_in_file(result.block.code, result.file)
    r = """
    Verifying doctest at $(Documenter.locrepr(result.file, lines))

    ```$(result.block.info)
    $(result.block.code)
    ```

    Subexpression:

    $(result.input)

    Evaluated output:

    $(evaluated)

    Expected output:

    $(result.output)
    """
    if !isempty(filters)
        r *= "\n"
        r *= (length(filters) == 1) ? "1 doctest filter was applied:\n\n" :
            "$(length(filters)) doctest filters were applied:\n\n"
        for rs in filters
            r *= "  $rs\n"
        end
        r *= """

        Evaluated output (filtered):

        $(evaluated_filtered)

        Expected output (filtered):

        $(expected_filtered)
        """
    end
    return r
end

function collect_doctest_filters(doc::Documenter.Document, meta::Dict)
    meta_block_filters = get(Vector{Any}, meta, :DocTestFilters)
    meta_block_filters === nothing && (meta_block_filters = [])
    doctest_local_filters = get(meta[:LocalDocTestArguments], :filter, [])
    return [doc.user.doctestfilters; meta_block_filters; doctest_local_filters]
end

# Display doctesting results.

function result_to_string(buf, value)
    value === nothing || Base.invokelatest(show, IOContext(buf, :limit => true), MIME"text/plain"(), value)
    return sanitise(buf)
end

function error_to_string(buf, er, bt)
    # Remove unimportant backtrace info.
    bt = Documenter.remove_common_backtrace(bt, backtrace())
    # Remove everything below the last eval call (which should be the one in IOCapture.capture)
    index = findlast(ptr -> Base.ip_matches_func(ptr, :eval), bt)
    bt = (index === nothing) ? bt : bt[1:(index - 1)]
    # Print a REPL-like error message.
    print(buf, "ERROR: ")
    Base.invokelatest(showerror, buf, er, bt)
    return sanitise(buf)
end

# Strip trailing whitespace from each line and return resulting string
function sanitise(buffer)
    out = IOBuffer()
    for line in eachline(seekstart(Base.unwrapcontext(buffer)[1]))
        println(out, rstrip(line))
    end
    return rstrip(String(take!(out)), '\n')
end

import .Documenter.TextDiff

function report(result::Result, str, doc::Documenter.Document)
    diff = TextDiff.Diff{TextDiff.Words}(result.output, rstrip(str))
    lines = Documenter.find_block_in_file(result.block.code, result.file)
    line = lines === nothing ? nothing : first(lines)
    @error(
        """
        doctest failure in $(Documenter.locrepr(result.file, lines))

        ```$(result.block.info)
        $(result.block.code)
        ```

        Subexpression:

        $(result.input)

        Evaluated output:

        $(rstrip(str))

        Expected output:

        $(result.output)

        """, diff, _file = result.file, _line = line
    )
    return
end

function fix_doctest(result::Result, str, doc::Documenter.Document; prefix::MutablePrefix = MutablePrefix())
    code = result.block.code
    filename = Base.find_source_file(result.file)
    # read the file containing the code block
    content = read(filename, String)
    # output stream
    io = IOBuffer(sizehint = sizeof(content))
    # first look for the entire code block
    # make a regex of the code that matches leading whitespace
    rcode = "(\\h*)" * replace(Documenter.regex_escape(code), "\\n" => "\\n\\h*")
    r = Regex(rcode)
    codeidx = findfirst(r, content)
    if codeidx === nothing
        @warn "could not find code block in source file $filename"
        return
    end
    # use the capture group to identify indentation
    indent = match(r, content).captures[1]
    # write everything up until the code block
    data = content[1:prevind(content, first(codeidx))]
    write(io, data)
    # next look for the particular input string in the given code block
    # make a regex of the input that matches leading whitespace (for multiline input)
    composed = prefix.content * result.raw_input
    rinput = replace(Documenter.regex_escape(composed), "\\n" => "\\n\\h*")
    r = Regex(rinput)
    inputidx = findfirst(r, code)
    if inputidx === nothing
        startline = count("\n", data)
        @warn "could not find input line in code block in $filename:$startline"
        return
    end
    # construct the new code-snippet (without indent)
    # first part: everything up until the last index of the input string
    newcode = code[1:last(inputidx)]
    prefix.content = newcode * "\n"
    if str != ""
        prefix.content *= str * "\n"
    end
    prefix.content *= "\n"
    isempty(result.output) && (newcode *= '\n') # issue #772
    # second part: the rest, with the old output replaced with the new one
    if result.output == ""
        # This works around a regression in Julia 1.5.0 (https://github.com/JuliaLang/julia/issues/36953)
        # Technically, it is only necessary if VERSION >= v"1.5.0-DEV.826"
        newcode *= str
        newcode *= code[nextind(code, last(inputidx)):end]
    else
        if str == ""
            newcode *= replace(code[nextind(code, last(inputidx)):end], result.output * "\n" => str, count = 1)
        else
            newcode *= replace(code[nextind(code, last(inputidx)):end], result.output => str, count = 1)
        end
    end
    # replace internal code block with the non-indented new code, needed if we come back
    # looking to replace output in the same code block later
    result.block.code = newcode
    # write the new code snippet to the stream, with indent
    newcode = replace(newcode, r"^(.+)$"m => Base.SubstitutionString(indent * "\\1"))
    write(io, newcode)
    # write rest of the file
    write(io, content[nextind(content, last(codeidx)):end])
    # write to file
    write(filename, seekstart(io))
    return
end

# REPL doctest splitter.

const PROMPT_REGEX = r"^julia> (.*)$"
const SOURCE_REGEX = r"^       (.*)$"

function repl_splitter(code, doc::Documenter.Document, file, src_lines)
    lines = split(string(code, "\n"), '\n')
    input = String[]
    raw_inputs = String[]
    output = String[]
    prefix = MutablePrefix()
    buffer = IOBuffer() # temporary buffer for doctest inputs and outputs
    raw_input_buffer = IOBuffer()
    found_first_prompt = false
    last_was_prompt = false
    while !isempty(lines)
        line = popfirst!(lines)
        # We allow comments before the first julia> prompt
        if !found_first_prompt && startswith(line, '#')
            prefix.content *= line * "\n"
            continue
        end
        # Empty lines before the first julia> prompt are forbidden
        if !found_first_prompt && isempty(line)
            @docerror(
                doc, :doctest,
                """
                Unable to to evaluate doctest in $(Documenter.locrepr(file, src_lines))
                No empty lines are allowed before first `julia>` prompt.

                ```jldoctest
                $(code)
                ```
                """
            )
            return prefix, zip(String[], String[], String[])
        end
        prompt = match(PROMPT_REGEX, line)
        if prompt === nothing
            source = match(SOURCE_REGEX, line)
            if source === nothing
                savebuffer!(input, buffer)
                savebuffer!(raw_inputs, raw_input_buffer)
                println(buffer, line)
                takeuntil!(PROMPT_REGEX, buffer, lines)
            else
                println(buffer, source[1])
                println(raw_input_buffer, line)
            end
            last_was_prompt = false
        else
            if last_was_prompt
                @docerror(
                    doc, :doctest,
                    """
                    Unable to to evaluate doctest in $(Documenter.locrepr(file, src_lines))
                    Consecutive `julia>` prompts must be separated by an empty line.

                    ```jldoctest
                    $(code)
                    ```
                    """
                )
                return prefix, zip(String[], String[], String[])
            end
            found_first_prompt = true
            savebuffer!(output, buffer)
            println(buffer, prompt[1])
            println(raw_input_buffer, line)
            last_was_prompt = true
        end
    end
    savebuffer!(output, buffer)
    return prefix, zip(raw_inputs, input, output)
end

function savebuffer!(out, buf)
    n = bytesavailable(seekstart(buf))
    return n > 0 ? push!(out, rstrip(String(take!(buf)))) : out
end

function takeuntil!(r, buf, lines)
    while !isempty(lines)
        line = lines[1]
        if !occursin(r, line)
            println(buf, popfirst!(lines))
        else
            break
        end
    end
    return
end

"""
Defines the `Documenter.jl` build "pipeline" named [`DocumentPipeline`](@ref).

Each stage of the pipeline performs an action on a [`Document`](@ref Documenter.Document) object.
These actions may involve creating directory structures, expanding templates, running
doctests, etc.
"""
module Builder
    import ..Documenter
    import ..Documenter.Selectors

    """
    The default document processing "pipeline", which consists of the following actions:

    - [`SetupBuildDirectory`](@ref)
    - [`Doctest`](@ref)
    - [`ExpandTemplates`](@ref)
    - [`CheckDocument`](@ref)
    - [`Populate`](@ref)
    - [`RenderDocument`](@ref)

    """
    abstract type DocumentPipeline <: Selectors.AbstractSelector end

    """
    Creates the correct directory layout within the `build` folder and parses markdown files.
    """
    abstract type SetupBuildDirectory <: DocumentPipeline end

    """
    Runs all the doctests in all docstrings and Markdown files.
    """
    abstract type Doctest <: DocumentPipeline end

    """
    Executes a sequence of actions on each node of the parsed markdown files in turn.
    """
    abstract type ExpandTemplates <: DocumentPipeline end

    """
    Finds and sets URLs for each `@ref` link in the document to the correct destinations.
    """
    abstract type CrossReferences <: DocumentPipeline end

    """
    Checks that all documented objects are included in the document and runs doctests on all
    valid Julia code blocks.
    """
    abstract type CheckDocument <: DocumentPipeline end

    """
    Populates the `ContentsNode`s and `IndexNode`s with links.
    """
    abstract type Populate <: DocumentPipeline end

    """
    Writes the document tree to the `build` directory.
    """
    abstract type RenderDocument <: DocumentPipeline end
end

Selectors.order(::Type{Builder.SetupBuildDirectory}) = 1.0
Selectors.order(::Type{Builder.Doctest}) = 1.1
Selectors.order(::Type{Builder.ExpandTemplates}) = 2.0
Selectors.order(::Type{Builder.CrossReferences}) = 3.0
Selectors.order(::Type{Builder.CheckDocument}) = 4.0
Selectors.order(::Type{Builder.Populate}) = 5.0
Selectors.order(::Type{Builder.RenderDocument}) = 6.0

Selectors.matcher(::Type{T}, doc::Documenter.Document) where {T <: Builder.DocumentPipeline} = true

Selectors.strict(::Type{T}) where {T <: Builder.DocumentPipeline} = false

function Selectors.runner(::Type{Builder.SetupBuildDirectory}, doc::Documenter.Document)
    @info "SetupBuildDirectory: setting up build directory."

    # Frequently used fields.
    build = doc.user.build
    source = doc.user.source
    workdir = doc.user.workdir

    # The .user.source directory must exist.
    isdir(source) || error("source directory '$(abspath(source))' is missing.")

    # We create the .user.build directory.
    # If .user.clean is set, we first clean the existing directory.
    doc.user.clean && isdir(build) && rm(build; recursive = true)
    isdir(build) || mkpath(build)

    # We'll walk over all the files in the .user.source directory.
    # The directory structure is copied over to .user.build. All files, with
    # the exception of markdown files (identified by the extension) are copied
    # over as well, since they're assumed to be images, data files etc.
    # Markdown files, however, get added to the document and also stored into
    # `mdpages`, to be used later.
    mdpages = String[]
    for (root, dirs, files) in walkdir(source; follow_symlinks = true)
        for dir in dirs
            d = normpath(joinpath(build, relpath(root, source), dir))
            isdir(d) || mkdir(d)
        end
        for file in files
            src = normpath(joinpath(root, file))
            dst = normpath(joinpath(build, relpath(root, source), file))

            if workdir == :build
                # set working directory to be the same as `build`
                wd = normpath(joinpath(build, relpath(root, source)))
            elseif workdir isa Symbol
                # Maybe allow `:src` and `:root` as well?
                throw(ArgumentError("Unrecognized working directory option '$workdir'"))
            else
                wd = normpath(joinpath(doc.user.root, workdir))
            end

            if endswith(file, ".md")
                push!(mdpages, Documenter.srcpath(source, root, file))
                Documenter.addpage!(doc, src, dst, wd)
            else
                cp(src, dst; force = true)
            end
        end
    end

    # If the user hasn't specified the page list, then we'll just default to a
    # flat list of all the markdown files we found, sorted by the filesystem
    # path (it will group them by subdirectory, among others).
    userpages = isempty(doc.user.pages) ? sort(mdpages, lt = lt_page) : doc.user.pages

    # Populating the .navtree and .navlist.
    # We need the for loop because we can't assign to the fields of the immutable
    # doc.internal.
    for navnode in walk_navpages(userpages, nothing, doc)
        push!(doc.internal.navtree, navnode)
    end

    # Finally we populate the .next and .prev fields of the navnodes that point
    # to actual pages.
    local prev::Union{Documenter.NavNode, Nothing} = nothing
    for navnode in doc.internal.navlist
        navnode.prev = prev
        if prev !== nothing
            prev.next = navnode
        end
        prev = navnode
    end

    # If the user specified pagesonly, we will remove all the pages not in the navigation
    # menu (.pages).
    if doc.user.pagesonly
        navlist_pages = getfield.(doc.internal.navlist, :page)
        for page in keys(doc.blueprint.pages)
            page ∈ navlist_pages || delete!(doc.blueprint.pages, page)
        end
    end
    return
end

"""
    lt_page(a::AbstractString, b::AbstractString)

Checks if the page path `a` should come before `b` in a sorted list. Falls back to standard
string sorting, except for prioritizing `index.md` (i.e. `index.md` always comes first).
"""
function lt_page(a, b)
    # note: length("index.md") == 8
    a = endswith(a, "index.md") ? chop(a; tail = 8) : a
    b = endswith(b, "index.md") ? chop(b; tail = 8) : b
    return a < b
end

"""
$(SIGNATURES)

Recursively walks through the [`Document`](@ref)'s `.user.pages` field,
generating [`NavNode`](@ref)s and related data structures in the
process.

This implementation is the de facto specification for the `.user.pages` field.
"""
function walk_navpages(visible, title, src, children, parent, doc)
    # parent can also be nothing (for top-level elements)
    parent_visible = (parent === nothing) || parent.visible
    if src !== nothing
        src = normpath(src)
        src in keys(doc.blueprint.pages) || error("'$src' is not an existing page!")
    end
    nn = Documenter.NavNode(src, title, parent)
    (src === nothing) || push!(doc.internal.navlist, nn)
    nn.visible = parent_visible && visible
    nn.children = walk_navpages(children, nn, doc)
    return nn
end

function walk_navpages(hps::Tuple, parent, doc)
    @assert length(hps) == 4
    return walk_navpages(hps..., parent, doc)
end

walk_navpages(title::String, children::Vector, parent, doc) = walk_navpages(true, title, nothing, children, parent, doc)
walk_navpages(title::String, page, parent, doc) = walk_navpages(true, title, page, [], parent, doc)

walk_navpages(p::Pair, parent, doc) = walk_navpages(p.first, p.second, parent, doc)
walk_navpages(ps::Vector, parent, doc) = [walk_navpages(p, parent, doc)::Documenter.NavNode for p in ps]
walk_navpages(src::String, parent, doc) = walk_navpages(true, nothing, src, [], parent, doc)

function Selectors.runner(::Type{Builder.Doctest}, doc::Documenter.Document)
    if doc.user.doctest in [:fix, :only, true]
        @info "Doctest: running doctests."
        _doctest(doc.blueprint, doc)
        num_errors = length(doc.internal.errors)
        if (doc.user.doctest === :only || is_strict(doc, :doctest)) && num_errors > 0
            error("`makedocs` encountered $(num_errors > 1 ? "$(num_errors) doctest errors" : "a doctest error"). Terminating build")
        end
    else
        @info "Doctest: skipped."
    end
    return
end

function Selectors.runner(::Type{Builder.ExpandTemplates}, doc::Documenter.Document)
    is_doctest_only(doc, "ExpandTemplates") && return
    @info "ExpandTemplates: expanding markdown templates."
    expand(doc)
    return
end

function Selectors.runner(::Type{Builder.CrossReferences}, doc::Documenter.Document)
    is_doctest_only(doc, "CrossReferences") && return
    @info "CrossReferences: building cross-references."
    crossref(doc)
    return
end

function Selectors.runner(::Type{Builder.CheckDocument}, doc::Documenter.Document)
    is_doctest_only(doc, "CheckDocument") && return
    @info "CheckDocument: running document checks."
    missingdocs(doc)
    footnotes(doc)
    linkcheck(doc)
    githubcheck(doc)
    return
end

function Selectors.runner(::Type{Builder.Populate}, doc::Documenter.Document)
    is_doctest_only(doc, "Populate") && return
    @info "Populate: populating indices."
    doctest_replace!(doc)
    populate!(doc)
    return
end

function Selectors.runner(::Type{Builder.RenderDocument}, doc::Documenter.Document)
    is_doctest_only(doc, "RenderDocument") && return
    # How many fatal errors
    fatal_errors = filter(is_strict(doc), doc.internal.errors)
    c = length(fatal_errors)
    if c > 0
        error(
            "`makedocs` encountered $(c > 1 ? "errors" : "an error") ["
                * join(Ref(":") .* string.(fatal_errors), ", ")
                * "] -- terminating build before rendering."
        )
    else
        @info "RenderDocument: rendering document."
        Documenter.render(doc)
    end
    return
end

Selectors.runner(::Type{Builder.DocumentPipeline}, doc::Documenter.Document) = nothing

function is_doctest_only(doc, stepname)
    if doc.user.doctest in [:fix, :only]
        @info "Skipped $stepname step (doctest only)."
        return true
    end
    return false
end

# Defines node "expanders" that transform nodes from the parsed markdown files.

function clear_global!(M::Module, name::Symbol)
    isconst(M, name) && return
    if VERSION >= v"1.9"
        Nothing <: Core.get_binding_type(M, name) || return
        setglobal!(M, name, nothing)
    else
        Core.eval(M, :($name = $nothing))
    end
    return nothing
end

# helper for "cleaning up" content of modules to enable garbage collection.
# See also <https://github.com/JuliaDocs/Documenter.jl/issues/2640>.
function clear_module!(M::Module)
    # we need `invokelatest` here for Julia >= 1.12 (or 1.13?)
    for name in Base.invokelatest(names, M, all = true)::Vector{Symbol}
        # see, e.g https://github.com/JuliaDocs/Documenter.jl/issues/2673
        # it is not possible to set `nothing` to variables, which are strongly typed
        # still attempt to set it, but ignore any errors
        try
            Base.invokelatest(clear_global!, M, name::Symbol)
        catch err
            @debug "Could not clear variable `$name` by assigning `nothing`" err
        end
        VERSION >= v"1.12" && Base.delete_binding(M, name)
    end
    return
end

function clear_modules!(d::Dict{Symbol, Any})
    for (k, v) in d
        startswith(String(k), "__atexample__") || continue
        v isa Module && clear_module!(v)
    end
    return
end

function expand(doc::Documenter.Document)
    expandfirst = map(normpath, doc.user.expandfirst)
    priority_pages = filter(expandfirst) do src
        if src in keys(doc.blueprint.pages)
            return true
        else
            @warn "$(src) in expandfirst does not exist"
            return false
        end
    end
    normal_pages = filter(src -> !(src in priority_pages), keys(doc.blueprint.pages))
    normal_pages = sort([src for src in normal_pages])
    @debug "pages" keys(doc.blueprint.pages) priority_pages normal_pages
    for src in Iterators.flatten([priority_pages, normal_pages])
        page = doc.blueprint.pages[src]
        @debug "Running ExpanderPipeline on $src"
        copy!(page.globals.meta, doc.user.meta)
        # We need to collect the child nodes here because we will end up changing the structure
        # of the tree in some cases.
        for node in collect(page.mdast.children)
            Selectors.dispatch(Expanders.ExpanderPipeline, node, page, doc)
            expand_recursively(node, page, doc)
        end
        # Register arbitrary `[content](@id name)` anchors. This runs after the per-node
        # expansion above (so header `@id` links have already been consumed by TrackHeaders)
        # and, crucially, before the CrossReferences pipeline stage, so that `@ref`s to these
        # anchors — including forward references to later pages — can be resolved.
        collect_named_anchors!(page, doc)
        pagecheck(doc, page)
        clear_modules!(page.globals.meta)
    end
    return
end

"""
Similar to `expand()`, but recursively calls itself on all descendants of `node`
and applies `NestedExpanderPipeline` instead of `ExpanderPipeline`.
"""
function expand_recursively(node, page, doc)
    if typeof(node.element) in (
            MarkdownAST.Admonition,
            MarkdownAST.BlockQuote,
            MarkdownAST.Item,
            MarkdownAST.List,
        )
        for child in node.children
            Selectors.dispatch(Expanders.NestedExpanderPipeline, child, page, doc)
            expand_recursively(child, page, doc)
        end
    end
    return
end

# run some checks after expanding the page
function pagecheck(doc, page)
    # make sure there is no "continued code" lingering around
    if haskey(page.globals.meta, :ContinuedCode) && !isempty(page.globals.meta[:ContinuedCode])
        @warn "code from a continued @example block unused in $(Documenter.locrepr(doc, page))."
    end
    return
end

share_default_module(page)::Bool = get(page.globals.meta, :ShareDefaultModule, false)

# Draft output code block
function create_draft_result!(node::Node; blocktype = "code")
    @assert node.element isa MarkdownAST.CodeBlock
    codeblock = node.element
    codeblock.info = "julia"
    node.element = Documenter.MultiOutput(codeblock)
    push!(node.children, Node(codeblock))
    outputnode = Node(
        Documenter.MultiOutputElement(
            Dict{MIME, Any}(MIME"text/plain"() => "<< $(blocktype)-block not executed in draft mode >>")
        )
    )
    push!(node.children, outputnode)
    return
end


# Expander Pipeline.
module Expanders
    import ..Documenter # for docstring references
    import ..Documenter.Selectors

    """
    The default node expander "pipeline", which consists of the following expanders:

    - [`TrackHeaders`](@ref)
    - [`MetaBlocks`](@ref)
    - [`DocsBlocks`](@ref)
    - [`AutoDocsBlocks`](@ref)
    - [`EvalBlocks`](@ref)
    - [`IndexBlocks`](@ref)
    - [`ContentsBlocks`](@ref)
    - [`ExampleBlocks`](@ref)
    - [`SetupBlocks`](@ref)
    - [`REPLBlocks`](@ref)

    """
    abstract type ExpanderPipeline <: Selectors.AbstractSelector end

    """
    The subset of [node expanders](@ref `ExpanderPipeline`) which also apply in nested contexts.

    See also [`expand_recursively`](@ref `Documenter.expand_recursively`).
    """
    abstract type NestedExpanderPipeline <: ExpanderPipeline end

    """
    Tracks all `Markdown.Header` nodes found in the parsed markdown files and stores an
    [`Anchor`](@ref `Documenter.Anchor`) object for each one.
    """
    abstract type TrackHeaders <: ExpanderPipeline end

    """
    Parses each code block where the language is `@meta` and evaluates the key/value pairs found
    within the block, i.e.

    ````markdown
    ```@meta
    CurrentModule = Documenter
    DocTestSetup  = quote
        using Documenter
    end
    ```
    ````
    """
    abstract type MetaBlocks <: ExpanderPipeline end

    """
    Parses each code block where the language is `@docs` and evaluates the expressions found
    within the block. Replaces the block with the docstrings associated with each expression.

    ````markdown
    ```@docs
    Documenter
    makedocs
    deploydocs
    ```
    ````
    """
    abstract type DocsBlocks <: ExpanderPipeline end

    """
    Parses each code block where the language is `@autodocs` and replaces it with all the
    docstrings that match the provided key/value pairs `Modules = ...` and `Order = ...`.

    ````markdown
    ```@autodocs
    Modules = [Foo, Bar]
    Order   = [:function, :type]
    ```
    ````
    """
    abstract type AutoDocsBlocks <: ExpanderPipeline end

    """
    Parses each code block where the language is `@eval` and evaluates its content. Replaces
    the block with the value resulting from the evaluation. This can be useful for inserting
    generated content into a document such as plots.

    ````markdown
    ```@eval
    using PyPlot
    x = linspace(-π, π)
    y = sin(x)
    plot(x, y, color = "red")
    savefig("plot.svg")
    Markdown.parse("![Plot](plot.svg)")
    ```
    ````
    """
    abstract type EvalBlocks <: NestedExpanderPipeline end

    """
    Parses each code block where the language is `@raw`.

    ````markdown
    ```@raw html
    <svg style="display: block; margin: 0 auto;" width="5em" height="5em">
        <circle cx="2.5em" cy="2.5em" r="2em" stroke="black" stroke-width=".1em" fill="red" />
    </svg>
    ```
    ````
    """
    abstract type RawBlocks <: NestedExpanderPipeline end

    """
    Parses each code block where the language is `@index` and replaces it with an index of all
    docstrings spliced into the document. The pages that are included can be set using a
    key/value pair `Pages = [...]` such as

    ````markdown
    ```@index
    Pages = ["foo.md", "bar.md"]
    ```
    ````
    """
    abstract type IndexBlocks <: ExpanderPipeline end

    """
    Parses each code block where the language is `@contents` and replaces it with a nested list
    of all `Header` nodes in the generated document. The pages and depth of the list can be set
    using `Pages = [...]` and `Depth = N` where `N` is an integer.

    ````markdown
    ```@contents
    Pages = ["foo.md", "bar.md"]
    Depth = 1
    ```
    ````
    The default `Depth` value is `2`.
    """
    abstract type ContentsBlocks <: ExpanderPipeline end

    """
    Parses each code block where the language is `@example` and evaluates the parsed Julia code
    found within. The resulting value is then inserted into the final document after the source
    code.

    ````markdown
    ```@example
    a = 1
    b = 2
    a + b
    ```
    ````
    """
    abstract type ExampleBlocks <: NestedExpanderPipeline end

    """
    Similar to the [`ExampleBlocks`](@ref) expander, but inserts a Julia REPL prompt before each
    toplevel expression in the final document.

    ````markdown
    ```@repl
    a = 1
    b = 2
    a + b
    ```
    ````
    """
    abstract type REPLBlocks <: NestedExpanderPipeline end

    """
    Similar to the [`ExampleBlocks`](@ref) expander, but hides all output in the final document.

    ````markdown
    ```@setup
    using MyExamplePackage
    ```
    ````
    """
    abstract type SetupBlocks <: NestedExpanderPipeline end
end

Selectors.order(::Type{Expanders.TrackHeaders}) = 1.0
Selectors.order(::Type{Expanders.MetaBlocks}) = 2.0
Selectors.order(::Type{Expanders.DocsBlocks}) = 3.0
Selectors.order(::Type{Expanders.AutoDocsBlocks}) = 4.0
Selectors.order(::Type{Expanders.EvalBlocks}) = 5.0
Selectors.order(::Type{Expanders.IndexBlocks}) = 6.0
Selectors.order(::Type{Expanders.ContentsBlocks}) = 7.0
Selectors.order(::Type{Expanders.ExampleBlocks}) = 8.0
Selectors.order(::Type{Expanders.REPLBlocks}) = 9.0
Selectors.order(::Type{Expanders.SetupBlocks}) = 10.0
Selectors.order(::Type{Expanders.RawBlocks}) = 11.0

Selectors.matcher(::Type{Expanders.TrackHeaders}, node, page, doc) = isa(node.element, MarkdownAST.Heading)
Selectors.matcher(::Type{Expanders.MetaBlocks}, node, page, doc) = iscode(node, "@meta")
Selectors.matcher(::Type{Expanders.DocsBlocks}, node, page, doc) = iscode(node, r"^@docs")
Selectors.matcher(::Type{Expanders.AutoDocsBlocks}, node, page, doc) = iscode(node, r"^@autodocs")
Selectors.matcher(::Type{Expanders.EvalBlocks}, node, page, doc) = iscode(node, r"^@eval")
Selectors.matcher(::Type{Expanders.IndexBlocks}, node, page, doc) = iscode(node, "@index")
Selectors.matcher(::Type{Expanders.ContentsBlocks}, node, page, doc) = iscode(node, "@contents")
Selectors.matcher(::Type{Expanders.ExampleBlocks}, node, page, doc) = iscode(node, r"^@example")
Selectors.matcher(::Type{Expanders.REPLBlocks}, node, page, doc) = iscode(node, r"^@repl")
Selectors.matcher(::Type{Expanders.SetupBlocks}, node, page, doc) = iscode(node, r"^@setup")
Selectors.matcher(::Type{Expanders.RawBlocks}, node, page, doc) = iscode(node, r"^@raw")

# Default Expander.

Selectors.runner(::Type{Expanders.ExpanderPipeline}, node, page, doc) = nothing
Selectors.runner(::Type{Expanders.NestedExpanderPipeline}, node, page, doc) = nothing

# Track Headers.
# --------------

function Selectors.runner(::Type{Expanders.TrackHeaders}, node, page, doc)
    header = node.element
    # Get the header slug.
    if namedheader(node)
        # If the Header is wrapped in an [](@id) link, we remove the Link element from
        # the tree.
        link_node = first(node.children)
        MarkdownAST.unlink!(link_node)
        append!(node.children, link_node.children)
        text = match(NAMED_ANCHOR_REGEX, link_node.element.destination)[1]
    else
        # TODO: remove this hack (replace with mdflatten?)
        ast = MarkdownAST.@ast MarkdownAST.Document() do
            MarkdownAST.copy_tree(node)
        end
        md = convert(Markdown.MD, ast)
        text = sprint(Markdown.plain, Markdown.Paragraph(md.content[1].text))
    end
    slug = Documenter.slugify(text)
    # Add the header to the document's header map.
    anchor = Documenter.anchor_add!(doc.internal.anchors, header, slug, page.build)
    # Create an AnchoredHeader node and push the
    ah = MarkdownAST.Node(Documenter.AnchoredHeader(anchor))
    anchor.node = ah
    MarkdownAST.insert_after!(node, ah)
    push!(ah.children, node)
    return
end

# @meta
# -----

function Selectors.runner(::Type{Expanders.MetaBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element
    lines = Documenter.find_block_in_file(x.code, page.source)
    source = Documenter.locrepr(doc, page, lines)

    meta = page.globals.meta
    @debug "Evaluating @meta block:\n$(x.code)"
    for (ex, str) in Documenter.parseblock(x.code, doc, page; lines)
        # If not `isassign`, this might be a comment, or any code that the user
        # wants to hide. We should probably warn, but it is common enough that
        # we will silently skip for now.
        if Documenter.isassign(ex)
            if !(ex.args[1] in (:CurrentModule, :DocTestSetup, :DocTestTeardown, :DocTestFilters, :EditURL, :Description, :Draft, :CollapsedDocStrings, :ShareDefaultModule))
                @warn(
                    "In $source: `@meta` block has an unsupported " *
                        "keyword argument: $(ex.args[1])",
                )
            end
            try
                meta[ex.args[1]] = Core.eval(Main, ex.args[2])
            catch err
                @docerror(
                    doc, :meta_block,
                    """
                    failed to evaluate `$(strip(str))` in `@meta` block in $(source)
                    ```$(x.info)
                    $(x.code)
                    ```
                    """, exception = err
                )
            end
        end
    end
    node.element = MetaNode(x, copy(meta))
    return
end

# @docs / @autodocs utils
# -----------------------

function slugify_pagekey(page_ref)
    page_ref = slugify(page_ref)
    page_ref = replace(page_ref, "/" => "-")
    page_ref = replace(page_ref, r"\.md$" => "")
    return page_ref
end

function make_object(binding, typesig, is_canonical, doc, page)
    object = Documenter.Object(binding, typesig)
    if !is_canonical
        primary_anchor = string(object)
        counter = get!(page.globals.meta, :noncanonical_docs_counter, Dict())
        frag_extra = slugify_pagekey(pagekey(doc, page))
        if primary_anchor in keys(counter)
            counter[primary_anchor] += 1
            frag_extra *= "-$(counter[primary_anchor])"
        else
            counter[primary_anchor] = 1
        end
        object = Documenter.Object(binding, typesig, frag_extra)
    end
    return object
end

# @docs
# -----

function Selectors.runner(::Type{Expanders.DocsBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element
    lines = Documenter.find_block_in_file(x.code, page.source)
    source = Documenter.locrepr(doc, page, lines)

    success, name, d = parse_codeblock_args(
        "@docs", x, doc, source;
        allow_name = false,
        allowed_kwargs = [:canonical],
        bool_kwargs = [:canonical],
    )
    success || return

    is_canonical = get(d, :canonical, true)

    docsnodes = Node[]
    curmod = get(page.globals.meta, :CurrentModule, Main)

    @debug "Evaluating @docs block:\n$(x.code)"
    for (ex, str) in Documenter.parseblock(x.code, doc, page; lines)
        adstr = """
        !!! warning "Missing docstring."

            Missing docstring for `$(strip(str))`. Check Documenter's build log for details.
        """
        admonition = first(Documenter.mdparse(adstr, mode = :blocks))
        binding = try
            Documenter.DocSystem.binding(curmod, ex)
        catch err
            @docerror(
                doc, :docs_block,
                """
                unable to get the binding for '$(strip(str))' in `@docs` block in $(source) from expression '$(repr(ex))' in module $(curmod)
                ```$(x.info)
                $(x.code)
                ```
                """,
                exception = err
            )
            push!(docsnodes, admonition)
            continue
        end
        # Undefined `Bindings` get discarded.
        if !Documenter.DocSystem.iskeyword(binding) && !Documenter.DocSystem.defined(binding)
            @docerror(
                doc, :docs_block,
                """
                undefined binding '$(binding)' in `@docs` block in $(source)
                ```$(x.info)
                $(x.code)
                ```
                """
            )
            push!(docsnodes, admonition)
            continue
        end
        typesig = try
            Core.eval(curmod, Documenter.DocSystem.signature(ex, str))
        catch err
            @docerror(
                doc, :docs_block,
                """
                failed to evaluate `$(strip(str))` in `@docs` block in $(source)
                ```$(x.info)
                $(x.code)
                ```
                """, exception = err
            )
            push!(docsnodes, admonition)
            continue
        end
        object = make_object(binding, typesig, is_canonical, doc, page)
        # We can't include the same object more than once in a document.
        if haskey(doc.internal.objects, object)
            apistatus = DocSystem.APIStatus(binding)
            @docerror(
                doc, :docs_block,
                """
                duplicate docs found for '$(strip(str))' in `@docs` block in $(source)
                ```$(x.info)
                $(x.code)
                ``` $(DocSystem.public_unexported_msg(apistatus))
                """
            )
            push!(docsnodes, admonition)
            continue
        end

        # Find the docs matching `binding` and `typesig`. Only search within the provided modules.
        docs = Documenter.DocSystem.getdocs(binding, typesig; modules = doc.blueprint.modules)

        # Include only docstrings from user-provided modules if provided.
        if !isempty(doc.blueprint.modules)
            filter!(d -> d.data[:module] in doc.blueprint.modules, docs)
        end

        # Check that we aren't printing an empty docs list. Skip block when empty.
        if isempty(docs)
            @docerror(
                doc, :docs_block,
                """
                no docs found for '$(strip(str))' in `@docs` block in $(source)
                ```$(x.info)
                $(x.code)
                ```
                """
            )
            push!(docsnodes, admonition)
            continue
        end

        # Concatenate found docstrings into a single `MD` object.
        docstr = map(Documenter.DocSystem.parsedoc, docs)
        docsnode = create_docsnode(docstr, docs, object, page, doc)

        # Track the order of insertion of objects per-binding.
        push!(get!(doc.internal.bindings, binding, Documenter.Object[]), object)

        doc.internal.objects[object] = docsnode.element
        push!(docsnodes, docsnode)
    end
    node.element = Documenter.DocsNodesBlock(x)
    for docsnode in docsnodes
        push!(node.children, docsnode)
    end
    return
end

# @autodocs
# ---------

const AUTODOCS_DEFAULT_ORDER = [:module, :constant, :type, :function, :macro]

function Selectors.runner(::Type{Expanders.AutoDocsBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element
    lines = Documenter.find_block_in_file(x.code, page.source)
    source = Documenter.locrepr(doc, page, lines)

    success, name, d = parse_codeblock_args(
        "@autodocs", x, doc, source;
        allow_name = false,
        allowed_kwargs = [:canonical],
        bool_kwargs = [:canonical],
    )
    success || return

    is_canonical = get(d, :canonical, true)

    curmod = get(page.globals.meta, :CurrentModule, Main)
    fields = Dict{Symbol, Any}()
    @debug "Evaluating @autodocs block:\n$(x.code)"
    for (ex, str) in Documenter.parseblock(x.code, doc, page; lines)
        if Documenter.isassign(ex)
            try
                if ex.args[1] == :Filter
                    fields[ex.args[1]] = Core.eval(Main, ex.args[2])
                elseif ex.args[1] in (:Modules, :Order, :Pages, :Public, :Private)
                    fields[ex.args[1]] = Core.eval(curmod, ex.args[2])
                else
                    @warn(
                        "In $source: `@autodocs` block has an unsupported " *
                            "keyword argument: $(ex.args[1])",
                    )
                end
            catch err
                @docerror(
                    doc, :autodocs_block,
                    """
                    failed to evaluate `$(strip(str))` in `@autodocs` block in $(source)
                    ```$(x.info)
                    $(x.code)
                    ```
                    """, exception = err
                )
            end
        end
    end
    if haskey(fields, :Modules)
        # Gather and filter docstrings.
        modules = fields[:Modules]
        order = get(fields, :Order, AUTODOCS_DEFAULT_ORDER)
        pages = map(normpath, get(fields, :Pages, []))
        public = get(fields, :Public, true)
        private = get(fields, :Private, true)
        filterfunc = get(fields, :Filter, x -> true)
        results = []
        for mod in modules
            for (binding, multidoc) in Documenter.DocSystem.getmeta(mod)
                # Which bindings should be included?
                apistatus = DocSystem.APIStatus(mod, binding.var)
                included = (apistatus.ispublic && public) || (!apistatus.ispublic && private)
                # What category does the binding belong to?
                category = try
                    Documenter.DocSystem.category(binding)
                catch err
                    isa(err, UndefVarError) || rethrow(err)
                    @docerror(
                        doc, :autodocs_block,
                        """
                        @autodocs ($(source)) encountered a bad docstring binding '$(binding)'
                        ```$(x.info)
                        $(x.code)
                        ```
                        This is likely due to a bug in the Julia docsystem relating to the handling of
                        docstrings attached to methods of callable objects. See:

                          https://github.com/JuliaLang/julia/issues/45174

                        As a workaround, the docstrings for the functor methods could be included in the docstring
                        of the type definition. This error can also be ignored by disabling strict checking for
                        :autodocs_block in the makedocs call with e.g.

                          warnonly = [:autodocs_block]

                        However, the relevant docstrings will then not be included by the @autodocs block.
                        """, exception = err
                    )
                    continue # skip this docstring
                end
                if category in order && included
                    # filter the elements after category/order has been evaluated
                    # to ensure that e.g. when `Order = [:type]` is given, the filter
                    # function really receives only types
                    filtered = Base.invokelatest(filterfunc, Core.eval(binding.mod, binding.var))
                    if filtered
                        for (typesig, docstr) in multidoc.docs
                            path = normpath(docstr.data[:path])
                            object = make_object(binding, typesig, is_canonical, doc, page)
                            if isempty(pages)
                                push!(results, (mod, path, category, object, apistatus, docstr))
                            else
                                for p in pages
                                    if endswith(path, p)
                                        push!(results, (mod, p, category, object, apistatus, docstr))
                                        break
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end

        # Sort docstrings.
        modulemap = Documenter.precedence(modules)
        pagesmap = Documenter.precedence(pages)
        ordermap = Documenter.precedence(order)
        comparison = function (a, b)
            local t
            if (t = Documenter._compare(modulemap, 1, a, b)) != 0
                # module
                return t < 0
            elseif (t = Documenter._compare(pagesmap, 2, a, b)) != 0
                # page
                return t < 0
            elseif (t = Documenter._compare(ordermap, 3, a, b)) != 0
                # category
                return t < 0
            else
                # name
                return string(a[4]) < string(b[4])
            end
        end
        sort!(results; lt = comparison)

        # Finalise docstrings.
        docsnodes = Node[]
        for (mod, path, category, object, apistatus, docstr) in results
            if haskey(doc.internal.objects, object)
                @docerror(
                    doc, :autodocs_block,
                    """
                    duplicate docs found for '$(object.binding)' in $(source)
                    ```$(x.info)
                    $(x.code)
                    ``` $(DocSystem.public_unexported_msg(apistatus))
                    """
                )
                continue
            end
            markdown::Markdown.MD = Documenter.DocSystem.parsedoc(docstr)
            docsnode = create_docsnode([markdown], [docstr], object, page, doc)

            # Track the order of insertion of objects per-binding.
            push!(get!(doc.internal.bindings, object.binding, Documenter.Object[]), object)

            doc.internal.objects[object] = docsnode.element
            push!(docsnodes, docsnode)
        end
        node.element = Documenter.DocsNodesBlock(x)
        for docsnode in docsnodes
            push!(node.children, docsnode)
        end
    else
        @docerror(
            doc, :autodocs_block,
            """
            '@autodocs' missing 'Modules = ...' in $(source)
            ```$(x.info)
            $(x.code)
            ```
            """
        )
    end
    return
end

# @eval
# -----

function Selectors.runner(::Type{Expanders.EvalBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element
    lines = Documenter.find_block_in_file(x.code, page.source)
    source = Documenter.locrepr(doc, page, lines)

    # parse codelang first, even in draft mode, to catch syntax errors
    success, name, d = parse_codeblock_args("@eval", x, doc, source)
    success || return

    # Bail early if in draft mode
    if Documenter.is_draft(doc, page)
        @debug "Skipping evaluation of @eval block in draft mode:\n$(x.code)"
        create_draft_result!(node; blocktype = "@eval")
        return
    end

    # The sandboxed module -- either a new one or a cached one from this page.
    sandbox = Documenter.get_sandbox_module!(page.globals.meta, "atexample", name; share_default_module = share_default_module(page))

    linenumbernode = LineNumberNode(
        lines === nothing ? 0 : lines.first, basename(page.source)
    )
    @debug "Evaluating @eval block:\n$(x.code)"
    cd(page.workdir) do
        result = nothing
        for (ex, str) in Documenter.parseblock(
                x.code, doc, page; keywords = false, linenumbernode, lines
            )
            try
                result = Core.eval(sandbox, ex)
            catch err
                bt = Documenter.remove_common_backtrace(catch_backtrace())
                @docerror(
                    doc, :eval_block,
                    """
                    failed to evaluate `@eval` block in $(source)
                    ```$(x.info)
                    $(x.code)
                    ```
                    """, exception = (err, bt)
                )
            end
        end
        result = if isnothing(result)
            nothing
        elseif isa(result, Markdown.MD)
            convert(Node, result)
        else
            # TODO: we could handle the cases where the user provides some of the Markdown library
            # objects, like Paragraph.
            @docerror(
                doc, :eval_block,
                """
                Invalid type of object in @eval in $(source)
                ```$(x.info)
                $(x.code)
                ```
                Evaluated to `$(typeof(result))`, but should be one of
                 - Nothing
                 - Markdown.MD
                Falling back to textual code block representation.

                If you are seeing this warning/error after upgrading Documenter and this used to work,
                please open an issue on the Documenter issue tracker.
                """
            )
            MarkdownAST.@ast MarkdownAST.Document() do
                MarkdownAST.CodeBlock("", sprint(show, MIME"text/plain"(), result))
            end
        end
        # TODO: make result a child node
        node.element = EvalNode(x, result)
    end
    return
end

# @index
# ------

function Selectors.runner(::Type{Expanders.IndexBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element

    indexnode = Documenter.buildnode(Documenter.IndexNode, x, doc, page)
    push!(doc.internal.indexnodes, indexnode)
    node.element = indexnode
    return
end

# @contents
# ---------

function Selectors.runner(::Type{Expanders.ContentsBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element

    contentsnode = Documenter.buildnode(Documenter.ContentsNode, x, doc, page)
    push!(doc.internal.contentsnodes, contentsnode)
    node.element = contentsnode
    return
end

# @example
# --------

# Find if there is any format with color output.
function _any_color_fmt(doc)
    idx = findfirst(writer_supports_ansicolor, doc.user.format)
    idx === nothing && return false
    return doc.user.format[idx].ansicolor
end

# General fallback.
"""
    writer_supports_ansicolor(::Documenter.Writer)::Bool

Returns whether the writer supports ANSI-colored output (`true`) or not (`false`).

This is usually relevant in Documenter blocks that execute code, like `@example` or `@repl`.

If `true`, these blocks will call `show` on the returned Julia object with `color = true`.  If `false`, then show is called with `color=false`.
"""
writer_supports_ansicolor(::Writer) = false

function Selectors.runner(::Type{Expanders.ExampleBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element
    lines = Documenter.find_block_in_file(x.code, page.source)
    source = Documenter.locrepr(doc, page, lines)

    # parse codelang first, even in draft mode, to catch syntax errors
    success, name, d = parse_codeblock_args(
        "@example", x, doc, source;
        allowed_kwargs = [:continued, :ansicolor],
        bool_kwargs = [:continued, :ansicolor],
    )
    success || return

    # Bail early if in draft mode
    if Documenter.is_draft(doc, page)
        @debug "Skipping evaluation of @example block in draft mode:\n$(x.code)"
        create_draft_result!(node; blocktype = "@example")
        return
    end

    # The sandboxed module -- either a new one or a cached one from this page.
    sandbox = Documenter.get_sandbox_module!(page.globals.meta, "atexample", name; share_default_module = share_default_module(page))
    sym = nameof(sandbox)

    # "parse" keyword arguments to example
    continued = get(d, :continued, false)
    ansicolor = get(d, :ansicolor, nothing)
    if ansicolor === nothing
        ansicolor = _any_color_fmt(doc)
    end

    @debug "Evaluating @example block:\n$(x.code)"
    # Evaluate the code block. We redirect stdout/stderr to `buffer`.
    result, buffer = nothing, IOBuffer()
    if !continued # run the code
        # check if there is any code waiting
        if haskey(page.globals.meta, :ContinuedCode) && haskey(page.globals.meta[:ContinuedCode], sym)
            code = page.globals.meta[:ContinuedCode][sym] * '\n' * x.code
            delete!(page.globals.meta[:ContinuedCode], sym)
        else
            code = x.code
        end
        linenumbernode = LineNumberNode(
            lines === nothing ? 0 : lines.first, basename(page.source)
        )
        for (ex, str) in Documenter.parseblock(
                code, doc, page; keywords = false, linenumbernode, lines
            )
            c = IOCapture.capture(rethrow = InterruptException, color = ansicolor) do
                cd(page.workdir) do
                    Core.eval(sandbox, ex)
                end
            end
            Core.eval(sandbox, Expr(:global, Expr(:(=), :ans, QuoteNode(c.value))))
            result = c.value
            print(buffer, c.output)
            if c.error
                bt = Documenter.remove_common_backtrace(c.backtrace)
                @docerror(
                    doc, :example_block,
                    """
                    failed to run `@example` block in $(source)
                    ```$(x.info)
                    $(x.code)
                    ```
                    """, exception = (c.value, bt)
                )
                return
            end
        end
    else # store the continued code
        CC = get!(page.globals.meta, :ContinuedCode, Dict())
        CC[sym] = get(CC, sym, "") * '\n' * x.code
    end
    # Splice the input and output into the document.
    content = Node[]
    input = droplines(x.code)

    # Generate different  in different formats and let each writer select
    output = Base.invokelatest(Documenter.display_dict, result, context = :color => ansicolor)
    # Remove references to gensym'd module from text/plain
    m = MIME"text/plain"()
    if haskey(output, m)
        output[m] = remove_sandbox_from_output(output[m], sandbox)
    end

    # Only add content when there's actually something to add.
    isempty(input) || push!(content, Node(MarkdownAST.CodeBlock("julia", input)))
    if result === nothing
        stdouterr = Documenter.sanitise(buffer)
        stdouterr = remove_sandbox_from_output(stdouterr, sandbox)
        isempty(stdouterr) || push!(content, Node(Documenter.MultiOutputElement(Dict{MIME, Any}(MIME"text/plain"() => stdouterr))))
    elseif !isempty(output)
        push!(content, Node(Documenter.MultiOutputElement(output)))
    end
    # ... and finally map the original code block to the newly generated ones.
    node.element = Documenter.MultiOutput(x)
    append!(node.children, content)
    return
end

# Replace references to gensym'd module with Main
function remove_sandbox_from_output(str, sandbox::Module)
    return replace(str, Regex(("(Main\\.)?$(nameof(sandbox))")) => "Main")
end

# @repl
# -----

function Selectors.runner(::Type{Expanders.REPLBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element
    lines = Documenter.find_block_in_file(x.code, page.source)
    source = Documenter.locrepr(doc, page, lines)

    success, name, d = parse_codeblock_args(
        "@repl", x, doc, source;
        allowed_kwargs = [:ansicolor],
        bool_kwargs = [:ansicolor],
    )
    success || return

    # Bail early if in draft mode
    if Documenter.is_draft(doc, page)
        @debug "Skipping evaluation of @repl block in draft mode:\n$(x.code)"
        create_draft_result!(node; blocktype = "@repl")
        return
    end

    # The sandboxed module -- either a new one or a cached one from this page.
    sandbox = Documenter.get_sandbox_module!(page.globals.meta, "atexample", name; share_default_module = share_default_module(page))

    # "parse" keyword arguments to repl
    ansicolor = get(d, :ansicolor, nothing)
    if ansicolor === nothing
        ansicolor = _any_color_fmt(doc)
    end

    multicodeblock = MarkdownAST.CodeBlock[]
    linenumbernode = LineNumberNode(0, "REPL") # line unused, set to 0
    @debug "Evaluating @repl block:\n$(x.code)"
    for (ex, str) in Documenter.parseblock(
            x.code, doc, page; keywords = false, linenumbernode, lines
        )
        input = droplines(str)
        # Use the REPL softscope for REPLBlocks,
        # see https://github.com/JuliaLang/julia/pull/33864
        ex = REPL.softscope(ex)
        c = IOCapture.capture(rethrow = InterruptException, color = ansicolor) do
            cd(page.workdir) do
                Core.eval(sandbox, ex)
            end
        end
        Core.eval(sandbox, Expr(:global, Expr(:(=), :ans, QuoteNode(c.value))))
        result = c.value
        buf = IOContext(IOBuffer(), :color => ansicolor)
        output = if !c.error
            hide = REPL.ends_with_semicolon(input)
            result_to_string(buf, hide ? nothing : c.value)
        else
            error_to_string(buf, c.value, [])
        end
        if !isempty(input)
            push!(multicodeblock, MarkdownAST.CodeBlock("julia-repl", prepend_prompt(input)))
        end
        out = IOBuffer()
        print(out, c.output) # c.output is std(out|err)
        if isempty(input) || isempty(output)
            println(out)
        else
            println(out, output, "\n")
        end

        outstr = String(take!(out))
        # Replace references to gensym'd module with Main
        outstr = rstrip(remove_sandbox_from_output(outstr, sandbox))
        !isempty(outstr) && push!(multicodeblock, MarkdownAST.CodeBlock("documenter-ansi", outstr))
    end
    node.element = Documenter.MultiCodeBlock(x, "julia-repl", [])
    for element in multicodeblock
        push!(node.children, Node(element))
    end
    return
end

# @setup
# ------

function Selectors.runner(::Type{Expanders.SetupBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element
    lines = Documenter.find_block_in_file(x.code, page.source)
    source = Documenter.locrepr(doc, page, lines)

    # parse codelang first, even in draft mode, to catch syntax errors
    success, name, d = parse_codeblock_args("@setup", x, doc, source)
    success || return
    if name === nothing
        @warn "In $source: `@setup` block requires a name."
    end

    # Bail early if in draft mode
    if Documenter.is_draft(doc, page)
        @debug "Skipping evaluation of @setup block in draft mode:\n$(x.code)"
        create_draft_result!(node; blocktype = "@setup")
        return
    end

    # The sandboxed module -- either a new one or a cached one from this page.
    sandbox = Documenter.get_sandbox_module!(page.globals.meta, "atexample", name; share_default_module = share_default_module(page))

    @debug "Evaluating @setup block:\n$(x.code)"
    # Evaluate whole @setup block at once instead of piecewise
    try
        cd(page.workdir) do
            include_string(sandbox, x.code)
        end
    catch err
        @docerror(
            doc, :setup_block,
            """
            failed to run `@setup` block in $(source)
            ```$(x.info)
            $(x.code)
            ```
            """, exception = err
        )
    end
    node.element = Documenter.SetupNode(x.info, x.code)
    return
end

# @raw
# ----

function Selectors.runner(::Type{Expanders.RawBlocks}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock
    x = node.element
    lines = Documenter.find_block_in_file(x.code, page.source)
    source = Documenter.locrepr(doc, page, lines)

    success, name, d = parse_codeblock_args("@raw", x, doc, source)
    success || return
    name === nothing && error("invalid '@raw <name>' syntax: $(x.info)")
    node.element = Documenter.RawNode(Symbol(name), x.code)
    return
end

# Documenter.
# ----------

iscode(node::Node, lang) = iscode(node.element, lang)
iscode(x::MarkdownAST.CodeBlock, r::Regex) = occursin(r, x.info)
iscode(x::MarkdownAST.CodeBlock, lang) = x.info == lang
iscode(x, lang) = false

# Matches the destination of an `@id` link, both for named headers (`# [H](@id name)`,
# handled by TrackHeaders) and for inline anchors on arbitrary content (handled by
# collect_named_anchors!).
const NAMED_ANCHOR_REGEX = r"^@id (.+)$"

function namedheader(node::Node)
    @assert node.element isa MarkdownAST.Heading
    if length(node.children) == 1 && first(node.children).element isa MarkdownAST.Link
        url = first(node.children).element.destination
        return occursin(NAMED_ANCHOR_REGEX, url)
    else
        return false
    end
end

# Walk the whole page tree and turn every `[content](@id name)` link on non-header content
# into an `AnchoredInline`, registering the anchor in `doc.internal.anchors`. Sharing that
# AnchorMap with headers gives all `@id` anchors a single id namespace (so collisions are
# caught by the existing uniqueness checks), lets them resolve through the existing `@ref`
# header pipeline, and gets them written to the `objects.inv` inventory automatically.
function collect_named_anchors!(page, doc)
    for node in AbstractTrees.PreOrderDFS(page.mdast)
        node.element isa MarkdownAST.Link || continue
        m = match(NAMED_ANCHOR_REGEX, node.element.destination)
        isnothing(m) && continue
        # Links that are the sole child of a Heading are header anchors, handled (and removed
        # from the tree) by TrackHeaders; guard against re-registering one here.
        parent = node.parent
        if !isnothing(parent) && parent.element isa MarkdownAST.Heading && length(parent.children) == 1
            continue
        end
        # Slugify the id exactly as TrackHeaders does for named headers, so that inline and
        # header `@id` anchors share identical id semantics (and never emit an invalid HTML
        # id, e.g. one containing spaces).
        id = Documenter.slugify(String(m[1]))
        # The anchor and the element carrying it are mutually referential, so the anchor is
        # registered with no object and told about the AnchoredInline once that exists.
        anchor = Documenter.anchor_add!(doc.internal.anchors, nothing, id, page.build)
        element = Documenter.AnchoredInline(anchor)
        anchor.object = element
        node.element = element
        anchor.node = node
    end
    return
end

# Remove any `# hide` lines, leading/trailing blank lines, and trailing whitespace.
function droplines(code; skip = 0)
    buffer = IOBuffer()
    for line in split(code, r"\r?\n")[(skip + 1):end]
        occursin(r"^(.*)#\s*hide$", line) && continue
        println(buffer, rstrip(line))
    end
    return strip(String(take!(buffer)), '\n')
end

function prepend_prompt(input)
    prompt = "julia> "
    padding = " "^length(prompt)
    out = IOBuffer()
    for (n, line) in enumerate(split(input, '\n'))
        line = rstrip(line)
        println(out, n == 1 ? prompt : padding, line)
    end
    return rstrip(String(take!(out)))
end

function create_docsnode(docstrings, results, object, page, doc)
    # Generate a unique name to be used in anchors and links for the docstring.
    slug = Documenter.slugify(object)
    anchor = Documenter.anchor_add!(doc.internal.docs, object, slug, page.build)
    docsnode = DocsNode(anchor, object, page)
    # Convert docstring to MarkdownAST, convert Heading elements, and push to DocsNode
    for (markdown, result) in zip(docstrings, results)
        ast = convert(Node, markdown)
        doc.user.highlightsig && highlightsig!(ast)
        recursive_heading_to_bold!(ast)
        push!(docsnode.mdasts, ast)
        push!(docsnode.results, result)
        push!(docsnode.metas, markdown.meta)
    end
    return Node(docsnode)
end

function highlightsig!(node::Node)
    @assert node.element isa MarkdownAST.Document
    MarkdownAST.haschildren(node) || return
    node = first(node.children)
    if node.element isa MarkdownAST.CodeBlock && isempty(node.element.info)
        node.element.info = "julia"
    end
    return
end

function recursive_heading_to_bold!(ast::MarkdownAST.Node)
    for node in ast.children
        if node.element isa MarkdownAST.List
            for child in node.children
                recursive_heading_to_bold!(child)
            end
        end
        if !(node.element isa MarkdownAST.Heading)
            continue
        end
        # node is a headingnode
        boldnode = Node(MarkdownAST.Strong())
        for textnode in collect(node.children)
            push!(boldnode.children, textnode)
        end
        node.element = MarkdownAST.Paragraph()
        push!(node.children, boldnode)
    end
    return
end

# Negative test: module with syntax version set to 1.13
# Verifies that the parser actually respects the older syntax version

module SyntaxVersioning13

Base.Experimental.@set_syntax_version v"1.13"

"""
Verify that the syntax version is 1.13, not 1.14.

```jldoctest
julia> (Base.Experimental.@VERSION).syntax == v"1.13"
true
```
"""
function check_syntax_version end

end # module

using Test
import Documenter
include("TestUtilities.jl"); using Main.TestUtilities

function testset_include(filename; quietly = false)
    return @testset "$filename" begin
        if quietly
            @quietly include(filename)
        else
            include(filename)
        end
    end
end

@testset "Documenter" begin
    # Build the example docs
    @info "Building example/make.jl"
    include("examples/make.jl")

    # Build the symlinked example docs
    @info "Building symlinks/make.jl"
    include("symlinks/tests.jl")

    # Test missing docs
    @info "Building missingdocs/make.jl"
    include("missingdocs/make.jl")

    # Test @ref fallback to Main for fully qualified names
    @info "Building docsxref/make.jl"
    include("docsxref/make.jl")

    # Test cross-references with method arguments
    @info "Building xref_signatures/make.jl"
    include("xref_signatures/make.jl")

    # Test that a non-unique header slug is reported and never resolved as a binding
    @info "Building duplicate_headers/make.jl"
    include("duplicate_headers/make.jl")

    # Warnings
    @info "Building warnings/make.jl"
    include("warnings/make.jl")

    # Error reporting.
    @info "Building errors/make.jl"
    @quietly include("errors/make.jl")

    # Plugin API
    @info "Building plugins/make.jl"
    @quietly include("plugins/make.jl")

    # Unit tests for module internals.
    include("except.jl")
    include("utilities.jl")

    # Remote repository link handling
    include("remotes.jl")
    testset_include("repolinks.jl")

    # DocChecks tests
    include("docchecks.jl")

    # NavNode tests.
    include("navnode.jl")

    # DocSystem unit tests.
    include("docsystem.jl")

    # CrossReferences
    include("crossreferences.jl")

    # DocTest unit tests.
    @info "Running tests in doctests/"
    include("doctests/docmeta.jl")
    include("doctests/doctestapi.jl")
    include("doctests/doctests.jl")
    include("doctests/fix/tests.jl")
    include("doctests/syntax_versioning.jl")

    # DOM Tests.
    include("dom.jl")

    # MDFlatten tests.
    include("mdflatten.jl")

    # Main build pipeline (Builder and Expanders modules)
    include("pipeline.jl")

    # HTMLWriter
    include("htmlwriter.jl")

    # LaTeXWriter
    include("latexwriter.jl")

    # Deployment configurations
    include("deployconfig.jl")
    include("deploydocs.jl")

    # Mock package docs.
    include("examples/tests.jl")

    # A simple build outside of a Git repository
    @info "Building nongit/tests.jl"
    @quietly include("nongit/tests.jl")

    # A simple build evaluating code outside build directory
    @info "Building workdir/tests.jl"
    @quietly include("workdir/tests.jl")

    # A simple build verifying that sandbox modules are cleared at the end of each page
    @info "Building clear_module/tests.jl"
    @quietly include("clear_module/tests.jl")

    # A simple build verifying that default meta data for pages works
    @info "Building default_meta/tests.jl"
    @quietly include("default_meta/tests.jl")

    # Passing a writer positionally (https://github.com/JuliaDocs/Documenter.jl/issues/1046)
    @test_throws MethodError makedocs(sitename = "", HTML())

    # Running doctest() on our own manual
    @info "doctest() Documenter's manual"
    @quietly include("manual.jl")
end

using Documenter
using Test

const pages = [
    "Home" => "index.md",
]

makedocs(sitename = "Test", pages = pages, doctest = true)

@testset "clear_modules!" begin
    # force a full GC
    GC.gc(true)
    # check that the finalizer was run
    @test Main.finalizer_count[1] == 1
end

"""
`f` from page `a.jl`.

Links:

- [`deepcopy`](@ref)
- [`while`](@ref)
- [`@eval(x)`](@ref)
- [`T(x)`](@ref)
- [`T(x, y)`](@ref)
- [`f(::Integer)`](@ref)
- [`f(::Any)`](@ref)
- [`f(::Any, ::Any)`](@ref)
- [`f(x, y, z)`](@ref)

[^footnote]:

    Footnote contents. [^footnote]

"""
f(x) = x

# Tests for syntax versioning support in doctests
#
# These tests verify that modules with syntax version set via
# Base.Experimental.@set_syntax_version have their doctests parsed
# with the correct syntax version.

module SyntaxVersioningTests
using Test
using Documenter
import IOCapture

function run_doctest(; modules = Module[], mdfiles = String[])
    builds_directory = mktempdir()
    srcdir = joinpath(builds_directory, "src")
    mkpath(srcdir)
    touch(joinpath(srcdir, "index.md"))
    for mdfile in mdfiles
        cp(joinpath(@__DIR__, "src", mdfile), joinpath(srcdir, mdfile))
    end
    c = IOCapture.capture(rethrow = InterruptException) do
        withenv("JULIA_DEBUG" => "") do
            makedocs(
                sitename = " ",
                format = Documenter.HTML(edit_link = nothing),
                root = builds_directory,
                modules = modules,
                pages = isempty(mdfiles) ? Documenter.Page[] : mdfiles,
                remotes = nothing,
                checkdocs = :none,
                doctest = true,
                warnonly = false,
            )
        end
    end
    if c.error
        @error "Doctest failed" output = c.output
    end
    return @test !c.error
end

# Only run these tests on Julia 1.14+ where syntax versioning is available
@testset "Syntax Versioning" begin
    if !isdefined(Base, :VersionedParse)
        @info "Skipping syntax versioning tests: requires Julia 1.14+"
        @test_skip false
    else
        include("src/SyntaxVersioning.jl")
        include("src/SyntaxVersioning13.jl")

        @testset "Module with @set_syntax_version v\"1.14\"" begin
            run_doctest(modules = [SyntaxVersioning])
        end

        @testset "Module with @set_syntax_version v\"1.13\" (negative)" begin
            run_doctest(modules = [SyntaxVersioning13])
        end

        @testset "Markdown with syntax= attribute" begin
            run_doctest(mdfiles = ["syntax_versioning.md"])
        end
    end
end

end # module

using Statistics
using Dates
using PrettyTables
using Crayons
using JSON

# This block ensures that the query file is loaded before evaluate.jl
# It finds the query file path from the command line arguments.
let
    query_file_path = ""
    for arg in ARGS
        if endswith(arg, ".jl")
            # Basic check to find the query file argument.
            # This assumes it's the first .jl file in the arguments.
            query_file_path = arg
            break
        end
    end
    if !isempty(query_file_path) && isfile(query_file_path)
        include(query_file_path)
    end
end

include(joinpath(@__DIR__, "evaluate.jl"))
include(joinpath(@__DIR__, "real_search.jl"))

function load_reference_values(query_file_path::String)
    # Determine reference file based on query file
    if endswith(query_file_path, "edge_case_queries.jl")
        reference_file = joinpath(@__DIR__, "edge_case_benchmark_reference.json")
    else
        reference_file = joinpath(@__DIR__, "search_benchmark_reference.json")
    end

    if isfile(reference_file)
        return JSON.parsefile(reference_file; dicttype = Dict{String, Any})
    else
        return Dict()
    end
end

function write_detailed_results(results::EvaluationResults, category::String, io::IO)
    println(io, "\n== $category ==")
    summary_data = [
        string("Average Precision")  string(round(results.average_precision * 100, digits = 1));
        string("Average Recall")     string(round(results.average_recall * 100, digits = 1));
        string("Average F1 Score")   string(round(results.average_f1_score * 100, digits = 1));
        string("Total Relevant Found") string(results.total_relevant_found);
        string("Total Documents Retrieved") string(results.total_documents_retrieved);
        string("Total Relevant Documents") string(results.total_relevant_documents)
    ]
    pretty_table(io, summary_data, header = ["Metric", "Value"]; alignment = :l)

    println(io, "\nDetailed Results:")
    detailed_data = Matrix{String}(undef, length(results.individual_results), 9)
    for (i, result) in enumerate(results.individual_results)
        detailed_data[i, 1] = string(result.query)
        detailed_data[i, 2] = string(round(result.precision * 100, digits = 1))
        detailed_data[i, 3] = string(round(result.recall * 100, digits = 1))
        detailed_data[i, 4] = string(round(result.f1 * 100, digits = 1))
        detailed_data[i, 5] = string(result.relevant_count)
        detailed_data[i, 6] = string(result.total_retrieved)
        detailed_data[i, 7] = string(result.total_relevant)
        detailed_data[i, 8] = string(first(result.expected, 5))
        detailed_data[i, 9] = string(result.actual)
    end
    pretty_table(io, detailed_data, header = ["Query", "Precision (%)", "Recall (%)", "F1 (%)", "Relevant Found", "Total Retrieved", "Total Relevant", "Expected", "Actual"]; alignment = :l)
    return
end

function run_benchmarks(search_index_path::String, query_file_path::String, overall_queries_name::String)
    println("Running search benchmarks for $query_file_path...")

    reference_values = load_reference_values(query_file_path)

    overall_queries = getfield(Main, Symbol(overall_queries_name))
    all_results = evaluate_all(real_search, overall_queries, search_index_path)

    println("\n== Overall Results for $query_file_path ==")

    function get_color_for_percentage(value)
        if value >= 80.0
            return crayon"green"
        elseif value >= 60.0
            return crayon"yellow"
        elseif value >= 40.0
            return crayon"red"
        else
            return crayon"bold red"
        end
    end

    precision_val = round(all_results.average_precision * 100, digits = 1)
    recall_val = round(all_results.average_recall * 100, digits = 1)
    f1_val = round(all_results.average_f1_score * 100, digits = 1)

    precision_ref = get(reference_values, "average_precision", 0.0)
    recall_ref = get(reference_values, "average_recall", 0.0)
    f1_ref = get(reference_values, "average_f1_score", 0.0)

    precision_diff = precision_val - precision_ref
    recall_diff = recall_val - recall_ref
    f1_diff = f1_val - f1_ref

    function get_color_for_diff(diff)
        if diff > 0
            return crayon"green"
        elseif diff < 0
            return crayon"red"
        else
            return crayon"default"
        end
    end

    summary_data = [
        "Average Precision" precision_val precision_ref string(round(precision_diff, digits = 1));
        "Average Recall" recall_val recall_ref string(round(recall_diff, digits = 1));
        "Average F1 Score" f1_val f1_ref string(round(f1_diff, digits = 1));
        "Total Relevant Found" all_results.total_relevant_found "" "";
        "Total Documents Retrieved" all_results.total_documents_retrieved "" "";
        "Total Relevant Documents" all_results.total_relevant_documents "" ""
    ]

    precision_highlighter = Highlighter((data, i, j) -> i == 1 && j == 2, get_color_for_percentage(precision_val))
    recall_highlighter = Highlighter((data, i, j) -> i == 2 && j == 2, get_color_for_percentage(recall_val))
    f1_highlighter = Highlighter((data, i, j) -> i == 3 && j == 2, get_color_for_percentage(f1_val))

    pretty_table(
        summary_data, header = ["Metric", "Value", "Reference", "Diff"], alignment = :l,
        header_crayon = crayon"bold blue",
        highlighters = (
            precision_highlighter,
            recall_highlighter,
            f1_highlighter,
            Highlighter((data, i, j) -> j == 4 && i == 1, get_color_for_diff(precision_diff)),
            Highlighter((data, i, j) -> j == 4 && i == 2, get_color_for_diff(recall_diff)),
            Highlighter((data, i, j) -> j == 4 && i == 3, get_color_for_diff(f1_diff)),
        )
    )

    timestamp = Dates.format(now(), "yyyy-mm-dd_HH-MM-SS")
    query_file_name = basename(query_file_path)
    results_file = joinpath(@__DIR__, "search_benchmark_results_$(query_file_name)_$(timestamp).txt")

    open(results_file, "w") do io
        println(io, "Search Benchmark Results for $query_file_path - $(timestamp)")
        write_detailed_results(all_results, "Overall Results", io)
    end

    println("\nDetailed results have been written to: $results_file")

    return all_results
end

function main()
    if length(ARGS) != 3
        println("Usage: julia run_benchmarks.jl <path_to_search_index.js> <path_to_query_file.jl> <overall_queries_name>")
        exit(1)
    end
    search_index_path = ARGS[1]
    query_file_path = ARGS[2]
    overall_queries_name = ARGS[3]

    return run_benchmarks(search_index_path, query_file_path, overall_queries_name)
end

if abspath(PROGRAM_FILE) == @__FILE__
    main()
end

module XRefSignatures

# Testing the method signature lookup behaviour (with UnionAll) as described in
# https://github.com/JuliaDocs/Documenter.jl/pull/2889

using Test
using Documenter
using IOCapture

include("../TestUtilities.jl"); using Main.TestUtilities

module XRefSignaturesContent
    """
        g

    This is the general function `g`.
    """
    function g end

    """
        g(::Float64)

    This is the specialized method of `g` with signature (::Float64)

    See also [parametric `g`](@ref g(::X) where X).

    See also [parametric array `g`](@ref g(::AbstractArray{S}) where S <: Number).
    """
    g(::Float64) = "Specialized to Float64."

    """
        g(::X) where {X}

    This is a parametric method `g`, with UnionAll signature (::X) where X

    See also [specialized `g`](@ref g(::Float64)).
    """
    function g(::X) where {X}
        return "Parametric method $(nameof(X))."
    end

    """
        g(::AbstractArray{T}) where {T <: Number}

    This is another parametric method `g`, this time with a constrained type parameter.

    See also [plain parametric `g`](@ref g(::X) where X).
    """
    function g(::AbstractArray{T}) where {T <: Number}
        return "Numerical array method $(nameof(T))."
    end

    export g
end

@testset "Cross-referencing methods" begin
    kwargs = (
        root = dirname(@__FILE__),
        source = "src",
        build = "build",
        modules = [Main.XRefSignatures.XRefSignaturesContent],
        sitename = "XRefSignatures",
        warnonly = false,
        format = Documenter.HTML(
            prettyurls = false,
            inventory_version = "",
        ),
    )

    @quietly makedocs(; kwargs...)

    index_html = joinpath(dirname(@__FILE__), "build", "index.html")
    @test isfile(index_html)
    if isfile(index_html)
        html = read(index_html, String)

        # Find anchor name for docstring containing AbstractArray (this differs between Julia 1.6 and 1.12!)
        array_anchor_pattern = r"""<a\s+class="docstring-binding"\s+href="([^"]*AbstractArray[^"]*)"[^>]*>\s*<code>Main\.XRefSignatures.XRefSignaturesContent\.g</code>\s*</a>"""x
        array_anchor_rx = match(array_anchor_pattern, html)
        @test !isnothing(array_anchor_rx)
        array_anchor = array_anchor_rx.captures[1]

        # Body -> API xref
        @test contains(html, """<a href="index.html#Main.XRefSignatures.XRefSignaturesContent.g-Tuple{Float64}">specialized methods</a>""")
        @test contains(html, """<a href="index.html#Main.XRefSignatures.XRefSignaturesContent.g-Tuple{X} where X">parametric methods</a>""")
        @test contains(html, """<a href="index.html$(array_anchor)">constrained parametric methods</a>""")
        @test contains(html, """<a href="index.html#Main.XRefSignatures.XRefSignaturesContent.g-Tuple{X} where X"><code>g(::Y) where Y</code></a>""")

        # API -> API xref
        @test contains(html, """See also <a href="index.html#Main.XRefSignatures.XRefSignaturesContent.g-Tuple{X} where X">parametric <code>g</code></a>""")
        @test contains(html, """See also <a href="index.html$(array_anchor)">parametric array <code>g</code></a>""")
        @test contains(html, """See also <a href="index.html#Main.XRefSignatures.XRefSignaturesContent.g-Tuple{Float64}">specialized <code>g</code></a>""")
        @test contains(html, """See also <a href="index.html#Main.XRefSignatures.XRefSignaturesContent.g-Tuple{X} where X">plain parametric <code>g</code></a>""")
    end
end

end

module DocstringLinkTests
using Test
using Documenter
import IOCapture


module InvalidLinks
    export f

    """Link to [invalid](http://domain.invalid/docstring.html)"""
    f(x) = x

end


@testset "invalid links in docstring" begin
    c = IOCapture.capture(; rethrow = Union{}) do
        makedocs(;
            root = dirname(@__FILE__),
            modules = InvalidLinks,
            sitename = "InvalidLinks Checks",
            warnonly = false,
            linkcheck = true,
            debug = false
        )
    end
    @test contains(c.output, r"Error:.*http://domain.invalid/index.html")
    @test contains(c.output, r"Error:.*http://domain.invalid/docstring.html")
    @test c.value isa ErrorException
    @test contains(c.value.msg, "`makedocs` encountered an error [:linkcheck]")
end

end

"""
An extensible code selection interface.

The `Selectors` module provides an extensible way to write code that has to dispatch on
different predicates without hardcoding the control flow into a single chain of `if`
statements.

In the following example a selector for a simple condition is implemented and the generated
selector code is described:

```julia
abstract type MySelector <: Selectors.AbstractSelector end

# The different cases we want to test.
abstract type One    <: MySelector end
abstract type NotOne <: MySelector end

# The order in which to test the cases.
Selectors.order(::Type{One})    = 0.0
Selectors.order(::Type{NotOne}) = 1.0

# The predicate to test against.
Selectors.matcher(::Type{One}, x)    = x === 1
Selectors.matcher(::Type{NotOne}, x) = x !== 1

# What to do when a test is successful.
Selectors.runner(::Type{One}, x)    = println("found one")
Selectors.runner(::Type{NotOne}, x) = println("not found")

# Test our selector with some numbers.
for i in 0:5
    Selectors.dispatch(MySelector, i)
end
```

`Selectors.dispatch(Selector, i)` will behave equivalent to the following:

```julia
function dispatch(::Type{MySelector}, i::Int)
    if matcher(One, i)
        runner(One, i)
    elseif matcher(NotOne, i)
        runner(NotOne, i)
    end
end
```

and further to

```julia
function dispatch(::Type{MySelector}, i::Int)
    if i === 1
        println("found one")
    elseif i !== 1
        println("not found")
    end
end
```

The module provides the following interface for creating selectors:

- [`order`](@ref)
- [`matcher`](@ref)
- [`runner`](@ref)
- [`strict`](@ref)
- [`disable`](@ref)
- [`dispatch`](@ref)

"""
module Selectors

import InteractiveUtils: subtypes

"""
Root selector type. Each user-defined selector must subtype from this, i.e.

```julia
abstract type MySelector <: Selectors.AbstractSelector end

abstract type First  <: MySelector end
abstract type Second <: MySelector end
```
"""
abstract type AbstractSelector end

"""
Define the precedence of each case in a selector, i.e.

```julia
Selectors.order(::Type{First})  = 1.0
Selectors.order(::Type{Second}) = 2.0
```

Note that the return type must be `Float64`. Defining multiple case types to have the same
order will result in undefined behaviour.
"""
function order end

"""
Define the matching test for each case in a selector, i.e.

```julia
Selectors.matcher(::Type{First}, x)  = x == 1
Selectors.matcher(::Type{Second}, x) = true
```

Note that the return type must be `Bool`.

To match against multiple cases use the [`Selectors.strict`](@ref) function.
"""
function matcher end

"""
Define the code that will run when a particular [`Selectors.matcher`](@ref) test returns
`true`, i.e.

```julia
Selectors.runner(::Type{First}, x)  = println("`x` is equal to `1`.")
Selectors.runner(::Type{Second}, x) = println("`x` is not equal to `1`.")
```
"""
function runner end

"""
Define whether a selector case will "fallthrough" or not when successfully matched against.
By default matching is strict and does not fallthrough to subsequent selector cases.

```julia
# Adding a debugging selector case.
abstract type Debug <: MySelector end

# Insert prior to all other cases.
Selectors.order(::Type{Debug}) = 0.0

# Fallthrough to the next case on success.
Selectors.strict(::Type{Debug}) = false

# We always match, regardless of the value of `x`.
Selectors.matcher(::Type{Debug}, x) = true

# Print some debugging info.
Selectors.runner(::Type{Debug}, x) = @show x
```
"""
strict(::Type{T}) where {T <: AbstractSelector} = true

"""
Disable a particular case in a selector so that it is never used.

```julia
Selectors.disable(::Type{Debug}) = true
```
"""
disable(::Type{T}) where {T <: AbstractSelector} = false

"""
Call `Selectors.runner(T, args...)` where `T` is a subtype of
`MySelector` for which `matcher(T, args...)` is `true`.

```julia
Selectors.dispatch(MySelector, args...)
```
"""
function dispatch(::Type{T}, x...) where {T <: AbstractSelector}
    types = get!(selector_subtypes, T) do
        sort(leaf_subtypes(T); by = order)
    end
    for t in types
        if !disable(t) && matcher(t, x...)
            runner(t, x...)
            strict(t) && return
        end
    end
    return runner(T, x...)
end

"""
Return a list of all subtypes of `T` which do not have further subtypes.

The returned list includes subtypes of subtypes, and it does not distinguish
between concrete types (i.e. types which are guaranteed not to have subtypes)
and abstract types (which may or may not have subtypes).
"""
function leaf_subtypes(::Type{T}) where {T}
    stack = Type[T]
    leaves = Type[]
    while !isempty(stack)
        t = pop!(stack)
        s = subtypes(t)
        if length(s) == 0
            push!(leaves, t)
        else
            append!(stack, s)
        end
    end
    return leaves
end

# Under certain circumstances, the function `subtypes` can be very slow
# (https://github.com/JuliaLang/julia/issues/38079), so to ensure that
# `dispatch` remains fast we cache the results of `subtypes` here.
const selector_subtypes = Dict{Type, Vector}()

end

using Logging

@testset "Travis CI deploy configuration" begin
    with_logger(NullLogger()) do
        # Regular tag build
        withenv(
            "TRAVIS_CI" => "true",
            "TRAVIS_PULL_REQUEST" => "false",
            "TRAVIS_REPO_SLUG" => "JuliaDocs/Documenter.jl",
            "TRAVIS_BRANCH" => "master",
            "TRAVIS_TAG" => "v1.2.3",
            "TRAVIS_EVENT_TYPE" => nothing,
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Travis()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
            @test Documenter.authentication_method(cfg) === Documenter.SSH
        end
        # Regular tag build with tag prefix
        withenv(
            "TRAVIS_CI" => "true",
            "TRAVIS_PULL_REQUEST" => "false",
            "TRAVIS_REPO_SLUG" => "JuliaDocs/Documenter.jl",
            "TRAVIS_BRANCH" => "master",
            "TRAVIS_TAG" => "MySubPackage-v1.2.3",
            "TRAVIS_EVENT_TYPE" => nothing,
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Travis()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", tag_prefix = "MySubPackage-",
                devurl = "dev", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
            @test Documenter.authentication_method(cfg) === Documenter.SSH
        end
        # Broken tag build
        withenv(
            "TRAVIS_CI" => "true",
            "TRAVIS_PULL_REQUEST" => "false",
            "TRAVIS_REPO_SLUG" => "JuliaDocs/Documenter.jl",
            "TRAVIS_BRANCH" => "master",
            "TRAVIS_TAG" => "not-a-version",
            "TRAVIS_EVENT_TYPE" => nothing,
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Travis()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test !d.all_ok
        end
        # Regular/broken devbranch build
        withenv(
            "TRAVIS_CI" => "true",
            "TRAVIS_PULL_REQUEST" => "false",
            "TRAVIS_REPO_SLUG" => "JuliaDocs/Documenter.jl",
            "TRAVIS_BRANCH" => "master",
            "TRAVIS_TAG" => nothing,
            "TRAVIS_EVENT_TYPE" => nothing,
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Travis()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "hello-world"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "not-master", devurl = "hello-world", push_preview = true
            )
            @test !d.all_ok
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
        end
        # Regular pull request build
        withenv(
            "TRAVIS_CI" => "true",
            "TRAVIS_PULL_REQUEST" => "42",
            "TRAVIS_REPO_SLUG" => "JuliaDocs/Documenter.jl",
            "TRAVIS_BRANCH" => "something",
            "TRAVIS_TAG" => nothing,
            "TRAVIS_EVENT_TYPE" => nothing,
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Travis()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "previews/PR42"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = false
            )
            @test !d.all_ok
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
        end
        # Missing/broken environment variables
        withenv(
            "TRAVIS_CI" => "true",
            "TRAVIS_PULL_REQUEST" => "false",
            "TRAVIS_REPO_SLUG" => "JuliaDocs/Documenter.jl",
            "TRAVIS_BRANCH" => "master",
            "TRAVIS_TAG" => "v1.2.3",
            "TRAVIS_EVENT_TYPE" => nothing,
            "DOCUMENTER_KEY" => nothing,
        ) do
            cfg = Documenter.Travis()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = false
            )
            @test !d.all_ok
        end
    end
end

@testset "GitHub Actions deploy configuration" begin
    with_logger(NullLogger()) do
        # Regular tag build with GITHUB_TOKEN
        withenv(
            "GITHUB_EVENT_NAME" => "push",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/tags/v1.2.3",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
            "DOCUMENTER_KEY" => nothing,
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.authentication_method(cfg) === Documenter.HTTPS
            @test Documenter.authenticated_repo_url(cfg) === "https://github-actions:SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
        end
        # Regular tag build with SSH deploy key (SSH key prioritized)
        withenv(
            "GITHUB_EVENT_NAME" => "push",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/tags/v1.2.3",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.authentication_method(cfg) === Documenter.SSH
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
        end
        # External Repo: Regular tag build with SSH deploy key (SSH key prioritized)
        withenv(
            "GITHUB_EVENT_NAME" => "push",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/tags/v1.2.3",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.authentication_method(cfg) === Documenter.SSH
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
        end
        # Regular tag build GITHUB_EVENT_NAME `release`
        withenv(
            "GITHUB_EVENT_NAME" => "release",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/tags/v1.2.3+docs",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                deploy_repo = "github.com/JuliaDocs/DocumenterDocs.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/DocumenterDocs.jl.git"
            @test d.branch == "gh-pages"
        end
        # Regular tag build with GITHUB_TOKEN and with tag prefix
        withenv(
            "GITHUB_EVENT_NAME" => "push",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/tags/MySubPackage-v1.2.3",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
            "DOCUMENTER_KEY" => nothing,
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true,
                tag_prefix = "MySubPackage-"
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.authentication_method(cfg) === Documenter.HTTPS
            @test Documenter.authenticated_repo_url(cfg) === "https://github-actions:SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
        end
        # Broken tag build
        withenv(
            "GITHUB_EVENT_NAME" => "push",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/tags/not-a-version",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
            "DOCUMENTER_KEY" => nothing,
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test !d.all_ok
        end
        # Regular devbranch build with GITHUB_TOKEN
        withenv(
            "GITHUB_EVENT_NAME" => "push",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/heads/master",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
            "DOCUMENTER_KEY" => nothing,
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "hello-world"
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "not-master", devurl = "hello-world", push_preview = true
            )
            @test !d.all_ok
            @test Documenter.authentication_method(cfg) === Documenter.HTTPS
            @test Documenter.authenticated_repo_url(cfg) === "https://github-actions:SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
        end
        # Regular devbranch build with SSH deploy key (SSH key prioritized)
        withenv(
            "GITHUB_EVENT_NAME" => "push",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/heads/master",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "hello-world"
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "not-master", devurl = "hello-world", push_preview = true
            )
            @test !d.all_ok
            @test Documenter.authentication_method(cfg) === Documenter.SSH
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
        end

        # These tests requires GITHUB_TOKEN to be set (and valid) in order to verify the origin
        # of the PR. Only runs on CI.
        if get(ENV, "GITHUB_ACTIONS", nothing) == "true" && haskey(ENV, "GITHUB_TOKEN")
            # Regular pull request build with GITHUB_TOKEN
            withenv(
                "GITHUB_EVENT_NAME" => "pull_request",
                "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
                "GITHUB_REF" => "refs/pull/1962/merge",
                "GITHUB_ACTOR" => "github-actions",
                "DOCUMENTER_KEY" => nothing,
            ) do
                cfg = Documenter.GitHubActions()
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "master", devurl = "hello-world", push_preview = true
                )
                @test d.all_ok
                @test d.subfolder == "previews/PR1962"
                @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
                @test d.branch == "gh-pages"
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "not-master", devurl = "hello-world", push_preview = false
                )
                @test !d.all_ok
                @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                @test Documenter.authenticated_repo_url(cfg) == "https://github-actions:$(ENV["GITHUB_TOKEN"])@github.com/JuliaDocs/Documenter.jl.git"
            end
            # Regular pull request build with GITHUB_TOKEN, PR from a fork
            withenv(
                "GITHUB_EVENT_NAME" => "pull_request",
                "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
                "GITHUB_REF" => "refs/pull/1967/merge",
                "GITHUB_ACTOR" => "github-actions",
                "DOCUMENTER_KEY" => nothing,
            ) do
                cfg = Documenter.GitHubActions()
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "master", devurl = "hello-world", push_preview = true
                )
                @test !d.all_ok
            end
            # Regular pull request build with SSH deploy key (SSH key prioritized)
            withenv(
                "GITHUB_EVENT_NAME" => "pull_request",
                "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
                "GITHUB_REF" => "refs/pull/1962/merge",
                "GITHUB_ACTOR" => "github-actions",
                "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
            ) do
                cfg = Documenter.GitHubActions()
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "master", devurl = "hello-world", push_preview = true
                )
                @test d.all_ok
                @test d.subfolder == "previews/PR1962"
                @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
                @test d.branch == "gh-pages"
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "not-master", devurl = "hello-world", push_preview = false
                )
                @test !d.all_ok
                @test Documenter.authentication_method(cfg) === Documenter.SSH
                @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
            end
            # Regular pull request build with SSH deploy key (SSH key prioritized), but push previews to a different repo and different branch
            withenv(
                "GITHUB_EVENT_NAME" => "pull_request",
                "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
                "GITHUB_REF" => "refs/pull/1962/merge",
                "GITHUB_ACTOR" => "github-actions",
                "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
            ) do
                cfg = Documenter.GitHubActions()
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "master", devurl = "hello-world", push_preview = true,
                    repo_previews = "github.com/JuliaDocs/Documenter-previews.jl.git",
                    branch_previews = "gh-pages-previews"
                )
                @test d.all_ok
                @test d.subfolder == "previews/PR1962"
                @test d.repo == "github.com/JuliaDocs/Documenter-previews.jl.git"
                @test d.branch == "gh-pages-previews"
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "not-master", devurl = "hello-world", push_preview = false,
                    repo_previews = "",
                    branch_previews = ""
                )
                @test !d.all_ok
                @test Documenter.authentication_method(cfg) === Documenter.SSH
                @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
            end
            # Regular pull request build with SSH deploy key (SSH key prioritized), but push previews to a different repo and different branch; use a different deploy key for previews
            withenv(
                "GITHUB_EVENT_NAME" => "pull_request",
                "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
                "GITHUB_REF" => "refs/pull/1962/merge",
                "GITHUB_ACTOR" => "github-actions",
                "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
                "DOCUMENTER_KEY_PREVIEWS" => "SGVsbG8sIHdvcmxkLw==",
            ) do
                cfg = Documenter.GitHubActions()
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "master", devurl = "hello-world", push_preview = true,
                    repo_previews = "github.com/JuliaDocs/Documenter-previews.jl.git",
                    branch_previews = "gh-pages-previews"
                )
                @test d.all_ok
                @test d.subfolder == "previews/PR1962"
                @test d.repo == "github.com/JuliaDocs/Documenter-previews.jl.git"
                @test d.branch == "gh-pages-previews"
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "not-master", devurl = "hello-world", push_preview = false,
                    repo_previews = "",
                    branch_previews = ""
                )
                @test !d.all_ok
                @test Documenter.authentication_method(cfg) === Documenter.SSH
                @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
                @test Documenter.documenter_key_previews(cfg) === "SGVsbG8sIHdvcmxkLw=="
            end
            # External Repo: Regular pull request build with GITHUB_TOKEN
            withenv(
                "GITHUB_EVENT_NAME" => "pull_request",
                "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
                "GITHUB_REF" => "refs/pull/1962/merge",
                "GITHUB_ACTOR" => "github-actions",
                "DOCUMENTER_KEY" => nothing,
            ) do
                cfg = Documenter.GitHubActions()
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    deploy_repo = "github.com/JuliaDocs/DocumenterDocs.jl.git",
                    devbranch = "master", devurl = "hello-world", push_preview = true
                )
                @test d.all_ok
                @test d.subfolder == "previews/PR1962"
                @test d.repo == "github.com/JuliaDocs/DocumenterDocs.jl.git"
                @test d.branch == "gh-pages"
            end
            # External Repo: Regular pull request build with SSH deploy key (SSH key prioritized), but push previews to a different repo and different branch
            withenv(
                "GITHUB_EVENT_NAME" => "pull_request",
                "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
                "GITHUB_REF" => "refs/pull/1962/merge",
                "GITHUB_ACTOR" => "github-actions",
                "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
            ) do
                cfg = Documenter.GitHubActions()
                d = Documenter.deploy_folder(
                    cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                    devbranch = "master", devurl = "hello-world", push_preview = true,
                    repo_previews = "github.com/JuliaDocs/Documenter-previews.jl.git",
                    deploy_repo = "github.com/JuliaDocs/DocumenterDocs.jl.git",
                    branch_previews = "gh-pages-previews"
                )
                @test d.all_ok
                @test d.subfolder == "previews/PR1962"
                @test d.repo == "github.com/JuliaDocs/Documenter-previews.jl.git" # prioritize repo_previews
                @test d.branch == "gh-pages-previews"
            end
        end
        # Missing environment variables
        withenv(
            "GITHUB_EVENT_NAME" => "push",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/tags/v1.2.3",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => nothing,
            "DOCUMENTER_KEY" => nothing,
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = true
            )
            @test !d.all_ok
        end
    end
end

@testset "GitLab CI deploy configuration" begin
    with_logger(NullLogger()) do
        # Regular tag build
        withenv(
            "GITLAB_CI" => "true",
            "CI_COMMIT_BRANCH" => "master",
            "CI_EXTERNAL_PULL_REQUEST_IID" => "",
            "CI_PROJECT_PATH_SLUG" => "juliadocs-documenter-jl",
            "CI_COMMIT_TAG" => "v1.2.3",
            "CI_PIPELINE_SOURCE" => "push",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.GitLab()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
            @test Documenter.authentication_method(cfg) === Documenter.SSH
        end
        # Regular tag build with tag_prefix
        withenv(
            "GITLAB_CI" => "true",
            "CI_COMMIT_BRANCH" => "master",
            "CI_EXTERNAL_PULL_REQUEST_IID" => "",
            "CI_PROJECT_PATH_SLUG" => "juliadocs-documenter-jl",
            "CI_COMMIT_TAG" => "MySubPackage-v1.2.3",
            "CI_PIPELINE_SOURCE" => "push",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.GitLab()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true,
                tag_prefix = "MySubPackage-"
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
            @test Documenter.authentication_method(cfg) === Documenter.SSH
        end
        # Broken tag build
        withenv(
            "GITLAB_CI" => "true",
            "CI_COMMIT_BRANCH" => "master",
            "CI_EXTERNAL_PULL_REQUEST_IID" => "",
            "CI_PROJECT_PATH_SLUG" => "juliadocs-documenter-jl",
            "CI_COMMIT_TAG" => "not-a-version",
            "CI_PIPELINE_SOURCE" => "push",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.GitLab()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test !d.all_ok
        end
        # Regular/broken devbranch build
        withenv(
            "GITLAB_CI" => "true",
            "CI_COMMIT_BRANCH" => "master",
            "CI_EXTERNAL_PULL_REQUEST_IID" => "",
            "CI_PROJECT_PATH_SLUG" => "juliadocs-documenter-jl",
            "CI_COMMIT_TAG" => nothing,
            "CI_PIPELINE_SOURCE" => "push",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.GitLab()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "hello-world"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "not-master", devurl = "hello-world", push_preview = true
            )
            @test !d.all_ok
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
        end
        # Regular pull request build
        withenv(
            "GITLAB_CI" => "true",
            "CI_COMMIT_BRANCH" => "something",
            "CI_EXTERNAL_PULL_REQUEST_IID" => "42",
            "CI_PROJECT_PATH_SLUG" => "juliadocs-documenter-jl",
            "CI_COMMIT_TAG" => nothing,
            "CI_PIPELINE_SOURCE" => "push",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.GitLab()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "previews/PR42"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = false
            )
            @test !d.all_ok
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
        end
        # Missing/broken environment variables
        withenv(
            "GITLAB_CI" => "true",
            "CI_COMMIT_BRANCH" => "master",
            "CI_EXTERNAL_PULL_REQUEST_IID" => "",
            "CI_PROJECT_PATH_SLUG" => "juliadocs-documenter-jl",
            "CI_COMMIT_TAG" => "v1.2.3",
            "CI_PIPELINE_SOURCE" => "push",
            "DOCUMENTER_KEY" => nothing,
        ) do
            cfg = Documenter.GitLab()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = false
            )
            @test !d.all_ok
        end
        # Build on `schedule` jobs
        withenv(
            "GITHUB_EVENT_NAME" => "schedule",
            "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
            "GITHUB_REF" => "refs/tags/v1.2.3",
            "GITHUB_ACTOR" => "github-actions",
            "GITHUB_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
            "DOCUMENTER_KEY" => nothing,
        ) do
            cfg = Documenter.GitHubActions()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.authentication_method(cfg) === Documenter.HTTPS
            @test Documenter.authenticated_repo_url(cfg) === "https://github-actions:SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
        end
    end
end

@testset "Buildkite CI deploy configuration" begin
    with_logger(NullLogger()) do
        # Regular tag build
        withenv(
            "BUILDKITE" => "true",
            "BUILDKITE_BRANCH" => "master",
            "BUILDKITE_PULL_REQUEST" => "false",
            "BUILDKITE_TAG" => "v1.2.3",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Buildkite()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
            @test Documenter.authentication_method(cfg) === Documenter.SSH
        end
        # Regular tag build with tag_prefix
        withenv(
            "BUILDKITE" => "true",
            "BUILDKITE_BRANCH" => "master",
            "BUILDKITE_PULL_REQUEST" => "false",
            "BUILDKITE_TAG" => "MySubPackage-v1.2.3",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Buildkite()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true,
                tag_prefix = "MySubPackage-"
            )
            @test d.all_ok
            @test d.subfolder == "v1.2.3"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
            @test Documenter.authentication_method(cfg) === Documenter.SSH
        end
        # Broken tag build
        withenv(
            "BUILDKITE" => "true",
            "BUILDKITE_BRANCH" => "master",
            "BUILDKITE_PULL_REQUEST" => "false",
            "BUILDKITE_TAG" => "not-a-version",
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Buildkite()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "dev", push_preview = true
            )
            @test !d.all_ok
        end
        # Regular/broken devbranch build
        withenv(
            "BUILDKITE" => "true",
            "BUILDKITE_BRANCH" => "master",
            "BUILDKITE_PULL_REQUEST" => "false",
            "BUILDKITE_TAG" => nothing,
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Buildkite()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "hello-world"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "not-master", devurl = "hello-world", push_preview = true
            )
            @test !d.all_ok
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
        end
        # Regular pull request build
        withenv(
            "BUILDKITE" => "true",
            "BUILDKITE_BRANCH" => "something",
            "BUILDKITE_PULL_REQUEST" => "42",
            "BUILDKITE_TAG" => nothing,
            "DOCUMENTER_KEY" => "SGVsbG8sIHdvcmxkLg==",
        ) do
            cfg = Documenter.Buildkite()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = true
            )
            @test d.all_ok
            @test d.subfolder == "previews/PR42"
            @test d.repo == "github.com/JuliaDocs/Documenter.jl.git"
            @test d.branch == "gh-pages"
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = false
            )
            @test !d.all_ok
            @test Documenter.documenter_key(cfg) === "SGVsbG8sIHdvcmxkLg=="
        end
        # Missing/broken environment variables
        withenv(
            "BUILDKITE" => "true",
            "BUILDKITE_BRANCH" => "master",
            "BUILDKITE_PULL_REQUEST" => "false",
            "BUILDKITE_TAG" => "v1.2.3",
            "DOCUMENTER_KEY" => nothing,
        ) do
            cfg = Documenter.Buildkite()
            d = Documenter.deploy_folder(
                cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
                devbranch = "master", devurl = "hello-world", push_preview = false
            )
            @test !d.all_ok
        end
    end
end

@testset "Woodpecker CI deploy configuration" begin
    with_logger(NullLogger()) do
        @testset "Woodpecker 0.15.x" begin
            with_logger(NullLogger()) do
                # Regular tag build with PROJECT_ACCESS_TOKEN
                withenv(
                    "CI_SYSTEM_VERSION" => "0.15.0",
                    "CI_BUILD_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO_LINK" => "https://github.com/JuliaDocs/Documenter.jl",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/v1.2.3",
                    "CI_COMMIT_TAG" => "v1.2.3",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true
                    )

                    @test d.all_ok
                    @test d.subfolder == "v1.2.3"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Regular tag build with PROJECT_ACCESS_TOKEN and with tag prefix
                withenv(
                    "CI_SYSTEM_VERSION" => "0.15.0",
                    "CI_BUILD_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO_LINK" => "https://github.com/JuliaDocs/Documenter.jl",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/MySubPackage-v1.2.3",
                    "CI_COMMIT_TAG" => "MySubPackage-v1.2.3",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true,
                        tag_prefix = "MySubPackage-"
                    )

                    @test d.all_ok
                    @test d.subfolder == "v1.2.3"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Broken tag build
                withenv(
                    "CI_SYSTEM_VERSION" => "0.15.0",
                    "CI_BUILD_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO_LINK" => "https://github.com/JuliaDocs/Documenter.jl",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/not-a-version",
                    "CI_COMMIT_TAG" => "not-a-version",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true
                    )
                    @test !d.all_ok
                end
                # Regular devbranch build
                withenv(
                    "CI_SYSTEM_VERSION" => "0.15.0",
                    "CI_BUILD_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO_LINK" => "https://github.com/JuliaDocs/Documenter.jl",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/heads/master",
                    "CI_COMMIT_TAG" => nothing,
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test d.all_ok
                    @test d.subfolder == "hello-world"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "not-master", devurl = "hello-world", push_preview = true
                    )
                    @test !d.all_ok
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Regular pull request build
                withenv(
                    "CI_SYSTEM_VERSION" => "0.15.0",
                    "CI_BUILD_EVENT" => "pull_request",
                    "CI_COMMIT_PULL_REQUEST" => "42",
                    "CI" => "woodpecker",
                    "CI_REPO_LINK" => "https://github.com/JuliaDocs/Documenter.jl",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/pull/42/merge",
                    "CI_BUILD_EVENT" => "pull_request",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test d.all_ok
                    @test d.subfolder == "previews/PR42"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = false
                    )
                    @test !d.all_ok
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Not a pull request
                withenv(
                    "CI_SYSTEM_VERSION" => "0.15.0",
                    "CI_BUILD_EVENT" => "push",
                    "CI_COMMIT_PULL_REQUEST" => "42",
                    "CI" => "woodpecker",
                    "CI_REPO_LINK" => "https://github.com/JuliaDocs/Documenter.jl",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/pull/42/merge",
                    "CI_BUILD_EVENT" => "push",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test !d.all_ok
                end
                # Missing environment variables
                withenv(
                    "CI_SYSTEM_VERSION" => "0.15.0",
                    "CI" => "woodpecker",
                    "CI_REPO_LINK" => "https://github.com/JuliaDocs/Documenter.jl",
                    "CI_BUILD_EVENT" => "pull_request",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/pull/42/merge",
                    "PROJECT_ACCESS_TOKEN" => nothing,
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test !d.all_ok
                end
            end
        end
        @testset "Woodpecker 1.0.0" begin
            with_logger(NullLogger()) do
                # Regular tag build with PROJECT_ACCESS_TOKEN
                withenv(
                    "CI_SYSTEM_VERSION" => "1.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/v1.2.3",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => "v1.2.3",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true
                    )

                    @test d.all_ok
                    @test d.subfolder == "v1.2.3"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Regular tag build with PROJECT_ACCESS_TOKEN and with tag prefix
                withenv(
                    "CI_SYSTEM_VERSION" => "1.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/MySubPackage-v1.2.3",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => "MySubPackage-v1.2.3",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true,
                        tag_prefix = "MySubPackage-"
                    )

                    @test d.all_ok
                    @test d.subfolder == "v1.2.3"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Broken tag build
                withenv(
                    "CI_SYSTEM_VERSION" => "1.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/not-a-version",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => "not-a-version",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true
                    )
                    @test !d.all_ok
                end
                # Regular devbranch build
                withenv(
                    "CI_SYSTEM_VERSION" => "1.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/heads/master",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => nothing,
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test d.all_ok
                    @test d.subfolder == "hello-world"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "not-master", devurl = "hello-world", push_preview = true
                    )
                    @test !d.all_ok
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Regular pull request build
                withenv(
                    "CI_SYSTEM_VERSION" => "1.0.0",
                    "CI_PIPELINE_EVENT" => "pull_request",
                    "CI_COMMIT_PULL_REQUEST" => "42",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/pull/42/merge",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_PIPELINE_EVENT" => "pull_request",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test d.all_ok
                    @test d.subfolder == "previews/PR42"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = false
                    )
                    @test !d.all_ok
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Not a pull request
                withenv(
                    "CI_SYSTEM_VERSION" => "1.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI_COMMIT_PULL_REQUEST" => "42",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/pull/42/merge",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_PIPELINE_EVENT" => "push",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test !d.all_ok
                end
                # Missing environment variables
                withenv(
                    "CI_SYSTEM_VERSION" => "1.0.0",
                    "CI" => "woodpecker",
                    "CI_PIPELINE_EVENT" => "pull_request",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/pull/42/merge",
                    "CI_FORGE_URL" => "https://github.com",
                    "PROJECT_ACCESS_TOKEN" => nothing,
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test !d.all_ok
                end
            end
        end
        @testset "Woodpecker 2.0.0" begin
            with_logger(NullLogger()) do
                # Regular tag build with PROJECT_ACCESS_TOKEN
                withenv(
                    "CI_SYSTEM_VERSION" => "2.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/v1.2.3",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => "v1.2.3",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true
                    )

                    @test d.all_ok
                    @test d.subfolder == "v1.2.3"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Regular tag build with PROJECT_ACCESS_TOKEN and with tag prefix
                withenv(
                    "CI_SYSTEM_VERSION" => "2.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/MySubPackage-v1.2.3",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => "MySubPackage-v1.2.3",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true,
                        tag_prefix = "MySubPackage-"
                    )

                    @test d.all_ok
                    @test d.subfolder == "v1.2.3"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Broken tag build
                withenv(
                    "CI_SYSTEM_VERSION" => "2.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/not-a-version",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => "not-a-version",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true
                    )
                    @test !d.all_ok
                end
                # Regular devbranch build
                withenv(
                    "CI_SYSTEM_VERSION" => "2.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/heads/master",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => nothing,
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test d.all_ok
                    @test d.subfolder == "hello-world"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "not-master", devurl = "hello-world", push_preview = true
                    )
                    @test !d.all_ok
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Regular pull request build
                withenv(
                    "CI_SYSTEM_VERSION" => "2.0.0",
                    "CI_PIPELINE_EVENT" => "pull_request",
                    "CI_COMMIT_PULL_REQUEST" => "42",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/pull/42/merge",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_PIPELINE_EVENT" => "pull_request",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test d.all_ok
                    @test d.subfolder == "previews/PR42"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = false
                    )
                    @test !d.all_ok
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Not a pull request
                withenv(
                    "CI_SYSTEM_VERSION" => "2.0.0",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI_COMMIT_PULL_REQUEST" => "42",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/pull/42/merge",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_PIPELINE_EVENT" => "push",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test !d.all_ok
                end
                # Missing environment variables
                withenv(
                    "CI_SYSTEM_VERSION" => "2.0.0",
                    "CI" => "woodpecker",
                    "CI_PIPELINE_EVENT" => "pull_request",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/pull/42/merge",
                    "CI_FORGE_URL" => "https://github.com",
                    "PROJECT_ACCESS_TOKEN" => nothing,
                ) do
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "hello-world", push_preview = true
                    )
                    @test !d.all_ok
                end
            end
        end
        @testset "Woodpecker CI No CI_SYSTEM_VERSION environmental variable" begin
            with_logger(NullLogger()) do
                # Regular tag build with PROJECT_ACCESS_TOKEN but no CI_SYSTEM_VERSION. It should throw.
                withenv(
                    "CI_SYSTEM_VERSION" => nothing,
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/v1.2.3",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => "v1.2.3",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    @test_throws KeyError cfg = Documenter.Woodpecker()
                end
            end
        end
        @testset "Woodpecker CI Unreleased Versions" begin
            with_logger(NullLogger()) do
                # NOTE Unreleased versions starts with `next-<commit hash>`
                # Regular tag build with PROJECT_ACCESS_TOKEN with next unreleased version.
                withenv(
                    "CI_SYSTEM_VERSION" => "next-woodpeckerversion",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/v1.2.3",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => "v1.2.3",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    @test_warn r"(You are currently using an unreleased version of Woodpecker)*" Documenter.Woodpecker()
                    cfg = Documenter.Woodpecker()
                    d = Documenter.deploy_folder(
                        cfg; repo = "JuliaDocs/Documenter.jl",
                        devbranch = "master", devurl = "dev", push_preview = true
                    )
                    @test d.all_ok
                    @test d.subfolder == "v1.2.3"
                    @test d.repo == "JuliaDocs/Documenter.jl"
                    @test d.branch == "pages"
                    @test Documenter.authentication_method(cfg) === Documenter.HTTPS
                    @test Documenter.authenticated_repo_url(cfg) === "https://SGVsbG8sIHdvcmxkLg==@github.com/JuliaDocs/Documenter.jl.git"
                end
                # Incorrect `next` version
                withenv(
                    "CI_SYSTEM_VERSION" => "notnext-indeed",
                    "CI_PIPELINE_EVENT" => "push",
                    "CI" => "woodpecker",
                    "CI_REPO" => "JuliaDocs/Documenter.jl",
                    "CI_COMMIT_REF" => "refs/tags/v1.2.3",
                    "CI_FORGE_URL" => "https://github.com",
                    "CI_COMMIT_TAG" => "v1.2.3",
                    "PROJECT_ACCESS_TOKEN" => "SGVsbG8sIHdvcmxkLg==",
                ) do
                    @test_throws ArgumentError cfg = Documenter.Woodpecker()
                end
            end
        end
    end
end

struct CustomConfig <: Documenter.DeployConfig end
Documenter.deploy_folder(::CustomConfig; kwargs...) = Documenter.DeployDecision(; all_ok = true, subfolder = "v1.2.3")
struct BrokenConfig <: Documenter.DeployConfig end

@testset "Custom configuration" begin
    with_logger(NullLogger()) do
        cfg = CustomConfig()
        d = Documenter.deploy_folder(
            cfg; repo = "github.com/JuliaDocs/Documenter.jl.git",
            devbranch = "master", devurl = "dev", push_preview = true
        )
        @test d.all_ok
        @test d.subfolder == "v1.2.3"
        cfg = BrokenConfig()
        @test (@test_logs (:warn, r"Documenter\.deploy_folder\(::BrokenConfig; kwargs\.\.\.\) not implemented") Documenter.deploy_folder(cfg)) == Documenter.DeployDecision(; all_ok = false)
        @test (@test_logs (:warn, r"Documenter could not auto-detect") Documenter.deploy_folder(nothing)) == Documenter.DeployDecision(; all_ok = false)
    end
end

@testset "Autodetection of deploy system" begin
    withenv(
        "TRAVIS_REPO_SLUG" => "JuliaDocs/Documenter.jl",
        "GITHUB_REPOSITORY" => nothing,
    ) do
        cfg = Documenter.auto_detect_deploy_system()
        @test cfg isa Documenter.Travis
    end
    withenv(
        "TRAVIS_REPO_SLUG" => nothing,
        "GITHUB_REPOSITORY" => "JuliaDocs/Documenter.jl",
    ) do
        cfg = Documenter.auto_detect_deploy_system()
        @test cfg isa Documenter.GitHubActions
    end
    withenv(
        "TRAVIS_REPO_SLUG" => nothing,
        "GITHUB_REPOSITORY" => nothing,
    ) do
        cfg = Documenter.auto_detect_deploy_system()
        @test cfg === nothing
    end

    # Woodpecker requires a CI_SYSTEM_VERSION env var
    withenv(
        "CI" => "woodpecker",
        "CI_SYSTEM_VERSION" => "1.0.0",
        "GITHUB_REPOSITORY" => nothing
    ) do
        cfg = Documenter.auto_detect_deploy_system()
        @test cfg isa Documenter.Woodpecker
    end
    withenv(
        "CI" => "woodpecker",
        "CI_SYSTEM_VERSION" => "0.15.0",
        "GITHUB_REPOSITORY" => nothing
    ) do
        cfg = Documenter.auto_detect_deploy_system()
        @test cfg isa Documenter.Woodpecker
    end
    withenv(
        "CI" => "woodpecker",
        "GITHUB_REPOSITORY" => nothing
    ) do
        @test_throws KeyError  cfg = Documenter.auto_detect_deploy_system()
    end
    # Drone compatibility ends post-1.0.0
    withenv(
        "CI" => "drone",
        "CI_SYSTEM_VERSION" => "0.15.0",
        "GITHUB_REPOSITORY" => nothing
    ) do
        cfg = Documenter.auto_detect_deploy_system()
        @test cfg isa Documenter.Woodpecker
    end
    withenv(
        "CI" => "drone",
        "GITHUB_REPOSITORY" => nothing
    ) do
        @test_throws KeyError cfg = Documenter.auto_detect_deploy_system()
    end
    withenv(
        "CI" => nothing,
        "GITHUB_REPOSITORY" => nothing
    ) do
        cfg = Documenter.auto_detect_deploy_system()
        @test cfg === nothing
    end
end
##
@testset "Remote repository paths" begin
    uhu = Documenter.user_host_upstream("github.com/JuliaDocs/Documenter.jl.git")
    @test uhu == ("git", "github.com", "git@github.com:JuliaDocs/Documenter.jl.git")

    uhu = Documenter.user_host_upstream("github.com:JuliaDocs/Documenter.jl.git")
    @test uhu == ("git", "github.com", "git@github.com:JuliaDocs/Documenter.jl.git")

    uhu = Documenter.user_host_upstream("gitlab.com/JuliaDocs/Documenter.jl")
    @test uhu == ("git", "gitlab.com", "git@gitlab.com:JuliaDocs/Documenter.jl")

    uhu = Documenter.user_host_upstream("user@page.com:path/to/repo")
    @test uhu == ("user", "page.com", "user@page.com:path/to/repo")

    uhu = Documenter.user_host_upstream("user@page.com/path/to/repo")
    @test uhu == ("user", "page.com", "user@page.com:path/to/repo")

    uhu = Documenter.user_host_upstream("user@subdom.long-page.com:/path/to/repo")
    @test uhu == ("user", "subdom.long-page.com", "user@subdom.long-page.com:path/to/repo")

    @test_throws ErrorException Documenter.user_host_upstream("https://github.com/JuliaDocs/Documenter.jl.git")
    @test_throws ErrorException Documenter.user_host_upstream("user@subdom.long-page.com")
end

@testset "version_tag_strip_build" begin
    using Documenter: version_tag_strip_build
    @test version_tag_strip_build("v1.2.3") == "v1.2.3"
    @test version_tag_strip_build("v1.2.3+build") == "v1.2.3"
    @test version_tag_strip_build("v1.2.3+1") == "v1.2.3"
    @test version_tag_strip_build("v1.2.3-DEV") == "v1.2.3-DEV"
    @test version_tag_strip_build("v1.2.3-DEV+build") == "v1.2.3-DEV"
    @test version_tag_strip_build("v1.2") == "v1.2"
    @test version_tag_strip_build("v1.2+build-build") == "v1.2"
    @test version_tag_strip_build("v1.2-1+build-build") == "v1.2-1"
    @test version_tag_strip_build("v0") == "v0"
    @test version_tag_strip_build("v0+build-build") == "v0"
    @test version_tag_strip_build("v0-A+build-build") == "v0-A"
    # In case the tag does not have v, no v in the output
    @test version_tag_strip_build("1.2") == "1.2"
    @test version_tag_strip_build("1.2.3-DEV+build") == "1.2.3-DEV"
    # If it's not a valid version number
    @test version_tag_strip_build("") === nothing
    @test version_tag_strip_build("+A") === nothing
    @test version_tag_strip_build("X.Y.Z") === nothing
    @test version_tag_strip_build("1#2") === nothing
    @test version_tag_strip_build(".1") === nothing

    # ...and now when there's a non-empty tag_prefix:
    tag_prefix = "TagPrefix-"
    @test version_tag_strip_build("v1.2.3"; tag_prefix) === nothing
    @test version_tag_strip_build("TagPrefix-v1.2.3"; tag_prefix) == "v1.2.3"
    @test version_tag_strip_build("TagPrefixTagPrefix-v1.2.3"; tag_prefix) === nothing
    @test version_tag_strip_build("v1.2.3-TagPrefix-"; tag_prefix) === nothing
    @test version_tag_strip_build("TagPrefix-1.2"; tag_prefix) == "1.2"
    @test version_tag_strip_build("TagPrefix-1.2.3-DEV+build"; tag_prefix) == "1.2.3-DEV"
    @test version_tag_strip_build("TagPrefix-"; tag_prefix) === nothing
    @test version_tag_strip_build("TagPrefix-+A"; tag_prefix) === nothing
    @test version_tag_strip_build("TagPrefix-X.Y.Z"; tag_prefix) === nothing
    @test version_tag_strip_build("TagPrefix-1#2"; tag_prefix) === nothing
    @test version_tag_strip_build("TagPrefix-.1"; tag_prefix) === nothing
end

@testset "verify_github_pull_repository" begin
    if Sys.which("curl") === nothing
        @warn "'curl' binary not found, skipping related tests."
    else
        r = Documenter.run_and_capture(`curl --help`)
        @test haskey(r, :stdout)
        @test haskey(r, :stderr)
        @test r.stdout isa String
        @test length(r.stdout) > 0
    end
end

module RemoteTests
using Test
using Documenter
using .Remotes: repofile, repourl, issueurl, URL, GitHub, GitLab, Forgejo

@testset "RepositoryRemote" begin
    let r = URL("https://github.com/FOO/BAR/blob/{commit}{path}#{line}")
        @test repourl(r) === nothing
        @test repofile(r, "master", "src/foo.jl") == "https://github.com/FOO/BAR/blob/master/src/foo.jl#"
        @test repofile(r, "master", "src/foo.jl", 5:5) == "https://github.com/FOO/BAR/blob/master/src/foo.jl#L5"
        @test repofile(r, "master", "src/foo.jl", 10) == "https://github.com/FOO/BAR/blob/master/src/foo.jl#L10"
        @test repofile(r, "master", "src/foo.jl", 5:15) == "https://github.com/FOO/BAR/blob/master/src/foo.jl#L5-L15"
        @test issueurl(r, "123") === nothing
    end

    # Default linerange formatting is GitHub-style
    let r = URL("http://example.org/{commit}/x{path}?lines={line}", "https://example.org/X")
        @test repourl(r) == "https://example.org/X"
        @test repofile(r, "123abc", "src/foo.jl") == "http://example.org/123abc/x/src/foo.jl?lines="
        @test repofile(r, "123abc", "src/foo.jl", 5:5) == "http://example.org/123abc/x/src/foo.jl?lines=L5"
        @test repofile(r, "123abc", "src/foo.jl", 5:15) == "http://example.org/123abc/x/src/foo.jl?lines=L5-L15"
        @test issueurl(r, "123") === nothing
    end

    # Different line range formatting for URLs containing 'bitbucket'
    let r = URL("https://bitbucket.org/foo/bar/src/{commit}{path}#lines-{line}")
        @test repourl(r) === nothing
        @test repofile(r, "mybranch", "src/foo.jl") == "https://bitbucket.org/foo/bar/src/mybranch/src/foo.jl#lines-"
        @test repofile(r, "mybranch", "src/foo.jl", 5:5) == "https://bitbucket.org/foo/bar/src/mybranch/src/foo.jl#lines-5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:15) == "https://bitbucket.org/foo/bar/src/mybranch/src/foo.jl#lines-5:15"
        @test issueurl(r, "123") === nothing
    end

    # Different line range formatting for URLs containing 'gitlab'
    let r = URL("https://gitlab.mydomain.eu/foo/bar/-/blob/{commit}{path}#{line}", "https://gitlab.mydomain.eu/foo/bar/")
        @test repourl(r) == "https://gitlab.mydomain.eu/foo/bar/"
        @test repofile(r, "v1.2.3-rc3+foo", "src/foo.jl") == "https://gitlab.mydomain.eu/foo/bar/-/blob/v1.2.3-rc3+foo/src/foo.jl#"
        @test repofile(r, "v1.2.3-rc3+foo", "src/foo.jl", 5:5) == "https://gitlab.mydomain.eu/foo/bar/-/blob/v1.2.3-rc3+foo/src/foo.jl#L5"
        @test repofile(r, "v1.2.3-rc3+foo", "src/foo.jl", 5:15) == "https://gitlab.mydomain.eu/foo/bar/-/blob/v1.2.3-rc3+foo/src/foo.jl#L5-15"
        @test issueurl(r, "123") === nothing
    end

    # Different line range formatting for URLs containing 'azure'
    let r = URL("https://gitlab.mydomain.eu/foo/bar/-/blob/{commit}{path}#{line}", "https://gitlab.mydomain.eu/foo/bar/")
        @test repourl(r) == "https://gitlab.mydomain.eu/foo/bar/"
        @test repofile(r, "v1.2.3-rc3+foo", "src/foo.jl") == "https://gitlab.mydomain.eu/foo/bar/-/blob/v1.2.3-rc3+foo/src/foo.jl#"
        @test repofile(r, "v1.2.3-rc3+foo", "src/foo.jl", 5:5) == "https://gitlab.mydomain.eu/foo/bar/-/blob/v1.2.3-rc3+foo/src/foo.jl#L5"
        @test repofile(r, "v1.2.3-rc3+foo", "src/foo.jl", 5:15) == "https://gitlab.mydomain.eu/foo/bar/-/blob/v1.2.3-rc3+foo/src/foo.jl#L5-15"
        @test issueurl(r, "123") === nothing
    end

    # GitHub remote
    let r = GitHub("JuliaDocs", "Documenter.jl")
        @test repourl(r) == "https://github.com/JuliaDocs/Documenter.jl"
        @test repofile(r, "mybranch", "src/foo.jl") == "https://github.com/JuliaDocs/Documenter.jl/blob/mybranch/src/foo.jl"
        @test repofile(r, "mybranch", "src/foo.jl", 5) == "https://github.com/JuliaDocs/Documenter.jl/blob/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:5) == "https://github.com/JuliaDocs/Documenter.jl/blob/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:8) == "https://github.com/JuliaDocs/Documenter.jl/blob/mybranch/src/foo.jl#L5-L8"
        @test issueurl(r, "123") == "https://github.com/JuliaDocs/Documenter.jl/issues/123"
    end

    let r = GitHub("JuliaDocs/Documenter.jl")
        @test repourl(r) == "https://github.com/JuliaDocs/Documenter.jl"
        @test repofile(r, "mybranch", "src/foo.jl") == "https://github.com/JuliaDocs/Documenter.jl/blob/mybranch/src/foo.jl"
        @test repofile(r, "mybranch", "src/foo.jl", 5) == "https://github.com/JuliaDocs/Documenter.jl/blob/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:5) == "https://github.com/JuliaDocs/Documenter.jl/blob/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:8) == "https://github.com/JuliaDocs/Documenter.jl/blob/mybranch/src/foo.jl#L5-L8"
        @test issueurl(r, "123") == "https://github.com/JuliaDocs/Documenter.jl/issues/123"
    end

    # GitLab remote
    let r = GitLab("JuliaDocs", "Documenter.jl")
        @test repourl(r) == "https://gitlab.com/JuliaDocs/Documenter.jl"
        @test repofile(r, "mybranch", "src/foo.jl") == "https://gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl"
        @test repofile(r, "mybranch", "src/foo.jl", 5) == "https://gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:5) == "https://gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:8) == "https://gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl#L5-L8"
        @test issueurl(r, "123") == "https://gitlab.com/JuliaDocs/Documenter.jl/-/issues/123"
    end

    let r = GitLab("my-gitlab.com", "JuliaDocs", "Documenter.jl")
        @test repourl(r) == "https://my-gitlab.com/JuliaDocs/Documenter.jl"
        @test repofile(r, "mybranch", "src/foo.jl") == "https://my-gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl"
        @test repofile(r, "mybranch", "src/foo.jl", 5) == "https://my-gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:5) == "https://my-gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:8) == "https://my-gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl#L5-L8"
        @test issueurl(r, "123") == "https://my-gitlab.com/JuliaDocs/Documenter.jl/-/issues/123"
    end

    let r = GitLab("JuliaDocs/Documenter.jl")
        @test repourl(r) == "https://gitlab.com/JuliaDocs/Documenter.jl"
        @test repofile(r, "mybranch", "src/foo.jl") == "https://gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl"
        @test repofile(r, "mybranch", "src/foo.jl", 5) == "https://gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:5) == "https://gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:8) == "https://gitlab.com/JuliaDocs/Documenter.jl/-/tree/mybranch/src/foo.jl#L5-L8"
        @test issueurl(r, "123") == "https://gitlab.com/JuliaDocs/Documenter.jl/-/issues/123"
    end

    # Forgejo remote
    let r = Forgejo("git.mydomain.tld", "JuliaDocs", "Documenter.jl")
        @test repourl(r) == "https://git.mydomain.tld/JuliaDocs/Documenter.jl"
        @test repofile(r, "mybranch", "src/foo.jl") == "https://git.mydomain.tld/JuliaDocs/Documenter.jl/src/commit/mybranch/src/foo.jl"
        @test repofile(r, "mybranch", "src/foo.jl", 5) == "https://git.mydomain.tld/JuliaDocs/Documenter.jl/src/commit/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:5) == "https://git.mydomain.tld/JuliaDocs/Documenter.jl/src/commit/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:8) == "https://git.mydomain.tld/JuliaDocs/Documenter.jl/src/commit/mybranch/src/foo.jl#L5-L8"
        @test issueurl(r, "123") == "https://git.mydomain.tld/JuliaDocs/Documenter.jl/issues/123"
    end

    let r = Forgejo("codeberg.org/JuliaDocs/Documenter.jl")
        @test repourl(r) == "https://codeberg.org/JuliaDocs/Documenter.jl"
        @test repofile(r, "mybranch", "src/foo.jl") == "https://codeberg.org/JuliaDocs/Documenter.jl/src/commit/mybranch/src/foo.jl"
        @test repofile(r, "mybranch", "src/foo.jl", 5) == "https://codeberg.org/JuliaDocs/Documenter.jl/src/commit/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:5) == "https://codeberg.org/JuliaDocs/Documenter.jl/src/commit/mybranch/src/foo.jl#L5"
        @test repofile(r, "mybranch", "src/foo.jl", 5:8) == "https://codeberg.org/JuliaDocs/Documenter.jl/src/commit/mybranch/src/foo.jl#L5-L8"
        @test issueurl(r, "123") == "https://codeberg.org/JuliaDocs/Documenter.jl/issues/123"
    end
end

end # module

using Test
using Documenter
include("../TestUtilities.jl"); using Main.TestUtilities

const pages = [
    "Home" => "index.md",
    "File" => "other.md",
]

@quietly makedocs(sitename = "Test", pages = pages)

@testset "Symlinks" begin
    # check that the symlinked page is built at all
    other = joinpath(@__DIR__, "build", "other")
    @test isdir(other)
    other_index = joinpath(other, "index.html")
    @test isfile(other_index)

    # check that it contains what we want
    filecontents = read(other_index, String)
    @test occursin("another test", filecontents)
end

"""
Main module for `Documenter.jl` -- a documentation generation package for Julia.

Two functions are exported from this module for public use:

- [`makedocs`](@ref). Generates documentation from docstrings and templated markdown files.
- [`deploydocs`](@ref). Deploys generated documentation from *Travis-CI* to *GitHub Pages*.

# Exports

$(EXPORTS)

"""
module Documenter

import AbstractTrees
import Downloads
import IOCapture
import Markdown
using MarkdownAST: MarkdownAST, Node
import REPL
import Unicode
import Pkg
import RegistryInstances
import Git
# Additional imported names
using Test: @testset, @test
using DocStringExtensions: SIGNATURES, EXPORTS
using Base64: base64decode

# Version number of Documenter itself
const DOCUMENTER_VERSION = let
    project = joinpath(dirname(dirname(pathof(Documenter))), "Project.toml")
    Base.include_dependency(project) # Retrigger precompilation when Project.toml changes
    toml = read(project, String)
    m = match(r"(*ANYCRLF)^version\s*=\s\"(.*)\"$"m, toml)
    VersionNumber(m[1])
end

# Potentially sensitive variables to be removed from environment when not needed
const NO_KEY_ENV = Dict(
    "DOCUMENTER_KEY" => nothing,
    "DOCUMENTER_KEY_PREVIEWS" => nothing,
)

# Names of possible internal errors
const ERROR_NAMES = [
    :autodocs_block, :cross_references, :docs_block, :doctest,
    :eval_block, :example_block, :footnote, :linkcheck_remotes, :linkcheck,
    :meta_block, :missing_docs, :parse_error, :setup_block,
]

"""
    abstract type Plugin end

Any plugin that needs to either solicit user input or store information in a
[`Document`](@ref) should create a subtype of `Plugin`, i.e., `T <: DocumenterPlugin`.

Initialized objects of type `T` can be elements of the list of `plugins` passed as a
keyword argument to [`makedocs`](@ref).

A plugin may retrieve the existing object holding its state via the
[`Documenter.getplugin`](@ref) function. Alternatively, `getplugin` can also instantiate
`T()` on demand, if there is no existing object. This requires that `T` implements an empty
constructor `T()`.
"""
abstract type Plugin end

abstract type Writer end

include("utilities/DOM.jl")
include("utilities/JSDependencies.jl")
include("utilities/MDFlatten.jl")
include("utilities/Remotes.jl")
include("utilities/Selectors.jl")
include("utilities/TextDiff.jl")
include("utilities/utilities.jl")
include("DocMeta.jl")
include("DocSystem.jl")
include("anchors.jl")
include("documents.jl")
include("expander_pipeline.jl")
include("doctests.jl")
include("builder_pipeline.jl")
include("cross_references.jl")
include("docchecks.jl")
include("writers.jl")
include("html/HTMLWriter.jl")
include("latex/LaTeXWriter.jl")

# This is to keep DocumenterTools working:
module Writers
    import ..HTMLWriter
end

import .HTMLWriter: HTML, asset, RawHTMLHeadContent
import .HTMLWriter.RD: KaTeX, MathJax, MathJax2, MathJax3
import .LaTeXWriter: LaTeX

# User Interface.
# ---------------
export makedocs, deploydocs, hide, doctest, DocMeta, asset, RawHTMLHeadContent, Remotes,
    KaTeX, MathJax, MathJax2, MathJax3

include("makedocs.jl")
include("deployconfig.jl")
include("deploydocs.jl")
include("doctest.jl")

import PrecompileTools
PrecompileTools.@compile_workload begin
    include("docs_precompile/make.jl")
end

end # module

module DocSystemTests

using Test

import Documenter: Documenter, DocSystem

const alias_of_getdocs = DocSystem.getdocs # NOTE: won't get docstrings if in a @testset

module TestDocstrings
    "A"
    struct A end
    "A(x)"
    A(x) = A()
    B = A

    "foo(::Number)"
    foo(::Number) = nothing

    "foo(::Float64)"
    foo(::Float64) = nothing

    const bar = foo
    const baz = foo

    "baz(::Number)"
    baz(::Number)

    "baz(::Float64)"
    baz(::Float64)

    using Markdown: @doc_str
    @doc doc"qux(::Float64)"
    qux(::Float64)
end

@testset "DocSystem" begin
    ## Bindings.
    @test_throws ArgumentError DocSystem.binding(9000)
    let b = Docs.Binding(@__MODULE__, :DocSystem)
        @test DocSystem.binding(b) == b
    end
    let b = DocSystem.binding(Documenter.Document)
        @test b.mod === Documenter
        @test b.var === :Document
    end
    let b = DocSystem.binding(Documenter)
        @test b.mod === (Documenter)
        @test b.var === :Documenter
    end
    let b = DocSystem.binding(:Main)
        # @test b.mod === Main
        @test b.var === :Main
    end
    let b = DocSystem.binding(DocSystem.binding)
        @test b.mod === DocSystem
        @test b.var === :binding
    end
    let b = DocSystem.binding(Documenter, :Documenter)
        @test b.mod === (Documenter)
        @test b.var === :Documenter
    end

    ## `MultiDoc` object.
    @test isdefined(DocSystem, :MultiDoc)
    @test (fieldnames(DocSystem.MultiDoc)...,) == (:order, :docs)

    ## `DocStr` object.
    @test isdefined(DocSystem, :DocStr)
    @test (fieldnames(DocSystem.DocStr)...,) == (:text, :object, :data)
    ## `getdocs`.
    let b = DocSystem.binding(DocSystem, :getdocs),
            d_0 = DocSystem.getdocs(b, Tuple{}),
            d_1 = DocSystem.getdocs(b),
            d_2 = DocSystem.getdocs(b, Union{Tuple{Any}, Tuple{Any, Type}}; compare = (==)),
            d_3 = DocSystem.getdocs(b; modules = Module[Main]),
            d_4 = DocSystem.getdocs(DocSystem.binding(@__MODULE__, :alias_of_getdocs)),
            d_5 = DocSystem.getdocs(DocSystem.binding(@__MODULE__, :alias_of_getdocs); aliases = false),
            d_6 = DocSystem.getdocs(b, Union{Tuple{Docs.Binding}, Tuple{Docs.Binding, Type}}; compare = (==)),
            d_7 = DocSystem.getdocs(DocSystem.binding(@__MODULE__, :alias_of_getdocs), Union{Tuple{Docs.Binding}, Tuple{Docs.Binding, Type}})

        @test length(d_0) == 0
        @test length(d_1) == 2
        @test length(d_2) == 1
        @test length(d_3) == 0
        @test length(d_4) == 2
        @test length(d_5) == 0
        @test length(d_6) == 1
        @test length(d_7) == 1

        @test d_1[1].data[:binding] == b
        @test d_1[2].data[:binding] == b
        @test d_1[1].data[:typesig] == Union{Tuple{Docs.Binding}, Tuple{Docs.Binding, Type}}
        @test d_1[2].data[:typesig] == Union{Tuple{Any}, Tuple{Any, Type}}
        @test d_1[1].data[:module] == DocSystem
        @test d_1[2].data[:module] == DocSystem

        @test d_2[1].data[:binding] == b
        @test d_2[1].data[:typesig] == Union{Tuple{Any}, Tuple{Any, Type}}
        @test d_2[1].data[:module] == DocSystem

        @test d_6[1].data[:binding] == b
        @test d_6[1].data[:typesig] == Union{Tuple{Docs.Binding}, Tuple{Docs.Binding, Type}}
        @test d_6[1].data[:module] == DocSystem

        @test d_1 == d_4
        @test d_1 != d_5
        @test d_6 == d_7
    end

    ## `UnionAll`
    let b = DocSystem.binding(@__MODULE__, Meta.parse("f(x::T) where T"))
        @test b.var == :f
    end

    # TestDocstrings
    a_1 = DocSystem.getdocs(Docs.Binding(TestDocstrings, :A))
    a_2 = DocSystem.getdocs(Docs.Binding(TestDocstrings, :A), Union{})
    a_3 = DocSystem.getdocs(Docs.Binding(TestDocstrings, :A), Tuple{Any})
    b_1 = DocSystem.getdocs(Docs.Binding(TestDocstrings, :B))
    b_2 = DocSystem.getdocs(Docs.Binding(TestDocstrings, :B), Union{})
    b_3 = DocSystem.getdocs(Docs.Binding(TestDocstrings, :B), Tuple{Any})
    @test length(a_2) == 1
    @test a_2[1].data[:typesig] == Union{}
    # No signature fetches the docstring of the type (Union{}) in this case
    @test a_1 == a_2
    @test length(a_3) == 1
    @test a_3[1].data[:typesig] == Tuple{Any}
    # Make sure that for an alias we get consistent docstrings
    @test b_1 == a_1
    @test b_2 == a_2
    @test b_3 == a_3

    # Tests for method and alias fallback logic
    foo_1 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :foo))
    foo_2 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :foo), Tuple{Int})
    foo_3 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :foo), Tuple{Float64})
    foo_4 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :foo), Tuple{AbstractFloat})
    foo_5 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :foo), Tuple{Number})
    foo_6 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :foo), Tuple{Any})

    @test length(foo_1) == 2 # should have fetched both docstrings

    @test length(foo_5) == 1 # contains docstring for generic ::Number method
    @test foo_5[1].data[:binding] == Docs.Binding(TestDocstrings, :foo)
    @test foo_5[1].data[:typesig] == Tuple{Number}

    @test isempty(foo_6) # this shouldn't match anything
    @test foo_2 == foo_5 # ::Int dispatches to ::Number
    @test foo_4 == foo_5 # ::AbstractFloat also dispatches to ::Number

    @test foo_3 != foo_5 # foo(::Float64) has its own docstring
    @test foo_3[1].data[:binding] == Docs.Binding(TestDocstrings, :foo)
    @test foo_3[1].data[:typesig] == Tuple{Float64}

    @test foo_2[1] ∈ foo_1
    @test foo_3[1] ∈ foo_1

    # setting 'compare' to subtype, will fetch both docstrings
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :foo), Tuple{Float64}, compare = (<:)) == foo_1

    # bar is an alias, so falls back to foo
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar)) == foo_1
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{Int}) == foo_2
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{Float64}) == foo_3
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{AbstractFloat}) == foo_4
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{Number}) == foo_5
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{Any}) == foo_6
    # unless we disable following aliases
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar); aliases = false) |> isempty
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{Int}; aliases = false) |> isempty
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{Float64}; aliases = false) |> isempty
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{AbstractFloat}; aliases = false) |> isempty
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{Number}; aliases = false) |> isempty
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :bar), Tuple{Any}; aliases = false) |> isempty

    # baz, while an alias of foo, has the same 'structure', but different docstrings..
    baz_1 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz))
    baz_2 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{Int})
    baz_3 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{Float64})
    baz_4 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{AbstractFloat})
    baz_5 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{Number})
    baz_6 = Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{Any})

    @test length(baz_1) == 2 # should have fetched both docstrings

    @test length(baz_5) == 1 # contains docstring for generic ::Number method
    @test baz_5[1].data[:binding] == Docs.Binding(TestDocstrings, :baz)
    @test baz_5[1].data[:typesig] == Tuple{Number}

    @test isempty(baz_6) # this shouldn't match anything
    @test baz_2 == baz_5 # ::Int dispatches to ::Number
    @test baz_4 == baz_5 # ::AbstractFloat also dispatches to ::Number

    @test baz_3 != baz_5 # baz(::Float64) has its own docstring
    @test baz_3[1].data[:binding] == Docs.Binding(TestDocstrings, :baz)
    @test baz_3[1].data[:typesig] == Tuple{Float64}

    @test baz_2[1] ∈ baz_1
    @test baz_3[1] ∈ baz_1

    # .. even if we disable aliases
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz); aliases = false) == baz_1
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{Int}; aliases = false) == baz_2
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{Float64}; aliases = false) == baz_3
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{AbstractFloat}; aliases = false) == baz_4
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{Number}; aliases = false) == baz_5
    @test Documenter.DocSystem.getdocs(Docs.Binding(TestDocstrings, :baz), Tuple{Any}; aliases = false) == baz_6
end

end

using Documenter
include("dummy_module.jl")

makedocs(
    root = @__DIR__,
    sitename = "Search Edge Case Tests",
    modules = [DummyModule],
    format = Documenter.HTML(
        prettyurls = false,
    ),
    pages = [
        "Welcome" => "index.md",
        "Atypical Content" => "atypical_content.md",
        "Structural Cases" => "structural_cases.md",
        "Markdown Syntax" => "markdown_syntax.md",
        "Common Words" => "common_words.md",
        "Auto-generated Docs" => "autodocs.md",
        "Cross-references" => "cross_references.md",
        "Doctests" => "doctests.md",
        "Tables" => "tables.md",
    ],
    build = "build",
    warnonly = [:cross_references],
)

# Defines [`Document`](@ref) and its supporting types

# When processing the AST during the build, in the MarkdownAST representation, we
# replace various code blocks etc. with Documenter-specific elements that the writers
# then can dispatch on. All the Documenter elements are subtypes of this node.
abstract type AbstractDocumenterBlock <: MarkdownAST.AbstractBlock end
abstract type AbstractDocumenterInline <: MarkdownAST.AbstractInline end

# Override the show for Documenter elements types so that we would not print too much
# information when we happen to show the AST.
Base.show(io::IO, node::AbstractDocumenterBlock) = print(io, typeof(node), "([...])")
Base.show(io::IO, node::AbstractDocumenterInline) = print(io, typeof(node), "([...])")

# Pages.
# ------

"""
[`Page`](@ref)-local values such as current module that are shared between nodes in a page.
"""
mutable struct Globals
    mod::Module
    meta::Dict{Symbol, Any}
end
Globals() = Globals(Main, Dict())

"""
Represents a single markdown file.
"""
struct Page
    source::String
    build::String
    workdir::Union{Symbol, String}
    """
    Ordered list of raw toplevel markdown nodes from the parsed page contents. This vector
    should be considered immutable.
    """
    elements::Vector
    """
    Each element in `.elements` maps to an "expanded" element. This may be itself if the
    element does not need expanding or some other object, such as a `DocsNode` in the case
    of `@docs` code blocks.
    """
    globals::Globals
    mdast::MarkdownAST.Node{Nothing}
end
function Page(source::AbstractString, build::AbstractString, workdir::AbstractString)
    # The Markdown standard library parser is sensitive to line endings:
    #   https://github.com/JuliaLang/julia/issues/29344
    # This can lead to different AST and therefore differently rendered docs, depending on
    # what platform the docs are being built (e.g. when Git checks out LF files with
    # CRFL line endings on Windows). To make sure that the docs are always built consistently,
    # we'll normalize the line endings when parsing Markdown files by removing all CR characters.
    mdsrc = replace(read(source, String), '\r' => "")
    mdpage = Markdown.parse(mdsrc)
    mdast = try
        convert(MarkdownAST.Node, mdpage)
    catch err
        @error """
        MarkdownAST conversion error on $(source).
        This is a bug — please report this on the Documenter issue tracker
        """
        rethrow(err)
    end
    return Page(source, build, workdir, mdpage.content, Globals(), mdast)
end

Base.show(io::IO, page::Page) = print(
    io,
    "Documenter.Page(\"",
    page.source,
    "\", \"",
    page.build,
    "\", \"",
    page.workdir,
    "\")",
)


# FIXME -- special overload for parseblock
function parseblock(code::AbstractString, doc, page::Documenter.Page; kwargs...)
    file = joinpath(doc.user.root, page.source)
    return parseblock(code, doc, file; kwargs...)
end

# Document blueprints.
# --------------------

# Should contain all the information that is necessary to build a document.
# Currently has enough information to just run doctests.
struct DocumentBlueprint
    pages::Dict{String, Page} # Markdown files only.
    modules::Set{Module} # Which modules to check for missing docs?
end


# Document Nodes.
# ---------------

## IndexNode.

struct IndexNode <: AbstractDocumenterBlock
    pages::Vector{String} # Which pages to include in the index? Set by user.
    modules::Vector{Module} # Which modules to include? Set by user.
    order::Vector{Symbol} # What order should docs be listed in? Set by user.
    build::String         # Path to the file where this index will appear.
    source::String         # Path to the file where this index was written.
    elements::Vector         # (object, doc, page, mod, cat)-tuple for constructing links.
    codeblock::MarkdownAST.CodeBlock # original code block

    function IndexNode(
            codeblock;
            # TODO: Fix difference between uppercase and lowercase naming of keys.
            #       Perhaps deprecate the uppercase versions? Same with `ContentsNode`.
            Pages = [],
            Modules = [],
            Order = [:module, :constant, :type, :function, :macro],
            build = error("missing value for `build` in `IndexNode`."),
            source = error("missing value for `source` in `IndexNode`."),
            others...
        )
        if !isempty(others)
            @warn(
                "In file $source: the following unsupported keyword " *
                    "arguments have been set in the `@index` node:\n" *
                    join([string(k, " = ", v) for (k, v) in others], "\n"),
            )
        end
        return new(Pages, Modules, Order, build, source, [], codeblock)
    end
end

## ContentsNode.

struct ContentsNode <: AbstractDocumenterBlock
    pages::Vector{String} # Which pages should be included in contents? Set by user.
    mindepth::Int         # Minimum header level that should be displayed. Set by user.
    depth::Int            # Down to which level should headers be displayed? Set by user.
    build::String         # Same as for `IndexNode`s.
    source::String        # Same as for `IndexNode`s.
    elements::Vector      # (order, page, anchor)-tuple for constructing links.
    codeblock::MarkdownAST.CodeBlock # original code block

    function ContentsNode(
            codeblock;
            Pages = [],
            Depth = 1:2,
            build = error("missing value for `build` in `ContentsNode`."),
            source = error("missing value for `source` in `ContentsNode`."),
            others...
        )
        if Depth isa Integer
            Depth = 1:Depth
        end
        if !isempty(others)
            @warn(
                "In file $source: the following unsupported keyword " *
                    "arguments have been set in the `@contents` node:\n" *
                    join([string(k, " = ", v) for (k, v) in others], "\n"),
            )
        end
        return new(Pages, first(Depth), last(Depth), build, source, [], codeblock)
    end
end

## Other nodes

struct MetaNode <: AbstractDocumenterBlock
    codeblock::MarkdownAST.CodeBlock
    dict::Dict{Symbol, Any}
end

struct DocsNode <: AbstractDocumenterBlock
    anchor::Anchor
    object::Object
    page::Documenter.Page
    # MarkdownAST support.
    # TODO: should be the docstring components (i.e. .mdasts) be stored as child nodes?
    mdasts::Vector{MarkdownAST.Node{Nothing}}
    results::Vector{Base.Docs.DocStr}
    metas::Vector{Dict{Symbol, Any}}
    function DocsNode(anchor, object, page)
        return new(anchor, object, page, [], [], [])
    end
end

struct DocsNodes
    nodes::Vector{Union{DocsNode, Markdown.Admonition}}
end

struct EvalNode <: AbstractDocumenterBlock
    codeblock::MarkdownAST.CodeBlock
    result::Union{MarkdownAST.Node, Nothing}
end

struct RawNode <: AbstractDocumenterBlock
    name::Symbol
    text::String
end

# MultiOutput contains child nodes in .content that are either code blocks or
# dictionaries corresponding to the outputs rendered with various MIME types.
# In the MarkdownAST representation, the dictionaries get converted into
# MultiOutputElement elements.
struct MultiOutput <: AbstractDocumenterBlock
    codeblock::MarkdownAST.CodeBlock
end

# For @repl blocks we store the inputs and outputs as separate Markdown.Code
# objects, and then combine them in the writer. When converting to MarkdownAST,
# those separate code blocks become child nodes.
struct MultiCodeBlock <: AbstractDocumenterBlock
    codeblock::MarkdownAST.CodeBlock
    language::String
    content::Vector{Markdown.Code}
end

# Cross-references

struct PageLink <: AbstractDocumenterInline
    page::Documenter.Page
    fragment::String
end
Base.show(io::IO, link::PageLink) = print(io, "Documenter.PageLink(\"", link.page, "\", \"", link.fragment, "\")")

"""
Represents a reference to a local file. The `path` can be assumed to be an "absolute" path
relative to the document root (i.e. `src/` or `build/` directories).

In the standard setup, when the documentation setup lives in `docs/`, with source files
in `docs/src`, a link to the file `docs/src/foo/bar.md` would have `path = "foo/bar.md"`.
"""
struct LocalLink <: AbstractDocumenterInline
    path::String
    fragment::String
end
Base.show(io::IO, link::LocalLink) = print(io, "Documenter.LocalLink(\"", link.path, "\", \"", link.fragment, "\")")

"""
Represents a reference to a local image. The `path` can be assumed to be an "absolute" path
relative to the document root (i.e. `src/` or `build/` directories). See [`LocalLink`](@ref)
for more details.
"""
struct LocalImage <: AbstractDocumenterInline
    path::String
end
Base.show(io::IO, image::LocalImage) = print(io, "Documenter.LocalImage(\"", image.path, "\")")

"""
Represents a named anchor attached to arbitrary inline content via the `[content](@id name)`
syntax. Unlike a header anchor (`AnchoredHeader`), this can wrap any inline content
(text, images, code) so that it becomes a cross-reference target for `[text](@ref name)`.

The wrapped content is stored as the child nodes of the `MarkdownAST.Node` holding this
element, mirroring how `PageLink` replaces a `MarkdownAST.Link` in place.
"""
struct AnchoredInline <: AbstractDocumenterInline
    anchor::Anchor
end
MarkdownAST.iscontainer(::AnchoredInline) = true
Base.show(io::IO, ::AnchoredInline) = print(io, "Documenter.AnchoredInline([...])")

# Navigation
# ----------------------

"""
Element in the navigation tree of a document, containing navigation references
to other pages, a reference to the [`Page`](@ref) object etc.
"""
mutable struct NavNode
    """
    `nothing` if the `NavNode` is a non-page node of the navigation tree, otherwise
    the string should be a valid key in `doc.blueprint.pages`
    """
    page::Union{String, Nothing}
    """
    If not `nothing`, specifies the text that should be displayed in navigation
    links etc. instead of the automatically determined text.
    """
    title_override::Union{String, Nothing}
    parent::Union{NavNode, Nothing}
    children::Vector{NavNode}
    visible::Bool
    prev::Union{NavNode, Nothing}
    next::Union{NavNode, Nothing}
end
NavNode(page, title_override, parent) = NavNode(page, title_override, parent, [], true, nothing, nothing)
# This method ensures that we do not print the whole navtree in case we ever happen to print
# a NavNode in some debug output somewhere.
function Base.show(io::IO, n::NavNode)
    parent = isnothing(n.parent) ? "nothing" : "NavNode($(repr(n.parent.page)), ...)"
    print(io, "NavNode($(repr(n.page)), $(repr(n.title_override)), $(parent))")
    return
end

"""
Constructs a list of the ancestors of the `navnode` (including the `navnode` itself),
ordered so that the root of the navigation tree is the first and `navnode` itself
is the last item.
"""
navpath(navnode::NavNode) = navnode.parent === nothing ? [navnode] :
    push!(navpath(navnode.parent), navnode)


# Inner Document Fields.
# ----------------------

# Represents a 'root path' => (Remote, commit/branch) mapping.
struct RemoteRepository
    # Path to the root of the repository on the local machine
    root::String
    remote::Remotes.Remote
    # Note: in the HTML output you can override whether edit links
    # point to commits or main/master. But this here should still be a commit, since
    # it is predominantly used for source links in docstrings (when manually specified
    # via the remotes argument).
    commit::String
end
function RemoteRepository(root::AbstractString, remote::Remotes.Remote)
    try
        return RemoteRepository(realpath(root), remote, repo_commit(root))
    catch e
        e isa RepoCommitError || rethrow()
        @error "Unable to determine the commit for the remote repository:\n$(e.msg)" e.directory exception = e.err_bt
        msg = """
        Unable to determine the commit for the remote repository
          at $(root) => $(remote)"""
        throw(ArgumentError(msg))
    end
end

"""
$(SIGNATURES)

Returns the first 5 characters of the current Git commit hash of the remote.
"""
shortcommit(remoteref::RemoteRepository) = (length(remoteref.commit) > 5) ? remoteref.commit[1:5] : remoteref.commit

"""
User-specified values used to control the generation process.
"""
struct User
    root::String # An absolute path to the root directory of the document.
    source::String # Parent directory is `.root`. Where files are read from.
    build::String # Parent directory is also `.root`. Where files are written to.
    workdir::Union{Symbol, String} # Parent directory is also `.root`. Where code is executed from.
    format::Vector{Writer} # What format to render the final document with?
    clean::Bool # Empty the `build` directory before starting a new build?
    doctest::Union{Bool, Symbol} # Run doctests?
    linkcheck::Bool # Check external links..
    linkcheck_ignore::Vector{Union{String, Regex}} # ..and then ignore (some of) them.
    linkcheck_timeout::Real # ..but only wait this many seconds for each one.
    linkcheck_useragent::Union{String, Nothing} # User agent to use for linkchecks.
    checkdocs::Symbol # Check objects missing from `@docs` blocks. `:none`, `:exports`, `:public` or `:all`.
    checkdocs_ignored_modules::Vector{Module} # ..and then ignore (some of) them.
    doctestfilters::Vector{<:Any} # Filtering for doctests
    warnonly::Vector{Symbol} # List of docerror groups that should only warn, rather than cause a build failure
    pages::Vector{Any} # Ordering of document pages specified by the user.
    pagesonly::Bool # Discard any .md pages from processing that are not in .pages
    expandfirst::Vector{String} # List of pages that get "expanded" before others
    # Remote Git repository information
    #
    # .remote is the remote corresponding to the main package / project repository.
    #  It is used for issue references, the repo-wide "GitHub" links and such, but not
    # to figure out where to link files to.
    #
    # .remotes is an array of (path, remote) pairs, where the path is the absolute path
    # to the root of the directory that contains the repository `remote`. The array
    # is sorted by having the longer prefixes first, so that you could have nested
    # repositories as well. When we try to match a file path with a remote, we can just
    # walk through the list and do a startswith(), and take the first one that matches.
    #
    # While the initial list in .remotes is populated when we construct the Document
    # object, we also dynamically add links to the .remotes array as we check different
    # files, by looking at .git directories.
    remote::Union{Remotes.Remote, Nothing}
    remotes::Union{Vector{RemoteRepository}, Nothing}
    sitename::String
    authors::String
    version::String # version string used in the version selector by default
    highlightsig::Bool  # assume leading unlabeled code blocks in docstrings to be Julia.
    draft::Bool
    meta::Dict{Symbol, Any} # default @meta block data for pages
    treat_markdown_warnings_as_error::Bool # option to treat markdown warnings as an error
end

"""
Private state used to control the generation process.
"""
struct Internal
    assets::String # Path where asset files will be copied to.
    navtree::Vector{NavNode} # A vector of top-level navigation items.
    navlist::Vector{NavNode} # An ordered list of `NavNode`s that point to actual pages
    anchors::AnchorMap # See `modules/Anchors.jl`. Tracks `@id` anchors on headers and inline content.
    docs::AnchorMap # See `modules/Anchors.jl`. Tracks `@docs` docstrings.
    bindings::IdDict{Any, Any} # Tracks insertion order of object per-binding.
    objects::IdDict{Any, Any} # Tracks which `Objects` are included in the `Document`.
    contentsnodes::Vector{ContentsNode}
    indexnodes::Vector{IndexNode}
    locallinks::IdDict{MarkdownAST.Link, String}
    errors::Set{Symbol}
    src_to_uuid::Dict{String, Base.UUID} # These two are used to cache information from Pkg
    uuid_to_version_info::Dict{Base.UUID, Tuple{VersionNumber, String}}
end

# Document.
# ---------

"""
Represents an entire document.
"""
struct Document
    user::User # Set by the user via `makedocs`.
    internal::Internal # Computed values.
    plugins::Dict{DataType, Plugin}
    blueprint::DocumentBlueprint
end

function Document(;
        root::AbstractString = currentdir(),
        source::AbstractString = "src",
        build::AbstractString = "build",
        workdir::Union{Symbol, AbstractString} = :build,
        format::Any = HTML(),
        clean::Bool = true,
        doctest::Union{Bool, Symbol} = true,
        linkcheck::Bool = false,
        linkcheck_ignore::Vector = [],
        linkcheck_timeout::Real = 10,
        linkcheck_useragent::Union{AbstractString, Nothing} = _LINKCHECK_DEFAULT_USERAGENT,
        checkdocs::Symbol = :all,
        checkdocs_ignored_modules::Vector{Module} = Module[],
        doctestfilters::Vector{<:Any} = Regex[],
        warnonly::Union{Bool, Symbol, Vector{Symbol}} = Symbol[],
        modules::Union{Module, Vector{Module}} = Module[],
        pages::Vector = Any[],
        pagesonly::Bool = false,
        expandfirst::Vector = String[],
        plugins::Vector = Plugin[],
        repo::Union{Remotes.Remote, AbstractString} = "",
        remotes::Union{Dict, Nothing} = Dict(),
        sitename::AbstractString = "",
        authors::AbstractString = "",
        version::AbstractString = "",
        highlightsig::Bool = true,
        draft::Bool = false,
        meta::Dict{Symbol} = Dict{Symbol, Any}(),
        treat_markdown_warnings_as_error::Bool = false,
        others...
    )

    if !isempty(others)
        msg = "makedocs() got passed invalid keyword arguments:"
        for (k, v) in others
            msg *= string("\n  ", k, " = ", repr(v))
        end
        throw(ArgumentError(msg))
    end

    warnonly = reduce_warnonly(warnonly) # convert warnonly to Symbol[]

    if !isa(format, AbstractVector)
        format = Writer[format]
    end

    remote, remotes = if isnothing(remotes)
        if isa(repo, AbstractString) && !isempty(repo)
            err = """
            When `remotes` is set to `nothing`, `repo` must not be set.
            """
            throw(ArgumentError(err))
        end
        nothing, nothing
    else
        interpret_repo_and_remotes(; root, repo, remotes)
    end
    @debug "Document: remotes" remote remotes

    if version == "git-commit"
        if isnothing(remote)
            err = """
            Unable to determine the Git commit of the main repository, but `version` is set to `git-commit`."""
            throw(ArgumentError(err))
        end
        version = "git:$(shortcommit(remote))"
    end

    user = User(
        root,
        source,
        build,
        workdir,
        format,
        clean,
        doctest,
        linkcheck,
        linkcheck_ignore,
        linkcheck_timeout,
        linkcheck_useragent,
        checkdocs,
        checkdocs_ignored_modules,
        doctestfilters,
        warnonly,
        pages,
        pagesonly,
        expandfirst,
        remote,
        remotes,
        sitename,
        authors,
        version,
        highlightsig,
        draft,
        meta,
        treat_markdown_warnings_as_error,
    )
    internal = Internal(
        assetsdir(),
        [],
        [],
        AnchorMap(),
        AnchorMap(),
        IdDict{Any, Any}(),
        IdDict{Any, Any}(),
        [],
        [],
        Dict{Markdown.Link, String}(),
        Set{Symbol}(),
        Dict{String, String}(),
        Dict{String, Tuple{String, String}}()
    )

    plugin_dict = Dict{DataType, Plugin}()
    for plugin in plugins
        plugin isa Plugin ||
            throw(ArgumentError("$(typeof(plugin)) in `plugins=` is not a subtype of `Documenter.Plugin`."))
        haskey(plugin_dict, typeof(plugin)) &&
            throw(ArgumentError("only one copy of $(typeof(plugin)) may be passed."))
        plugin_dict[typeof(plugin)] = plugin
    end

    blueprint = DocumentBlueprint(
        Dict{String, Page}(),
        submodules(modules; ignore = Set(checkdocs_ignored_modules)),
    )
    return Document(user, internal, plugin_dict, blueprint)
end

function interpret_repo_and_remotes(; root, repo, remotes)
    # For `remotes`, we'll first validate that the array provided by the user contains
    # valid path-remote pairs.
    remotes_checked = RemoteRepository[]
    for (path, remoteref) in something(remotes, ()) # remotes can be nothing
        # The paths should be relative to the directory containing make.jl (or, more generally, to the root
        # argument of makedocs)
        path = joinpath(root, path)
        if !isdir(path)
            throw(ArgumentError(("Invalid local path in remotes (not a directory): $(path)")))
        end
        path = realpath(path)
        # We'll also check that there are no duplicate entries.
        idx = findfirst(isequal(path), [remote.root for remote in remotes_checked])
        if !isnothing(idx)
            msg = """
            Duplicate remote path in remotes: $(path) => $(remoteref)
            vs $(remotes_checked[idx])
            """
            throw(ArgumentError(msg))
        end
        # Now we actually check the remotes themselves
        remote = if remoteref isa Tuple{Remotes.Remote, AbstractString}
            RemoteRepository(path, remoteref[1], remoteref[2])
        elseif remoteref isa Remotes.Remote
            RemoteRepository(path, remoteref)
        else
            msg = """
            Invalid remote in remotes: $(remoteref) (::$(typeof(remoteref)))
            for path $path
            must be ::Remotes.Remote or ::Tuple{Remotes.Remote, AbstractString}"""
            throw(ArgumentError(msg))
        end
        addremote!(remotes_checked, remote)
    end

    # We'll normalize repo to be a `Remotes.Remote` object (or nothing if omitted)
    repo_normalized::Union{Remotes.Remote, Nothing} = if isa(repo, AbstractString) && isempty(repo)
        # If the user does not provide the `repo` argument, we'll try to automatically
        # detect the remote repository later. But for now, we'll set it to `nothing`.
        nothing
    elseif repo isa AbstractString
        # Use the old template string parsing logic if a string was passed.
        Remotes.URL(repo)
    else
        # Otherwise it should be some Remote object, so we'll just use that.
        repo
    end

    # Now we sort out the interaction between `repo` and `remotes`. Our goal is to make sure that we have a
    # value in both remotes for the repository root, and also that we get the correct value for the main
    # .remote.
    #
    # The .root may be either in a Git repository, or inside one for the `remotes`, or both. If it is both,
    # we need to sort of if one is more specific than the other.
    #
    # TODO: figure out how to re-use relpath_from_remote_root here.
    makedocs_root_remoteref = nothing
    find_root_parent(root) do directory
        for remoteref in remotes_checked
            @debug "interpret_repo_and_remotes / find_root_parent" directory remoteref.root
            if directory == remoteref.root
                makedocs_root_remoteref = remoteref
                return true
            end
        end
        return false
    end
    makedocs_root_repo::Union{String, Nothing} = find_root_parent(is_git_repo_root, root)
    makedocs_root_remote::Union{Remotes.Remote, Nothing} = isnothing(makedocs_root_repo) ? nothing : getremote(makedocs_root_repo)
    @debug "interpret_repo_and_remotes" remotes_checked repo_normalized makedocs_root_remoteref makedocs_root_repo makedocs_root_remote
    if !isnothing(makedocs_root_remoteref) && !isnothing(makedocs_root_repo)
        # If both are set, then there is potential for conflict.
        if makedocs_root_remoteref.root == makedocs_root_repo
            # If they are the same, then the reference from remotes should take priority.
            @debug "Remotes: remotes takes precedence over automatically determined remote" makedocs_root_remoteref makedocs_root_repo makedocs_root_remote repo_normalized
            # But we must sure that `repo` was not set, since that would conflict.
            if !isnothing(repo_normalized)
                err = """
                Conflicting remote reference for main repo -- `repo` and `remotes` both configure the same path:
                  path: $(makedocs_root_repo)
                  remotes entry: $(makedocs_root_remoteref.remote)
                  repo: $(repo_normalized)
                """
                throw(ArgumentError(err))
            end
            # If repo is not set, then remotes takes precedence.
            makedocs_root_remote = makedocs_root_remoteref.remote
        elseif startswith(makedocs_root_remoteref.root, makedocs_root_repo)
            # In this case the automatically determined root is outside of a path configured
            # with remotes. In that case, the remote in `remotes` takes precedence as well.
            @debug "Remotes: `remotes` takes precedence over automatically determined remote" makedocs_root_remoteref makedocs_root_repo makedocs_root_remote repo_normalized
            makedocs_root_remote = makedocs_root_remoteref.remote
        elseif startswith(makedocs_root_repo, makedocs_root_remoteref.root)
            # In this case we determined that root of the repository is more specific than
            # whatever we found in remotes. So the main remote will be determined from the Git
            # repository. This will be a no-op, except that `repo` argument may override the
            # automatically determined remote.
            if !isnothing(repo_normalized)
                @debug "Remotes: repo takes precedence over automatically determined remote" makedocs_root_remoteref makedocs_root_repo makedocs_root_remote repo_normalized
                makedocs_root_remote = repo_normalized
            else
                @debug "Remotes: repo not set, using automatically determined remote" makedocs_root_remoteref makedocs_root_repo makedocs_root_remote repo_normalized
            end
            # Since this path was not in remotes, we also need to add it there.
            addremote!(remotes_checked, RemoteRepository(makedocs_root_repo, makedocs_root_remote))
        else
            # The final case is where the two repo paths have different roots, which should never
            # happen.
            error(
                """
                Unexpected repository roots -- must have a common prefix.
                makedocs_root_remoteref.root: $(makedocs_root_remoteref.root)
                makedocs_root_repo: $(makedocs_root_repo)
                """
            )
        end
    elseif !isnothing(makedocs_root_remoteref) && isnothing(makedocs_root_repo)
        # If we found something in remotes, but were not able to determine the root of the Git repository,
        # we will use the remote from remotes. But we also check for conflicts with `repo`.
        @debug "Remotes: `repo` not set, using remotes" makedocs_root_remoteref makedocs_root_repo makedocs_root_remote repo_normalized
        if !isnothing(repo_normalized)
            err = """
            Conflicting remote reference for main repo -- `repo` and `remotes` both configure the same path:
              path: $(makedocs_root_remoteref.root)
              remotes entry: $(makedocs_root_remoteref.remote)
              repo: $(repo_normalized)
            """
            throw(ArgumentError(err))
        end
        makedocs_root_remote = makedocs_root_remoteref.remote
    elseif isnothing(makedocs_root_remoteref) && !isnothing(makedocs_root_repo)
        # If we found a Git repository, but nothing in remotes, we will use the remote from the
        # repository, which can optionally be overridden by `repo`. However, if we are unable to
        # determine the repo from the Git repository, we will throw an error.
        @debug "Remotes: using automatically determined remote" makedocs_root_remoteref makedocs_root_repo makedocs_root_remote repo_normalized
        if !isnothing(repo_normalized)
            makedocs_root_remote = repo_normalized
        elseif isnothing(makedocs_root_remote)
            err = """
            Unable to automatically determine remote for main repo.
            > `repo` is not set, and the Git repository has invalid origin.
            Configure `repo` and/or `remotes` appropriately, or set `remotes = nothing` to disable remote source
            links altogether (e.g. if not working in a Git repository).
              path: $(makedocs_root_repo)"""
            throw(ArgumentError(err))
        end
        # Since this path was not in remotes, we also need to add it there.
        addremote!(remotes_checked, RemoteRepository(makedocs_root_repo, makedocs_root_remote))
    else
        # Finally, if we're neither in a git repo, and nothing is in remotes,
        err = "Unable to automatically determine remote for main repo."
        err *= '\n'
        err *= if isnothing(repo_normalized)
            """> `repo` is not set, and makedocs is not in a Git repository.
            Configure `repo` and/or `remotes` appropriately, or set `remotes = nothing` to disable remote source
            links altogether (e.g. if not working in a Git repository)."""
        else
            """> `repo` is set but makedocs is not in a Git repository. You should configure `remotes` instead,
            with the appropriate local path pointing to the repository root."""
        end
        err *= '\n'
        err *= "  repo: $(repo_normalized)"
        throw(ArgumentError(err))
    end

    return (makedocs_root_remote, remotes_checked)
end

# Converts the warnonly keyword argument to a Vector{Symbol}
reduce_warnonly(warnonly::Bool) = reduce_warnonly(warnonly ? ERROR_NAMES : Symbol[])
reduce_warnonly(s::Symbol) = reduce_warnonly(Symbol[s])
function reduce_warnonly(warnonly)
    warnonly = Symbol[s for s in warnonly]
    extra_names = setdiff(warnonly, ERROR_NAMES)
    if !isempty(extra_names)
        msg = """
        Keyword argument `warnonly` given invalid values: $(extra_names)
        Valid options are: $(ERROR_NAMES)
        """
        throw(ArgumentError(msg))
    end
    return warnonly
end

"""
    is_strict(::Document, val::Symbol) -> Bool

Internal function to check if Documenter should throw an error or simply
print a warning when hitting error condition.

Single-argument `is_strict(strict)` provides a curried function.
"""
function is_strict(doc::Document, val::Symbol)
    val in ERROR_NAMES || throw(ArgumentError("Invalid val in is_strict: $val"))
    return !(val ∈ doc.user.warnonly)
end
is_strict(doc::Document) = Base.Fix1(is_strict, doc)

function addremote!(remotes::Vector{RemoteRepository}, remoteref::RemoteRepository)
    for ref in remotes
        if ref.root == remoteref.root
            error("Duplicate path in doc.user.remotes: $(remoteref.root)")
        end
    end
    push!(remotes, remoteref)
    # At this point we assume that all the paths are absolute and fully resolved, so
    # we can check for subpaths by just doing startswith. This also means that any path
    # that is longer than another will be a subpath (as we assume they are all directories
    # as well). So we put the longest names first in the list, and check for subpaths
    # by just linearly walking through this list.
    sortremotes!(remotes)
    return nothing
end
addremote!(doc::Document, remoteref::RemoteRepository) = addremote!(doc.user.remotes, remoteref)
# We'll sort the remotes, first, to make sure that the longer paths come first,
# so that we could match them first. How the individual paths are sorted is pretty
# unimportant, but we just want to make sure they are sorted in some well-defined
# order.
sortremotes!(remotes::Vector{RemoteRepository}) = sort!(remotes, lt = lt_remotepair)
function lt_remotepair(r1::RemoteRepository, r2::RemoteRepository)
    if length(r1.root) == length(r2.root)
        return r1.root < r2.root
    end
    return length(r1.root) > length(r2.root)
end

function build_dep_info_dicts(doc::Document)
    for (uuid, dep) in pairs(Pkg.dependencies())
        doc.internal.src_to_uuid[dep.source] = uuid
        if dep.version === nothing || dep.tree_hash === nothing
            continue
        end
        doc.internal.uuid_to_version_info[uuid] = (dep.version, dep.tree_hash)
    end
    return
end

function get_src_to_uuid(doc::Document)
    if isempty(doc.internal.src_to_uuid)
        build_dep_info_dicts(doc)
    end
    return doc.internal.src_to_uuid
end

function get_uuid_to_version_info(doc::Document)
    if isempty(doc.internal.uuid_to_version_info)
        build_dep_info_dicts(doc)
    end
    return doc.internal.uuid_to_version_info
end

function get_pkginfo(uuid)
    for registry in RegistryInstances.reachable_registries()
        for (registry_uuid, pkg) in registry.pkgs
            if registry_uuid == uuid
                return RegistryInstances.registry_info(pkg)
            end
        end
    end
    return
end

function uuid_to_repo(doc, uuid)
    pkginfo = get_pkginfo(uuid)
    uuid_to_version_info = get_uuid_to_version_info(doc)
    if !(uuid in keys(uuid_to_version_info))
        return nothing
    end
    version = uuid_to_version_info[uuid][1]
    if pkginfo === nothing
        @debug "package not found in registries" uuid
        return nothing
    end
    remote = parse_remote_url(pkginfo.repo)
    if !(remote isa Remotes.GitHub)
        @debug "could not get hash from repo -- only GitHub supported for now" pkginfo.repo
        return nothing
    end
    tag_guess = "v" * string(version)
    return (remote, tag_guess)
end


"""
    $(SIGNATURES)

Returns the remote that contains the file, and the relative path of the
file within the repo (or `nothing, nothing` if the file is not in a known repo).
"""
function relpath_from_remote_root(doc::Document, path::AbstractString)
    remotes = doc.user.remotes
    if remotes === nothing
        # It's possible that doc.user.remotes is set to nothing, in which case
        # we are not able to determine remote links.
        return nothing
    end
    ispath(path) || error("relpath_from_repo_root called with nonexistent path: $path")
    isabspath(path) || error("relpath_from_repo_root called with non-absolute path: $path")
    # We want to expand the path properly, including symlinks, so we call realpath()
    # Note: it throws for non-existing files, but we just checked for it.
    path = realpath(path)
    # Try to see if `path` falls into any of the remotes in .remotes, or if it's a GitHub repository
    # we can automatically "configure".
    root_remote::Union{RemoteRepository, Nothing} = nothing
    root_directory = find_root_parent(path) do directory
        # First, we'll check the list of existing remotes, to see if the directory is already
        # listed there. If yes, we just return that.
        for remoteref in remotes
            if directory == remoteref.root
                root_remote = remoteref
                return true
            end
        end
        # If it is not in .remotes, it is still possible that the directory is a Git repository.
        # In that case, we add it to .remotes.
        if is_git_repo_root(directory)
            # getremote() can only detect GitHub repositories right now, so there is a good
            # chance that it will return `nothing`. In that we also abort the check, because
            # we won't be able to correctly determine the remote (as we might incorrectly fall
            # back to the remote of one of the parent directories).
            remote = getremote(directory)
            if !isnothing(remote)
                # TODO: we might need the ability to skip the remote auto detection for certain
                # directories.. This could be done by allowing e.g. `nothing`s in `doc.user.remotes`
                # and `continue`-ing if we detect that. But let's not add that complexity now.
                # TODO: the RemoteRepository() call may throw -- we should handle this more gracefully
                remoteref = RemoteRepository(directory, remote)
                @debug "relpath_from_remote_root: adding .git directory -based remote" remoteref
                addremote!(remotes, remoteref)
                root_remote = remoteref
            end
            return true
        end
        # Finally, we can try figuring out the remote from information
        # obtainable through Pkg
        src_to_uuid = get_src_to_uuid(doc)
        if haskey(src_to_uuid, directory)
            uuid = src_to_uuid[directory]
            repo_info = uuid_to_repo(doc, uuid)

            if repo_info !== nothing
                remoteref = RemoteRepository(directory, repo_info[1], repo_info[2])
                @debug "relpath_from_remote_root: adding pkg registry -based remote" remoteref
                addremote!(remotes, remoteref)
                root_remote = remoteref
                return true
            end
        end
        return false
    end
    # If we were not able to detect the remote
    if isnothing(root_remote)
        return nothing
    else
        # When root_remote is set, so should be root_directory
        @assert !isnothing(root_directory)
        return (; repo = root_remote, relpath = relpath(path, root_directory))
    end
end

# Determines the Edit URL for a local path.
#  - rev: indicates a Git revision; if omitted, the current repo commit is used.
# May return nothing if it is unable to determine the local path.
function edit_url(doc::Document, path; rev::Union{AbstractString, Nothing})
    # If the user has disabled remote links, we abort immediately
    isnothing(doc.user.remotes) && return nothing
    # We'll prepend doc.user.root, unless already an absolute path.
    path = abspath(doc.user.root, path)
    if !ispath(path)
        error("Unable to generate remote link (local path does not exist)\n path: $(path)")
    end
    remoteref = relpath_from_remote_root(doc, path)
    if isnothing(remoteref)
        throw(MissingRemoteError(; path))
    end
    rev = isnothing(rev) ? remoteref.repo.commit : rev
    @debug "edit_url" path remoteref rev
    return repofile(remoteref.repo.remote, rev, remoteref.relpath)
end

source_url(doc::Document, docstring) = source_url(
    doc, docstring.data[:module], docstring.data[:path], linerange(docstring)
)

function source_url(doc::Document, mod::Module, file::AbstractString, linerange)
    # If the user has disabled remote links, we abort immediately
    isnothing(doc.user.remotes) && return nothing
    # needed since julia v0.6, see #689
    file === nothing && return nothing
    # Non-absolute paths generally indicate methods from Base.
    if inbase(mod) || !isabspath(file)
        ref = if isempty(Base.GIT_VERSION_INFO.commit)
            "v$VERSION"
        else
            Base.GIT_VERSION_INFO.commit
        end
        return repofile(julia_remote, ref, "base/$file", linerange)
    end
    # Generally, we assume that the Julia source file exists on the system.
    isfile(file) || return nothing
    remoteref = relpath_from_remote_root(doc, file)
    if isnothing(remoteref)
        throw(MissingRemoteError(; path = file, linerange, mod))
    end
    @debug "source_url" mod file linerange remoteref
    return repofile(remoteref.repo.remote, remoteref.repo.commit, remoteref.relpath, linerange)
end

"""
    Documenter.getplugin(doc::Document, T) -> Plugin

Retrieves the object for the [`Plugin`](@ref) sub-type `T` stored in `doc`. If an
object of type `T` was an element of the `plugins` list passed to [`makedocs`](@ref),
that object will be returned. Otherwise, a new `T` object will be created using the default
constructor `T()`. Subsequent calls to `getplugin(doc, T)` return the same object.
"""
function getplugin(doc::Document, plugin_type::Type{T}) where {T <: Plugin}
    if !haskey(doc.plugins, plugin_type)
        doc.plugins[plugin_type] = plugin_type()
    end

    return doc.plugins[plugin_type]
end

## Methods

function addpage!(doc::Document, src::AbstractString, dst::AbstractString, wd::AbstractString)
    page = Page(src, dst, wd)
    # page's identifier is the path relative to the `doc.user.source` directory
    name = pagekey(doc, page)
    # This check is here to make sure that the new function matches the old
    # (correct) implementation.
    @assert name == normpath(relpath(src, doc.user.source))
    doc.blueprint.pages[name] = page
    return
end

# The page.source field is relative to doc.user.root, but the keys in
# doc.blueprint.pages are relative to doc.user.source (which is itself
# relative to doc.user.root). This function calculates the key corresponding
# to a page.
pagekey(doc::Document, page::Page) = normpath(
    relpath(
        joinpath(doc.user.root, page.source),
        joinpath(doc.user.root, doc.user.source)
    )
)

"""
$(SIGNATURES)

Populates the `ContentsNode`s and `IndexNode`s of the `document` with links.

This can only be done after all the blocks have been expanded (and nodes constructed),
because the items have to exist before we can gather the links to those items.
"""
function populate!(document::Document)
    for node in document.internal.contentsnodes
        populate!(node, document)
    end
    for node in document.internal.indexnodes
        populate!(node, document)
    end
    return
end

function populate!(index::IndexNode, document::Document)
    # Filtering valid index links.
    for (object, doc) in document.internal.objects
        page = relpath(doc.page.build, dirname(index.build))
        mod = object.binding.mod
        # Include *all* signatures, whether they are `Union{}` or not.
        cat = Symbol(lowercase(doccat(object.binding, Union{})))
        if is_canonical(object) && _isvalid(page, index.pages) && _isvalid(mod, index.modules) && _isvalid(cat, index.order)
            push!(index.elements, (object, doc, page, mod, cat))
        end
    end
    # Sorting index links.
    pagesmap = precedence(index.pages)
    modulesmap = precedence(index.modules)
    ordermap = precedence(index.order)
    comparison = function (a, b)
        (x = _compare(pagesmap, 3, a, b)) == 0 || return x < 0 # page
        (x = _compare(modulesmap, 4, a, b)) == 0 || return x < 0 # module
        (x = _compare(ordermap, 5, a, b)) == 0 || return x < 0 # category
        return string(a[1].binding) < string(b[1].binding)              # object name
    end
    sort!(index.elements, lt = comparison)
    return index
end

function populate!(contents::ContentsNode, document::Document)
    # Filtering valid contents links.
    for (id, filedict) in document.internal.anchors.map
        for (file, anchors) in filedict
            for anchor in anchors
                page = relpath(anchor.file, dirname(contents.build))
                # Note: This only filters based on contents.depth and *not* contents.mindepth.
                #       Instead the writers who support this adjust this when rendering.
                # Only headers participate in `@contents` listings. The same AnchorMap also
                # holds arbitrary `[content](@id name)` anchors (whose `.object` is an
                # `AnchoredInline`), which must be skipped here.
                if _isvalid(page, contents.pages) && anchor.object isa MarkdownAST.Heading && anchor.object.level ≤ contents.depth
                    push!(contents.elements, (anchor.order, page, anchor))
                end
            end
        end
    end
    # Sorting contents links.
    pagesmap = precedence(contents.pages)
    comparison = function (a, b)
        (x = _compare(pagesmap, 2, a, b)) == 0 || return x < 0 # page
        return a[1] < b[1]                                            # anchor order
    end
    sort!(contents.elements, lt = comparison)
    return contents
end

# some replacements for jldoctest blocks
function doctest_replace!(doc::Documenter.Document)
    for (src, page) in doc.blueprint.pages
        doctest_replace!(page.mdast)
    end
    return
end
function doctest_replace!(ast::MarkdownAST.Node)
    for node in AbstractTrees.PreOrderDFS(ast)
        doctest_replace!(node.element)
    end
    return
end
doctest_replace!(docsnode::DocsNode) = foreach(doctest_replace!, docsnode.mdasts)
function doctest_replace!(block::MarkdownAST.CodeBlock)
    startswith(block.info, "jldoctest") || return
    # suppress output for `#output`-style doctests with `output=false` kwarg
    if occursin(r"^# output$"m, block.code) && occursin(r";.*output\h*=\h*false", block.info)
        input = first(split(block.code, "# output\n", limit = 2))
        block.code = rstrip(input)
    end
    # correct the language field
    return block.info = occursin(r"^julia> "m, block.code) ? "julia-repl" : "julia"
end
doctest_replace!(@nospecialize _) = nothing

function buildnode(T::Type, block, doc, page)
    mod = get(page.globals.meta, :CurrentModule, Main)
    dict = Dict{Symbol, Any}(:source => page.source, :build => page.build)
    for (ex, str) in parseblock(block.code, doc, page)
        if isassign(ex)
            cd(dirname(page.source)) do
                dict[ex.args[1]] = Core.eval(mod, ex.args[2])
            end
        end
    end
    return T(block; dict...)
end

function _compare(col, ind, a, b)
    x, y = a[ind], b[ind]
    return haskey(col, x) && haskey(col, y) ? _compare(col[x], col[y]) : 0
end
_compare(a, b) = a < b ? -1 : a == b ? 0 : 1
_isvalid(x, xs) = isempty(xs) || x in xs
precedence(vec) = Dict(zip(vec, 1:length(vec)))

###########################################################################################
# Conversion to MarkdownAST, for writers

struct AnchoredHeader <: AbstractDocumenterBlock
    anchor::Anchor
end
MarkdownAST.iscontainer(::AnchoredHeader) = true

# A DocsNodesBlock corresponds to one @docs (or @autodocs) code block, and contains
# a list of docstrings, which are represented as child nodes of type DocsNode.
# In addition, the child node can also be an Admonition in case there was an error
# in splicing in a docstring.
struct DocsNodesBlock <: AbstractDocumenterBlock
    codeblock::MarkdownAST.CodeBlock
end
MarkdownAST.iscontainer(::DocsNodesBlock) = true
MarkdownAST.can_contain(::DocsNodesBlock, ::MarkdownAST.AbstractElement) = false
MarkdownAST.can_contain(::DocsNodesBlock, ::Union{DocsNode, MarkdownAST.Admonition}) = true

MarkdownAST.iscontainer(::MultiCodeBlock) = true
MarkdownAST.can_contain(::MultiCodeBlock, ::MarkdownAST.Code) = true

struct MultiOutputElement <: AbstractDocumenterBlock
    element::Any
end
MarkdownAST.iscontainer(::MultiOutput) = true
MarkdownAST.can_contain(::MultiOutput, ::Union{MultiOutputElement, MarkdownAST.CodeBlock}) = true

# In the SetupBlocks expander, we map @setup nodes to Markdown.MD() objects
struct SetupNode <: AbstractDocumenterBlock
    name::String
    code::String
end

# Extend MDFlatten.mdflatten to support the Documenter-specific elements
MDFlatten.mdflatten(io, node::MarkdownAST.Node, ::AnchoredHeader) = MDFlatten.mdflatten(io, node.children)
MDFlatten.mdflatten(io, node::MarkdownAST.Node, ::AnchoredInline) = MDFlatten.mdflatten(io, node.children)
MDFlatten.mdflatten(io, node::MarkdownAST.Node, e::RawNode) = MDFlatten.mdflatten(io, node, MarkdownAST.CodeBlock("@raw $(e.name)", e.text))
MDFlatten.mdflatten(io, node::MarkdownAST.Node, e::AbstractDocumenterBlock) = MDFlatten.mdflatten(io, node, e.codeblock)

# The at-blocks below flatten to what the writers actually render, rather than to
# the source of the at-block, so that the search index does not pick up text that
# is nowhere to be seen on the rendered page (issue #1929).

# @meta and @setup blocks render nothing at all.
MDFlatten.mdflatten(io, ::MarkdownAST.Node, ::Union{MetaNode, SetupNode}) = nothing

# @example and @repl blocks render their children: the input code and, for
# @example, the output of evaluating it.
function MDFlatten.mdflatten(io, node::MarkdownAST.Node, ::Union{MultiOutput, MultiCodeBlock})
    # Children that flatten to nothing (e.g. image output) must not leave a
    # stray separator behind.
    parts = filter(!isempty, [MDFlatten.mdflatten(child) for child in node.children])
    print(io, join(parts, '\n'))
    return
end

# Of the MIME representations of an @example output, only the plain text one is
# meaningful as flattened text; images and the like are dropped.
function MDFlatten.mdflatten(io, ::MarkdownAST.Node, e::MultiOutputElement)
    mime = MIME"text/plain"()
    e.element isa AbstractDict && haskey(e.element, mime) && print(io, e.element[mime])
    return
end

# @eval blocks render only the result of evaluating the block.
function MDFlatten.mdflatten(io, ::MarkdownAST.Node, e::EvalNode)
    isnothing(e.result) || MDFlatten.mdflatten(io, e.result)
    return
end

function MDFlatten.mdflatten(io, ::MarkdownAST.Node, e::DocsNode)
    # this special case separates top level blocks with newlines
    for node in e.mdasts
        MDFlatten.mdflatten(io, node)
        # Docstrings are double wrapped in MD objects, and so led to extra newlines
        # in the old Markdown-based mdflatten()
        print(io, "\n\n\n\n")
    end
    return
end
MDFlatten.mdflatten(io, node::MarkdownAST.Node, ::PageLink) = MDFlatten.mdflatten(io, node.children)
MDFlatten.mdflatten(io, node::MarkdownAST.Node, ::LocalLink) = MDFlatten.mdflatten(io, node.children)
function MDFlatten.mdflatten(io, node::MarkdownAST.Node, ::LocalImage)
    print(io, "(Image: ")
    MDFlatten.mdflatten(io, node.children)
    print(io, ")")
    return
end

module LaTeXWriterTests

using Test
import IOCapture
import Documenter
import Documenter.LaTeXWriter

@testset "file ordering" begin
    # Single page returns a single page
    @test LaTeXWriter.files(["a.md"]) == [("", "a.md", 1)]

    # Multiple pages at the top-level
    @test LaTeXWriter.files(["a.md", "b.md"]) ==
        [("", "a.md", 1), ("", "b.md", 1)]

    # Single header
    @test LaTeXWriter.files(["A" => "a.md"]) == [("A", "a.md", 1)]

    # Single page and a header
    @test LaTeXWriter.files(["a.md", "B" => "b.md"]) ==
        [("", "a.md", 1), ("B", "b.md", 1)]

    # Single page and a vector
    @test LaTeXWriter.files(["a.md", "B" => ["b.md", "c.md"]]) ==
        [("", "a.md", 1), ("B", "", 1), ("", "b.md", 2), ("", "c.md", 2)]

    # Multiple layers of nesting
    @test LaTeXWriter.files(["a.md", "B" => ["b.md", "C" => ["c.md"]]]) == [
        ("", "a.md", 1),
        ("B", "", 1),
        ("", "b.md", 2),
        ("C", "", 2),
        ("", "c.md", 3),
    ]
end


function _dummy_lctx()
    doc = Documenter.Document()
    buffer = IOBuffer()
    return LaTeXWriter.Context(buffer, doc)
end

function _latexesc(str)
    lctx = _dummy_lctx()
    LaTeXWriter.latexesc(lctx, str)
    return String(take!(lctx.io))
end

function _md_to_latex(mdstr)
    lctx = _dummy_lctx()
    ast = Documenter.mdparse(mdstr; mode = :single)[1]
    LaTeXWriter.latex(lctx, ast.children)  # should use latexesc internally
    return String(take!(lctx.io))
end

function _mdblocks_to_latex(mdstr)
    lctx = _dummy_lctx()
    ast = Documenter.mdparse(mdstr; mode = :blocks)
    for node in ast
        LaTeXWriter.latex(lctx, node)
    end
    return String(take!(lctx.io))
end

function _node_to_latex(node)
    lctx = _dummy_lctx()
    LaTeXWriter.latex(lctx, node)
    return String(take!(lctx.io))
end


@testset "latex escapes" begin

    md = "~ Ref.\u00A0[1], O'Reilly, \"Book #1\""
    tex = "{\\textasciitilde} Ref.~[1], O{\\textquotesingle}Reilly, {\\textquotedbl}Book \\#1{\\textquotedbl}"
    @test _latexesc(md) == tex
    @test _md_to_latex(md) == tex

    md = "[DocumenterCitations.jl](https://github.com/JuliaDocs/DocumenterCitations.jl#readme)"
    tex = "\\href{https://github.com/JuliaDocs/DocumenterCitations.jl\\#readme}{DocumenterCitations.jl}"
    @test _md_to_latex(md) == tex

    md = "[Description with ~](https://link.with/~tilde)"
    tex = "\\href{https://link.with/~tilde}{Description with {\\textasciitilde}}"
    @test _md_to_latex(md) == tex

end

@testset "latex optional MarkdownAST nodes" begin
    strikethrough = Documenter.MarkdownAST.Node(Documenter.MarkdownAST.Strikethrough())
    push!(strikethrough.children, Documenter.MarkdownAST.Node(Documenter.MarkdownAST.Text("gone")))
    @test _node_to_latex(strikethrough) == "gone"

    htmlinline = Documenter.MarkdownAST.Node(Documenter.MarkdownAST.HTMLInline("<span>x</span>"))
    @test_logs (:warn, r"Raw HTML inline is not supported in LaTeX output") _node_to_latex(htmlinline) == "x"

    htmlblock = Documenter.MarkdownAST.Node(Documenter.MarkdownAST.HTMLBlock("<div>y</div>"))
    @test_logs (:warn, r"Raw HTML block is not supported in LaTeX output") _node_to_latex(htmlblock) == "y\n"
end

@testset "latex table link fragment PDF regression reproducer" begin
    pdflatex = Sys.which("pdflatex")
    pdflatex === nothing && (@test_skip false; return)

    md = raw"""
    | Type | Description |
    |:---- |:----------- |
    | `A`  | [B](https://example.com/path) |
    | `C`  | [D](https://example.com/path#frag) |
    """
    table_tex = _mdblocks_to_latex(md)
    @test occursin("\\href{https://example.com/path\\#frag}{D}", table_tex)

    mktempdir() do tmp
        texfile = joinpath(tmp, "repro.tex")
        write(
            texfile,
            """
            \\documentclass{article}
            \\usepackage{booktabs}
            \\usepackage{tabulary}
            \\usepackage{hyperref}
            \\begin{document}
            $table_tex
            \\end{document}
            """,
        )
        cmd = `$(pdflatex) -interaction=nonstopmode -halt-on-error repro.tex`
        proc = cd(tmp) do
            p = run(pipeline(cmd; stdout = devnull, stderr = devnull); wait = false)
            wait(p)
            p
        end
        log = read(joinpath(tmp, "repro.log"), String)

        @test success(proc)
        @test !occursin("Illegal parameter number in definition of \\Hy@tempa", log)
    end
end

@testset "LaTeX show_log option" begin
    @test !LaTeXWriter.LaTeX().show_log
    @test LaTeXWriter.LaTeX(show_log = true).show_log
    withenv("DOCUMENTER_LATEX_SHOW_LOGS" => "1") do
        @test LaTeXWriter.LaTeX().show_log
        @test LaTeXWriter.LaTeX(show_log = false).show_log
    end
end

@testset "dump latex log" begin
    mktempdir() do tmp
        output = cd(tmp) do
            open("manual.log", "w") do io
                write(io, "latex failure details\n")
            end
            open("LaTeXWriter.stdout", "w") do io
                write(io, "stdout details\n")
            end
            c = IOCapture.capture() do
                LaTeXWriter.dump_latex_log("manual")
            end
            c.output
        end
        @test occursin("BEGIN manual.log", output)
        @test occursin("latex failure details", output)
        @test occursin("BEGIN LaTeXWriter.stdout", output)
        @test occursin("stdout details", output)
    end

    mktempdir() do tmp
        output = cd(tmp) do
            c = IOCapture.capture() do
                LaTeXWriter.dump_latex_log("manual")
            end
            c.output
        end
        @test occursin("show_log=true but no log files were found", output)
    end
end


end

# Tests for the public doctest() function
#
# If the tests are giving you trouble, you can run the tests with
#
#    JULIA_DEBUG=DocTestAPITests julia doctests.jl
#
# TODO: Combine the makedocs calls and stdout files. Also, allow running them one by one.
#
module DocTestAPITests
using Test
using Documenter
import IOCapture

# Test the Documenter.doctest function
# ------------------------------------
function run_doctest(f, args...; kwargs...)
    c = IOCapture.capture(rethrow = InterruptException) do
        # Starting from 1.13, the Julia test infrastructure uses ScopedValues
        # to handle testsets. So the original task-based approach does not work
        # anymore for "detaching" the doctest testsets from the test suite.
        # But we can manipulate the internal Test module state instead.
        # X-ref: https://github.com/JuliaLang/julia/pull/53462
        @static if VERSION >= v"1.13-"
            Base.ScopedValues.@with(
                Test.CURRENT_TESTSET => Test.FallbackTestSet(),
                Test.TESTSET_DEPTH => 0,
                doctest(args...; kwargs...)
            )
        else
            # Running inside a Task to make sure that the parent testsets do not interfere.
            t = Task(() -> doctest(args...; kwargs...))
            schedule(t)
            # if an exception happens, it gets propagated
            try
                fetch(t)
            catch e
                # Since Julia 1.3, errors in task are wrapped in TaskFailedException, so
                # we need to unwrap it (https://github.com/JuliaLang/julia/pull/32814).
                rethrow(e.task.exception)
            end
        end
    end

    @debug """run_doctest($args;, $kwargs) -> $(c.error ? "fail" : "success")
    ------------------------------------ output ------------------------------------
    $(c.output)
    --------------------------------------------------------------------------------
    """ c.value stacktrace(c.backtrace)

    return f(c.value, !c.error, c.backtrace, c.output)
end

"""
```jldoctest
julia> 2 + 2
4
```
"""
module DocTest1 end

"""
```jldoctest
julia> 2 + 2
5
```
"""
module DocTest2 end

"""
```jldoctest
julia> x
42
```
"""
module DocTest3 end

module DocTest4
    """
    ```jldoctest
    julia> x
    42
    ```
    """
    function foo end
    module Submodule
        """
        ```jldoctest
        julia> x + 1
        43
        ```
        """
        function foo end
    end
end

module DocTest5
    """
    ```jldoctest
    julia> x
    42
    ```
    """
    function foo end
    """
    ```jldoctest
    julia> x
    4200
    ```
    """
    module Submodule
        """
        ```jldoctest
        julia> x + 1
        4201
        ```
        """
        function foo end
    end
end

"""
```jldoctest
julia> println("global filter")
global FILTER
```

```jldoctest; filter = r"local (filter|FILTER)"
julia> println("local filter")
local FILTER
```
"""
module DoctestFilters end

"""
```jldoctest
julia> map(tuple, 1/(i+j) for i=1:2, j=1:2, [1:4;])
ERROR: syntax: invalid iteration specification
```
```jldoctest
julia> 1.2.3
ERROR: syntax: invalid numeric constant "1.2."
```
```jldoctest
println(9.8.7)
# output
ERROR: syntax: invalid numeric constant "9.8."
```
```jldoctest
julia> Meta.ParseError("foo")
Base.Meta.ParseError("foo")

julia> Meta.ParseError("foo") |> throw
ERROR: Base.Meta.ParseError("foo")
Stacktrace:
[...]
```
"""
module ParseErrorSuccess_1x00 end

"""
```jldoctest
julia> map(tuple, 1/(i+j) for i=1:2, j=1:2, [1:4;])
ERROR: ParseError:
# Error @ none:1:44
map(tuple, 1/(i+j) for i=1:2, j=1:2, [1:4;])
#                                          └ ── invalid iteration spec: expected one of `=` `in` or `∈`
Stacktrace:
[...]
```
```jldoctest
julia> 1.2.3
ERROR: ParseError:
# Error @ none:1:1
1.2.3
└──┘ ── invalid numeric constant
[...]
```
```jldoctest
println(9.8.7)
# output
ERROR: ParseError:
# Error @ none:1:9
println(9.8.7)
#       └──┘ ── invalid numeric constant
[...]
```
```jldoctest
julia> Meta.ParseError("foo")
Base.Meta.ParseError("foo", nothing)

julia> Meta.ParseError("foo") |> throw
ERROR: ParseError("foo")
Stacktrace:
[...]
```
"""
module ParseErrorSuccess_1x10 end
# The JuliaSyntax swap in 1.10 changed the printing of parse errors quite considerably
ParseErrorSuccess() = (VERSION >= v"1.10.0-DEV.1520") ? ParseErrorSuccess_1x10 : ParseErrorSuccess_1x00

"""
```jldoctest
julia> map(tuple, 1/(i+j) for i=1:2, j=1:2, [1:4;])
ERROR: syntax: invalid iteration specificationX
```
"""
module ParseErrorFail end

"""
```jldoctest
println(9.8.7)
# output
ERROR: syntax: invalid numeric constant "1.2."
```
"""
module ScriptParseErrorFail end

module PR1075
    "x \$(42) y"
    function qux end
    "..."
    function foo end
    @doc @doc(foo) function bar end
    @doc @doc(bar) function baz end
end

"""
```jldoctest;
julia> 2 + 2
4
```
"""
module BadDocTestKwargs1 end

"""
```jldoctest; %%%
julia> 2 + 2
4
```
"""
module BadDocTestKwargs2 end

"""
```jldoctest; foo
julia> 2 + 2
4
```
"""
module BadDocTestKwargs3 end

@testset "Documenter.doctest" begin
    # DocTest1
    run_doctest(nothing, [DocTest1]) do result, success, backtrace, output
        @test success
        @test result isa Test.DefaultTestSet
    end

    # DocTest2
    run_doctest(nothing, [DocTest2]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end

    # DocTest3
    run_doctest(nothing, [DocTest3]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end
    DocMeta.setdocmeta!(DocTest3, :DocTestSetup, :(x = 42))
    run_doctest(nothing, [DocTest3]) do result, success, backtrace, output
        @test success
        @test result isa Test.DefaultTestSet
    end

    # DocTest4
    run_doctest(nothing, [DocTest4]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end
    DocMeta.setdocmeta!(DocTest4, :DocTestSetup, :(x = 42))
    run_doctest(nothing, [DocTest4]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end
    DocMeta.setdocmeta!(DocTest4, :DocTestSetup, :(x = 42); recursive = true, warn = false)
    run_doctest(nothing, [DocTest4]) do result, success, backtrace, output
        @test success
        @test result isa Test.DefaultTestSet
    end

    # DocTest5
    run_doctest(nothing, [DocTest5]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end
    DocMeta.setdocmeta!(DocTest5, :DocTestSetup, :(x = 42))
    DocMeta.setdocmeta!(DocTest5.Submodule, :DocTestSetup, :(x = 4200))
    run_doctest(nothing, [DocTest5]) do result, success, backtrace, output
        @test success
        @test result isa Test.DefaultTestSet
    end

    # DoctestFilters
    df = [r"global (filt|FILT)(er|ER)" => s"global \1", r"global (filt|FILT)"]
    run_doctest(nothing, [DoctestFilters], doctestfilters = df) do result, success, backtrace, output
        @test success
    end

    # Parse errors in doctests (https://github.com/JuliaDocs/Documenter.jl/issues/1046)
    run_doctest(nothing, [ParseErrorSuccess()]) do result, success, backtrace, output
        @test success
        @test result isa Test.DefaultTestSet
    end
    run_doctest(nothing, [ParseErrorFail]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end
    run_doctest(nothing, [ScriptParseErrorFail]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end

    # PR 1075
    run_doctest(nothing, [PR1075]) do result, success, backtrace, output
        @test success
        @test result isa Test.DefaultTestSet
    end

    # Issue 1556, PR 1557
    run_doctest(nothing, [BadDocTestKwargs1]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end
    run_doctest(nothing, [BadDocTestKwargs2]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end
    run_doctest(nothing, [BadDocTestKwargs3]) do result, success, backtrace, output
        @test !success
        @test result isa TestSetException
    end
end

end # module

module HTMLWriterTests

using Test
import MarkdownAST
using Documenter
using Documenter: DocSystem
using Documenter.HTMLWriter: HTMLWriter, generate_version_file, generate_redirect_file, expand_versions, _strip_latex_math_delimiters

function verify_version_file(versionfile, entries)
    @test isfile(versionfile)
    content = read(versionfile, String)
    idx = 1
    for entry in entries
        i = findnext(entry, content, idx)
        @test i !== nothing
        idx = last(i)
    end
    return
end

function verify_redirect_file(redirectfile, version)
    @test isfile(redirectfile)
    content = read(redirectfile, String)

    return @test occursin("url=./$(version)/", content)
end

@testset "HTMLWriter" begin
    @test isdir(HTMLWriter.ASSETS)
    @test isdir(HTMLWriter.ASSETS_SASS)
    @test isdir(HTMLWriter.ASSETS_THEMES)

    for theme in HTMLWriter.THEMES
        # catppuccin-* themes are templated based on a common catppuccin.scss source file
        scss = replace(theme, r"(?<=^catppuccin)-[a-z]+$" => "")
        @test isfile(joinpath(HTMLWriter.ASSETS_SASS, "$(scss).scss"))
        @test isfile(joinpath(HTMLWriter.ASSETS_THEMES, "$(theme).css"))
    end

    # asset handling
    function assetlink(src, asset)
        links = HTMLWriter.asset_links(src, [asset])
        @test length(links) == 1
        (; node = links[1], links[1].attributes...)
    end
    @test_logs (:error, "Absolute path '/foo' passed to asset_links") HTMLWriter.asset_links(
        "/foo", HTMLWriter.HTMLAsset[]
    )
    let asset = asset("https://example.com/foo.js")
        @test asset.uri == "https://example.com/foo.js"
        @test asset.class == :js
        @test asset.islocal === false
        link = assetlink("my/sub/page", asset)
        @test link.node.name === :script
        @test link.src == "https://example.com/foo.js"
    end
    let asset = asset("https://example.com/foo.js", islocal = false)
        @test asset.islocal === false
        link = assetlink("my/sub/page", asset)
        @test link.src == "https://example.com/foo.js"
    end
    let asset = asset("http://example.com/foo.js", class = :ico)
        @test asset.uri == "http://example.com/foo.js"
        @test asset.class == :ico
        @test asset.islocal === false
    end
    let asset = asset("foo/bar.css", islocal = true)
        @test asset.uri == "foo/bar.css"
        @test asset.class == :css
        @test asset.islocal === true
        link = assetlink("my/sub/page", asset)
        @test link.node.name === :link
        @test link.href == "../../foo/bar.css"
        link = assetlink("page.md", asset)
        @test link.href == "foo/bar.css"
        link = assetlink("foo/bar.md", asset)
        @test link.href == "bar.css"
    end
    @test_throws Exception asset("ftp://example.com/foo.js")
    @test_throws Exception asset("example.com/foo.js")
    @test_throws Exception asset("foo.js")
    @test_throws Exception asset("foo.js", islocal = false)
    @test_throws Exception asset("https://example.com/foo.js?q=1")
    @test_throws Exception asset("https://example.com/foo.js", class = :error)
    # Edge cases that do not actually quite work correctly:
    let asset = asset("https://example.com/foo.js", islocal = true)
        @test asset.uri == "https://example.com/foo.js"
        @test asset.islocal === true
        link = assetlink("my/sub/page", asset)
        @test link.node.name === :script
        # This actually leads to different results on Windows and Linux (on the former, it
        # gets treated as an absolute path).
        if Sys.iswindows()
            @test endswith(link.src, "example.com/foo.js")
        else
            @test link.src == "../../https:/example.com/foo.js"
        end

    end
    @test_logs (:error, "Local asset should not have an absolute URI: /foo/bar.ico") asset("/foo/bar.ico", islocal = true)

    let asset = asset("https://plausible.io/js/plausible.js"; class = :js, attributes = Dict(Symbol("data-domain") => "example.com", :defer => ""))
        @test asset.uri == "https://plausible.io/js/plausible.js"
        @test asset.class == :js
        @test asset.islocal === false
        link = assetlink("my/sub/page", asset)
        @test link.node.name === :script
        @test link.src == "https://plausible.io/js/plausible.js"
        @test Base.getproperty(link, Symbol("data-domain")) == "example.com"
        @test link.defer == ""
    end

    # HTML format object
    @test Documenter.HTML() isa Documenter.HTML
    @test Documenter.HTML(assets = [RawHTMLHeadContent("<!-- hello -->")]) isa Documenter.HTML
    @test_throws ArgumentError Documenter.HTML(collapselevel = -200)
    @test_throws Exception Documenter.HTML(assets = ["foo.js", 10])
    @test_throws ArgumentError Documenter.HTML(footer = "foo\n\nbar")
    @test_throws ArgumentError Documenter.HTML(footer = "# foo")
    @test_throws ArgumentError Documenter.HTML(footer = "")
    @test Documenter.HTML(footer = "foo bar [baz](https://github.com)") isa Documenter.HTML
    @test_throws ErrorException Documenter.HTML(edit_branch = nothing, edit_link = nothing)

    # MathEngine
    let katex = KaTeX()
        @test length(katex.config) == 1
        @test haskey(katex.config, :delimiters)
    end
    let katex = KaTeX(Dict(:foo => 1))
        @test length(katex.config) == 2
        @test haskey(katex.config, :delimiters)
        @test haskey(katex.config, :foo)
    end
    let katex = KaTeX(Dict(:delimiters => 1, :foo => 2))
        @test length(katex.config) == 2
        @test haskey(katex.config, :delimiters)
        @test katex.config[:delimiters] == 1
        @test haskey(katex.config, :foo)
    end

    let mathjax = MathJax2()
        @test length(mathjax.config) == 5
        @test haskey(mathjax.config, :tex2jax)
        @test haskey(mathjax.config, :config)
        @test haskey(mathjax.config, :jax)
        @test haskey(mathjax.config, :extensions)
        @test haskey(mathjax.config, :TeX)
    end
    let mathjax = MathJax2(Dict(:foo => 1))
        @test length(mathjax.config) == 6
        @test haskey(mathjax.config, :tex2jax)
        @test haskey(mathjax.config, :config)
        @test haskey(mathjax.config, :jax)
        @test haskey(mathjax.config, :extensions)
        @test haskey(mathjax.config, :TeX)
        @test haskey(mathjax.config, :foo)
    end
    let mathjax = MathJax2(Dict(:tex2jax => 1, :foo => 2))
        @test length(mathjax.config) == 6
        @test haskey(mathjax.config, :tex2jax)
        @test haskey(mathjax.config, :config)
        @test haskey(mathjax.config, :jax)
        @test haskey(mathjax.config, :extensions)
        @test haskey(mathjax.config, :TeX)
        @test haskey(mathjax.config, :foo)
        @test mathjax.config[:tex2jax] == 1
    end

    mktempdir() do tmpdir
        versionfile = joinpath(tmpdir, "versions.js")
        redirectfile = joinpath(tmpdir, "index.html")
        devurl = "dev"
        versions = [
            "stable", "dev",
            "2.1.1", "v2.1.0", "v2.0.1", "v2.0.0",
            "1.1.1", "v1.1.0", "v1.0.1", "v1.0.0",
            "0.1.1", "v0.1.0",
        ] # note no `v` on first ones

        # make dummy directories of versioned docs
        cd(tmpdir) do
            for version in versions
                mkdir(version)
            end
        end

        # case1: default versioning
        versions = ["stable" => "v^", "v#.#", "dev" => "dev"] # default to makedocs
        entries, symlinks = expand_versions(tmpdir, versions)
        @test entries == ["stable", "v2.1", "v2.0", "v1.1", "v1.0", "v0.1", "dev"]
        @test symlinks == [
            "stable" => "2.1.1", "v2.1" => "2.1.1", "v2.0" => "v2.0.1",
            "v1.1" => "1.1.1", "v1.0" => "v1.0.1", "v0.1" => "0.1.1",
            "v2" => "2.1.1", "v1" => "1.1.1", "v2.1.1" => "2.1.1",
            "v1.1.1" => "1.1.1", "v0.1.1" => "0.1.1",
        ]
        generate_version_file(versionfile, entries)
        verify_version_file(versionfile, entries)
        generate_redirect_file(redirectfile, entries)
        verify_redirect_file(redirectfile, "stable")

        # case2: major released versions
        versions = ["v#"]
        entries, symlinks = expand_versions(tmpdir, versions)
        @test entries == ["v2.1", "v1.1"]
        @test symlinks == [
            "v2.1" => "2.1.1", "v1.1" => "1.1.1", "v2" => "2.1.1", "v1" => "1.1.1",
            "v2.0" => "v2.0.1", "v1.0" => "v1.0.1", "v0.1" => "0.1.1",
            "v2.1.1" => "2.1.1", "v1.1.1" => "1.1.1", "v0.1.1" => "0.1.1",
        ]
        generate_version_file(versionfile, entries)
        verify_version_file(versionfile, entries)
        generate_redirect_file(redirectfile, entries)
        verify_redirect_file(redirectfile, "v2.1")

        # case3: all released versions
        versions = ["v#.#.#"]
        entries, symlinks = expand_versions(tmpdir, versions)
        @test entries == [
            "v2.1.1", "v2.1.0", "v2.0.1", "v2.0.0", "v1.1.1", "v1.1.0",
            "v1.0.1", "v1.0.0", "v0.1.1", "v0.1.0",
        ]
        @test symlinks == [
            "v2.1.1" => "2.1.1", "v1.1.1" => "1.1.1", "v0.1.1" => "0.1.1",
            "v2" => "2.1.1", "v1" => "1.1.1", "v2.1" => "2.1.1",
            "v2.0" => "v2.0.1", "v1.1" => "1.1.1", "v1.0" => "v1.0.1", "v0.1" => "0.1.1",
        ]
        generate_version_file(versionfile, entries)
        verify_version_file(versionfile, entries)
        generate_redirect_file(redirectfile, entries)
        verify_redirect_file(redirectfile, "v2.1.1")

        # case4: invalid versioning
        versions = ["v^", "devel" => "dev", "foobar", "foo" => "bar"]
        entries, symlinks = @test_logs(
            (:warn, "no match for `versions` entry `\"foobar\"`"),
            (:warn, "no match for `versions` entry `\"foo\" => \"bar\"`"),
            expand_versions(tmpdir, versions)
        )
        @test entries == ["v2.1", "devel"]
        @test ("v2.1" => "2.1.1") in symlinks
        @test ("devel" => "dev") in symlinks
        generate_version_file(versionfile, entries)
        verify_version_file(versionfile, entries)
        generate_redirect_file(redirectfile, entries)
        verify_redirect_file(redirectfile, "v2.1")

        # case5: invalid versioning
        versions = ["stable" => "v^", "dev" => "stable"]
        @test_throws ArgumentError expand_versions(tmpdir, versions)

        # case6: default versioning (no released version)
        cd(tmpdir) do
            # remove dummy directories
            for dir in readdir(tmpdir)
                rm(dir)
            end
            mkdir("dev")
        end
        versions = ["stable" => "v^", "v#.#", "dev" => "dev"] # default to makedocs
        entries, symlinks = expand_versions(tmpdir, versions)
        @test entries == ["dev"]
        @test symlinks == []
        generate_version_file(versionfile, entries)
        verify_version_file(versionfile, entries)
        generate_redirect_file(redirectfile, entries)
        verify_redirect_file(redirectfile, "dev")

        # Case 7: no entries
        entries = String[]
        generate_version_file(versionfile, entries)
        verify_version_file(versionfile, entries)
        rm(redirectfile)
        generate_redirect_file(redirectfile, entries)
        @test !isfile(redirectfile)
    end

    @testset "HTML: size_threshold" begin
        @test_throws ArgumentError Documenter.HTML(size_threshold = 0)
        @test_throws ArgumentError Documenter.HTML(size_threshold = -100)
        @test_throws ArgumentError Documenter.HTML(size_threshold_warn = 0)
        @test_throws ArgumentError Documenter.HTML(size_threshold_warn = -100)
        @test_throws ArgumentError Documenter.HTML(size_threshold = -100, size_threshold_warn = -100)
        @test_throws ArgumentError Documenter.HTML(size_threshold = 1, size_threshold_warn = 2)
        # Less than size_threshold_warn:
        @test_throws ArgumentError Documenter.HTML(size_threshold = 1)

        html = Documenter.HTML()
        @test html.size_threshold == 200 * 2^10
        @test html.size_threshold_warn == 100 * 2^10

        html = Documenter.HTML(size_threshold = nothing)
        @test html.size_threshold == typemax(Int)
        @test html.size_threshold_warn == 100 * 2^10

        html = Documenter.HTML(size_threshold = nothing, size_threshold_warn = 1234)
        @test html.size_threshold == typemax(Int)
        @test html.size_threshold_warn == 1234

        html = Documenter.HTML(size_threshold_warn = nothing)
        @test html.size_threshold == 200 * 2^10
        @test html.size_threshold_warn == 200 * 2^10

        html = Documenter.HTML(size_threshold = 1234, size_threshold_warn = nothing)
        @test html.size_threshold == 1234
        @test html.size_threshold_warn == 1234

        html = Documenter.HTML(size_threshold = 12345, size_threshold_warn = 1234)
        @test html.size_threshold == 12345
        @test html.size_threshold_warn == 1234
    end

    @testset "HTML: format_units" begin
        @test HTMLWriter.format_units(0) == "0.0 (bytes)"
        @test HTMLWriter.format_units(1) == "1.0 (bytes)"
        @test HTMLWriter.format_units(1023) == "1023.0 (bytes)"
        @test HTMLWriter.format_units(1024) == "1.0 (KiB)"
        @test HTMLWriter.format_units(4000) == "3.91 (KiB)"
        @test HTMLWriter.format_units(2^20 + 123) == "1.0 (MiB)"
        @test HTMLWriter.format_units(typemax(Int)) == "(no limit)"
    end

    @testset "HTML: _strip_latex_math_delimiters" begin
        for content in [
                "a",
                "x_1",
                "x_{1} + x_{2}",
                "\\begin{array}x_1\\\nx_2\\end{array}",
            ]
            for (left, right) in [("\\[", "\\]"), ("\$", "\$"), ("\$\$", "\$\$")]
                for (input, output) in [
                        content => (false, content),
                        "$left$content$right" => (true, content),
                        " $left$content$right" => (true, content),
                        "$left$content$right " => (true, content),
                        "\t$left$content$right  " => (true, content),
                        " \t$left$content$right\t\t" => (true, content),
                    ]
                    @test _strip_latex_math_delimiters(input) == output
                end
            end
            # Test that miss-matched delimiters are not treated as math
            # delimiters
            for (left, right) in [
                    ("\\[", ""),
                    ("\$", ""),
                    ("\$\$", ""),
                    ("", "\\]"),
                    ("", "\$"),
                    ("", "\$\$"),
                    ("\$", "\\]"),
                    ("\$\$", "\$"),
                    ("\$", "\$\$"),
                ]
                for input in [
                        content,
                        "$left$content$right",
                        " $left$content$right",
                        "$left$content$right ",
                        "\t$left$content$right  ",
                        " \t$left$content$right\t\t",
                    ]
                    @test _strip_latex_math_delimiters(input) == (false, input)
                end
            end
        end
    end

end

end

# Represents the evaluation results for a single search query
struct QueryResult
    query::String
    precision::Float64
    recall::Float64
    f1::Float64
    expected::Vector{String}
    actual::Vector{String}
    # Raw integer values used in calculations
    relevant_count::Int  # Number of relevant documents found
    total_retrieved::Int  # Total number of documents retrieved
    total_relevant::Int   # Total number of relevant documents
end

# Aggregates evaluation results across multiple search queries
struct EvaluationResults
    individual_results::Vector{QueryResult}
    average_precision::Float64
    average_recall::Float64
    average_f1_score::Float64
    # Raw integer values for overall evaluation
    total_relevant_found::Int    # Total number of relevant documents found across all queries
    total_documents_retrieved::Int  # Total number of documents retrieved across all queries
    total_relevant_documents::Int   # Total number of relevant documents across all queries
end

# Calculates precision for search results against expected documents
# Precision = (relevant documents found) / (total documents retrieved)
# Returns precision score, count of relevant documents found, and total documents retrieved
function calculate_precision(results, expected_docs)
    if isempty(results)
        return 0.0, 0, 0
    end

    relevant_count = length(intersect(results, expected_docs))
    total_retrieved = length(results)

    return relevant_count / total_retrieved, relevant_count, total_retrieved
end

# Calculates recall for search results against expected documents
# Recall = (relevant documents found) / (total relevant documents)
# Measures completeness of the search results - how many of the relevant documents were found
# Returns recall score, count of relevant documents found, and total relevant documents
function calculate_recall(results, expected_docs)
    if isempty(expected_docs)
        return 1.0, 0, 0
    end

    found_count = length(intersect(results, expected_docs))
    total_relevant = length(expected_docs)

    return found_count / total_relevant, found_count, total_relevant
end

# Calculates F1 score from precision and recall values
# F1 = 2 * (precision * recall) / (precision + recall)
# Combines precision and recall into a single score, giving equal weight to both metrics
# Returns 0.0 if both precision and recall are 0
function calculate_f1(precision, recall)
    if precision + recall == 0
        return 0.0
    end

    return 2 * (precision * recall) / (precision + recall)
end

# Evaluates a single search query using the provided search function
# Returns a QueryResult containing precision, recall, and F1 metrics
function evaluate_query(search_function, query::TestQuery, search_index_path::String)
    results = search_function(query.query, search_index_path)

    precision, relevant_count, total_retrieved = calculate_precision(results, query.expected_docs)
    recall, found_count, total_relevant = calculate_recall(results, query.expected_docs)
    f1 = calculate_f1(precision, recall)

    return QueryResult(
        query.query,
        precision,
        recall,
        f1,
        query.expected_docs,
        results,
        relevant_count,
        total_retrieved,
        total_relevant
    )
end

# Evaluates multiple search queries and aggregates the results
# Returns an EvaluationResults containing average metrics across all queries
function evaluate_all(search_function, queries, search_index_path::String)
    results = [evaluate_query(search_function, q, search_index_path) for q in queries]

    avg_precision = mean([r.precision for r in results])
    avg_recall = mean([r.recall for r in results])
    avg_f1 = mean([r.f1 for r in results])

    # Calculate total raw values across all queries
    total_relevant_found = sum(r.relevant_count for r in results)
    total_documents_retrieved = sum(r.total_retrieved for r in results)
    total_relevant_documents = sum(r.total_relevant for r in results)

    return EvaluationResults(
        results,
        avg_precision,
        avg_recall,
        avg_f1,
        total_relevant_found,
        total_documents_retrieved,
        total_relevant_documents
    )
end

# To fix all the output reference files, run this file with
#
#    DOCUMENTER_FIXTESTS= julia doctests.jl
#
# If the inputs and outputs are giving you trouble, you can run the tests with
#
#    JULIA_DEBUG=DocTestsTests julia doctests.jl
#
# TODO: Combine the makedocs calls and stdout files. Also, allow running them one by one.
#
module DocTestsTests
using Test
using Documenter
using Documenter.TextDiff: Diff, Words
import IOCapture

include("src/FooWorking.jl")
include("src/FooBroken.jl")
include("src/NoMeta.jl")

const builds_directory = joinpath(@__DIR__, "builds")
ispath(builds_directory) && rm(builds_directory, recursive = true)
mkpath(builds_directory)

function run_makedocs(f, mdfiles, modules = Module[]; kwargs...)
    dir = mktempdir(builds_directory)
    srcdir = joinpath(dir, "src"); mkpath(srcdir)

    for mdfile in mdfiles
        cp(joinpath(@__DIR__, "src", mdfile), joinpath(srcdir, mdfile))
    end
    # Create a dummy index.md file so that we wouldn't generate the "can't generated landing
    # page" warning.
    touch(joinpath(srcdir, "index.md"))

    c = IOCapture.capture(rethrow = InterruptException) do
        # In case JULIA_DEBUG is set to something, we'll override that, so that we wouldn't
        # get some unexpected debug output from makedocs.
        withenv("JULIA_DEBUG" => "") do
            makedocs(
                sitename = " ",
                format = Documenter.HTML(edit_link = "master"),
                root = dir,
                modules = modules;
                kwargs...
            )
        end
    end

    @debug """run_makedocs($mdfiles, modules=$modules) -> $(c.error ? "fail" : "success")
    ------------------------------------ output ------------------------------------
    $(c.output)
    --------------------------------------------------------------------------------
    """ c.value stacktrace(c.backtrace) dir

    write(joinpath(dir, "output"), c.output)
    write(joinpath(dir, "output.onormalize"), onormalize(c.output))
    open(joinpath(dir, "result"), "w") do io
        show(io, "text/plain", c.value)
        println(io, "-"^80)
        show(io, "text/plain", stacktrace(c.backtrace))
    end

    return f(c.value, !c.error, c.backtrace, c.output)
end

function printoutput(result, success, backtrace, output)
    printstyled("="^80, color = :cyan); println()
    println(output)
    printstyled("-"^80, color = :cyan); println()
    println(repr(result))
    printstyled("-"^80, color = :cyan)
    return println()
end

function onormalize(s)
    # Runs a bunch of regexes on captured documenter output strings to remove any machine /
    # platform / environment / time dependent parts, so that it would actually be possible
    # to compare Documenter output to previously generated reference outputs.

    # We need to make sure that, if we're running the tests on Windows, that we'll have consistent
    # line breaks. So we'll normalize CRLF to LF.
    if Sys.iswindows()
        s = replace(s, "\r\n" => "\n")
    end

    # Remove filesystem paths in doctests failures
    s = replace(s, r"(doctest failure in )(.*)$"m => s"\1{PATH}")
    s = replace(s, r"(@ Documenter )(.*)$"m => s"\1{PATH}")
    s = replace(s, r"(@ Documenter.HTMLWriter )(.*)$"m => s"\1{PATH}")
    s = replace(s, r"(top-level scope at )(.*)$"m => s"\1{PATH}")
    s = replace(s, r"(Cannot extract version for inventory from )(.*):(.*)$"m => s"\1{PATH}:\3")
    # Remove line numbers from Julia source line references (like in stacktraces)
    # Note: currently only supports top-level files (e.g. ./error.jl, but not ./strings/basic.jl)
    s = replace(s, r"Base (\.[\\/])?([A-Za-z0-9\.]+):[0-9]+\s*$"m => s"Base ./\2:LL")

    # Remove stacktraces
    s = replace(s, r"(│\s+Stacktrace:)(\n(│\s+)\[[0-9]+\].*)(\n(│\s+)@.*)?+" => s"\1\\n\3{STACKTRACE}")

    # In Julia 1.9, the printing of UndefVarError has slightly changed (added backticks around binding name)
    s = replace(s, r"UndefVarError: `([A-Za-z0-9.]+)` not defined"m => s"UndefVarError: \1 not defined")

    # Remove floating point numbers
    s = replace(s, r"([0-9]*\.[0-9]{8})[0-9]+" => s"\1***")

    return s
end

function is_same_as_file(output, filename)
    # Compares output to the contents of a reference file. Runs onormalize on both strings
    # before doing a character-by-character comparison.
    fixtests = haskey(ENV, "DOCUMENTER_FIXTESTS")
    success = if isfile(filename)
        reference = read(filename, String)
        if onormalize(reference) != onormalize(output)
            @error """Output does not agree with reference file
            ref: $(filename)
            """
            ps(s::AbstractString) = printstyled(stdout, s, '\n'; color = :magenta, bold = true)
            "------------------------------------ output ------------------------------------" |> ps
            output |> println
            "---------------------------------- reference -----------------------------------" |> ps
            reference |> println
            "------------------------------ onormalize(output) ------------------------------" |> ps
            onormalize(output) |> println
            "---------------------------- onormalize(reference) -----------------------------" |> ps
            onormalize(reference) |> println
            "------------------------------------- diff -------------------------------------" |> ps
            diff = Diff{Words}(onormalize(reference), onormalize(output))
            diff |> println
            "------------------------------------- end --------------------------------------" |> ps
            false
        else
            true
        end
    else
        fixtests || error("Missing reference file: $(filename)")
        false
    end
    if fixtests && !success
        @info "Updating $(filename)"
        write(filename, output)
        success = true
    end
    return success
end

const MINVERSION = v"0.0.0-"

function rfile(index::Integer)
    reference_directory = joinpath(@__DIR__, "stdouts")
    reference_file, versionmatch = "", MINVERSION
    for filename in readdir(reference_directory)
        m = match(r"^(?<index>[0-9]+)(?:\.v(?<major>[[0-9]+)_(?<minor>[0-9]+))?\.stdout$", filename)
        # If the regex doesn't match, then we're not interested in this file
        isnothing(m) && continue
        # Similarly, we're only interested in collecting up the reference files that match `index`
        m[:index] == string(index) || continue
        # Parse the version, or stick to a fallback value if the filename does not contain a version number.
        version = if isnothing(m[:major])
            # This is the fallback version, matching everything
            MINVERSION
        else
            major, minor = parse(Int, m[:major]), parse(Int, m[:minor])
            # Format as 'v$(major).$(minor).0-'. This should match every version within a minor version,
            # including all the -DEV etc. prereleases.
            VersionNumber(major, minor, 0, ("",))
        end
        if (version <= VERSION) && (version >= versionmatch)
            reference_file, versionmatch = joinpath(reference_directory, filename), version
        end
    end
    # If `reference_file` is still an empty string, then the loop above failed because the appropriate
    # reference file is missing.
    isempty(reference_file) && error("Unable to find reference files for $(index).stdout, VERSION=$VERSION")
    return reference_file
end

@testset "doctesting" begin
    # So, we have 4 doctests: 2 in a docstring, 2 in an .md file. One of either pair is
    # OK, other is broken. Here we first test all possible combinations of these doctest
    # to make sure that the doctests are indeed failing.
    #
    # Some tests are broken due to https://github.com/JuliaDocs/Documenter.jl/issues/974
    run_makedocs(["working.md"]) do result, success, backtrace, output
        @test success
        @test is_same_as_file(output, rfile(1))
    end

    run_makedocs(["broken.md"]) do result, success, backtrace, output
        @test !success
        @test is_same_as_file(output, rfile(2))
    end

    run_makedocs(["working.md", "fooworking.md"]; modules = [FooWorking]) do result, success, backtrace, output
        @test success
        @test is_same_as_file(output, rfile(3))
    end

    run_makedocs(["working.md", "foobroken.md"]; modules = [FooBroken]) do result, success, backtrace, output
        @test !success
        @test is_same_as_file(output, rfile(4))
    end

    run_makedocs(["broken.md", "fooworking.md"]; modules = [FooWorking]) do result, success, backtrace, output
        @test !success
        @test is_same_as_file(output, rfile(5))
    end

    for warnonly in (false, :autodocs_block, Documenter.except(:doctest))
        run_makedocs(["broken.md", "foobroken.md"]; modules = [FooBroken], warnonly) do result, success, backtrace, output
            @test !success
            @test is_same_as_file(output, rfile(6))
        end
    end

    run_makedocs(["fooworking.md"]; modules = [FooWorking]) do result, success, backtrace, output
        @test success
        @test is_same_as_file(output, rfile(7))
    end

    run_makedocs(["foobroken.md"]; modules = [FooBroken]) do result, success, backtrace, output
        @test !success
        @test is_same_as_file(output, rfile(8))
    end

    # Here we try the former default (strict = false, now warnonly = true) --
    # output should say that doctest failed, but success should still be true.
    run_makedocs(["working.md"]; warnonly = true) do result, success, backtrace, output
        @test success
        @test is_same_as_file(output, rfile(11))
    end

    # Three options that do not strictly check doctests, including testing the default
    for warnonly_kw in ((; warnonly = true), (; warnonly = Documenter.except(:meta_block)))
        run_makedocs(["broken.md"]; warnonly_kw...) do result, success, backtrace, output
            @test success
            @test is_same_as_file(output, rfile(12))
        end
    end

    # Tests for doctest = :only. The output should reflect that the docs themselves do not
    # get built.
    run_makedocs(["working.md"]; modules = [FooWorking], doctest = :only) do result, success, backtrace, output
        @test success
        @test is_same_as_file(output, rfile(21))
    end

    run_makedocs(["working.md"]; modules = [FooBroken], doctest = :only) do result, success, backtrace, output
        @test !success
        @test is_same_as_file(output, rfile(22))
    end

    run_makedocs(["broken.md"]; modules = [FooWorking], doctest = :only) do result, success, backtrace, output
        @test !success
        @test is_same_as_file(output, rfile(23))
    end

    run_makedocs(["broken.md"]; modules = [FooBroken], doctest = :only) do result, success, backtrace, output
        @test !success
        @test is_same_as_file(output, rfile(24))
    end
    # warnonly gets ignored with doctest = :only
    run_makedocs(["broken.md"]; modules = [FooBroken], doctest = :only, warnonly = true) do result, success, backtrace, output
        @test !success
        @test is_same_as_file(output, rfile(25))
    end

    # DocTestSetup in modules
    run_makedocs([]; modules = [NoMeta], doctest = :only) do result, success, backtrace, output
        @test !success
        @test is_same_as_file(output, rfile(31))
    end
    # Now, let's use Documenter's APIs to add the necessary meta information
    DocMeta.setdocmeta!(NoMeta, :DocTestSetup, :(baz(x) = 2x))
    run_makedocs([]; modules = [NoMeta], doctest = :only) do result, success, backtrace, output
        @test success
        @test is_same_as_file(output, rfile(32))
    end

    # Tests for special REPL softscope
    softscope_src = (VERSION >= v"1.11.0-") ? "softscope.v1_11.md" : "softscope.md"
    run_makedocs([softscope_src]; warnonly = true) do result, success, backtrace, output
        @test success
        @test is_same_as_file(output, rfile(41))
    end
end

end # module

using JSON
using NodeJS_22_jll
using Documenter

# Load the real search index from test examples (already built!)
function load_real_search_index(search_index_path)
    # Use the search index from the provided path
    # search_index_path = joinpath(@__DIR__, "../../docs/build/search_index.js")

    if !isfile(search_index_path)
        error("Search index not found at: $search_index_path")
    end

    # Read and parse the JavaScript file
    content = read(search_index_path, String)

    # Find the JSON data after "var documenterSearchIndex = "
    json_start = findfirst("var documenterSearchIndex = ", content)
    if json_start === nothing
        error("Invalid search index format: missing variable declaration")
    end

    # Extract JSON content (everything after the variable declaration)
    json_content = content[(last(json_start) + 1):end]

    # Parse the JSON
    parsed = JSON.parse(json_content)
    return parsed["docs"]  # Return just the docs array
end

# Simple function that uses the existing search.js with real search data
function real_search(query::String, search_index_path::String)
    search_index_data = load_real_search_index(search_index_path)

    # Read the JS wrapper and inject data
    wrapper_js = read(joinpath(@__DIR__, "wrapper.js"), String)
    wrapper_js = replace(wrapper_js, "__SEARCH_INDEX__" => JSON.json(search_index_data))
    wrapper_js = replace(wrapper_js, "__QUERY__" => "\"" * query * "\"")


    # Write the wrapper to a temporary file and run it
    return mktemp(@__DIR__) do path, io
        write(io, wrapper_js)
        close(io)
        cd(@__DIR__) do
            # Install minisearch if it's not there
            if !isdir("node_modules") || !isfile("node_modules/minisearch/package.json")
                version = Documenter.HTMLWriter.MINISEARCH_VERSION
                if version === nothing
                    error("Could not find minisearch version in search.js")
                end
                # We have to pass --prefix here, otherwise npm might try to install
                # minisearch in a different location depending on the environment.
                run(`$(NodeJS_22_jll.npm) --prefix . install minisearch@$(version)`)
            end
            result = read(`$(NodeJS_22_jll.node) $path`, String)
            return JSON.parse(strip(result))
        end
    end
end

"""
A module for rendering `Document` objects to LaTeX and PDF.

# Keywords

[`LaTeXWriter`](@ref) uses the following additional keyword arguments that can be passed to
[`makedocs`](@ref Documenter.makedocs): `authors`, `sitename`.

**`sitename`** is the site's title displayed in the title bar and at the top of the
navigation menu. It goes into the `\\title` LaTeX command.

**`authors`** can be used to specify the authors of. It goes into the `\\author` LaTeX command.

"""
module LaTeXWriter
import ...Documenter: Documenter
using MarkdownAST: MarkdownAST, Node

"""
    Documenter.LaTeX(; kwargs...)

Output format specifier that results in LaTeX/PDF output.
Used together with [`makedocs`](@ref Documenter.makedocs), e.g.

```julia
makedocs(
    format = Documenter.LaTeX()
)
```

The `makedocs` argument `sitename` will be used for the `\\title` field in the tex document.
The `authors` argument should also be specified and will be used for the `\\authors` field
in the tex document. Finally, a version number can be specified with the `version` option to
`LaTeX`, which will be printed in the document and also appended to the output PDF file name.

# Keyword arguments

**`platform`** sets the platform where the tex-file is compiled, either `"native"` (default),
`"tectonic"`, `"docker"`, or "none" which doesn't compile the tex. The option `tectonic`
requires a `tectonic` executable to be available in `PATH` or to be passed as the `tectonic`
keyword.

**`version`** specifies the version number that gets printed on the title page of the manual.
It defaults to the value in the `TRAVIS_TAG` environment variable (although this behaviour is
considered to be deprecated), or to an empty string if `TRAVIS_TAG` is unset.

**`tectonic`** path to a `tectonic` executable used for compilation.

**`show_log`** if `true`, dump the generated LaTeX log files to stdout when PDF compilation
fails. This can be useful in CI where temporary build directories are not preserved. If
the environment variable `DOCUMENTER_LATEX_SHOW_LOGS` is set, log dumping is always enabled.

See [Other Output Formats](@ref) for more information.
"""
struct LaTeX <: Documenter.Writer
    platform::String
    version::String
    tectonic::Union{Cmd, String, Nothing}
    show_log::Bool
    function LaTeX(;
            platform = "native",
            version = get(ENV, "TRAVIS_TAG", ""),
            tectonic = nothing,
            show_log = false,
        )
        platform ∈ ("native", "tectonic", "docker", "none") || throw(ArgumentError("unknown platform: $platform"))
        show_log = show_log || haskey(ENV, "DOCUMENTER_LATEX_SHOW_LOGS")
        return new(platform, string(version), tectonic, show_log)
    end
end

import ..Documenter
import Markdown
import ANSIColoredPrinters

mutable struct Context{I <: IO} <: IO
    io::I
    in_header::Bool
    footnotes::Dict{String, Int}
    depth::Int
    filename::String # currently active source file
    doc::Documenter.Document
end
Context(io, doc) = Context{typeof(io)}(io, false, Dict(), 1, "", doc)

_print(c::Context, args...) = Base.print(c.io, args...)
_println(c::Context, args...) = Base.println(c.io, args...)
_print(io, args...) = Base.print(io, args...)

# Labels in the TeX file are hashes of plain text labels.
# To keep the plain text label (for debugging), say _hash(x) = x
_hash(x) = string(hash(x))


const STYLE = joinpath(dirname(@__FILE__), "..", "..", "assets", "latex", "documenter.sty")
const DEFAULT_PREAMBLE_PATH = joinpath(dirname(@__FILE__), "..", "..", "assets", "latex", "preamble.tex")

function hastex()
    try
        return success(`latexmk -version`)
    catch
        return false
    end
end

const DOCUMENT_STRUCTURE = (
    "part",
    "chapter",
    "section",
    "subsection",
    "subsubsection",
    "paragraph",
    "subparagraph",
)

function render(doc::Documenter.Document, settings::LaTeX = LaTeX())
    if isempty(doc.user.sitename) # otherwise, the latex compiler will terminate with a cryptic "There's no line here to end" error
        error(
            """
            LaTeXWriter needs a non-empty `sitename` passed to `makedocs`, otherwise the LaTeX build will error!
            Please pass e.g. `sitename = "Some Site Name"` as a keyword argument to `makedocs`.
            """
        )
    end

    @info "LaTeXWriter: creating the LaTeX file."
    mktempdir() do path
        cp(joinpath(doc.user.root, doc.user.build), joinpath(path, "build"))
        cd(joinpath(path, "build")) do
            fileprefix = latex_fileprefix(doc, settings)
            open("$(fileprefix).tex", "w") do io
                context = Context(io, doc)
                writeheader(context, doc, settings)
                for (title, filename, depth) in files(doc.user.pages)
                    context.filename = filename
                    empty!(context.footnotes)
                    if 1 <= depth <= length(DOCUMENT_STRUCTURE)
                        header_type = DOCUMENT_STRUCTURE[depth]
                        title_text = latexesc("$title")
                        header_text = "\n\\$(header_type){$title_text}\n"
                        if isempty(filename)
                            _println(context, header_text)
                        else
                            path = normpath(filename)
                            page = doc.blueprint.pages[path]
                            if get(page.globals.meta, :IgnorePage, :none) !== :latex
                                context.depth = depth + (isempty(title) ? 0 : 1)
                                context.depth > depth && _println(context, header_text)
                                latex(context, page.mdast.children; toplevel = true)
                            end
                        end
                    end
                end
                writefooter(context, doc)
            end
            cp(STYLE, "documenter.sty")

            # compile .tex
            status = compile_tex(doc, settings, fileprefix)

            # Debug: if DOCUMENTER_LATEX_DEBUG environment variable is set, copy the LaTeX
            # source files over to a directory under doc.user.root.
            if haskey(ENV, "DOCUMENTER_LATEX_DEBUG")
                dst = isempty(ENV["DOCUMENTER_LATEX_DEBUG"]) ? mktempdir(doc.user.root; cleanup = false) :
                    joinpath(doc.user.root, ENV["DOCUMENTER_LATEX_DEBUG"])
                sources = cp(pwd(), dst, force = true)
                @info "LaTeX sources copied for debugging to $(sources)"
            end

            # If the build was successful, copy the PDF or the LaTeX source to the .build directory
            if status && (settings.platform != "none")
                pdffile = "$(fileprefix).pdf"
                cp(pdffile, joinpath(doc.user.root, doc.user.build, pdffile); force = true)
            elseif status && (settings.platform == "none")
                cp(pwd(), joinpath(doc.user.root, doc.user.build); force = true)
            else
                error("Compiling the .tex file failed. See logs for more information.")
            end
        end
    end
    return
end

function latex_fileprefix(doc::Documenter.Document, settings::LaTeX)
    fileprefix = doc.user.sitename
    if occursin(Base.VERSION_REGEX, settings.version)
        v = VersionNumber(settings.version)
        fileprefix *= "-$(v.major).$(v.minor).$(v.patch)"
    end
    return replace(fileprefix, " " => "")
end

const DOCKER_IMAGE_TAG = "0.1"

function compile_tex(doc::Documenter.Document, settings::LaTeX, fileprefix::String)
    if settings.platform == "native"
        Sys.which("latexmk") === nothing && (@error "LaTeXWriter: latexmk command not found."; return false)
        @info "LaTeXWriter: using latexmk to compile tex."
        try
            piperun(`latexmk -f -interaction=batchmode -halt-on-error -view=none -lualatex -shell-escape $(fileprefix).tex`, clearlogs = true)
            return true
        catch err
            settings.show_log && dump_latex_log(fileprefix)
            logs = cp(pwd(), mktempdir(; cleanup = false); force = true)
            @error "LaTeXWriter: failed to compile tex with latexmk. " *
                "Logs and partial output can be found in $(Documenter.locrepr(logs))" exception = err
            return false
        end
    elseif settings.platform == "tectonic"
        @info "LaTeXWriter: using tectonic to compile tex."
        tectonic = isnothing(settings.tectonic) ? Sys.which("tectonic") : settings.tectonic
        isnothing(tectonic) && (@error "LaTeXWriter: tectonic command not found."; return false)
        try
            piperun(`$(tectonic) -X compile --keep-logs -Z shell-escape $(fileprefix).tex`, clearlogs = true)
            return true
        catch err
            settings.show_log && dump_latex_log(fileprefix)
            logs = cp(pwd(), mktempdir(; cleanup = false); force = true)
            @error "LaTeXWriter: failed to compile tex with tectonic. " *
                "Logs and partial output can be found in $(Documenter.locrepr(logs))" exception = err
            return false
        end
    elseif settings.platform == "docker"
        Sys.which("docker") === nothing && (@error "LaTeXWriter: docker command not found."; return false)
        @info "LaTeXWriter: using docker to compile tex."
        script = """
        mkdir /home/zeptodoctor/build
        cd /home/zeptodoctor/build
        cp -r /mnt/. .
        latexmk -f -interaction=batchmode -halt-on-error -view=none -lualatex -shell-escape $(fileprefix).tex
        """
        try
            piperun(`docker run -itd -u zeptodoctor --name latex-container -v $(pwd()):/mnt/ --rm juliadocs/documenter-latex:$(DOCKER_IMAGE_TAG)`, clearlogs = true)
            piperun(`docker exec -u zeptodoctor latex-container bash -c $(script)`)
            piperun(`docker cp latex-container:/home/zeptodoctor/build/$(fileprefix).pdf .`)
            return true
        catch err
            settings.show_log && dump_latex_log(fileprefix)
            logs = cp(pwd(), mktempdir(; cleanup = false); force = true)
            @error "LaTeXWriter: failed to compile tex with docker. " *
                "Logs and partial output can be found in $(Documenter.locrepr(logs))" exception = err
            return false
        finally
            try
                piperun(`docker stop latex-container`)
            catch
            end
        end
    elseif settings.platform == "none"
        @info "Skipping compiling tex file."
        return true
    end
end

function dump_latex_log(fileprefix::String)
    logfiles = String[]
    for logfile in ("$(fileprefix).log", "LaTeXWriter.stdout", "LaTeXWriter.stderr")
        isfile(logfile) && push!(logfiles, logfile)
    end

    if isempty(logfiles)
        println(stdout, "LaTeXWriter: show_log=true but no log files were found in $(pwd())")
        return
    end

    println(stdout, "LaTeXWriter: show_log=true, dumping LaTeX logs.")
    for logfile in logfiles
        println(stdout, "========== BEGIN $logfile ==========")
        print(stdout, read(logfile, String))
        println(stdout)
        println(stdout, "========== END $logfile ==========")
    end
    return
end

function piperun(cmd; clearlogs = false)
    verbose = "--verbose" in ARGS || get(ENV, "DOCUMENTER_VERBOSE", "false") == "true"
    if verbose
        cmd = pipeline(
            cmd,
            stdout = "LaTeXWriter.stdout", stderr = "LaTeXWriter.stderr",
            append = !clearlogs,
        )
    end
    return run(cmd)
end

function writeheader(io::IO, doc::Documenter.Document, settings::LaTeX)
    custom = joinpath(doc.user.root, doc.user.source, "assets", "custom.sty")
    isfile(custom) ? cp(custom, "custom.sty"; force = true) : touch("custom.sty")

    custom_preamble_file = joinpath(doc.user.root, doc.user.source, "assets", "preamble.tex")
    if isfile(custom_preamble_file)
        # copy custom preamble.
        cp(custom_preamble_file, "preamble.tex"; force = true)
    else # no custom preamble.tex, use default.
        cp(DEFAULT_PREAMBLE_PATH, "preamble.tex"; force = true)
    end
    preamble =
    """
    % Useful variables
    \\newcommand{\\DocMainTitle}{$(doc.user.sitename)}
    \\newcommand{\\DocVersion}{$(settings.version)}
    \\newcommand{\\DocAuthors}{$(doc.user.authors)}
    \\newcommand{\\JuliaVersion}{$(VERSION)}

    % ---- Insert preamble
    \\input{preamble.tex}
    """
    # output preamble
    _println(io, preamble)
    return
end

function writefooter(io::IO, doc::Documenter.Document)
    _println(io, "\n\\end{document}")
    return
end

# A few of the nodes are printed differently depending on whether they appear
# as the top-level blocks of a page, or somewhere deeper in the AST.
istoplevel(n::Node) = !isnothing(n.parent) && isa(n.parent.element, MarkdownAST.Document)

latex(io::Context, node::Node) = latex(io, node, node.element)
latex(io::Context, node::Node, e) = error("$(typeof(e)) not implemented: $e")

function latex(io::Context, children; toplevel = false)
    @assert eltype(children) <: MarkdownAST.Node
    for node in children
        otherelement = !isa(node.element, NoExtraTopLevelNewlines)
        toplevel && otherelement && _println(io)
        latex(io, node)
        toplevel && otherelement && _println(io)
    end
    return
end
const NoExtraTopLevelNewlines = Union{
    Documenter.AnchoredHeader,
    Documenter.ContentsNode,
    Documenter.DocsNode,
    Documenter.DocsNodesBlock,
    Documenter.EvalNode,
    Documenter.IndexNode,
    Documenter.MetaNode,
}

function latex(io::Context, node::Node, ah::Documenter.AnchoredHeader)
    anchor = ah.anchor
    # latex(io::IO, anchor::Anchor, page, doc)
    id = _hash(Documenter.anchor_label(anchor))
    latex(io, node.children; toplevel = istoplevel(node))
    _println(io, "\n\\label{", id, "}{}\n")
    return
end

## Documentation Nodes.

function latex(io::Context, node::Node, ::Documenter.DocsNodesBlock)
    return latex(io, node.children; toplevel = istoplevel(node))
end

function latex(io::Context, node::Node, docs::Documenter.DocsNode)
    node, ast = docs, node
    # latex(io::IO, node::Documenter.DocsNode, page, doc)
    id = _hash(Documenter.anchor_label(node.anchor))
    # Docstring header based on the name of the binding and it's category.
    _print(io, "\\hypertarget{", id, "}{\\texttt{")
    latexesc(io, Documenter.bindingstring(node.object.binding))
    _print(io, "}} ")
    _println(io, " -- {", Documenter.doccat(node.object), ".}\n")
    # # Body. May contain several concatenated docstrings.
    _println(io, "\\begin{adjustwidth}{2em}{0pt}")
    latexdoc(io, ast)
    _println(io, "\n\\end{adjustwidth}")
    return
end

function latexdoc(io::IO, node::Node)
    @assert node.element isa Documenter.DocsNode
    # The `:results` field contains a vector of `Docs.DocStr` objects associated with
    # each markdown object. The `DocStr` contains data such as file and line info that
    # we need for generating correct source links.
    for (docstringast, result) in zip(node.element.mdasts, node.element.results)
        _println(io)
        latex(io, docstringast.children)
        _println(io)
        # When a source link is available then print the link.
        url = Documenter.source_url(io.doc, result)
        if url !== nothing
            link = "\\href{$url}{\\texttt{source}}"
            _println(io, "\n", link, "\n")
        end
    end
    return
end

## Index, Contents, and Eval Nodes.

function latex(io::Context, node::Node, index::Documenter.IndexNode)
    # Having an empty itemize block in LaTeX throws an error, so we bail early
    # in that situation:
    isempty(index.elements) && (_println(io); return)

    _println(io, "\\begin{itemize}")
    for (object, _, page, mod, cat) in index.elements
        id = _hash(string(Documenter.slugify(object)))
        text = Documenter.bindingstring(object.binding)
        _print(io, "\\item \\hyperlinkref{")
        _print(io, id, "}{\\texttt{")
        latexesc(io, text)
        _println(io, "}}")
    end
    _println(io, "\\end{itemize}\n")
    return
end

function latex(io::Context, node::Node, contents::Documenter.ContentsNode)
    # Having an empty itemize block in LaTeX throws an error, so we bail early
    # in that situation:
    isempty(contents.elements) && (_println(io); return)

    depth = 1
    _println(io, "\\begin{itemize}")
    for (count, path, anchor) in contents.elements
        @assert length(anchor.node.children) == 1
        header = first(anchor.node.children)
        level = header.element.level
        # Filter out header levels smaller than the requested mindepth
        level = level - contents.mindepth + 1
        level < 1 && continue
        # If we're changing depth, we need to make sure we always print the
        # correct number of \begin{itemize} and \end{itemize} statements.
        if level > depth
            for k in 1:(level - depth)
                # if we jump by more than one level deeper we need to put empty
                # \items in -- otherwise LaTeX will complain
                (k >= 2) && _println(io, "\\item ~")
                _println(io, "\\begin{itemize}")
                depth += 1
            end
        elseif level < depth
            for _ in 1:(depth - level)
                _println(io, "\\end{itemize}")
                depth -= 1
            end
        end
        # Print the corresponding \item statement
        id = _hash(Documenter.anchor_label(anchor))
        _print(io, "\\item \\hyperlinkref{", id, "}{")
        latex(io, header.children)
        _println(io, "}")
    end
    # print any remaining missing \end{itemize} statements
    for _ in 1:depth
        _println(io, "\\end{itemize}")
    end
    _println(io)
    return
end

function latex(io::Context, node::Node, evalnode::Documenter.EvalNode)
    if evalnode.result !== nothing
        latex(io, evalnode.result.children, toplevel = true)
    end
    return
end

# Select the "best" representation for LaTeX output.
using Base64: base64decode
latex(io::Context, node::Node, ::Documenter.MultiOutput) = latex(io, node.children)
function latex(io::Context, node::Node, moe::Documenter.MultiOutputElement)
    return Base.invokelatest(latex, io, node, moe.element)
end
function latex(io::Context, ::Node, d::Dict{MIME, Any})
    filename = String(rand('a':'z', 7))
    if haskey(d, MIME"image/png"())
        write("$(filename).png", base64decode(d[MIME"image/png"()]))
        _println(
            io, """
            \\begin{figure}[H]
            \\centering
            \\includegraphics[max width=\\linewidth]{$(filename)}
            \\end{figure}
            """
        )
    elseif haskey(d, MIME"image/jpeg"())
        write("$(filename).jpeg", base64decode(d[MIME"image/jpeg"()]))
        _println(
            io, """
            \\begin{figure}[H]
            \\centering
            \\includegraphics[max width=\\linewidth]{$(filename)}
            \\end{figure}
            """
        )
    elseif haskey(d, MIME"text/latex"())
        # If it has a latex MIME, just write it out directly.
        content = d[MIME("text/latex")]
        if startswith(content, "\\begin{tabular}")
            # This is a hacky fix for the printing of DataFrames (or any type
            # that produces a {tabular} environment). The biggest problem is
            # that tables with may columns will run off the page. An ideal fix
            # would be for the printing to omit some columns, but we don't have
            # the luxury here. So instead we just rescale everything until it
            # fits. This might make the rows too small, but it's arguably better
            # than having them go off the page.
            _println(io, "\\begin{table}[h]\n\\centering")
            _println(io, "\\adjustbox{max width=\\linewidth}{")
            _print(io, content)
            _println(io, "}\\end{table}")
        else
            _print(io, content)
        end
    elseif haskey(d, MIME"text/markdown"())
        md = Markdown.parse(d[MIME"text/markdown"()])
        ast = MarkdownAST.convert(MarkdownAST.Node, md)
        latex(io, ast.children)
    elseif haskey(d, MIME"text/plain"())
        text = d[MIME"text/plain"()]
        out = repr(MIME"text/plain"(), ANSIColoredPrinters.PlainTextPrinter(IOBuffer(text)))
        # We set a "fake" language as text/plain so that the writer knows how to
        # deal with it.
        codeblock = MarkdownAST.CodeBlock("text/plain", out)
        latex(io, MarkdownAST.Node(codeblock))
    else
        error("this should never happen.")
    end
    return nothing
end


## Basic Nodes. AKA: any other content that hasn't been handled yet.

function latex(io::Context, node::Node, heading::MarkdownAST.Heading)
    N = heading.level
    # latex(io::IO, h::Markdown.Header{N}) where N
    tag = DOCUMENT_STRUCTURE[min(io.depth + N - 1, length(DOCUMENT_STRUCTURE))]
    _print(io, "\\", tag, "{")
    io.in_header = true
    latex(io, node.children)
    io.in_header = false
    # {sub}pagragraphs need an explicit `\indent` after them
    # to ensure the following text is on a new line. Others
    if endswith(tag, "paragraph")
        _println(io, "}\\indent\n")
    else
        _println(io, "}\n")
    end
    return
end

# Whitelisted lexers.
const LEXER = Set(
    [
        "julia",
        "jlcon",
        "text",
    ]
)

function latex(io::Context, node::Node, code::MarkdownAST.CodeBlock)
    language = Documenter.codelang(code.info)
    if language == "julia-repl"
        language = "jlcon"  # the julia-repl is called "jlcon" in Pygments
    elseif !(language in LEXER) && language != "text/plain"
        # For all others, like ```python or ```markdown, render as text.
        language = "text"
    end
    text = IOBuffer(code.code)
    code_code = repr(MIME"text/plain"(), ANSIColoredPrinters.PlainTextPrinter(text))
    escape = '⊻' ∈ code_code
    _print(io, "\n\\begin{minted}")
    if escape
        _print(io, "[escapeinside=\\#\\%")
    end
    if language == "text/plain"
        _print(io, escape ? "," : "[")
        # Special-case the formatting of code outputs from Julia.
        _println(io, "xleftmargin=-\\fboxsep,xrightmargin=-\\fboxsep,bgcolor=white,frame=single]{text}")
    else
        _println(io, escape ? "]{" : "{", language, "}")
    end
    if escape
        _print_code_escapes_minted(io, code_code)
    else
        _print(io, code_code)
    end
    _println(io, "\n\\end{minted}\n")
    return
end

latex(io::Context, node::Node, mcb::Documenter.MultiCodeBlock) = latex(io, node, join_multiblock(node))
function join_multiblock(node::Node)
    @assert node.element isa Documenter.MultiCodeBlock
    io = IOBuffer()
    codeblocks = [n.element::MarkdownAST.CodeBlock for n in node.children]
    for (i, thing) in enumerate(codeblocks)
        print(io, thing.code)
        if i != length(codeblocks)
            println(io)
            if findnext(x -> x.info == node.element.language, codeblocks, i + 1) == i + 1
                println(io)
            end
        end
    end
    return MarkdownAST.CodeBlock(node.element.language, String(take!(io)))
end

function _print_code_escapes_minted(io, s::AbstractString)
    for ch in s
        ch === '#' ? _print(io, "##%") :
            ch === '%' ? _print(io, "#%%") : # Note: "#\\%%" results in pygmentize error...
            ch === '⊻' ? _print(io, "#\\unicodeveebar%") :
            _print(io, ch)
    end
    return
end

function latex(io::Context, node::Node, code::MarkdownAST.Code)
    _print(io, "\\texttt{")
    _print_code_escapes_inline(io, code.code)
    _print(io, "}")
    return
end

function _print_code_escapes_inline(io, s::AbstractString)
    for ch in s
        ch === '⊻' ? _print(io, "\\unicodeveebar{}") : latexesc(io, ch)
    end
    return
end

function latex(io::Context, node::Node, ::MarkdownAST.Paragraph)
    latex(io, node.children)
    _println(io, "\n")
    return
end

function latex(io::Context, node::Node, ::MarkdownAST.BlockQuote)
    wrapblock(io, "quote") do
        latex(io, node.children)
    end
    return
end

function latex(io::Context, node::Node, md::MarkdownAST.Admonition)
    color = "admonition-default"
    if md.category in ("danger", "warning", "note", "info", "tip", "compat", "todo")
        color = "admonition-$(md.category)"
    end
    _print(io, "\\begin{tcolorbox}[toptitle=-1mm,bottomtitle=1mm,")
    _print(io, "colback=$(color)!50!white,colframe=$(color),")
    _print(io, "title=\\textbf{")
    latexesc(io, md.title)
    _println(io, "}]")
    latex(io, node.children)
    _println(io, "\\end{tcolorbox}")
    return
end

function latex(io::Context, node::Node, f::MarkdownAST.FootnoteDefinition)
    id = get(io.footnotes, f.id, 1)
    _print(io, "\\footnotetext[", id, "]{")
    latex(io, node.children)
    _println(io, "}")
    return
end

function latex(io::Context, node::Node, list::MarkdownAST.List)
    # TODO: MarkdownAST doesn't support lists starting at arbitrary numbers
    isordered = (list.type === :ordered)
    ordered = (list.type === :bullet) ? -1 : 1
    # `\begin{itemize}` is used here for both ordered and unordered lists since providing
    # custom starting numbers for enumerated lists is simpler to do by manually assigning
    # each number to `\item` ourselves rather than using `\setcounter{enumi}{<start>}`.
    #
    # For an ordered list starting at 5 the following will be generated:
    #
    # \begin{itemize}
    #   \item[5. ] ...
    #   \item[6. ] ...
    #   ...
    # \end{itemize}
    #
    pad = ndigits(ordered + length(node.children)) + 2
    fmt = n -> (isordered ? "[$(rpad("$(n + ordered - 1).", pad))]" : "")
    wrapblock(io, "itemize") do
        for (n, item) in enumerate(node.children)
            _print(io, "\\item$(fmt(n)) ")
            latex(io, item.children)
            n < length(node.children) && _println(io)
        end
    end
    return
end

function latex(io::Context, node::Node, e::MarkdownAST.ThematicBreak)
    _println(io, "{\\rule{\\textwidth}{1pt}}")
    return
end

# This (equation*, split) math env seems to be the only way to correctly render all the
# equations in the Julia manual. However, if the equation is already wrapped in
# align/align*, then there is no need to further wrap it (in fact, it will break).
function latex(io::Context, node::Node, math::MarkdownAST.DisplayMath)
    if occursin(r"^\\begin\{align\*?\}", math.math)
        _print(io, math.math)
    else
        _print(io, "\\begin{equation*}\n\\begin{split}")
        _print(io, math.math)
        _println(io, "\\end{split}\\end{equation*}")
    end
    return
end

function latex(io::Context, node::Node, table::MarkdownAST.Table)
    rows = MarkdownAST.tablerows(node)
    _println(io, "\n\\begin{table}[h]\n\\centering")
    _print(io, "\\begin{tabulary}{\\linewidth}")
    _println(io, "{", uppercase(join(spec_to_align.(table.spec), ' ')), "}")
    _println(io, "\\toprule")
    for (i, row) in enumerate(rows)
        for (j, cell) in enumerate(row.children)
            j === 1 || _print(io, " & ")
            latex(io, cell.children)
        end
        _println(io, " \\\\")
        if i === 1
            _println(io, "\\toprule")
        end
    end
    _println(io, "\\bottomrule")
    _println(io, "\\end{tabulary}\n")
    _println(io, "\\end{table}\n")
    return
end
spec_to_align(spec::Symbol) = Symbol(first(String(spec)))

function latex(io::Context, node::Node, raw::Documenter.RawNode)
    raw.name === :latex && _println(io, "\n", raw.text, "\n")
    return
end

# Inline Elements.

function latex(io::Context, node::Node, e::MarkdownAST.Text)
    return latexesc(io, e.text)
end

function latex(io::Context, node::Node, e::MarkdownAST.Strong)
    wrapinline(io, "textbf") do
        latex(io, node.children)
    end
    return
end

function latex(io::Context, node::Node, e::MarkdownAST.Emph)
    wrapinline(io, "emph") do
        latex(io, node.children)
    end
    return
end

function latex(io::Context, node::Node, ::MarkdownAST.Strikethrough)
    # TODO: use a LaTeX package like soul or ulem to render strike through
    latex(io, node.children)
    return
end

function _warn_raw_html_in_latex(io::Context, kind::AbstractString)
    source = isempty(io.filename) ? "(unknown source)" : Documenter.locrepr(io.filename)
    @warn "Raw HTML $kind is not supported in LaTeX output in $(source); stripping tags."
    return
end

function latex(io::Context, ::Node, html::MarkdownAST.HTMLBlock)
    _warn_raw_html_in_latex(io, "block")
    latexesc(io, replace(html.html, r"<[^>]+>" => ""))
    _println(io)
    return
end

function latex(io::Context, ::Node, html::MarkdownAST.HTMLInline)
    _warn_raw_html_in_latex(io, "inline")
    latexesc(io, replace(html.html, r"<[^>]+>" => ""))
    return
end

function latex(io::Context, node::Node, image::Documenter.LocalImage)
    # TODO: also print the .title field somehow
    wrapblock(io, "figure") do
        _println(io, "\\centering")
        wrapinline(io, "includegraphics[max width=\\linewidth]") do
            _print(io, replace(image.path, "\\" => "/"))
        end
        _println(io)
        wrapinline(io, "caption") do
            latex(io, node.children)
        end
        _println(io)
    end
    return
end

function latex(io::Context, node::Node, image::MarkdownAST.Image)
    # TODO: also print the .title field somehow
    wrapblock(io, "figure") do
        _println(io, "\\centering")
        @warn "images with absolute URLs not supported in LaTeX output in $(Documenter.locrepr(io.filename))" url = image.destination
        # We nevertheless output an \includegraphics with the URL. The LaTeX build will
        # then give an error, indicating to the user that something wrong.
        url = replace(image.destination, "\\" => "/") # use / on Windows too.
        wrapinline(io, "includegraphics[max width=\\linewidth]") do
            _print(io, url)
        end
        _println(io)
        wrapinline(io, "caption") do
            latex(io, node.children)
        end
        _println(io)
    end
    return
end

function latex(io::Context, node::Node, f::MarkdownAST.FootnoteLink)
    id = get!(io.footnotes, f.id, length(io.footnotes) + 1)
    _print(io, "\\footnotemark[", id, "]")
    return
end

function latex(io::Context, node::Node, link::Documenter.PageLink)
    # If we're in a header, we don't want to print any \hyperlinkref commands,
    # so we handle this here.
    if io.in_header
        latex(io, node.children)
        return
    end
    # This branch is the normal case, when we're not in a header.
    # TODO: this link handling does not seem correct
    if !isempty(link.fragment)
        id = _hash(link.fragment)
        wrapinline(io, "hyperlinkref") do
            _print(io, id)
        end
    else
        wrapinline(io, "href") do
            path = Documenter.pagekey(io.doc, link.page)
            latexesc(io, path)
        end
    end
    _print(io, "{")
    latex(io, node.children)
    _print(io, "}")
    return
end

function latex(io::Context, node::Node, link::Documenter.LocalLink)
    # If we're in a header, we don't want to print any \hyperlinkref commands,
    # so we handle this here.
    if io.in_header
        latex(io, node.children)
        return
    end
    # This branch is the normal case, when we're not in a header.
    # TODO: this link handling does not seem correct
    wrapinline(io, "href") do
        href = isempty(link.fragment) ? link.path : "$(link.path)#($(link.fragment))"
        latexesc(io, href)
    end
    _print(io, "{")
    latex(io, node.children)
    _print(io, "}")
    return
end

function latex(io::Context, node::Node, link::MarkdownAST.Link)
    # If we're in a header, we don't want to print any \hyperlinkref commands,
    # so we handle this here.
    if io.in_header
        latex(io, node.children)
        return
    end
    # This branch is the normal case, when we're not in a header.
    # TODO: handle the .title attribute
    wrapinline(io, "href") do
        # Keep URL characters such as '~' unescaped, while escaping '#'
        # which otherwise breaks \href argument handling in some contexts
        # (e.g. tabulary table cells).
        _print(io, replace(link.destination, "#" => "\\#"))
    end
    _print(io, "{")
    latex(io, node.children)
    _print(io, "}")
    return
end

function latex(io::Context, node::Node, math::MarkdownAST.InlineMath)
    # Handle MathJax and TeX inconsistency since the first wants `\LaTeX` wrapped
    # in math delims, whereas actual TeX fails when that is done.
    math.math == "\\LaTeX" ? _print(io, math.math) : _print(io, "\\(", math.math, "\\)")
    return
end

# Metadata Nodes get dropped from the final output for every format but are needed throughout
# rest of the build and so we just leave them in place and print a blank line in their place.
latex(io::Context, node::Node, ::Documenter.MetaNode) = _println(io, "\n")

# In the original AST, SetupNodes were just mapped to empty Markdown.MD() objects.
latex(io::Context, node::Node, ::Documenter.SetupNode) = nothing

function latex(io::Context, node::Node, value::MarkdownAST.JuliaValue)
    message =
    """
    Unexpected Julia interpolation in the Markdown. This probably means that you have an
    unbalanced or un-escaped \$ in the text.

    To write the dollar sign, escape it with `\\\$`

    This is in file $(io.filename), and we were given the value:

    `$(value.ref)` which is of type `$(typeof(value.ref))`
    """
    if io.doc.user.treat_markdown_warnings_as_error
        error(message)
    else
        @warn(message)
    end
    return latexesc(io, string(value.ref))
end

# TODO: Implement SoftBreak, Backslash (but they don't appear in standard library Markdown conversions)
latex(io::Context, node::Node, ::MarkdownAST.LineBreak) = _println(io, "\\\\")

# Documenter.

const _latexescape_chars = Dict{Char, AbstractString}(
    '~' => "{\\textasciitilde}",
    '\u00A0' => "~",  # nonbreaking space
    '^' => "{\\textasciicircum}",
    '\\' => "{\\textbackslash}",
    '\'' => "{\\textquotesingle}",
    '"' => "{\\textquotedbl}",
)
for ch in "&%\$#_{}"
    _latexescape_chars[ch] = "\\$ch"
end

latexesc(io, ch::AbstractChar) = _print(io, get(_latexescape_chars, ch, ch))

function latexesc(io, s::AbstractString)
    for ch in s
        latexesc(io, ch)
    end
    return
end

latexesc(s) = sprint(latexesc, s)

function wrapblock(f, io, env)
    _println(io, "\\begin{", env, "}")
    f()
    _println(io, "\\end{", env, "}")
    return
end

function wrapinline(f, io, cmd)
    _print(io, "\\", cmd, "{")
    f()
    _print(io, "}")
    return
end


function files!(out::Vector, v::Vector, depth)
    for each in v
        files!(out, each, depth + 1)
    end
    return out
end

# Tuples come from `hide(page)` with either
# (visible, nothing,    page,         children) or
# (visible, page.first, pages.second, children)
function files!(out::Vector, v::Tuple, depth)
    files!(out, v[2] == nothing ? v[3] : v[2] => v[3], depth)
    files!(out, v[4], depth)
    return
end

files!(out, s::AbstractString, depth) = push!(out, ("", s, depth))

function files!(out, p::Pair{<:AbstractString, <:Any}, depth)
    # Hack time. Because of Julia's typing, something like
    # `"Introduction" => "index.md"` may get typed as a `Pair{String,Any}`!
    if p[2] isa AbstractString
        push!(out, (p.first, p.second, depth))
    else
        push!(out, (p.first, "", depth))
        files!(out, p.second, depth)
    end
    return out
end

files(v::Vector) = files!(Tuple{String, String, Int}[], v, 0)

end

module OnlineGithubCheckTests
using Documenter: Documenter, MarkdownAST, AbstractTrees, render, expand, walk_navpages, githubcheck
using Documenter.HTMLWriter: render_article, HTMLContext, HTML
using Markdown
using Test

include("../repolink_helpers.jl")

# A Document with a single remote that looks like it was guessed from the registry, so
# that githubcheck queries the GitHub API for it. Using a synthetic remote rather than a
# live package keeps the failure modes reproducible -- a real package that happens to be
# untagged today gets tagged tomorrow.
const MARKDOWNAST_UUID = Base.UUID("d0879d2d-cac2-40c8-9cee-1863dc0c7391")
function synthetic_remote_doc(version::VersionNumber, tree_hash::AbstractString)
    doc = Documenter.Document(; sitename = "sitename", linkcheck = true)
    # Not a real path; githubcheck only ever uses it as a dictionary key.
    root = joinpath(@__DIR__, "synthetic-package-root")
    doc.internal.src_to_uuid[root] = MARKDOWNAST_UUID
    doc.internal.uuid_to_version_info[MARKDOWNAST_UUID] = (version, tree_hash)
    remote = Documenter.Remotes.GitHub("JuliaDocs", "MarkdownAST.jl")
    Documenter.addremote!(doc, Documenter.RemoteRepository(root, remote, "v$(version)"))
    return doc
end

@testset "Online githubcheck" begin
    @testset "Success" begin
        src = convert(
            MarkdownAST.Node,
            md"""
            ```@meta
            CurrentModule = Main.OnlineGithubCheckTests.TestHelperModule
            ```
            ```@docs
            MarkdownAST.Node
            ```
            """
        )
        doc, html = render_expand_doc(src)

        # Links to repo
        re = r"<a[^>]+ href=['\"]?https://github.com/JuliaDocs/MarkdownAST.jl"
        @test occursin(re, string(html))

        # No error on check
        @test githubcheck(doc) === nothing
        @test doc.internal.errors == Set{Symbol}()
    end

    @testset "Failure: no such tag" begin
        doc = synthetic_remote_doc(v"999.999.999", "0"^40)
        @test_logs (:error,) @test githubcheck(doc) === nothing
        @test doc.internal.errors == Set{Symbol}([:linkcheck_remotes])
    end

    @testset "Failure: tree hash mismatch" begin
        # v0.1.2 exists, but not with this tree hash.
        doc = synthetic_remote_doc(v"0.1.2", "0"^40)
        @test_logs (:error,) @test githubcheck(doc) === nothing
        @test doc.internal.errors == Set{Symbol}([:linkcheck_remotes])
    end
end

end

module CrossReferencesTests
import Documenter
using Test

@testset "CrossReferences" begin
    @test Documenter.xrefname("") === nothing
    @test Documenter.xrefname("@") === nothing
    @test Documenter.xrefname("@re") === nothing
    @test Documenter.xrefname("@refx") === nothing
    @test Documenter.xrefname("@ref#") === nothing
    @test Documenter.xrefname("@ref_") === nothing
    # basic at-refs
    @test Documenter.xrefname("@ref") == ""
    @test Documenter.xrefname("@ref ") == ""
    @test Documenter.xrefname("@ref     ") == ""
    @test Documenter.xrefname("@ref\t") == ""
    @test Documenter.xrefname("@ref\t  ") == ""
    @test Documenter.xrefname("@ref \t") == ""
    @test Documenter.xrefname(" @ref") == ""
    @test Documenter.xrefname(" \t@ref") == ""
    # named at-refs
    @test Documenter.xrefname("@ref foo") == "foo"
    @test Documenter.xrefname("@ref      foo") == "foo"
    @test Documenter.xrefname("@ref  foo  ") == "foo"
    @test Documenter.xrefname("@ref \t foo \t ") == "foo"
    @test Documenter.xrefname("@ref\tfoo") == "foo"
    @test Documenter.xrefname("@ref foo%bar") == "foo%bar"
    @test Documenter.xrefname("@ref  foo bar  \t baz   ") == "foo bar  \t baz"
    @test Documenter.xrefname(" \t@ref  foo") == "foo"
end

@testset "CrossReference classification" begin
    anchors = Documenter.AnchorMap()
    Documenter.anchor_add!(anchors, :dummy, "existing-id", "index.html")
    Documenter.anchor_add!(anchors, :dummy, "DocsReferencingMain.g", "index.html")

    @test Documenter.classifyxref("", (:text, "Header title"), anchors) ==
        (kind = :implicit_header, target = "Header title", slug = "Header-title")
    @test Documenter.classifyxref("", (:text, "#123"), anchors) ==
        (kind = :issue, target = "123", slug = "#123")
    @test Documenter.classifyxref("", (:code, "Main.f"), anchors) ==
        (kind = :implicit_docs, target = "Main.f", slug = "Main.f")

    @test Documenter.classifyxref("\"Header title\"", (:text, "label"), anchors) ==
        (kind = :explicit_header_title, target = "Header title", slug = "Header-title")
    @test Documenter.classifyxref("#123", (:text, "label"), anchors) ==
        (kind = :issue, target = "123", slug = "#123")
    @test Documenter.classifyxref("`Main.f`", (:text, "label"), anchors) ==
        (kind = :explicit_docs, target = "Main.f", slug = "Main.f")
    @test Documenter.classifyxref("existing-id", (:text, "label"), anchors) ==
        (kind = :explicit_header_id, target = "existing-id", slug = "existing-id")
    @test Documenter.classifyxref("missing-id", (:text, "label"), anchors) ==
        (kind = :explicit_header_id, target = "missing-id", slug = "missing-id")
    @test Documenter.classifyxref("Main.f", (:text, "label"), anchors) ==
        (kind = :explicit_docs, target = "Main.f", slug = "Main.f")
    @test Documenter.classifyxref("DocsReferencingMain.g", (:text, "label"), anchors) ==
        (kind = :explicit_header_id, target = "DocsReferencingMain.g", slug = "DocsReferencingMain.g")
end

# Arbitrary anchors on inline content via `[content](@id name)` (issue #745).
@testset "Inline @id anchors" begin
    using CodecZlib: ZlibDecompressor, transcode
    import IOCapture

    function build_doc(files::Vector{Pair{String, String}}; kwargs...)
        tmp = mktempdir()
        src = joinpath(tmp, "src")
        mkpath(joinpath(src, "assets"))
        write(joinpath(src, "assets", "logo.png"), "\x89PNG\r\n\x1a\n")
        for (name, content) in files
            write(joinpath(src, name), content)
        end
        # Captured so that the many builds below do not drown the test log; errors still
        # propagate, which the `@test_throws` cases below rely on.
        IOCapture.capture() do
            Documenter.makedocs(;
                root = tmp, sitename = "T", pages = [f.first for f in files],
                format = Documenter.HTML(edit_link = nothing, disable_git = true, inventory_version = "1.0"),
                remotes = nothing, kwargs...,
            )
        end
        return tmp
    end

    function read_inventory(tmp)
        bytes = read(joinpath(tmp, "build", "objects.inv"))
        hdrend = findlast(codeunits("zlib.\n"), bytes)
        return String(transcode(ZlibDecompressor, bytes[(last(hdrend) + 1):end]))
    end

    # Happy path: inline text anchor + a thumbnail-image anchor, both referenced.
    tmp = build_doc(
        [
            "index.md" => """
                # Header

                Inline anchor: [my target](@id my-anchor) mid-sentence.

                Thumbnail: [![thumb](assets/logo.png)](@id fig-anchor)

                Refs: [go to target](@ref my-anchor) and [see figure](@ref fig-anchor).
                """,
        ]
    )
    html = read(joinpath(tmp, "build", "index.html"), String)
    @test occursin("<span id=\"my-anchor\">", html)
    @test occursin("<span id=\"fig-anchor\">", html)
    @test occursin("href=\"#my-anchor\"", html)
    @test occursin("href=\"#fig-anchor\"", html)
    # The anchors are written to the inventory as std:label entries.
    inv = read_inventory(tmp)
    @test occursin("my-anchor std:label", inv)
    @test occursin("fig-anchor std:label", inv)

    # The id is slugified exactly like a header `@id`, so an id with spaces/mixed case
    # yields a valid HTML id and resolves via its slug (matching header behaviour).
    tmp = build_doc(
        [
            "index.md" => "# H\n\n[content](@id My Anchor Name).\n\nRef: [x](@ref My-Anchor-Name).\n",
        ]
    )
    html = read(joinpath(tmp, "build", "index.html"), String)
    @test occursin("<span id=\"My-Anchor-Name\">", html)
    @test !occursin("id=\"My Anchor Name\"", html)
    @test occursin("href=\"#My-Anchor-Name\"", html)

    # Forward/cross-page reference to an inline anchor defined on a later page.
    tmp = build_doc(
        [
            "a.md" => "# A\n\nSee [target](@ref cross-anchor).\n",
            "b.md" => "# B\n\nHere: [the target](@id cross-anchor).\n",
        ]
    )
    @test occursin("href=\"../b/#cross-anchor\"", read(joinpath(tmp, "build", "a", "index.html"), String))

    # `@contents` must not trip over inline anchors sharing the header AnchorMap.
    @test (build_doc(["index.md" => "# Top\n\n```@contents\n```\n\n## Sec\n\n[t](@id inline-a).\n"]); true)

    # A referenced duplicate id is an error, not a silent pick.
    @test_throws Exception build_doc(
        [
            "index.md" => "# H\n\n[a](@id dup) and [b](@id dup).\n\nRef: [x](@ref dup).\n",
        ]
    )

    # Inline anchors are found inside nested containers (admonitions, lists, ...).
    tmp = build_doc(
        [
            "index.md" => """
                # H

                !!! note
                    An [anchored note](@id in-admon).

                * a list item with [an anchor](@id in-list)

                Refs: [x](@ref in-admon) and [y](@ref in-list).
                """,
        ]
    )
    html = read(joinpath(tmp, "build", "index.html"), String)
    @test occursin("<span id=\"in-admon\">", html)
    @test occursin("<span id=\"in-list\">", html)

    # An inline id sharing the header namespace collides with a header slug of the same name.
    @test_throws Exception build_doc(["index.md" => "# Foo\n\ntext [x](@id Foo).\n\nRef: [r](@ref Foo).\n"])

    # An empty-content anchor `[](@id name)` uses `-` as its inventory display name.
    tmp = build_doc(["index.md" => "# H\n\n[](@id empty1)\n\nRef [r](@ref empty1).\n"])
    @test any(l -> startswith(l, "empty1 std:label -1 ") && endswith(strip(l), " -"), split(read_inventory(tmp), '\n'))
end

end

"""
$(SIGNATURES)

Traverses a [`Documenter.Document`](@ref) and process internal links and
references.

- Links containing `@ref` URLs are replaced with their real URLs. This
  delegates to [`xref`](@ref), which in turn delegates to the
  [`XRefResolvers.XRefResolverPipeline`](@ref).
- Links to local (`.md`) documents are rewritten to link to the corresponding
  path in the output build.
- For links to local files or images, check that the linked files exist.
"""
function crossref(doc::Documenter.Document)
    for (src, page) in doc.blueprint.pages
        empty!(page.globals.meta)
        crossref(doc, page, page.mdast)
    end
    return
end

function crossref(doc::Documenter.Document, page, mdast::MarkdownAST.Node)
    meta = page.globals.meta
    for node in AbstractTrees.PreOrderDFS(mdast)
        if node.element isa Documenter.MetaNode
            merge!(meta, node.element.dict)
        elseif node.element isa Documenter.DocsNode
            # the docstring AST trees are not part of the tree of the page, so we need to explicitly
            # call crossref() on them to update the links there. We also need up update
            # the CurrentModule meta key as needed, to make sure we find the correct
            # relative refs within docstrings
            tmp = get(page.globals.meta, :CurrentModule, nothing)
            for (docstr, docmeta) in zip(node.element.mdasts, node.element.metas)
                mod = get(docmeta, :module, nothing)
                isnothing(mod) || (meta[:CurrentModule] = mod)
                crossref(doc, page, docstr)
            end
            if isnothing(tmp)
                delete!(meta, :CurrentModule)
            else
                meta[:CurrentModule] = tmp
            end
        elseif node.element isa MarkdownAST.Link
            link_url = node.element.destination
            if Documenter.isabsurl(link_url) || startswith(link_url, "mailto:")
                # Absolute / external links simply get left alone
            else
                if occursin(XREF_REGEX, link_url)
                    xref(node, meta, page, doc)
                else
                    local_links!(node, meta, page, doc)
                end
            end
        elseif node.element isa MarkdownAST.Image
            # Images must be either be …
            if Documenter.isabsurl(node.element.destination)
                # … absolute / external links (no further processing) …
            else
                # … or local links (no at-ref syntax for those at the moment)
                local_links!(node, meta, page, doc)
            end
        end
    end
    return
end

function local_links!(node::MarkdownAST.Node, meta, page, doc)
    @assert node.element isa Union{MarkdownAST.Link, MarkdownAST.Image}
    link_url = node.element.destination
    @assert !Documenter.isabsurl(link_url)
    @assert !startswith(link_url, "mailto:")

    # For any local link, we check that it is actually pointing to a file.
    path, fragment = splitfragment(link_url)
    # Links starting with a # are references within the same file -- so there's not much
    # for us to do here, except to just construct the PageLink object. Note that we do
    # not verify that the fragments are valid -- there might be reasons why people want to
    # use custom fragments, in particular in the HTML output.
    if isempty(path)
        if node.element isa MarkdownAST.Image
            @docerror(
                doc, :cross_references,
                "invalid local image: path missing in $(Documenter.locrepr(doc, page))",
                link = node
            )
            return
        end
        node.element = Documenter.PageLink(page, fragment)
        return
    elseif Sys.iswindows() && ':' in path
        @docerror(
            doc, :cross_references,
            "invalid local link/image: colons not allowed in paths on Windows in $(Documenter.locrepr(doc, page))",
            link = node
        )
        return
    end
    # This path should be relative to doc.user.build, which is kinda line doc.user.source,
    # since most non-md files get copied to doc.user.build.
    path = normpath(joinpath(dirname(Documenter.pagekey(doc, page)), path))
    if startswith(path, "..")
        @docerror(
            doc, :cross_references,
            "invalid local link/image: path pointing to a file outside of build directory in $(Documenter.locrepr(doc, page))",
            link = node
        )
        return
    elseif path in keys(doc.blueprint.pages)
        node.element = Documenter.PageLink(doc.blueprint.pages[path], fragment)
        return
    elseif isfile(joinpath(doc.user.root, doc.user.build, path))
        if endswith(path, ".md")
            @warn "referring to a MD file that is not included in documentation build" path node
        end
        if node.element isa MarkdownAST.Image
            if !isempty(fragment)
                @docerror(
                    doc, :cross_references,
                    "invalid local image: path contains a fragment in $(Documenter.locrepr(doc, page))",
                    link = node
                )
            end
            node.element = Documenter.LocalImage(path)
        else
            node.element = Documenter.LocalLink(path, fragment)
        end
        return
    else
        @docerror(
            doc, :cross_references,
            "invalid local link/image: file does not exist in $(Documenter.locrepr(doc, page))",
            link = node
        )
        return
    end
end

function splitfragment(s)
    xs = split(s, '#', limit = 2)
    return xs[1], get(xs, 2, "")
end

# Dispatch pipeline for @ref links
# --------------------------------

module XRefResolvers
    import ..Documenter  # import for docstrings only
    import ..Documenter.Remotes #  import for docstrings only
    import ..Documenter.Selectors

    """The default pipeline for resolving `@ref` links.

    The steps for trying to resolve links are:

    - [`XRefResolvers.Header`](@ref) for links like `[Section Header](@ref)`
    - [`XRefResolvers.Issue`](@ref) for links like `[#11](@ref)`
    - [`XRefResolvers.Docs`](@ref) for links like ```[`Documenter.makedocs`](@ref)```

    Each step may or may not be able to resolve the link. Processing continues until the
    link is resolved or the end of the pipeline is reached. If the link is still unresolved
    after the last step, [`Documenter.xref`](@ref) issues an error that includes any
    accumulated error messages from the steps. Failure to resolve an `@ref` link will fail
    [`Documenter.makedocs`](@ref) if it is not called with `warnonly=true`.
    A step may choose to make the entire pipeline fail when it encounters a case that obviously
    has to be resolved by this step, but cannot be resolved due to an error (for example,
    a non-unique header slug). In that case, the step should set its [`Selectors.strict`](@ref)
    to `true`.

    The default pipeline could be extended by plugins using the general [`Selectors`](@ref)
    machinery.

    Each pipeline step receives the following arguments:

    * `node`: the `MarkdownAST.Node` representing the link. To resolve the `@ref` URL, any
      pipeline step can modify the node.
    * `slug`: the "slug" for the link, see [`Documenter.xref`](@ref)
    * `meta`: a dictionary of metadata, see [`@meta` block](@ref)
    * `page`: the [`Documenter.Page`](@ref) object containing the `node`
    * `doc`: the [`Documenter.Document`](@ref) instance representing the full site
    * `errors`: a list of strings of error messages accumulated in the
      `XRefResolverPipeline`. If a pipeline step indicates that it might be able to resolve
      a `@ref` link ([`Selectors.matcher`](@ref) is `true`), but then encounters an error in
      [`Selectors.runner`](@ref) that prevents resolution, it should push an error message
      to the list of `errors` to explain the failure. These accumulated errors will be shown
      if (and only if) the entire pipeline fails to resolve the link.

    The [`Selectors.matcher`](@ref) of any custom pipeline step should use
    [`Documenter.xref_unresolved`](@ref) to check whether the link was already resolved in an
    earlier pipeline step.
    """
    abstract type XRefResolverPipeline <: Selectors.AbstractSelector end

    Selectors.strict(::Type{T}) where {T <: XRefResolverPipeline} = false

    """Resolve `@ref` links for headers.

    This runs if the `slug` corresponds to a known local section title, and resolves the
    `node` to link to that section.
    """
    abstract type Header <: XRefResolverPipeline end

    """Resolve `@ref` links for issues.

    This runs if the `slug` is `"#"` followed by one or more digits and tries to link to an
    issue number using [`Remotes.issueurl`](@ref).
    """
    abstract type Issue <: XRefResolverPipeline end

    """Resolve `@ref` links for docstrings.

    This runs unconditionally (if no previous step was able to resolve the link), and
    tries to find a code binding for the given `slug`, linking to its docstring.
    """
    abstract type Docs <: XRefResolverPipeline end

end

Selectors.order(::Type{XRefResolvers.Header}) = 1.0
Selectors.order(::Type{XRefResolvers.Issue}) = 2.0
Selectors.order(::Type{XRefResolvers.Docs}) = 3.0


"""
$(SIGNATURES)

checks whether `node` is a link with an `@ref` URL. Any step in the
[`XRefResolvers.XRefResolverPipeline`](@ref) should use this to determine whether the `node`
still needs to be resolved.
"""
function xref_unresolved(node)
    return (node.element isa MarkdownAST.Link) &&
        occursin(XREF_REGEX, node.element.destination)
end


function Selectors.matcher(::Type{XRefResolvers.Header}, node, slug, meta, page, doc, errors)
    return (xref_unresolved(node) && anchor_exists(doc.internal.headers, slug))
end

function Selectors.runner(::Type{XRefResolvers.Header}, node, slug, meta, page, doc, errors)
    return namedxref(node, slug, meta, page, doc, errors)
end

Selectors.strict(::Type{XRefResolvers.Header}) = true


function Selectors.matcher(::Type{XRefResolvers.Issue}, node, slug, meta, page, doc, errors)
    return (xref_unresolved(node) && occursin(r"#[0-9]+", slug))
end

function Selectors.runner(::Type{XRefResolvers.Issue}, node, slug, meta, page, doc, errors)
    return issue_xref(node, lstrip(slug, '#'), meta, page, doc, errors)
end


function Selectors.matcher(::Type{XRefResolvers.Docs}, node, slug, meta, page, doc, errors)
    return xref_unresolved(node)
end

function Selectors.runner(::Type{XRefResolvers.Docs}, node, slug, meta, page, doc, errors)
    return docsxref(node, slug, meta, page, doc, errors)
end


# Finalizer (not used) …
Selectors.runner(::Type{XRefResolvers.XRefResolverPipeline}, args...) = nothing
# – in principle, this finalizer could do the final `@docerror`, but it's just a little more
# robust to do it in `xref` after the `dispatch`. That way, it doesn't break if some plugin
# does something unexpected with `Selectors.strict`.


"""
$(SIGNATURES)

Resolve a `MarkdownAST.Link` node with an `@ref` URL.

This delegates to [`XRefResolvers.XRefResolverPipeline`](@ref). In addition to forwarding
the `node`, `meta`, `page`, and `doc` arguments, it also passes a `slug` to the pipeline
that any pipeline step can use to easily resolve the link target. This `slug` is obtained as
follows:

- For, e.g, ```[`Documenter.makedocs`](@ref)``` or `[text](@ref Documenter.makedocs)`, the
  `slug` is `"Documenter.makedocs"`
- For, e.g, ```[Hosting Documentation](@ref)``` or `[text](@ref "Hosting Documentation")`,
  the `slug` is sluggified version of the given section title, `"Hosting-Documentation"` in
  this case.
"""
function xref(node::MarkdownAST.Node, meta, page, doc)
    @assert node.element isa MarkdownAST.Link
    link = node.element
    slug = xrefname(link.destination)
    @assert !isnothing(slug)
    if isempty(slug)
        # obtain a slug from the link text
        if length(node.children) == 1 && isa(first(node.children).element, MarkdownAST.Code)
            slug = first(node.children).element.code
        else
            # TODO: remove this hack (replace with mdflatten?)
            md = _link_node_as_md(node)
            text = strip(sprint(Markdown.plain, Markdown.Paragraph(md.content[1].content[1].text)))
            slug = Documenter.slugify(text)
        end
    else
        # explicit slugs that are enclosed in quotes must be further sluggified
        stringmatch = match(r"\"(.+)\"", slug)
        if !isnothing(stringmatch)
            slug = Documenter.slugify(stringmatch[1])
        end
    end
    errors = String[]
    Selectors.dispatch(
        XRefResolvers.XRefResolverPipeline, node, slug, meta, page, doc, errors
    )
    # finalizer
    if xref_unresolved(node)
        md_str = strip(Markdown.plain(_link_node_as_md(node)))
        msg = "Cannot resolve @ref for md$(repr(md_str)) in $(Documenter.locrepr(doc, page))."
        if (length(errors) > 0)
            msg *= ("\n" * join([string("- ", err) for err in errors], "\n"))
        end
        @docerror(doc, :cross_references, msg)
    end
    return nothing
end


# Helper to convert MarkdownAST link node to a Markdown.MD object
function _link_node_as_md(node::MarkdownAST.Node)
    @assert node.element isa MarkdownAST.Link
    document = MarkdownAST.@ast MarkdownAST.Document() do
        MarkdownAST.Paragraph() do
            MarkdownAST.copy_tree(node)
        end
    end
    return convert(Markdown.MD, document)
end


"""
Parse the `link.url` field of an `@ref` link. Returns `nothing` if it's not an `@ref`,
an empty string the reference link has no label, or a whitespace-stripped version the
label.
"""
function xrefname(link_url::AbstractString)
    m = match(XREF_REGEX, link_url)
    isnothing(m) && return nothing
    return isnothing(m[1]) ? "" : strip(m[1])
end

"""Regular expression for an `@ref` link url.

This is used by the [`XRefResolvers.XRefResolverPipeline`](@ref), respectively
[`xref_unresolved`](@ref): as long as the url of the link node still matches `XREF_REGEX`,
the reference remains unresolved and needs further processing in subsequent steps of the
pipeline.
"""
const XREF_REGEX = r"^\s*@ref(\s.*)?$"


# Cross referencing headers.
# --------------------------

function namedxref(node::MarkdownAST.Node, slug, meta, page, doc, errors)
    @assert node.element isa MarkdownAST.Link
    headers = doc.internal.headers
    @assert anchor_exists(headers, slug)
    # Add the link to list of local uncheck links.
    doc.internal.locallinks[node.element] = node.element.destination
    # Error checking: `slug` should exist and be unique.
    # TODO: handle non-unique slugs.
    if anchor_isunique(headers, slug)
        # Replace the `@ref` url with a path to the referenced header.
        anchor = Documenter.anchor(headers, slug)
        pagekey = relpath(anchor.file, doc.user.build)
        page = doc.blueprint.pages[pagekey]
        node.element = Documenter.PageLink(page, anchor_label(anchor))
    else
        push!(errors, "Header with slug '$slug' is not unique in $(Documenter.locrepr(doc, page)).")
    end
    return
end

# Cross referencing docstrings.
# -----------------------------

function docsxref(node::MarkdownAST.Node, code, meta, page, doc, errors)
    @assert node.element isa MarkdownAST.Link
    # Add the link to list of local uncheck links.
    doc.internal.locallinks[node.element] = node.element.destination
    if haskey(meta, :CurrentModule)
        # CurrentModule can be set manually for `.md` pages. For a @ref that's
        # inside a docstring, CurrentModule is automatically set to the module
        # containing that docstring.
        modules = [meta[:CurrentModule], Main]
    else
        modules = [Main]
    end
    for (attempt, mod) in enumerate(modules)
        docref = find_docref(code, mod, page, doc)
        if haskey(docref, :error)
            # We'll bail if the parsing of the docref wasn't successful
            msg = "Exception trying to find docref for `$code`: $(docref.error)"
            @debug msg exception = docref.exception  # shows the full backtrace
            push!(errors, msg)
        else
            binding, typesig = docref
            # Try to find a valid object that we can cross-reference.
            object = find_object(doc, binding, typesig)
            if object !== nothing
                if (attempt == 1) || startswith(code, string(binding.mod))
                    # Replace the `@ref` url with a path to the referenced docs.
                    docsnode = doc.internal.objects[object]
                    slug = Documenter.slugify(object)
                    pagekey = relpath(docsnode.page.build, doc.user.build)
                    page = doc.blueprint.pages[pagekey]
                    node.element = Documenter.PageLink(page, slug)
                    break  # stop after first mod with binding we can link to
                else
                    # In the "fallback" attempt 2 in Main we abort if `code` is
                    # not a fully qualified name (it must start with
                    # `binding.mod`)
                    @assert mod == Main
                    msg = "Fallback resolution in $mod for `$code` -> `$(binding.mod).$(binding.var)` is only allowed for fully qualified names"
                    push!(errors, msg)
                end
            else
                msg = "No docstring found in doc for binding `$(binding.mod).$(binding.var)`."
                push!(errors, msg)
            end
        end
    end
    return
end

function find_docref(code, mod, page, doc)
    # Parse the link text and find current module.
    keyword = Symbol(strip(code))
    local ex
    if haskey(Docs.keywords, keyword)
        ex = QuoteNode(keyword)
    else
        try
            ex = Meta.parse(code)
        catch err
            isa(err, Meta.ParseError) || rethrow(err)
            return (error = "unable to parse the reference `$code` in $(Documenter.locrepr(doc, page)).", exception = nothing)
        end
    end

    # Find binding and type signature associated with the link.
    local binding
    try
        binding = Documenter.DocSystem.binding(mod, ex)
    catch err
        return (
            error = "unable to get the binding for `$code` in module $(mod)",
            exception = (err, catch_backtrace()),
        )
        return
    end

    local typesig
    try
        typesig = Core.eval(mod, Documenter.DocSystem.signature(ex, rstrip(code)))
    catch err
        return (
            error = "unable to evaluate the type signature for `$code` in $(Documenter.locrepr(doc, page)) in module $(mod)",
            exception = (err, catch_backtrace()),
        )
    end

    return (binding = binding, typesig = typesig)
end

"""
$(SIGNATURES)

Find the included `Object` in the `doc` matching `binding` and `typesig`. The matching
heuristic isn't too picky about what matches and will only fail when no `Binding`s matching
`binding` have been included.
"""
function find_object(doc::Documenter.Document, binding, typesig)
    object = Documenter.Object(binding, typesig)
    if haskey(doc.internal.objects, object)
        # Exact object matching the requested one.
        return object
    else
        objects = get(doc.internal.bindings, binding, Documenter.Object[])
        if isempty(objects)
            # No bindings match the requested object == FAILED.
            return nothing
        elseif length(objects) == 1
            # Only one possible choice. Use it even if the signature doesn't match.
            return objects[1]
        else
            candidate = find_object(binding, typesig)
            if candidate in objects
                # We've found an actual match out of the possible choices! Use it.
                return candidate
            else
                # No match in the possible choices. Use the one that was first included.
                return objects[1]
            end
        end
    end
end
function find_object(binding, typesig)
    if Documenter.DocSystem.defined(binding)
        local λ = Documenter.DocSystem.resolve(binding)
        return find_object(λ, binding, typesig)
    else
        return Documenter.Object(binding, typesig)
    end
end
function find_object(λ::Union{Function, DataType}, binding, typesig)
    if hasmethod(λ, typesig)
        signature = getsig(λ, typesig)
        return Documenter.Object(binding, signature)
    else
        return Documenter.Object(binding, typesig)
    end
end
find_object(::Union{Function, DataType}, binding, ::Union{Union, Type{Union{}}}) = Documenter.Object(binding, Union{})
find_object(other, binding, typesig) = Documenter.Object(binding, typesig)

getsig(λ::Union{Function, DataType}, typesig) = Base.tuple_type_tail(which(λ, typesig).sig)


# Issues/PRs cross referencing.
# -----------------------------

function issue_xref(node::MarkdownAST.Node, num, meta, page, doc, errors)
    @assert node.element isa MarkdownAST.Link
    # Update issue links starting with a hash, but only if our Remote supports it
    issue_url = isnothing(doc.user.remote) ? nothing : Remotes.issueurl(doc.user.remote, num)
    if isnothing(issue_url)
        push!(errors, "unable to generate issue reference for '[`#$num`](@ref)' in $(Documenter.locrepr(doc, page)).")
    else
        node.element.destination = issue_url
    end
    return
end

module Foo
"""
```jldoctest
julia> Main.DocTestFixArray_2468
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8

julia> Main.DocTestFixArray_1234
4×1×1 Array{Int64,3}:
[:, :, 1] =
 1
 2
 3
 4
```
```jldoctest
julia> Main.DocTestFixArray_1234
4×1×1 Array{Int64,3}:
[:, :, 1] =
 1
 2
 3
 4

julia> Main.DocTestFixArray_2468
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8
```
```jldoctest
julia> Main.DocTestFixArray_2468
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8

julia> Main.DocTestFixArray_2468
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8
```
```jldoctest
julia> begin
           Main.DocTestFixArray_2468
       end
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8
```
```jldoctest
Main.DocTestFixArray_2468

# output

4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8
```
```jldoctest; filter = r"foo"
julia> println("  foobar")
  foobar
```
```jldoctest
julia> 1 + 2
3

julia> 3 + 4
7
```
"""
foo() = 1

"""
```jldoctest
julia> begin
           Main.DocTestFixArray_2468
       end
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8
```
```jldoctest
julia> println(); println("foo")

foo
```
"""
foo(x) = 1

end # module

using Documenter
using Test

@testset "Manual doctest" begin
    @info "Doctesting Documenter manual"
    doctest(Documenter)

    # Make sure that doctest() fails if there is a manual page with a failing doctest
    # Will need to run it in a Task though, so that we could easily capture the error.
    @info "Doctesting Documenter manual w/ failing doctest"
    tmpfile = joinpath(@__DIR__, "..", "docs", "src", "lib", "internals", "tmpfile.md")
    write(
        tmpfile, """
        # Temporary source file w/ failing doctest
        ```jldoctest
        julia> 2 + 2
        42
        ```
        """
    )
    @test isfile(tmpfile)
    # Starting from 1.13, the Julia test infrastructure uses ScopedValues
    # to handle testsets. So the original task-based approach does not work
    # anymore for "detaching" the doctest testsets from the test suite.
    # But we can manipulate the internal Test module state instead.
    # X-ref: https://github.com/JuliaLang/julia/pull/53462
    e = try
        @static if VERSION >= v"1.13-"
            Base.ScopedValues.@with(
                Test.CURRENT_TESTSET => Test.FallbackTestSet(),
                Test.TESTSET_DEPTH => 0,
                doctest(Documenter)
            )
        else
            fetch(schedule(Task(() -> doctest(Documenter))))
        end
    catch e
        @static if VERSION >= v"1.13-"
            e
        else
            # If we use the task-based approach, we need to unwrap the error
            @test e isa TaskFailedException
            e.task.exception
        end
    end
    println("^^^ Expected error output.")
    @test e isa TestSetException
    rm(tmpfile)
    @test !isfile(tmpfile)
end

# Test module that sets its syntax version to 1.14
# Doctests in this module should automatically use 1.14 syntax

module SyntaxVersioning

# Set this module's syntax version to 1.14
Base.Experimental.@set_syntax_version v"1.14"

"""
Verify that the syntax version is set correctly.

```jldoctest
julia> (Base.Experimental.@VERSION).syntax
v"1.14.0"
```
"""
function check_syntax_version end

"""
This doctest uses labeled break syntax which requires Julia 1.14.
Since the module has its syntax version set, this should work without
needing a `syntax=` annotation.

```jldoctest
julia> result = @label myblock begin
           for i in 1:10
               if i > 5
                   break myblock i * 2
               end
           end
           0
       end
12
```
"""
function labeled_break_example end

"""
This doctest uses labeled continue syntax which requires Julia 1.14.

```jldoctest
julia> output = Int[]
Int64[]

julia> @label outer for i in 1:3
           for j in 1:3
               if j == 2
                   continue outer
               end
               push!(output, i * 10 + j)
           end
       end

julia> output
3-element Vector{Int64}:
 11
 21
 31
```
"""
function labeled_continue_example end

end # module

struct TestQuery
    query::String
    expected_docs::Vector{String}
end

atypical_content_queries = [
    TestQuery("α β γ", String[]),
    TestQuery("🚀", String[]),
    TestQuery("averylongunbrokenstringofcharacterstotestthesearchindex", ["Atypical Content"]),
    TestQuery("мир", String[]),
    TestQuery("empty", ["An Empty Section"]),
    TestQuery("function", ["Structural Cases", "Doctests"]),
]

structural_cases_queries = [
    TestQuery("An Empty Section", ["An Empty Section"]),
    TestQuery("A Section With Only A Code Block", ["A Section With Only A Code Block"]),
    TestQuery("function foo()", ["Structural Cases"]),
]

markdown_syntax_queries = [
    TestQuery("Deeply nested lists", ["Markdown Syntax"]),
    TestQuery("complex to parse correctly", ["Markdown Syntax"]),
    TestQuery("blockquote with nested blockquotes", String[]),
]

common_words_queries = [
    TestQuery("function struct end", ["Structural Cases", "Common Words"]),
]

autodocs_queries = [
    TestQuery("Documenter", ["Structural Cases"]),
    TestQuery("makedocs", String[]),
    TestQuery("func1", ["Main.DummyModule.func1", "Main.DummyModule.func2"]),
    TestQuery("func2", ["Main.DummyModule.func2", "Main.DummyModule.func1"]),
    TestQuery("MyType", ["Main.DummyModule.MyType"]),
    TestQuery("docstring for func1", ["Main.DummyModule.func1", "Main.DummyModule.func2"]),
    TestQuery("docstring for func2", ["Main.DummyModule.func2", "Main.DummyModule.func1"]),
]

cross_references_queries = [
    TestQuery("link to the welcome page", ["Cross_references"]),
    TestQuery("cross-referencing syntax", ["Cross_references"]),
]

doctests_queries = [
    TestQuery("jldoctest", String[]),
    TestQuery("1 + 1", ["An Empty Section", "A Section With Only A Title", "Cross-references", "A Section With Only A Code Block", "Cross-References"]),
]


tables_queries = [
    TestQuery("table rendering", ["Tables"]),
    TestQuery("cell content A", ["Tables"]),
    TestQuery("cell content B", ["Tables"]),
    TestQuery("cell content C", ["Tables"]),
    TestQuery("1", ["Tables", "Doctests"]),
    TestQuery("2", ["Tables", "Doctests"]),
    TestQuery("3", ["Tables", "Doctests"]),
    TestQuery("4", ["Tables"]),
    TestQuery("5", ["Tables", "Doctests"]),
    TestQuery("6", ["Tables"]),
    # Test that markdown table syntax doesn't return search results
    TestQuery("|---|---|---|", String[]),
    TestQuery("| A | B | C |", String[]),
    TestQuery("|", String[]),
    TestQuery("---", String[]),
]

all_edge_case_queries = vcat(atypical_content_queries, structural_cases_queries, markdown_syntax_queries, common_words_queries, autodocs_queries, cross_references_queries, doctests_queries, tables_queries)

# Implements the makedocs() and functions directly related to it.

"""
    makedocs(;
        root    = "<current-directory>",
        source  = "src",
        build   = "build",
        clean   = true,
        doctest = true,
        modules = Module[],
        repo    = "",
        highlightsig = true,
        sitename = "",
        expandfirst = [],
        draft = false,
        others...
    )

Combines markdown files and inline docstrings into an interlinked document.
In most cases [`makedocs`](@ref) should be run from a `make.jl` file:

```julia
using Documenter
makedocs(
    # keywords...
)
```

which is then run from the command line with:

```sh
\$ julia make.jl
```

The folder structure that [`makedocs`](@ref) expects looks like:

    docs/
        build/
        src/
        make.jl

# Keywords

**`root`** is the directory from which `makedocs` should run. When run from a `make.jl` file
this keyword does not need to be set. It is, for the most part, needed when repeatedly
running `makedocs` from the Julia REPL like so:

    julia> makedocs(root = joinpath(dirname(pathof(MyModule)), "..", "docs"))

**`source`** is the directory, relative to `root`, where the markdown source files are read
from. By convention this folder is called `src`. Note that any non-markdown files stored
in `source` are copied over to the build directory when [`makedocs`](@ref) is run.

**`build`** is the directory, relative to `root`, into which generated files and folders are
written when [`makedocs`](@ref) is run. The name of the build directory is, by convention,
called `build`, though, like with `source`, users are free to change this to anything else
to better suit their project needs.

**`clean`** tells [`makedocs`](@ref) whether to remove all the content from the `build`
folder prior to generating new content from `source`. By default this is set to `true`.

**`doctest`** instructs [`makedocs`](@ref) on whether to try to test Julia code blocks
that are encountered in the generated document. By default this keyword is set to `true`.
Doctesting should only ever be disabled when initially setting up a newly developed package
where the developer is just trying to get their package and documentation structure correct.
After that, it's encouraged to always make sure that documentation examples are runnable and
produce the expected results. See the [Doctests](@ref) manual section for details about
running doctests.

Setting `doctest` to `:only` allows for doctesting without a full build. In this mode, most
build stages are skipped and the `warnonly` keyword is ignored (a doctesting error will always
make `makedocs` throw an error in this mode).

**`modules`** specifies a vector of modules that should be documented in `source`. If any
inline docstrings from those modules are seen to be missing from the generated content then
a warning will be printed during execution of [`makedocs`](@ref). By default no modules are
passed to `modules` and so no warnings will appear. This setting can be used as an indicator
of the "coverage" of the generated documentation.
For example Documenter's `make.jl` file contains:

```julia
makedocs(
    modules = [Documenter],
    # ...
)
```

and so any docstring from the module `Documenter` that is not spliced into the generated
documentation in `build` will raise a warning.

**`repo`** specifies the remote hosted Git repository (e.g. on `github.com`) related to the
documentation build. It should be passed an object that subtypes and implements the
[`Remotes.Remote`](@ref) interface (e.g. [`Remotes.GitHub`](@ref)). A template string can
also be passed (interpreted according to the rules described in [`Remotes.URL`](@ref)), but
the use of the template strings is discouraged, in favor of concrete
[`Remotes.Remote`](@ref) objects.

**`remotes`** can be used to declare a list of additional
`path::AbstractString => remote` pairs that are used to determine the remote
repository URLs for local filesystem files, such as the edit links for manual Markdown
pages, or docstring source links. `path` should be an absolute local filesystem path to a
directory, and will be interpreted as the root of the remote repository specified with
`remote`. `remote` would normally be a [`Remote`](@ref `Remotes.Remote`) object, but can also be
a `(remote::Remote, commit::AbstractString)` tuple, where the second argument specifies the
commit within the repository. This is necessary when `path` is not pointing to a proper Git
repository, and so determining the commit automatically is not possible.

If `repo` is not passed, `makedocs` will try to determine it automatically, either by
inspecting the locally checked out Git repository, or via the `remotes` keyword. See the
manual section on [Remote repository links](@ref) for more information on how the remote
repository links are handled.

If `remotes` is set to `nothing`, all remote repository links (repository links, source links,
edit links, issue links etc.) will be completely disabled. This can be useful when publicly
deploying documentation for private packages.

**`highlightsig`** enables or disables automatic syntax highlighting of leading, unlabeled
code blocks in docstrings (as Julia code). For example, if your docstring begins with an
indented code block containing the function signature, then that block would be highlighted
as if it were a labeled Julia code block. No other code blocks are affected. This feature
is enabled by default.

**`sitename`** is displayed in the title bar and/or the navigation menu when applicable.

**`pages`** can be used to specify a hierarchical page structure, and the order in which
the pages appear in the navigation of the rendered output. If omitted, Documenter will
automatically generate a flat list of pages based on the files present in the source
directory.

```julia
pages = [
    "Overview" => "index.md",
    "tutorial.md",
    "Tutorial" => [
        "tutorial/introduction.md",
        "Advanced" => "tutorial/features.md",
    ],
    "apireference.md",
]
```

The `pages` keyword must be a list where each element must be one of the following:

1. A string containing the full path of a Markdown file _within_ the source directory (i.e. relative to the `docs/src/` root in standard deployments).
2. A `"Page title" => "path/to/page.md"` pair, where `Page title` overrides the page title in the navigation menu (but not on the page itself).
3. A `"Subsection title" => [...]` pair, indicating a subsection of pages with the given title in the navigation menu. The list of pages for the subsection follows the same rules as the top-level `pages` keyword.

See also [`hide`](@ref), which can be used to hide certain pages in the navigation menu.

Note that, by default, regardless of what is specified in `pages`, Documenter will run and
render _all_ Markdown files it finds, even if they are not present in `pages`. The
`pagesonly` keyword can be used to change this behaviour.

**`pagesonly`** can be set to `true` (default: `false`) to make Documenter process only the
pages listed with the `pages` keyword. In that case, the Markdown files not present in
`pages` are ignored, i.e. code blocks do not run, docstrings do not get included, and the
pages are not rendered in the output in any way.

**`expandfirst`** allows some of the pages to be _expanded_ (i.e. at-blocks evaluated etc.)
before the others. Documenter normally evaluates the files in the alphabetic order of their
file paths relative to `src`, but `expandfirst` allows some pages to be prioritized.

For example, if you have `foo.md` and `bar.md`, `bar.md` would normally be evaluated before
`foo.md`. But with `expandfirst = ["foo.md"]`, you can force `foo.md` to be evaluated first.

Evaluation order among the `expandfirst` pages is according to the order they appear in the
argument.

**`meta`** can be used to provide default values for the `@meta` blocks executed on every
page. For example `meta = Dict(:DocTestSetup => :(using MyPackages))` sets `DocTestSetup`
on every page to the code block `:(using MyPackages)`. This can still be overridden on
each individual page.

**`draft`** can be set to `true` to build a draft version of the document. In draft mode
some potentially time-consuming steps are skipped (e.g. running `@example` blocks), which is
useful when iterating on the documentation. This setting can also be configured per-page
by setting `Draft = true` in an `@meta` block.

**`checkdocs`** instructs [`makedocs`](@ref) to check whether all names within the modules
defined in the `modules` keyword that have a docstring attached have the docstring also
listed in the manual (e.g. there's a `@docs` block with that docstring). Possible values
are `:all` (check all names; the default), `:exports` (check only exported names),
`:public` (check exported names and those marked with the `public` keyword in Julia ≥ 1.11),
and `:none` (no checks are performed).

By default, if the document checks detect any errors, it will fail the documentation build.
This behavior can be relaxed with the `warnonly` or `checkdocs_ignored_modules` keywords.

**`checkdocs_ignored_modules`** prevents `checkdocs` from checking modules supplied as a list
of module objects. It will also cause all submodules of these modules to be ignored. It can be
useful for completely private modules including modules which have been vendored from
elsewhere.

Note that `checkdocs_ignored_modules` does not conversely verify that these docstrings are *not*
included in the documentation.

**`linkcheck`** -- if set to `true` [`makedocs`](@ref) uses `curl` to check the status codes
of external-pointing links, to make sure that they are up-to-date. The links and their
status codes are printed to the standard output. When enabled, any detected errors will fail
the build, but this can be overridden by passing `:linkcheck` to `warnonly`. Default: `false`.

**`linkcheck_ignore`** allows certain URLs to be ignored in `linkcheck`. The values should
be a list of strings (which get matched exactly) or `Regex` objects. By default nothing is
ignored.

**`linkcheck_timeout`** configures how long `curl` waits (in seconds) for a link request to
return a response before giving up. The default is 10 seconds.

**`linkcheck_useragent`** can be used to override the user agent string used by the HTTP and
HTTPS requests made when checking for broken links. If set to `nothing`, it uses the default
user agent string of the library/tool used to actually perform the requests (currently, the
system's `curl` binary).

If unset, Documenter uses the following user agent string:

```
$(_LINKCHECK_DEFAULT_USERAGENT)
```

This is set to mimic a realistic web browser. However, the exact user agent string is subject
to change. As such, it is possible that breakages can occur when Documenter's version changes,
but the goal is to set the user agent such that it would be accepted by as many web servers as
possible.

**`warnonly`** can be used to control whether the `makedocs` build fails with an error, or
simply prints a warning if it detects any issues with the document. Additionally, a `Symbol`
or a `Vector` of `Symbol`s can be passed to make Documenter warn for only those specified
error classes (see also: [`Documenter.except`](@ref)). If set to `true`, the build should
never fail due to document checks. The keyword defaults to `false`.

Note that setting `warnonly = true` in general is not recommended, since it will make it very
easy to miss Documentation build issues, and will lead to the deployment of broken manuals.
The only case where you may want to consider passing `true` is when you are automatically
deploying the documentation for a package release. In that case, `warnonly` should be set
dynamically by checking the relevant environment variables set by the CI system.

**`treat_markdown_warnings_as_error`** can be used to control whether a build fails with an error, or
simply prints a warning if it detects unintended julia values within the markdown.

**`workdir`** determines the working directory where `@example` and `@repl` code blocks are
executed. It can be either a path or the special value `:build` (default).

If the `workdir` is set to a path, the working directory is reset to that path for each code
block being evaluated. Relative paths are taken to be relative to `root`, but using absolute
paths is recommended (e.g. `workdir = joinpath(@__DIR__, "..")` for executing in the package
root for the usual `docs/make.jl` setup).

With the default `:build` option, the working directory is set to a subdirectory of `build`,
determined from the source file path. E.g. for `src/foo.md` it is set to `build/`, for
`src/foo/bar.md` it is set to `build/foo` etc.

Note that `workdir` does not affect doctests.

**`plugins`** is a list of [`Documenter.Plugin`](@ref) objects. Use as directed by the
documentation of a third-party plugin. For any subtype `T <: Plugin`, the
`plugins` list may contain at most a single object of type `T`.

## Output formats

**`format`** allows the output format to be specified. The default format is
[`Documenter.HTML`](@ref) which creates a set of HTML files, but Documenter also provides
PDF output via the [`Documenter.LaTeX`](@ref) writer.

Other formats can be enabled by using other addon-packages. For example, the
[DocumenterMarkdown](https://github.com/JuliaDocs/DocumenterMarkdown.jl) package provides
the original Markdown -> Markdown output. See [Other Output Formats](@ref) for more
information.

# See Also

A guide detailing how to document a package using Documenter's [`makedocs`](@ref) is provided
in the [setup guide in the manual](@ref Package-Guide).
"""
function makedocs(; debug = false, format = HTML(), kwargs...)
    document = Documenter.Document(; format = format, kwargs...)
    # Before starting the build pipeline, we empty out the subtype cache used by
    # Selectors.dispatch. This is to make sure that we pick up any new selector stages that
    # may have been added to the selector pipelines between makedocs calls.
    empty!(Selectors.selector_subtypes)
    original_pwd[] = pwd()
    cd(document.user.root) do
        withenv(NO_KEY_ENV...) do
            Selectors.dispatch(Builder.DocumentPipeline, document)
        end
    end
    return debug ? document : nothing
end

"""
    Documenter.except(errors...)

Returns the list of all valid error classes that can be passed as the `warnonly` argument of
[`makedocs`](@ref), except for the ones specified in the `errors` argument. Each error class
must be a `Symbol` and passed as a separate argument.

This can be used to enable strict error checking for only the listed error classes, while having
other error types simply print a warning. E.g. to make Documenter fail the build only for
footnote and linkcheck errors, one can set `warnonly` as

```julia
makedocs(...,
    warnonly = Documenter.except(:linkcheck, :footnote),
)
```

The possible `Symbol` values that can be passed to the function are:
$(join(Ref("`:") .* string.(ERROR_NAMES) .* Ref("`"), ", ", ", and ")).
"""
function except(errors::Symbol...)
    invalid_errors = setdiff(errors, ERROR_NAMES)
    if !isempty(invalid_errors)
        throw(
            DomainError(
                tuple(invalid_errors...),
                "Invalid error classes passed to Documenter.except. Valid error classes are: $(ERROR_NAMES)"
            )
        )
    end
    return setdiff(ERROR_NAMES, errors)
end

"""
$(SIGNATURES)

Allows a page to be hidden in the navigation menu. It will only show up if it happens to be
the current page. The hidden page will still be present in the linear page list that can be
accessed via the previous and next page links. The title of the hidden page can be overridden
using the `=>` operator as usual.

# Usage

```julia
makedocs(
    ...,
    pages = [
        ...,
        hide("page1.md"),
        hide("Title" => "page2.md")
    ]
)
```
"""
hide(page::Pair) = (false, page.first, page.second, [])
hide(page::AbstractString) = (false, nothing, page, [])

"""
$(SIGNATURES)

Allows a subsection of pages to be hidden from the navigation menu. `root` will be linked
to in the navigation menu, with the title determined as usual. `children` should be a list
of pages (note that it **can not** be hierarchical).

# Usage

```julia
makedocs(
    ...,
    pages = [
        ...,
        hide("Hidden section" => "hidden_index.md", [
            "hidden1.md",
            "Hidden 2" => "hidden2.md"
        ]),
        hide("hidden_index.md", [...])
    ]
)
```
"""
hide(root::Pair, children) = (true, root.first, root.second, map(hide, children))
hide(root::AbstractString, children) = (true, nothing, root, map(hide, children))

"""
    struct MissingRemoteError <: Exception

This error is thrown by [`makedocs`](@ref) when it is unable to determine the remote repository link
for a Markdown file or a docstring.

See the [Remote repository links](@ref) section in the manual for more information.
"""
struct MissingRemoteError <: Exception
    path::String
    linerange::Any
    mod::Union{Module, Nothing}

    function MissingRemoteError(;
            path::AbstractString,
            linerange = nothing,
            mod::Union{Module, Nothing} = nothing
        )
        return new(path, linerange, mod)
    end
end

function Base.showerror(io::IO, e::MissingRemoteError)
    print(io, "MissingRemoteError: unable to generate source url\n  path: $(e.path)")
    isnothing(e.linerange) || print(io, ':', e.linerange)
    println(io)
    isnothing(e.mod) || println(io, "  module: ", e.mod)
    return print(
        io, """
        Documenter was unable to automatically determine the remote repository for this file.
        This can happen if you are including docstrings or pages from secondary packages. Those packages
        must be cloned as Git repositories (i.e. Pkg.develop instead of Pkg.add), or the `remotes` keyword
        must be configured appropriately. See the 'Remote repository links' section in the manual for
        more information."""
    )
end

module DuplicateHeaderTests

# A non-unique header slug must be reported, and must never be resolved as a binding.
# `[Blow-Ups](@ref)` parses as `Blow - Ups`, which used to link to the docstring of `-`
# (https://github.com/JuliaDocs/Documenter.jl/issues/2668); plain text is now a header
# reference only, so it is never looked up as code in the first place.
#
# It must also not pre-empt a reference that a later step resolves correctly, which is what
# made https://github.com/JuliaDocs/Documenter.jl/issues/2843 report 66 working links.

using Test
using Documenter
using IOCapture

isdefined(Main, :DuplicateHeaderContent) || @eval Main module DuplicateHeaderContent
    struct MyStruct end
    """This is the `-` method."""
    Base.:-(::MyStruct) = nothing

    """This is the `Stepsize` type, whose name also occurs as a header."""
    struct Stepsize end
end

@testset "Duplicate headers" begin
    captured = IOCapture.capture() do
        makedocs(
            root = dirname(@__FILE__),
            source = "src",
            build = "build",
            sitename = "DuplicateHeaders",
            modules = [Main.DuplicateHeaderContent],
            warnonly = true,
            remotes = nothing,
            format = Documenter.HTML(prettyurls = false, inventory_version = ""),
        )
    end
    output = replace(captured.output, "\\src\\index" => "/src/index")

    # The ambiguity is reported ...
    @test contains(output, "Cannot resolve @ref for md\"[Blow-Ups](@ref)\"")
    @test contains(output, "Header or `@id` anchor with slug 'Blow-Ups' is not unique")
    # ... and not papered over by a docstring lookup.
    @test !contains(output, "binding `Base.-`")

    html = read(joinpath(dirname(@__FILE__), "build", "index.html"), String)
    @test contains(html, "<a href=\"@ref\">Blow-Ups</a>")
    @test !occursin(r"<a href=\"[^\"]*Base[^\"]*\">Blow-Ups</a>", html)
    # An ambiguous header slug does not stop a docstring reference of the same name.
    @test contains(html, "#Main.DuplicateHeaderContent.Stepsize\"><code>Main.DuplicateHeaderContent.Stepsize</code></a>")
end

end

"""
This is the [`DocumenterShowcase`](@ref), which contains

* [`DocumenterShowcase.foo`](@ref)
* [`DocumenterShowcase.bar`](@ref)

!!! compat "Documenter 0.24"

    This showcase page is included in Documenter version 0.24.0 and above.

# Contents

Docstrings can contain admonitions and other block-level nodes.

!!! info

    This admonition is in a docstring. It itself can contain block levels nodes such
    as code blocks:

    ```julia
    println("Hello World")
    ```

    ... or block quotes:

    > Lorem ipsum.

In fact, while not recommended, you can actually have a matryoshka of admonitions:

!!! danger
    !!! warning
        !!! tip
            !!! note
                Stack overflow.
"""
module DocumenterShowcase

"""
    foo(::Integer)

Docstring for `foo(::Integer)`.
"""
foo(::Integer) = nothing

"""
    foo(::AbstractString)

Docstring for `foo(::AbstractString)`.
"""
foo(::AbstractString) = nothing

"""
    bar(::Integer)

Docstring for `bar(::Integer)`.
"""
bar(::Integer) = nothing

"""
    bar(::AbstractString)

Docstring for `bar(::AbstractString)`.
"""
bar(::AbstractString) = nothing

"""
    baz(x, f, k)

Function with a more complex docstring.
Headings that are part of docstrings are not rendered as headings but rather as bold text:

# Arguments
- `x::Integer`: the first argument
- `f`: a function with multiple allowable arguments itself  

  ## Pattern
  - `f(a::Integer)`
  - `f(a::Real)`
  - `f(a::Real, b::Real)`

- `k::Integer`: the third argument

See also [`bar`](@ref).
"""
baz(x::Integer, f, k::Integer) = nothing

function hello(who)
    println("Hello, $(who)!")
    return
end

struct SVGCircle
    stroke::String
    fill::String
end
function Base.show(io, ::MIME"image/svg+xml", c::SVGCircle)
    write(
        io, """
        <svg width="50" height="50">
          <g style="stroke-width: 3">
            <circle cx="25" cy="25" r="24" stroke-width="2" style="stroke: #$(c.stroke); fill: #$(c.fill)" />
          </g>
        </svg>
        """
    )
    return
end

"The type definition."
struct Foo{T, S} end

"Constructor `Foo()` with no arguments."
Foo() = Foo{Nothing, Nothing}()

"Constructor `Foo{T}()` with one parametric argument."
Foo{T}() where {T} = Foo{T, Nothing}()

end # module

module ErrorsModule

    """
    ```jldoctest
    julia> a = 1
    2

    ```

    ```jldoctest
    ```
    """
    func(x) = x

end

using Documenter, Test

makedocs(sitename = "-", modules = [ErrorsModule], warnonly = true)

for warnonly in (false, :autodocs_block, [:autodocs_block])
    # The build should fail with a :doctest error
    @test_throws ErrorException makedocs(modules = [ErrorsModule], warnonly = warnonly)
end

# The following tests check that we can somewhat handle bad docsystem metadata. Issues:
#
#  - https://github.com/JuliaDocs/Documenter.jl/issues/1192
#  - https://github.com/JuliaDocs/Documenter.jl/issues/1810
#  - https://github.com/JuliaDocs/Documenter.jl/pull/1811
#  - https://github.com/JuliaLang/julia/issues/45174
#
module BadDocmetaModule
    struct TestStruct1 end
    struct TestStruct2 end
    struct TestStruct3 end

    "standard"
    (baz::TestStruct1)(a::Int) = 0

    "parametric"
    (foo::TestStruct2)(a::T) where {T} = 0

    "return"
    (bar::TestStruct3)(a::Int, b::Int)::Int = 0
end

@test makedocs(
    warnonly = :autodocs_block,
    source = "src.docmeta", modules = [BadDocmetaModule], sitename = "-", checkdocs = :exports,
) === nothing
@test makedocs(
    warnonly = true,
    source = "src.docmeta", modules = [BadDocmetaModule], sitename = "-", checkdocs = :exports,
) === nothing
if VERSION >= v"1.9.0-DEV.954"
    # The docsystem metadata for the following tests was fixed in
    #   https://github.com/JuliaLang/julia/pull/45529
    @test makedocs(
        source = "src.docmeta", modules = [BadDocmetaModule], sitename = "-", checkdocs = :exports,
    ) === nothing
    @test makedocs(
        warnonly = Documenter.except(:autodocs_block),
        source = "src.docmeta", modules = [BadDocmetaModule], sitename = "-", checkdocs = :exports,
    ) === nothing
else
    @test_throws ErrorException makedocs(
        source = "src.docmeta", modules = [BadDocmetaModule], sitename = "-", checkdocs = :exports,
    )
    @test_throws ErrorException makedocs(
        warnonly = Documenter.except(:autodocs_block),
        source = "src.docmeta", modules = [BadDocmetaModule], sitename = "-", checkdocs = :exports,
    )
end

module NavNodeTests

using Test

import Documenter: Documenter, Builder, NavNode

mutable struct FakeDocumentBlueprint
    pages::Dict{String, Nothing}
    FakeDocumentBlueprint() = new(Dict())
end
mutable struct FakeDocumentInternal
    navlist::Vector{NavNode}
    FakeDocumentInternal() = new([])
end
mutable struct FakeDocument
    internal::FakeDocumentInternal
    blueprint::FakeDocumentBlueprint
    FakeDocument() = new(FakeDocumentInternal(), FakeDocumentBlueprint())
end

@testset "NavNode" begin
    @test fieldtype(FakeDocumentInternal, :navlist) == fieldtype(Documenter.Internal, :navlist)

    pages = [
        "page1.md",
        "Page2" => "page2.md",
        "Section" => [
            "page3.md",
            "Page4" => "page4.md",
            "Subsection" => [
                "page5.md",
            ],
        ],
        "page6.md",
    ]
    doc = FakeDocument()
    doc.blueprint.pages = Dict(map(i -> "page$i.md" => nothing, 1:8))
    navtree = Documenter.walk_navpages(pages, nothing, doc)
    navlist = doc.internal.navlist

    @test length(navlist) == 6
    for (i, navnode) in enumerate(navlist)
        @test navnode.page == "page$i.md"
    end

    @test isa(navtree, Vector{NavNode})
    @test length(navtree) == 4
    @test navtree[1] === navlist[1]
    @test navtree[2] === navlist[2]
    @test navtree[4] === navlist[6]

    section = navtree[3]
    @test section.title_override == "Section"
    @test section.page === nothing
    @test length(section.children) == 3

    navpath = Documenter.navpath(navlist[5])
    @test length(navpath) == 3
    @test navpath[1] === section
    @test navpath[3] === navlist[5]

    @test repr(navlist[1]) == "NavNode(\"page1.md\", nothing, nothing)"
    @test repr(navlist[2]) == "NavNode(\"page2.md\", \"Page2\", nothing)"
    @test repr(navlist[3]) == "NavNode(\"page3.md\", nothing, NavNode(nothing, ...))"
    @test repr(navlist[4]) == "NavNode(\"page4.md\", \"Page4\", NavNode(nothing, ...))"
    @test repr(navlist[5]) == "NavNode(\"page5.md\", nothing, NavNode(nothing, ...))"
    @test repr(navlist[6]) == "NavNode(\"page6.md\", nothing, nothing)"
end

end

using Documenter, DocumenterTools, Changelog
include("DocumenterShowcase.jl")

# The DOCSARGS environment variable can be used to pass additional arguments to make.jl.
# This is useful on CI, if you need to change the behavior of the build slightly but you
# cannot change the .travis.yml or make.jl scripts any more (e.g. for a tag build).
if haskey(ENV, "DOCSARGS")
    for arg in split(ENV["DOCSARGS"])
        (arg in ARGS) || push!(ARGS, arg)
    end
end

# Generate a Documenter-friendly changelog from CHANGELOG.md
Changelog.generate(
    Changelog.Documenter(),
    joinpath(@__DIR__, "..", "CHANGELOG.md"),
    joinpath(@__DIR__, "src", "release-notes.md");
    repo = "JuliaDocs/Documenter.jl",
)

linkcheck_ignore = [
    # We'll ignore links that point to GitHub's edit pages, as they redirect to the
    # login screen and cause a warning:
    r"https://github.com/([A-Za-z0-9_.-]+)/([A-Za-z0-9_.-]+)/edit(.*)",
    "https://nvd.nist.gov/vuln/detail/CVE-2018-16487",
    # We'll ignore the links to Documenter tags in CHANGELOG.md, since when you tag
    # a release, the release link does not exist yet, and this will cause the linkcheck
    # CI job to fail on the PR that tags a new release.
    r"https://github.com/JuliaDocs/Documenter.jl/releases/tag/v1.\d+.\d+",
]
# Extra ones we ignore only on CI.
if get(ENV, "GITHUB_ACTIONS", nothing) == "true"
    # It seems that CTAN blocks GitHub Actions?
    push!(linkcheck_ignore, "https://ctan.org/pkg/minted")
    # Putty homepage times out from Actions runners (curl exit 28).
    push!(linkcheck_ignore, "https://www.chiark.greenend.org.uk/~sgtatham/putty/")
    # Codeberg answers 403 to Actions runners.
    push!(linkcheck_ignore, r"^https://codeberg.org")
end

makedocs(
    modules = [Documenter, DocumenterTools, DocumenterShowcase],
    format = if "pdf" in ARGS
        Documenter.LaTeX(platform = "docker")
    else
        Documenter.HTML(
            # Use clean URLs, unless built as a "local" build
            prettyurls = !("local" in ARGS),
            canonical = "https://documenter.juliadocs.org/stable/",
            assets = ["assets/favicon.ico"],
            analytics = "UA-136089579-2",
            highlights = ["yaml"],
            ansicolor = true,
            size_threshold_ignore = ["release-notes.md"],
            inventory_version = Documenter.DOCUMENTER_VERSION,
        )
    end,
    build = ("pdf" in ARGS) ? "build-pdf" : "build",
    debug = ("pdf" in ARGS),
    sitename = "Documenter.jl",
    authors = "Michael Hatherly, Morten Piibeleht, and contributors.",
    linkcheck = "linkcheck" in ARGS,
    linkcheck_ignore = linkcheck_ignore,
    pages = [
        "Home" => "index.md",
        "Manual" => Any[
            "Guide" => "man/guide.md",
            "man/examples.md",
            "man/syntax.md",
            "man/doctests.md",
            "man/latex.md",
            hide("man/hosting.md", ["man/hosting/walkthrough.md"]),
            "man/other-formats.md",
        ],
        "showcase.md",
        "Reference" => Any[
            "Public API" => "lib/public.md",
            "lib/remote-links.md",
            "Semantic versioning" => "lib/semver.md",
        ],
        "Developers" => [
            "contributing.md",
            "checklists.md",
            "Internals" => map(
                s -> "lib/internals/$(s)",
                sort(readdir(joinpath(@__DIR__, "src/lib/internals")))
            ),
        ],
        "release-notes.md",
    ],
    warnonly = ("strict=false" in ARGS),
    doctest = ("doctest=only" in ARGS) ? :only : true,
)

if "pdf" in ARGS
    # hack to only deploy the actual pdf-file
    mkpath(joinpath(@__DIR__, "build-pdf", "commit"))
    let files = readdir(joinpath(@__DIR__, "build-pdf"))
        for f in files
            if startswith(f, "Documenter.jl") && endswith(f, ".pdf")
                mv(
                    joinpath(@__DIR__, "build-pdf", f),
                    joinpath(@__DIR__, "build-pdf", "commit", f)
                )
            end
        end
    end
    deploydocs(
        repo = "github.com/JuliaDocs/Documenter.jl.git",
        target = "pdf/build-pdf/commit",
        branch = "gh-pages-pdf",
        forcepush = true,
    )
else
    deploydocs(
        repo = "github.com/JuliaDocs/Documenter.jl.git",
        target = "build",
        push_preview = "linkcheck" ∉ ARGS,
    )
end

using Documenter
using Test

module DefaultMetaTestModule
    "A function that is not exported, and hence only findable via `CurrentModule`."
    function unexported_function end
end

const pages = [
    "Home" => "index.md",
    "No meta" => "nometa.md",
]

makedocs(
    sitename = "Test", pages = pages, doctest = true,
    modules = [DefaultMetaTestModule],
    meta = Dict(
        :DocTestSetup => :(x = 42),
        :CurrentModule => DefaultMetaTestModule,
        :CollapsedDocStrings => true,
    )
)

# `doctest` builds its own document, so it needs to forward `meta` itself.
doctest(
    joinpath(@__DIR__, "src"), Module[];
    testset = "Doctests: default meta",
    meta = Dict(:DocTestSetup => :(x = 42)),
)

# index.md passing its doctest covers `DocTestSetup`, and nometa.md resolving
# its `@ref` covers `CurrentModule`; both would have errored above. What is left
# to check is that `CollapsedDocStrings` reaches the HTML writer.
@testset "default meta reaches the writer" begin
    build = joinpath(@__DIR__, "build")
    file = joinpath(build, "nometa", "index.html")
    isfile(file) || (file = joinpath(build, "nometa.html"))
    @test occursin("data-docstringscollapsed", read(file, String))
end

module E

# https://discourse.julialang.org/t/is-compat-jl-worth-it-for-the-public-keyword/119041/
macro public_or_export(ex)
    args = ex isa Symbol ? (ex,) : Base.isexpr(ex, :tuple) ? ex.args : error()
    return if Base.isdefined(Base, :ispublic)
        esc(Expr(:public, args...))
    else
        esc(Expr(:export, args...))
    end
end

export f_1, f_2
@public_or_export f_3

"f_1"
f_1(x) = x

"f_2"
f_2(x) = x

"f_3"
f_3(x) = x


"g_1"
g_1(x) = x

"g_2"
g_2(x) = x

"g_3"
g_3(x) = x

export T_1

"T_1"
mutable struct T_1 end

"T_2"
mutable struct T_2 end

"T_3"
struct T_3{T} end

end

"""
Types and functions for handling repository remotes.
"""
module Remotes

"""
    abstract type Remote

Abstract supertype for implementing additional remote repositories that Documenter can use
when generating links to files hosted on Git hosting service (such as GitHub, GitLab etc).
For custom or less common Git hosting services, the user can create their own `Remote`
subtype and pass that as the `repo` argument to [`makedocs`](@ref Main.Documenter.makedocs).

When implementing a new type `T <: Remote`, the following functions must be extended for
that type:

* [`Remotes.repourl`](@ref)
* [`Remotes.fileurl`](@ref)

Additionally, it may also extend the following functions:

* [`Remotes.issueurl`](@ref)
"""
abstract type Remote end

"""
    Remotes.repourl(remote::T) -> String

An internal Documenter function that **must** be extended when implementing a user-defined
[`Remote`](@ref). It should return a string pointing to the landing page of the remote
repository. E.g. for [`GitHub`](@ref) it returns `"https://github.com/USER/REPO/"`.
"""
function repourl end

"""
    Remotes.fileurl(remote::T, ref, filename, linerange) -> String

An internal Documenter function that **must** be extended when implementing a user-defined
[`Remote`](@ref). Should return the full remote URL to the source file `filename`,
optionally including the line numbers.

* **`ref`** is string containing the Git reference, such as a commit SHA, branch name or a tag
  name.

* **`filename`** is a string containing the full path of the file in the repository without any
  leading `/` characters.

* **`linerange`** either specifies a range of integers or is `nothing`. In the former case it
  either specifies a line number (if `first(linerange) == last(linerange)`) or a range of
  lines (`first(linerange) < last(linerange)`). The line information should be accessed only
  with the `first` and `last` functions (no other interface guarantees are made).

  If `linerange` is `nothing`, the line numbers should be omitted and the returned URL
  should refer to the full file.

  It is also acceptable for an implementation to completely ignore the value of the
  `linerange` argument, e.g. when the remote repository does not support direct links to
  particular line numbers.

E.g. for [`GitHub`](@ref), depending on the input arguments, it would return the following
strings:

| `ref`       | `filename`     | `linerange` | returned string                                                 |
| ----------- | -------------- | ----------- | :-------------------------------------------------------------- |
| `"master"`  | `"foo/bar.jl"` | `nothing`   | `"https://github.com/USER/REPO/blob/master/foo/bar.jl"`         |
| `"v1.2.3"`  | `"foo/bar.jl"` | `12:12`     | `"https://github.com/USER/REPO/blob/v1.2.3/foo/bar.jl#L12"`     |
| `"xyz/foo"` | `"README.md"`  | `10:15`     | `"https://github.com/USER/REPO/blob/xyz/foo/README.md#L10-L15"` |
"""
function fileurl end

"""
    Remotes.issueurl(remote::T, issuenumber)

An internal Documenter function that can be extended when implementing a user-defined
[`Remote`](@ref). It should return a string with the full URL to an issue referenced by
`issuenumber`, or `nothing` if it is not possible to determine such a URL.

* **`issuenumber`** is a string containing the issue number.

It is not mandatory to define this method for a custom [`Remote`](@ref). In this case it
just falls back to always returning `nothing`.

E.g. for [`GitHub`](@ref) when `issuenumber = "123"`, it would return
`"https://github.com/USER/REPO/issues/123"`.
"""
function issueurl end
# Generic fallback always returning nothing
issueurl(::Remote, ::Any) = nothing

"""
    repofile(remote::Remote, ref, filename, linerange=nothing)

Documenter's internal version of `fileurl`, which sanitizes the inputs before they are passed
to the potentially user-defined `fileurl` implementations.
"""
function repofile(remote::Remote, ref, filename, linerange = nothing)
    # sanitize the file name
    filename = replace(filename, '\\' => '/') # remove backslashes on Windows
    filename = lstrip(filename, '/') # remove leading spaces
    # Only pass UnitRanges to user code (even though we require the users to support any
    # collection supporting first/last).
    return fileurl(remote, ref, filename, isnothing(linerange) ? nothing : Int(first(linerange)):Int(last(linerange)))
end

"""
    GitHub(user :: AbstractString, repo :: AbstractString)
    GitHub(remote :: AbstractString)

Represents a remote Git repository hosted on GitHub. The repository is identified by the
names of the user (or organization) and the repository: `GitHub(user, repository)`. E.g.:

```julia
makedocs(
    repo = GitHub("JuliaDocs", "Documenter.jl")
)
```

The single-argument constructor assumes that the user and repository parts are separated by
a slash (e.g. `JuliaDocs/Documenter.jl`).
"""
struct GitHub <: Remote
    user::String
    repo::String
end
function GitHub(remote::AbstractString)
    user, repo = split(remote, '/')
    return GitHub(user, repo)
end
repourl(remote::GitHub) = "https://github.com/$(remote.user)/$(remote.repo)"
function fileurl(remote::GitHub, ref::AbstractString, filename::AbstractString, linerange)
    url = "$(repourl(remote))/blob/$(ref)/$(filename)"
    isnothing(linerange) && return url
    lstart, lend = first(linerange), last(linerange)
    return (lstart == lend) ? "$(url)#L$(lstart)" : "$(url)#L$(lstart)-L$(lend)"
end
issueurl(remote::GitHub, issuenumber) = "$(repourl(remote))/issues/$issuenumber"

"""
    GitLab(host, user, repo)
    GitLab(user, repo)
    GitLab(remote)

Represents a remote Git repository hosted on GitLab. The repository is
identified by the host, name of the user (or organization), and the
repository. For example:

```julia
makedocs(
    repo = GitLab("JuliaDocs", "Documenter.jl")
)
```

The single argument constructor assumes that the end user and
repository parts are separated by a slash (e.g.,
`JuliaDocs/Documenter.jl`).
"""
struct GitLab <: Remote
    host::String
    user::String
    repo::String
end
GitLab(user::AbstractString, repo::AbstractString) = GitLab("gitlab.com", user, repo)
function GitLab(remote::AbstractString)
    user, repo = split(remote, '/')
    return GitLab(user, repo)
end
repourl(remote::GitLab) = "https://$(remote.host)/$(remote.user)/$(remote.repo)"
function fileurl(remote::GitLab, ref::AbstractString, filename::AbstractString, linerange)
    url = "$(repourl(remote))/-/tree/$(ref)/$(filename)"
    isnothing(linerange) && return url
    lstart, lend = first(linerange), last(linerange)
    return (lstart == lend) ? "$(url)#L$(lstart)" : "$(url)#L$(lstart)-L$(lend)"
end
issueurl(remote::GitLab, issuenumber) = "$(repourl(remote))/-/issues/$issuenumber"

"""
    Forgejo(host, user, repo)
    Forgejo(remote)

Represents a remote Git repository hosted on Forgejo (for example,
[Codeberg](https://codeberg.org)). The repository is
identified by the host, name of the user (or organization), and the
repository. For example:

```julia
makedocs(
    repo = Forgejo("codeberg.org", "JuliaDocs", "Documenter.jl")
)
```

The single argument constructor assumes that the host, end user and
repository parts are separated by a slash (e.g.,
`codeberg.org/JuliaDocs/Documenter.jl`).
"""
struct Forgejo <: Remotes.Remote
    host::String
    user::String
    repo::String
end
function Forgejo(remote::AbstractString)
    host, user, repo = split(remote, '/')
    return Forgejo(host, user, repo)
end
repourl(
    remote::Forgejo,
) = "https://$(remote.host)/$(remote.user)/$(remote.repo)"
function fileurl(
        remote::Forgejo,
        ref::AbstractString,
        filename::AbstractString,
        linerange,
    )
    url = "$(repourl(remote))/src/commit/$(ref)/$(filename)"
    isnothing(linerange) && return url
    lstart, lend = first(linerange), last(linerange)
    return (lstart == lend) ? "$(url)#L$(lstart)" : "$(url)#L$(lstart)-L$(lend)"
end
issueurl(
    remote::Forgejo,
    issuenumber,
) = "$(repourl(remote))/issues/$issuenumber"

############################################################################
# Handling of URL string templates (deprecated, for backwards compatibility)
#
"""
    URL(urltemplate, repourl=nothing)

A [`Remote`](@ref) type used internally in Documenter when the user passes a URL template
string as the `repo` argument. Will return `nothing` from `repourl` if the optional
`repourl` argument is not passed.

Can contain the following template sections that Documenter will replace:

* `{commit}`: replaced by the commit SHA, branch or tag name
* `{path}`: replaced by the path of the file, relative to the repository root
* `{line}`: replaced by the line (or line range) reference

For example, the template URLs might look something like:

* GitLab:
  ```
  https://gitlab.com/user/project/-/tree/{commit}{path}#{line}
  ```
* Azure DevOps:
  ```
  https://dev.azure.com/org/project/_git/repo?path={path}&version={commit}{line}&lineStartColumn=1&lineEndColumn=1
  ```
* BitBucket:
  ```
  https://bitbucket.org/user/project/src/{commit}/{path}#lines-{line}
  ```

However, an explicit [`Remote`](@ref) object is preferred over using a template string when
configuring Documenter.
"""
struct URL <: Remote
    urltemplate::String
    repourl::Union{String, Nothing}
    URL(urltemplate, repourl = nothing) = new(urltemplate, repourl)
end
repourl(remote::URL) = remote.repourl
function fileurl(remote::URL, ref, filename, linerange)
    hosttype = repo_host_from_url(remote.urltemplate)
    lines = (linerange === nothing) ? "" : format_line(linerange, LineRangeFormatting(hosttype))
    ref = format_commit(ref, hosttype)
    # lines = if linerange !== nothing
    # end
    s = replace(remote.urltemplate, "{commit}" => ref)
    # template strings assume that {path} has a leading / whereas filename does not
    s = replace(s, "{path}" => "/$(filename)")
    return replace(s, "{line}" => lines)
end

# Repository hosts
#   RepoUnknown denotes that the repository type could not be determined automatically
@enum RepoHost RepoGithub RepoBitbucket RepoGitlab RepoAzureDevOps RepoUnknown

# Repository host from repository url
# i.e. "https://github.com/something" => RepoGithub
#      "https://bitbucket.org/xxx" => RepoBitbucket
# If no match, returns RepoUnknown
function repo_host_from_url(repoURL::String)
    if occursin("bitbucket", repoURL)
        return RepoBitbucket
    elseif occursin("github", repoURL) || isempty(repoURL)
        return RepoGithub
    elseif occursin("gitlab", repoURL)
        return RepoGitlab
    elseif occursin("azure", repoURL)
        return RepoAzureDevOps
    else
        return RepoUnknown
    end
end
repo_host_from_url(::GitHub) = RepoGithub
repo_host_from_url(remote::Remote) = repo_host_from_url(Remotes.repourl(remote))
repo_host_from_url(::Nothing) = RepoUnknown

function format_commit(commit::AbstractString, host::RepoHost)
    if host === RepoAzureDevOps
        # if commit hash then preceded by GC, if branch name then preceded by GB
        if match(r"[0-9a-fA-F]{40}", commit) !== nothing
            commit = "GC$commit"
        else
            commit = "GB$commit"
        end
    else
        return commit
    end
end

struct LineRangeFormatting
    prefix::String
    separator::String

    function LineRangeFormatting(host::RepoHost)
        if host === RepoAzureDevOps
            return new("&line=", "&lineEnd=")
        elseif host == RepoBitbucket
            return new("", ":")
        elseif host == RepoGitlab
            return new("L", "-")
        else
            # default is github-style
            return new("L", "-L")
        end
    end
end

function format_line(range::AbstractRange, format::LineRangeFormatting)
    if length(range) <= 1
        return string(format.prefix, first(range))
    else
        return string(format.prefix, first(range), format.separator, last(range))
    end
end

end

module TestHelperModule
    import MarkdownAST
    import RegistryInstances
end


function render_expand_doc(src, kwargs...)
    doc = Documenter.Document(;
        sitename = "sitename",
        modules = [TestHelperModule, TestHelperModule.MarkdownAST, TestHelperModule.RegistryInstances],
        pages = ["testpage" => "testpage.md"],
        linkcheck = true
    )
    doc.blueprint.pages["testpage.md"] = Documenter.Page("", "", "", [], Documenter.Globals(), src)
    for navnode in walk_navpages(doc.user.pages, nothing, doc)
        push!(doc.internal.navtree, navnode)
    end
    expand(doc)
    ctx = HTMLContext(doc, HTML())
    html = render_article(ctx, doc.internal.navtree[1])
    return doc, html
end

module DocCheckTests

using Test

using Markdown
import Documenter
using Documenter: linkcheck, allbindings

# The following modules set up a few docstrings for allbindings tests
module Dep1
    "dep1_private"
    dep1_private() = nothing
    "dep1_private_2"
    dep1_private_2() = nothing
    "dep1_exported"
    dep1_exported() = nothing
    export dep1_exported
    "dep1_reexported"
    dep1_reexported() = nothing
    # test for shadowing exports
    "bar"
    bar() = nothing
end
module Dep2
    # This module extends a function from Dep1, but creates a new local binding
    # for it, to reproduce the case reported in
    # https://github.com/JuliaDocs/Documenter.jl/issues/1695
    using ..Dep1: Dep1
    const dep1_private = Dep1.dep1_private
    "Dep2: dep1_private"
    dep1_private(::Int) = nothing
end
module TestModule
    # Standard case of attaching a docstring to a local binding
    "local_binding"
    local_binding() = nothing
    "local_binding"
    local_binding_exported() = nothing
    export local_binding_exported

    # These extend functions from another module (package). The bindings should
    # all be Dep1.XXX, rather than TestModule.XXX
    using ..Dep1
    "TestModule : dep1_private"
    Dep1.dep1_private(::Any) = nothing
    "TestModule : dep1_exported"
    Dep1.dep1_exported(::Any) = nothing
    import ..Dep1: dep1_private_2
    "TestModule : dep1_private_2"
    dep1_private_2(::Any) = nothing
    # Re-export of a binding from another module
    import ..Dep1: dep1_reexported
    "TestModule : dep1_reexported"
    dep1_reexported(::Any) = nothing
    export dep1_reexported
    # This also extends Dep1.dep1_private, but the docstring should get attached
    # to the Dep2.dep1_private binding because of the assignment.
    using ..Dep2: Dep2
    "TestModuleDep2: Dep2.dep1_private"
    Dep2.dep1_private(::Any, ::Any) = nothing

    # This tests the case where there is an undocumented but exported local function
    # that shares the name with a documented function from another module, potentially
    # confusing the isexported check.
    const bar = nothing
    export bar
    "Dep1.bar"
    Dep1.bar(::Any) = nothing
end

@testset "doc checks" begin
    @testset "allbindings" begin
        # dep1_private has not been imported into TestModule, so the binding does not
        # resolve to the Deps1 binding.
        @test Docs.Binding(TestModule, :dep1_private) != Docs.Binding(Dep1, :dep1_private)
        @test Docs.Binding(TestModule, :dep1_private) != Docs.Binding(Dep2, :dep1_private)
        # These three bindings are imported into the TestModule scope, so the Binding objects
        # automatically resolve to the Dep1.X bindings.
        @test Docs.Binding(TestModule, :dep1_private_2) == Docs.Binding(Dep1, :dep1_private_2)
        @test Docs.Binding(TestModule, :dep1_exported) == Docs.Binding(Dep1, :dep1_exported)
        @test Docs.Binding(TestModule, :dep1_reexported) == Docs.Binding(Dep1, :dep1_reexported)
        # There is a TestModule.bar, but it's not the same as Dep1.bar, but the latter has
        # a docstring in TestModule.
        @test Docs.Binding(TestModule, :bar) != Docs.Binding(Dep1, :bar)

        let bindings = allbindings(:all, TestModule)
            @test length(bindings) == 8
            @test Docs.Binding(TestModule, :local_binding) in keys(bindings)
            @test Docs.Binding(TestModule, :local_binding_exported) in keys(bindings)
            @test Docs.Binding(Dep1, :dep1_private) in keys(bindings)
            @test Docs.Binding(Dep1, :dep1_private_2) in keys(bindings)
            @test Docs.Binding(Dep1, :dep1_exported) in keys(bindings)
            @test Docs.Binding(Dep1, :dep1_reexported) in keys(bindings)
            @test Docs.Binding(Dep1, :bar) in keys(bindings)
            @test Docs.Binding(Dep2, :dep1_private) in keys(bindings)
        end
        let bindings = allbindings(:exports, TestModule)
            @test length(bindings) == 2
            @test Docs.Binding(TestModule, :local_binding_exported) in keys(bindings)
            @test Docs.Binding(Dep1, :dep1_reexported) in keys(bindings)
        end
    end
end

end

"""
A module for rendering `Document` objects to HTML.

# Keywords

[`HTMLWriter`](@ref) uses the following additional keyword arguments that can be passed to
[`Documenter.makedocs`](@ref): `authors`, `pages`, `sitename`, `version`.
The behavior of [`HTMLWriter`](@ref) can be further customized by setting the `format`
keyword of [`Documenter.makedocs`](@ref) to a [`HTML`](@ref), which accepts the following
keyword arguments: `analytics`, `assets`, `canonical`, `disable_git`, `edit_link`,
`prettyurls`, `collapselevel`, `sidebar_sitename`, `highlights`, `mathengine` and `footer`.

**`sitename`** is the site's title displayed in the title bar and at the top of the
*navigation menu. It is also written into the inventory (see below).
This argument is mandatory for [`HTMLWriter`](@ref).

**`pages`** defines the hierarchy of the navigation menu.

# Experimental keywords

**`version`** specifies the version string of the current version which will be the
selected option in the version selector. If this is left empty (default) the version
selector will be hidden. The special value `git-commit` sets the value in the output to
`git:{commit}`, where `{commit}` is the first few characters of the current commit hash.

# `HTML` `Plugin` options

The [`HTML`](@ref) object provides additional customization options
for the [`HTMLWriter`](@ref). For more information, see the [`HTML`](@ref) documentation.

# Page outline

The [`HTMLWriter`](@ref) makes use of the page outline that is determined by the
headings. It is assumed that if the very first block of a page is a level 1 heading,
then it is intended as the page title. This has two consequences:

1. It is then used to automatically determine the page title in the navigation menu
   and in the `<title>` tag, unless specified in the `.pages` option.
2. If the first heading is interpreted as being the page title, it is not displayed
   in the navigation sidebar.

# Inventory

The `HTMLWriter` automatically generates an `objects.inv` "inventory" file in
the output `build` folder. This file contains a list of all pages, headers and
docstrings in the documentation, and a relative URL that can be used to link to
those items from an external source.

Other projects that build their documentation with Documenter can use the
[`DocumenterInterLinks` plugin](https://github.com/JuliaDocs/DocumenterInterLinks.jl#readme)
to link to any other project with an inventory file, see
[External Cross-References](@ref).

The [format of the `objects.inv` file](https://juliadocs.org/DocInventories.jl/stable/formats/#Sphinx-Inventory-Format)
is borrowed from the [Sphinx project](https://www.sphinx-doc.org/en/master/). It consists
of a plain text header that includes the project name, taken from the `sitename` argument
to [`Documenter.makedocs`](@ref), and a project `version` taken from the
`inventory_version` argument of the [`HTML`](@ref) options, or automatically
determined by [`deploydocs`](@ref Documenter.deploydocs) for tagged releases.
The bulk of the file is a list of plain text records, compressed with gzip. See
[Inventory Generation](https://juliadocs.org/DocumenterInterLinks.jl/stable/write_inventory/)
for details on these records.
"""
module HTMLWriter

using Dates: Dates
using Markdown: Markdown
using MarkdownAST: MarkdownAST, Node
using TOML: TOML
using JSON: JSON
using Base64: Base64
using SHA: SHA
using CodecZlib: ZlibCompressorStream
using ANSIColoredPrinters: ANSIColoredPrinters

using ..Documenter: Documenter, Default, Remotes, locrepr
using ...JSDependencies: JSDependencies
using ...DOM: DOM, @tags
using ...MDFlatten: mdflatten

export HTML

"Data attribute for the script inserting a warning for outdated docs."
const OUTDATED_VERSION_ATTR = "data-outdated-warner"

"List of Documenter native themes."
const THEMES = ["documenter-light", "documenter-dark", "catppuccin-latte", "catppuccin-frappe", "catppuccin-macchiato", "catppuccin-mocha"]
"The root directory of the HTML assets."
const ASSETS = normpath(joinpath(@__DIR__, "..", "..", "assets", "html"))
"The version of minisearch to use."
const MINISEARCH_VERSION = "6.1.0"
"The directory where all the Sass/SCSS files needed for theme building are."
const ASSETS_SASS = joinpath(ASSETS, "scss")
"Directory for the compiled CSS files of the themes."
const ASSETS_THEMES = joinpath(ASSETS, "themes")

abstract type HTMLHeadContent end

struct HTMLAsset <: HTMLHeadContent
    class::Symbol
    uri::String
    islocal::Bool
    attributes::Dict{Symbol, String}

    function HTMLAsset(class::Symbol, uri::String, islocal::Bool, attributes::Dict{Symbol, String} = Dict{Symbol, String}())
        if !islocal && match(r"^https?://", uri) === nothing
            error("Remote asset URL must start with http:// or https://")
        end
        if islocal && isabspath(uri)
            @error("Local asset should not have an absolute URI: $uri")
        end
        class in [:ico, :css, :js] || error("Unrecognised asset class $class for `$(uri)`")
        return new(class, uri, islocal, attributes)
    end
end

"""
    RawHTMLHeadContent(content::String)

Raw HTML content to be inserted into the `<head>` section of the HTML document. This type can
be used in the `assets` keyword of [`HTML`](@ref), just like [`asset`](@ref).
"""
struct RawHTMLHeadContent <: HTMLHeadContent
    content::String
end

"""
    asset(uri)

Can be used to pass non-local web assets to [`HTML`](@ref), where `uri` should be an absolute
HTTP or HTTPS URL.

It accepts the following keyword arguments:

**`class`** can be used to override the asset class, which determines how exactly the asset
gets included in the HTML page. This is necessary if the class can not be determined
automatically (default).

Should be one of: `:js`, `:css` or `:ico`. They become a `<script>`,
`<link rel="stylesheet" type="text/css">` and `<link rel="icon" type="image/x-icon">`
elements in `<head>`, respectively.

**`islocal`** can be used to declare the asset to be local. The `uri` should then be a path
relative to the documentation source directory (conventionally `src/`). This can be useful
when it is necessary to override the asset class of a local asset.

# Usage

```julia
Documenter.HTML(assets = [
    # Standard local asset
    "assets/extra_styles.css",
    # Standard remote asset (extension used to determine that class = :js)
    asset("https://example.com/jslibrary.js"),
    # Setting asset class manually, since it can't be determined manually
    asset("https://example.com/fonts", class = :css),
    # Same as above, but for a local asset
    asset("asset/foo.script", class=:js, islocal=true),
])
```
"""
function asset(uri; class = nothing, islocal = false, attributes = Dict{Symbol, String}())
    if class === nothing
        class = assetclass(uri)
        if class === nothing
            error(
                """
                Unable to determine asset class for: $(uri)
                It can be set explicitly with the `class` keyword argument.
                """
            )
        end
    end
    return HTMLAsset(class, uri, islocal, attributes)
end

function assetclass(uri)
    # TODO: support actual proper URIs
    ext = splitext(uri)[end]
    return ext == ".ico" ? :ico :
        ext == ".css" ? :css :
        ext == ".js" ? :js : :unknown
end

abstract type MathEngine end

"""
    KaTeX(config::Dict = <default>, override = false)

An instance of the `KaTeX` type can be passed to [`HTML`](@ref) via the `mathengine` keyword
to specify that the [KaTeX rendering engine](https://katex.org/) should be used in the HTML
output to render mathematical expressions.

A dictionary can be passed via the `config` argument to configure KaTeX. It becomes the
[options argument of `renderMathInElement`](https://katex.org/docs/autorender.html#api). By
default, Documenter only sets a custom `delimiters` option.

By default, the user-provided dictionary gets _merged_ with the default dictionary (i.e. the
resulting configuration dictionary will contain the values from both dictionaries, but e.g.
setting your own `delimiters` value will override the default). This can be overridden by
setting `override` to `true`, in which case the default values are ignored and only the
user-provided dictionary is used.
"""
struct KaTeX <: MathEngine
    config::Dict{Symbol, Any}
    function KaTeX(config::Union{Dict, Nothing} = nothing, override = false)
        default = Dict(
            :delimiters => [
                Dict(:left => raw"$", :right => raw"$", :display => false),
                Dict(:left => raw"$$", :right => raw"$$", :display => true),
                Dict(:left => raw"\[", :right => raw"\]", :display => true),
            ]
        )
        return new((config === nothing) ? default : override ? config : merge(default, config))
    end
end

"""
    MathJax2(config::Dict = <default>, override = false)

An instance of the `MathJax2` type can be passed to [`HTML`](@ref) via the `mathengine`
keyword to specify that the [MathJax v2 rendering engine](https://www.mathjax.org/) should be
used in the HTML output to render mathematical expressions.

A dictionary can be passed via the `config` argument to configure MathJax. It gets passed to
the [`MathJax.Hub.Config`](https://docs.mathjax.org/en/v2.7/options/) function. By
default, Documenter sets custom configurations for `tex2jax`, `config`, `jax`, `extensions`
and `Tex`.

By default, the user-provided dictionary gets _merged_ with the default dictionary (i.e. the
resulting configuration dictionary will contain the values from both dictionaries, but e.g.
setting your own `tex2jax` value will override the default). This can be overridden by
setting `override` to `true`, in which case the default values are ignored and only the
user-provided dictionary is used.

The URL of the MathJax JS file can be overridden using the `url` keyword argument (e.g. to
use a particular minor version).
"""
struct MathJax2 <: MathEngine
    config::Dict{Symbol, Any}
    url::String
    function MathJax2(config::Union{Dict, Nothing} = nothing, override = false; url = "")
        default = Dict(
            :tex2jax => Dict(
                "inlineMath" => [["\$", "\$"], ["\\(", "\\)"]],
                "processEscapes" => true
            ),
            :config => ["MMLorHTML.js"],
            :jax => [
                "input/TeX",
                "output/HTML-CSS",
                "output/NativeMML",
            ],
            :extensions => [
                "MathMenu.js",
                "MathZoom.js",
                "TeX/AMSmath.js",
                "TeX/AMSsymbols.js",
                "TeX/autobold.js",
                "TeX/autoload-all.js",
            ],
            :TeX => Dict(:equationNumbers => Dict(:autoNumber => "AMS"))
        )
        return new((config === nothing) ? default : override ? config : merge(default, config), url)
    end
end

@deprecate MathJax(config::Union{Dict, Nothing} = nothing, override = false) MathJax2(config, override) false
@doc "deprecated – Use [`MathJax2`](@ref) instead" MathJax

"""
    MathJax3(config::Dict = <default>, override = false)

An instance of the `MathJax3` type can be passed to [`HTML`](@ref) via the `mathengine`
keyword to specify that the [MathJax v3 rendering engine](https://www.mathjax.org/) should be
used in the HTML output to render mathematical expressions.

A dictionary can be passed via the `config` argument to configure MathJax. It gets passed to
[`Window.MathJax`](https://docs.mathjax.org/en/latest/options/) function. By default,
Documenter specifies in the key `tex` that `\$...\$` and `\\(...\\)` denote inline math, that AMS
style tags should be used and the `base`, `ams` and `autoload` packages should be imported.
The key `options`, by default, specifies which HTML classes to ignore and which to process
using MathJax.

By default, the user-provided dictionary gets _merged_ with the default dictionary (i.e. the
resulting configuration dictionary will contain the values from both dictionaries, but e.g.
setting your own `tex` value will override the default). This can be overridden by
setting `override` to `true`, in which case the default values are ignored and only the
user-provided dictionary is used.

The URL of the MathJax JS file can be overridden using the `url` keyword argument (e.g. to
use a particular minor version).
"""
struct MathJax3 <: MathEngine
    config::Dict{Symbol, Any}
    url::String
    function MathJax3(config::Union{Dict, Nothing} = nothing, override = false; url = "")
        default = Dict(
            :tex => Dict(
                "inlineMath" => [["\$", "\$"], ["\\(", "\\)"]],
                "tags" => "ams",
                "packages" => ["base", "ams", "autoload", "mhchem"],
            ),
            :options => Dict(
                "ignoreHtmlClass" => "tex2jax_ignore",
                "processHtmlClass" => "tex2jax_process",
            )
        )
        return new((config === nothing) ? default : override ? config : merge(default, config), url)
    end
end

"""
    HTML(kwargs...)

Sets the behavior of [`HTMLWriter`](@ref).

# Keyword arguments

**`prettyurls`** (default `true`) -- allows toggling the pretty URLs feature.

By default (i.e., when `prettyurls` is set to `true`), Documenter creates a directory
structure that hides the `.html` suffixes from the URLs (e.g., by default `src/foo.md`
becomes `src/foo/index.html`, but can be accessed via `src/foo/` in the browser). This
structure is preferred when publishing the generated HTML files as a website (e.g., on
GitHub Pages), which is Documenter's primary use case. However, when building locally,
viewing the resulting pages requires a running webserver. It is recommended to use the
[`LiveServer` package](https://github.com/JuliaDocs/LiveServer.jl) for this.

If `prettyurls = false`, then Documenter generates `src/foo.html` instead.

**`disable_git`** can be used to disable calls to `git` when the document is not
in a Git-controlled repository. Without setting this to `true`, Documenter will throw
an error and exit if any of the Git commands fail. The calls to Git are mainly used to
gather information about the current commit hash and file paths, necessary for constructing
the links to the remote repository.

**`edit_link`** can be used to specify which branch, tag or commit (when passed a `String`)
in the remote repository the edit buttons point to. If a special `Symbol` value `:commit`
is passed, the current commit will be used instead. If set to `nothing`, the link edit link
will be hidden altogether. By default, Documenter tries to determine it automatically by
looking at the `origin` remote, and falls back to `"master"` if that fails.

**`repolink`** can be used to override the URL of the Git repository link in the top navbar
(if passed a `String`). By default, Documenter attempts to determine the link from the Git
remote of the repository (e.g. specified via the `remotes` argument of
[`makedocs`](@ref Documenter.makedocs)). Passing a `nothing` disables the repository link.

**`canonical`** specifies the canonical URL for your documentation. We recommend
you set this to the base url of your stable documentation, e.g. `https://documenter.juliadocs.org/stable`.
This allows search engines to know which version to send their users to. [See
wikipedia for more information](https://en.wikipedia.org/wiki/Canonical_link_element).
Default is `nothing`, in which case no canonical link is set.

**`assets`** can be used to include additional assets (JS, CSS, ICO etc. files). See below
for more information.

**`analytics`** can be used specify the Google Analytics tracking ID.

**`collapselevel`** controls the navigation level visible in the sidebar. Defaults to `2`.
To show fewer levels by default, set `collapselevel = 1`.

**`sidebar_sitename`** determines whether the site name is shown in the sidebar or not.
Setting it to `false` can be useful when the logo already contains the name of the package.
Defaults to `true`.

**`highlights`** can be used to add highlighting for additional languages. By default,
Documenter already highlights all the ["Common" highlight.js](https://highlightjs.org/download)
languages and Julia (`julia`, `julia-repl`). Additional languages must be specified by
their filenames as they appear on [CDNJS](https://cdnjs.com/libraries/highlight.js) for the
highlight.js version Documenter is using. E.g. to include highlighting for YAML and LLVM IR,
you would set `highlights = ["llvm", "yaml"]`. Note that no verification is done whether the
provided language names are sane.

**`mathengine`** specifies which LaTeX rendering engine will be used to render the math
blocks. The options are either [KaTeX](https://katex.org/) (default),
[MathJax v2](https://www.mathjax.org/), or [MathJax v3](https://www.mathjax.org/), enabled by
passing an instance of [`KaTeX`](@ref), [`MathJax2`](@ref), or
[`MathJax3`](@ref) objects, respectively. The rendering engine can further be customized by
passing options to the [`KaTeX`](@ref) or [`MathJax2`](@ref)/[`MathJax3`](@ref) constructors.

**`description`** is the site-wide description that displays in page previews and search
engines. Defaults to `"Documentation for \$sitename"`, where `sitename` is defined as
an argument to [`makedocs`](@ref Documenter.makedocs).

**`footer`** can be a valid single-line markdown `String` or `nothing` and is displayed below
the page navigation. Defaults to `"Powered by [Documenter.jl](https://github.com/JuliaDocs/Documenter.jl)
and the [Julia Programming Language](https://julialang.org/)."`.

**`ansicolor`** can be used to globally disable colored output from `@repl` and `@example`
blocks by setting it to `false` (default: `true`).

**`lang`** specifies the [`lang` attribute](https://developer.mozilla.org/en-US/docs/Web/HTML/Reference/Global_attributes/lang)
of the top-level `<html>` element, declaring the language of the generated pages. The default
value is `"en"`.

**`warn_outdated`** inserts a warning if the current page is not the newest version of the
documentation.

**`example_size_threshold`** specifies the size threshold above which the `@example` and other block
outputs get written to files, rather than being included in the HTML page. This mechanism is present
to reduce the size of the generated HTML files that contain a lot of figures etc.
Setting it to `nothing` will disable writing to files, and setting to `0` means that all examples
will be written to files. Defaults to `8 KiB`.

**`size_threshold`** sets the maximum allowed HTML file size (in bytes) that Documenter is allowed to
generate for a page. If the generated HTML file is larged than this, Documenter will throw an error and
the build will fail. If set to `nothing`, the file sizes are not checked. Defaults to `200 KiB` (but
increases of this default value will be considered to be non-breaking).

**`size_threshold_warn`**: like `size_threshold`, but going over this limit will only cause Documenter to
print a warning, instead of throwing an error. Defaults to `100 KiB`, and must be less than or equal to
`size_threshold`.

**`size_threshold_ignore`** can be passed a list of pages for which the size thresholds are completely
ignored (silently). The arguments should be the same file paths as for the `pages` argument of
[`makedocs`](@ref Documenter.makedocs). Using this argument to ignore a few specific pages is preferred
over setting a high general limit, or disabling the size checking altogether.

!!! note "Purpose of HTML size thresholds"

    The size threshold, with a reasonable default, exists so that users would not deploy huge pages
    accidentally (which among other this will result in bad UX for the readers and negatively impacts
    SEO). It is relatively easy to have e.g. an `@example` produce a lot of output.

## Experimental options

**`prerender`** a boolean (`true` or `false` (default)) for enabling prerendering/build
time application of syntax highlighting of code blocks. Requires a `node` (NodeJS)
executable to be available in `PATH` or to be passed as the `node` keyword.

**`node`** path to a `node` (NodeJS) executable used for prerendering.

**`highlightjs`** file path to custom highglight.js library to be used with prerendering.

**`inventory_version`** a version string to write to the header of the
`objects.inv` inventory file. This should be a valid version number without a `v` prefix.
Defaults to the `version` defined in the `Project.toml` file in the parent folder of the
documentation root. Setting this to an empty string leaves the `version` in the inventory
unspecified until [`deploydocs`](@ref Documenter.deploydocs) runs and automatically sets the
`version` for any tagged release.

# Default and custom assets

Documenter copies all files under the source directory (e.g. `/docs/src/`) over
to the compiled site. It also copies a set of default assets from `/assets/html/`
to the site's `assets/` directory, unless the user already had a file with the
same name, in which case the user's files overrides the Documenter's file.
This could, in principle, be used for customizing the site's style and scripting.

The HTML output also links certain custom assets to the generated HTML documents,
specifically a logo, a preview image, and additional javascript files.
The asset files that should be linked must be placed in `assets/`, under the source
directory (e.g `/docs/src/assets`) and must be on the top level (i.e. files in
the subdirectories of `assets/` are not linked).

For the **logo**, Documenter checks for the existence of `assets/logo.{svg,png,webp,gif,jpg,jpeg}`,
in this order. The first one it finds gets displayed at the top of the navigation sidebar.
It will also check for `assets/logo-dark.{svg,png,webp,gif,jpg,jpeg}` and use that for dark
themes.

Similarly, for the **preview image**, Documenter checks for the existence of
`assets/preview.{png,webp,gif,jpg,jpeg}` in order. Assuming that `canonical` has
been set, the canonical URL for the image gets constructed, , and a set of
HTML `<meta>` tags are generated for the image, ensuring that the image shows
up in link previews. The preview image will not be shown if `canonical` is not set.

Additional JS, ICO, and CSS assets can be included in the generated pages by passing them as
a list with the `assets` keyword. Each asset will be included in the `<head>` of every page
in the order in which they are given. The type of the asset (i.e. whether it is going to be
included with a `<script>` or a `<link>` tag) is determined by the file's extension --
either `.js`, `.ico`[^1], or `.css` (unless overridden with [`asset`](@ref)).

Simple strings are assumed to be local assets and that each correspond to a file relative to
the documentation source directory (conventionally `src/`). Non-local assets, identified by
their absolute URLs, can be included with the [`asset`](@ref) function.

[^1]: Adding an ICO asset is primarily useful for setting a custom `favicon`.
"""
struct HTML <: Documenter.Writer
    prettyurls::Bool
    disable_git::Bool
    edit_link::Union{String, Symbol, Nothing}
    repolink::Union{String, Nothing, Default{Nothing}}
    canonical::Union{String, Nothing}
    assets::Vector{<:HTMLHeadContent}
    analytics::String
    collapselevel::Int
    sidebar_sitename::Bool
    highlights::Vector{String}
    mathengine::Union{MathEngine, Nothing}
    description::Union{String, Nothing}
    footer::Union{MarkdownAST.Node, Nothing}
    ansicolor::Bool
    lang::String
    warn_outdated::Bool
    prerender::Bool
    node::Union{Cmd, String, Nothing}
    highlightjs::Union{String, Nothing}
    size_threshold::Int
    size_threshold_warn::Int
    size_threshold_ignore::Vector{String}
    example_size_threshold::Int
    search_size_threshold_warn::Int
    inventory_version::Union{String, Nothing}

    function HTML(;
            prettyurls::Bool = true,
            disable_git::Bool = false,
            repolink::Union{String, Nothing, Default} = Default(nothing),
            edit_link::Union{String, Symbol, Nothing, Default} = Default(Documenter.git_remote_head_branch("HTML(edit_link = ...)", Documenter.currentdir())),
            canonical::Union{String, Nothing} = nothing,
            assets::Vector = String[],
            analytics::String = "",
            collapselevel::Integer = 2,
            sidebar_sitename::Bool = true,
            highlights::Vector{String} = String[],
            mathengine::Union{MathEngine, Nothing} = KaTeX(),
            description::Union{String, Nothing} = nothing,
            footer::Union{String, Nothing} = "Powered by [Documenter.jl](https://github.com/JuliaDocs/Documenter.jl) and the [Julia Programming Language](https://julialang.org/).",
            ansicolor::Bool = true,
            lang::String = "en",
            warn_outdated::Bool = true,
            prerender::Bool = false,
            node::Union{Cmd, String, Nothing} = nothing,
            highlightjs::Union{String, Nothing} = nothing,
            size_threshold::Union{Integer, Nothing} = 200 * 2^10, # 200 KiB
            size_threshold_warn::Union{Integer, Nothing} = 100 * 2^10, # 100 KiB
            size_threshold_ignore::Vector = String[],
            # The choice of the default here is that having ~10 figures on a page
            # seems reasonable, and that would lead to ~80 KiB, which is still fine
            # and leaves a buffer before hitting `size_threshold_warn`.
            example_size_threshold::Union{Integer, Nothing} = 8 * 2^10, # 8 KiB
            search_size_threshold_warn::Union{Integer, Nothing} = 500 * 2^10, # 500 KiB
            inventory_version = nothing,

            # deprecated keywords
            edit_branch::Union{String, Nothing, Default} = Default(nothing),
        )
        collapselevel >= 1 || throw(ArgumentError("collapselevel must be >= 1"))
        if prerender
            prerender, node, highlightjs = prepare_prerendering(prerender, node, highlightjs, highlights)
        end
        assets = map(assets) do asset
            isa(asset, HTMLHeadContent) && return asset
            isa(asset, AbstractString) && return HTMLAsset(assetclass(asset), asset, true)
            error("Invalid value in assets: $(asset) [$(typeof(asset))]")
        end
        # Handle edit_branch deprecation
        if !isa(edit_branch, Default)
            isa(edit_link, Default) || error("Can't specify edit_branch (deprecated) and edit_link simultaneously")
            @warn """
            The edit_branch keyword is deprecated -- use edit_link instead.
            Note: `edit_branch = nothing` must be changed to `edit_link = :commit`.
            """
            edit_link = (edit_branch === nothing) ? :commit : edit_branch
        end
        if isa(edit_link, Symbol) && (edit_link !== :commit)
            throw(ArgumentError("Invalid symbol (:$edit_link) passed to edit_link."))
        end
        if footer !== nothing
            footer = Markdown.parse(footer)
            if !(length(footer.content) == 1 && footer.content[1] isa Markdown.Paragraph)
                throw(ArgumentError("footer must be a single-line markdown compatible string."))
            end
            footer = isnothing(footer) ? nothing : convert(Node, footer)
        end
        # convert size threshold values to integers, if need be
        if isnothing(size_threshold)
            size_threshold = typemax(Int)
        elseif size_threshold <= 0
            throw(ArgumentError("size_threshold must be non-negative, got $(size_threshold)"))
        end
        if isnothing(size_threshold_warn)
            size_threshold_warn = min(typemax(Int), size_threshold)
        elseif size_threshold_warn <= 0
            throw(ArgumentError("size_threshold_warn must be non-negative, got $(size_threshold_warn)"))
        elseif size_threshold_warn > size_threshold
            throw(ArgumentError("size_threshold_warn ($size_threshold_warn) must be smaller than size_threshold ($size_threshold)"))
        end
        if isnothing(example_size_threshold)
            example_size_threshold = typemax(Int)
        elseif example_size_threshold < 0
            throw(ArgumentError("example_size_threshold must be non-negative, got $(example_size_threshold)"))
        end
        if isnothing(search_size_threshold_warn)
            search_size_threshold_warn = typemax(Int)
        elseif search_size_threshold_warn <= 0
            throw(ArgumentError("search_size_threshold_warn must be non-negative, got $(search_size_threshold_warn)"))
        end
        isa(edit_link, Default) && (edit_link = edit_link[])
        # We use normpath() when we construct the .page value for NavNodes, so we also need to normpath()
        # these values. This also ensures cross-platform compatibility of the values.
        size_threshold_ignore = normpath.(size_threshold_ignore)
        return new(
            prettyurls, disable_git, edit_link, repolink, canonical, assets, analytics,
            collapselevel, sidebar_sitename, highlights, mathengine, description, footer,
            ansicolor, lang, warn_outdated, prerender, node, highlightjs,
            size_threshold, size_threshold_warn, size_threshold_ignore, example_size_threshold,
            search_size_threshold_warn,
            (isnothing(inventory_version) ? nothing : string(inventory_version))
        )
    end
end

# HTML accepts ANSI, so this is `true`.
Documenter.writer_supports_ansicolor(::HTML) = true


# Cache of downloaded highlight.js bundles
const HLJSFILES = Dict{String, String}()
# Look for node and highlight.js
function prepare_prerendering(prerender, node, highlightjs, highlights)
    node = node === nothing ? Sys.which("node") : node
    if node === nothing
        @error "HTMLWriter: no node executable given or found on the system. Setting `prerender=false`."
        return false, node, highlightjs
    end
    if !success(`$node --version`)
        @error "HTMLWriter: bad node executable at $node. Setting `prerender=false`."
        return false, node, highlightjs
    end
    if highlightjs === nothing
        # Try to download
        curl = Sys.which("curl")
        if curl === nothing
            @error "HTMLWriter: no highlight.js file given and no curl executable found " *
                "on the system. Setting `prerender=false`."
            return false, node, highlightjs
        end
        @debug "HTMLWriter: downloading highlightjs"
        r = Documenter.JSDependencies.RequireJS([])
        RD.highlightjs!(r, highlights)
        libs = sort!(collect(r.libraries); by = first) # puts highlight first
        key = join((x.first for x in libs), ',')
        highlightjs = get!(HLJSFILES, key) do
            path, io = mktemp()
            # The path will be used as module path to be loaded by Node.js,
            # so we always need `/`. But on Windows, `mktemp` will give `\`.
            path = replace(path, '\\' => '/')
            for lib in libs
                println(io, "// $(lib.first)")
                run(pipeline(`$(curl) -fsSL $(lib.second.url)`; stdout = io))
                println(io)
            end
            close(io)
            return path
        end
    end
    return prerender, node, highlightjs
end

include("RD.jl")
include("write_inventory.jl")

struct SearchRecord
    src::String
    page::Documenter.Page
    fragment::String
    category::String
    title::String
    page_title::String
    text::String
end

Base.@kwdef struct AtExampleFallbackWarning
    page::String
    size_bytes::Int
    fallback::Union{String, Nothing}
end

"""
[`HTMLWriter`](@ref)-specific globals that are passed to `domify` and
other recursive functions.
"""
mutable struct HTMLContext
    doc::Documenter.Document
    settings::Union{HTML, Nothing}
    scripts::Vector{String}
    documenter_js::String
    themeswap_js::String
    warner_js::String
    search_index::Vector{SearchRecord}
    search_index_js::String
    search_navnode::Documenter.NavNode
    atexample_warnings::Vector{AtExampleFallbackWarning}

    HTMLContext(doc, settings = nothing) = new(
        doc, settings, [], "", "", "", [], "",
        Documenter.NavNode("search", "Search", nothing),
        AtExampleFallbackWarning[],
    )
end

struct DCtx
    # ctx and navnode were recursively passed to all domify() methods
    ctx::HTMLContext
    navnode::Documenter.NavNode
    # The following fields were keyword arguments to mdconvert()
    droplinks::Bool
    footnotes::Union{Vector{Node{Nothing}}, Nothing}

    DCtx(ctx, navnode, droplinks = false) = new(ctx, navnode, droplinks, [])
    DCtx(
        dctx::DCtx;
        navnode = dctx.navnode,
        droplinks = dctx.droplinks,
        footnotes = dctx.footnotes,
    ) = new(dctx.ctx, navnode, droplinks, footnotes)
end

function Documenter.locrepr(dctx::DCtx, lines = nothing)
    doc = dctx.ctx.doc
    src = dctx.navnode.page
    page = doc.blueprint.pages[src]
    return Documenter.locrepr(doc, page, lines)
end

function SearchRecord(ctx::HTMLContext, navnode; fragment = "", title = nothing, category = "page", text = "")
    page_title = mdflatten_pagetitle(DCtx(ctx, navnode))
    if title === nothing
        title = page_title
    end
    return SearchRecord(
        pretty_url(ctx, get_url(ctx, navnode.page)),
        getpage(ctx, navnode),
        fragment,
        lowercase(category),
        title,
        page_title,
        text
    )
end


function SearchRecord(ctx, navnode, node::Node, ::MarkdownAST.AbstractElement)
    return SearchRecord(ctx, navnode; text = mdflatten(node))
end

# Returns nothing for nodes that shouldn't be indexed in search
const _SEARCHRECORD_IGNORED_BLOCK_TYPES = Union{
    Documenter.MetaNode,
    Documenter.DocsNodesBlock,
    Documenter.SetupNode,
}

# Content segment for grouping content by sections
struct ContentSegment
    section_header::Union{Node, Nothing}
    content_nodes::Vector{Node}           # Content nodes belonging to this section
end

# Segment page content by sections for improved search indexing
function segment_page_by_sections(page_mdast::Node)
    segments = ContentSegment[]
    current = ContentSegment(nothing, Node[])

    for node in page_mdast.children
        if node.element isa Documenter.AnchoredHeader
            # Save previous segment if it has content or a header
            if !isempty(current.content_nodes) || current.section_header !== nothing
                push!(segments, current)
            end
            # Start new section
            current = ContentSegment(node, Node[])
        else
            # Skip nodes that shouldn't be indexed
            if !(node.element isa _SEARCHRECORD_IGNORED_BLOCK_TYPES)
                push!(current.content_nodes, node)
            end
        end
    end

    # Add final segment
    if !isempty(current.content_nodes) || current.section_header !== nothing
        push!(segments, current)
    end

    return segments
end

# Create search record for a content segment
function searchrecord(ctx::HTMLContext, navnode::Documenter.NavNode, segment::ContentSegment)
    text = join([mdflatten(node) for node in segment.content_nodes], "\n\n")

    if segment.section_header === nothing
        title = nothing
        fragment = ""
    else
        a = segment.section_header.element.anchor
        title = mdflatten(segment.section_header)
        fragment = Documenter.anchor_fragment(a)
    end

    return SearchRecord(
        ctx, navnode;
        fragment,
        title,
        category = "section",
        text
    )
end

function JSON.lower(rec::SearchRecord)
    # Replace any backslashes in links, if building the docs on Windows
    src = replace(rec.src, '\\' => '/')
    ref = string(src, rec.fragment)
    return Dict{String, String}(
        "location" => ref,
        "page" => rec.page_title,
        "title" => rec.title,
        "category" => rec.category,
        "text" => rec.text
    )
end

"""
Returns a page (as a [`Documenter.Page`](@ref) object) using the [`HTMLContext`](@ref).
"""
getpage(ctx::HTMLContext, path) = ctx.doc.blueprint.pages[path]
getpage(ctx::HTMLContext, navnode::Documenter.NavNode) = getpage(ctx, navnode.page)

function render(doc::Documenter.Document, settings::HTML = HTML())
    @info "HTMLWriter: rendering HTML pages."
    !isempty(doc.user.sitename) || error("HTML output requires `sitename`.")
    if isempty(doc.blueprint.pages)
        error("Aborting HTML build: no pages under src/")
    elseif !haskey(doc.blueprint.pages, "index.md")
        @warn "Can't generate landing page (index.html): src/index.md missing" keys(doc.blueprint.pages)
    end

    if isa(settings.repolink, Default) && (isnothing(doc.user.remote) || Remotes.repourl(doc.user.remote) === nothing)
        @warn """
        Unable to determine the repository root URL for the navbar link.
        This can happen when a string is passed to the `repo` keyword of `makedocs`.

        To remove this warning, either pass a Remotes.Remote object to `repo` to completely
        specify the remote repository, or explicitly set the remote URL by setting `repolink`
        via `makedocs(format = HTML(repolink = "..."), ...)`.
        """
    end

    ctx = HTMLContext(doc, settings)
    ctx.search_index_js = "search_index.js"
    ctx.themeswap_js = copy_asset("themeswap.js", doc)
    ctx.warner_js = copy_asset("warner.js", doc)

    # Generate documenter.js file with all the JS dependencies
    ctx.documenter_js = "assets/documenter.js"
    if isfile(joinpath(doc.user.source, "assets", "documenter.js"))
        @warn "not creating 'documenter.js', provided by the user."
    else
        r = JSDependencies.RequireJS(
            [RD.jquery, RD.jqueryui, RD.headroom, RD.headroom_jquery]
        )
        RD.mathengine!(r, settings.mathengine)
        if !settings.prerender
            RD.highlightjs!(r, settings.highlights)
        end
        for filename in readdir(joinpath(ASSETS, "js"))
            path = joinpath(ASSETS, "js", filename)
            endswith(filename, ".js") && isfile(path) || continue

            content = read(path, String)
            if filename == "search.js"
                if isfile(joinpath(doc.user.source, "assets", "search.js"))
                    @warn "not embedding 'search.js', provided by the user."
                    continue
                end
                content = replace(content, "__MINISEARCH_VERSION__" => MINISEARCH_VERSION)
            end

            push!(r, JSDependencies.parse_snippet(IOBuffer(content)))
        end
        JSDependencies.verify(r; verbose = true) || error("RequireJS declaration is invalid")
        JSDependencies.writejs(joinpath(doc.user.build, "assets", "documenter.js"), r)
    end

    for theme in THEMES
        copy_asset("themes/$(theme).css", doc)
    end

    size_limit_successes = map(collect(keys(doc.blueprint.pages))) do page
        idx = findfirst(nn -> nn.page == page, doc.internal.navlist)
        nn = (idx === nothing) ? Documenter.NavNode(page, nothing, nothing) : doc.internal.navlist[idx]
        @debug "Rendering $(page) [$(repr(idx))]"
        render_page(ctx, nn)
    end
    # ctx::HTMLContext might have accumulated some warnings about large at-example blocks
    # If so, we'll report them here in one big warning (rather than one each).
    if !isempty(ctx.atexample_warnings)
        msg = """
        For $(length(ctx.atexample_warnings)) @example blocks, the 'text/html' representation of the resulting
        object is above the threshold (example_size_threshold: $(ctx.settings.example_size_threshold) bytes).
        """
        fallbacks = unique(w.fallback for w in ctx.atexample_warnings)
        # We'll impose some regular order, but importantly we want 'nothing'-s on the top
        for fallback in sort(fallbacks, by = s -> isnothing(s) ? "" : s)
            warnings = filter(w -> w.fallback == fallback, ctx.atexample_warnings)
            n_warnings = length(warnings)
            largest_size = maximum(w -> w.size_bytes, warnings)
            msg *= if isnothing(fallback)
                """
                - $(n_warnings) blocks had no image MIME show() method representation as an alternative.
                  Sticking to the 'text/html' representation (largest block is $(largest_size) bytes).
                """
            else
                """
                - $(n_warnings) blocks had '$(fallback)' fallback image representation available, using that.
                """
            end
            pages = sort(unique(w.page for w in warnings))
            msg *= "  On pages: $(join(pages, ", "))\n"
        end
        @warn(msg)
    end
    # Check that all HTML files are smaller or equal to size_threshold option
    all(size_limit_successes) || throw(HTMLSizeThresholdError())

    # Check the size of the search index
    search_index_path = joinpath(doc.user.build, ctx.search_index_js)
    open(search_index_path, "w") do io
        println(io, "var documenterSearchIndex = {\"docs\":")
        # convert Vector{SearchRecord} to a JSON string + do additional JS escaping
        println(io, JSDependencies.json_jsescape(ctx.search_index), "\n}")
    end
    let file_size = filesize(search_index_path)
        if file_size > settings.search_size_threshold_warn
            file_size_format_results = format_units(file_size)
            size_threshold_warn_format_results = format_units(settings.search_size_threshold_warn)
            @warn """
            Generated search index over size_threshold_warn limit:
                Generated file size: $(file_size_format_results)
                search_size_threshold_warn: $(size_threshold_warn_format_results)
                Search index file:   $(search_index_path)
            """
        end
    end

    write_inventory(doc, ctx)

    return generate_siteinfo_json(doc.user.build)
end

struct HTMLSizeThresholdError <: Exception end
function Base.showerror(io::IO, ::HTMLSizeThresholdError)
    return print(
        io, """
        HTMLSizeThresholdError: Some generated HTML files are above size_threshold.
        See logged errors for details."""
    )
end

"""
Copies an asset from Documenters `assets/html/` directory to `doc.user.build`.
Returns the path of the copied asset relative to `.build`.
"""
function copy_asset(file, doc)
    src = joinpath(Documenter.assetsdir(), "html", file)
    alt_src = joinpath(doc.user.source, "assets", file)
    dst = joinpath(doc.user.build, "assets", file)
    isfile(src) || error("Asset '$file' not found at $(abspath(src))")

    # Since user's alternative assets are already copied over in a previous build
    # step and they should override Documenter's original assets, we only actually
    # perform the copy if <source>/assets/<file> does not exist. Note that checking
    # the existence of <build>/assets/<file> is not sufficient since the <build>
    # directory might be dirty from a previous build.
    if isfile(alt_src)
        @warn "not copying '$src', provided by the user."
    else
        ispath(dirname(dst)) || mkpath(dirname(dst))
        ispath(dst) && @warn "overwriting '$dst'."
        # Files in the Documenter folder itself are read-only when
        # Documenter is Pkg.added so we create a new file to get
        # correct file permissions.
        open(io -> write(dst, io), src, "r")
    end
    assetpath = normpath(joinpath("assets", file))
    # Replace any backslashes in links, if building the docs on Windows
    return replace(assetpath, '\\' => '/')
end

# Page
# ------------------------------------------------------------------------------

## Standard page
"""
Constructs and writes the page referred to by the `navnode` to `.build`.
"""
function render_page(ctx, navnode)
    head = render_head(ctx, navnode)
    sidebar = render_sidebar(ctx, navnode)
    navbar = render_navbar(ctx, navnode, true)
    article = render_article(ctx, navnode)
    footer = render_footer(ctx, navnode)
    extras = render_extras(ctx, navnode)
    htmldoc = render_html(ctx, head, sidebar, navbar, article, footer, extras)
    return write_html(ctx, navnode, htmldoc)
end

## Rendering HTML elements
# ------------------------------------------------------------------------------

"""
Renders the main `<html>` tag.
"""
function render_html(ctx, head, sidebar, navbar, article, footer, extras)
    @tags html body div
    return DOM.HTMLDocument(
        html[:lang => ctx.settings.lang](
            head,
            body(
                div["#documenter"](
                    sidebar,
                    div[".docs-main"](navbar, article, footer),
                    render_settings(),
                ),
            ),
            extras...
        )
    )
end

"""
Renders the modal settings dialog.
"""
function render_settings()
    @tags div header section footer p button hr span select option label a

    theme_selector = p(
        label[".label"]("Theme"),
        div[".select"](
            select["#documenter-themepicker"](
                option[:value => "auto"]("Automatic (OS)"),
                (option[:value => theme](theme) for theme in THEMES)...,
            )
        )
    )

    now_full = Dates.format(Dates.now(), Dates.dateformat"E d U Y HH:MM")
    now_short = Dates.format(Dates.now(), Dates.dateformat"E d U Y")
    buildinfo = p(
        "This document was generated with ",
        a[:href => "https://github.com/JuliaDocs/Documenter.jl"]("Documenter.jl"),
        " version $(Documenter.DOCUMENTER_VERSION)",
        " on ",
        span[".colophon-date", :title => now_full](now_short),
        ". ",
        "Using Julia version $(Base.VERSION)."
    )

    return div["#documenter-settings.modal"](
        div[".modal-background"],
        div[".modal-card"](
            header[".modal-card-head"](
                p[".modal-card-title"]("Settings"),
                button[".delete"]()
            ),
            section[".modal-card-body"](
                theme_selector, hr(), buildinfo
            ),
            footer[".modal-card-foot"]()
        )
    )
end

function render_head(ctx, navnode)
    @tags head meta link script title
    src = get_url(ctx, navnode)

    page_title = "$(mdflatten_pagetitle(DCtx(ctx, navnode))) · $(ctx.doc.user.sitename)"

    description = if navnode !== ctx.search_navnode
        get(getpage(ctx, navnode).globals.meta, :Description) do
            default_site_description(ctx)
        end
    else
        default_site_description(ctx)
    end

    css_links = [
        RD.lato,
        RD.juliamono,
        RD.fontawesome_css...,
        RD.katex_css,
    ]

    return head(
        meta[:charset => "UTF-8"],
        meta[:name => "viewport", :content => "width=device-width, initial-scale=1.0"],

        # Title tag and meta tags
        title(page_title),
        meta[:name => "title", :content => page_title],
        meta[:property => "og:title", :content => page_title],
        meta[:property => "twitter:title", :content => page_title],

        # Description meta tags
        meta[:name => "description", :content => description],
        meta[:property => "og:description", :content => description],
        meta[:property => "twitter:description", :content => description],

        # Canonical URL tags
        canonical_url_tags(ctx, navnode),

        # Preview image meta tags
        preview_image_meta_tags(ctx),

        # Analytics and warning scripts
        analytics_script(ctx.settings.analytics),
        warning_script(src, ctx),

        # Stylesheets.
        map(css_links) do each
            link[:href => each, :rel => "stylesheet", :type => "text/css"]
        end,

        script("documenterBaseURL=\"$(relhref(src, "."))\""),
        script[
            :src => RD.requirejs_cdn,
            Symbol("data-main") => relhref(src, ctx.documenter_js),
        ],
        script[:src => relhref(src, ctx.search_index_js)],

        script[:src => relhref(src, "siteinfo.js")],
        script[:src => relhref(src, "../versions.js")],
        # Themes. Note: we reverse the list to make sure that the default theme (first in
        # the array) comes as the last <link> tag.
        map(Iterators.reverse(enumerate(THEMES))) do (i, theme)
            e = link[
                ".docs-theme-link",
                :rel => "stylesheet", :type => "text/css",
                :href => relhref(src, "assets/themes/$(theme).css"),
                Symbol("data-theme-name") => theme,
            ]
            (i == 1) && push!(e.attributes, Symbol("data-theme-primary") => "")
            (i == 2) && push!(e.attributes, Symbol("data-theme-primary-dark") => "")
            return e
        end,
        script[:src => relhref(src, ctx.themeswap_js)],
        # Custom user-provided assets.
        asset_links(src, ctx.settings.assets),
    )
end

function canonical_url_tags(ctx, navnode)
    @tags meta link
    canonical = canonical_url(ctx, navnode)
    if isnothing(canonical)
        return DOM.VOID
    else
        tags = DOM.Node[
            meta[:property => "og:url", :content => canonical],
            meta[:property => "twitter:url", :content => canonical],
            link[:rel => "canonical", :href => canonical],
        ]
        return tags
    end
end

function preview_image_meta_tags(ctx)
    @tags meta
    canonical_link = ctx.settings.canonical
    preview = find_preview_image(ctx)
    if canonical_link === nothing || preview === nothing
        # Cannot construct absolute link if canonical URL is not set
        return DOM.VOID
    else
        # Return OpenGraph and Twitter image meta tags.
        preview = replace(preview, r"[/\\]+" => "/")
        preview_url = rstrip(canonical_link, '/') * "/" * preview
        tags = DOM.Node[
            meta[:property => "og:image", :content => preview_url],
            meta[:property => "twitter:image", :content => preview_url],
            meta[:property => "twitter:card", :content => "summary_large_image"],
        ]
        return tags
    end
end

function default_site_description(ctx)
    if isnothing(ctx.settings.description)
        return "Documentation for $(ctx.doc.user.sitename)."
    else
        return ctx.settings.description
    end
end

function find_preview_image(ctx)
    for ext in ["png", "webp", "gif", "jpg", "jpeg"]
        filename = joinpath("assets", "preview.$(ext)")
        isfile(joinpath(ctx.doc.user.build, filename)) && return filename
    end
    return nothing
end

function asset_links(src::AbstractString, assets::Vector{<:HTMLHeadContent})
    isabspath(src) && @error("Absolute path '$src' passed to asset_links")
    @tags link script
    links = DOM.Node[]
    for asset in assets
        if isa(asset, RawHTMLHeadContent)
            push!(links, DOM.Tag(Symbol("#RAW#"))(asset.content))
            continue
        end
        class = asset.class
        url = asset.islocal ? relhref(src, asset.uri) : asset.uri
        node =
            class == :ico ? link[:href => url, :rel => "icon", :type => "image/x-icon", pairs(asset.attributes)...] :
            class == :css ? link[:href => url, :rel => "stylesheet", :type => "text/css", pairs(asset.attributes)...] :
            class == :js ? script[:src => url, pairs(asset.attributes)...] : continue # Skip non-js/css files.
        push!(links, node)
    end
    return links
end

function analytics_script(tracking_id::AbstractString)
    @tags script
    if isempty(tracking_id)
        return DOM.VOID
    else
        return [
            script[:async, :src => "https://www.googletagmanager.com/gtag/js?id=$(tracking_id)"](),
            script(
                """
                  window.dataLayer = window.dataLayer || [];
                  function gtag(){dataLayer.push(arguments);}
                  gtag('js', new Date());
                  gtag('config', '$(tracking_id)', {'page_path': location.pathname + location.search + location.hash});
                """
            ),
        ]
    end
end

function warning_script(src, ctx)
    if ctx.settings.warn_outdated
        return DOM.Tag(:script)[Symbol(OUTDATED_VERSION_ATTR), :src => relhref(src, ctx.warner_js)]()
    end
    return DOM.VOID
end

# Navigation menu
# ------------------------------------------------------------------------------

struct NavMenuContext
    htmlctx::HTMLContext
    current::Documenter.NavNode
    idstack::Vector{Int}
end
NavMenuContext(ctx::HTMLContext, current::Documenter.NavNode) = NavMenuContext(ctx, current, [])

function render_sidebar(ctx, navnode)
    @tags a img nav div button select option span
    src = get_url(ctx, navnode)
    navmenu = nav[".docs-sidebar"]

    # The logo and sitename will point to the first page in the navigation menu
    href = navhref(ctx, first(ctx.doc.internal.navlist), navnode)

    # Logo
    logo = find_image_asset(ctx, "logo")
    logo_dark = find_image_asset(ctx, "logo-dark")
    if logo !== nothing
        alt = isempty(ctx.doc.user.sitename) ? "Logo" : "$(ctx.doc.user.sitename) logo"
        logo_element = a[".docs-logo", :href => href]
        if logo_dark === nothing
            push!(logo_element.nodes, img[:src => relhref(src, logo), :alt => alt])
        else
            push!(logo_element.nodes, img[".docs-light-only", :src => relhref(src, logo), :alt => alt])
            push!(logo_element.nodes, img[".docs-dark-only", :src => relhref(src, logo_dark), :alt => alt])
        end
        push!(navmenu.nodes, logo_element)
    end
    # Sitename
    if ctx.settings.sidebar_sitename
        push!(
            navmenu.nodes, div[".docs-package-name"](
                span[".docs-autofit"](a[:href => href](ctx.doc.user.sitename))
            )
        )
    end

    # Search box
    push!(
        navmenu.nodes,
        button["#documenter-search-query.docs-search-query.input.is-rounded.is-small.is-clickable.my-2.mx-auto.py-1.px-2"]("Search docs (Ctrl + /)")
    )

    # The menu itself
    menu = navitem(NavMenuContext(ctx, navnode))
    push!(menu.attributes, :class => "docs-menu")
    push!(navmenu.nodes, menu)

    # Version selector
    let
        vs_class = ".docs-version-selector.field.has-addons"
        vs_label = span[".docs-label.button.is-static.is-size-7"]("Version")
        vs_label = div[".control"](vs_label)
        vs_select = select["#documenter-version-selector"]
        if !isempty(ctx.doc.user.version)
            vs_class = "$(vs_class).visible"
            opt = option[:value => "#", :selected => "selected"](ctx.doc.user.version)
            vs_select = vs_select(opt)
        end
        vs_select = div[".select.is-fullwidth.is-size-7"](vs_select)
        vs_select = div[".docs-selector.control.is-expanded"](vs_select)
        push!(navmenu.nodes, div[vs_class](vs_label, vs_select))
    end
    return navmenu
end

function find_image_asset(ctx, name)
    for ext in ["svg", "png", "webp", "gif", "jpg", "jpeg"]
        filename = joinpath("assets", "$(name).$(ext)")
        isfile(joinpath(ctx.doc.user.build, filename)) && return filename
    end
    return nothing
end

"""
[`navitem`](@ref) returns the lists and list items of the navigation menu.
It gets called recursively to construct the whole tree.

It always returns a [`DOM.Node`](@ref). If there's nothing to display (e.g. the node is set
to be invisible), it returns an empty text node (`DOM.Node("")`).
"""
navitem(nctx) = navitem(nctx, nctx.htmlctx.doc.internal.navtree)
function navitem(nctx, nns::Vector)
    push!(nctx.idstack, 0)
    nodes = map(nns) do nn
        nctx.idstack[end] = nctx.idstack[end] + 1
        navitem(nctx, nn)
    end
    pop!(nctx.idstack)
    filter!(node -> node.name !== DOM.TEXT, nodes) # FIXME: why?
    ulclass = (length(nctx.idstack) >= nctx.htmlctx.settings.collapselevel) ? ".collapsed" : ""
    return isempty(nodes) ? DOM.Node("") : DOM.Tag(:ul)[ulclass](nodes)
end
function navitem(nctx, nn::Documenter.NavNode)
    @tags ul li span a input label i
    ctx, current = nctx.htmlctx, nctx.current
    dctx = DCtx(nctx.htmlctx, nn, true)
    # We'll do the children first, primarily to determine if this node has any that are
    # visible. If it does not and it itself is not visible (including current), then
    # we'll hide this one as well, returning an empty string Node.
    children = navitem(nctx, nn.children)
    if nn !== current && !nn.visible && children.name === DOM.TEXT
        return DOM.Node("")
    end

    # construct this item
    title = domify(dctx, pagetitle(dctx))
    currentclass = (nn === current) ? ".is-active" : ""
    item = if length(nctx.idstack) >= ctx.settings.collapselevel && children.name !== DOM.TEXT
        menuid = "menuitem-$(join(nctx.idstack, '-'))"
        input_attr = ["#$(menuid).collapse-toggle", :type => "checkbox"]
        nn in Documenter.navpath(nctx.current) && push!(input_attr, :checked)
        li[currentclass](
            input[input_attr...],
            label[".tocitem", :for => menuid](span[".docs-label"](title), i[".docs-chevron"]),
        )
    elseif nn.page === nothing
        li[currentclass](span[".tocitem"](title))
    else
        li[currentclass](a[".tocitem", :href => navhref(ctx, nn, current)](title))
    end

    # add the subsections (2nd level headings) from the page
    if (nn === current) && current.page !== nothing
        subs = collect_subsections(getpage(ctx, current.page).mdast)
        internal_links = map(subs) do s
            istoplevel, anchor, text = s
            _li = istoplevel ? li[".toplevel"] : li[]
            _li(a[".tocitem", :href => anchor](span(domify(dctx, text.children))))
        end
        # Only create the ul.internal tag if there actually are in-page headers
        length(internal_links) > 0 && push!(item.nodes, ul[".internal"](internal_links))
    end

    # add the visible subsections, if any, as a single list
    (children.name === DOM.TEXT) || push!(item.nodes, children)

    return item
end

function render_navbar(ctx, navnode, edit_page_link::Bool)
    @tags div header nav ul li a span

    # Hamburger on mobile
    navbar_left = a[
        "#documenter-sidebar-button.docs-sidebar-button.docs-navbar-link.fa-solid.fa-bars.is-hidden-desktop",
        :href => "#",
    ]

    # The breadcrumb (navigation links on top)
    navpath = Documenter.navpath(navnode)
    header_links = map(navpath) do nn
        dctx = DCtx(ctx, nn, true)
        title = domify(dctx, pagetitle(dctx))
        nn.page === nothing ? li(a[".is-disabled"](title)) : li(a[:href => navhref(ctx, nn, navnode)](title))
    end
    header_links[end] = header_links[end][".is-active"]
    breadcrumb = nav[".breadcrumb"](
        ul[".is-hidden-mobile"](header_links),
        ul[".is-hidden-tablet"](header_links[end]) # when on mobile, we only show the page title, basically
    )

    # The "Edit on GitHub" links and the hamburger to open the sidebar (on mobile) float right
    navbar_right = div[".docs-right"]

    # Set up the link to the root of the remote Git repository
    #
    # By default, we try to determine it from the configured remote. If that fails, the link
    # is not displayed. The user can also pass `repolink` to HTML to either disable it
    # (repolink = nothing) or override the link URL (if set to a string). In the latter case,
    # we try to figure out what icon and string we should use based on the URL.
    if !isnothing(ctx.settings.repolink) && (ctx.settings.repolink isa String || ctx.doc.user.remote isa Remotes.Remote)
        url, (host, logo) = if ctx.settings.repolink isa String
            ctx.settings.repolink, host_logo(ctx.settings.repolink)
        else # ctx.doc.user.remote isa Remotes.Remote
            Remotes.repourl(ctx.doc.user.remote), host_logo(ctx.doc.user.remote)
        end
        # repourl() can sometimes return a nothing (Remotes.URL)
        if !isnothing(url)
            repo_title = "View the repository" * (isempty(host) ? "" : " on $host")
            push!(
                navbar_right.nodes,
                a[".docs-navbar-link", :href => url, :title => repo_title](
                    span[".docs-icon.fa-brands"](logo),
                    span[".docs-label.is-hidden-touch"](isempty(host) ? "Repository" : host)
                )
            )
        end
    end
    # Add an edit link, with just an icon, but only on pages where edit_page_link is true.
    # Some pages, like search, are special and do not have a source file to link to.
    edit_page_link && edit_link(ctx, navnode) do logo, title, url
        push!(
            navbar_right.nodes,
            a[".docs-navbar-link", :href => url, :title => title](
                span[".docs-icon.fa-solid"](logo)
            )
        )
    end

    # Settings cog
    push!(
        navbar_right.nodes,
        a[
            "#documenter-settings-button.docs-settings-button.docs-navbar-link.fa-solid.fa-gear",
            :href => "#", :title => "Settings",
        ]
    )

    # Collapse/Expand All articles toggle
    push!(
        navbar_right.nodes,
        a[
            "#documenter-article-toggle-button.docs-article-toggle-button.fa-solid.fa-chevron-up",
            :href => "javascript:;", :title => "Collapse all docstrings",
        ]
    )

    # Construct the main <header> node that should be the first element in div.docs-main
    return header[".docs-navbar"](navbar_left, breadcrumb, navbar_right)
end

"""
Calls `f(logo, title, url)` if it is possible to create an edit link for the `navnode`.
"""
function edit_link(f, ctx, navnode)
    view_logo, edit_logo = "\uf15c", "\uf044" # 'fa-file-lines' and 'fa-pen-to-square', from .fa-solid class
    # Let's fetch the edit path. Usually this is the source file of the page, but the user
    # can override it specifying the EditURL option in an @meta block. Usually, it is a
    # relative path pointing to a file, but can also be set to an absolute URL.
    editpath = get(getpage(ctx, navnode).globals.meta, :EditURL, getpage(ctx, navnode).source)
    # If the user has set :EditURL to nothing, then the link will be disabled. Note: the
    # .source field of a Page is always a String.
    isnothing(editpath) && return
    # If the user has set an absolute :EditURL, then we just use that URL without
    # modifications. The only thing we want to do is to determine the Git remote host name
    # from the URL, if we can. We also use the "view" verb and logo here, since we do not
    # know if the remote link allows editing, and so it is the safer option.
    if Documenter.isabsurl(editpath)
        host, _ = host_logo(editpath)
        title = "View source" * (isempty(host) ? "" : " on $(host)")
        f(view_logo, title, editpath)
        return
    end
    # If the user has disable Git, then we can not determine edit links
    ctx.settings.disable_git && return
    # If the user has passed HTML(edit_link = nothing), then all edit links (with relative
    # paths) are disabled.
    isnothing(ctx.settings.edit_link) && return
    # edit_url will call abspath() on the path, but our working directory is set to
    # makedocs' root argument. The Page .source paths are already relative to that, but
    # user-provided EditURLs are assumed to be relative to the current page. So we need to
    # update the path accordingly.
    if editpath != getpage(ctx, navnode).source
        editpath = joinpath(dirname(getpage(ctx, navnode).source), editpath)
    end
    # If the user has set `ctx.settings.edit_link = :commit` (only non-String value), then
    # we set pass commit=nothing and let edit_url figure out the commit ref with Git.
    # We also render a "view" link, instead of the usual "edit" link, since it is usually
    # not possible to directly modify the repository files if they refer to a particular
    # commit.
    verb, logo, commit = if ctx.settings.edit_link === :commit
        "View", view_logo, nothing
    else
        "Edit", edit_logo, ctx.settings.edit_link
    end
    host, _ = host_logo(ctx.doc.user.remote)
    editurl = Documenter.edit_url(ctx.doc, editpath, rev = commit)
    # It is possible for editurl() to return a nothing, if something goes wrong
    isnothing(editurl) && return
    # Create the edit link
    f(logo, "$verb source" * (isempty(host) ? "" : " on $(host)"), editurl)
    return
end

# All these logos are from the .fa-brands (brands) class
const host_logo_github = (host = "GitHub", logo = "\uf09b") # fa-github
const host_logo_bitbucket = (host = "BitBucket", logo = "\uf171") # fa-bitbucket
const host_logo_gitlab = (host = "GitLab", logo = "\uf296") # fa-gitlab
const host_logo_azure = (host = "Azure DevOps", logo = "\uf3ca") # fa-microsoft; TODO: change to ADO logo when added to FontAwesome
const host_logo_fallback = (host = "", logo = "\uf841") # fa-git-alt
host_logo(remote::Remotes.GitHub) = host_logo_github
host_logo(remote::Remotes.URL) = host_logo(remote.urltemplate)
host_logo(remote::Union{Remotes.Remote, Nothing}) = host_logo_fallback
function host_logo(remoteurl::String)
    return occursin("github", remoteurl) ? host_logo_github :
        occursin("gitlab", remoteurl) ? host_logo_gitlab :
        occursin("bitbucket", remoteurl) ? host_logo_bitbucket :
        occursin("azure", remoteurl) ? host_logo_azure :
        host_logo_fallback
end

function render_footer(ctx, navnode)
    @tags a div nav
    # Navigation links (previous/next page), if there are any
    navlinks = DOM.Node[]
    if navnode.prev !== nothing
        dctx = DCtx(ctx, navnode.prev, true)
        title = domify(dctx, pagetitle(dctx))
        link = a[".docs-footer-prevpage", :href => navhref(ctx, navnode.prev, navnode)]("« ", title)
        push!(navlinks, link)
    end
    if navnode.next !== nothing
        dctx = DCtx(ctx, navnode.next, true)
        title = domify(dctx, pagetitle(dctx))
        link = a[".docs-footer-nextpage", :href => navhref(ctx, navnode.next, navnode)](title, " »")
        push!(navlinks, link)
    end

    linebreak = div[".flexbox-break"]()
    footer_content = ctx.settings.footer

    nav_children = []
    if !isempty(navlinks)
        push!(nav_children, navlinks, linebreak)
    end

    if footer_content !== nothing
        footer_container = domify(DCtx(ctx, navnode), ctx.settings.footer)
        push!(first(footer_container).attributes, :class => "footer-message")
        push!(nav_children, footer_container)
    end

    return nav[".docs-footer"](nav_children...)
end

function render_extras(ctx, navnode)
    @tags div
    meta_divs = DOM.Node[]
    if get(getpage(ctx, navnode).globals.meta, :CollapsedDocStrings, false)
        # if DocStringsCollapse = true in `@meta`, we let JavaScript click the
        # collapse button after that page has loaded.
        push!(meta_divs, div[Symbol("data-docstringscollapsed") => "true"]())
    end
    return meta_divs
end

# Article (page contents)
# ------------------------------------------------------------------------------

function render_article(ctx, navnode)
    dctx = DCtx(ctx, navnode)
    @tags article section ul li a p

    # Build the page itself (and collect any footnotes)
    empty!(dctx.footnotes)
    art_body = article["#documenter-page.content"](domify(dctx))
    # Footnotes, if there are any
    if !isempty(dctx.footnotes)
        fnotes = map(dctx.footnotes) do f
            # If there are any nested footnotes, they'll get ignored.
            dctx_footnote = DCtx(dctx, footnotes = nothing)
            fid = "footnote-$(f.element.id)"
            citerefid = "citeref-$(f.element.id)"
            if length(f.children) == 1 && first(f.children).element isa MarkdownAST.Paragraph
                li["#$(fid).footnote"](
                    a[".tag.is-link", :href => "#$(citerefid)"](f.element.id),
                    domify(dctx_footnote, first(f.children).children),
                )
            else
                li["#$(fid).footnote"](
                    a[".tag.is-link", :href => "#$(citerefid)"](f.element.id),
                    # passing an empty MD() as `parent` to give it block context
                    domify(dctx_footnote, f.children),
                )
            end
        end
        push!(art_body.nodes, section[".footnotes.is-size-7"](ul(fnotes)))
    end
    return art_body
end

# expand the versions argument from the user
# and return entries and needed symlinks
function expand_versions(dir, versions)
    # output: entries and symlinks
    entries = String[]
    symlinks = Pair{String, String}[]

    # read folders and filter out symlinks
    available_folders = readdir(dir)
    cd(() -> filter!(!islink, available_folders), dir)

    # filter and sort release folders
    vnum(x) = VersionNumber(x)
    version_folders = [x for x in available_folders if occursin(Base.VERSION_REGEX, x)]
    sort!(version_folders, lt = (x, y) -> vnum(x) < vnum(y), rev = true)
    release_folders = filter(x -> (v = vnum(x); v.prerelease == () && v.build == ()), version_folders)
    # pre_release_folders = filter(x -> (v = vnum(x); v.prerelease != () || v.build != ()), version_folders)
    major_folders = filter!(
        x -> (v = vnum(x); v.major != 0),
        unique(x -> (v = vnum(x); v.major), release_folders)
    )
    minor_folders = filter!(
        x -> (v = vnum(x); !(v.major == 0 && v.minor == 0)),
        unique(x -> (v = vnum(x); (v.major, v.minor)), release_folders)
    )
    patch_folders = unique(x -> (v = vnum(x); (v.major, v.minor, v.patch)), release_folders)

    filter!(x -> vnum(x) !== 0, major_folders)

    # populate output
    for entry in versions
        if entry == "v#" # one doc per major release
            for x in major_folders
                vstr = "v$(vnum(x).major).$(vnum(x).minor)"
                push!(entries, vstr)
                push!(symlinks, vstr => x)
            end
        elseif entry == "v#.#" # one doc per minor release
            for x in minor_folders
                vstr = "v$(vnum(x).major).$(vnum(x).minor)"
                push!(entries, vstr)
                push!(symlinks, vstr => x)
            end
        elseif entry == "v#.#.#" # one doc per patch release
            for x in patch_folders
                vstr = "v$(vnum(x).major).$(vnum(x).minor).$(vnum(x).patch)"
                push!(entries, vstr)
                push!(symlinks, vstr => x)
            end
        elseif entry == "v^" || (entry isa Pair && entry.second == "v^")
            if !isempty(release_folders)
                x = first(release_folders)
                vstr = isa(entry, Pair) ? entry.first : "v$(vnum(x).major).$(vnum(x).minor)"
                push!(entries, vstr)
                push!(symlinks, vstr => x)
            end
        elseif entry isa Pair
            k, v = entry
            i = findfirst(==(v), available_folders)
            if i === nothing
                @warn "no match for `versions` entry `$(repr(entry))`"
            else
                push!(entries, k)
                push!(symlinks, k => v)
            end
        else
            @warn "no match for `versions` entry `$(repr(entry))`"
        end
    end
    unique!(entries) # remove any duplicates

    # generate remaining symlinks
    foreach(x -> push!(symlinks, "v$(vnum(x).major)" => x), major_folders)
    foreach(x -> push!(symlinks, "v$(vnum(x).major).$(vnum(x).minor)" => x), minor_folders)
    foreach(x -> push!(symlinks, "v$(vnum(x).major).$(vnum(x).minor).$(vnum(x).patch)" => x), patch_folders)
    filter!(x -> x.first != x.second, unique!(symlinks))

    # assert that none of the links point to another link
    for link in symlinks
        i = findfirst(x -> link.first == x.second, symlinks)
        if i !== nothing
            throw(ArgumentError("link `$(link)` incompatible with link `$(symlinks[i])`."))
        end
    end

    return entries, symlinks
end

# write version file
function generate_version_file(versionfile::AbstractString, entries, symlinks = [])
    open(versionfile, "w") do buf
        println(buf, "var DOC_VERSIONS = [")
        for folder in entries
            println(buf, "  \"", folder, "\",")
        end
        println(buf, "];")

        # entries is empty if no versions have been built at all
        isempty(entries) && return

        # The first element in entries corresponds to the latest version, but is usually not the full version
        # number. So this essentially follows the symlinks that will be generated to figure out the full
        # version number (stored in DOCUMENTER_CURRENT_VERSION in siteinfo.js).
        # Every symlink points to a directory, so this doesn't need to be recursive.
        newest = first(entries)
        for s in symlinks
            if s.first == newest
                newest = s.second
                break
            end
        end
        println(buf, "var DOCUMENTER_NEWEST = \"$(newest)\";")
        println(buf, "var DOCUMENTER_STABLE = \"$(first(entries))\";")
    end
    return
end

# write redirect file
function generate_redirect_file(redirectfile::AbstractString, entries)
    # The link to the redirected destination is same as outdated-warning. (DOCUMENTER_STABLE)

    comment = "<!--This file is automatically generated by Documenter.jl-->"

    isfile(redirectfile) && !startswith(read(redirectfile, String), comment) && return
    isempty(entries) && return

    open(redirectfile, "w") do buf
        println(buf, comment)
        println(buf, "<meta http-equiv=\"refresh\" content=\"0; url=./$(first(entries))/\"/>")
    end
    return
end

function generate_siteinfo_file(dir::AbstractString, version::Union{AbstractString, Nothing}, is_dev_version::Bool = false)
    open(joinpath(dir, "siteinfo.js"), "w") do buf
        if version !== nothing
            println(buf, "var DOCUMENTER_CURRENT_VERSION = \"$(version)\";")
            # Add the development version flag
            println(buf, "var DOCUMENTER_IS_DEV_VERSION = $(is_dev_version ? "true" : "false");")
        else
            println(buf, "var DOCUMENTER_VERSION_SELECTOR_DISABLED = true;")
        end
    end
    return
end

# The .documenter-siteinfo.json can contain various metadata (such as the Documenter version
# used to generate the docs) that automated tools (like DocumenterTools) can use to when
# performing e.g. post-processing after the fact on the generated docs.
#
# The file should be assumed to contain a JSON object that contains at least a 'documenter'
# field. The 'documenter' field is controlled by Documenter. Other tools are free to modify
# the file and add their own values, preferably in a namespace that is unlikely to cause
# a conflict.
#
# Note: siteinfo.js is generated by `deploydocs` and gets loaded in the HTML, whereas
# .documenter-siteinfo.json gets generated by makedocs and does not normally get loaded
# in the HTML
function generate_siteinfo_json(root::AbstractString)
    isdir(root) || error("generate_siteinfo_json: not a directory at $root")
    siteinfo = Dict(
        "documenter_version" => string(Documenter.DOCUMENTER_VERSION),
        "julia_version" => string(VERSION),
        "generation_timestamp" => Dates.format(Dates.now(), Dates.dateformat"yyyy-mm-dd\THH:MM:SS"),
    )
    open(joinpath(root, ".documenter-siteinfo.json"), "w") do io
        JSON.print(io, Dict("documenter" => siteinfo))
    end
    return
end

## domify(...)
# ------------

function domify(::DCtx, ::Node, element::MarkdownAST.AbstractElement)
    error("Unimplemented element: $(typeof(element))")
end

function domify(dctx::DCtx)
    ctx, navnode = dctx.ctx, dctx.navnode
    page_mdast = getpage(ctx, navnode).mdast

    # Generate search index using custom segmentation, with pages merged together
    segments = segment_page_by_sections(page_mdast)
    for segment in segments
        search_record = searchrecord(ctx, navnode, segment)
        push!(ctx.search_index, search_record)
    end

    # Generate HTML as before - process each child node individually
    return map(page_mdast.children) do node
        domify(dctx, node, node.element)
    end
end
domify(dctx::DCtx, node::Node) = domify(dctx, node, node.element)
function domify(dctx::DCtx, children)
    @assert eltype(children) <: Node
    return map(child -> domify(dctx, child), children)
end

domify(dctx::DCtx, node::Node, ::MarkdownAST.Document) = domify(dctx, node.children)

function domify(dctx::DCtx, node::Node, ah::Documenter.AnchoredHeader)
    @assert length(node.children) == 1 && isa(first(node.children).element, MarkdownAST.Heading)
    anchor = ah.anchor
    @tags a
    frag = Documenter.anchor_fragment(anchor)
    legacy = anchor.nth == 1 ? (a[:id => lstrip(frag, '#') * "-1"],) : ()
    h = first(node.children)
    return DOM.Tag(Symbol("h$(h.element.level)"))[:id => lstrip(frag, '#')](
        a[".docs-heading-anchor", :href => frag](domify(dctx, h.children)),
        legacy...,
        a[".docs-heading-anchor-permalink", :href => frag, :title => "Permalink"]
    )
end

struct ListBuilder
    es::Vector
end
ListBuilder() = ListBuilder([])

function Base.push!(lb::ListBuilder, level, node)
    @assert level >= 1
    if level == 1
        push!(lb.es, node)
    else
        if isempty(lb.es) || typeof(last(lb.es)) !== ListBuilder
            push!(lb.es, ListBuilder())
        end
        push!(last(lb.es), level - 1, node)
    end
    return
end

function domify(lb::ListBuilder)
    @tags ul li
    return ul(map(e -> isa(e, ListBuilder) ? li[".no-marker"](domify(e)) : li(e), lb.es))
end

function domify(dctx::DCtx, ::Node, contentsnode::Documenter.ContentsNode)
    ctx, navnode = dctx.ctx, dctx.navnode
    @tags a
    navnode_dir = dirname(navnode.page)
    navnode_url = get_url(ctx, navnode)
    lb = ListBuilder()
    for (count, path, anchor) in contentsnode.elements
        header = first(anchor.node.children)
        level = header.element.level
        # Skip header levels smaller than the requested mindepth
        level = level - contentsnode.mindepth + 1
        level < 1 && continue
        path = joinpath(navnode_dir, path) # links in ContentsNodes are relative to current page
        path = pretty_url(ctx, relhref(navnode_url, get_url(ctx, path)))
        url = string(path, Documenter.anchor_fragment(anchor))
        node = a[:href => url](domify(DCtx(dctx, droplinks = true), header.children))
        push!(lb, level, node)
    end
    return domify(lb)
end

function domify(dctx::DCtx, ::Node, indexnode::Documenter.IndexNode)
    ctx, navnode = dctx.ctx, dctx.navnode
    @tags a code li ul
    navnode_dir = dirname(navnode.page)
    navnode_url = get_url(ctx, navnode)
    lis = map(indexnode.elements) do el
        object, doc, path, mod, cat = el
        path = joinpath(navnode_dir, path) # links in IndexNodes are relative to current page
        path = pretty_url(ctx, relhref(navnode_url, get_url(ctx, path)))
        url = string(path, "#", Documenter.slugify(object))
        li(a[:href => url](code(Documenter.bindingstring(object.binding))))
    end
    return ul(lis)
end

domify(dctx::DCtx, node::Node, ::Documenter.DocsNodesBlock) = domify(dctx, node.children)

function domify(dctx::DCtx, mdast_node::Node, docsnode::Documenter.DocsNode)
    ctx, navnode = dctx.ctx, dctx.navnode
    @tags a code article header span summary details

    # push to search index
    rec = SearchRecord(
        ctx, navnode;
        fragment = Documenter.anchor_fragment(docsnode.anchor),
        title = Documenter.bindingstring(docsnode.object.binding),
        category = Documenter.doccat(docsnode.object),
        text = mdflatten(mdast_node)
    )
    push!(ctx.search_index, rec)

    docstring = article(
        details[".docstring"](
            summary[
                :id => docsnode.anchor.id,
            ](
                a[".docstring-binding", :href => "#$(docsnode.anchor.id)"](code(Documenter.bindingstring(docsnode.object.binding))),
                " — ", # &mdash;
                span[".docstring-category"]("$(Documenter.doccat(docsnode.object))")
            ),
            domify_doc(dctx, mdast_node)
        )
    )
    if !get(getpage(ctx, navnode).globals.meta, :CollapsedDocStrings, false)
        # If DocStringsCollapse = false in `@meta`, then set the `open`
        # attribute to expand the docstring blocks (We don't need to care about
        # the other case because detail blocks are collapsed by default)
        push!(docstring.nodes[1].attributes, :open => "true")
    end
    return docstring
end

function domify_doc(dctx::DCtx, node::Node)
    @assert node.element isa Documenter.DocsNode
    ctx = dctx.ctx
    @tags a section div
    # The `:results` field contains a vector of `Docs.DocStr` objects associated with
    # each markdown object. The `DocStr` contains data such as file and line info that
    # we need for generating correct source links.
    return map(zip(node.element.mdasts, node.element.results)) do (markdown, result)
        ret = section(div(domify(dctx, markdown)))
        # When a source link is available then print the link.
        if !ctx.settings.disable_git
            url = Documenter.source_url(ctx.doc, result)
            if url !== nothing
                push!(ret.nodes, a[".docs-sourcelink", :target => "_blank", :href => url]("source"))
            end
        end
        return ret
    end
end

function domify(dctx::DCtx, ::Node, evalnode::Documenter.EvalNode)
    return isnothing(evalnode.result) ? DOM.Node[] : domify(dctx, evalnode.result.children)
end

# nothing to show for MetaNodes, so we just return an empty list
domify(::DCtx, ::Node, ::Documenter.MetaNode) = DOM.Node[]
domify(::DCtx, ::Node, ::Documenter.SetupNode) = DOM.Node[]

function domify(::DCtx, ::Node, rawnode::Documenter.RawNode)
    return rawnode.name === :html ? DOM.Tag(Symbol("#RAW#"))(rawnode.text) : DOM.Node[]
end


# Utilities
# ------------------------------------------------------------------------------

"""
Writes the HTML DOM into the HTML file that corresponds to `navnode`.
Prints a warning/error if the page goes over the `size_threshold` or `size_threshold_warn`
limits, and in the former case also returns `false`, to report back to the caller that the
size threshold check failed.
"""
function write_html(ctx::HTMLContext, navnode::Documenter.NavNode, page_html::DOM.HTMLDocument)::Bool
    page_path = get_url(ctx, navnode)
    buf = IOBuffer()
    print(buf, page_html)
    path = joinpath(ctx.doc.user.build, page_path)
    isdir(dirname(path)) || mkpath(dirname(path))
    file_size = open(io -> write(io, take!(buf)), path; write = true)

    file_size_format_results = format_units(file_size)
    size_threshold_format_results = format_units(ctx.settings.size_threshold)
    size_threshold_warn_format_results = format_units(ctx.settings.size_threshold_warn)

    size_threshold_msg(var::Symbol) = """
    Generated HTML over $(var) limit: $(navnode.page)
        Generated file size: $file_size_format_results
        size_threshold_warn: $size_threshold_warn_format_results
        size_threshold:      $size_threshold_format_results
        HTML file:           $(page_path)"""
    if navnode.page in ctx.settings.size_threshold_ignore
        if file_size > ctx.settings.size_threshold_warn
            @debug """
            $(size_threshold_msg(:size_threshold_warn))
            Hard limit ignored due to 'size_threshold_ignore'.
            """ size_threshold_ignore = ctx.settings.size_threshold_ignore
        end
    elseif file_size > ctx.settings.size_threshold
        @error size_threshold_msg(:size_threshold)
        return false
    elseif file_size > ctx.settings.size_threshold_warn
        @warn size_threshold_msg(:size_threshold_warn)
    end
    return true
end

"""
Calculates and converts bytes to appropriate format.
"""
function format_units(size)
    unit = "bytes"

    if size == typemax(Int)
        return "(no limit)"
    end
    if size >= 1024
        size = size / 1024
        unit = "KiB"
        if size >= 1024
            size = size / 1024
            unit = "MiB"
        end
    end

    return string(round(size, digits = 2), " (", unit, ")")
end

"""
Get the relative hyperlink between two [`Documenter.NavNode`](@ref)s. Assumes that both
[`Documenter.NavNode`](@ref)s have an associated [`Documenter.Page`](@ref) (i.e. `.page`
is not `nothing`).
"""
navhref(ctx, to, from) = pretty_url(ctx, relhref(get_url(ctx, from), get_url(ctx, to)))

"""
Calculates a relative HTML link from one path to another.
"""
function relhref(from, to)
    pagedir = dirname(from)
    # The regex separator replacement is necessary since otherwise building the docs on
    # Windows will result in paths that have `//` separators which break asset inclusion.
    return replace(relpath(to, isempty(pagedir) ? "." : pagedir), r"[/\\]+" => "/")
end

"""
Returns the full path corresponding to a path of a `.md` page file. The the input and output
paths are assumed to be relative to `src/`.
"""
function get_url(ctx, path::AbstractString)
    if ctx.settings.prettyurls
        d = if basename(path) == "index.md"
            dirname(path)
        else
            first(splitext(path))
        end
        return isempty(d) ? "index.html" : "$d/index.html"
    else
        # change extension to .html
        return string(splitext(path)[1], ".html")
    end
end

"""
Generates a unique file for the output of an at-example block if it goes over the configured
size threshold, and returns the filename (that should be in the same directory are the
corresponding HTML file). If the data is under the threshold, no file is created, and the
function returns `nothing`.
"""
function write_data_file(dctx::DCtx, data::Union{Vector{UInt8}, AbstractString}; suffix::AbstractString)
    # If we're under the threshold, we return `nothing`, indicating to the caller that
    # they should inline the file instead.
    if length(data) < dctx.ctx.settings.example_size_threshold
        return nothing
    end
    slug = dataslug(data)
    datafile = data_filename(dctx, slug, suffix)
    mkpath(dirname(datafile.path)) # generally, the directory for the HTML page will not exist yet
    write(datafile.path, data)
    # In all cases the file should be places in the same directory as the HTML file,
    # so we only need the filename to generate a valid relative href.
    return datafile.filename
end

function data_filename(dctx::DCtx, slug::AbstractString, suffix::AbstractString)
    ctx, navnode = dctx.ctx, dctx.navnode
    # We want to
    dir, pagename = splitdir(navnode.page)
    # Let's normalize the filename of the page by removing .md extensions (if present).
    # We'll keep other extensions though.
    if endswith(pagename, ".md")
        pagename = first(splitext(pagename))
    end

    filename_prefix = if ctx.settings.prettyurls
        # If pretty URLs are enabled, we would normally have
        # foo/bar.md -> foo/bar/index.html, and we then generate files
        # like foo/bar/$(slug).png
        # However, if we have foo/index.md, then it becomes foo/index.html,
        # and so we want to differentiate the data filenames just in case,
        # and so they become foo/index-$(slug).png
        if pagename == "index"
            string("index-", slug)
        else
            # We also need to update dir from foo/ to foo/bar here, since we want the
            # file to end up at foo/bar/$(slug).png
            dir = joinpath(dir, pagename)
            slug
        end
    else
        # If pretty URLs are disabled, then
        # foo/bar.md becomes foo/bar.html, and we always want to add the
        # Markdown filename to the data filename, i.e. foo/bar-$(slug).png
        string(pagename, "-", slug)
    end
    # Now we need to find a valid file name, in case there are existing duplicates.
    filename = find_valid_data_file(joinpath(ctx.doc.user.build, dir), filename_prefix, suffix)
    return (;
        filename,
        path = joinpath(ctx.doc.user.build, dir, filename),
    )
end

function find_valid_data_file(directory::AbstractString, prefix::AbstractString, suffix::AbstractString)
    # We'll try 10_000 different filename.. if this doesn't work, then something is probably really
    # badly wrong, and so we just crash.
    for i in 0:10_000
        filename = if i == 0
            string(prefix, suffix)
        else
            string(prefix, '-', lpad(string(i), 3, '0'), suffix)
        end
        ispath(joinpath(directory, filename)) || return filename
    end
    error(
        """
        Unable to find valid file name for an at-example output:
          directory = $(directory)
          prefix = $(prefix)
          suffix = $(suffix)"""
    )
end

"""
Returns the first `limit` characters of the hex SHA1 of the data `bytes`.
"""
function dataslug(bytes::Union{Vector{UInt8}, AbstractString}; limit = 8)::String
    full_sha = bytes2hex(SHA.sha1(bytes))
    return first(full_sha, limit)
end

"""
Returns the full path of a [`Documenter.NavNode`](@ref) relative to `src/`.
"""
get_url(ctx, navnode::Documenter.NavNode) = get_url(ctx, navnode.page)

"""
If `prettyurls` for [`HTML`](@ref Documenter.HTML) is enabled, returns a "pretty" version of
the `path` which can then be used in links in the resulting HTML file.
"""
function pretty_url(ctx, path::AbstractString)
    if ctx.settings.prettyurls
        dir, file = splitdir(path)
        if file == "index.html"
            return length(dir) == 0 ? "" : "$(dir)/"
        end
    end
    return path
end

"""
If `canonical` for [`HTML`](@ref Documenter.HTML) is set, returns the canonical
URL of a `path` or [`Documenter.NavNode`](@ref), otherwise returns nothing.
"""
function canonical_url(ctx, path_or_navnode)
    canonical_link = ctx.settings.canonical
    if canonical_link === nothing
        return nothing
    else
        canonical_link_stripped = rstrip(canonical_link, '/')
        url = pretty_url(ctx, get_url(ctx, path_or_navnode))
        return "$canonical_link_stripped/$url"
    end
end

"""
Tries to guess the page title by looking at the `<h1>` headers and returns the
header contents of the first `<h1>` on a page (or `nothing` if the algorithm
was unable to find any `<h1>` headers).
"""
function pagetitle(page::Node)
    @assert page.element isa MarkdownAST.Document
    title = nothing
    for node in page.children
        # AnchoredHeaders should have just one child node, which is the Heading node
        if isa(node.element, Documenter.AnchoredHeader)
            node = first(node.children)
        end
        if isa(node.element, MarkdownAST.Heading) && node.element.level == 1
            title = collect(node.children)
            break
        end
    end
    return title
end

function pagetitle(dctx::DCtx)
    ctx, navnode = dctx.ctx, dctx.navnode
    if navnode.title_override !== nothing
        # parse title_override as markdown
        md = Markdown.parse(navnode.title_override)
        # Markdown.parse results in a paragraph so we need to strip that
        if !(length(md.content) === 1 && isa(first(md.content), Markdown.Paragraph))
            error("Bad Markdown provided for page title: '$(navnode.title_override)'")
        end
        mdast = convert(Node, md)
        return collect(first(mdast.children).children)
    end

    if navnode.page !== nothing
        title = pagetitle(getpage(ctx, navnode).mdast)
        title === nothing || return title
    end

    return [MarkdownAST.@ast("-")]
end

mdflatten_pagetitle(dctx::DCtx) = sprint((io, ns) -> foreach(n -> mdflatten(io, n), ns), pagetitle(dctx))

"""
Returns an ordered list of tuples, `(toplevel, anchor, text)`, corresponding to level 1 and 2
headings on the `page`. Note that if the first header on the `page` is a level 1 header then
it is not included -- it is assumed to be the page title and so does not need to be included
in the navigation menu twice.
"""
function collect_subsections(page::MarkdownAST.Node)
    @assert page.element isa MarkdownAST.Document
    sections = []
    title_found = false
    for node in page.children
        @assert !isa(node.element, MarkdownAST.Heading) # all headings should have been replaced
        isa(node.element, Documenter.AnchoredHeader) || continue
        anchor = node.element.anchor
        node = first(node.children) # get the Heading node
        @assert isa(node.element, MarkdownAST.Heading)
        if node.element.level < 3
            toplevel = node.element.level === 1
            # Don't include the first header if it is `h1`.
            if toplevel && isempty(sections) && !title_found
                title_found = true
                continue
            end
            push!(sections, (toplevel, Documenter.anchor_fragment(anchor), node))
        end
    end
    return sections
end

function domify_ansicoloredtext(text::AbstractString, class = "")
    @tags pre
    stack = DOM.Node[pre()] # this `pre` is dummy
    function cb(io::IO, printer, tag::String, attrs::Dict{Symbol, String})
        text = String(take!(io))
        children = stack[end].nodes
        isempty(text) || push!(children, DOM.Tag(Symbol("#RAW#"))(text))
        if startswith(tag, "/")
            pop!(stack)
        else
            parent = DOM.Tag(Symbol(tag))[attrs]
            push!(children, parent)
            push!(stack, parent)
        end
        return true
    end
    ansiclass = isempty(class) ? "ansi" : class * " ansi"
    printer = ANSIColoredPrinters.HTMLPrinter(
        IOBuffer(text), callback = cb,
        root_tag = "code", root_class = ansiclass
    )
    show(IOBuffer(), MIME"text/html"(), printer)
    return stack[1].nodes
end

function domify(::DCtx, ::Node, e::MarkdownAST.Text)
    text = e.text

    # Javascript LaTeX engines have a hard time dealing with `$` floating around
    # because they use them as in-line escapes. You can try a few different
    # solutions that don't work (e.g., HTML symbols &#x24;). The easiest (if
    # hacky) solution is to wrap dollar signs in a <span>. For now, only do this
    # when the text coming in is a singleton escaped $ sign.
    if text == "\$"
        return DOM.Tag(:span)("\$")
    end
    return DOM.Node(text)
end

domify(dctx::DCtx, node::Node, ::MarkdownAST.BlockQuote) = DOM.Tag(:blockquote)(domify(dctx, node.children))

domify(dctx::DCtx, node::Node, ::MarkdownAST.Strong) = DOM.Tag(:strong)(domify(dctx, node.children))

domify(dctx::DCtx, node::Node, ::MarkdownAST.Emph) = DOM.Tag(:em)(domify(dctx, node.children))

domify(dctx::DCtx, node::Node, ::MarkdownAST.Strikethrough) = DOM.Tag(:del)(domify(dctx, node.children))

function domify(dctx::DCtx, ::Node, c::MarkdownAST.CodeBlock)
    ctx = dctx.ctx
    settings = ctx.settings
    language = c.info
    @tags pre code
    language = Documenter.codelang(language)
    if language == "documenter-ansi" # From @repl blocks (through MultiCodeBlock)
        return pre(domify_ansicoloredtext(c.code, "nohighlight hljs"))
    elseif settings !== nothing && settings.prerender &&
            !(isempty(language) || language == "nohighlight")
        r = hljs_prerender(c, settings)
        r !== nothing && return r
    end
    class = isempty(language) ? "nohighlight" : "language-$(language)"
    return pre(code[".$(class) .hljs"](c.code))
end

function domify(dctx::DCtx, node::Node, mcb::Documenter.MultiCodeBlock)
    @tags pre br
    p = pre()
    for (i, thing) in enumerate(node.children)
        pre = domify(dctx, thing)
        code = pre.nodes[1]
        # TODO: This should probably be added to the CSS later on...
        push!(code.attributes, :style => "display:block;")
        push!(p.nodes, code)
        # insert a <br> between output and the next input
        if i != length(node.children) &&
                findnext(x -> x.element.info == mcb.language, collect(node.children), i + 1) == i + 1
            push!(p.nodes, br())
        end
    end
    return p
end

domify(::DCtx, ::Node, c::MarkdownAST.Code) = DOM.Tag(:code)(c.code)

function hljs_prerender(c::MarkdownAST.CodeBlock, settings::HTML)
    @assert settings.prerender "unreachable"
    @tags pre code
    lang = Documenter.codelang(c.info)
    hljs = settings.highlightjs
    js = """
    const hljs = require('$(hljs)');
    console.log(hljs.highlight($(repr(c.code)), {'language': "$(lang)"}).value);
    """
    out, err = IOBuffer(), IOBuffer()
    try
        run(pipeline(`$(settings.node) -e "$(js)"`; stdout = out, stderr = err))
        str = String(take!(out))
        # prepend nohighlight to stop runtime highlighting
        # return pre(code[".nohighlight $(lang) .hljs"](DOM.Tag(Symbol("#RAW#"))(str)))
        return pre(code[".language-$(lang) .hljs"](DOM.Tag(Symbol("#RAW#"))(str)))
    catch e
        @error "HTMLWriter: prerendering failed" exception = e stderr = String(take!(err))
    end
    return nothing
end

function domify(dctx::DCtx, node::Node, h::MarkdownAST.Heading)
    N = h.level
    return DOM.Tag(Symbol("h$N"))(domify(dctx, node.children))
end

domify(::DCtx, ::Node, ::MarkdownAST.ThematicBreak) = DOM.Tag(:hr)()

const ImageElements = Union{MarkdownAST.Image, Documenter.LocalImage}
function domify(dctx::DCtx, node::Node, i::ImageElements)
    alt = mdflatten(node.children)
    url = filehref(dctx, node, i)
    # TODO: Implement .title
    @tags video img a

    if occursin(r"\.(webm|mp4|ogg|ogm|ogv|avi)$", url)
        return video[:src => url, :controls => "true", :title => alt](
            a[:href => url](alt)
        )
    else
        return img[:src => url, :alt => alt]
    end
end

domify(::DCtx, ::Node, m::MarkdownAST.DisplayMath) = DOM.Tag(:p)[".math-container"](string("\\[", m.math, "\\]"))

domify(::DCtx, ::Node, m::MarkdownAST.InlineMath) = DOM.Tag(:span)(string('$', m.math, '$'))

domify(::DCtx, ::Node, html::MarkdownAST.HTMLBlock) = DOM.Tag(Symbol("#RAW#"))(html.html)

domify(::DCtx, ::Node, html::MarkdownAST.HTMLInline) = DOM.Tag(Symbol("#RAW#"))(html.html)

domify(::DCtx, ::Node, m::MarkdownAST.LineBreak) = DOM.Tag(:br)()
# TODO: Implement SoftBreak, Backslash (but they don't appear in standard library Markdown conversions)

const LinkElements = Union{MarkdownAST.Link, Documenter.PageLink, Documenter.LocalLink}
function domify(dctx::DCtx, node::Node, link::LinkElements)
    droplinks = dctx.droplinks
    url = filehref(dctx, node, link)
    link_text = domify(dctx, node.children)
    return droplinks ? link_text : DOM.Tag(:a)[:href => url](link_text)
end

function domify(dctx::DCtx, node::Node, list::MarkdownAST.List)
    isordered = (list.type === :ordered)
    return (isordered ? DOM.Tag(:ol) : DOM.Tag(:ul))(map(DOM.Tag(:li), domify(dctx, node.children)))
end
domify(dctx::DCtx, node::Node, ::MarkdownAST.Item) = domify(dctx, node.children)

function domify(dctx::DCtx, node::Node, ::MarkdownAST.Paragraph)
    content = domify(dctx, node.children)
    # This 'if' here is to render tight/loose lists properly, as they all have Markdown.Paragraph as a child
    # node, but we should not render it for tight lists.
    # See also: https://github.com/JuliaLang/julia/pull/26598
    return is_in_tight_list(node) ? content : DOM.Tag(:p)(content)
end
is_in_tight_list(node::Node) = !isnothing(node.parent) && isa(node.parent.element, MarkdownAST.Item) &&
    !isnothing(node.parent.parent) && isa(node.parent.parent.element, MarkdownAST.List) &&
    node.parent.parent.element.tight

function domify(dctx::DCtx, node::Node, t::MarkdownAST.Table)
    th_row, tbody_rows = Iterators.peel(MarkdownAST.tablerows(node))
    @tags table tr th td
    alignment_style = map(t.spec) do align
        if align == :right
            "text-align: right"
        elseif align == :center
            "text-align: center"
        else
            "text-align: left"
        end
    end
    return table(
        tr(
            map(enumerate(th_row.children)) do (i, x)
                th[:style => alignment_style[i]](domify(dctx, x.children))
            end
        ),
        map(tbody_rows) do x
            tr(
                map(enumerate(x.children)) do (i, y) # each cell in a row
                    td[:style => alignment_style[i]](domify(dctx, y.children))
                end
            )
        end
    )
end

function domify(dctx::DCtx, ::Node, e::MarkdownAST.JuliaValue)
    message =
    """
    Unexpected Julia interpolation in the Markdown. This probably means that you have an
    unbalanced or un-escaped \$ in the text.

    To write the dollar sign, escape it with `\\\$`

    This is in file $(locrepr(dctx)), and we were given the value:

    `$(e.ref)` which is of type `$(typeof(e.ref))`
    """
    if dctx.ctx.doc.user.treat_markdown_warnings_as_error
        error(message)
    else
        @warn(message)
    end
    return string(e.ref)
end

function domify(::DCtx, ::Node, f::MarkdownAST.FootnoteLink)
    @tags sup a span
    # Create the footnote reference with preview
    return sup[".footnote-reference"](
        a["#citeref-$(f.id)", :href => "#footnote-$(f.id)", :class => "footnote-ref"]("[$(f.id)]"),
        span[".footnote-preview", :id => "fn-$(f.id)"]()
    )
end

function domify(dctx::DCtx, node::Node, f::MarkdownAST.FootnoteDefinition)
    # As we run through the document to generate the document, we won't render the footnote
    # definitions right away, and instead store them on dctx.footnotes. They get printed
    # a little later, at the very end of the page.
    #
    # It does mean that we call domify() again later on the actual footnote bodies, and in that
    # case dctx.footnotes = nothing. In case we then still end up here, it means we have footnote
    # definitions nested inside footnote definition. We just ignore those and print a warning.
    #
    # TODO: this could be rearranged such that we push!() the DOM here into .footnotes, rather
    # than the Node objects.
    if isnothing(dctx.footnotes)
        @error "Invalid nested footnote definition in $(Documenter.locrepr(dctx))" f.id
    else
        push!(dctx.footnotes, node)
    end
    return DOM.Node[]
end

function domify(dctx::DCtx, node::Node, a::MarkdownAST.Admonition)
    @tags header div details summary
    colorclass =
        (a.category == "danger") ? ".is-danger" :
        (a.category == "warning") ? ".is-warning" :
        (a.category == "note") ? ".is-info" :
        (a.category == "info") ? ".is-info" :
        (a.category == "tip") ? ".is-success" :
        (a.category == "todo") ? ".is-todo" :
        (a.category == "compat") ? ".is-compat" : begin
            # If the admonition category is not one of the standard ones, we tag the
            # admonition div element with a `is-category-$(category)` class. However, we
            # first carefully sanitize the category name. Strictly speaking, this is not
            # necessary when were using the Markdown parser in the Julia standard library,
            # since it restricts the category to [a-z]+. But it is possible for the users to
            # construct their own Admonition objects with arbitrary category strings and
            # pass them onto Documenter.
            #
            # (1) remove all characters except A-Z, a-z, 0-9 and -
            cat_sanitized = replace(a.category, r"[^A-Za-z0-9-]" => "")
            # (2) remove any dashes from the beginning and end of the string
            cat_sanitized = replace(cat_sanitized, r"^[-]+" => "")
            cat_sanitized = replace(cat_sanitized, r"[-]+$" => "")
            # (3) reduce any duplicate dashes in the middle to single dashes
            cat_sanitized = replace(cat_sanitized, r"[-]+" => "-")
            cat_sanitized = lowercase(cat_sanitized)
            # (4) if nothing is left (or the category was empty to begin with), we don't
            # apply a class
            isempty(cat_sanitized) ? "" : ".is-category-$(cat_sanitized)"
        end
    node_repr = strip(mdflatten(node))
    content_hash = string(hash(node_repr), base = 16)
    admonition_id = if !isempty(a.title)
        base_id = Documenter.slugify(a.title)
        "$(base_id)-$(content_hash)"
    else
        "$(a.category)-$(content_hash)"
    end
    anchor_link = DOM.Tag(:a)[".admonition-anchor", :href => "#$(admonition_id)", :title => "Permalink"]()
    inner_div = div[".admonition-body"](domify(dctx, node.children))
    if a.category == "details"
        # details admonitions are rendered as <details><summary> blocks
        return details[".admonition.is-details", :id => admonition_id](
            summary[".admonition-header"](a.title, anchor_link), inner_div
        )
    else
        return div[".admonition$(colorclass)", :id => admonition_id](
            header[".admonition-header"](a.title, anchor_link), inner_div
        )
    end
end

# Select the "best" representation for HTML output.
domify(dctx::DCtx, node::Node, ::Documenter.MultiOutput) = domify(dctx, node.children)
domify(dctx::DCtx, node::Node, moe::Documenter.MultiOutputElement) = Base.invokelatest(domify, dctx, node, moe.element)

function domify(dctx::DCtx, node::Node, d::Dict{MIME, Any})
    rawhtml(code) = DOM.Tag(Symbol("#RAW#"))(code)
    # Our first preference for the MIME type is 'text/html', which we can natively include
    # in the HTML. But it might happen that it's too large (above example_size_threshold),
    # in which case we move on to trying to write it as an image.
    has_text_html = false
    if haskey(d, MIME"text/html"())
        if length(d[MIME"text/html"()]) < dctx.ctx.settings.example_size_threshold
            # If the size threshold is met, we can just return right away
            return rawhtml(d[MIME"text/html"()])
        end
        # We'll set has_text_html to distinguish it from the case where the 'text/html' MIME
        # show() method was simply missing.
        has_text_html = true
    end
    # If text/html failed, we try to write the output as an image, possibly to a file.
    image = if haskey(d, MIME"image/svg+xml"())
        @tags img
        svg = d[MIME"image/svg+xml"()]
        svg_tag_match = match(r"<svg[^>]*>", svg)
        dom = if length(svg) >= dctx.ctx.settings.example_size_threshold
            filename = write_data_file(dctx, svg; suffix = ".svg")
            @assert !isnothing(filename)
            img[:src => filename, :alt => "Example block output"]
        elseif svg_tag_match === nothing
            # There is no svg tag so we don't do any more advanced
            # processing and just return the svg as HTML.
            # The svg string should be invalid but that's not our concern here.
            rawhtml(svg)
        else
            # The xmlns attribute has to be present for data:image/svg+xml
            # to work (https://stackoverflow.com/questions/18467982).
            # If it doesn't exist, we splice it into the first svg tag.
            # This should never invalidate otherwise valid svg.
            svg_tag = svg_tag_match.match
            xmlns_present = occursin("xmlns", svg_tag)
            if !xmlns_present
                svg = replace(svg, "<svg" => "<svg xmlns=\"http://www.w3.org/2000/svg\"", count = 1)
            end

            # We can leave the svg as utf8, but the minimum safety precaution we need
            # is to ensure the src string separator is not in the svg.
            # That can be either " or ', and the svg will most likely use only one of them
            # so we check which one occurs more often and use the other as the separator.
            # This should leave most svg basically intact.

            # Replace % with %25 and # with %23 https://github.com/jakubpawlowicz/clean-css/issues/763#issuecomment-215283553
            svg = replace(svg, "%" => "%25")
            svg = replace(svg, "#" => "%23")

            singles = count(==('\''), svg)
            doubles = count(==('"'), svg)
            if singles > doubles
                # Replace every " with %22 because it terminates the src=" string otherwise
                svg = replace(svg, "\"" => "%22")
                sep = "\""
            else
                # Replace every ' with %27 because it terminates the src=' string otherwise
                svg = replace(svg, "\'" => "%27")
                sep = "'"
            end

            rawhtml(string("<img src=", sep, "data:image/svg+xml;utf-8,", svg, sep, "/>"))
        end
        (; dom = dom, mime = "image/svg+xml")
    elseif haskey(d, MIME"image/png"())
        domify_show_image_binary(dctx, "png", d)
    elseif haskey(d, MIME"image/webp"())
        domify_show_image_binary(dctx, "webp", d)
    elseif haskey(d, MIME"image/gif"())
        domify_show_image_binary(dctx, "gif", d)
    elseif haskey(d, MIME"image/jpeg"())
        domify_show_image_binary(dctx, "jpeg", d)
    end
    # If image is nothing, then the object did not have any of the supported image
    # representations. In that case, if the 'text/html' representation exists, we use that,
    # but with a warning because it goes over the size limit. If 'text/html' was missing too,
    # we carry on to additional MIME types.
    if has_text_html && isnothing(image)
        # The 'text/html' representation of an @example block is above the threshold, but no
        # supported image representation is present as an alternative.
        push!(
            dctx.ctx.atexample_warnings,
            AtExampleFallbackWarning(
                page = dctx.navnode.page,
                size_bytes = length(d[MIME"text/html"()]),
                fallback = nothing,
            )
        )
        return rawhtml(d[MIME"text/html"()])
    elseif has_text_html && !isnothing(image)
        # The 'text/html' representation of an @example block is above the threshold,
        # falling back to '$(image.mime)' representation.
        push!(
            dctx.ctx.atexample_warnings,
            AtExampleFallbackWarning(
                page = dctx.navnode.page,
                size_bytes = length(d[MIME"text/html"()]),
                fallback = image.mime,
            )
        )
        return image.dom
    elseif !has_text_html && !isnothing(image)
        return image.dom
    end
    # Check for some 'fallback' MIMEs, defaulting to 'text/plain' if we can't find any of them.
    return if haskey(d, MIME"text/latex"())
        latex = d[MIME"text/latex"()]
        # If the show(io, ::MIME"text/latex", x) output is already wrapped in
        # \[ ... \] or $$ ... $$, we unwrap it first, since when we output
        # Markdown.LaTeX objects we put the correct delimiters around it anyway.
        has_math, latex = _strip_latex_math_delimiters(latex)
        out = if !has_math
            Documenter.mdparse(latex; mode = :single)
        else
            [MarkdownAST.@ast MarkdownAST.DisplayMath(latex)]
        end
        domify(dctx, out)
    elseif haskey(d, MIME"text/markdown"())
        out = Markdown.parse(d[MIME"text/markdown"()])
        out = convert(MarkdownAST.Node, out)
        domify(dctx, out)
    elseif haskey(d, MIME"text/plain"())
        @tags pre
        text = d[MIME"text/plain"()]
        pre[".documenter-example-output"](domify_ansicoloredtext(text, "nohighlight hljs"))
    else
        error("this should never happen.")
    end
end

function _strip_latex_math_delimiters(latex::AbstractString)
    # Make sure to match multiline strings!
    m_bracket = match(r"\s*\\\[(.*)\\\]\s*"s, latex)
    if m_bracket !== nothing
        return true, m_bracket[1]
    end
    # This regex matches the strings "$ ... $" and "$$ ... $$", but not
    # strings with miss-matched dollar signs such as "$ ... $$" or "$$ ... $"
    m_dollars = match(r"^\s*(\${1,2})([^\$]*)\1\s*$"s, latex)
    if m_dollars !== nothing
        return true, m_dollars[2]
    end
    return false, latex
end

function domify_show_image_binary(dctx::DCtx, filetype::AbstractString, d::Dict{MIME, Any})
    @tags img
    mime_name = "image/$filetype"
    mime = MIME{Symbol(mime_name)}()
    # When we construct `d` in the expander pipeline, we call `stringmime`, which
    # base64-encodes the bytes, so the values in the dictionary are base64-encoded.
    # So if we do write it to a file, we need to decode it first.
    data_base64 = d[mime]
    filename = write_data_file(dctx, Base64.base64decode(data_base64); suffix = ".$filetype")
    alt = (:alt => "Example block output")
    dom = if isnothing(filename)
        src = string("data:$(mime_name);base64,", data_base64)
        img[:src => src, alt]
    else
        img[:src => filename, alt]
    end
    return (; dom, mime = mime_name)
end

# filehrefs
# ------------------------------------------------------------------------------

# If the nodes passed through CrossReferences as native MarkdownAST elements, then that
# means they're reasonable absolute URLs. Or, possibly, the URL is problematic, but we
# just ignore that here. That should have been caught earlier.
filehref(::DCtx, ::Node, e::Union{MarkdownAST.Image, MarkdownAST.Link}) = e.destination

function filehref(dctx::DCtx, ::Node, pagelink::Documenter.PageLink)
    ctx, navnode = dctx.ctx, dctx.navnode
    path = Documenter.pagekey(ctx.doc, pagelink.page)
    path = pretty_url(ctx, relhref(get_url(ctx, navnode), get_url(ctx, path)))
    # Add a fragment, if present
    return isempty(pagelink.fragment) ? path : "$path#$(pagelink.fragment)"
end

function filehref(dctx::DCtx, ::Node, locallink::Documenter.LocalLink)
    ctx, navnode = dctx.ctx, dctx.navnode
    path = relhref(get_url(ctx, navnode), locallink.path)
    # Replace any backslashes in links, if building the docs on Windows
    path = replace(path, '\\' => '/')
    # Add a fragment, if present
    return isempty(locallink.fragment) ? path : "$path#$(locallink.fragment)"
end

function filehref(dctx::DCtx, ::Node, localimage::Documenter.LocalImage)
    ctx, navnode = dctx.ctx, dctx.navnode
    path = relhref(get_url(ctx, navnode), localimage.path)
    # Replace any backslashes in links, if building the docs on Windows
    return replace(path, '\\' => '/')
end

end

# Provides the [`missingdocs`](@ref), [`footnotes`](@ref) and [`linkcheck`](@ref) functions
# for checking docs.

# Missing docstrings.
# -------------------

"""
$(SIGNATURES)

Checks that a [`Document`](@ref) contains all available docstrings that are
defined in the `modules` keyword passed to [`makedocs`](@ref).

Prints out the name of each object that has not had its docs spliced into the document.

Returns the number of missing bindings to allow for automated testing of documentation.
"""
function missingdocs(doc::Document)
    doc.user.checkdocs === :none && return 0
    bindings = missingbindings(doc)
    n = reduce(+, map(length, values(bindings)), init = 0)
    if n > 0
        b = IOBuffer()
        println(b, "$n docstring$(n ≡ 1 ? "" : "s") not included in the manual:\n")
        for (binding, signatures) in bindings
            for sig in signatures
                println(b, "    $binding", sig ≡ Union{} ? "" : " :: $sig")
            end
        end
        println(b)
        print(
            b, """
            These are docstrings in the checked modules (configured with the modules keyword)
            that are not included in canonical @docs or @autodocs blocks.
            """
        )
        @docerror(doc, :missing_docs, String(take!(b)))
    end
    return n
end

function missingbindings(doc::Document)
    @debug "checking for missing docstrings."
    bindings = allbindings(doc.user.checkdocs, doc.blueprint.modules)
    for object in keys(doc.internal.objects)
        if !is_canonical(object)
            continue
        end
        # The module references in docs blocks can yield a binding like
        # Docs.Binding(Mod, :SubMod) for a module SubMod, a submodule of Mod. However, the
        # module bindings that come from Docs.meta() always appear to be of the form
        # Docs.Binding(Mod.SubMod, :SubMod) (since Julia 0.7). We therefore "normalize"
        # module bindings before we search in the list returned by allbindings().
        binding = if DocSystem.defined(object.binding) && !DocSystem.iskeyword(object.binding)
            m = DocSystem.resolve(object.binding)
            isa(m, Module) && nameof(object.binding.mod) != object.binding.var ?
                Docs.Binding(m, nameof(m)) : object.binding
        else
            object.binding
        end
        if haskey(bindings, binding)
            signatures = bindings[binding]
            if object.signature ≡ Union{} || length(signatures) ≡ 1
                delete!(bindings, binding)
            elseif object.signature in signatures
                delete!(signatures, object.signature)
            end
        end
    end
    return bindings
end

function allbindings(checkdocs::Symbol, mods)
    out = Dict{Binding, Set{Type}}()
    for m in mods
        allbindings(checkdocs, m, out)
    end
    return out
end

function allbindings(checkdocs::Symbol, mod::Module, out = Dict{Binding, Set{Type}}())
    for (binding, doc) in meta(mod)
        # The keys of the docs meta dictionary should always be Docs.Binding objects in
        # practice. However, the key type is Any, so it is theoretically possible that
        # some non-binding metadata gets added to the dict. So on the off-chance that has
        # happened, we simply ignore those entries.
        isa(binding, Docs.Binding) || continue
        # We only consider a name exported only if it actually exists in the module, either
        # by virtue of being defined there, or if it has been brought into the scope with
        # import/using.
        name = nameof(binding)
        isexported = (binding == Binding(mod, name)) && Base.isexported(mod, name)
        ispublic = (binding == Binding(mod, name)) && @static if isdefined(Base, :ispublic)
            Base.ispublic(mod, name)
        else
            Base.isexported(mod, name)
        end
        if checkdocs === :all ||
                (isexported && checkdocs === :exports) ||
                (ispublic && checkdocs === :public)
            out[binding] = Set(sigs(doc))
        end
    end
    return out
end

meta(m) = Docs.meta(m)

nameof(b::Base.Docs.Binding) = b.var
nameof(x) = Base.nameof(x)

sigs(x::Base.Docs.MultiDoc) = x.order
sigs(::Any) = Type[Union{}]


# Footnote checks.
# ----------------
"""
$(SIGNATURES)

Checks footnote links in a [`Document`](@ref).
"""
function footnotes(doc::Document)
    @debug "checking footnote links."
    # A mapping of footnote ids to a tuple counter of how many footnote references and
    # footnote bodies have been found.
    #
    # For all ids the final result should be `(N, 1)` where `N > 1`, i.e. one or more
    # footnote references and a single footnote body.
    footnotes = Dict{Page, Dict{String, Tuple{Int, Int}}}()
    for (src, page) in doc.blueprint.pages
        orphans = Dict{String, Tuple{Int, Int}}()
        for node in AbstractTrees.PreOrderDFS(page.mdast)
            footnote(node.element, orphans)
        end
        footnotes[page] = orphans
    end
    for (page, orphans) in footnotes
        for (id, (ids, bodies)) in orphans
            # Multiple footnote bodies.
            if bodies > 1
                @docerror(doc, :footnote, "footnote '$id' has $bodies bodies in $(locrepr(doc, page)).")
            end
            # No footnote references for an id.
            if ids === 0
                @docerror(doc, :footnote, "unused footnote named '$id' in $(locrepr(doc, page)).")
            end
            # No footnote bodies for an id.
            if bodies === 0
                @docerror(doc, :footnote, "no footnotes found for '$id' in $(locrepr(doc, page)).")
            end
        end
    end
    return
end

function footnote(fn::MarkdownAST.FootnoteLink, orphans::Dict)
    ids, bodies = get(orphans, fn.id, (0, 0))
    # Footnote references: syntax `[^1]`.
    return orphans[fn.id] = (ids + 1, bodies)
end
function footnote(fn::MarkdownAST.FootnoteDefinition, orphans::Dict)
    ids, bodies = get(orphans, fn.id, (0, 0))
    # Footnote body: syntax `[^1]:`.
    return orphans[fn.id] = (ids, bodies + 1)
end
footnote(other, orphans::Dict) = true

# Link Checks.
# ------------

function hascurl()
    try
        return success(`curl --version`)
    catch err
        return false
    end
end

"""
$(SIGNATURES)

Checks external links using curl.
"""
function linkcheck(doc::Document)
    if doc.user.linkcheck
        if hascurl()
            for (src, page) in doc.blueprint.pages
                linkcheck(page.mdast, doc)
            end
        else
            @docerror(doc, :linkcheck, "linkcheck requires `curl`.")
        end
    end
    return nothing
end

function linkcheck(mdast::MarkdownAST.Node, doc::Document)
    for node in AbstractTrees.PreOrderDFS(mdast)
        linkcheck(node, node.element, doc)
    end
    return
end

function linkcheck(node::MarkdownAST.Node, element::MarkdownAST.AbstractElement, doc::Document)
    # The linkcheck is only active for specific `element` types
    # (`MarkdownAST.Link`, most importantly), which are defined below as more
    # specific methods
    return nothing
end

function linkcheck(node::MarkdownAST.Node, link::MarkdownAST.Link, doc::Document; method::Symbol = :HEAD)

    # first, make sure we're not supposed to ignore this link
    for r in doc.user.linkcheck_ignore
        if linkcheck_ismatch(r, link.destination)
            @debug "linkcheck '$(link.destination)': ignored."
            return
        end
    end

    if !haskey(doc.internal.locallinks, link)
        cmd = _linkcheck_curl(method, link.destination; timeout = doc.user.linkcheck_timeout, useragent = doc.user.linkcheck_useragent)

        local result
        try
            # interpolating into backticks escapes spaces so constructing a Cmd is necessary
            result = read(cmd, String)
        catch err
            @docerror(doc, :linkcheck, "$cmd failed:", exception = err)
            return false
        end
        STATUS_REGEX = r"^(\d+) (\w+)://(?:\S+) (\S+)?$"m
        matched = match(STATUS_REGEX, result)
        if matched !== nothing
            status, scheme, location = matched.captures
            status = parse(Int, status)
            scheme = uppercase(scheme)
            protocol = startswith(scheme, "HTTP") ? :HTTP :
                startswith(scheme, "FTP") ? :FTP : :UNKNOWN

            if (protocol === :HTTP && (status < 300 || status == 302)) ||
                    (protocol === :FTP && (200 <= status < 300 || status == 350))
                if location !== nothing
                    @debug "linkcheck '$(link.destination)' status: $(status), redirects to '$(location)'"
                else
                    @debug "linkcheck '$(link.destination)' status: $(status)."
                end
            elseif protocol === :HTTP && status < 400
                if location !== nothing
                    @warn "linkcheck '$(link.destination)' status: $(status), redirects to '$(location)'"
                else
                    @warn "linkcheck '$(link.destination)' status: $(status)."
                end
            elseif protocol === :HTTP && status == 405 && method === :HEAD
                # when a server doesn't support HEAD requests, fallback to GET
                @debug "linkcheck '$(link.destination)' status: $(status), retrying without `-I`"
                return linkcheck(node, link, doc; method = :GET)
            else
                @docerror(doc, :linkcheck, "linkcheck '$(link.destination)' status: $(status).")
            end
        else
            @docerror(doc, :linkcheck, "invalid result returned by $cmd:", result)
        end
    end
    return false
end


function linkcheck(node::MarkdownAST.Node, docs_node::Documenter.DocsNode, doc::Document)
    for mdast in docs_node.mdasts
        linkcheck(mdast, doc)
    end
    return
end

linkcheck_ismatch(r::String, url) = (url == r)
linkcheck_ismatch(r::Regex, url) = occursin(r, url)

const _LINKCHECK_DEFAULT_USERAGENT = "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/127.0.0.0 Safari/537.36"

function _url_requires_github_token(url::AbstractString)
    # GitHub has started rate limiting some domains.
    # https://github.blog/changelog/2025-05-08-updated-rate-limits-for-unauthenticated-requests/
    # It's a little unclear which domains are throttled:
    # > These changes will apply to operations like cloning repositories over
    # > HTTPS, anonymously interacting with our REST APIs, and downloading files
    # > from raw.githubusercontent.com.
    # This one clearly is:
    if match(r"http(s?)://raw.githubusercontent.com", url) !== nothing
        return true
    end
    # See https://github.com/JuliaDocs/Documenter.jl/pull/2729 for details. Most
    # GitHub urls support authenticating with the token, but /pulls returns
    # 500 when you do a HEAD request.
    # TODO: try full GET request when HEAD fails
    if match(r"http(s?)://github.com/.+?/pulls", url) !== nothing
        return false
    end
    return match(r"http(s?)://github.com", url) !== nothing
end

function _linkcheck_curl(method::Symbol, url::AbstractString; timeout::Real, useragent::Union{AbstractString, Nothing})
    null_file = @static Sys.iswindows() ? "nul" : "/dev/null"
    headers = String[]
    # In some cases, web servers (e.g. docs.github.com as of 2022) will reject requests
    # that declare a non-browser user agent (curl specifically passes 'curl/X.Y'). In
    # case of docs.github.com, the server returns a 403 with a page saying "The request
    # is blocked". However, spoofing a realistic browser User-Agent string is enough to
    # get around this, and so here we simply pass the example Chrome UA string from the
    # Mozilla developer docs, but only if it's an HTTP(S) request.
    #
    # https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/User-Agent#chrome_ua_string
    if startswith(uppercase(url), "HTTP")
        push!(headers, "-H")
        push!(headers, "accept-encoding: gzip, deflate, br")
        if !isnothing(useragent)
            push!(headers, "--user-agent", useragent)
        end
    end
    if haskey(ENV, "GITHUB_TOKEN") && _url_requires_github_token(url)
        push!(headers, "-H")
        push!(headers, "Authorization: Bearer $(ENV["GITHUB_TOKEN"])")
    end
    return `curl $(method === :HEAD ? "-sI" : "-s") --proto =http,https,ftp,ftps -g $(headers) $(url) --max-time $timeout -o $null_file --write-out "%{http_code} %{url_effective} %{redirect_url}"`
end

# Automatic Pkg.add() GitHub remote check
# ---------------------------------------

function gh_get_json(path)
    io = IOBuffer()
    url = "https://api.github.com$(path)"
    @debug "request: GET $url"
    resp = Downloads.request(
        url,
        output = io,
        headers = Dict(
            "Accept" => "application/vnd.github.v3+json",
            "X-GitHub-Api-Version" => "2022-11-28"
        )
    )
    return resp.status, JSON.parse(String(take!(io)))
end

function tag(repo, tag_ref)
    status, result = gh_get_json("/repos/$(repo)/git/ref/tags/$(tag_ref)")
    if status == 404
        return nothing
    elseif status != 200
        error("Unexpected error code $(status) '$(repo)' while getting tag '$(tag_ref)'.")
    end
    if result["object"]["type"] == "tag"
        status, result = gh_get_json("/repos/$(repo)/git/tags/$(result["object"]["sha"])")
        if status == 404
            return nothing
        elseif status != 200
            error("Unexpected error code $(status) '$(repo)' while getting tag '$(tag_ref)'.")
        end
    end
    return result
end

function gitcommit(repo, commit_tag)
    status, result = gh_get_json("/repos/$(repo)/git/commits/$(commit_tag)")
    if status != 200
        error("Unexpected error code $(status) '$(repo)' while getting commit '$(commit_tag)'.")
    end
    return result
end

GITHUB_ERROR_ADVICE = (
    "This means automatically finding the source URL link for this package failed. " *
        "Please add the source URL link manually to the `remotes` field " *
        "in `makedocs` or install the package using `Pkg.develop()``."
)

function githubcheck(doc::Document)
    if !doc.user.linkcheck || (doc.user.remotes === nothing)
        return
    end
    # When we add GitHub links based on packages which have been added with
    # Pkg.add(), we don't have much git information, so we simply use a guessed
    # tag based on the version `v$VERSION`, as this tag is added by the popular
    # TagBot action.
    #
    # This check uses the GitHub API to check whether the tag exists, and if
    # so, whether the tree hash matches the tree hash of the package entry
    # in the manifest.
    src_to_uuid = get_src_to_uuid(doc)
    for remote_repo in doc.user.remotes
        if !(remote_repo.remote isa Remotes.GitHub)
            continue
        end
        if !(remote_repo.root in keys(src_to_uuid))
            continue
        end
        uuid = src_to_uuid[remote_repo.root]
        repo_info = uuid_to_repo(doc, uuid)
        if repo_info === nothing
            continue
        end
        if remote_repo.remote != repo_info[1] || remote_repo.commit != repo_info[2]
            continue
        end
        # Looks like it's been guessed -- let's check if it matches the
        # tree hash from the package entry
        uuid_to_version_info = get_uuid_to_version_info(doc)
        tree_hash = uuid_to_version_info[uuid][2]
        remote = remote_repo.remote
        repo = remote.user * "/" * remote.repo
        tag_guess = remote_repo.commit
        tag_ref = tag(repo, tag_guess)
        if tag_ref === nothing
            @docerror(doc, :linkcheck_remotes, "linkcheck (remote) '$(repo)' error while getting tag '$(tag_guess)'. $(GITHUB_ERROR_ADVICE)")
            return
        end
        if tag_ref["object"]["type"] != "commit"
            @docerror(doc, :linkcheck_remotes, "linkcheck (remote) '$(repo)' tag '$(tag_guess)' does not point to a commit. $(GITHUB_ERROR_ADVICE)")
            return
        end
        commit_sha = tag_ref["object"]["sha"]
        git_commit = gitcommit(repo, commit_sha)
        actual_tree_hash = git_commit["tree"]["sha"]
        if string(tree_hash) != actual_tree_hash
            @docerror(
                doc,
                :linkcheck_remotes,
                "linkcheck (remote) '$(repo)' tag '$(tag_guess)' points to tree hash $(actual_tree_hash), but package entry has $(tree_hash). $(GITHUB_ERROR_ADVICE)"
            )
        end
    end
    return
end

module UtilitiesTests
using Test
using Logging: Info, Warn, with_logger
include("TestUtilities.jl")
using Main.TestUtilities

import Documenter
using Documenter: git
import Markdown, MarkdownAST

module UnitTests
    module SubModule end

    # Does `submodules` collect *all* the submodules?
    module A
        module B
            module C
                module D end
            end
        end
    end

    mutable struct T end
    mutable struct S{T} end

    "Documenter unit tests."
    Base.length(::T) = 1

    f(x) = x

    const pi = 3.0

    const TA = Vector{UInt128}
    const TB = Array{T, 8} where {T}
    const TC = Union{Int64, Float64, String}
end

module OuterModule
    module InnerModule
        import ..OuterModule
        export OuterModule
    end
end

module ExternalModule end
module ModuleWithAliases
    using ..ExternalModule
    Y = ExternalModule
    module A
        module B
            const X = Main
        end
    end
end

function git_config(path = pwd())
    return trun(`$(git()) -C $path config user.email "tester@example.com"`) &&
        trun(`$(git()) -C $path config user.name "Test Committer"`) &&
        trun(`$(git()) -C $path config commit.gpgsign false`)
end

# Between the JuliaSyntax merge and https://github.com/JuliaLang/julia/pull/57280
# there were some differences in the AST.
function bad_juliasyntax_version()
    return any(
        (
            # JuliaSyntax merge and the #57280 backport
            v"1.10.0-DEV.1520" <= VERSION <= v"1.12.0-DEV.1985",
            # 1.13-DEV until #57280
            v"1.13-" <= VERSION <= v"1.13.0-DEV.13",
        )
    )
end

@testset "utilities" begin

    @test UnitTests.A in Documenter.submodules(UnitTests.A)
    @test UnitTests.A.B in Documenter.submodules(UnitTests.A)
    @test UnitTests.A.B.C in Documenter.submodules(UnitTests.A)
    @test UnitTests.A.B.C.D in Documenter.submodules(UnitTests.A)
    @test OuterModule in Documenter.submodules(OuterModule)
    @test OuterModule.InnerModule in Documenter.submodules(OuterModule)
    @test length(Documenter.submodules(OuterModule)) == 2
    @test Documenter.submodules(ModuleWithAliases) == Set([ModuleWithAliases, ModuleWithAliases.A, ModuleWithAliases.A.B])

    @test Documenter.isabsurl("file.md") === false
    @test Documenter.isabsurl("../file.md") === false
    @test Documenter.isabsurl(".") === false
    @test Documenter.isabsurl("https://example.org/file.md") === true
    @test Documenter.isabsurl("http://example.org") === true
    @test Documenter.isabsurl("ftp://user:pw@example.org") === true
    @test Documenter.isabsurl("/fs/absolute/path") === false

    @test Documenter.doccat(UnitTests) == "Module"
    @test Documenter.doccat(UnitTests.T) == "Type"
    @test Documenter.doccat(UnitTests.S) == "Type"
    @test Documenter.doccat(UnitTests.f) == "Function"
    @test Documenter.doccat(UnitTests.pi) == "Constant"
    @test Documenter.doccat(UnitTests.TA) == "Type"
    @test Documenter.doccat(UnitTests.TB) == "Type"
    @test Documenter.doccat(UnitTests.TC) == "Type"

    let b = Base.Docs.Binding(Base, Symbol(":")), obj = Documenter.Object(b, Union{})
        @test Documenter.bindingstring(b) == "Base.:(:)"
        @test string(obj) == "Base.:(:)"
        @test Documenter.slugify(obj) == "Base.:(:)"
    end
    let b = Base.Docs.Binding(Base, Symbol("==")), obj = Documenter.Object(b, Union{})
        @test Documenter.bindingstring(b) == "Base.:(==)"
        @test string(obj) == "Base.:(==)"
        @test Documenter.slugify(obj) == "Base.:(==)"
    end
    let b = Base.Docs.Binding(Base, Symbol("+")), obj = Documenter.Object(b, Union{})
        @test Documenter.bindingstring(b) == "Base.:+"
        @test string(obj) == "Base.:+"
        @test Documenter.slugify(obj) == "Base.:+"
    end
    let b = Base.Docs.Binding(Base, :sin), obj = Documenter.Object(b, Union{})
        @test Documenter.bindingstring(b) == "Base.sin"
        @test string(obj) == "Base.sin"
        @test Documenter.slugify(obj) == "Base.sin"
    end

    # repo type
    @test Documenter.repo_host_from_url("https://bitbucket.org/somerepo") == Documenter.RepoBitbucket
    @test Documenter.repo_host_from_url("https://www.bitbucket.org/somerepo") == Documenter.RepoBitbucket
    @test Documenter.repo_host_from_url("http://bitbucket.org/somethingelse") == Documenter.RepoBitbucket
    @test Documenter.repo_host_from_url("http://github.com/Whatever") == Documenter.RepoGithub
    @test Documenter.repo_host_from_url("https://github.com/Whatever") == Documenter.RepoGithub
    @test Documenter.repo_host_from_url("https://www.github.com/Whatever") == Documenter.RepoGithub
    @test Documenter.repo_host_from_url("https://gitlab.com/Whatever") == Documenter.RepoGitlab
    @test Documenter.repo_host_from_url("https://dev.azure.com/Whatever") == Documenter.RepoAzureDevOps

    # line range
    let formatting = Documenter.LineRangeFormatting(Documenter.RepoGithub)
        @test Documenter.format_line(1:1, formatting) == "L1"
        @test Documenter.format_line(123:123, formatting) == "L123"
        @test Documenter.format_line(2:5, formatting) == "L2-L5"
        @test Documenter.format_line(100:9999, formatting) == "L100-L9999"
    end

    let formatting = Documenter.LineRangeFormatting(Documenter.RepoGitlab)
        @test Documenter.format_line(1:1, formatting) == "L1"
        @test Documenter.format_line(123:123, formatting) == "L123"
        @test Documenter.format_line(2:5, formatting) == "L2-5"
        @test Documenter.format_line(100:9999, formatting) == "L100-9999"
    end

    let formatting = Documenter.LineRangeFormatting(Documenter.RepoBitbucket)
        @test Documenter.format_line(1:1, formatting) == "1"
        @test Documenter.format_line(123:123, formatting) == "123"
        @test Documenter.format_line(2:5, formatting) == "2:5"
        @test Documenter.format_line(100:9999, formatting) == "100:9999"
    end

    let formatting = Documenter.LineRangeFormatting(Documenter.RepoAzureDevOps)
        @test Documenter.format_line(1:1, formatting) == "&line=1"
        @test Documenter.format_line(123:123, formatting) == "&line=123"
        @test Documenter.format_line(2:5, formatting) == "&line=2&lineEnd=5"
        @test Documenter.format_line(100:9999, formatting) == "&line=100&lineEnd=9999"
    end

    @test Documenter.linerange(Core.svec(), 0) === 0:0

    # commit format
    @test Documenter.format_commit("7467441e33e2bd586fb0ec80ed4c4cdef5068f6a", Documenter.RepoGithub) == "7467441e33e2bd586fb0ec80ed4c4cdef5068f6a"
    @test Documenter.format_commit("test", Documenter.RepoGithub) == "test"
    @test Documenter.format_commit("7467441e33e2bd586fb0ec80ed4c4cdef5068f6a", Documenter.RepoGitlab) == "7467441e33e2bd586fb0ec80ed4c4cdef5068f6a"
    @test Documenter.format_commit("test", Documenter.RepoGitlab) == "test"
    @test Documenter.format_commit("7467441e33e2bd586fb0ec80ed4c4cdef5068f6a", Documenter.RepoBitbucket) == "7467441e33e2bd586fb0ec80ed4c4cdef5068f6a"
    @test Documenter.format_commit("test", Documenter.RepoBitbucket) == "test"
    @test Documenter.format_commit("7467441e33e2bd586fb0ec80ed4c4cdef5068f6a", Documenter.RepoAzureDevOps) == "GC7467441e33e2bd586fb0ec80ed4c4cdef5068f6a"
    @test Documenter.format_commit("test", Documenter.RepoAzureDevOps) == "GBtest"

    # URL building
    filepath = string(first(methods(Documenter.source_url)).file)
    Sys.iswindows() && (filepath = replace(filepath, "/" => "\\")) # work around JuliaLang/julia#26424
    let expected_filepath = "/src/documents.jl"
        Sys.iswindows() && (expected_filepath = replace(expected_filepath, "/" => "\\"))
        @test endswith(filepath, expected_filepath)
    end

    repo_root(filepath) = Documenter.find_root_parent(Documenter.is_git_repo_root, filepath)
    repo_root(filepath, dbdir) = Documenter.find_root_parent(d -> Documenter.is_git_repo_root(d; dbdir), filepath)

    @quietly @testset "repo_commit" begin
        mktempdir() do path
            cd(path) do
                @test_throws Documenter.RepoCommitError Documenter.repo_commit(path)
                @test trun(`$(git()) init`)
                @test git_config()
                @test_throws Documenter.RepoCommitError Documenter.repo_commit(path)
                touch("foo")
                @test trun(`$(git()) add -A`)
                @test trun(`$(git()) commit -m 1234`)
                @test Documenter.repo_commit(path) isa AbstractString
                mkdir("bar")
                @test_throws Documenter.RepoCommitError Documenter.repo_commit(joinpath(path, "bar"))
            end
        end
    end

    mktempdir() do path
        remote = Documenter.Remotes.URL("//blob/{commit}{path}#{line}")
        path_repo = joinpath(path, "repository")
        mkpath(path_repo)
        cd(path_repo) do
            # Create a simple mock repo in a temporary directory with a single file.
            @test trun(`$(git()) init`)
            @test git_config()
            @test trun(`$(git()) remote add origin git@github.com:JuliaDocs/Documenter.jl.git`)
            mkpath("src")
            filepath = abspath(joinpath("src", "SourceFile.jl"))
            write(filepath, "X")
            @test trun(`$(git()) add -A`)
            @test trun(`$(git()) commit -m"Initial commit."`)

            # Run tests
            commit = Documenter.repo_commit(path_repo)
            doc = Documenter.Document(root = pwd(), remotes = Dict(pwd() => remote))

            @test Documenter.edit_url(doc, filepath; rev = nothing) == "//blob/$(commit)/src/SourceFile.jl#"
            # The '//blob/..' remote conflicts with the github.com origin.url of the repository and source_url()
            # picks the wrong remote currently ()
            @test Documenter.source_url(doc, Documenter, filepath, 10:20) == "//blob/$(commit)/src/SourceFile.jl#L10-L20"

            # repo_root & relpath_from_repo_root
            @test repo_root(filepath) == realpath(joinpath(dirname(filepath), ".."))
            @test repo_root(filepath, ".svn") === nothing
            let remoteref = Documenter.relpath_from_remote_root(doc, filepath)
                @test remoteref.repo.remote === remote
                @test remoteref.relpath == joinpath("src", "SourceFile.jl")
            end
            # We assume that a temporary file is not in a repo
            @test_throws ArgumentError repo_root(tempname())
            @test_throws ErrorException Documenter.relpath_from_remote_root(doc, tempname())
        end

        # Test worktree
        path_worktree = joinpath(path, "worktree")
        cd("$(path_repo)") do
            @test trun(`$(git()) worktree add $(path_worktree)`)
        end
        cd(path_worktree) do
            filepath = abspath(joinpath("src", "SourceFile.jl"))
            # Run tests
            commit = Documenter.repo_commit(path_worktree)
            doc = Documenter.Document(root = pwd(), remotes = Dict(pwd() => remote))

            @test Documenter.edit_url(doc, filepath; rev = nothing) == "//blob/$(commit)/src/SourceFile.jl#"
            @test Documenter.source_url(doc, Documenter, filepath, 10:20) == "//blob/$(commit)/src/SourceFile.jl#L10-L20"

            # repo_root & relpath_from_repo_root
            @test repo_root(filepath) == realpath(joinpath(dirname(filepath), ".."))
            @test repo_root(filepath, ".svn") === nothing
            let remoteref = Documenter.relpath_from_remote_root(doc, filepath)
                @test remoteref.repo.remote === remote
                @test remoteref.relpath == joinpath("src", "SourceFile.jl")
            end
            # We assume that a temporary file is not in a repo
            @test_throws ArgumentError repo_root(tempname())
            @test_throws ErrorException Documenter.relpath_from_remote_root(doc, tempname())
        end

        # Test submodule
        path_submodule = joinpath(path, "submodule")
        mkpath(path_submodule)
        cd(path_submodule) do
            @test trun(`$(git()) init`)
            @test git_config()
            # NOTE: the target path in the `git submodule add` command is necessary for
            # Windows builds, since otherwise Git claims that the path is in a .gitignore
            # file.
            #
            # protocol.file.allow=always is necessary to work around a changed default
            # setting that was changed due to a security flaw.
            # See: https://bugs.launchpad.net/ubuntu/+source/git/+bug/1993586
            @test trun(`$(git()) -c protocol.file.allow=always submodule add $(path_repo) repository`)
            @test trun(`$(git()) add -A`)
            @test trun(`$(git()) commit -m"Initial commit."`)
        end
        path_submodule_repo = joinpath(path, "submodule", "repository")
        @test isdir(path_submodule_repo)
        cd(path_submodule_repo) do
            filepath = abspath(joinpath("src", "SourceFile.jl"))
            # Run tests
            commit = Documenter.repo_commit(path_submodule_repo)
            doc = Documenter.Document(root = pwd(), remotes = Dict(pwd() => remote))

            @test isfile(filepath)

            @test Documenter.edit_url(doc, filepath; rev = nothing) == "//blob/$(commit)/src/SourceFile.jl#"
            @test Documenter.source_url(doc, Documenter, filepath, 10:20) == "//blob/$(commit)/src/SourceFile.jl#L10-L20"

            # repo_root & relpath_from_repo_root
            @test repo_root(filepath) == realpath(joinpath(dirname(filepath), ".."))
            @test repo_root(filepath, ".svn") === nothing
            let remoteref = Documenter.relpath_from_remote_root(doc, filepath)
                @test remoteref.repo.remote === remote
                @test remoteref.relpath == joinpath("src", "SourceFile.jl")
            end
            # We assume that a temporary file is not in a repo
            @test_throws ArgumentError repo_root(tempname())
            @test_throws ErrorException Documenter.relpath_from_remote_root(doc, tempname())
        end

        # This tests the case where the origin.url is some unrecognised Git hosting service, in which case we are unable
        # to parse the remote out of the origin.url value and we fallback to the user-provided remote.
        path_repo_github = joinpath(path, "repository-not-github")
        mkpath(path_repo_github)
        cd(path_repo_github) do
            # Create a simple mock repo in a temporary directory with a single file.
            @test trun(`$(git()) init`)
            @test git_config()
            @test trun(`$(git()) remote add origin git@this-is-not-github.com:JuliaDocs/Documenter.jl.git`)
            mkpath("src")
            filepath = abspath(joinpath("src", "SourceFile.jl"))
            write(filepath, "X")
            @test trun(`$(git()) add -A`)
            @test trun(`$(git()) commit -m"Initial commit."`)

            # Run tests
            commit = Documenter.repo_commit(path_repo_github)
            doc = Documenter.Document(root = pwd(), remotes = Dict(pwd() => remote))
            @test Documenter.edit_url(doc, filepath; rev = nothing) == "//blob/$(commit)/src/SourceFile.jl#"
            @test Documenter.source_url(doc, Documenter, filepath, 10:20) == "//blob/$(commit)/src/SourceFile.jl#L10-L20"
        end
    end

    import Documenter: Document, Page, Globals
    let page = Page("source", "build", :build, [], Globals(), MarkdownAST.@ast MarkdownAST.Document()), doc = Document()
        code = """
        x += 3
        γγγ_γγγ
        γγγ
        """
        exprs = Documenter.parseblock(code, doc, page)

        @test isa(exprs, Vector)
        @test length(exprs) === 3

        @test isa(exprs[1][1], Expr)
        @test exprs[1][1].head === :+=
        @test exprs[1][2] == "x += 3\n"

        @test exprs[2][2] == "γγγ_γγγ\n"

        @test exprs[3][1] === :γγγ
        if bad_juliasyntax_version()
            @test exprs[3][2] == "γγγ\n\n"
        else
            @test exprs[3][2] == "γγγ\n"
        end
    end

    @testset "TextDiff" begin
        import Documenter.TextDiff: splitby
        @test splitby(r"\s+", "X Y  Z") == ["X ", "Y  ", "Z"]
        @test splitby(r"[~]", "X~Y~Z") == ["X~", "Y~", "Z"]
        @test splitby(r"[▶]", "X▶Y▶Z") == ["X▶", "Y▶", "Z"]
        @test splitby(r"[▶]+", "X▶▶Y▶Z▶") == ["X▶▶", "Y▶", "Z▶"]
        @test splitby(r"[▶]+", "▶▶Y▶Z▶") == ["▶▶", "Y▶", "Z▶"]
        @test splitby(r"[▶]+", "Ω▶▶Y▶Z▶") == ["Ω▶▶", "Y▶", "Z▶"]
        @test splitby(r"[▶]+", "Ω▶▶Y▶Z▶κ") == ["Ω▶▶", "Y▶", "Z▶", "κ"]
    end

    @testset "issues #749, #790, #823" begin
        let parse(x) = Documenter.parseblock(x, nothing, nothing)
            for LE in ("\r\n", "\n")
                l1, l2 = parse("x = Int[]$(LE)$(LE)push!(x, 1)$(LE)")
                @test l1[1] == :(x = Int[])
                @test l2[1] == :(push!(x, 1))
                if bad_juliasyntax_version()
                    @test l1[2] == "x = Int[]$(LE)$(LE)"
                    @test l2[2] == "push!(x, 1)$(LE)\n"
                else
                    @test l1[2] == "x = Int[]$(LE)"
                    @test l2[2] == "push!(x, 1)$(LE)"
                end
            end
        end
    end

    @testset "PR #1634, issue #1655" begin
        let parse(x) = Documenter.parseblock(
                x, nothing, nothing;
                linenumbernode = LineNumberNode(123, "testfile.jl")
            )
            code = """
            1 + 1
            2 + 2
            """
            exs = parse(code)
            @test length(exs) == 2
            @test exs[1][2] == "1 + 1\n"
            @test exs[1][1].head == :toplevel
            @test exs[1][1].args[1] == LineNumberNode(124, "testfile.jl")
            @test exs[1][1].args[2] == Expr(:call, :+, 1, 1)
            if bad_juliasyntax_version()
                @test exs[2][2] == "2 + 2\n\n"
            else
                @test exs[2][2] == "2 + 2\n"
            end
            @test exs[2][1].head == :toplevel
            @test exs[2][1].args[1] == LineNumberNode(125, "testfile.jl")
            @test exs[2][1].args[2] == Expr(:call, :+, 2, 2)

            # corner case trailing whitespace
            code1 = """
            1 + 1

            """
            # corner case: trailing comment
            code2 = """
            1 + 1
            # comment
            """
            for code in (code1, code2)
                exs = parse(code)
                @test length(exs) == 1
                if bad_juliasyntax_version()
                    if code == code1
                        @test exs[1][2] == "1 + 1\n\n\n"
                    else
                        @test exs[1][2] == "1 + 1\n# comment\n\n"
                    end
                else
                    @test exs[1][2] == "1 + 1\n"
                end
                @test exs[1][1].head == :toplevel
                @test exs[1][1].args[1] == LineNumberNode(124, "testfile.jl")
                @test exs[1][1].args[2] == Expr(:call, :+, 1, 1)
            end
        end
    end

    @testset "mdparse" begin
        mdparse = Documenter.mdparse

        @test_throws ArgumentError mdparse("", mode = :foo)

        @test mdparse("") == [
            MarkdownAST.@ast MarkdownAST.Paragraph() do
                ""
            end
        ]
        @test mdparse("foo bar") == [
            MarkdownAST.@ast MarkdownAST.Paragraph() do
                "foo bar"
            end
        ]
        @test mdparse("", mode = :span) == [
            MarkdownAST.@ast(MarkdownAST.Text("")),
        ]
        @test mdparse("", mode = :blocks) == []

        # Note: Markdown.parse() does not put any child nodes into admonition.contents
        # unless there is something non-empty there, which in turn means that the
        # MarkdownAST Admonition node has no children.
        @test mdparse("!!! adm"; mode = :single) == [
            MarkdownAST.@ast MarkdownAST.Admonition("adm", "Adm")
        ]
        @test mdparse("!!! adm"; mode = :blocks) == [
            MarkdownAST.@ast MarkdownAST.Admonition("adm", "Adm")
        ]
        @test mdparse("x\n\ny", mode = :blocks) == [
            MarkdownAST.@ast(
                MarkdownAST.Paragraph() do
                    "x"
                end
            ),
            MarkdownAST.@ast(
                MarkdownAST.Paragraph() do
                    "y"
                end
            ),
        ]

        @quietly begin
            @test_throws ArgumentError mdparse("!!! adm", mode = :span)
            @test_throws ArgumentError mdparse("x\n\ny")
            @test_throws ArgumentError mdparse("x\n\ny", mode = :span)
        end
    end

    @testset "JSDependencies" begin
        using Documenter.JSDependencies:
            RemoteLibrary, Snippet, RequireJS, verify, writejs, parse_snippet
        libraries = [
            RemoteLibrary("foo", "example.com/foo"),
            RemoteLibrary("bar", "example.com/bar"; deps = ["foo"]),
        ]
        snippet = Snippet(["foo", "bar"], ["Foo"], "f(x)")
        let r = RequireJS(libraries)
            push!(r, snippet)
            @test verify(r)
            output = let io = IOBuffer()
                writejs(io, r)
                String(take!(io))
            end
            # The expected output should look something like this:
            #
            #   // Generated by Documenter.jl
            #   requirejs.config({
            #     paths: {
            #       'bar': 'example.com/bar',
            #       'foo': 'example.com/foo',
            #     },
            #     shim: {
            #     "bar": {
            #       "deps": [
            #         "foo"
            #       ]
            #     }
            #   }
            #   });
            #   ////////////////////////////////////////////////////////////////////////////////
            #   require(['foo', 'bar'], function(Foo) {
            #   f(x)
            #   })
            #
            # But the output is not entirely deterministic, so we can't do just a string
            # comparison. Hence, we'll just do a few simple `occursin` tests, to make sure
            # that the most important things are at least present.
            @test occursin("'foo'", output)
            @test occursin("'bar'", output)
            @test occursin("example.com/foo", output)
            @test occursin("example.com/bar", output)
            @test occursin("f(x)", output)
            @test occursin(r"requirejs\.config\({[\S\s]+}\)", output)
            @test occursin(r"require\([\S\s]+\)", output)
        end
        # Error conditions: missing dependency
        let r = RequireJS(
                [
                    RemoteLibrary("foo", "example.com/foo"),
                    RemoteLibrary("bar", "example.com/bar"; deps = ["foo", "baz"]),
                ]
            )
            @test !verify(r)
            push!(r, RemoteLibrary("baz", "example.com/baz"))
            @test verify(r)
            push!(r, Snippet(["foo", "qux"], ["Foo"], "f(x)"))
            @test !verify(r)
            push!(r, RemoteLibrary("qux", "example.com/qux"))
            @test verify(r)
        end

        let io = IOBuffer(
                raw"""
                // libraries: foo, bar
                // arguments: $
                script
                """
            )
            snippet = parse_snippet(io)
            @test snippet.deps == ["foo", "bar"]
            @test snippet.args == ["\$"]
            @test snippet.js == "script\n"
        end

        # jsescape
        @testset "jsescape" begin
            using Documenter.JSDependencies: jsescape
            @test jsescape("abc123") == "abc123"
            @test jsescape("▶αβγ") == "▶αβγ"
            @test jsescape("") == ""

            @test jsescape("a\nb") == "a\\nb"
            @test jsescape("\r\n") == "\\r\\n"
            @test jsescape("\\") == "\\\\"

            @test jsescape("\"'") == "\\\"\\'"

            # Ref: #639
            @test jsescape("\u2028") == "\\u2028"
            @test jsescape("\u2029") == "\\u2029"
            include("utilities.sample.jl")
            @test jsescape(U2028_STRING) == "policy to\\u2028 delete."
        end

        @testset "json_jsescape" begin
            using Documenter.JSDependencies: json_jsescape
            @test json_jsescape(["abc"]) == raw"[\"abc\"]"
            @test json_jsescape(["\\"]) == raw"[\"\\\\\"]"
            @test json_jsescape(["x\u2028y"]) == raw"[\"x\u2028y\"]"
        end

        # Proper escaping of generated JS
        let r = RequireJS(
                [
                    RemoteLibrary("fo\'o", "example.com\n/foo"),
                ]
            )
            @test verify(r)
            push!(r, Snippet(["fo\'o"], ["Foo"], "f(x)"))
            output = let io = IOBuffer()
                writejs(io, r)
                String(take!(io))
            end
            @test occursin("'fo\\'o'", output)
            @test occursin("example.com\\n/foo", output)
            @test !occursin("'fo'o'", output)
            @test !occursin("example.com\n/foo", output)
        end
    end

    @testset "find_block_in_file" begin
        # The Markdown parser hands over the block body without the surrounding
        # fences and with the indentation of nested blocks stripped.
        markdown = """
        # Title

        ```julia
        f(x) = 2x
        ```

        - a list item

          ```@example
          g(y) = y
          h(z) = z
          ```

        > ```@repl
        > k = 1
        > ```

        !!! note
            ```@raw html
            <p>hi</p>
            ```
        """
        mktempdir() do dir
            file = joinpath(dir, "index.md")
            write(file, markdown)

            # the returned range covers the fences, not the body
            @test Documenter.find_block_in_file("f(x) = 2x", file) == (3 => 5)
            @test Documenter.find_block_in_file("g(y) = y\nh(z) = z", file) == (9 => 12)
            @test Documenter.find_block_in_file("k = 1", file) == (14 => 16)
            @test Documenter.find_block_in_file("<p>hi</p>", file) == (19 => 21)

            @test Documenter.find_block_in_file("not in the file", file) === nothing
            @test Documenter.find_block_in_file("", file) === nothing
            @test Documenter.find_block_in_file("f(x) = 2x", joinpath(dir, "nope.md")) === nothing

            crlf = joinpath(dir, "crlf.md")
            write(crlf, replace(markdown, "\n" => "\r\n"))
            @test Documenter.find_block_in_file("f(x) = 2x", crlf) == (3 => 5)

            # a block far too large to compile into a regex (issue #2992)
            huge = join(("<div>line $(i)</div>" for i in 1:5000), "\n")
            hugefile = joinpath(dir, "huge.md")
            write(hugefile, "# Title\n\n```@raw html\n$(huge)\n```\n")
            @test Documenter.find_block_in_file(huge, hugefile) == (3 => 5004)
        end
    end

    @testset "codelang" begin
        @test Documenter.codelang("") == ""
        @test Documenter.codelang(" ") == ""
        @test Documenter.codelang("  ") == ""
        @test Documenter.codelang("\t  ") == ""
        @test Documenter.codelang("julia") == "julia"
        @test Documenter.codelang("julia-repl") == "julia-repl"
        @test Documenter.codelang("julia-repl x=y") == "julia-repl"
        @test Documenter.codelang("julia-repl\tx=y") == "julia-repl"
        @test Documenter.codelang(" julia-repl\tx=y") == "julia-repl"
        @test Documenter.codelang("\t julia   \tx=y ") == "julia"
        @test Documenter.codelang("\t julia   \tx=y ") == "julia"
        @test Documenter.codelang("&%^ ***") == "&%^"
    end

    @testset "parse fenced code block language" begin
        @test Documenter.parse_codelang(MarkdownAST.CodeBlock("jldoctest", "julia> 1+1")) ==
            ("jldoctest", nothing, nothing)
        @test Documenter.parse_codelang(MarkdownAST.CodeBlock("@setup NAME ; arg1=val1, arg2=val2", "")) ==
            ("@setup", "NAME", "arg1=val1, arg2=val2")
        @test Documenter.parse_codelang(MarkdownAST.CodeBlock("@eval ; ans = 42", "")) ==
            ("@eval", nothing, "ans = 42")
        @test Documenter.parse_codelang(MarkdownAST.CodeBlock(" ; ans = 42", "")) === nothing

        dummy_doc = Documenter.Document(; warnonly = [:parse_error])
        dummy_block = MarkdownAST.CodeBlock("@setup NAME ; arg1=1", "")
        @test Documenter.parse_kwargs("@setup", nothing, dummy_block, dummy_doc, "dummy.md") ==
            Dict{Symbol, Any}()
        @test Documenter.parse_kwargs(
            "@setup", "arg1=1, arg2=:sym, arg3=(x + 1)", dummy_block, dummy_doc, "dummy.md"
        ) == Dict{Symbol, Any}(:arg1 => 1, :arg2 => QuoteNode(:sym), :arg3 => :(x + 1))

        @test Documenter.parse_kwargs("@setup", "arg1 = ", dummy_block, dummy_doc, "dummy.md") === nothing
        @test :parse_error ∈ dummy_doc.internal.errors
        empty!(dummy_doc.internal.errors)
        @test Documenter.parse_kwargs("@setup", "foo.bar = 1", dummy_block, dummy_doc, "dummy.md") === nothing
        @test :parse_error ∈ dummy_doc.internal.errors

        logger = Test.TestLogger()
        success, name, kwargs = with_logger(logger) do
            Documenter.parse_codeblock_args(
                "@example",
                MarkdownAST.CodeBlock("@example NAME ; continued = true, ansicolor = false, typo = 1", ""),
                dummy_doc,
                "dummy.md";
                allow_name = true,
                allowed_kwargs = [:continued, :ansicolor],
                bool_kwargs = [:continued, :ansicolor],
            )
        end
        @test success
        @test name == "NAME"
        @test kwargs == Dict{Symbol, Any}(:continued => true, :ansicolor => false)
        @test [(log.level, log.message) for log in logger.logs] == [
            (Warn, "In dummy.md: `@example` block has an unsupported keyword argument: typo"),
        ]
    end

    @testset "validate fenced code block arguments" begin
        name, kwargs = @test_logs (
            :warn, "In dummy.md: `@docs` block does not support a name; ignoring `NAME`.",
        ) Documenter.validate_codeblock_args(
            "@docs", "NAME", Dict{Symbol, Any}(), "dummy.md";
            allow_name = false,
            allowed_kwargs = Symbol[],
        )
        @test name === nothing
        @test kwargs == Dict{Symbol, Any}()

        logger = Test.TestLogger()
        name, kwargs = with_logger(logger) do
            Documenter.validate_codeblock_args(
                "@example", "NAME",
                Dict{Symbol, Any}(:continued => true, :typo => true, :ansicolor => QuoteNode(:blue)),
                "dummy.md";
                allow_name = true,
                allowed_kwargs = [:continued, :ansicolor],
                bool_kwargs = [:continued, :ansicolor],
            )
        end
        @test [(log.level, log.message) for log in logger.logs] == [
            (Warn, "In dummy.md: `@example` block has an unsupported keyword argument: typo"),
            (Warn, "In dummy.md: `@example` block keyword argument `ansicolor` must be `true` or `false`; ignoring :blue"),
        ]
        @test name == "NAME"
        @test kwargs == Dict{Symbol, Any}(:continued => true)
    end

    @testset "check_strict_kw" begin
        @test Documenter.reduce_warnonly(:setup_block) == [:setup_block]
        @test Documenter.reduce_warnonly(:doctest) == [:doctest]
        @test Documenter.reduce_warnonly([:doctest, :setup_block]) == [:doctest, :setup_block]
        @test Documenter.reduce_warnonly([]) == Symbol[]
        @test Documenter.reduce_warnonly(false) == Symbol[]
        @test Documenter.reduce_warnonly(true) == Documenter.ERROR_NAMES
        @test_throws ArgumentError Documenter.reduce_warnonly(:a)
        @test_throws ArgumentError Documenter.reduce_warnonly([:a, :doctest])
    end

    @testset "warnonly" begin
        @test_throws ArgumentError Documenter.Document(; warnonly = :a)
        @test_throws ArgumentError Documenter.Document(; warnonly = [:a, :b])
        let doc = Documenter.Document(; warnonly = false)
            @test Documenter.is_strict(doc, :doctest)
            @test Documenter.is_strict(doc, :setup_block)
            @test_throws ArgumentError Documenter.is_strict(doc, :a)
        end
        let doc = Documenter.Document(; warnonly = true)
            @test !Documenter.is_strict(doc, :doctest)
            @test !Documenter.is_strict(doc, :setup_block)
            @test_throws ArgumentError Documenter.is_strict(doc, :a)
        end
        let doc = Documenter.Document(; warnonly = :doctest)
            @test !Documenter.is_strict(doc, :doctest)
            @test Documenter.is_strict(doc, :setup_block)
            @test_throws ArgumentError Documenter.is_strict(doc, :a)
        end
        let doc = Documenter.Document(; warnonly = [:doctest])
            @test !Documenter.is_strict(doc, :doctest)
            @test Documenter.is_strict(doc, :setup_block)
            @test_throws ArgumentError Documenter.is_strict(doc, :a)
        end
    end

    @testset "@docerror" begin
        doc = Documenter.Document(; warnonly = [:meta_block, :setup_block])
        foo = 123
        @test_logs (:warn, "meta_block issue 123") (Documenter.@docerror(doc, :meta_block, "meta_block issue $foo"))
        @test :meta_block ∈ doc.internal.errors
        @test_logs (:error, "doctest issue 123") (Documenter.@docerror(doc, :doctest, "doctest issue $foo"))
        @test :doctest ∈ doc.internal.errors
        try
            @macroexpand Documenter.@docerror(doc, :foo, "invalid tag")
            error("unexpected")
        catch err
            err isa LoadError && (err = err.error)
            @test err isa ArgumentError
            @test err.msg == "tag :foo is not a valid Documenter error"
        end
    end

    @testset "git_remote_head_branch" begin

        function git_create_bare_repo(path; head = nothing)
            mkdir(path)
            @test trun(`$(git()) -C $(path) init --bare`)
            @test isfile(joinpath(path, "HEAD"))
            if head !== nothing
                write(
                    joinpath(path, "HEAD"), """
                    ref: refs/heads/$(head)
                    """
                )
            end
            mktempdir() do subdir_path
                # We need to commit something to the non-standard branch to actually
                # "activate" the non-standard HEAD:
                head = (head === nothing) ? "master" : head
                @test trun(`$(git()) clone $(path) $(subdir_path)`)
                @test git_config(subdir_path)
                @test trun(`$(git()) -C $(subdir_path) checkout -b $(head)`)
                @test trun(`$(git()) -C $(subdir_path) commit --allow-empty -m"initial empty commit"`)
                @test trun(`$(git()) -C $(subdir_path) push --set-upstream origin $(head)`)
            end
        end

        mktempdir() do path
            cd(path) do
                # Note: running @test_logs with match_mode=:any here so that the tests would
                # also pass when e.g. JULIA_DEBUG=Documenter when the tests are being run.
                # If there is no parent remote repository, we should get a warning and the fallback value:
                @test (@test_logs (:warn,) match_mode = :any Documenter.git_remote_head_branch(".", pwd(); fallback = "fallback")) == "fallback"
                @test (@test_logs (:warn,) match_mode = :any Documenter.git_remote_head_branch(".", pwd())) == "master"
                # We'll set up two "remote" bare repositories with non-standard HEADs:
                git_create_bare_repo("barerepo", head = "maindevbranch")
                git_create_bare_repo("barerepo_other", head = "main")
                # Clone barerepo and test git_remote_head_branch:
                @test trun(`$(git()) clone barerepo/ local/`)
                @test Documenter.git_remote_head_branch(".", "local") == "maindevbranch"
                # Now, let's add the other repo as another remote, and fetch the HEAD for that:
                @test trun(`$(git()) -C local/ remote add other ../barerepo_other/`)
                @test trun(`$(git()) -C local/ fetch other`)
                @test Documenter.git_remote_head_branch(".", "local") == "maindevbranch"
                @test Documenter.git_remote_head_branch(".", "local"; remotename = "other") == "main"
                # Asking for a nonsense remote should also warn and drop back to fallback:
                @test (@test_logs (:warn,) match_mode = :any Documenter.git_remote_head_branch(".", pwd(); remotename = "nonsense", fallback = "fallback")) == "fallback"
                @test (@test_logs (:warn,) match_mode = :any Documenter.git_remote_head_branch(".", pwd(); remotename = "nonsense")) == "master"
            end
        end
    end

    using Documenter: remove_common_backtrace
    @testset "remove_common_backtrace" begin
        @test remove_common_backtrace([], []) == []
        @test remove_common_backtrace([1], []) == [1]
        @test remove_common_backtrace([1, 2], []) == [1, 2]
        @test remove_common_backtrace([1, 2, 3], [1]) == [1, 2, 3]
        @test remove_common_backtrace([1, 2, 3], [2]) == [1, 2, 3]
        @test remove_common_backtrace([1, 2, 3], [3]) == [1, 2]
        @test remove_common_backtrace([1, 2, 3], [2, 3]) == [1]
        @test remove_common_backtrace([1, 2, 3], [1, 3]) == [1, 2]
        @test remove_common_backtrace([1, 2, 3], [1, 2, 3]) == []
        @test remove_common_backtrace([1, 2, 3], [0, 1, 2, 3]) == []
    end

    @testset "slugify" begin
        for (test, answer) in [
                # Nonstrings get converted to strings
                1 => "1",
                # Good strings stay good
                "a" => "a",
                "my-heading" => "my-heading",
                "documenter.jl/abc" => "documenter.jl/abc",
                "https://documenter.jl/abc" => "https://documenter.jl/abc",
                "2nd" => "2nd",
                "2nd-2" => "2nd-2",
                "123" => "123",
                "123a" => "123a",
                # Spaces get replaced by -
                "2nd feature" => "2nd-feature",
                # & gets replaced by -and-
                "a & b" => "a-and-b",
                # Multiple -- are reduced
                "a---b" => "a-b",
                # Leading and trailing - are stripped
                "-a---b-" => "a-b",
                # A combination of things
                "   a & b" => "a-and-b",
                "--a & b" => "a-and-b",
                # Non letter, punctuation, digit, or `-` characters are removed
                "a\0a" => "aa",
            ]
            @test Documenter.slugify(test) == answer
        end
    end
end

end

"""
Generate the `objects.inv` inventory file.

Write the file `objects.inv` to the root of the HTML build folder, containing an
inventory of all linkable targets in the documentation (pages, headings, and docstrings).

The `objects.inv` file is compatible with [Sphinx](https://www.sphinx-doc.org/en/master/index.html)
See [DocInventories](https://juliadocs.org/DocInventories.jl/stable/formats/) for a
description. The file can be used by [Intersphinx](https://www.sphinx-doc.org/en/master/usage/extensions/intersphinx.html)
and the [DocumenterInterLinks](https://github.com/JuliaDocs/DocumenterInterLinks.jl/)
plugin to link into the documentation from other projects.
"""
function write_inventory(doc, ctx)

    project = doc.user.sitename
    version = ctx.settings.inventory_version
    if isnothing(version)
        project_toml = joinpath(dirname(doc.user.root), "Project.toml")
        version = _get_inventory_version(project_toml)
    end

    io_inv_header = open(joinpath(doc.user.build, "objects.inv"), "w")

    write(io_inv_header, "# Sphinx inventory version 2\n")
    write(io_inv_header, "# Project: $project\n")
    write(io_inv_header, "# Version: $version\n")
    write(io_inv_header, "# The remainder of this file is compressed using zlib.\n")
    io_inv = ZlibCompressorStream(io_inv_header)

    domain = "std"
    role = "doc"
    priority = -1
    for navnode in doc.internal.navlist
        name = replace(splitext(navnode.page)[1], "\\" => "/")
        uri = _get_inventory_uri(doc, ctx, navnode)
        dispname = _get_inventory_dispname(doc, ctx, navnode)
        line = "$name $domain:$role $priority $uri $dispname\n"
        write(io_inv, line)
    end

    domain = "std"
    role = "label"
    priority = -1
    for name in keys(doc.internal.headers.map)
        isempty(name) && continue  # skip empty heading
        anchor = Documenter.anchor(doc.internal.headers, name)
        if isnothing(anchor)
            # anchor not unique -> exclude from inventory
            continue
        end
        uri = _get_inventory_uri(doc, ctx, name, anchor)
        dispname = _get_inventory_dispname(doc, ctx, name, anchor)
        line = "$name $domain:$role $priority $uri $dispname\n"
        write(io_inv, line)
    end

    domain = "jl"
    priority = 1
    for name in keys(doc.internal.docs.map)
        anchor = Documenter.anchor(doc.internal.docs, name)
        if isnothing(anchor)
            # anchor not unique -> exclude from inventory
            continue
        end
        uri = _get_inventory_uri(doc, ctx, name, anchor)
        role = lowercase(Documenter.doccat(anchor.object))
        dispname = "-"
        line = "$name $domain:$role $priority $uri $dispname\n"
        write(io_inv, line)
    end

    close(io_inv)
    close(io_inv_header)
    return
end


function _get_inventory_version(project_toml)
    version = ""
    if isfile(project_toml)
        project_data = TOML.parsefile(project_toml)
        if haskey(project_data, "version")
            version = project_data["version"]
            @info "Automatic `version=$(repr(version))` for inventory from $(relpath(project_toml))"
        else
            @warn "Cannot extract version for inventory from $(project_toml): no version information"
        end
    else
        @warn "Cannot extract version for inventory from $(project_toml): no such file"
    end
    if isempty(version)
        # The automatic `inventory_version` determined in this function is intended only for
        # projects with a standard layout with Project.toml file in the expected
        # location (the parent folder of doc.user.root). Any non-standard project should
        # explicitly set an `inventory_version` as an option to `HTML()` in `makedocs`, or
        # specifically set `inventory_version=""` so that `_get_inventory_version` is never
        # called, and thus this warning is suppressed.
        @warn "Please set `inventory_version` in the `HTML()` options passed to `makedocs`."
    end
    return version
end


# URI for :std:label
function _get_inventory_uri(doc, ctx, name::AbstractString, anchor::Documenter.Anchor)
    filename = relpath(anchor.file, doc.user.build)
    page_url = pretty_url(ctx, get_url(ctx, filename))
    if Sys.iswindows()
        # https://github.com/JuliaDocs/Documenter.jl/issues/2387
        page_url = replace(page_url, "\\" => "/")
    end
    page_url = join(map(_escapeuri, split(page_url, "/")), "/")
    label = _escapeuri(Documenter.anchor_label(anchor))
    if label == name
        uri = page_url * raw"#$"
    else
        uri = page_url * "#$label"
    end
    return uri
end


# URI for :std:doc
function _get_inventory_uri(doc, ctx, navnode::Documenter.NavNode)
    uri = pretty_url(ctx, get_url(ctx, navnode.page))
    if Sys.iswindows()
        # https://github.com/JuliaDocs/Documenter.jl/issues/2387
        uri = replace(uri, "\\" => "/")
    end
    uri = join(map(_escapeuri, split(uri, "/")), "/")
    return uri
end


# dispname for :std:label
function _get_inventory_dispname(doc, ctx, name::AbstractString, anchor::Documenter.Anchor)
    dispname = mdflatten(anchor.node)
    if dispname == name
        dispname = "-"
    end
    return dispname
end


# dispname for :std:doc
function _get_inventory_dispname(doc, ctx, navnode::Documenter.NavNode)
    dispname = navnode.title_override
    if isnothing(dispname)
        page = getpage(ctx, navnode)
        title_node = pagetitle(page.mdast)
        if isnothing(title_node)
            dispname = "-"
        else
            dispname = mdflatten(title_node)
        end
    end
    return dispname
end


@inline _issafe(c::Char) =
    c == '-' || c == '.' || c == '_' || (isascii(c) && (isletter(c) || isnumeric(c)))

_utf8_chars(str::AbstractString) = (Char(c) for c in codeunits(str))

_escapeuri(c::Char) = string('%', uppercase(string(Int(c), base = 16, pad = 2)))
_escapeuri(str::AbstractString) =
    join(_issafe(c) ? c : _escapeuri(c) for c in _utf8_chars(str))

module MissingDocsTests
using Test
using Documenter
include("../TestUtilities.jl"); using Main.TestUtilities

module MissingDocs
    export f

    "exported"
    f(x) = x

    "unexported"
    g(x) = x
end

module MissingDocsSubmodule
    module UndocumentedSubmodule
        export f

        "exported"
        f(x) = x
    end
end

@testset "missing docs" begin
    for (sym, n_expected) in zip([:none, :exports, :public, :all], [0, 1, 1, 2])
        kwargs = (
            root = dirname(@__FILE__),
            source = joinpath("src", string(sym)),
            build = joinpath("build", string(sym)),
            modules = MissingDocs,
            checkdocs = sym,
            sitename = "MissingDocs Checks",
            warnonly = true,
        )
        @quietly @test makedocs(; kwargs...) === nothing

        doc = Documenter.Document(; kwargs...)
        @quietly @test Documenter.missingdocs(doc) == n_expected
    end

    @quietly @test_throws ErrorException makedocs(
        root = dirname(@__FILE__),
        source = joinpath("src", "none"),
        build = joinpath("build", "error"),
        modules = MissingDocs,
        checkdocs = :all,
        sitename = "MissingDocs Checks",
    )

    for (ignore, n_expected) in zip([false, true], [1, 0])
        kwargs = (
            root = dirname(@__FILE__),
            source = joinpath("src", "none"),
            build = joinpath("build", "submodule"),
            modules = MissingDocsSubmodule,
            checkdocs = :all,
            sitename = "MissingDocsSubmodule Checks",
            warnonly = true,
            checkdocs_ignored_modules = ignore ? Module[MissingDocsSubmodule.UndocumentedSubmodule] : Module[],
        )
        @quietly @test makedocs(; kwargs...) === nothing

        doc = Documenter.Document(; kwargs...)
        @quietly @test Documenter.missingdocs(doc) == n_expected
    end
end

end

import SHA
using Documenter
include("../TestUtilities.jl"); using Main.TestUtilities

# Defines the modules referred to in the example docs (under src/) and then builds them.
# It can be called separately to build the examples/, or as part of the test suite.

# The `Mod` and `AutoDocs` modules are assumed to exist in the Main module.
(@__MODULE__) === Main || error("$(@__FILE__) must be included into Main.")

# DOCUMENTER_TEST_EXAMPLES environment variable can be used to control which
# builds actually run. E.g. to only build the HTML deployment example build, you
# could call the make.jl file as follows:
#
#     DOCUMENTER_TEST_EXAMPLES=html julia --project test/examples/make.jl
#
EXAMPLE_BUILDS = if haskey(ENV, "DOCUMENTER_TEST_EXAMPLES")
    split(ENV["DOCUMENTER_TEST_EXAMPLES"])
else
    [
        "html", "html-meta-custom", "html-mathjax2-custom", "html-mathjax3", "html-mathjax3-custom",
        "html-local", "html-draft", "html-repo-git", "html-repo-nothing", "html-repo-error",
        "html-sizethreshold-defaults-fail", "html-sizethreshold-success", "html-sizethreshold-ignore-success", "html-sizethreshold-override-fail", "html-sizethreshold-ignore-success", "html-sizethreshold-ignore-fail",
        "latex_texonly", "latex_simple_texonly", "latex_showcase_texonly", "html-pagesonly",
    ]
end

# Modules `Mod` and `AutoDocs`
module Mod
    """
        func(x)

    [`T`](@ref)
    """
    func(x) = x

    """
        T

    [`func(x)`](@ref)
    """
    mutable struct T end

    @doc raw"""
    Inline: ``\frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2}``

    Display equation:

    ```math
    \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2}
    ```

    !!! note "Long equations in admonitions"

        Inline: ``\frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2}``

        Display equation:

        ```math
        \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2}
        ```

    Long equations in footnotes.[^longeq_footnote]

    [^longeq_footnote]:

        Inline: ``\frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2}``

        Display equation:

        ```math
        \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2} + \frac{1+2+3+4+5+6}{\sigma^2}
        ```
    """
    function long_equations_in_docstrings end
end

"`AutoDocs` module."
module AutoDocs
module Pages
    include("pages/a.jl")
    include("pages/b.jl")
    include("pages/c.jl")
    include("pages/d.jl")
    include("pages/e.jl")
end

"Function `f`."
f(x) = x

"Constant `K`."
const K = 1

"Type `T`."
mutable struct T end

"Macro `@m`."
macro m() end

"Module `A`."
module A
    "Function `A.f`."
    f(x) = x

    "Constant `A.K`."
    const K = 1

    "Type `B.T`."
    mutable struct T end

    "Macro `B.@m`."
    macro m() end
end

"Module `B`."
module B
    "Function `B.f`."
    f(x) = x

    "Constant `B.K`."
    const K = 1

    "Type `B.T`."
    mutable struct T end

    "Macro `B.@m`."
    macro m() end
end

module Filter
    "abstract super type"
    abstract type Major end

    "abstract sub type 1"
    abstract type Minor1 <: Major end

    "abstract sub type 2"
    abstract type Minor2 <: Major end

    "random constant"
    qq = 3.14

    using Markdown: @doc_str
    @doc doc"random function"
    function qqq end
end
end

struct MIMEBytes{M <: MIME}
    bytes::Vector{UInt8}
    hash_slug::String
    function MIMEBytes(mime::AbstractString, bytes::AbstractVector{UInt8})
        hash_slug = bytes2hex(SHA.sha1(bytes))[1:8]
        return new{MIME{Symbol(mime)}}(bytes, hash_slug)
    end
end
Base.show(io::IO, ::M, obj::MIMEBytes{M}) where {M <: MIME} = write(io, obj.bytes)

const AT_EXAMPLE_FILES = Dict(
    ("png", :big) => MIMEBytes("image/png", read(joinpath(@__DIR__, "images", "big.png"))),
    ("png", :tiny) => MIMEBytes("image/png", read(joinpath(@__DIR__, "images", "tiny.png"))),
    ("webp", :big) => MIMEBytes("image/webp", read(joinpath(@__DIR__, "images", "big.webp"))),
    ("webp", :tiny) => MIMEBytes("image/webp", read(joinpath(@__DIR__, "images", "tiny.webp"))),
    ("gif", :big) => MIMEBytes("image/gif", read(joinpath(@__DIR__, "images", "big.gif"))),
    ("jpeg", :tiny) => MIMEBytes("image/jpeg", read(joinpath(@__DIR__, "images", "tiny.jpeg"))),
)
SVG_BIG = MIMEBytes("image/svg+xml", read(joinpath(@__DIR__, "images", "big.svg")))
SVG_HTML = MIMEBytes("text/html", read(joinpath(@__DIR__, "images", "big.svg")))

struct MultiMIMESVG
    bytes::Vector{UInt8}
    hash_slug::String
    function MultiMIMESVG(bytes::AbstractVector{UInt8})
        hash_slug = bytes2hex(SHA.sha1(bytes))[1:8]
        return new(bytes, hash_slug)
    end
end
Base.show(io::IO, ::MIME"image/svg+xml", obj::MultiMIMESVG) = write(io, obj.bytes)
Base.show(io::IO, ::MIME"text/html", obj::MultiMIMESVG) = write(io, obj.bytes)
SVG_MULTI = MultiMIMESVG(read(joinpath(@__DIR__, "images", "big.svg")))

# Helper functions
function withassets(f, assets...)
    src(asset) = joinpath(@__DIR__, asset)
    dst(asset) = joinpath(@__DIR__, "src/assets/$(basename(asset))")
    for asset in assets
        isfile(src(asset)) || error("$(asset) is missing")
    end
    for asset in assets
        isfile(dst(asset)) && @warn "Asset '$asset' present, dirty build directory. Overwriting." src(asset) dst(asset)
        cp(src(asset), dst(asset), force = true)
    end
    return try
        f()
    finally
        @debug "Cleaning up assets" assets
        for asset in assets
            rm(dst(asset))
        end
    end
end

struct TestRemote <: Remotes.Remote end
Remotes.repourl(::TestRemote) = "https://example.org/Repository.jl"
function Remotes.fileurl(::TestRemote, ::Any, filename, linerange)
    L1, L2 = first(linerange), last(linerange)
    return "https://example.org/Repository.jl/blob/$(filename)#L$(L1)-$(L2)"
end
Remotes.issueurl(::TestRemote, issue) = "https://example.org/Repository.jl/blob/$(issue)"

# Build example docs

examples_root = @__DIR__
builds_directory = joinpath(examples_root, "builds")
ispath(builds_directory) && rm(builds_directory, recursive = true)

expandfirst = ["expandorder/AA.md"]
htmlbuild_pages = Any[
    "**Home**" => "index.md",
    "Manual" => [
        "man/tutorial.md",
        "man/style.md",
        "man/page with space.md",
    ],
    hide("hidden.md"),
    "Library" => [
        "lib/functions.md",
        "lib/autodocs.md",
    ],
    hide(
        "Hidden Pages" => "hidden/index.md", Any[
            "Page X" => "hidden/x.md",
            "hidden/y.md",
            "hidden/z.md",
        ]
    ),
    "Expandorder" => [
        "expandorder/00.md",
        "expandorder/01.md",
        "expandorder/AA.md",
    ],
    "unicode.md",
    "latex.md",
    "example-output.md",
    "fonts.md",
    "issue491.md",
    "linenumbers.md",
    "EditURL" => [
        "editurl/good.md",
        "editurl/bad.md",
        "editurl/ugly.md",
    ],
    "xrefs.md",
    "Outputs" => [
        "outputs/index.md",
        "outputs/outputs.md",
    ],
]

function html_doc(
        build_directory, mathengine;
        htmlkwargs = (;),
        image_assets = ("images/logo.png", "images/logo.jpg", "images/logo.gif"),
        warnonly = (VERSION.major == 1 && VERSION.minor <= 10),
        kwargs...
    )
    return @quietly withassets(image_assets...) do
        makedocs(;
            debug = true,
            root = examples_root,
            build = "builds/$(build_directory)",
            doctestfilters = [r"Ptr{0x[0-9]+}"],
            sitename = "Documenter example",
            pages = htmlbuild_pages,
            expandfirst = expandfirst,
            doctest = false,
            format = Documenter.HTML(;
                assets = [
                    "assets/favicon.ico",
                    "assets/custom.css",
                    asset("https://example.com/resource.js"),
                    asset("http://example.com/fonts?param=foo", class = :css),
                    asset("https://fonts.googleapis.com/css?family=Nanum+Brush+Script&display=swap", class = :css),
                ],
                prettyurls = true,
                canonical = "https://example.com/stable",
                mathengine = mathengine,
                highlights = ["erlang", "erlang-repl"],
                footer = "This footer has been customized.",
                inventory_version = "$(Documenter.DOCUMENTER_VERSION)+test",
                htmlkwargs...
            ),
            warnonly = warnonly,
            kwargs...
        )
    end
end

# Build with pretty URLs and canonical links and a PNG logo
examples_html_doc = if "html" in EXAMPLE_BUILDS
    @info("Building mock package docs: HTMLWriter / deployment build")
    html_doc(
        "html",
        MathJax2(
            Dict(
                :TeX => Dict(
                    :equationNumbers => Dict(:autoNumber => "AMS"),
                    :Macros => Dict(
                        :ket => ["|#1\\rangle", 1],
                        :bra => ["\\langle#1|", 1],
                        :pdv => ["\\frac{\\partial^{#1} #2}{\\partial #3^{#1}}", 3, ""],
                    ),
                ),
            )
        ),
        htmlkwargs = (; edit_link = :commit),
    )
else
    @info "Skipping build: HTML/deploy"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

# Same as HTML but with custom site description and preview image
examples_html_meta_custom_doc = if "html-meta-custom" in EXAMPLE_BUILDS
    @info("Building mock package docs: HTMLWriter / deployment build (custom meta tags)")
    html_doc(
        "html-meta-custom",
        MathJax2(
            Dict(
                :TeX => Dict(
                    :equationNumbers => Dict(:autoNumber => "AMS"),
                    :Macros => Dict(
                        :ket => ["|#1\\rangle", 1],
                        :bra => ["\\langle#1|", 1],
                        :pdv => ["\\frac{\\partial^{#1} #2}{\\partial #3^{#1}}", 3, ""],
                    ),
                ),
            )
        ),
        htmlkwargs = (;
            edit_link = :commit,
            description = "Example site-wide description.",
        ),
        image_assets = ("images/logo.png", "images/logo.jpg", "images/logo.gif", "images/preview.png"),
    )
else
    @info "Skipping build: HTML/deploy (custom meta tags)"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

# Same as HTML, but with variations on the MathJax configuration
examples_html_mathjax2_custom_doc = if "html-mathjax2-custom" in EXAMPLE_BUILDS
    @info("Building mock package docs: HTMLWriter / deployment build using MathJax v2 (custom URL)")
    html_doc(
        "html-mathjax2-custom",
        MathJax2(
            Dict(
                :TeX => Dict(
                    :equationNumbers => Dict(:autoNumber => "AMS"),
                    :Macros => Dict(
                        :ket => ["|#1\\rangle", 1],
                        :bra => ["\\langle#1|", 1],
                        :pdv => ["\\frac{\\partial^{#1} #2}{\\partial #3^{#1}}", 3, ""],
                    ),
                ),
            ),
            url = "https://cdn.jsdelivr.net/npm/mathjax@2/MathJax.js?config=TeX-AMS-MML_HTMLorMML",
        ),
        htmlkwargs = (; edit_link = nothing, repolink = nothing),
    )
else
    @info "Skipping build: HTML/deploy MathJax v2 (custom URL)"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end
examples_html_mathjax3_doc = if "html-mathjax3" in EXAMPLE_BUILDS
    @info("Building mock package docs: HTMLWriter / deployment build using MathJax v3")
    html_doc(
        "html-mathjax3",
        MathJax3(
            Dict(
                :loader => Dict("load" => ["[tex]/physics"]),
                :tex => Dict(
                    "inlineMath" => [["\$", "\$"], ["\\(", "\\)"]],
                    "tags" => "ams",
                    "packages" => ["base", "ams", "autoload", "physics"],
                ),
            )
        ),
    )
else
    @info "Skipping build: HTML/deploy MathJax v3"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end
examples_html_mathjax3_custom_doc = if "html-mathjax3-custom" in EXAMPLE_BUILDS
    @info("Building mock package docs: HTMLWriter / deployment build using MathJax v3 (custom URL)")
    html_doc(
        "html-mathjax3-custom",
        MathJax3(
            Dict(
                :loader => Dict("load" => ["[tex]/physics"]),
                :tex => Dict(
                    "inlineMath" => [["\$", "\$"], ["\\(", "\\)"]],
                    "tags" => "ams",
                    "packages" => ["base", "ams", "autoload", "physics"],
                ),
            ),
            url = "https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js",
        ),
    )
else
    @info "Skipping build: HTML/deploy MathJax v3 (custom URL)"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

# HTML: local build with pretty URLs off
examples_html_local_doc = if "html-local" in EXAMPLE_BUILDS
    @info("Building mock package docs: HTMLWriter / local build")
    @quietly makedocs(
        debug = true,
        root = examples_root,
        build = "builds/html-local",
        doctestfilters = [r"Ptr{0x[0-9]+}"],
        sitename = "Documenter example",
        pages = htmlbuild_pages,
        expandfirst = expandfirst,
        repo = "https://dev.azure.com/org/project/_git/repo?path={path}&version={commit}{line}&lineStartColumn=1&lineEndColumn=1",
        linkcheck = true,
        linkcheck_ignore = [r"(x|y).md", "z.md", r":func:.*"],
        linkcheck_useragent = "Documenter/1",
        format = Documenter.HTML(
            assets = [
                "assets/custom.css",
                asset("https://plausible.io/js/plausible.js", class = :js, attributes = Dict(Symbol("data-domain") => "example.com", :defer => "")),
                RawHTMLHeadContent("<script>console.log('hello from head content! 🌸')</script>"),
            ],
            prettyurls = false,
            footer = nothing,
        ),
        # TODO: example_block failure only happens on windows, so that's not actually expected
        warnonly = [:doctest, :footnote, :cross_references, :linkcheck, :example_block, :eval_block],
    )
else
    @info "Skipping build: HTML/local"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

# HTML: draft mode
examples_html_draft_doc = if "html-draft" in EXAMPLE_BUILDS
    @info("Building mock package docs: HTMLWriter / draft build")
    @quietly makedocs(
        debug = true,
        draft = true,
        root = examples_root,
        build = "builds/html-draft",
        sitename = "Documenter example (draft)",
        pages = htmlbuild_pages,
        warnonly = [:footnote, :cross_references],
    )
else
    @info "Skipping build: HTML/draft"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

# HTML: pagesonly
examples_html_pagesonly_doc = if "html-pagesonly" in EXAMPLE_BUILDS
    @info("Building mock package docs: HTMLWriter / draft build")
    @quietly makedocs(
        debug = true,
        draft = true,
        root = examples_root,
        build = "builds/html-pagesonly",
        sitename = "Documenter example (pagesonly)",
        pages = [
            "**Home**" => "index.md",
            "Manual" => [
                "man/tutorial.md",
                "man/style.md",
            ],
        ],
        pagesonly = true,
        warnonly = :cross_references,
    )
else
    @info "Skipping build: HTML/pagesonly"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

# HTML: A few simple builds testing the repo keyword fallbacks
macro examplebuild(name, block)
    docvar = Symbol("examples_html_", replace(name, "-" => "_"), "_doc")
    fullname = "html-$(name)"
    return quote
        $(esc(docvar)) = if $(fullname) in EXAMPLE_BUILDS
            $(block)
        else
            @info string("Skipping build: HTML/", $(name))
            @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
            nothing
        end
    end
end
function html_repo(name; kwargs...)
    return @quietly makedocs(;
        sitename = "Documenter Repo ($name)",
        build = joinpath(examples_root, "builds/html-repo-$(name)"),
        pages = ["Main section" => ["index.md"]],
        doctest = false,
        debug = true,
        kwargs...,
    )
end
@examplebuild "repo-git" begin
    # should pick up JuliaDocs/Documenter.jl remote from Documenter's repo
    html_repo("git", root = examples_root, source = "src.latex_simple")
end
@examplebuild "repo-nothing" begin
    mktempdir() do dir
        cp(joinpath(examples_root, "src.latex_simple"), joinpath(dir, "src"))
        html_repo("nothing", root = dir, remotes = nothing)
    end
end
@examplebuild "repo-error" begin
    mktempdir() do dir
        cp(joinpath(examples_root, "src.latex_simple"), joinpath(dir, "src"))
        html_repo("error", root = dir, remotes = nothing)
    end
end

# size thresholds
@examplebuild "sizethreshold-defaults-fail" begin
    @quietly try
        makedocs(;
            sitename = "Megabyte",
            root = examples_root,
            build = "builds/sizethreshold-defaults-fail",
            source = "src.megapage",
            debug = true,
        )
    catch e
        e
    end
end
@examplebuild "sizethreshold-success" begin
    @quietly try
        makedocs(;
            sitename = "Megabyte",
            root = examples_root,
            build = "builds/sizethreshold-success",
            source = "src.megapage",
            format = Documenter.HTML(size_threshold = 5 * 2^20),
            debug = true,
        )
    catch e
        e
    end
end
@examplebuild "sizethreshold-ignore-success" begin
    @quietly try
        makedocs(;
            sitename = "Megabyte",
            root = examples_root,
            build = "builds/sizethreshold-ignore-success",
            source = "src.megapage",
            format = Documenter.HTML(size_threshold = nothing),
            debug = true,
        )
    catch e
        e
    end
end
@examplebuild "sizethreshold-override-fail" begin
    @quietly try
        makedocs(;
            sitename = "Megabyte",
            root = examples_root,
            build = "builds/sizethreshold-override-fail",
            source = "src.megapage",
            format = Documenter.HTML(size_threshold = 100, size_threshold_warn = nothing),
            debug = true,
        )
    catch e
        e
    end
end
@examplebuild "sizethreshold-ignore-success" begin
    @quietly try
        makedocs(;
            sitename = "Megabyte",
            root = examples_root,
            build = "builds/sizethreshold-defaults-fail",
            source = "src.megapage",
            format = Documenter.HTML(size_threshold_ignore = ["index.md", "subdir/subpage.md"]),
            debug = true,
        )
    catch e
        e
    end
end
@examplebuild "sizethreshold-ignore-fail" begin
    @quietly try
        makedocs(;
            sitename = "Megabyte",
            root = examples_root,
            build = "builds/sizethreshold-defaults-fail",
            source = "src.megapage",
            # Note: it's fine to pass non-existent pages to size_threshold_ignore
            format = Documenter.HTML(size_threshold_ignore = ["foo.md"]),
            debug = true,
        )
    catch e
        e
    end
end

# PDF/LaTeX
examples_latex_simple_doc = if "latex_simple" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/simple")
    @quietly makedocs(
        format = Documenter.LaTeXWriter.LaTeX(platform = "docker", version = v"1.2.3"),
        sitename = "Documenter LaTeX Simple",
        root = examples_root,
        build = "builds/latex_simple",
        source = "src.latex_simple",
        pages = ["Main section" => ["index.md"]],
        doctest = false,
        debug = true,
    )
else
    @info "Skipping build: LaTeXWriter/simple"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

examples_latex_doc = if "latex" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/latex")
    @quietly makedocs(
        format = Documenter.LaTeXWriter.LaTeX(platform = "docker"),
        sitename = "Documenter LaTeX",
        root = examples_root,
        build = "builds/latex",
        pages = htmlbuild_pages = Any[
            "General" => [
                "index.md",
                "latex.md",
                "unicode.md",
                hide("hidden.md"),
                # The title override tests that we escape headings correctly
                "`@example_output`" => "example-output.md",
            ],
            # SVG images nor code blocks in footnotes are allowed in LaTeX
            # "Manual" => [
            #     "man/tutorial.md",
            #     "man/style.md",
            # ],
            hide(
                "Hidden Pages" => "hidden/index.md", Any[
                    "Page X" => "hidden/x.md",
                    "hidden/y.md",
                    "hidden/z.md",
                ]
            ),
            "Library" => [
                "lib/functions.md",
                "lib/autodocs.md",
            ],
            "Expandorder" => [
                "expandorder/00.md",
                "expandorder/01.md",
                "expandorder/AA.md",
            ],
        ],
        doctest = false,
        debug = true,
        warnonly = [:footnote, :cross_references, :example_block, :eval_block],
    )
else
    @info "Skipping build: LaTeXWriter/latex"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

examples_latex_simple_nondocker_doc = if "latex_simple_nondocker" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/latex_simple_nondocker")
    @quietly makedocs(
        format = Documenter.LaTeX(version = v"1.2.3"),
        sitename = "Documenter LaTeX Simple Non-Docker",
        root = examples_root,
        build = "builds/latex_simple_nondocker",
        source = "src.latex_simple",
        pages = ["Main section" => ["index.md"]],
        doctest = false,
        debug = true,
    )
else
    @info "Skipping build: LaTeXWriter/latex_simple_nondocker"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

examples_latex_simple_tectonic_doc = if "latex_simple_tectonic" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/latex_simple_tectonic")
    using tectonic_jll: tectonic
    @quietly makedocs(
        format = Documenter.LaTeX(platform = "tectonic", version = v"1.2.3", tectonic = tectonic()),
        sitename = "Documenter LaTeX Simple Tectonic",
        root = examples_root,
        build = "builds/latex_simple_tectonic",
        source = "src.latex_simple",
        pages = ["Main section" => ["index.md"]],
        doctest = false,
        debug = true,
    )
else
    @info "Skipping build: LaTeXWriter/latex_simple_tectonic"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end


examples_latex_texonly_doc = if "latex_texonly" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/latex_texonly")
    @quietly makedocs(
        format = Documenter.LaTeX(platform = "none"),
        sitename = "Documenter LaTeX",
        root = examples_root,
        build = "builds/latex_texonly",
        pages = Any[
            "General" => [
                "index.md",
                "latex.md",
                "unicode.md",
                hide("hidden.md"),
                "example-output.md",
                "linenumbers.md",
            ],
            # SVG images nor code blocks in footnotes are allowed in LaTeX
            # "Manual" => [
            #     "man/tutorial.md",
            #     "man/style.md",
            # ],
            hide(
                "Hidden Pages" => "hidden/index.md", Any[
                    "Page X" => "hidden/x.md",
                    "hidden/y.md",
                    "hidden/z.md",
                ]
            ),
            "Library" => [
                "lib/functions.md",
                "lib/autodocs.md",
            ],
            "Expandorder" => [
                "expandorder/00.md",
                "expandorder/01.md",
                "expandorder/AA.md",
            ],
        ],
        doctest = false,
        debug = true,
        warnonly = [:footnote, :cross_references, :example_block, :eval_block],
    )
else
    @info "Skipping build: LaTeXWriter/latex_texonly"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

examples_latex_simple_texonly_doc = if "latex_simple_texonly" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/latex_simple_texonly")
    @quietly makedocs(
        format = Documenter.LaTeX(platform = "none", version = v"1.2.3"),
        sitename = "Documenter LaTeX Simple Non-Docker",
        root = examples_root,
        build = "builds/latex_simple_texonly",
        source = "src.latex_simple",
        pages = ["Main section" => ["index.md"]],
        doctest = false,
        debug = true,
    )
else
    @info "Skipping build: LaTeXWriter/latex_simple_texonly"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

examples_latex_cover_page = if "latex_cover_page" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/latex_cover_page")
    @quietly makedocs(
        format = Documenter.LaTeXWriter.LaTeX(platform = "docker"),
        sitename = "Documenter LaTeX",
        root = examples_root,
        build = "builds/latex_cover_page",
        source = "src.cover_page",
        pages = ["Home" => "index.md"],
        authors = "The Julia Project",
        doctest = false,
        debug = true,
    )
else
    @info "Skipping build: LaTeXWriter/latex_cover_page"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

examples_latex_toc_style = if "latex_toc_style" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/latex_toc_style")
    @quietly makedocs(
        format = Documenter.LaTeXWriter.LaTeX(platform = "docker"),
        sitename = "Documenter LaTeX",
        root = examples_root,
        build = "builds/latex_toc_style",
        source = "src.toc_style",
        pages = ["Part-I" => "index.md"],
        authors = "The Julia Project",
        doctest = false,
        debug = true,
    )
else
    @info "Skipping build: LaTeXWriter/latex_toc_style"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

examples_latex_showcase_doc = if "latex_showcase" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/latex_showcase")
    @quietly makedocs(
        format = Documenter.LaTeX(platform = "docker", version = v"1.2.3"),
        sitename = "Documenter LaTeX Showcase",
        root = examples_root,
        build = "builds/latex_showcase",
        source = "src.latex_showcase",
        pages = ["Showcase" => ["showcase.md", "docstrings.md"]],
        remotes = Dict(@__DIR__() => (TestRemote(), "6ef16754bc5da93f67a4323fb204c5bd3e64f336")),
        doctest = false,
        debug = true,
        warnonly = [:docs_block, :cross_references],
    )
else
    @info "Skipping build: LaTeXWriter/latex_showcase"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

examples_latex_showcase_texonly_doc = if "latex_showcase_texonly" in EXAMPLE_BUILDS
    @info("Building mock package docs: LaTeXWriter/latex_showcase_texonly")
    @quietly makedocs(
        format = Documenter.LaTeX(platform = "none", version = v"1.2.3"),
        sitename = "Documenter LaTeX Showcase",
        root = examples_root,
        build = "builds/latex_showcase_texonly",
        source = "src.latex_showcase",
        pages = ["Showcase" => ["showcase.md", "docstrings.md"]],
        remotes = Dict(@__DIR__() => (TestRemote(), "6ef16754bc5da93f67a4323fb204c5bd3e64f336")),
        doctest = false,
        debug = true,
        warnonly = [:docs_block, :cross_references],
    )
else
    @info "Skipping build: LaTeXWriter/latex_showcase_texonly"
    @debug "Controlling variables:" EXAMPLE_BUILDS get(ENV, "DOCUMENTER_TEST_EXAMPLES", nothing)
    nothing
end

module DocsXRefTests

# Testing the fallback behavior implemented in
# https://github.com/JuliaDocs/Documenter.jl/pull/2470

using Test
using Documenter
using IOCapture

isdefined(Main, :Documenter) || @eval Main import Documenter

isdefined(Main, :AbstractSelector) || @eval Main using Documenter.Selectors: AbstractSelector

isdefined(Main, :DocsReferencingMain) || @eval Main module DocsReferencingMain
    export f, g

    """This is the function `f`.

    It references [`Documenter.Selectors.AbstractSelector`](@ref), which
    resolves only because of a fallback to `Main`.

    See also [`g`](@ref).
    """
    f(x) = x

    """This is the function `g`

    If references [`Main.AbstractSelector`](@ref), which should resolve,
    unlike the non-fully-qualified [`AbstractSelector`](@ref) (even though
    `AbstractSelector` is in `Main`)

    See also [`f`](@ref).
    """
    g(x) = x
end


@testset "xrefs to Main" begin

    kwargs = (
        root = dirname(@__FILE__),
        source = "src",
        build = "build",
        sitename = "DocsXRef",
        warnonly = true,
        format = Documenter.HTML(
            prettyurls = false,
            inventory_version = "",
        ),
    )

    captured = IOCapture.capture() do
        makedocs(; kwargs...)
    end

    output = captured.output
    output = replace(output, "\\src\\index" => "/src/index")
    output = replace(output, "\\src\\page" => "/src/page")
    output = replace(output, "test/docsxref/src/index" => "docsxref/src/index")
    output = replace(output, "test/docsxref/src/page" => "docsxref/src/page")

    @test isnothing(captured.value)
    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[`AbstractSelector`](@ref)" in docsxref/src/index.md.
        │ - No docstring found in doc for binding `Main.DocsReferencingMain.AbstractSelector`.
        │ - Fallback resolution in Main for `AbstractSelector` -> `Documenter.Selectors.AbstractSelector` is only allowed for fully qualified names
        """
    )
    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[`DocsReferencingMain.f`](@ref)" in docsxref/src/page.md.
        │ - Exception trying to find docref for `DocsReferencingMain.f`: unable to get the binding for `DocsReferencingMain.f` in module Documenter.Selectors
        │ - Fallback resolution in Main for `DocsReferencingMain.f` -> `Main.DocsReferencingMain.f` is only allowed for fully qualified names
        """
    )

    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[header](@ref)" in docsxref/src/index.md.
        │ - Header or `@id` anchor with slug 'header' in docsxref/src/index.md does not exist.
        """
    )
    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[header link](@ref \\\"header\\\")" in docsxref/src/index.md.
        │ - Header or `@id` anchor with slug 'header' in docsxref/src/index.md does not exist.
        """
    )

    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[Multiple words](@ref)" in docsxref/src/index.md.
        │ - Header or `@id` anchor with slug 'Multiple-words' in docsxref/src/index.md does not exist.
        """
    )
    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[header link](@ref \\\"Multiple words\\\")" in docsxref/src/index.md.
        │ - Header or `@id` anchor with slug 'Multiple-words' in docsxref/src/index.md does not exist.
        """
    )
    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[header id link](@ref missing-header-id)" in docsxref/src/index.md.
        │ - Header or `@id` anchor with slug 'missing-header-id' in docsxref/src/index.md does not exist.
        """
    )
    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[dashed header id link](@ref missing-header-id-with-dashes)" in docsxref/src/index.md.
        │ - Header or `@id` anchor with slug 'missing-header-id-with-dashes' in docsxref/src/index.md does not exist.
        """
    )

    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[`foobar`](@ref)" in docsxref/src/index.md.
        │ - No docstring found in doc for binding `Main.foobar`.
        """
    )
    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[docstring link](@ref Main.foobar)" in docsxref/src/index.md.
        │ - No docstring found in doc for binding `Main.foobar`.
        """
    )
    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[docstring code link](@ref `Main.foobar`)" in docsxref/src/index.md.
        │ - No docstring found in doc for binding `Main.foobar`.
        """
    )

    # An implicit target that is neither a header nor a plausible binding is
    # reported, not silently resolved to the docstring of `-` (#2960).
    @test contains(
        output,
        """
        ┌ Warning: Cannot resolve @ref for md"[Some-Hyphenated-Target](@ref)" in docsxref/src/index.md.
        │ - Header or `@id` anchor with slug 'Some-Hyphenated-Target' in docsxref/src/index.md does not exist.
        """
    )
    @test !contains(output, "binding `Base.-`")

    index_html = joinpath(dirname(@__FILE__), "build", "index.html")
    @test isfile(index_html)
    if isfile(index_html)
        html = read(index_html, String)
        @test contains(html, "<a href=\"index.html#Documenter.Selectors.AbstractSelector\"><code>AbstractSelector</code></a>")
        @test contains(html, "<a href=\"index.html#Documenter.Selectors.AbstractSelector\"><code>Documenter.Selectors.AbstractSelector</code></a>")
        @test contains(html, "<a href=\"index.html#Documenter.Selectors.AbstractSelector\"><code>Main.AbstractSelector</code></a>")
        @test contains(html, "<a href=\"@ref\"><code>AbstractSelector</code></a>")

        @test contains(html, "<a href=\"index.html#API\">API</a>")
        @test contains(html, "<a href=\"index.html#API\">header link</a>")
        @test contains(html, "<a href=\"index.html#Two-words\">Two words</a>")
        @test contains(html, "<a href=\"index.html#Two-words\">header link</a>")
        @test contains(html, "<a href=\"index.html#api-reference\">header id link</a>")
        @test contains(html, "<a href=\"index.html#multi-word-section-id\">multi-dash id link</a>")
        @test contains(html, "<a href=\"https://github.com/JuliaDocs/Documenter.jl/issues/12345\">#12345</a>")
        @test contains(html, "<a href=\"https://github.com/JuliaDocs/Documenter.jl/issues/12345\">issue link</a>")
        @test contains(html, "<a href=\"index.html#Main.DocsReferencingMain.g\"><code>DocsReferencingMain.g</code></a>")
        @test contains(html, "<a href=\"index.html#Main.DocsReferencingMain.f\">docstring link</a>")
        @test contains(html, "<a href=\"index.html#Main.DocsReferencingMain.g\">docstring code link</a>")
        @test contains(html, "<a href=\"index.html#DocsReferencingMain.g\">conflict link</a>")
        # Plain text is a header reference only, so this names nothing (#2960).
        @test contains(html, "<a href=\"@ref\">DocsReferencingMain.f</a>")
        # Precedence by syntax: plain text prefers the header, backticks the docstring.
        @test contains(html, "<a href=\"index.html#DocsReferencingMain.g\">DocsReferencingMain.g</a>")
        @test contains(html, "<a href=\"index.html#Main.DocsReferencingMain.g\"><code>DocsReferencingMain.g</code></a>")
        # Backticked link text still finds a header `@id` (#2960).
        @test contains(html, "<a href=\"index.html#ENVVAR\"><code>ENVVAR</code></a>")
        @test contains(html, "<a href=\"index.html#Main.DocsReferencingMain.g\">conflict docs link</a>")
    end
    page_html = joinpath(dirname(@__FILE__), "build", "page.html")
    @test isfile(page_html)
    if isfile(page_html)
        html = read(page_html, String)
        @test contains(html, "<a href=\"index.html#Documenter.Selectors.AbstractSelector\"><code>AbstractSelector</code></a>")
        @test contains(html, "<a href=\"@ref\"><code>DocsReferencingMain.f</code></a>")
        @test contains(html, "<a href=\"index.html#Main.DocsReferencingMain.f\"><code>Main.DocsReferencingMain.f</code></a>")
        @test contains(html, "<a href=\"index.html#Documenter.hide\"><code>Documenter.hide</code></a>")
    end


end

end

struct TestQuery
    query::String
    expected_docs::Vector{String}
end

navigational_queries = [
    TestQuery(
        "makedocs",
        ["Documenter.makedocs", "Markdown & MkDocs", "Doctests", "Syntax", "Documenter.LatexWriter"]
    ),
    TestQuery(
        "deploydocs",
        ["Deploydocs", "The deploydocs function", "Documenter.deploydocs", "Hosting Documentation"]
    ),
]

informational_queries = [
    TestQuery(
        "cross references",
        ["External Cross-References", "Guide", "Syntax", "Documenter.crossref"]
    ),
    TestQuery(
        "hosting documentation",
        ["Hosting Documentation", "SSH Deploy Keys Walkthrough", "Documenter.xref", "Guide"]
    ),
    TestQuery(
        "unicode",
        ["Documenter.JSDependencies.json_jsescape", "Release Notes"]
    ),
]

api_lookup_queries = [
    TestQuery(
        "doctest",
        ["DocTestSetup and DocTestTeardown in @meta blocks", "Doctesting example", "Doctesting as Part of Testing", "Documenter.doctest", "Documenter._doctest"]
    ),
    TestQuery(
        "@docs",
        ["@docs block", "@docs; canonical=false block", "docs/Project.toml", "Markdown & MkDocs", "Documenter.docs"]
    ),
    TestQuery(
        "HTML themes",
        ["Documenter.HTMLWriter.HTML", "Guide", "Release Notes", "Semantic Versioning"]
    ),
]

# Edge cases - realistic edge cases based on actual content
edge_case_queries = [
    TestQuery(
        "nonexistent function",
        String[]  # Should return empty
    ),
]

special_symbol_queries = [
    TestQuery(
        "^",
        ["Version v1.6.0 - 2024-08-20", "Version v1.9.0 - 2025-03-17", "Version v1.5.0 - 2024-06-26", "Version v1.4.0 - 2024-04-14", "Version v1.8.1 - 2025-02-11"]
    ),
    TestQuery(
        "@",
        ["@ref and @id links", "@raw <format> block", "@setup <name> block", "@docs; canonical=false block", "@eval block"]
    ),

]

all_test_queries = vcat(navigational_queries, informational_queries, api_lookup_queries, edge_case_queries, special_symbol_queries)

# These tests test the remote repository link handling. We don't do full
# makedocs() builds here, but rather construct a Document object with
# the appropriate `repo` and `remotes` arguments (like for makedocs) and
# then explicitly test the edit_url and source_url functions.
module RepoLinkTests
using Test
using Random: randstring
using Documenter: Documenter, Remotes, git, edit_url, source_url, MarkdownAST, walk_navpages, expand
using Documenter.HTMLWriter: render_article, HTMLContext, HTML
using Markdown
include("TestUtilities.jl"); using Main.TestUtilities

function init_git_repo(
        f, path;
        remote, # (name, url) tuple, or nothing
        user_email = "tester@example.com",
        user_name = "Test Committer",
    )
    path = abspath(path)
    ispath(path) && error("path already exists\n at $(path)")
    mkpath(path)
    cd(path) do
        @test trun(`$(git()) init`)
        @test trun(`$(git()) config user.email "tester@example.com"`)
        @test trun(`$(git()) config user.name "Test Committer"`)
        @test trun(`$(git()) config commit.gpgsign false`)
        if !isnothing(remote)
            name, url = remote
            @test trun(`$(git()) remote add $(name) $(url)`)
        end
        # Run additional code
        f()
        # Commit everything
        @test trun(`$(git()) add -A`)
        @test trun(`$(git()) commit -m"Initial commit."`)
    end
    return Documenter.repo_commit(path)
end

function create_defaultfiles()
    mkpath("docs")
    write("foo", randstring(10))
    mkpath("bar/baz")
    return write("bar/baz/qux", randstring(10))
end

# Set up a complex hierarchy of temporary repositories
tmproot = mktempdir()
mainrepo = joinpath(tmproot, "mainrepo")
mainrepo_commit = init_git_repo(
    create_defaultfiles, mainrepo;
    remote = ("origin", "git@github.com:TestOrg/TestRepo.jl.git")
)
subrepo = joinpath(mainrepo, "subrepo")
subrepo_commit = init_git_repo(
    create_defaultfiles, subrepo;
    remote = ("origin", "git@github.com:TestOrg/AnotherRepo.jl.git")
)
# Second repository in a subdirectory, but without a remote set up, so this would
# require it to be set explicitly in remotes.
subrepo_noremote = joinpath(mainrepo, "bar", "subrepo_noremote")
subrepo_noremote_commit = init_git_repo(create_defaultfiles, subrepo_noremote; remote = nothing)
# A repository outside of the main repository (with remote)
extrepo = joinpath(tmproot, "extrepo")
extrepo_commit = init_git_repo(
    create_defaultfiles, extrepo;
    remote = ("origin", "git@github.com:TestOrg/ExtRepo.jl.git")
)
# A repository outside of the main repository (without remote)
extrepo_noremote = joinpath(tmproot, "extrepo_noremote")
extrepo_noremote_commit = init_git_repo(create_defaultfiles, extrepo_noremote; remote = nothing)
# Just a directory outside of the main repository
extdirectory = joinpath(tmproot, "extdirectory")
mkpath(extdirectory)
cd(create_defaultfiles, extdirectory)

@debug let
    tree = Sys.which("tree")
    if isnothing(tree)
        "`tree` command not found"
    else
        s = read(`$(tree) $(tmproot)`, String)
        "tree @ $tmproot\n$s"
    end
end

@testset "Defaults (no arguments)" begin
    @debug Test.get_testset()
    # First, let's test the default behaviours, without arguments,
    # in which case we should pick up all the Git repositories that
    # have valid origins, and throw on others.
    doc = Documenter.Document(root = joinpath(mainrepo, "docs"))
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = nothing) == "https://github.com/TestOrg/TestRepo.jl/blob/$(mainrepo_commit)/foo"
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = "main") == "https://github.com/TestOrg/TestRepo.jl/blob/main/foo"
    @test edit_url(doc, joinpath(mainrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/TestOrg/TestRepo.jl/blob/$(mainrepo_commit)/bar/baz/qux"
    @test source_url(doc, RepoLinkTests, joinpath(mainrepo, "foo"), 5:8) == "https://github.com/TestOrg/TestRepo.jl/blob/$(mainrepo_commit)/foo#L5-L8"
    # Directories are fine too, but non-existent local paths are not
    @test edit_url(doc, joinpath(mainrepo, "bar"); rev = nothing) == "https://github.com/TestOrg/TestRepo.jl/blob/$(mainrepo_commit)/bar"
    @test_throws ErrorException edit_url(doc, joinpath(mainrepo, "nonext"); rev = nothing)
    # We also automatically pick up the Git remote of a subdirectory
    @test edit_url(doc, joinpath(subrepo, "foo"); rev = nothing) == "https://github.com/TestOrg/AnotherRepo.jl/blob/$(subrepo_commit)/foo"
    @test edit_url(doc, joinpath(subrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/TestOrg/AnotherRepo.jl/blob/$(subrepo_commit)/bar/baz/qux"
    # We also automatically pick up the Git remote of path outside the repo
    @test edit_url(doc, joinpath(extrepo, "foo"); rev = nothing) == "https://github.com/TestOrg/ExtRepo.jl/blob/$(extrepo_commit)/foo"
    @test edit_url(doc, joinpath(extrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/TestOrg/ExtRepo.jl/blob/$(extrepo_commit)/bar/baz/qux"
    # But if you don't have the Git origin set, then we error
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(subrepo_noremote, "foo"); rev = nothing)
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(subrepo_noremote, "bar", "baz", "qux"); rev = nothing)
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extrepo_noremote, "foo"); rev = nothing)
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extrepo_noremote, "bar", "baz", "qux"); rev = nothing)
    # And the same applies to external directories
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extdirectory, "foo"); rev = nothing)
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extdirectory, "bar", "baz", "qux"); rev = nothing)
end

@testset "Repo only" begin
    @debug Test.get_testset()
    # If we override the `repo` argument (only), we should override everything in the main repository
    doc = Documenter.Document(root = joinpath(mainrepo, "docs"), repo = Remotes.GitHub("AlternateOrg", "TestRepo.jl"))
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = nothing) == "https://github.com/AlternateOrg/TestRepo.jl/blob/$(mainrepo_commit)/foo"
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = "main") == "https://github.com/AlternateOrg/TestRepo.jl/blob/main/foo"
    @test edit_url(doc, joinpath(mainrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/AlternateOrg/TestRepo.jl/blob/$(mainrepo_commit)/bar/baz/qux"
    @test source_url(doc, RepoLinkTests, joinpath(mainrepo, "foo"), 5:8) == "https://github.com/AlternateOrg/TestRepo.jl/blob/$(mainrepo_commit)/foo#L5-L8"
    # We also automatically pick up the Git remote of a subdirectory
    @test edit_url(doc, joinpath(subrepo, "foo"); rev = nothing) == "https://github.com/TestOrg/AnotherRepo.jl/blob/$(subrepo_commit)/foo"
    @test edit_url(doc, joinpath(subrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/TestOrg/AnotherRepo.jl/blob/$(subrepo_commit)/bar/baz/qux"
    # We also automatically pick up the Git remote of path outside the repo
    @test edit_url(doc, joinpath(extrepo, "foo"); rev = nothing) == "https://github.com/TestOrg/ExtRepo.jl/blob/$(extrepo_commit)/foo"
    @test edit_url(doc, joinpath(extrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/TestOrg/ExtRepo.jl/blob/$(extrepo_commit)/bar/baz/qux"
    # But if you don't have the Git origin set, then we error
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(subrepo_noremote, "foo"); rev = nothing)
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(subrepo_noremote, "bar", "baz", "qux"); rev = nothing)
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extrepo_noremote, "foo"); rev = nothing)
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extrepo_noremote, "bar", "baz", "qux"); rev = nothing)
    # And the same applies to external directories
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extdirectory, "foo"); rev = nothing)
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extdirectory, "bar", "baz", "qux"); rev = nothing)
end

@testset "repo for extrepo_noremote" begin
    @debug Test.get_testset()
    # We normally can't build for extrepo_noremote because we can't detect the remote repository, but if we set repo=,
    # then we will use that.
    doc = Documenter.Document(root = joinpath(extrepo_noremote, "docs"), repo = Remotes.GitHub("ExtRepoOrg", "TestRepo.jl"))
    @test edit_url(doc, joinpath(extrepo_noremote, "foo"); rev = nothing) == "https://github.com/ExtRepoOrg/TestRepo.jl/blob/$(extrepo_noremote_commit)/foo"
    @test edit_url(doc, joinpath(extrepo_noremote, "foo"); rev = "main") == "https://github.com/ExtRepoOrg/TestRepo.jl/blob/main/foo"
    @test edit_url(doc, joinpath(extrepo_noremote, "bar", "baz", "qux"); rev = nothing) == "https://github.com/ExtRepoOrg/TestRepo.jl/blob/$(extrepo_noremote_commit)/bar/baz/qux"
    @test source_url(doc, RepoLinkTests, joinpath(extrepo_noremote, "foo"), 5:8) == "https://github.com/ExtRepoOrg/TestRepo.jl/blob/$(extrepo_noremote_commit)/foo#L5-L8"
end

@testset "Remotes overrides" begin
    @debug Test.get_testset()
    # We'll set up a couple of overrides with remotes here
    doc = Documenter.Document(
        root = joinpath(mainrepo, "docs"),
        remotes = Dict(
            # Just non-repository directories
            extdirectory => (Remotes.GitHub("AlternateOrg", "ExtRepo.jl"), "12345"),
            # Pointing an unconfigured Git repo to another repo
            subrepo_noremote => Remotes.GitHub("AlternateOrg", "NoRemoteSubdir.jl"),
            # Pointing an a Git repo with a valid origin to a different repo
            subrepo => Remotes.GitHub("AlternateOrg", "AnotherRepo.jl"),
        )
    )
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = nothing) == "https://github.com/TestOrg/TestRepo.jl/blob/$(mainrepo_commit)/foo"
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = "main") == "https://github.com/TestOrg/TestRepo.jl/blob/main/foo"
    @test edit_url(doc, joinpath(mainrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/TestOrg/TestRepo.jl/blob/$(mainrepo_commit)/bar/baz/qux"
    @test source_url(doc, RepoLinkTests, joinpath(mainrepo, "foo"), 5:8) == "https://github.com/TestOrg/TestRepo.jl/blob/$(mainrepo_commit)/foo#L5-L8"
    # subrepo: now points to a different repo (well, org)
    @test edit_url(doc, joinpath(subrepo, "foo"); rev = nothing) == "https://github.com/AlternateOrg/AnotherRepo.jl/blob/$(subrepo_commit)/foo"
    @test edit_url(doc, joinpath(subrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/AlternateOrg/AnotherRepo.jl/blob/$(subrepo_commit)/bar/baz/qux"
    # extrepo: we did not touch this
    @test edit_url(doc, joinpath(extrepo, "foo"); rev = nothing) == "https://github.com/TestOrg/ExtRepo.jl/blob/$(extrepo_commit)/foo"
    @test edit_url(doc, joinpath(extrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/TestOrg/ExtRepo.jl/blob/$(extrepo_commit)/bar/baz/qux"
    # subrepo_noremote: this should point to AlternateOrg/NoRemoteSubdir.jl
    @test edit_url(doc, joinpath(subrepo_noremote, "foo"); rev = nothing) == "https://github.com/AlternateOrg/NoRemoteSubdir.jl/blob/$(subrepo_noremote_commit)/foo"
    @test edit_url(doc, joinpath(subrepo_noremote, "bar", "baz", "qux"); rev = nothing) == "https://github.com/AlternateOrg/NoRemoteSubdir.jl/blob/$(subrepo_noremote_commit)/bar/baz/qux"
    # extrepo_noremote: we did not touch this
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extrepo_noremote, "foo"); rev = nothing)
    @test_throws Documenter.MissingRemoteError edit_url(doc, joinpath(extrepo_noremote, "bar", "baz", "qux"); rev = nothing)
    # extdirectory: should point to AlternateOrg/ExtRepo.jl
    @test edit_url(doc, joinpath(extdirectory, "foo"); rev = nothing) == "https://github.com/AlternateOrg/ExtRepo.jl/blob/12345/foo"
    @test edit_url(doc, joinpath(extdirectory, "bar", "baz", "qux"); rev = nothing) == "https://github.com/AlternateOrg/ExtRepo.jl/blob/12345/bar/baz/qux"
end

# Trying to set up a remote to a directory that does not have Git repository will throw, because we need to know
# the commit hash.
@quietly @test_throws Exception Documenter.Document(
    root = joinpath(mainrepo, "docs"),
    remotes = Dict(
        extdirectory => Remotes.GitHub("AlternateOrg", "ExtRepo.jl"),
    )
)

@testset "Set repo with remotes" begin
    @debug Test.get_testset()
    # We'll try to override set repo (~ doc.user.remote) with remotes.
    doc = Documenter.Document(
        root = joinpath(mainrepo, "docs"),
        remotes = Dict(
            mainrepo => Remotes.GitHub("AlternateOrg", "AlternateRepo.jl"),
        )
    )
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = nothing) == "https://github.com/AlternateOrg/AlternateRepo.jl/blob/$(mainrepo_commit)/foo"
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = "main") == "https://github.com/AlternateOrg/AlternateRepo.jl/blob/main/foo"
    @test edit_url(doc, joinpath(mainrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/AlternateOrg/AlternateRepo.jl/blob/$(mainrepo_commit)/bar/baz/qux"
    @test source_url(doc, RepoLinkTests, joinpath(mainrepo, "foo"), 5:8) == "https://github.com/AlternateOrg/AlternateRepo.jl/blob/$(mainrepo_commit)/foo#L5-L8"
    @test doc.user.remote == Remotes.GitHub("AlternateOrg", "AlternateRepo.jl")
    # Let's also override the commit
    doc = Documenter.Document(
        root = joinpath(mainrepo, "docs"),
        remotes = Dict(
            mainrepo => (Remotes.GitHub("AlternateOrg", "AlternateRepo.jl"), "12345"),
        )
    )
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = nothing) == "https://github.com/AlternateOrg/AlternateRepo.jl/blob/12345/foo"
    @test edit_url(doc, joinpath(mainrepo, "foo"); rev = "main") == "https://github.com/AlternateOrg/AlternateRepo.jl/blob/main/foo"
    @test edit_url(doc, joinpath(mainrepo, "bar", "baz", "qux"); rev = nothing) == "https://github.com/AlternateOrg/AlternateRepo.jl/blob/12345/bar/baz/qux"
    @test source_url(doc, RepoLinkTests, joinpath(mainrepo, "foo"), 5:8) == "https://github.com/AlternateOrg/AlternateRepo.jl/blob/12345/foo#L5-L8"
    @test doc.user.remote == Remotes.GitHub("AlternateOrg", "AlternateRepo.jl")
end

# Setting both the `repo` and also overriding the same path in `remotes` should error
@test_throws Exception Documenter.Document(
    root = joinpath(mainrepo, "docs"),
    repo = Remotes.GitHub("AlternateOrg", "ExtRepo.jl"),
    remotes = Dict(
        mainrepo => (Remotes.GitHub("AlternateOrg", "AlternateRepo.jl"), "12345"),
    )
)

rm(tmproot, recursive = true, force = true)

include("repolink_helpers.jl")

@testset "Pkg.add() guesses github tag" begin
    src = convert(
        MarkdownAST.Node,
        md"""
        ```@meta
        CurrentModule = Main.RepoLinkTests.TestHelperModule
        ```
        ```@docs
        MarkdownAST.Node
        ```
        """
    )
    doc, html = render_expand_doc(src)

    # Links to repo
    re = r"<a[^>]+ href=['\"]?https://github.com/JuliaDocs/MarkdownAST.jl"
    @test occursin(re, string(html))

    src = convert(
        MarkdownAST.Node,
        md"""
        ```@meta
        CurrentModule = Main.RepoLinkTests.TestHelperModule
        ```
        This will result in a 404 because this version isn't tagged
        ```@docs
        RegistryInstances
        ```
        """
    )
    doc, html = render_expand_doc(src)

    # Links to repo
    re = r"<a[^>]+ href=['\"]?https://github.com/GunnarFarneback/RegistryInstances.jl"
    @test occursin(re, string(html))
end

end

module OnlineLinkcheckTests
using Documenter: Documenter, MarkdownAST, AbstractTrees
using Documenter: linkcheck
using Markdown
using HTTP
using Test

PORT = rand(10_000:40_000)
function lincheck_server_handler(req::HTTP.Request)
    useragent = HTTP.header(req, "user-agent")
    if startswith(useragent, "Mozilla/5.0")
        return HTTP.Response(404)
    elseif startswith(useragent, "curl")
        return HTTP.Response(200)
    end
    return HTTP.Response(500)
end
server = HTTP.serve!(lincheck_server_handler, PORT)

@testset "Online linkcheck" begin

    @testset "Successes" begin
        src = convert(
            MarkdownAST.Node,
            md"""
            [HTTP (HTTP/1.1) success](http://www.google.com)
            [HTTPS (HTTP/2) success](https://www.google.com)
            [FTP success](ftp://ftp.iana.org/tz/data/etcetera)
            [FTP (no proto) success](ftp.iana.org/tz/data/etcetera)
            [Redirect success](google.com)
            [HEAD fail GET success](https://codecov.io/gh/invenia/LibPQ.jl)

            [Requires GITHUB_TOKEN](https://raw.githubusercontent.com/JuliaDocs/Documenter.jl/v1.0.0/Project.toml)
            [Does not support GITHUB_TOKEN](https://github.com/JuliaDocs/Documenter.jl/pulls)
            [May require GITHUB_TOKEN](https://github.com/JuliaDocs/Documenter.jl/pull/2729)

            Use [`getindex`](https://docs.julialang.org/en/v1.12.1/base/arrays/#Base.getindex-Tuple{AbstractArray,%20Vararg{Any}}) to get one element of an array.
            """
        )
        doc = Documenter.Document(; linkcheck = true, linkcheck_timeout = 20)
        doc.blueprint.pages["testpage"] = Documenter.Page("", "", "", [], Documenter.Globals(), src)
        @test_logs (:warn,) (:warn,) @test linkcheck(doc) === nothing
        @test doc.internal.errors == Set{Symbol}()
    end

    @testset "Empty User-Agent" begin
        # This used to point to
        #
        #   https://www.intel.com/content/www/us/en/developer/tools/oneapi/mpi-library.html)
        #
        # but now we use a mock HTTP server, to guarantee that the server's behavior doesn't change.
        src = convert(
            MarkdownAST.Node,
            Markdown.parse(
                """
                [Linkcheck Empty UA](http://localhost:$(PORT)/content/www/us/en/developer/tools/oneapi/mpi-library.html)
                """
            )
        )

        # The default user-agent fails (server blocks it, returns a 500)
        doc = Documenter.Document(; linkcheck = true, linkcheck_timeout = 20)
        doc.blueprint.pages["testpage"] = Documenter.Page("", "", "", [], Documenter.Globals(), src)
        @test_logs (:error,) @test linkcheck(doc) === nothing
        @test doc.internal.errors == Set{Symbol}([:linkcheck])

        # You can work around by setting linkcheck_useragent=nothing and defaulting to the Curl's user agent
        doc = Documenter.Document(; linkcheck = true, linkcheck_timeout = 20, linkcheck_useragent = nothing)
        doc.blueprint.pages["testpage"] = Documenter.Page("", "", "", [], Documenter.Globals(), src)
        @test linkcheck(doc) === nothing
        @test doc.internal.errors == Set{Symbol}()
    end

    @testset "Failures" begin
        src = convert(MarkdownAST.Node, Markdown.parse("[FILE failure](file://$(@__FILE__))"))
        doc = Documenter.Document(; linkcheck = true)
        doc.blueprint.pages["testpage"] = Documenter.Page("", "", "", [], Documenter.Globals(), src)
        @test_logs (:error,) @test linkcheck(doc) === nothing
        @test doc.internal.errors == Set{Symbol}([:linkcheck])

        src = Markdown.parse("[Timeout](http://httpbin.org/delay/3)")
        doc = Documenter.Document(; linkcheck = true, linkcheck_timeout = 0.1)
        doc.blueprint.pages["testpage"] = Documenter.Page("", "", "", [], Documenter.Globals(), src)
        @test_logs (:error,) @test linkcheck(doc) === nothing
        @test doc.internal.errors == Set{Symbol}([:linkcheck])
    end

    @testset "Linkcheck in Docstrings" begin
        include("docstring_links/make.jl")
    end

end

# Close the mock HTTP server
close(server)

end # module

# A module that provides several renderers for `Document` objects. The supported
# formats are currently:
#
#   * `:html` -- generates a complete HTML site with navigation and search included.
#   * `:latex` -- generates a PDF using LuaLaTeX.

#
# Format selector definitions.
#

abstract type FormatSelector <: Selectors.AbstractSelector end

abstract type LaTeXFormat <: FormatSelector end
abstract type HTMLFormat <: FormatSelector end

Selectors.order(::Type{LaTeXFormat}) = 2.0
Selectors.order(::Type{HTMLFormat}) = 3.0

Selectors.matcher(::Type{LaTeXFormat}, fmt, _) = isa(fmt, LaTeXWriter.LaTeX)
Selectors.matcher(::Type{HTMLFormat}, fmt, _) = isa(fmt, HTMLWriter.HTML)

Selectors.runner(::Type{LaTeXFormat}, fmt, doc) = LaTeXWriter.render(doc, fmt)
Selectors.runner(::Type{HTMLFormat}, fmt, doc) = HTMLWriter.render(doc, fmt)

"""
Writes a [`Documenter.Document`](@ref) object to `.user.build` directory in
the formats specified in the `.user.format` vector.

Adding additional formats requires adding new `Selector` definitions as follows:

```julia
abstract type CustomFormat <: FormatSelector end

Selectors.order(::Type{CustomFormat}) = 4.0 # or a higher number.
Selectors.matcher(::Type{CustomFormat}, fmt, _) = fmt === :custom
Selectors.runner(::Type{CustomFormat}, _, doc) = CustomWriter.render(doc)

# Definition of `CustomWriter` module below...
```
"""
function render(doc::Documenter.Document)
    # Render each format. Additional formats must define an `order`, `matcher`, `runner`, as
    # well as their own rendering methods in a separate module.
    for each in doc.user.format
        Selectors.dispatch(FormatSelector, each, doc)
    end
    return
end

# This file checks that the compiled CSS files for the HTML themes are up to date.
#
# This does not run as part of the standard test suite, since the CSS produced by libsass
# is likely not deterministic across libsass versions.
#
# However, we can still run these tests as part of the CI, and ignore the results as needed.
using Test
using Documenter: HTMLWriter, git

const MAKE = Sys.which("make")
isnothing(MAKE) && error("Can't find `make` command")

@testset "HTML themes" begin
    @test isdir(HTMLWriter.ASSETS)
    @test isdir(HTMLWriter.ASSETS_SASS)
    @test isdir(HTMLWriter.ASSETS_THEMES)

    @testset "Remove: $(theme).css" for theme in HTMLWriter.THEMES
        # catppuccin-* themes are templated based on a common catppuccin.scss source file
        scss = replace(theme, r"(?<=^catppuccin)-[a-z]+$" => "")
        @test isfile(joinpath(HTMLWriter.ASSETS_SASS, "$(scss).scss"))

        css = joinpath(HTMLWriter.ASSETS_THEMES, "$(theme).css")
        @test isfile(css)
        @info "Removing $(theme).css" css
        rm(css)
    end

    @info "Rebuilding all the themes"
    run(`$MAKE -C $(@__DIR__) all`)

    # The `make` command should recreate all the CSS files, so we double check that
    # here, and also do a `git diff` check on it.
    @testset "Check: $(theme).css" for theme in HTMLWriter.THEMES
        @info "Checking $(theme).css"
        css = joinpath(HTMLWriter.ASSETS_THEMES, "$(theme).css")
        @test isfile(css)
        # Verify that the CSS file hasn't changed (exit code 1 indicates that it has)
        git_cmd = `$(git()) -C $(@__DIR__) diff --quiet $(css)`
        p = run(ignorestatus(git_cmd))
        if p.exitcode ∉ (0, 1)
            # An exit code that is not 0 or 1 indicates an unexpected failure
            # with the Git command (e.g. the file does not exist).
            @error "Git diff check failed unexpectedly for $(theme).css" css git_cmd
        end
        @test p.exitcode == 0
    end
end

# Implements deploydocs()

"""
    deploydocs(
        root = "<current-directory>",
        target = "build",
        dirname = "",
        repo = "<required>",
        branch = "gh-pages",
        deps = nothing | <Function>,
        make = nothing | <Function>,
        cname = nothing | <String>,
        devbranch = nothing,
        devurl = "dev",
        versions = ["stable" => "v^", "v#.#", devurl => devurl],
        forcepush = false,
        deploy_config = auto_detect_deploy_system(),
        push_preview = false,
        repo_previews = nothing,
        deploy_repo = nothing,
        branch_previews = branch,
        tag_prefix = "",
    )

Copies the files generated by [`makedocs`](@ref) in `target` to the appropriate
(sub-)folder in `dirname` on the deployment `branch`, commits them, and pushes
to `repo`.

This function should be called from within a package's `docs/make.jl` file after
the call to [`makedocs`](@ref), like so

```julia
using Documenter, PACKAGE_NAME
makedocs(
    # options...
)
deploydocs(
    repo = "github.com/..."
)
```

When building the docs for a tag (i.e. a release) the documentation is deployed to
a directory with the tag name (i.e. `vX.Y.Z`) and to the `stable` directory.
Otherwise the docs are deployed to the directory determined by the `devurl` argument.

The deployment procedure consists of the following steps:

* Check out the `branch` of `repo` to a temporary location.
* Remove the existing deployment (sub-)directory with `git rm -r`.
* Copy the `target` (build) folder to the deployment directory.
* Generate `index.html`, and `versions.js` in the `branch` root and
  `siteinfo.js` in the deployment directory.
* Add all files on the deployment `branch` (`git add -A .`), commit them, and
  push to the `repo`. Note that any `.gitignore` files in the `target` directory
  affect which files will be committed to `branch`.

!!! note
    The `index.html` will be created at the `branch` root if and only if
    one of the following two conditions hold:

    1. No such file already exists.

    2. The file exists and starts with the HTML comment

       ```html
       <!--This file is automatically generated by Documenter.jl-->
       ```

# Required keyword arguments

**`repo`** is the remote repository where generated HTML content should be pushed to. Do not
specify any protocol - "https://" or "git@" should not be present. This keyword *must*
be set and will throw an error when left undefined. For example this package uses the
following `repo` value:

```julia
repo = "github.com/JuliaDocs/Documenter.jl.git"
```

# Optional keyword arguments

**`deploy_config`** determines configuration for the deployment.
If this is not specified Documenter will try to autodetect from the
currently running environment. See the manual section about
[Deployment systems](@ref).

**`root`** has the same purpose as the `root` keyword for [`makedocs`](@ref).

**`target`** is the directory, relative to `root`, where generated content that should be
deployed to `gh-pages` is written to. It should generally be the same as
[`makedocs`](@ref)'s `build` and defaults to `"build"`.

**`branch`** is the branch where the generated documentation is pushed. If the branch does
not exist, a new orphaned branch is created automatically. It defaults to `"gh-pages"`.

**`dirname`** is a subdirectory of `branch` that the docs should be added to. By default,
it is `""`, which will add the docs to the root directory.

**`cname`** is the CNAME where the documentation will be hosted, which is equivalent to
the GitHub Pages "Custom domain" setting in the repository settings. If set, it will be
used to generate the `CNAME` file, which has a higher priority than the GitHub Pages settings.

**`devbranch`** is the branch that "tracks" the in-development version of the generated
documentation. By default Documenter tries to figure this out using `git`. Can be set
explicitly as a string (typically `"master"` or `"main"`).

**`devurl`** is the folder to which the in-development version of the docs will be deployed.
Defaults to `"dev"`.

**`forcepush`** is a boolean that specifies the behavior of the git-deployment.
The default (`forcepush = false`) is to push a new commit, but when
`forcepush = true` the changes will be combined with the previous commit and
force pushed (with lease), erasing the Git history on the deployment branch.

**`versions`** determines content and order of the resulting version selector in
the generated html. The following entries are valid in the `versions` vector:
 - `"v#"`: includes links to the latest documentation for each major release cycle
   (i.e. `v2.0`, `v1.1`).
 - `"v#.#"`: includes links to the latest documentation for each minor release cycle
   (i.e. `v2.0`, `v1.1`, `v1.0`, `v0.1`).
 - `"v#.#.#"`: includes links to all released versions.
 - `"v^"`: includes a link to the docs for the maximum version
   (i.e. a link `vX.Y` pointing to `vX.Y.Z` for highest `X`, `Y`, `Z`, respectively).
 - A pair, e.g. `"first" => "second"`, which will put `"first"` in the selector,
   and generate a url from which `"second"` can be accessed.
   The second argument can be `"v^"`, to point to the maximum version docs
   (as in e.g. `"stable" => "v^"`).
If `versions = nothing` documentation will be deployed directly to the "root", i.e.
not to a versioned subfolder. See the manual section on
[Deploying without the versioning scheme](@ref) for more details.

**`deploy_repo`** can be used to override the remote repository to deploy to, which
normally will be the same as `repo` (if this is unset or set to `nothing`). This is mostly
used when the documentation is deployed to a dedicated "docs hosting repository", usually
to avoid issues with the main repository's `gh-pages` branch getting too large. The
expected format of the argument is the same as for `repo`.

**`push_preview`** is a boolean that specifies if preview documentation should be
deployed from pull requests or not. If your published documentation is hosted
at `"https://USER.github.io/PACKAGE.jl/stable"`, by default the preview will be
hosted at `"https://USER.github.io/PACKAGE.jl/previews/PR##"`. This feature
works for pull requests with head branch in the same repository, i.e. not from
forks.

**`branch_previews`** is the branch to which pull request previews are deployed.
It defaults to the value of `branch`.

**`repo_previews`** can be used to override the remote repository to which pull request previews are
deployed. If this is not set, it will be the same as `deploy_repo` (if that is set) or `repo` otherwise.
The expected format of the argument is the same as for `repo`.

!!! note
    Pull requests made from forks will not have previews.
    Hosting previews requires access to the deploy key.
    Therefore, previews are available only for pull requests that were
    submitted directly from the main repository.
    On GitHub Actions, `GITHUB_TOKEN` must be present for previews to work, even if
    `DOCUMENTER_KEY` is being used to deploy.

!!! note
    Previews generated are NOT automatically cleaned up. This can be done manually or
    automated. A GitHub Actions workflow for automating the same can be found
    [here](@ref "Cleaning up `gh-pages`").

**`deps`** can be set to a function or a callable object and gets called during deployment,
and is usually used to install additional dependencies. By default, nothing gets executed.

**`make`** can be set to a function or a callable object and gets called during deployment,
and is usually used to specify additional build steps. By default, nothing gets executed.

**`tag_prefix`** can be set to allow prefixed version numbers to determine the version
number of a release. If `tag_prefix = ""` (the default), only version tags will trigger
deployment; with a non-empty `tag_prefix`, only version tags with that prefix will
trigger deployment. See manual sections on [Documentation Versions](@ref) and
[Deploying from a monorepo](@ref) for more details.

# Releases vs development branches

[`deploydocs`](@ref) will automatically figure out whether it is deploying the documentation
for a tagged release or just a development branch (usually, based on the environment
variables set by the CI system).

With versioned tags, [`deploydocs`](@ref) discards the build metadata (i.e. `+` and
everything that follows it) from the version number when determining the name of the
directory into which the documentation gets deployed, as well as the `tag_prefix`
(if present). Pre-release identifiers are preserved.

# See Also

The [Hosting Documentation](@ref) section of the manual provides a step-by-step guide to
using the [`deploydocs`](@ref) function to automatically generate docs and push them to
GitHub.
"""
function deploydocs(;
        root = currentdir(),
        target = "build",
        dirname = "",

        repo = error("no 'repo' keyword provided."),
        branch = "gh-pages",
        deploy_repo = nothing,

        repo_previews = nothing,
        branch_previews = branch,

        deps = nothing,
        make = nothing,

        cname = nothing,
        devbranch = nothing,
        devurl = "dev",
        versions = ["stable" => "v^", "v#.#", devurl => devurl],
        forcepush::Bool = false,
        deploy_config = auto_detect_deploy_system(),
        push_preview::Bool = false,
        tag_prefix = "",

        archive = nothing, # experimental and undocumented
    )

    # Try to figure out default branch (see #1443 and #1727)
    if devbranch === nothing
        devbranch = git_remote_head_branch("deploydocs(devbranch = ...)", root)
    end

    if !isnothing(archive)
        # If archive is a relative path, we'll make it relative to the make.jl
        # directory (e.g. docs/)
        archive = joinpath(root, archive)
        ispath(archive) && error("Output archive exists: $archive")
    end

    deploy_decision = deploy_folder(
        deploy_config;
        branch = branch,
        branch_previews = branch_previews,
        devbranch = devbranch,
        devurl = devurl,
        push_preview = push_preview,
        repo = repo,
        repo_previews = repo_previews,
        deploy_repo = deploy_repo,
        tag_prefix
    )
    if deploy_decision.all_ok
        deploy_branch = deploy_decision.branch
        deploy_repo = deploy_decision.repo
        deploy_is_preview = deploy_decision.is_preview

        # this dispatches on `versions` for a non-public API for DocumenterVitepress
        deploy_subfolder = determine_deploy_subfolder(deploy_decision, versions)

        # Install dependencies when applicable.
        if deps !== nothing
            @debug "installing dependencies."
            deps()
        end
        # Change to the root directory and try to deploy the docs.
        cd(root) do
            # Find the commit sha.
            # We'll make sure we run the git commands in the source directory (root), in case
            # the working directory has been changed (e.g. if the makedocs' build argument is
            # outside root).
            sha = try
                readchomp(`$(git()) rev-parse --short HEAD`)
            catch
                # git rev-parse will throw an error and return code 128 if it is not being
                # run in a git repository, which will make run/readchomp throw an exception.
                # We'll assume that if readchomp fails it is due to this and set the sha
                # variable accordingly.
                "(not-git-repo)"
            end

            @debug "setting up target directory."
            isdir(target) || mkpath(target)
            if !startswith(realpath(target), realpath(root))
                error(
                    """
                    target must be a subdirectory of root, got:
                      target: $(realpath(target))
                      root: $(realpath(root))
                    """
                )
            end
            # Run extra build steps defined in `make` if required.
            if make !== nothing
                @debug "running extra build steps."
                make()
            end
            objects_inv = joinpath(realpath(target), "objects.inv")
            if isfile(objects_inv)
                inventory_version = _get_inventory_version(objects_inv)
                deploy_version = _get_deploy_version(deploy_subfolder)
                if !isempty(deploy_version) && (inventory_version != deploy_version)
                    if !isempty(inventory_version)
                        @warn "Inventory declares version `$inventory_version`, but `deploydocs` is for version `$deploy_version`. Overwriting inventory version."
                    end
                    _patch_inventory_version(objects_inv, deploy_version)
                end
            end
            @debug "pushing new documentation to remote: '$deploy_repo:$deploy_branch'."
            mktempdir() do temp
                git_push(
                    root, temp, deploy_repo;
                    branch = deploy_branch, dirname = dirname, target = target,
                    sha = sha, deploy_config = deploy_config, subfolder = deploy_subfolder,
                    cname = cname, devurl = devurl,
                    versions = versions, forcepush = forcepush,
                    is_preview = deploy_is_preview, archive = archive,
                )
            end
        end
    end
    return
end

function _get_inventory_version(objects_inv)
    return open(objects_inv) do input
        for line in eachline(input)
            if startswith(line, "# Version:")
                return strip(line[11:end])
            end
        end
        error("Invalid $objects_inv: missing or invalid version line")
    end
end


function _patch_inventory_version(objects_inv, version)
    objects_inv_patched = tempname()
    open(objects_inv) do input
        open(objects_inv_patched, "w") do output
            for line in eachline(input; keep = true)
                if startswith(line, "# Version:")
                    @debug "Patched $objects_inv with version=$version"
                    line = "# Version: $version\n"
                end
                write(output, line)
            end
        end
    end
    mv(objects_inv_patched, objects_inv; force = true)
    return
end


function _get_deploy_version(foldername)
    try
        return string(VersionNumber(foldername))  # strips the leading "v" from foldername
    catch
        return ""
    end
end


"""
    git_push(
        root, tmp, repo;
        branch = "gh-pages", dirname = "", target = "site", sha = "",
        cname = nothing, devurl = "dev",
        deploy_config, subfolder
    )

Handles pushing changes to the remote documentation branch.
The documentation is placed in the folder specified by `subfolder`.
"""
function git_push(
        root, temp, repo;
        branch = "gh-pages", dirname = "", target = "site", sha = "",
        cname = nothing, devurl = "dev",
        versions, forcepush = false, deploy_config, subfolder,
        is_preview::Bool = false, archive,
    )
    dirname = isempty(dirname) ? temp : joinpath(temp, dirname)
    isdir(dirname) || mkpath(dirname)

    target_dir = abspath(target)

    # Generate a closure with common commands for ssh and https
    function git_commands(sshconfig = nothing)
        # Setup git.
        run(`$(git()) init --initial-branch=main`) # specify initial branch just to turn off the advice in the deploy logs
        run(`$(git()) config user.name "Documenter.jl"`)
        run(`$(git()) config user.email "documenter@juliadocs.github.io"`)
        run(`$(git()) config commit.gpgsign false`)
        if sshconfig !== nothing
            run(`$(git()) config core.sshCommand "ssh -F $(sshconfig)"`)
        end

        # Fetch from remote and checkout the branch.
        run(`$(git()) remote add upstream $upstream`)
        try
            run(`$(git()) fetch upstream`)
        catch
            @error """
            Git failed to fetch $upstream
            This can be caused by a DOCUMENTER_KEY variable that is not correctly set up.
            Make sure that the environment variable is properly set up as a Base64-encoded string
            of the SSH private key. You may need to re-generate the keys with DocumenterTools.
            """
            rethrow()
        end

        try
            run(`$(git()) checkout -b $branch upstream/$branch`)
        catch e
            @info """
            Checking out $branch failed, creating a new orphaned branch.
            This usually happens when deploying to a repository for the first time and
            the $branch branch does not exist yet. The fatal error above is expected output
            from Git in this situation.
            """
            @debug "checking out $branch failed with error: $e"
            run(`$(git()) checkout --orphan $branch`)
            run(`$(git()) commit --allow-empty -m "Initial empty commit for docs"`)
        end

        # Copy docs to `subfolder` directory.
        deploy_dir = subfolder === nothing ? dirname : joinpath(dirname, subfolder)
        gitrm_copy(target_dir, deploy_dir)

        # Generate the CNAME file if `cname` is set.
        if !isnothing(cname)
            write(joinpath(dirname, "CNAME"), cname)
        end

        # this dispatches on `versions` for a non-public API for DocumenterVitepress
        postprocess_before_push(versions; subfolder, devurl, deploy_dir, dirname)

        # Add, commit, and push the docs to the remote.
        run(`$(git()) add -A -- ':!.documenter-identity-file.tmp' ':!**/.documenter-identity-file.tmp'`)
        if !success(`$(git()) diff --cached --exit-code`)
            if !isnothing(archive)
                run(`$(git()) commit -m "build based on $sha"`)
                @info "Skipping push and writing repository to an archive" archive
                run(`$(git()) archive -o $(archive) HEAD`)
            elseif forcepush
                run(`$(git()) commit --amend --date=now -m "build based on $sha"`)
                run(`$(git()) push -q --force-with-lease upstream HEAD:$branch`)
            else
                run(`$(git()) commit -m "build based on $sha"`)
                run(`$(git()) push -q upstream HEAD:$branch`)
            end
        else
            @debug "new docs identical to the old -- not committing nor pushing."
        end
        return
    end

    if authentication_method(deploy_config) === SSH
        # Get the parts of the repo path and create upstream repo path
        user, host, upstream = user_host_upstream(repo)

        keyfile = abspath(joinpath(root, ".documenter-identity-file.tmp"))
        ispath(keyfile) && error("Keyfile not cleaned up from last run: $(keyfile)")
        try
            if is_preview
                keycontent = documenter_key_previews(deploy_config)
            else
                keycontent = documenter_key(deploy_config)
            end
            write(keyfile, _decode_key_content(keycontent))
            chmod(keyfile, 0o600) # user-only rw permissions
        catch e
            @error """
            Documenter failed to decode the DOCUMENTER_KEY environment variable.
            Make sure that the environment variable is properly set up as a Base64-encoded string
            of the SSH private key. You may need to re-generate the keys with DocumenterTools.
            """
            rm(keyfile; force = true)
            rethrow(e)
        end

        try
            mktemp() do sshconfig, io
                print(
                    io,
                    """
                    Host $host
                        StrictHostKeyChecking no
                        User $user
                        HostName $host
                        IdentityFile "$keyfile"
                        IdentitiesOnly yes
                        BatchMode yes
                    """
                )
                close(io)
                chmod(sshconfig, 0o600)
                # git config core.sshCommand requires git 2.10.0, but
                # GIT_SSH_COMMAND works from 2.3.0 so define both.
                withenv("GIT_SSH_COMMAND" => "ssh -F $(sshconfig)", NO_KEY_ENV...) do
                    cd(() -> git_commands(sshconfig), temp)
                end
            end
            post_status(deploy_config; repo = repo, type = "success", subfolder = subfolder)
        catch e
            @error "Failed to push:" exception = (e, catch_backtrace())
            post_status(deploy_config; repo = repo, type = "error")
            rethrow(e)
        finally
            # Remove the unencrypted private key.
            isfile(keyfile) && rm(keyfile)
        end
    else # authentication_method(deploy_config) === HTTPS
        # The upstream URL to which we push new content authenticated with token
        upstream = authenticated_repo_url(deploy_config)
        try
            cd(() -> withenv(git_commands, NO_KEY_ENV...), temp)
            post_status(deploy_config; repo = repo, type = "success", subfolder = subfolder)
        catch e
            @error "Failed to push:" exception = (e, catch_backtrace())
            post_status(deploy_config; repo = repo, type = "error")
            rethrow(e)
        end
    end
    return
end

# Run arbitrary logic (for example, creating siteinfo and version files)
# on the documentation with the new additions before the changes are pushed to the remote.
# The logic depends on the versioning scheme defined via `versions`.
# This function was factored out as part of a non-public API via dispatch on the `versions` keyword arg
# to `deploydocs`, for use in DocumenterVitepress because it cannot use the default versioning.
function postprocess_before_push(versions::Nothing; subfolder, devurl, deploy_dir, dirname)
    # If the documentation is unversioned and deployed to root, we generate a
    # siteinfo.js file that would disable the version selector in the docs
    HTMLWriter.generate_siteinfo_file(deploy_dir, nothing)
    return
end

# The default fallback method which we will use unless the user is passing a custom versions
# object and has overridden this method.
function postprocess_before_push(versions::Any; subfolder, devurl, deploy_dir, dirname)
    # Generate siteinfo-file with DOCUMENTER_CURRENT_VERSION
    # Determine if this is a development version (e.g., "dev" or "latest")
    is_dev_version = (subfolder == devurl || subfolder == "latest")
    HTMLWriter.generate_siteinfo_file(deploy_dir, subfolder, is_dev_version)

    # Expand the users `versions` vector
    entries, symlinks = HTMLWriter.expand_versions(dirname, versions)

    # Create the versions.js file containing a list of `entries`.
    # This must always happen after the folder copying.
    HTMLWriter.generate_version_file(joinpath(dirname, "versions.js"), entries, symlinks)

    # Create the index.html file to redirect ./stable or ./dev.
    # This must always happen after the folder copying.
    HTMLWriter.generate_redirect_file(joinpath(dirname, "index.html"), entries)

    # generate the symlinks, make sure we don't overwrite devurl
    return cd(dirname) do
        for kv in symlinks
            i = findfirst(x -> x.first == devurl, symlinks)
            if i === nothing
                rm_and_add_symlink(kv.second, kv.first)
            else
                throw(
                    ArgumentError(
                        string(
                            "link `$(kv)` cannot overwrite ",
                            "`devurl = $(devurl)` with the same name."
                        )
                    )
                )
            end
        end
    end
end

# Determine the subfolder to deploy to given the `deploy_decision` and the `versions`.
# Either return a `String` or `nothing` to deploy to the root folder.
# This function was factored out as part of a non-public API via dispatch on the `versions` keyword arg
# to `deploydocs`, for use in DocumenterVitepress because it cannot use the default versioning.
function determine_deploy_subfolder(deploy_decision, versions::Nothing)
    # Non-versioned docs: deploy to root unless it's a preview
    return deploy_decision.is_preview ? deploy_decision.subfolder : nothing
end
# Method to handle the standard versions = [...] argument.
function determine_deploy_subfolder(deploy_decision, versions::AbstractVector)
    return deploy_decision.subfolder
end
# Fallback determine_deploy_subfolder for any non-standard `versions` arguments.
function determine_deploy_subfolder(deploy_decision, versions::Any)
    @warn """
    Using a non-standard versions= argument, but determine_deploy_subfolder() is not implemented.
    """ typeof(versions) versions
    return deploy_decision.subfolder
end

function rm_and_add_symlink(target, link)
    if ispath(link) || islink(link)
        @warn "removing `$(link)` and linking `$(link)` to `$(target)`."
        rm(link; force = true, recursive = true)
    end
    symlink(target, link)
    return
end

"""
    user_host_upstream(repo)

Disassemble repo address into user, host, and path to repo. If no user is given, default to
"git". Reassemble user, host and path into an upstream to `git push` to.
"""
function user_host_upstream(repo)
    # If the repo path contains the protocol, throw immediately an error.
    occursin(r"^[a-z]+://", repo) && error("The repo path $(repo) should not contain the protocol (e.g. 'https://')")
    #= the regex has three parts:
    (?:([^@]*)@)?  matches any number of characters up to the first "@", if present,
        capturing only the characters before the "@" - this captures the username
    (?:([^\/:]*)[\/:]){1}  matches exactly one instance of any number of characters
        other than "/" or ":" up to the first "/" or ":" - this captures the hostname
    [\/]?(.*)  matches the rest of the repo, except an initial "/" if present (e.g. if
        repo is of the form usr@host:/path/to/repo) - this captures the path on the host
    =#
    m = match(r"(?:([^@]*)@)?(?:([^\/:]*)[\/:]){1}[\/]?(.*)", repo)
    (m === nothing) && error("Invalid repo path $repo")
    user, host, pth = m.captures
    user = (user === nothing) ? "git" : user
    upstream = "$user@$host:$pth"
    return user, host, upstream
end

"""
    gitrm_copy(src, dst)

Uses `git rm -r` to remove `dst` and then copies `src` to `dst`. Assumes that the working
directory is within the git repository of `dst` when the function is called.

This is to get around [#507](https://github.com/JuliaDocs/Documenter.jl/issues/507) on
filesystems that are case-insensitive (e.g. on OS X, Windows). Without doing a `git rm`
first, `git add -A` will not detect case changes in filenames.
"""
function gitrm_copy(src, dst)
    # Remove individual entries since with versions=nothing the root
    # would be removed and we want to preserve previews
    if isdir(dst)
        for x in filter!(!in((".git", "previews")), readdir(dst))
            # --ignore-unmatch so that we wouldn't get errors if dst does not exist
            run(`$(git()) rm -rf --ignore-unmatch $(joinpath(dst, x))`)
        end
    end
    # git rm also remove parent directories
    # if they are empty so need to mkpath after
    mkpath(dst)
    # Copy individual entries rather then the full folder since with
    # versions=nothing it would replace the root including e.g. the .git folder
    for x in readdir(src)
        cp(joinpath(src, x), joinpath(dst, x); force = true)
    end
    return
end

module ExceptTests
using Test
using Documenter: except, ERROR_NAMES

@testset "Documenter.except" begin
    @test_throws DomainError except(:foobar)
    @test_throws MethodError except([:linkcheck])
    @test sort(except()) == sort(ERROR_NAMES)
    @test sort(except(:linkcheck)) == sort(filter(!isequal(:linkcheck), ERROR_NAMES))
    @test isempty(except(ERROR_NAMES...))
end

end

isdefined(Main, :TestUtilities) || @eval Main module TestUtilities
using Test
import IOCapture

export @quietly, trun

const QUIETLY_LOG_DIR = joinpath(@__DIR__, "quietly-logs")
const QUIETLY_LOG_COUNTER = Ref{Int}(0)

quietly_logs_enabled() = haskey(ENV, "DOCUMENTER_TEST_QUIETLY")

function quietly_logfile(n)
    logid = lpad(n, 4, '0')
    return logid, joinpath(QUIETLY_LOG_DIR, "quietly.$(logid).log")
end
function quietly_next_log()
    quietly_logs_enabled() || return nothing, nothing
    isdir(QUIETLY_LOG_DIR) || mkdir(QUIETLY_LOG_DIR)
    # Find the next available log file
    logid, logfile = quietly_logfile(QUIETLY_LOG_COUNTER[])
    while isfile(logfile)
        QUIETLY_LOG_COUNTER[] += 1
        logid, logfile = quietly_logfile(QUIETLY_LOG_COUNTER[])
    end
    return logid, logfile
end

function __init__()
    # We only clean up the old log files if DOCUMENTER_TEST_QUIETLY is set
    quietly_logs_enabled() || return
    isdir(QUIETLY_LOG_DIR) && rm(QUIETLY_LOG_DIR, recursive = true)
    return
end

struct QuietlyException <: Exception
    logid::Union{String, Nothing}
    exception
    backtrace
end

function Base.showerror(io::IO, e::QuietlyException)
    prefix = isnothing(e.logid) ? "@quietly" : "@quietly[$(e.logid)]"
    println(io, "$(prefix) hit an exception ($(typeof(e.exception))):")
    showerror(io, e.exception, e.backtrace)
end

function _quietly(f, expr, source)
    c = IOCapture.capture(f; rethrow = InterruptException)
    logid, logfile = quietly_next_log()
    isnothing(logid) || open(logfile; write = true, append = true) do io
        println(io, "@quietly: c.error = $(c.error) / $(sizeof(c.output)) bytes of output captured")
        println(io, "@quietly: $(source.file):$(source.line)")
        println(io, "@quietly: typeof(result) = ", typeof(c.value))
        println(io, "@quietly: STDOUT")
        println(io, c.output)
        println(io, "@quietly: end of STDOUT")
        if c.error
            println(io, "@quietly: result (error) =")
            showerror(io, c.value, c.backtrace)
        else
            println(io, "@quietly: result =")
            println(io, c.value)
        end
    end
    prefix = isnothing(logid) ? "@quietly" : "@quietly[$logid]"
    if c.error
        @error """
        $(prefix): an error was thrown, $(sizeof(c.output)) bytes of output captured
        $(typeof(c.value)) at $(source.file):$(source.line) in expression:
        $(expr)
        """ exception = (c.value, c.backtrace)
        if !isempty(c.output)
            printstyled("$("="^21) $(prefix): output from the expression $("="^21)\n"; color = :magenta)
            print(c.output)
            last(c.output) != "\n" && println()
            printstyled("$("="^27) $(prefix): end of output $("="^28)\n"; color = :magenta)
        end
        throw(QuietlyException(logid, c.value, c.backtrace))
    elseif c.value isa Test.DefaultTestSet && !is_success(c.value)
        @error """
        $(prefix): a testset with failures, $(sizeof(c.output)) bytes of output captured
        $(typeof(c.value)) at $(source.file):$(source.line) in expression:
        $(expr)
        """ TestSet = c.value
        if !isempty(c.output)
            printstyled("$("="^21) $(prefix): output from the expression $("="^21)\n"; color = :magenta)
            print(c.output)
            last(c.output) != "\n" && println()
            printstyled("$("="^27) $(prefix): end of output $("="^28)\n"; color = :magenta)
        end
        return c.value
    else
        printstyled("$(prefix): success, $(sizeof(c.output)) bytes of output hidden\n"; color = :magenta)
        return c.value
    end
end
macro quietly(expr)
    orig_expr = Expr(:inert, expr)
    source = QuoteNode(__source__)
    return quote
        _quietly($orig_expr, $source) do
            $(esc(expr))
        end
    end
end

# Julia 1.13 change the .anynonpass field of the DefaultTestSet from a simple Bool
# to an UInt. On the other hand, it added a convenience function to get the Bool.
# So for compat, we just check the existence of the anynonpass() function.
# X-ref: https://github.com/JuliaLang/julia/pull/59374
function any_non_pass(testset::Test.DefaultTestSet)
    @static if isdefined(Test, :anynonpass)
        return Test.anynonpass(testset)
    else
        return testset.anynonpass
    end
end

is_success(testset::Test.DefaultTestSet) = !(any_non_pass(testset) || !is_success(testset.results))
is_success(ts::AbstractArray) = all(is_success.(ts))
is_success(::Test.Fail) = false
is_success(::Test.Pass) = true
function is_success(x)
    @warn "Unimplemented TestUtilities.is_success method" typeof(x) x
    return false
end

function trun(cmd::Base.AbstractCmd)
    buffer = IOBuffer()
    cmd_redirected = pipeline(cmd; stdin = devnull, stdout = buffer, stderr = buffer)
    try
        run(cmd_redirected)
        return true
    catch e
        @error """
        Running external program $(cmd) failed, output:
        $(String(take!(buffer)))
        """ exception = (e, catch_backtrace())
        return false
    end
end

end

# Hosting Documentation

After going through the [Package Guide](@ref) and [Doctests](@ref) page you will need to
host the generated documentation somewhere for potential users to read. This guide will
describe how to set up automatic updates for your package docs using either the Travis CI
build service or GitHub Actions together with GitHub Pages for hosting the generated
HTML files. This is the same approach used by this package to host its own docs --
the docs you're currently reading.

!!! note

    Following this guide should be the *final* step you take after you are comfortable with
    the syntax and build process used by `Documenter.jl`. It is recommended that you only
    proceed with the steps outlined here once you have successfully managed to build your
    documentation locally with Documenter.

    This guide assumes that you already have [GitHub](https://github.com/) and
    [Travis](https://www.travis-ci.com/) accounts set up. If not then go set those up first and
    then return here.

    It is possible to deploy from other systems than Travis CI or GitHub Actions,
    see the section on [Deployment systems](@ref).


## Overview

Once set up correctly, the following will happen each time you push new updates to your
package repository:

- Buildbots will start up and run your package tests in a "Test" stage.
- After the Test stage completes, a single bot will run a new "Documentation" stage, which
  will build the documentation.
- If the documentation is built successfully, the bot will attempt to push the generated
  HTML pages back to GitHub.

Note that the hosted documentation does not update when you (or other contributors)
make pull requests; you see updates only when you merge to the trunk branch (typically,
`master` or `main`) or push new tags.

In the upcoming sections we describe how to configure the build service to run
the documentation build stage. In general it is easiest to choose the same
service as the one testing your package. If you don't explicitly select
the service with the `deploy_config` keyword argument to `deploydocs`
Documenter will try to automatically detect which system is running and use that.

## GitHub Actions

To run the documentation build from GitHub Actions, create a new workflow
configuration file called `.github/workflows/documentation.yml` with the
following contents:
```yaml
name: Documentation

on:
  push:
    branches:
      - master # update to match your development branch (master, main, dev, trunk, ...)
    tags: '*'
  pull_request:
  workflow_dispatch:

jobs:
  build:
    # These permissions are needed to:
    # - Deploy the documentation: https://documenter.juliadocs.org/stable/man/hosting/#Permissions
    # - Delete old caches: https://github.com/julia-actions/cache#usage
    permissions:
      actions: write
      contents: write
      pull-requests: read
      statuses: write
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v7
      - uses: julia-actions/setup-julia@v3
        with:
          version: '1'
      - uses: julia-actions/cache@v3
      - name: Install dependencies
        shell: julia --color=yes --project=docs {0}
        run: |
          using Pkg
          Pkg.develop(PackageSpec(path=pwd()))
          Pkg.instantiate()
      - name: Build and deploy
        run: julia --color=yes --project=docs docs/make.jl
        env:
          GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }} # If authenticating with GitHub Actions token
          DOCUMENTER_KEY: ${{ secrets.DOCUMENTER_KEY }} # If authenticating with SSH deploy key
```

This will install Julia, checkout the correct commit of your repository, and run the
build of the documentation. The `julia-version:`, `julia-arch:` and `os:` entries decide
the environment from which the docs are built and deployed. The example above builds and deploys
the documentation from an Ubuntu worker running Julia 1.

!!! tip
    The example above is a basic workflow that should suit most projects. For more information on
    how to further customize your action, check out the [GitHub Actions manual](https://docs.github.com/en/actions).

The commands in the lines in the `run:` section do the same as for Travis,
see the previous section.

!!! warning "TagBot & tagged versions"

    In order to deploy documentation for **tagged versions**, the GitHub Actions workflow
    needs to be triggered by the tag. However, by default, when the [Julia TagBot](https://github.com/marketplace/actions/julia-tagbot)
    uses just the `GITHUB_TOKEN` for authentication, it does not have the permission to trigger
    any further workflow jobs, and so the documentation CI job never runs for the tag.

    To work around that, TagBot should be [configured to use `DOCUMENTER_KEY`](https://github.com/marketplace/actions/julia-tagbot#ssh-deploy-keys)
    for authentication, by adding `ssh: ${{ secrets.DOCUMENTER_KEY }}` to the `with` section.
    A complete TagBot workflow file could look as follows:

    ```yml
    name: TagBot
    on:
      issue_comment:
        types:
          - created
      workflow_dispatch:
    jobs:
      TagBot:
        if: github.event_name == 'workflow_dispatch' || github.actor == 'JuliaTagBot'
        runs-on: ubuntu-latest
        steps:
          - uses: JuliaRegistries/TagBot@v1
            with:
              token: ${{ secrets.GITHUB_TOKEN }}
              ssh: ${{ secrets.DOCUMENTER_KEY }}
    ```

### Authentication: `GITHUB_TOKEN`

When running from GitHub Actions it is possible to authenticate using
[the GitHub Actions authentication token
(`GITHUB_TOKEN`)](https://docs.github.com/en/actions/tutorials/authenticate-with-github_token). This is done by adding

```yaml
GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }}
```

to the configuration file, as shown in the [previous section](@ref GitHub-Actions).

!!! note
    You can only use `GITHUB_TOKEN` for authentication if the target repository
    of the deployment is the same as the current repository. In order to push
    elsewhere you should instead use an SSH deploy key.

### [Authentication: SSH Deploy Keys](@id ssh-deploy-keys)

Instead of `GITHUB_TOKEN`, deployment can be authenticated with an SSH deploy key.
A deploy key grants push access to a *single* repository, and, unlike `GITHUB_TOKEN`,
it can point at a repository other than the one running the workflow (see
[Out-of-repo deployment](@ref)).

The key pair is generated with `DocumenterTools.genkeys` from the
[DocumenterTools](https://github.com/JuliaDocs/DocumenterTools.jl) package:

```julia-repl
pkg> add DocumenterTools

julia> using DocumenterTools

julia> DocumenterTools.genkeys(user = "MyUser", repo = "MyPackage.jl")
```

If the package is checked out in development mode with `] dev MyPackage`, the
repository can also be inferred from the package itself:

```julia-repl
julia> using MyPackage

julia> DocumenterTools.genkeys(MyPackage)
```

The output looks similar to this:

```
[ Info: Add the key below as a new 'Deploy key' on GitHub
  (https://github.com/USER/REPO/settings/keys) with read and write access. [...]

[SSH PUBLIC KEY HERE]

[ Info: Add a secure 'Repository secret' named 'DOCUMENTER_KEY' (to
  https://github.com/USER/REPO/settings/secrets if you deploy using GitHub Actions)
  with value:

[LONG BASE64 ENCODED PRIVATE KEY]
```

!!! note

    You will need several command line programs (`which`, `git` and `ssh-keygen`) to be
    installed for the above to work. If DocumenterTools fails, see the
    [SSH Deploy Keys Walkthrough](@ref) section for instructions on how to generate the keys
    manually (including on Windows).

The two halves of the key pair go to two different places in the GitHub settings.
GitHub reorganizes these pages every so often; the paths below are the ones in the
current UI, and the direct URLs are stable.

#### Step 1: add the public key as a deploy key

Go to **Settings** → **Deploy keys** (in the **Security** section of the sidebar) of the
repository the documentation is deployed **to**, i.e.
`https://github.com/USER/REPO/settings/keys`, and click **`Add deploy key`**:

* **`Title`**: e.g. `documenter` (can be left empty, GitHub then infers it from the key comment).
* **`Key`**: the public key from the `genkeys` output.
* **`Allow write access`**: must be **checked**, otherwise Documenter cannot push.

#### Step 2: add the private key as a repository secret

Go to **Settings** → **Secrets and variables** → **Actions** of the repository the
documentation workflow runs **in**, i.e.
`https://github.com/USER/REPO/settings/secrets/actions`, and, on the **`Secrets`** tab,
click **`New repository secret`**:

* **`Name`**: `DOCUMENTER_KEY`
* **`Secret`**: the base64-encoded private key from the `genkeys` output, with
  **no whitespace** and no surrounding quotes.

!!! warning "Pick the right box"

    That page has several similar-looking sections, and putting the key in the wrong one is a
    common cause of failing deployments:

    * Use the **`Secrets`** tab, not the **`Variables`** tab. Variables are not encrypted
      and are not exposed through `secrets.*`.
    * Use **`Repository secrets`**, not **`Environment secrets`**. Environment secrets are
      only visible to jobs that explicitly opt into that environment with an
      `environment:` key, which the workflow above does not have.
    * **`Organization secrets`** work too, if the organization grants the repository access
      to the secret.

!!! warning "Security warning"

    The base64-encoded string contains the *unencrypted* private key that gives full write
    access to the target repository, so it must be kept secret. Never print it in a build
    log, and never merge code that exposes it.

#### Step 3: pass the secret to the doc build

Secrets are not automatically available to a workflow. Make the key available to the
doc-building step by adding

```yaml
DOCUMENTER_KEY: ${{ secrets.DOCUMENTER_KEY }}
```

to the `env:` section of the configuration file, as shown in the
[previous section](@ref GitHub-Actions). See GitHub's manual on
[using secrets in GitHub Actions](https://docs.github.com/en/actions/how-tos/write-workflows/choose-what-workflows-do/use-secrets)
for more information.

!!! tip "Deployment fails with a `github-actions[bot]` permission error"

    An error such as

    ```
    remote: Permission to USER/REPO.git denied to github-actions[bot].
    fatal: unable to access 'https://github.com/USER/REPO.git/': ... error: 403
    ```

    means Documenter fell back to `GITHUB_TOKEN` because `DOCUMENTER_KEY` did not reach the
    build. Documenter logs its deployment criteria before pushing; if that list shows
    `ENV["GITHUB_TOKEN"] exists` rather than `ENV["DOCUMENTER_KEY"] exists`, the secret did
    not arrive. Check that it is a repository secret (step 2) *and* that it is listed in the
    `env:` section of the workflow (step 3).

### Permissions

The following [GitHub Actions job or workflow permissions](https://docs.github.com/en/actions/tutorials/authenticate-with-github_token#modifying-the-permissions-for-the-github_token) are required to successfully use [`deploydocs`](#the-deploydocs-function):

```yaml
permissions:
  contents: write  # Required when authenticating with `GITHUB_TOKEN`, not needed when authenticating with SSH deploy keys
  pull-requests: read  # Required when using `push_preview=true`
  statuses: write  # Optional, used to report documentation build statuses
```

### Add code coverage from documentation builds

If you want code run during the documentation deployment to be covered by Codecov,
you can edit the end of the docs part of your workflow configuration file so that
`docs/make.jl` is run with the `--code-coverage=user` flag and the coverage reports
are uploaded to Codecov:

```yaml
      - run: julia --project=docs --code-coverage=user docs/make.jl
        env:
          GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }}
          DOCUMENTER_KEY: ${{ secrets.DOCUMENTER_KEY }}
      - uses: julia-actions/julia-processcoverage@v1
      - uses: codecov/codecov-action@v7
```

## Travis CI

To tell Travis that we want a new build stage, we can add the following to an existing `.travis.yml`
file. Note that the snippet below will not work by itself and must be accompanied by a complete Travis file.

```yaml
jobs:
  include:
    - stage: "Documentation"
      julia: 1
      os: linux
      script:
        - julia --project=docs/ -e 'using Pkg; Pkg.develop(PackageSpec(path=pwd()));
                                               Pkg.instantiate()'
        - julia --project=docs/ docs/make.jl
      after_success: skip
```

where the `julia:` and `os:` entries decide the worker from which the docs are built and
deployed. In the example above we will thus build and deploy the documentation from a linux
worker running Julia 1 (the latest stable version). For more information on how to set up a build stage, see the Travis
manual for [Build Stages](https://docs.travis-ci.com/user/build-stages).

The three lines in the `script:` section do the following:

 1. Instantiate the doc-building environment (i.e. `docs/Project.toml`, see below).
 2. Install your package in the doc-build environment.
 3. Run the docs/make.jl script, which builds and deploys the documentation.

!!! note
    If your package has a build script you should call
    `Pkg.build("PackageName")` after the call to `Pkg.develop` to make
    sure the package is built properly.

!!! note "matrix: section in .travis.yml"

    Travis CI used to use `matrix:` as the section to configure the build matrix in the config
    file. This now appears to be a deprecated alias for `jobs:`. If you use both `matrix:` and
    `jobs:` in your configuration, `matrix:` overrides the settings under `jobs:`.

    If your `.travis.yml` file still uses `matrix:`, it should be replaced with a single
    `jobs:` section.

### [Authentication: SSH Deploy Keys (Travis CI)](@id travis-ssh)

Travis CI also authenticates with an SSH deploy key. Generate the key pair with
`DocumenterTools.genkeys` as described in the
[SSH deploy key section](@ref ssh-deploy-keys) above. Only the private key is added
elsewhere:

 1. Add the public ssh key as a deploy key with write access on the
    `https://github.com/USER/REPO/settings/keys` page of the GitHub repository.

 2. Next add the long private key to the Travis settings page at
    `https://app.travis-ci.com/USER/REPO/settings`.
    Again note that you should include **no whitespace** when copying the key. In the **`Environment
    Variables`** section add a key with the name `DOCUMENTER_KEY` and the value that was printed
    out. **Do not** set the variable to be displayed in the build log. Then click **`Add`**.

    !!! warning "Security warning"

        To reiterate: make sure that this key is hidden. In particular, in the Travis CI settings
        the "Display value in build log" option should be **OFF** for
        the variable, so that it does not get printed when the tests run. This
        base64-encoded string contains the *unencrypted* private key that gives full write
        access to your repository, so it must be kept safe.  Also, make sure that you never
        expose this variable in your tests, nor merge any code that does. You can read more
        about Travis environment variables in [Travis User Documentation](https://docs.travis-ci.com/user/environment-variables/#Defining-Variables-in-Repository-Settings).

!!! note

    There are more explicit instructions for adding the keys to Travis in the
    [SSH Deploy Keys Walkthrough](@ref) section of the manual.


## `docs/Project.toml`

The doc-build environment `docs/Project.toml` includes Documenter and other doc-build
dependencies your package might have. If Documenter is the only dependency, then the
`Project.toml` should include the following:

````@eval
import Documenter, Markdown
v = Documenter.DOCUMENTER_VERSION
Markdown.parse("""
```toml
[deps]
Documenter = "e30172f5-a6a5-5a46-863b-614d45cd2de4"

[compat]
Documenter = "$(v.major).$(v.minor)"
```
""")
````

Note that it is recommended that you have a `[compat]` section, like the one above, in your
`Project.toml` file, which would restrict Documenter's version that gets installed when the
build runs. This is to make sure that your builds do not start failing suddenly due to a new
major release of Documenter, which may include breaking changes. However, it also means that
you will not get updates to Documenter automatically, and hence need to upgrade Documenter's
major version yourself.


## The `deploydocs` Function

At the moment your `docs/make.jl` file probably only contains

```julia
using Documenter, PACKAGE_NAME

makedocs()
```

We'll need to add an additional function call to this file after [`makedocs`](@ref) which
would perform the deployment of the docs to the `gh-pages` branch.
Add the following at the end of the file:

```julia
deploydocs(
    repo = "github.com/USER_NAME/PACKAGE_NAME.jl.git",
)
```

where `USER_NAME` and `PACKAGE_NAME` must be set to the appropriate names.
Note that `repo` should not specify any protocol, i.e. it should not begin with `https://`
or `git@`.

See the [`deploydocs`](@ref) function documentation for more details.



## `.gitignore`

Add the following to your package's `.gitignore` file

```
docs/build/
```

These are needed to avoid committing generated content to your repository.

## `gh-pages` Branch

By default, Documenter pushes documentation to the `gh-pages` branch. If the branch does not
exist it will be created automatically by [`deploydocs`](@ref). If it does exist then
Documenter simply adds an additional commit with the built documentation. You should be
aware that Documenter may overwrite existing content without warning.

If you wish to create the `gh-pages` branch manually, that can be done by [creating an "orphan" branch, with the `git checkout --orphan` option](https://git-scm.com/docs/git-checkout#Documentation/git-checkout.txt---orphanltnew-branchgt).

You also need to make sure that you have the `gh-pages` branch and `/ (root)` selected as
[the source of the GitHub Pages site in your GitHub repository
settings](https://docs.github.com/en/pages/getting-started-with-github-pages/configuring-a-publishing-source-for-your-github-pages-site),
so that GitHub would actually serve the contents as a website.

### Cleaning up `gh-pages`

The `gh-pages` branch can become very large, especially when `push_preview` is
enabled to build documentation for each pull request. To clean up the branch and remove
stale documentation previews, a GitHub Actions workflow like the following can be used.

```yaml
name: Doc Preview Cleanup

on:
  pull_request:
    types: [closed]

# Ensure that only one "Doc Preview Cleanup" workflow is force pushing at a time
concurrency:
  group: doc-preview-cleanup
  cancel-in-progress: false

jobs:
  doc-preview-cleanup:
    runs-on: ubuntu-latest
    permissions:
      contents: write
    steps:
      - name: Checkout gh-pages branch
        uses: actions/checkout@v7
        with:
          ref: gh-pages
      - name: Delete preview and history + push changes
        run: |
          if [ -d "${preview_dir}" ]; then
              git config user.name "Documenter.jl"
              git config user.email "documenter@juliadocs.github.io"
              git rm -rf "${preview_dir}"
              git commit -m "delete preview"
              git branch gh-pages-new "$(echo "delete history" | git commit-tree "HEAD^{tree}")"
              git push --force origin gh-pages-new:gh-pages
          fi
        env:
          preview_dir: previews/PR${{ github.event.number }}
```

_This workflow was based on [CliMA/ClimaTimeSteppers.jl](https://github.com/CliMA/ClimaTimeSteppers.jl/blob/0660ace688b4f4b8a86d3c459ab62ccf01d7ef31/.github/workflows/DocCleanup.yml) (Apache License 2.0)._

The `permissions:` line above is described in the
[GitHub Docs](https://docs.github.com/en/actions/tutorials/authenticate-with-github_token#modifying-the-permissions-for-the-github_token);
an alternative is to give GitHub workflows write permissions under the repo settings, e.g.,
`https://github.com/<USER>/<REPO>.jl/settings/actions`.

## Woodpecker CI

To run a documentation build from Woodpecker CI, one should create an access token
from their forge of choice: GitHub, GitLab, or Codeberg (or any Gitea instance).
This access token should be added to Woodpecker CI as a secret named
`project_access_token`. The case does not matter since this will be passed as
an uppercase environment variable to your pipeline. Next, create a new pipeline
configuration file called `.woodpecker.yml` with the following contents:

- Woodpecker 0.15.x and pre-1.0.0

  ```yaml
  pipeline:
      docs:
      when:
          branch: main  # update to match your development branch
      image: julia
      commands:
          - julia --project=docs/ -e 'using Pkg; Pkg.develop(PackageSpec(path=pwd())); Pkg.instantiate()'
          - julia --project=docs/ docs/make.jl
      secrets: [ project_access_token ]  # access token is a secret

  ```

- Woodpecker 1.0.x and onwards

  ```yaml
  steps:
      docs:
      when:
          branch: main  # update to match your development branch
      image: julia
      commands:
          - julia --project=docs/ -e 'using Pkg; Pkg.develop(PackageSpec(path=pwd())); Pkg.instantiate()'
          - julia --project=docs/ docs/make.jl
      secrets: [ project_access_token ]  # access token is a secret

  ```

This will pull an image of julia from docker and run the following commands from
`commands:` which instantiates the project for development and then runs the `make.jl`
file and builds and deploys the documentation to a branch which defaults to `pages`
which you can modify to something else e.g. GitHub → gh-pages, Codeberg → pages.

!!! tip
	The example above is a basic pipeline that suits most projects. Further information
	on how to customize your pipelines can be found in the official woodpecker
	documentation: [Woodpecker CI](https://woodpecker-ci.org/docs/intro).

## Documentation Versions

!!! note
    This section describes the default mode of deployment, which is by version.
    See the following section on [Deploying without the versioning scheme](@ref)
    if you want to deploy directly to the "root".

By default the documentation is deployed as follows:

- Documentation built for a tag `<tag_prefix>vX.Y.Z` will be stored in a folder `vX.Y.Z`,
  determined by the `tag_prefix` keyword to [`deploydocs`](@ref)
  (`""` by default).

- Documentation built from the `devbranch` branch (`master` by default) is stored in a folder
  determined by the `devurl` keyword to [`deploydocs`](@ref) (`dev` by default).

Which versions will show up in the version selector is determined by the
`versions` argument to [`deploydocs`](@ref). For examples of non-default `tag_prefix` usage, see [Deploying from a monorepo](@ref).

Unless a custom domain is being used, the pages are found at:

```
https://USER_NAME.github.io/PACKAGE_NAME.jl/vX.Y.Z
https://USER_NAME.github.io/PACKAGE_NAME.jl/dev
```

!!! tip
    If you need Documenter to maintain [a `CNAME` file](https://docs.github.com/en/pages/configuring-a-custom-domain-for-your-github-pages-site/managing-a-custom-domain-for-your-github-pages-site) for you, you can use the `cname` argument of [`deploydocs`](@ref) to specify the domain.

By default Documenter will create a link called `stable` that points to the latest release

```
https://USER_NAME.github.io/PACKAGE_NAME.jl/stable
```

It is recommended to use this link, rather than the versioned links, since it will be updated
with new releases.

Once your documentation has been pushed to the `gh-pages` branch you should add links to
your `README.md` pointing to the `stable` (and perhaps `dev`) documentation URLs. It is common
practice to make use of "badges" similar to those used for Travis and AppVeyor build
statuses or code coverage. Adding the following to your package `README.md` should be all
that is necessary:

```markdown
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://USER_NAME.github.io/PACKAGE_NAME.jl/stable)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://USER_NAME.github.io/PACKAGE_NAME.jl/dev)
```

`PACKAGE_NAME` and `USER_NAME` should be replaced with their appropriate values. The colour
and text of the image can be changed by altering `docs-stable-blue` as described on
[shields.io](https://shields.io), though it is recommended that package authors follow this
standard to make it easier for potential users to find documentation links across multiple
package README files.

### Fixing broken release deployments

It can happen that, for one reason or another, the documentation for a tagged version of
your package fails to deploy and a fix would require changes to the source code (e.g. a
misconfigured `make.jl`). However, as registered tags should not be changed, you cannot
simply update the original tag (e.g. `v1.2.3`) with the fix.

In this situation, you can manually create and push a tag for the commit with the fix
that has the same version number, but also some build metadata (e.g. `v1.2.3+doc1`). For
Git, this is a completely different tag, so it won't interfere with anything. But when
Documenter runs on this tag, it will ignore the build metadata and deploy the docs as if
they were for version `v1.2.3`.

Note that, as with normal tag builds, you need to make sure that your CI that runs
Documenter is configured to run on such tags (e.g. that the regex constraining the
branches the CI runs on is broad enough etc).

### Deploying without the versioning scheme

Documenter supports deployment directly to the website root ignoring any version
subfolders as described in the previous section. This can be useful if you use
Documenter for something that is not a versioned project, for example.
To do this, pass `versions = nothing` to the [`deploydocs`](@ref) function.
Now the pages should be found directly at

```
https://USER_NAME.github.io/PACKAGE_NAME.jl/
```

Preview builds are still deployed to the `previews` subfolder.

!!! note
    The landing page for the [JuliaDocs GitHub organization](https://juliadocs.org/)
    ([source repository](https://github.com/JuliaDocs/juliadocs.github.io)) is one example
    where this functionality is used.

### Out-of-repo deployment

Sometimes the `gh-pages` branch can become really large, either just due to a large number of commits over time, or due to figures and other large artifacts.
In those cases, it can be useful to deploy the docs in the `gh-pages` of a separate repository.
The following steps can be used to deploy the documentation of a "source"
repository on a "target" repo. The key pair is split across the two repositories, so it is
worth being precise about which half goes where (see
[Authentication: SSH Deploy Keys](@ref ssh-deploy-keys) for the exact GitHub settings pages):

1. Run `DocumenterTools.genkeys()` to generate a pair of keys.
2. Add the public key as a **deploy key** with write access to the **"target"** repository,
   under **Settings** → **Deploy keys**.
3. Add the private key as the `DOCUMENTER_KEY` **repository secret** to the **"source"**
   repository (the one that runs the documentation workflow), under **Settings** →
   **Secrets and variables** → **Actions**.
4. Adapt `docs/make.jl` to deploy on "target" repository:

```julia
deploydocs(
    repo = "github.com/SourceRepoOrg/SourceRepo",
    deploy_repo = "github.com/TargetRepoOrg/TargetRepo"
)
```

Note that, as for `repo`, no protocol (`https://` or `git@`) may be given in `deploy_repo`;
a trailing `.git` is optional. Setting the `GITHUB_REPOSITORY` environment variable around
the `deploydocs` call is *not* necessary.

!!! note

    Out-of-repo deployment requires SSH deploy keys. `GITHUB_TOKEN` only ever grants access
    to the repository the workflow runs in, so a build that falls back to it fails with a
    `Permission to TargetRepoOrg/TargetRepo.git denied to github-actions[bot]` error.

## Deploying from a monorepo

Documenter.jl supports building documentation for a package that lives in a monorepo, e.g., in a repository that contains multiple packages (including one potentially top level)

Here's one example of setting up documentation for a repository that has the following structure: one top level package and two subpackages PackageA.jl and PackageB.jl:
```
.
├── README.md
├── docs
|   ├── make.jl
│   └── Project.toml
├── src/...
├── PackageA.jl
│   ├── docs
|   │   ├── make.jl
|   │   └── Project.toml
│   └── src/...
└── PackageB.jl
    ├── docs
    │   ├── make.jl
    │   └── Project.toml
    └── src/...
```

The three respective `make.jl` scripts should contain [`deploydocs`](@ref) settings that look something like

```julia
# In ./docs/make.jl
deploydocs(;
    repo = "github.com/USER_NAME/PACKAGE_NAME.jl.git",
    # ...any additional kwargs
)

# In ./PackageA.jl/docs/make.jl
deploydocs(;
    repo = "github.com/USER_NAME/PACKAGE_NAME.jl.git",
    dirname = "PackageA",
    tag_prefix = "PackageA-",
    # ...any additional kwargs
)

# In ./PackageB.jl/docs/make.jl
deploydocs(;
    repo = "github.com/USER_NAME/PACKAGE_NAME.jl.git",
    dirname = "PackageB",
    tag_prefix = "PackageB-",
    # ...any additional kwargs
)
```

To build separate docs for each package, create three **separate** buildbot configurations, one for each package. Depending on the service used, the section that calls each `make.jl` script will need to be configured appropriately, e.g.,
```
# In the configuration file that builds docs for the top level package
run: julia --project=docs/ docs/make.jl

# In the configuration file that builds docs for PackageA.jl
run: julia --project=PackageA.jl/docs/ PackageA.jl/docs/make.jl

# In the configuration file that builds docs for PackageB.jl
run: julia --project=PackageB.jl/docs/ PackageB.jl/docs/make.jl
```

Releases of each subpackage should be tagged with that same prefix, namely `v0.3.2` (for the top-level package), `PackageA-v0.1.2`, and `PackageB-v3.2+extra_build_tags`, which will then trigger versioned documentation deployments. Similarly to [Documentation Versions](@ref), unless a custom domain is used these three separate sets of pages will be found at:

```
https://USER_NAME.github.io/PACKAGE_NAME.jl/vX.Y.Z
https://USER_NAME.github.io/PACKAGE_NAME.jl/dev
https://USER_NAME.github.io/PACKAGE_NAME.jl/stable  # Links to most recent top level version

https://USER_NAME.github.io/PACKAGE_NAME.jl/PackageA/vX.Y.Z
https://USER_NAME.github.io/PACKAGE_NAME.jl/PackageA/dev
https://USER_NAME.github.io/PACKAGE_NAME.jl/PackageA/stable  # Links to most recent PackageA version

https://USER_NAME.github.io/PACKAGE_NAME.jl/PackageB/vX.Y.Z
https://USER_NAME.github.io/PACKAGE_NAME.jl/PackageB/dev
https://USER_NAME.github.io/PACKAGE_NAME.jl/PackageB/stable  # Links to most recent PackageB version
```

While they won't automatically reference one another, such referencing can be added manually (e.g. by linking to `https://USER_NAME.github.io/PACKAGE_NAME.jl/PackageA/stable` from the docs built for PackageB).

!!! warning
    When building multiple subpackages in the same repo, unique `dirname`s must be specified in each package's `deploydocs`; otherwise, only the most recently built package for a given version over the entire monorepo will be present at `https://USER_NAME.github.io/PACKAGE_NAME.jl/PackageB/vX.Y.Z`, and the rest of the subpackages' documentation will be unavailable.

## Deployment systems

It is possible to customize Documenter to use other systems than the ones described in
the sections above. This is done by passing a configuration
(a [`DeployConfig`](@ref `Documenter.DeployConfig`)) to `deploydocs` by the `deploy_config`
keyword argument. Documenter supports [`Travis`](@ref `Documenter.Travis`),
[`GitHubActions`](@ref `Documenter.GitHubActions`), [`GitLab`](@ref `Documenter.GitLab`), and
[`Buildkite`](@ref `Documenter.Buildkite`) natively, but it is easy to define your own by
following the simple interface described below.

```@docs
Documenter.DeployConfig
Documenter.deploy_folder
Documenter.DeployDecision
Documenter.authentication_method
Documenter.authenticated_repo_url
Documenter.documenter_key
Documenter.documenter_key_previews
Documenter.Travis
Documenter.GitHubActions
Documenter.GitLab
Documenter.Buildkite
Documenter.Woodpecker
```

# Showcase

This page showcases the various page elements that are supported by Documenter.
It should be read side-by-side with its source (`docs/src/showcase.md`) to see what syntax exactly is used to create the various elements.

## Table of contents

A table of contents can be generated with an [`@contents` block](@ref).
The one for this page renders as

```@contents
Pages = ["showcase.md"]
```

## Basic Markdown

Documenter can render all the [Markdown syntax supported by the Julia Markdown parser](https://docs.julialang.org/en/v1/stdlib/Markdown/).
You can use all the usual markdown syntax, such as **bold text** and _italic text_ and `print("inline code")`.

## Code blocks

Code blocks are rendered as follows:

```
This is an non-highlighted code block.
... Rendered in monospace.
```

When the language is specified for the block, e.g. by starting the block with ````` ```julia`````, the content gets highlighted appropriately (for the languages that are supported by the highlighter).

```julia
function foo(x::Integer)
    @show x + 1
end
```

## Mathematics

For mathematics, both inline and display equations are supported.
Inline equations should be written as LaTeX between two backticks,
e.g. ``` ``A x^2 + B x + C = 0`` ```.
It will render as ``A x^2 + B x + C = 0``.

The LaTeX for display equations must be wrapped in a ````` ```math ````` code block and will render like

```math
x_{1,2} = \frac{-B \pm \sqrt{B^2 - 4 A C}}{2A}
```

By default, the HTML output renders equations with [KaTeX](https://katex.org/), but [MathJax](https://www.mathjax.org/) can optionally be used as well.

!!! warning
    Similar to LaTeX, using `$` and `$$` to escape inline and display equations
    also works. However, doing so is deprecated and this functionality may be
    removed in a future release.

## Images

Include images using basic Markdown syntax:

![Enter a descriptive caption for the image](assets/logo.png)

The path should be relative to the directory of the current file.

## Admonitions

Admonitions are colorful boxes used to highlight parts of the documentation.

Each admonition begins with three `!!!`, and then the content is indented
underneath with four spaces:
```
!!! note "An optional title"
    Here is something you should pay attention to.
```

Documenter supports a range of admonition types for different circumstances.

###### Note admonition
!!! note "'note' admonition"

    Admonitions look like this. This is a `!!! note`-type admonition.

    Note that admonitions themselves can contain other block-level elements,
    such as code blocks, e.g.

    ```julia
    f(x) = x^2
    ```

    and headings, e.g.

    # Heading 1
    ## Heading 2
    ### Heading 3
    #### Heading 4
    ##### Heading 5
    ###### Heading 6

    However, you **can not** have at-blocks, docstrings, doctests, etc. in an admonition.

    An admonition is closed when the indentation stops,
    so blank lines may be used within or before the content to improve raw text readability.

###### Info admonition
!!! info "'info' admonition"
    This is a `!!! info`-type admonition. This is the same as a `!!! note`-type.

###### Tip admonition
!!! tip "'tip' admonition"
    This is a `!!! tip`-type admonition.

###### Warning admonition
!!! warning "'warning' admonition"
    This is a `!!! warning`-type admonition.

###### Danger admonition
!!! danger "'danger' admonition"
    This is a `!!! danger`-type admonition.

###### Compat admonition
!!! compat "'compat' admonition"
    This is a `!!! compat`-type admonition.

###### TODO admonition
!!! todo "'todo' admonition"
    This is a `!!! todo`-type admonition.

###### Details admonition
Admonitions with type `details` is rendered as a collapsed `<details>` block in
the HTML output, with the admonition title as the `<summary>`.

!!! details "'details' admonition"
    This is a `!!! details`-type admonition.

###### Unknown admonition class
!!! ukw "Unknown admonition class"
    Admonition with an unknown admonition class. This is a `code example`.

## Lists

Tight lists look as follows

* Lorem ipsum dolor sit amet, consectetur adipiscing elit.
* Nulla quis venenatis justo.
* In non _sodales_ eros.

If the lists contain paragraphs or other block level elements, they look like this:

* Morbi et varius nisl, eu semper orci.

  Donec vel nibh sapien. Maecenas ultricies mauris sapien. Nunc et sem ac justo ultricies dignissim ac vitae sem.

* Nulla molestie aliquet metus, a dapibus ligula.

  Morbi pellentesque sodales sollicitudin. Fusce semper placerat suscipit. Aliquam semper tempus ex, non efficitur erat posuere in. Fusce at orci eu ex sagittis commodo.

  > Fusce tempus scelerisque egestas. Pellentesque varius nulla a varius fringilla.

  Fusce nec urna eu orci porta blandit.

Numbered lists are also supported

1. Lorem ipsum dolor sit amet, consectetur adipiscing elit.
2. Nulla quis venenatis justo.
3. In non _sodales_ eros.

As are nested lists

* Morbi et varius nisl, eu semper orci.

  Donec vel nibh sapien. Maecenas ultricies mauris sapien. Nunc et sem ac justo ultricies dignissim ac vitae sem.

  - Lorem ipsum dolor sit amet, consectetur adipiscing elit.
  - Nulla quis venenatis justo.
  - In non _sodales_ eros.

* Nulla molestie aliquet metus, a dapibus ligula.

  1. Lorem ipsum dolor sit amet, consectetur adipiscing elit.
  2. Nulla quis venenatis justo.
  3. In non _sodales_ eros.

  Fusce nec urna eu orci porta blandit.

Lists can also be included in other blocks that can contain block level items

!!! note "Bulleted lists in admonitions"

    * Lorem ipsum dolor sit amet, consectetur adipiscing elit.
    * Nulla quis venenatis justo.
    * In non _sodales_ eros.

!!! note "Large lists in admonitions"

    * Morbi et varius nisl, eu semper orci.

      Donec vel nibh sapien. Maecenas ultricies mauris sapien. Nunc et sem ac justo ultricies dignissim ac vitae sem.

      - Lorem ipsum dolor sit amet, consectetur adipiscing elit.
      - Nulla quis venenatis justo.
      - In non _sodales_ eros.

    * Nulla molestie aliquet metus, a dapibus ligula.

      1. Lorem ipsum dolor sit amet, consectetur adipiscing elit.
      2. Nulla quis venenatis justo.
      3. In non _sodales_ eros.

      Fusce nec urna eu orci porta blandit.

> * Morbi et varius nisl, eu semper orci.
>
>   Donec vel nibh sapien. Maecenas ultricies mauris sapien. Nunc et sem ac justo ultricies dignissim ac vitae sem.
>
>   - Lorem ipsum dolor sit amet, consectetur adipiscing elit.
>   - Nulla quis venenatis justo.
>   - In non _sodales_ eros.

## Tables

| object | implemented | value      |
| ------ | ----------- | ---------- |
| `A`    | ✓           | 10.00      |
| `BB`   | ✓           | 1000000.00 |

With explicit alignment.

| object | implemented |      value |
| :----- | :---------: | ---------: |
| `A`    |      ✓      |      10.00 |
| `BB`   |      ✓      | 1000000.00 |

Tables that are too wide should become scrollable.

| object                 |                 implemented                  |                                                      value |
| :--------------------- | :------------------------------------------: | ---------------------------------------------------------: |
| `A`                    |                      ✓                       |                                                      10.00 |
| `BBBBBBBBBBBBBBBBBBBB` | ✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓ | 1000000000000000000000000000000000000000000000000000000.00 |


## Footnotes

Footnote references can be added with the `[^label]` syntax.[^1] The footnote definitions get collected at the bottom of the page.

The footnote label can be an arbitrary string and even consist of block-level elements.[^Clarke61]

[^1]: A footnote definition uses the `[^label]: ...` syntax in a block scope.

[^Clarke61]:
    > Any sufficiently advanced technology is indistinguishable from magic.
    Arthur C. Clarke, _Profiles of the Future_ (1961): Clarke's Third Law.

## Headings

Finally, headings render as follows

### Heading level 3
#### Heading level 4
##### Heading level 5
###### Heading level 6

To see an example of a level 1 heading see the page title and for level 2 heading, see the one just under this paragraph.

!!! note "Headings in sidebars"
    Level 1 and 2 heading show up in the sidebar, for the current page.

Note that in docstrings, the headings get rewritten as just bold text right now:

```@docs
DocumenterShowcase.baz
```

## Docstrings

The key feature of Documenter, of course, is the ability to automatically include docstrings
from your package in the manual. The following example docstrings come from the demo
[`DocumenterShowcase`](@ref) module, the source of which can be found in
`docs/DocumenterShowcase.jl`.

To include a docstrings into a manual page, you needs to use an [`@docs` block](@ref)

````markdown
```@docs
DocumenterShowcase
```
````

This will include a single docstring and it will look like this:

```@docs
DocumenterShowcase
```

You can include the docstrings corresponding to different function signatures one by one.
E.g., the [`DocumenterShowcase.foo`](@ref) function has two signatures -- `(::Integer)` and `(::AbstractString)`.

````markdown
```@docs
DocumenterShowcase.foo(::Integer)
```
````

yielding the following docstring

```@docs
DocumenterShowcase.foo(::Integer)
```

And now, by having `DocumenterShowcase.foo(::AbstractString)` in the `@docs` block will give the other docstring

```@docs
DocumenterShowcase.foo(::AbstractString)
```

However, if you want, you can also combine multiple docstrings into a single docstring
block. To illustrate this, the [`DocumenterShowcase.bar`](@ref) function has the same
signatures as [`DocumenterShowcase.foo`](@ref).
If we just put `DocumenterShowcase.bar` in an `@docs` block, it will combine the docstrings as follows:

```@docs
DocumenterShowcase.bar
```

If you have very many docstrings, you may also want to consider using the [`@autodocs` block](@ref) which can include a whole set of docstrings automatically based on certain filtering options.

Both `@docs` and `@autodocs` support the [`canonical=false` keyword argument](@ref noncanonical-block). This can be used to include a docstring more than once.
For example, if we do this ...

````markdown
```@docs; canonical=false
DocumenterShowcase.bar
```
````

... we then see the same docstring as above:

```@docs; canonical=false
DocumenterShowcase.bar
```

### An index of docstrings

The [`@index` block](@ref) can be used to generate a list of all the docstrings on a page (or even across pages) and will look as follows:

```@index
Pages = ["showcase.md"]
```

### Multiple uses of the same symbol

Sometimes a symbol has multiple docstrings, for example a type definition, inner and outer constructors. The example
below shows how to use specific ones in the documentation.
````markdown
```@docs
DocumenterShowcase.Foo
DocumenterShowcase.Foo()
DocumenterShowcase.Foo{T}()
```
````

This is then rendered to this:

```@docs
DocumenterShowcase.Foo
DocumenterShowcase.Foo()
DocumenterShowcase.Foo{T}()
```

## Doctesting example

Often you want to write code example such as this:

```jldoctest
julia> f(x) = x^2
f (generic function with 1 method)

julia> f(3)
9
```

If you write them as a ````` ```jldoctest ````` code block, Documenter can make sure that the doctest has not become outdated. See [Doctests](@ref) for more information.

Script-style doctests are supported too:

```jldoctest
2 + 2
# output
4
```

### Setup code

You can have setup code for doctests that gets executed before the actual doctest.
For example, the following doctest needs to have the `Documenter` module to be present.

```jldoctest; setup=:(using Documenter)
julia> Documenter.splitexpr(:(Foo.Bar.baz))
(:(Foo.Bar), :(:baz))
```

This is achieved by the `setup` keyword to `jldoctest`.

````
```jldoctest; setup=:(using Documenter)
````

The alternative approach is to use the `DocTestSetup` keys in `@meta`-blocks, which will apply across multiple doctests.

````markdown
```@meta
DocTestSetup = quote
  f(x) = x^2
end
```
````
```@meta
DocTestSetup = quote
  f(x) = x^2
end
```

```jldoctest
julia> f(2)
4
```

The doctests and `@meta` blocks are evaluated sequentially on each page, so you can always unset the test code by setting it back to `nothing`.

````markdown
```@meta
DocTestSetup = nothing
```
````
```@meta
DocTestSetup = nothing
```

### Teardown code

Dually to setup code described in the preceding section it can be useful to have code that
gets executed *after* the actual doctest, perhaps to restore a setting or release
a resource acquired during setup.
For example, the following doctest expects that `setprecision` was used to
change the default precision for `BigFloat`. After the test completes, this should
be restored to the previous setting.

!!! note
    In real code it is usually better to use `setprecision` with a `do`-block
    to temporarily change the precision. But for the sake of this example it
    is useful to demonstrate the effect of changing and restoring a global setting.

```jldoctest; setup=:(oldprec=precision(BigFloat);setprecision(BigFloat,20)), teardown=:(setprecision(BigFloat,oldprec))
julia> sqrt(big(2.0))
1.4142132
```

This is achieved by the `teardown` keyword to `jldoctest` in addition to `setup`.

````
```jldoctest; setup=:(oldprec=precision(BigFloat);setprecision(BigFloat,20)), teardown=:(setprecision(BigFloat,oldprec))
````

Note that if we now run the same doctest content again but without `setup` and `teardown`
it will produce output with a different (higher) precision. If we had used `setup` without
`teardown` then this doctest would still use the smaller precision, i.e., it would be
affected by the preceding doctest, which is not what we want.
```jldoctest
julia> sqrt(big(2.0))
1.414213562373095048801688724209698078569671875376948073176679737990732478462102
```

The alternative approach is to use the `DocTestSetup` and `DocTestTeardown` keys in `@meta`-blocks, which will apply across multiple doctests.

````markdown
```@meta
DocTestSetup = quote
  oldprec = precision(BigFloat)
  setprecision(BigFloat, 20)
end
DocTestTeardown = quote
  setprecision(BigFloat, oldprec)
end
```
````
```@meta
DocTestSetup = quote
  oldprec = precision(BigFloat)
  setprecision(BigFloat, 20)
end
DocTestTeardown = quote
  setprecision(BigFloat, oldprec)
end
```

```jldoctest
julia> sqrt(big(2.0))
1.4142132
```

The doctests and `@meta` blocks are evaluated sequentially on each page, so you can always unset the test code by setting it back to `nothing`.

````markdown
```@meta
DocTestSetup = nothing
DocTestTeardown = nothing
```
````
```@meta
DocTestSetup = nothing
DocTestTeardown = nothing
```


## Running interactive code

[`@example` block](@ref reference-at-example) run a code snippet and insert the output into the document.
E.g. the following Markdown

````markdown
```@example
2 + 3
```
````

becomes the following code-output block pair

```@example
2 + 3
```

If the last element can be rendered as an image or `text/html` etc. (the corresponding `Base.show` method for the particular MIME type has to be defined), it will be rendered appropriately. E.g.:

```@example
using Main: DocumenterShowcase
DocumenterShowcase.SVGCircle("000", "aaa")
```

This is handy when combined with the `Markdown` standard library

```@example
using Markdown
Markdown.parse("""
`Markdown.MD` objects can be constructed dynamically on the fly and still get rendered "natively".
""")
```

If the last value in an `@example` block is a `nothing`, the standard output from the blocks' evaluation gets displayed instead

```@example
println("Hello World")
```

However, do note that if the block prints to standard output, but also has a final non-`nothing` value, the standard output just gets discarded:

```@example
println("Hello World")
42
```

### Color output

Output from [`@repl` block](@ref)s and [`@example` block](@ref reference-at-example)s support colored output,
transforming ANSI color codes to HTML.

!!! compat "Julia 1.6"
    Color output requires Julia 1.6 or higher.
    To enable color output pass `ansicolor=true` to [`Documenter.HTML`](@ref).

#### Colored `@example` block output

**Input:**
````markdown
```@example
code_typed(sqrt, (Float64,))
```
````

**Output:**
```@example
code_typed(sqrt, (Float64,))
```

#### Colored `@repl` block output

**Input:**
````markdown
```@repl
printstyled("This should be in bold light cyan.", color=:light_cyan, bold=true)
```
````

**Output:**
```@repl
printstyled("This should be in bold cyan.", color=:cyan, bold=true)
```

**Locally disabled color:**
````markdown
```@repl; ansicolor=false
printstyled("This should be in bold light cyan.", color=:light_cyan, bold=true)
```
````
```@repl; ansicolor=false
printstyled("This should be in bold light cyan.", color=:light_cyan, bold=true)
```

#### Raw ANSI code output

Regardless of the color setting, when you print the ANSI escape codes directly, coloring is
enabled.
```@example
for color in 0:15
    print("\e[38;5;$color;48;5;$(color)m  ")
    print("\e[49m", lpad(color, 3), " ")
    color % 8 == 7 && println()
end
print("\e[m")
```

### REPL-type

[`@repl` block](@ref) can be used to simulate the REPL evaluation of code blocks. For example, the following block

````markdown
```@repl
using Statistics
xs = collect(1:10)
median(xs)
sum(xs)
```
````

It gets expanded into something that looks like as if it was evaluated in the REPL, with the `julia>` prompt prepended etc.:

```@repl
using Statistics
xs = collect(1:10)
median(xs)
sum(xs)
```

### Named blocks

Generally, each blocks gets evaluated in a separate, clean context (i.e. no variables from previous blocks will be polluting the namespace etc).
However, you can also re-use a namespace by giving the blocks a name.

````markdown
```@example block-name
x = 40
```
will show up like this:
````
```@example block-name
x = 40
```

````markdown
```@example block-name
x + 1
```
will show up like this:
````
```@example block-name
x + 1
```

When you need setup code that you do not wish to show in the generated documentation, you can use [an `@setup` block](@ref reference-at-setup):

````markdown
```@setup block-name
x = 42
```
````
```@setup block-name
x = 42
```

The [`@setup` block](@ref reference-at-setup) essentially acts as a hidden [`@example` block](@ref reference-at-example).
Any state it sets up, you can access in subsequent blocks with the same name.
For example, the following `@example` block

````markdown
```@example block-name
x
```
````

will show up like this:

```@example block-name
x
```

You also have continued blocks which do not evaluate immediately.

````markdown
```@example block-name; continued = true
y = 99
```
````
```@example block-name; continued = true
y = 99
```

The continued evaluation only applies to [`@example` blocks](@ref reference-at-example) and so if you put, for example, a `@repl` block in between, it will lead to an error, because the `y = 99` line of code has not run yet.

````markdown
```@repl block-name
x
y
```
````

```@repl block-name
x
y
```

Another [`@example` block](@ref reference-at-example) with the same name will, however, finish evaluating it.
So a block like

````markdown
```@example block-name
(x, y)
```
````

will lead to

```@example block-name
(x, y)
```

# AGENTS.md

Project guidance for AI coding assistants.

## Read First

Before making changes, read
[`docs/src/contributing.md`](docs/src/contributing.md).
That document is the primary source of contributor guidance for this
repository.

In particular, follow its formatting rules instead of guessing or applying
generic defaults:

* for Julia code, use the Runic-based workflow described there
  (for example `make format-julia`);
* for Markdown, follow the Markdown conventions described there and do not
  introduce hard-wrapping or ad hoc list formatting.

## Pull Requests

Open pull requests against `master`, not `release-*`, unless a maintainer
explicitly asks for backport work.

Pull request descriptions must disclose when AI tools were used to prepare the
change.

## Commits

Commits made with material AI assistance must include an appropriate
`Co-authored-by:` trailer.

Keep commit diffs focused and preserve the surrounding style of the code you
touch.

## Changelog

User-visible changes should usually add or update an entry in
[`CHANGELOG.md`](CHANGELOG.md), following the style described in
[`docs/src/contributing.md`](docs/src/contributing.md).

If you are preparing a change for someone else, remind them to check whether a
changelog entry is needed.

## Verification

Run the relevant formatter and the most targeted tests you can for the area you
changed.

# Other Output Formats

In addition to the default native HTML output, Documenter also provides [a built-in
LaTeX-based PDF output](@ref pdf-output). Additional output formats are provided through
plugin packages. Once the corresponding package is loaded, the output format can be
specified using the `format` option in [`makedocs`](@ref).

## [PDF Output via LaTeX](@id pdf-output)

`makedocs` can be switched over to use the PDF/LaTeX backend by passing a
[`Documenter.LaTeX`](@ref) object as the `format` keyword:

```julia
using Documenter
makedocs(format = Documenter.LaTeX(), ...)
```

Documenter will then generate a PDF file of the documentation using LaTeX, which will be
placed in the output (`build/`) directory.

The `makedocs` argument `sitename` will be used for the `\title` field in the tex document,
and if the build is for a release tag (i.e. when the `"TRAVIS_TAG"` environment variable is set)
the version number will be appended to the title.
The `makedocs` argument `authors` should also be specified; it will be used for the
`\authors` field in the tex document.

!!! warning "Known issue"
    If the `makedocs` argument `pages` is not assigned, Documenter will generate tex documents without contents. ([#2132](@ref))

### Compiling using natively installed latex

The following is required to build the documentation:

* You need `pdflatex` and `latexmk` commands to be installed and available to Documenter.
* You need the [minted](https://ctan.org/pkg/minted) LaTeX package and its backend source
  highlighter [Pygments](https://pygments.org/) installed.
* You need the [_DejaVu Sans_ and _DejaVu Sans Mono_](https://dejavu-fonts.github.io/) fonts installed.

### Compiling using Tectonic

The documentation can be also built using the
[Tectonic](https://tectonic-typesetting.github.io) LaTeX engine. It is required to have a `tectonic` executable
available in `PATH`, or to provide a path to the binary using the `tectonic` keyword:

```julia
using Documenter

# Executable `tectonic` is present in `PATH`
makedocs(
    format = Documenter.LaTeX(platform="tectonic"),
    ...)

# The path to `tectonic` is provided by the tectonic_jll package
using tectonic_jll: tectonic
makedocs(
    format = Documenter.LaTeX(platform="tectonic", tectonic=tectonic()),
    ...)
```

### Compiling using docker image

It is also possible to use a prebuilt [docker image](https://hub.docker.com/r/juliadocs/documenter-latex/)
to compile the `.tex` file. The image contains all of the required installs described in the section
above. The only requirement for using the image is that `docker` is installed and available for
the builder to call. You also need to tell Documenter to use the docker image, instead of natively
installed tex which is the default. This is done with the `LaTeX` specifier:

```julia
using Documenter
makedocs(
    format = Documenter.LaTeX(platform = "docker"),
    ...
)
```

If you build the documentation on Travis you need to add

```yaml
services:
  - docker
```

to your `.travis.yml` file.

### Compiling to LaTeX only

There's a possibility to save only the `.tex` file and skip the PDF compilation.
For this purpose use the `platform="none"` keyword:

```julia
using Documenter
makedocs(
    format = Documenter.LaTeX(platform = "none"),
    ...
)
```

If you are building in CI and want compiler logs printed directly to the job output on
failures, you can enable:

```julia
makedocs(format = Documenter.LaTeX(show_log = true), ...)
```

You can also force this behavior via environment variable:

```bash
export DOCUMENTER_LATEX_SHOW_LOGS=1
```

## [Custom LaTeX style](@id custom-latex)

The PDF/LaTeX backend works by generating a TeX file based on the input Markdown files.
For users who need or want more control over the generated PDF, it is possible to customize
the setup part of the generated TeX code.

### Load custom packages

By default, the generated TeX file loads the [`documenter.sty`](https://github.com/JuliaDocs/Documenter.jl/blob/master/assets/latex/documenter.sty)
style file, which loads several packages (such as `fontspec`, `amsmath`, `listings`, `minted`, `tabulary`, `graphicx`)
and otherwise configures the TeX build.

Users can load additional packages and declare additional configuration by adding a
`custom.sty` file to the `assets/` source directory. The custom style file will be loaded
right after the default style (`documenter.sty`).

### Custom preamble

By default, Documenter uses the [`preamble.tex`](https://github.com/JuliaDocs/Documenter.jl/blob/master/assets/latex/preamble.tex)
preamble, with only the dynamically generated declarations for the `\DocMainTitle`,
`\DocVersion`, `\DocAuthors`, and `\JuliaVersion` variables preceding it.

For more control, it is possible to fully replace the preamble by adding a `preamble.tex`
file into the `assets/` source directory, which will then be used instead of the default
one. The Documenter tests contain two examples of how a custom preamble can be used:

- [To customize the cover page of the manual.](https://github.com/JuliaDocs/Documenter.jl/tree/master/test/examples/src.cover_page)
- [To customize the TOC style.](https://github.com/JuliaDocs/Documenter.jl/tree/master/test/examples/src.toc_style)

## Markdown & MkDocs

Documenter no longer provides the Markdown/MkDocs output, and this functionality has moved
to the [`DocumenterMarkdown`](https://github.com/JuliaDocs/DocumenterMarkdown.jl) package.

# Remote repository links

Documenter, if set up appropriately, can automatically generate links to publicly hosted Git repositories (such as source and edit links to e.g. repositories hosted on GitHub).
Usually this is for linking back to the main package repository or the project source code.

The [`Remotes` API](@ref remotes-api) is used to specify remote repositories and generate the URLs.
It is also designed to be extended, to support additional Git repository hosting services.

## Remote link types

There are two categories of remote repositories that (may) need to be configured for Documenter to be able to determine remote URLs:

1. **Project repository remote**, specified with the `repo` keyword to [`makedocs`](@ref).
   This refers to the project as a whole (rather than specific files), and is used for the repository landing page link, issue references etc.

2. **File link remotes**, specified by the `remotes` keyword to [`makedocs`](@ref).
   These are used to link a file system file to the corresponding file in the remote repository.
   In particular, these are used to generate the edit links for manual pages, and Julia source file links for docstrings.

For the most common case -- a repository of a simple Julia package -- there is usually only one remote repository that one links to, and the distinction between file links and repository links is not relevant.
However, in more complex setups it may be necessary to distinguish between the two cases.
The defaults to the two keywords try to cater for the most common use case, and [as is explained below](@ref repo-remote-interaction), this means that there has to be some interaction between these two arguments.

## [Remotes for files](@id remotes-for-files)

When Documenter has to determine the URL of a file in the hosted repository, it gets a local filesystem absolute path as an input.[^1]
In the case of Markdown files, those local paths are determined by [`makedocs`](@ref) when it reads them.
The links to Julia files are determined from the docsystem, and point to where the code was loaded from (e.g. for a development dependency of the environment, they come from the `Pkg.develop`ed path; but for normal `Pkg.add` dependencies the source files are usually in `~/.julia/packages`).

In most cases, for both Markdown and Julia files, the files Documenter is concerned about are located in the currently checked out Git repository that contains the Documenter `make.jl` script (e.g. the locally checked out package repository).
However, sometimes they may also be in a different repository (either in a subdirectory of or outside of the primary repository), or even in a non-Git directory outside of the primary repository (e.g. if you're trying to build the documentation of a release tarball).

To handle those cases, the `remotes` keyword to [`makedocs`](@ref) can be used to set up a `local directory => remote repository` mapping for local file system paths.
The local directory is assumed to correspond to the root of the Git repository, and any subpath within that directory is then resolved to the corresponding path in the remote repository.
If there are nested `remotes` configured, Documenter will use the one that matches first as it walks up the directory tree from the original path.

As the common cases are a locally checked out Git repository (added with `Pkg.develop` to the docs environment), or a released package which is hosted on GitHub (`Pkg.add`ed to the environment), Documenter will also try to determine such remotes automatically.

* When Documenter walks up the directory tree, it checks whether the directory is a root of a Git repository (by looking for the presence of a `.git` directory or file).
  Once it finds a valid local repository root, it tries to read its [`origin` remote URL](https://git-scm.com/book/en/v2/Git-Basics-Working-with-Remotes).
  - If that matches a GitHub repository[^2], Documenter automatically sets up a mapping from that directory, and then uses that to determine the remote URLs.
  - If Documenter is unable to determine the remote from the repository's `origin` (e.g. `origin` is not set up, or it is hosted somewhere else), it will error, as it will not be able to determine the remote URLs.
    In this case, the remote should be configured explicitly with `remotes`.

You can think of it as Documenter automatically populating `remotes` with any cloned GitHub repositories it finds.[^3]

For released packages (those added using `Pkg.add(...)` rather than `Pkg.develop(...)`), the version and repository can be determined from the package metadata, but a commit hash is not readily available.
In this case, Documenter will guess that a tag `v$VERSION` exists in the repository on GitHub.
Note that these tags are created automatically by the widely used JuliaRegistries/TagBot action.
Since this is sometimes not the case, and could cause dead or incorrect links, setting the `linkcheck` keyword to `true` to [`makedocs`](@ref) will check these guessed links have an existing target and that the existing target matches the published package.
(Note that this will also check all other external links from your documentation.)
Note that enabling this option can cause documentation builds to fail due to network errors or intermittent downtime of external services.

!!! note

    The [`Remotes` API](@ref remotes-api) can be used to implement the methods to compute the remote URLs (for now, Documenter supports [GitHub](@ref `Remotes.GitHub`), [GitLab](@ref `Remotes.GitLab`) and [Forgejo](@ref `Remotes.Forgejo`) natively).

[^1]: There is an exception to this: links to Julia `Base` module source files.
      But Documenter already knows how to handle those correctly, and they are really only relevant to the Julia main manual build.
[^2]: GitHub is the most common case, but this could be extended to cover other Git hosting services in the future (as long as the remote can be reliably determined from the `origin` URL).
[^3]: One thing to be aware of here is that Documenter builds up a cache of the Git repositories it finds on every `makedocs` call.
      This is for performance reasons, to reduce the number of file system accesses and, in particular, `git` calls, which are relatively slow.

## [`repo` & `remotes` interaction](@id repo-remote-interaction)

Since Documenter is primarily used to generate documentation for Julia packages, there is some interaction between the `repo` and `remotes` keyword arguments, to automagically determine their defaults.
This means that usually it is not necessary to specify either explicitly in the `make.jl` script.

The rules are as follows:

* If `repo` _is not_ specified, it is essentially [determined like any other remote link](@ref remotes-for-files), by trying to figure out the repository that contains the `root` path argument of [`makedocs`](@ref) (defaulting to the directory of the `make.jl` script; usually the `docs/` directory).
  The [`Remote`](@ref `Remotes.Remote`) object will be one of the `remotes`, which in turn may have been determined automatically via the `origin` URL of the containing Git repository.

* If `repo` _is_ specified, but the `remotes` for the repository root is not, `repo` will function as a `remotes` entry for the repository root.
  This is so that it would not be necessary to specify the same argument twice (i.e. once for general repository links, once for file links).

* If both `repo` and a `remotes` for the repository root are configured, Documenter will throw an error, as it does not really make sense for them to point to two different remotes.[^4]

[^4]: If there is a use case for this, this limitation could be relaxed in the future.

## [Remotes API](@id remotes-api)

```@docs
Documenter.Remotes
Documenter.Remotes.GitHub
Documenter.Remotes.GitLab
Documenter.Remotes.Forgejo
```

The following types and functions are relevant when creating custom
[`Remote`](@ref `Documenter.Remotes.Remote`) types:

```@docs
Documenter.Remotes.Remote
Documenter.Remotes.repourl
Documenter.Remotes.fileurl
Documenter.Remotes.issueurl
```

# Checklists

The purpose of this page is to collate a series of checklists for commonly
performed changes to the source code of Documenter.

In each case, copy the checklist into the description of the pull request.

## Making a release

In preparation for a release, use the following checklist. These steps should be performed on a branch with an open pull request.
Simply copy & paste the checklist below into the pull request description, and tick the boxes as appropriate.

````
## Pre-release

 - [ ] Change the version number in `Project.toml`
   * If the release is breaking, increment MAJOR
   * If the release adds a new user-visible feature, increment MINOR
   * Otherwise (bug-fixes, documentation improvements), increment PATCH
 - [ ] Update `CHANGELOG.md`, following the existing style (in particular, make sure that the change log for this version has the correct version number and date).
 - [ ] Run `make changelog`, to make sure that all the issue references in `CHANGELOG.md` are up to date.
 - [ ] Check that the commit messages in this PR do not contain `[ci skip]`
 - [ ] Check that the [regression-tests workflow](https://github.com/JuliaDocs/Documenter.jl/actions/workflows/regression-tests.yml) did not reveal any changes that broke extensions (this should run as part of the CI suite, but can also be triggered manually).

## The release

 - [ ] After merging the pull request, tag the release. There are two options for this:

   1. [Comment `[at]JuliaRegistrator register` on the GitHub commit.](https://github.com/JuliaRegistries/Registrator.jl#via-the-github-app)
   2. Use [JuliaHub's package registration feature](https://help.juliahub.com/juliahub/stable/contribute/#registrator) to trigger the registration.

   Either of those should automatically publish a new version to the Julia registry.
 - Once registered, the `TagBot.yml` workflow should create a tag, and rebuild the documentation for this tag.
 - These steps can take quite a bit of time (1 hour or more), so don't be surprised if the new documentation takes a while to appear.
````

# Examples

Sometimes the best way to learn how to use a new package is to look for
examples of what others have already built with it.

The following packages use Documenter to build their documentation and so
should give a good overview of what this package is currently able to do.

## Registered

Packages that have tagged versions available in the general Registry:

- [Augmentor.jl](https://evizero.github.io/Augmentor.jl/stable/)
- [BeaData.jl](https://stephenbnicar.github.io/BeaData.jl/stable/)
- [ControlSystems.jl](https://juliacontrol.github.io/ControlSystems.jl/stable/)
- [COSMO.jl](https://oxfordcontrol.github.io/COSMO.jl/stable/)
- [Distributions.jl](https://juliastats.org/Distributions.jl/stable/)
- [Documenter.jl](https://documenter.juliadocs.org/stable/)
- [DrWatson](https://juliadynamics.github.io/DrWatson.jl/stable/)
- [EzXML.jl](https://juliaio.github.io/EzXML.jl/stable/)
- [FourierFlows.jl](https://fourierflows.github.io/FourierFlowsDocumentation/stable/)
- [Gadfly.jl](https://gadflyjl.org/stable/)
- [GeophysicalFlows.jl](https://fourierflows.github.io/GeophysicalFlowsDocumentation/stable/)
- [GeoStats.jl](https://juliaearth.github.io/GeoStatsDocs/stable/)
- [HypothesisTests.jl](https://juliastats.org/HypothesisTests.jl/stable/)
- [InvertibleNetworks.jl](https://slimgroup.github.io/InvertibleNetworks.jl/stable/)
- [JUDI.jl](https://slimgroup.github.io/JUDI.jl/stable/)
- [JuliaGrid.jl](https://mcosovic.github.io/JuliaGrid.jl/stable/)
- [Luxor.jl](https://juliagraphics.github.io/LuxorManual/stable/)
- [Mimi.jl](https://www.mimiframework.org/Mimi.jl/stable/)
- [Oceananigans.jl](https://clima.github.io/OceananigansDocumentation/stable/)
- [OhMyREPL.jl](https://kristofferc.github.io/OhMyREPL.jl/stable/)
- [OnlineStats.jl](https://joshday.github.io/OnlineStats.jl/stable/)
- [PauliStrings.jl](https://paulistrings.org/dev/)
- [Pigeons.jl](https://pigeons.run/dev/)
- [POMDPs.jl](https://juliapomdp.github.io/POMDPs.jl/stable/)
- [PhyloNetworks.jl](https://juliaphylo.github.io/PhyloNetworks.jl/stable/)
- [SlimOptim.jl](https://slimgroup.github.io/SlimOptim.jl/stable/)
- [SymbolicRegression.jl](https://ai.damtp.cam.ac.uk/symbolicregression/dev/)
- [TaylorSeries.jl](https://juliadiff.org/TaylorSeries.jl/stable/)
- [WorldDynamics.jl](https://worlddynamics.github.io/WorldDynamics.jl/stable/)

## Documentation repositories

Some projects or organizations maintain dedicated documentation repositories that are
separate from specific packages.

- [DifferentialEquations.jl](https://docs.sciml.ai/DiffEqDocs/dev/)
- [JuliaDocs landing page](https://juliadocs.org/)
- [JuliaImages](https://juliaimages.org)
- [JuliaMusic](https://juliamusic.github.io/JuliaMusic_documentation.jl/dev/)
- [Plots.jl](https://docs.juliaplots.org/dev/)

# Public Documentation

Documentation for `Documenter.jl`'s public interface.

See the Internals section of the manual for internal package docs covering all submodules.

## Contents

```@contents
Pages = ["public.md"]
Depth = 2:2
```

## Index

```@index
Pages = ["public.md"]
```

## Public Interface

```@docs
Documenter
makedocs
Documenter.except
hide
Documenter.MissingRemoteError
asset
RawHTMLHeadContent
deploydocs
doctest
DocMeta
DocMeta.getdocmeta
DocMeta.setdocmeta!
```

## DocumenterTools

```@docs
DocumenterTools.generate
DocumenterTools.genkeys
DocumenterTools.OutdatedWarning.generate
```

## Extensions

These APIs are intended for extension and plugin authors to use.
They would normally not be relevant for usual end-users.

```@docs
Documenter.writer_supports_ansicolor
```

```@meta
CollapsedDocStrings = true
```

# Writers

```@autodocs
Modules = [
    Documenter,
    Documenter.HTMLWriter,
    Documenter.HTMLWriter.RD,
    Documenter.LaTeXWriter,
]
Filter = t -> t ∉ (asset, RawHTMLHeadContent)
Pages = ["writers.jl", "html/HTMLWriter.jl", "html/RD.jl", "html/write_inventory.jl", "latex/LaTeXWriter.jl"]
```
```@docs
Documenter.Plugin
```

# Contributing

This page details some of the guidelines that should be followed when contributing to this package.


## Branches

From `Documenter` version `0.3` onwards `release-*` branches are used for tagged minor versions of this package. This follows the same approach used in the main Julia repository, albeit on a much more modest scale.

Please open pull requests against the `master` branch rather than any of the `release-*` branches whenever possible.

### Backports

Bug fixes are backported to the `release-*` branches using `git cherry-pick -x` by a JuliaDocs member and will become available in point releases of that particular minor version of the package.

Feel free to nominate commits that should be backported by opening an issue. Requests for new point releases to be tagged in `METADATA.jl` can also be made in the same way.

### `release-*` branches

  * Each new minor version `x.y.0` gets a branch called `release-x.y` (a [protected branch](https://docs.github.com/en/repositories/configuring-branches-and-merges-in-your-repository/managing-protected-branches/about-protected-branches)).
  * New versions are usually tagged only from the `release-x.y` branches.
  * For patch releases, changes get backported to the `release-x.y` branch via a single PR with the standard name "Backports for x.y.z" and label ["Type: Backport"](https://github.com/JuliaDocs/Documenter.jl/pulls?q=label%3A%22Type%3A+Backport%22). The PR message links to all the PRs that are providing commits to the backport. The PR gets merged as a merge commit (i.e. not squashed).
  * The old `release-*` branches may be removed once they have outlived their usefulness.
  * Patch version [milestones](https://github.com/JuliaDocs/Documenter.jl/milestones) are used to keep track of which PRs get backported etc.


## Style Guide

Follow the style of the surrounding text when making changes. When adding new features please try to stick to the following points whenever applicable.

### Julia

Documenter uses [Runic.jl](https://github.com/fredrikekre/Runic.jl) for code
formatting. In addition, the following style guidelines should be followed:

  * use `function ... end` when a method definition contains more than one toplevel expression;
  * related short-form method definitions don't need a new line between them;
  * unrelated or long-form method definitions must have a blank line separating each one;
  * files containing a single `module ... end` must be named after the module;
  * method arguments should be ordered based on the amount of usage within the method body;
  * methods extended from other modules must follow their inherited argument order, not the above rule;
  * avoid dense expressions where possible e.g. prefer nested `if`s over complex nested `?`s;
  * do not use multiline comments (`#=` and `=#`);
  * wrap long lines as near to 92 characters as possible, this includes docstrings;
  * follow the standard naming conventions used in `Base`.

**Formatting.** You can run `make format-julia` to run Runic on the Documenter codebase.

It expects that Runic is installed into the global, shared `--project=@runic` Julia environment.
If the formatter fails to run because it cannot load Runic, you can install it easily in the right place by calling `make install-runic`.

### JS, HTML and (S)CSS

We use [Biome](https://biomejs.dev) for formatting the JavaScript source code. You can run it with `make format-js` (install with `make install-biome`).

### Markdown

  * Use unbalanced `#` headers, i.e. no `#` on the right hand side of the header text;
  * include a single blank line between toplevel blocks;
  * unordered lists must use `*` bullets with two preceding spaces;
  * do *not* hard wrap lines;
  * use emphasis (`*`) and bold (`**`) sparingly;
  * always use fenced code blocks instead of indented blocks;
  * follow the conventions outlined in the Julia documentation page on documentation.

## Changelog

All pull requests that make user visible changes should have a changelog entry
formatted according to the [Keep a Changelog](https://keepachangelog.com/en/1.1.0/)
style.

## Tests

### Unit tests

As is conventional for Julia packages, unit tests are located at `test/*.jl` with the entrypoint
`test/runtests.jl`.

### End to end testing

Tests that build example package docs from source and inspect the results (end to end tests) are
located in `/test/examples`. The main entry points are `test/examples/make.jl` for building and
`test/examples/test.jl` for doing some basic checks on the generated outputs.

# Documenter & semantic versioning

Documenter, [like any good Julia package](https://pkgdocs.julialang.org/v1/compatibility/#Version-specifier-format), follows [semantic versioning](https://semver.org/) (SemVer).
As such, and as the package is currently in the `v1.x` era of its lifecycle, any changes in Documenter should not break existing uses of the package that rely on documented behaviors.[^1]

[^1]: Eventually, of course, Documenter `2.0` may break everything. But we don't expect a breaking release in the very near future.

However, Documenter is relatively complex, and it can sometimes be unclear what constitutes a _breaking change_.
For example, is changing the CSS classes in the HTML themes allowed?
What if the user relied on a CSS class in an `@raw html`-block?
If their HTML is no longer rendered correctly, is that a breaking change?
Is completely changing the LaTeX compiler a breaking change?
What if it breaks a PDF build somewhere due to some math block using a feature that only works with `pdflatex`?

This page aims to clarify what **is** and **is not** covered by the Documenter SemVer guarantees, both as information for users, and as guidance for developers.

!!! note "This page is not complete!"

    If you need to rely on something that is currently an internal API or undocumented behavior, open an issue or a pull request to get it documented!
    There is a good chance that the behavior is already a _de facto_ SemVer guarantee, or can easily be cleaned up and made public API.
    The goal is to add and document additional SemVer guarantees over time.


## Documenter's API guarantees

The following APIs and behaviors are guaranteed not to change:

* Standard promises about the Julia APIs (public Documenter functions and their documented arguments).
  In a nutshell, any `make.jl` making use of just public, documented parts of the Documenter API should always continue working (i.e. builds should complete).
  The public APIs include all exported functions and types, but are not limited to that --- see the "Reference" section of the manual for a list of public Julia APIs.

* All _documented_ Documenter behaviors.
  E.g. the way Documenter [determines remote repository links is documented](remote-links.md), or what files and with what structure get generated by the HTML builds.
  The behavior of undocumented edge cases may change, but only in accordance with what is documented.

!!! note "Experimental APIs"

    Note that some APIs may be explicitly marked experimental.
    In that case, you can only rely on them _within a minor version_.
    The next minor version release may completely change or remove experimental features and APIs.

    When relying on an experimental API (either in a Documenter extension package, or in a documentation build environment), you should fix Documenter to the specific compatible minor version(s) with a ["tilde specifier" in the `Project.toml` file](https://pkgdocs.julialang.org/v1/compatibility/#Tilde-specifiers).

## What is not covered by SemVer

In principle, anything that is not covered by the previous section is, by definition, _not_ part of the public API and is _not_ guaranteed to keep working the way it is working right now.

However, it is worth mentioning a few things explicitly.
In particular, this includes things that are currently not part of the API, but should be added (in some way) in the future, but probably need careful consideration before we commit to them as public APIs.

* Any time you hook into Documenter's internals in some way.
  This includes hooking into the seemingly extensible parts of the internals, such as adding additional build steps, or renderers.
  The long-term aim here is to create clean plugin APIs, but it is unlikely we'll be able to keep the current internals for that.

* The HTML, TeX, or file structure of the generated documents (unless explicitly documented).
  This includes the CSS of the HTML themes, and as such any custom CSS overrides may stop working at any point.
  However, there are many _de facto_ guarantees here that should get documented over time (e.g. for custom themes).

* The look and feel of the HTML UI and the generated PDF may change considerably from one minor version to another.

* Anything explicitly marked experimental is not guaranteed to remain stable (see the note above).


!!! note "Patch versions are probably okay"

    If you are relying on some non-SemVer behaviors, features, or internals, it is probably fine to expect things not to break _within a patch release_.
    In this case, you should add a `[compat]` entry to your `Project.toml` files with a [tilde specifier](https://pkgdocs.julialang.org/v1/compatibility/#Tilde-specifiers) fixing Documenter to a specific minor version, e.g.

    ```toml
    Documenter = "~1.X"
    ```

    where `X` is the minor version you are developing against.

    Alternatively, if this is for package documentation, and your `docs/make.jl` script is relying on some non-SemVer behavior, you can also check in a `docs/Manifest.toml` file to fully fix the Documenter version.
    However, it may still be a good idea to include the version bound in the `docs/Project.toml` file, just as documentation for maintainers.

# Search

## Overview

The search system provides full-text search functionality for documentation sites through a two-phase architecture.
During build time, a Julia-based indexer processes all documentation content and generates a searchable index.
At runtime, a JavaScript client-side interface performs real-time search operations against this pre-built index using a Web Worker for performance optimization.

## Architecture

The search implementation consists of three primary components operating in sequence:

1. **Build-time Index Generation** - Julia code in `src/html/HTMLWriter.jl` processes documentation content during site generation.
2. **Client-side Search Interface** - JavaScript code in `assets/html/js/search.js` handles user interactions and search execution.
3. **Web Worker Processing** - Background thread execution prevents UI blocking during search operations.

## Index Generation Process

### 1. SearchRecord Structure

The core data structure is the `SearchRecord` struct defined in `src/html/HTMLWriter.jl`:

```julia
struct SearchRecord
    src::String          # URL/path to the document
    page::Documenter.Page # Reference to the page object
    fragment::String     # URL fragment (for anchored content)
    category::String     # Content category (page, section, docstring, etc.)
    title::String        # Display title for search results
    page_title::String   # Title of the containing page
    text::String         # Searchable text content
end
```

### 2. Index Generation Pipeline

The indexer processes documentation content through a multi-stage pipeline during HTML generation:

1. **AST Traversal** - The system walks each page's markdown abstract syntax tree structure at `src/html/HTMLWriter.jl` in the function `function domify(dctx::DCtx)`
2. **Record Instantiation** - Each content node generates a `SearchRecord` via the `searchrecord()` function at `src/html/HTMLWriter.jl`
3. **Content Classification** - The categorization system assigns content types
4. **Text Normalization** - The `mdflatten()` function extracts plain text from markdown structures for indexing.
5. **Deduplication Pass** - Records sharing identical locations undergo merging to optimize index size.
6. **JavaScript Serialization** - The processed index outputs as JavaScript object notation for client consumption.

### 3. Index Output

The search index is written to `search_index.js` in the following format:

```javascript
var documenterSearchIndex = {"docs": [
  {
    "location": "page.html#fragment",
    "page": "Page Title",
    "title": "Content Title",
    "category": "section",
    "text": "Searchable content text..."
  }
  // ... more records
]}
```

### 4. Content Filtering

The indexer excludes specific node types from search index generation (`src/html/HTMLWriter.jl`):
- `MetaNode` - Metadata annotation blocks containing non-searchable directives
- `DocsNodesBlock` - Internal documentation node structures
- `SetupNode` - Configuration and setup directive blocks

## Client-Side Search Implementation

### 1. Search Architecture

The client-side implementation employs a multi-threaded Web Worker architecture for computational isolation:

- **Main Thread** - Manages user interface event handling, result filtering, and DOM manipulation operations
- **Web Worker Thread** - Executes search algorithms using the [MiniSearch library](https://lucaong.github.io/minisearch/) without blocking the user interface

### 2. MiniSearch Configuration

The search system uses MiniSearch with the following configuration (`assets/html/js/search.js`):

```javascript
let index = new MiniSearch({
  fields: ["title", "text"],           // Fields to index
  storeFields: ["location", "title", "text", "category", "page"], // Fields to return
  processTerm: (term) => {
    // Custom term processing with stop words removal
    // Preserves Julia-specific symbols (@, !)
  },
  tokenize: (string) => string.split(/[\s\-\.]+/), // Custom tokenizer
  searchOptions: {
    prefix: true,       // Enable prefix matching
    boost: { title: 100 }, // Boost title matches
    fuzzy: 2           // Enable fuzzy matching
  }
});
```

### 3. Stop Words

The search engine implements a stop words filter (`assets/html/js/search.js`) derived from the Lunr 2.1.3 library, with Julia-language-specific modifications that preserve semantically important Julia symbols and keywords from filtration.

### 4. Search Workflow

#### Main Thread Execution Flow:
1. **Input Event Processing** - User keystrokes in search input trigger `input` event listeners
2. **Worker Thread Communication** - Available worker threads receive search requests via `postMessage` API
3. **Result Set Processing** - Worker thread responses undergo filtering and DOM rendering
4. **Browser State Management** - Search queries and active filters update browser URL parameters

#### Web Worker Execution Flow:
1. **Query Reception** - Main thread search requests arrive through message passing interface
2. **Search Algorithm Execution** - MiniSearch performs full-text search with minimum score threshold of 1
3. **Result Set Generation** - Search matches generate HTML markup limited to 200 results per content category
4. **Response Transmission** - Formatted search results return to main thread via message passing

### 5. Result Rendering

The search result rendering system generates structured output elements (`assets/html/js/search.js`):
- **Title Component** - Content titles with syntax highlighting and category classification badges
- **Text Snippet Component** - Extracted text excerpts with search term highlighting via HTML markup
- **Navigation Link Component** - Direct URL references to specific content locations within documentation
- **Context Metadata Component** - Hierarchical page information and document location path data

### 6. Content Filtering System

The search interface implements dynamic category-based result filtering:
- Filter options generate automatically from indexed content categories
- User filtering operates on content type classifications (page, section, docstring, etc.)
- Client-side filtering execution provides immediate response without server requests

## Performance Optimizations

### 1. Web Worker Usage
- Offloads search computation from main thread
- Maintains UI responsiveness during search operations
- Handles concurrent search requests efficiently

### 2. Result Limiting
- Pre-filters to 200 unique results per category
- Prevents excessive DOM manipulation
- Reduces memory usage for large documentation sites

### 3. Index Deduplication
- Merges duplicate entries at build time
- Reduces index size and network transfer
- Improves search performance

### 4. Progressive Loading
- Search index loads asynchronously
- Fallback handling for missing dependencies
- Graceful degradation without search functionality

## Configuration Options

### Build-Time Settings

```julia
# In make.jl
makedocs(
    # ... other options
    format = Documenter.HTML(
        # Search-related settings
        search_size_threshold_warn = 200_000  # Warn if index > 200KB
    )
)
```

### Size Thresholds
- Warning threshold: 200KB by default
- Large indices may impact page load performance
- Automatic warnings during build process

## Integration Points

### 1. Asset Management
- Search JavaScript is bundled with other Documenter assets
- MiniSearch library loaded from CDN (`__MINISEARCH_VERSION__` placeholder)
- Dependencies managed through `JSDependencies.jl`

### 2. Theme Integration
- Search UI styled using Bulma CSS framework
- Responsive design for mobile devices
- Dark/light theme support

### 3. URL Routing
- Search queries persist in URL parameters (`?q=search_term`)
- Filter states maintained in URL (`?filter=section`)
- Browser history integration for navigation

## Testing and Benchmarking

### 1. Test Infrastructure
- Real search testing: `test/search/real_search.jl`
- Benchmark suite: `test/search/run_benchmarks.jl`
- Edge case testing: `test/search_edge_cases/`

### 2. Search Validation
The testing system provides:
- Index generation validation
- Search result accuracy verification
- Performance benchmarking capabilities
- Edge case handling verification

# Package Guide

Documenter is designed to do one thing -- combine markdown files and inline docstrings from
Julia's docsystem into a single inter-linked document. What follows is a step-by-step guide
to creating a simple document.


## Installation

Documenter can be installed using the Julia package manager.
From the Julia REPL, type `]` to enter the Pkg REPL mode and run

```
pkg> add Documenter
```

For package documentation, the standard approach is to add a documentation-specific project stored in the `docs/` subdirectory of your package.

### Julia v1.12 and later
On Julia v1.12+, the [workspace](https://pkgdocs.julialang.org/v1/toml-files/#The-[workspace]-section) feature of your package's `Project.toml` makes it easy to add a `docs` workspace that includes `Documenter`.
To do this, first edit the package's top-level `Project.toml` file to have a `docs` workspace:
```
# The top-level Project.toml may already have other projects listed here as workspaces,
# simply append "docs" to the end of the list if it already exists.
[workspace]
projects = ["docs"]
```

Next, open up a Julia REPL in the `docs` subdirectory, enter `pkg>` mode with the `]` key and install `Documenter` and the top-level package (here called `PkgName`) with:

```
$ julia --project=docs
(PkgName/docs) pkg> add Documenter PkgName
```

This will create a `Project.toml` file in the `docs/` subdirectory and add `Documenter` and the top-level package as available packages.
See also the [Pkg.jl](https://github.com/JuliaLang/Pkg.jl/) documentation on working with [project workspaces](https://pkgdocs.julialang.org/v1/toml-files/#The-[workspace]-section) and [environments](https://pkgdocs.julialang.org/v1/environments/).

### Julia v1.11 and earlier
For Julia versions v1.11 and earlier, creating a separate project in `docs/` is the standard approach.
To do this, navigate to your package's root folder and do

```
pkg> activate docs/

(docs) pkg> add Documenter
```

This will create `Project.toml` and `Manifest.toml` files in the `docs/` subdirectory.
Note that for packages, you also likely need to have your package that you are documenting as a ["dev dependency"](https://pkgdocs.julialang.org/v1/managing-packages/#developing) of the `docs/` environment.
See also [the Pkg.jl documentation on working with project environments](https://pkgdocs.julialang.org/v1/environments/).

## Setting up the Folder Structure

!!! note
    The function [`DocumenterTools.generate`](@ref) from the `DocumenterTools` package
    can generate the basic structure that Documenter expects.

Firstly, we need a Julia module to document. This could be a package generated via
`Pkg.generate` or a single `.jl` script accessible via Julia's `LOAD_PATH`. For this
guide we'll be using a package called `Example.jl` that has the following directory layout:

```
Example/
├── src/
│   └── Example.jl
...
```

Note that the `...` just represent unimportant files and folders.

We must decide on a location where we'd like to store the documentation for this package.
It's recommended to use a folder named `docs/` in the toplevel of the package, like so

```
Example/
├── docs/
│   └── ...
├── src/
│   └── Example.jl
...
```

Inside the `docs/` folder we need to add two things. A source folder which will contain the
markdown files that will be used to build the finished document and a Julia script that will
be used to control the build process. The following names are recommended

```
docs/
├── src/
└── make.jl
```


## Building an Empty Document

With our `docs/` directory now set up we're going to build our first document. It'll just be
a single empty file at the moment, but we'll be adding to it later on.

Add the following to your `make.jl` file

```julia
using Documenter, Example

makedocs(sitename = "My Documentation")
```

This assumes you've installed Documenter as discussed in [Installation](@ref) and that your
`Example.jl` package can be found by Julia. If your package has been added as a dev
dependency using its local path rather than a remote git repository, you need to add the
keyword argument `remotes = nothing` to the function `makedocs`.

!!! note

    If your source directory is not accessible through Julia's LOAD_PATH, you might wish to
    add the following line at the top of make.jl

    ```julia
    push!(LOAD_PATH,"../src/")
    ```

Now add an `index.md` file to the `src/` directory.

!!! note
    If you use Documenter's default HTML output the name `index.md` is mandatory.
    This file will be the main page of the rendered HTML documentation.

Leave the newly added file empty and then run the following command from the `docs/` directory

```sh
$ julia --project make.jl
```

Note that `$` just represents the prompt character. You don't need to type that.

If you'd like to see the output from this command in color use

```sh
$ julia --color=yes --project make.jl
```

When you run that you should see the following output

```
[ Info: SetupBuildDirectory: setting up build directory.
[ Info: Doctest: running doctests.
[ Info: ExpandTemplates: expanding markdown templates.
[ Info: CrossReferences: building cross-references.
[ Info: CheckDocument: running document checks.
[ Info: Populate: populating indices.
[ Info: RenderDocument: rendering document.
[ Info: HTMLWriter: rendering HTML pages.
```

The `docs/` folder should contain a new directory -- called `build/`. Its structure should
look like the following

```
build/
├── assets
│   ├── documenter.js
│   ├── themes
│   │   ├── documenter-dark.css
│   │   └── documenter-light.css
│   ├── themeswap.js
│   └── warner.js
├── index.html
├── search
│   └── index.html
└── search_index.js
```

!!! note

    By default, Documenter has pretty URLs enabled, which means that `src/foo.md` is turned
    into `src/foo/index.html`, instead of simply `src/foo.html`, which is the preferred way
    when creating a set of HTML to be hosted on a web server.

    However, this can be a hindrance when browsing the documentation locally as browsers
    do not resolve directory URLs like `foo/` to `foo/index.html` for local files. To view
    the documentation locally, it is recommended that you run a local web server out of
    the `docs/build` directory. One way to accomplish this is to install the
    [LiveServer](https://github.com/JuliaDocs/LiveServer.jl) Julia package. You can then
    start the server with `julia -e 'using LiveServer; serve(dir="docs/build")'`.
    Alternatively, if you have Python installed, you can start one with
    `python3 -m http.server --bind localhost`.


!!! warning

    You may see setups using

    ```julia
    makedocs(...,
        format = Documenter.HTML(
            prettyurls = get(ENV, "CI", nothing) == "true"
        )
    )
    ```

    The intent behind this is to use `prettyurls=false` when building the documentation
    locally, for easy browsing, and `prettyurls=true` when deploying the documentation
    online from GitHub Actions.

    However, this is not recommended. For example, if a
    [`@raw` block](@ref @raw-format-block) references a local image, the correct relative
    path of that image would depend on the `prettyurls` setting ([#921](@ref)). Consequently, the
    documentation might build correctly locally and be broken on Github Actions, or vice
    versa. It is recommended to always use `prettyurls=true` and run a local web server
    to view the documentation.

!!! warning

    **Never** `git commit` the contents of `build` (or any other content generated by
    Documenter) to your repository's `master` branch. Always commit generated files to the
    `gh-pages` branch of your repository. This helps to avoid including unnecessary changes
    for anyone reviewing commits that happen to include documentation changes.

    See the [Hosting Documentation](@ref) section for details regarding how you should go
    about setting this up correctly.

At this point `build/index.html` should be an empty page since `src/index.md` is empty. You
can try adding some text to `src/index.md` and re-running the `make.jl` file to see the
changes.


## Adding Some Docstrings

Next we'll splice a docstring defined in the `Example` module into the `index.md` file. To
do this first document a function in that module:

```julia
module Example

export func

"""
    func(x)

Return double the number `x` plus `1`.
"""
func(x) = 2x + 1

end
```

Then in the `src/index.md` file add the following

````markdown
# Example.jl Documentation

```@docs
func(x)
```
````

When we next run `make.jl` the docstring for `Example.func(x)` should appear in place of
the `@docs` block in `build/index.md`. Note that *more than one* object can be referenced
inside a `@docs` block -- just place each one on a separate line.

Note that a `@docs` block is evaluated in the `Main` module. This means that each object
listed in the block must be visible there. The module can be changed to something else on
a per-page basis with a `@meta` block as in the following

````markdown
# Example.jl Documentation

```@meta
CurrentModule = Example
```

```@docs
func(x)
```
````

### Filtering included docstrings

In some cases you may want to include a docstring for a `Method` that extends a
`Function` from a different module -- such as `Base`. In the following example we extend
`Base.length` with a new definition for the struct `T` and also add a docstring:

```julia
struct T
    # ...
end

"""
Custom `length` docs for `T`.
"""
Base.length(::T) = 1
```

When trying to include this docstring with

````markdown
```@docs
length
```
````

all the docs for `length` will be included -- even those from other modules. There are two
ways to solve this problem. Either include the type in the signature with

````markdown
```@docs
length(::T)
```
````

or declare the specific modules that [`makedocs`](@ref) should include with

```julia
makedocs(
    # options
    modules = [MyModule]
)
```


## Cross Referencing

It may be necessary to refer to a particular docstring or section of your document from
elsewhere in the document. To do this we can make use of Documenter's cross-referencing
syntax which looks pretty similar to normal markdown link syntax. Replace the contents of
`src/index.md` with the following

````markdown
# Example.jl Documentation

```@docs
func(x)
```

- link to [Example.jl Documentation](@ref)
- link to [`func(x)`](@ref)
````

So we just have to replace each link's url with `@ref` and write the name of the thing we'd
like to cross-reference. For document headers it's just plain text that matches the name of
the header and for docstrings enclose the object in backticks.

This also works across different pages in the same way. Note that these sections and
docstrings must be unique within a document.


## External Cross-References

Any project building its documentation with the most recent release of Documenter will
generate an [`objects.inv` inventory](https://juliadocs.org/DocInventories.jl/stable/formats/#Sphinx-Inventory-Format)
that can be found in the root of the [deployed documentation](@ref Hosting-Documentation).
The [`DocumenterInterLinks` plugin](https://github.com/JuliaDocs/DocumenterInterLinks.jl#readme)
allows you to define a mapping in your `make.jl` file between an external project name
and its inventory file, e.g.,

```julia
using DocumenterInterLinks

links = InterLinks(
    "Documenter" => "https://documenter.juliadocs.org/stable/objects.inv"
)
```

That `InterLinks` object should then be passed to [`makedocs`](@ref) as an element of
`plugins`. This enables the ability to cross-reference into the external documentation,
e.g., of the `Documenter` package, using an [`@extref` link](@ref) with a syntax similar
to the above [`@ref`](@ref Cross-Referencing), e.g.,

```markdown
See the [`Documenter.makedocs`](@extref) function.
```

See the [documentation of the `DocumenterInterLinks` package](https://juliadocs.org/DocumenterInterLinks.jl/stable/)
for more details.


## Navigation

Documenter can auto-generate tables of contents and docstring indexes for your document with
the following syntax. We'll illustrate these features using our `index.md` file from the
previous sections. Add the following to that file

````markdown
# Example.jl Documentation

```@contents
```

## Functions

```@docs
func(x)
```

## Index

```@index
```
````

The `@contents` block will generate a nested list of links to all the section headers in
the document. By default it will gather all the level 1 and 2 headers from every page in the
document, but this can be adjusted using `Pages` and `Depth` settings as in the following

````markdown
```@contents
Pages = ["foo.md", "bar.md"]
Depth = 3
```
````

The `@index` block will generate a flat list of links to all the docs that have been
spliced into the document using `@docs` blocks. As with the `@contents` block the pages to
be included can be set with a `Pages = [...]` line. Since the list is not nested `Depth` is
not supported for `@index`.


## Pages in the Sidebar

By default all the pages (`.md` files) in your source directory get added to the sidebar,
sorted by their filenames. However, in most cases you want to use the `pages` argument to
[`makedocs`](@ref) to control what the sidebar looks like. The basic usage is as follows:

```julia
makedocs(
    ...,
    pages = [
        "page.md",
        "Page title" => "page2.md",
        "Subsection" => [
            ...
        ]
    ]
)
```

Using the `pages` argument you can organize your pages into subsections and hide some pages
from the sidebar with the help of the [`hide`](@ref) function.


## Adding a logo or icon

You can easily add a logo or icon to your documentation which
will be automatically displayed in the navigation sidebar.

During the build process, Documenter looks for suitable
graphic images in the `src/assets/` directory and
automatically copies them to `/build/assets/`.

You can use SVG, PNG, WEBP, GIF, or JPEG images.

Documenter looks for files `logo.svg`, `logo.png`,
`logo.webp`, `logo.gif`, `logo.jpg`, or `logo.jpeg`, in that
order. The first suitable image found is used.

This image will be used for both light and dark themes. If
you want to create a separate design for the dark theme, add a file
called `logo-dark.svg` (or PNG/WEBP/GIF/JPEG).

Files don't need to be square. Images with transparent
backgrounds can look better, particularly for dark themes.

There's a `sidebar_sitename` keyword option for
[`Documenter.HTML`](@ref) that lets you hide the sitename
that's usually displayed below a logo. This is useful if the
logo already contains the name.

# [``\LaTeX`` Syntax](@id latex_syntax)

The following section describes how to add equations written using ``\LaTeX`` to your
documentation.

## Escaping Characters in Docstrings

Since some characters used in ``\LaTeX`` syntax, such as `$` and `\`, are treated differently in docstrings. They
need to be escaped using a `\` character as in the following example:

```julia
"""
Here's some inline maths: ``\\sqrt[n]{1 + x + x^2 + \\ldots}``.

Here's an equation:

``\\frac{n!}{k!(n - k)!} = \\binom{n}{k}``

This is the binomial coefficient.
"""
func(x) = # ...
```

Note that for equations on the manual pages (in `.md` files) the escaping is not necessary. So, when moving equations
between the manual and docstrings, the escaping `\` characters have to the appropriately added or removed.

To avoid needing to escape the special characters in docstrings the `raw""` string macro can be used, combined with `@doc`:

```julia
@doc raw"""
Here's some inline maths: ``\sqrt[n]{1 + x + x^2 + \ldots}``.

Here's an equation:

``\frac{n!}{k!(n - k)!} = \binom{n}{k}``

This is the binomial coefficient.
"""
func(x) = # ...
```

A related issue is how to add dollar signs to a docstring. They need to be
double-escaped as follows:
```julia
"""
The cost was \\\$1.
"""
```

## Inline Equations

```markdown
Here's some inline maths: ``\sqrt[n]{1 + x + x^2 + \ldots}``.
```

which will be displayed as

---

Here's some inline maths: ``\sqrt[n]{1 + x + x^2 + \ldots}``.

---

!!! warning
    Similar to LaTeX, using `$` and `$$` to escape inline and display equations
    also works. However, doing so is deprecated and this functionality may be
    removed in a future release.

## Display Equations

````markdown
Here's an equation:

```math
\frac{n!}{k!(n - k)!} = \binom{n}{k}
```

This is the binomial coefficient.

---

To write a system of equations, use the `aligned` environment:

```math
\begin{aligned}
\nabla\cdot\mathbf{E}  &= 4 \pi \rho \\
\nabla\cdot\mathbf{B}  &= 0 \\
\nabla\times\mathbf{E} &= - \frac{1}{c} \frac{\partial\mathbf{B}}{\partial t} \\
\nabla\times\mathbf{B} &= - \frac{1}{c} \left(4 \pi \mathbf{J} + \frac{\partial\mathbf{E}}{\partial t} \right)
\end{aligned}
```

These are Maxwell's equations.

````

which will be displayed as

---

Here's an equation:

```math
\frac{n!}{k!(n - k)!} = \binom{n}{k}
```

This is the binomial coefficient.

---

To write a system of equations, use the `aligned` environment:

```math
\begin{aligned}
\nabla\cdot\mathbf{E}  &= 4 \pi \rho \\
\nabla\cdot\mathbf{B}  &= 0 \\
\nabla\times\mathbf{E} &= - \frac{1}{c} \frac{\partial\mathbf{B}}{\partial t} \\
\nabla\times\mathbf{B} &= - \frac{1}{c} \left(4 \pi \mathbf{J} + \frac{\partial\mathbf{E}}{\partial t} \right)
\end{aligned}
```

These are Maxwell's equations.

## Printing LaTeX from Julia

To pretty-print LaTeX from Julia, overload `Base.show` for the
`MIME"text/latex"` type. For example:
```@example
struct LaTeXEquation
    content::String
end

function Base.show(io::IO, ::MIME"text/latex", x::LaTeXEquation)
    # Wrap in $$ for display math printing
    return print(io, "\$\$ " * x.content * " \$\$")
end

LaTeXEquation(raw"""
    \left[\begin{array}{c}
        x \\
        y
    \end{array}\right]
""")
```

## Set math engine and define macros for LaTeX

The `mathengine` argument to [`Documenter.HTMLWriter.HTML`](@ref) allows the math rendering engine to be specified, supporting both MathJax and KaTeX (with the latter being the default).

Furthermore, you can also pass custom configuration to the rendering engine. E.g. to add global LaTeX command definitions, you can set `mathengine` to:
```julia
mathengine = Documenter.MathJax(Dict(:TeX => Dict(
    :equationNumbers => Dict(:autoNumber => "AMS"),
    :Macros => Dict(
        :ket => ["|#1\\rangle", 1],
        :bra => ["\\langle#1|", 1],
    ),
)))
```
Or with MathJax v3, the [physics package](https://mirrors.ibiblio.org/CTAN/macros/latex/contrib/physics/physics.pdf) can be loaded:

```julia
mathengine = MathJax3(Dict(
    :loader => Dict("load" => ["[tex]/physics"]),
    :tex => Dict(
        "inlineMath" => [["\$","\$"], ["\\(","\\)"]],
        "tags" => "ams",
        "packages" => ["base", "ams", "autoload", "physics"],
    ),
))
```

The syntax is slightly different if using KaTeX, the following example is what you might include in your `makedocs` function:

```julia
makedocs(
    format = Documenter.HTML(; mathengine=
        Documenter.KaTeX(
            Dict(:delimiters => [
                Dict(:left => raw"$",   :right => raw"$",   display => false),
                Dict(:left => raw"$$",  :right => raw"$$",  display => true),
                Dict(:left => raw"\[",  :right => raw"\]",  display => true),
                ],
                :macros => Dict("\\RR" => "\\mathbb{R}",
                    raw"\Xi" => raw"X_{i}",
                    raw"\Ru" => raw"R_{\mathrm{univ.}}",
                    raw"\Pstd" => raw"P_{\mathrm{std}}",
                    raw"\Tstd" => raw"T_{\mathrm{std}}",
                ),
            )
        )
    )
)
```

[`MathJax2`](@ref), [`MathJax3`](@ref) and [`KaTeX`](@ref) are available types for `mathengine`.

# Syntax

This section of the manual describes the syntax used by Documenter to build documentation.
For supported Markdown syntax, see the [documentation for the Markdown standard library in the Julia manual](https://docs.julialang.org/en/v1/stdlib/Markdown/).

```@contents
Pages = ["syntax.md"]
Depth = 2:2
```

## `@docs` block

Splice one or more docstrings into a document in place of the code block, i.e.

````markdown
```@docs
Documenter
makedocs
deploydocs
```
````

This block type is evaluated within the `CurrentModule` module if defined, otherwise within
`Main`, and so each object listed in the block should be visible from that
module. Undefined objects will raise warnings during documentation generation and cause the
code block to be rendered in the final document unchanged.

Objects may not be listed more than once within the document. When duplicate objects are
detected an error will be raised and the build process will be terminated.

To ensure that all docstrings from a module are included in the final document the `modules`
keyword for [`makedocs`](@ref) can be set to the desired module or modules, i.e.

```julia
makedocs(
    modules = [Documenter],
)
```

which will cause any unlisted docstrings to raise warnings when [`makedocs`](@ref) is
called. If `modules` is not defined then no warnings are printed, even if a document has
missing docstrings.

Notice also that you can use `@docs` to display the documentation strings of only specific
methods, by stating the dispatch types. For example
````markdown
```@docs
f(::Type1, ::Type2)
```
````
will only display the documentation string of `f` that is related to these types.
This can be useful when your module extends a function and adds a documentation
string to that new method.

Note that when specifying signatures, it should match the method definition exactly.
Documenter will not match methods based on dispatch rules. For example, assuming you
have a docstring attached to `foo(::Integer) = ...`, then neither `foo(::Number)` nor
`foo(::Int64)` will match it in an at-docs block (even though `Int64 <: Integer <: Number`).
The only way you can splice that docstring is by listing exactly `foo(::Integer)` in
the at-docs block.

### [`@docs; canonical=false` block](@id noncanonical-block)

You can pass the `canonical` keyword argument as `false` to `@docs` to indicate
that the `@docs` should be considered as non-canonical like so:

````markdown
```@docs; canonical=false
makedocs
```
````

This is useful when you want to include a docstring inline somewhere, e.g. in
a tutorial, but the canonical version of the docstring is already in the API
reference. References will all point to the canonical `@docs` block. For
a particular docstring, you can include it as many times as you like with
`@docs ; canonical=false`, but only once without. Non-canonical `@docs` blocks
are ignored when checking for missing docstrings.

## `@autodocs` block

Automatically splices all docstrings from the provided modules in place of the code block.
This is equivalent to manually adding all the docstrings in a `@docs` block.

````markdown
```@autodocs
Modules = [Foo, Bar, Bar.Baz]
Order   = [:function, :type]
```
````

The above `@autodocs` block adds all the docstrings found in modules `Foo`, `Bar`, and `Bar.Baz` that
refer to functions or types to the document.
Note that a submodule must be listed explicitly in order to include the docstrings within it.

Each module is added in order and so all docs from `Foo` will appear before those of `Bar`.
Possible values for the `Order` vector are

- `:module`
- `:constant`
- `:type`
- `:function`
- `:macro`

If no `Order` is provided then the order listed above is used.

When a potential docstring is found in one of the listed modules, but does not match any
value from `Order` then it will be omitted from the document. Hence `Order` acts as a basic
filter as well as sorter.

In addition to `Order`, a `Pages` vector may be included in `@autodocs` to filter docstrings
based on the source file in which they are defined:

````markdown
```@autodocs
Modules = [Foo]
Pages   = ["a.jl", "b.jl"]
```
````

In the above example docstrings from module `Foo` found in source files whose file path ends
with `a.jl` and `b.jl` are included. The page order provided by `Pages` is also used to sort the
docstrings. Note that page matching is done using the end of the provided strings and so
`a.jl` will be matched by *any* source file whose file path ends with `a.jl`, i.e. `src/a.jl`,
`src/foo/a.jl` or `src/bar_a.jl`.

To filter out certain docstrings by your own criteria, you can provide a function with the
`Filter` keyword:

````markdown
```@autodocs
Modules = [Foo]
Filter = t -> typeof(t) === DataType && t <: Foo.C
```
````

In the given example, only the docstrings of the subtypes of `Foo.C` are shown. Instead
of an [anonymous function](https://docs.julialang.org/en/v1/manual/functions/index.html#man-anonymous-functions-1)
you can give the name of a function you defined beforehand, too:

````markdown
```@autodocs
Modules = [Foo]
Filter =  myCustomFilterFunction
```
````

To include only the public names from the modules listed in `Modules` use `Private = false`.
In a similar way `Public = false` can be used to only show the private names. By
default both of these are set to `true` so that all names will be shown.

!!! info
    In Julia versions up to and including v1.10, "public" = "exported".
    Starting with Julia v1.11, "public" = "exported _or_ marked with the `public` keyword".

````markdown
Functions exported from `Foo`:

```@autodocs
Modules = [Foo]
Private = false
Order = [:function]
```

Private types in module `Foo`:

```@autodocs
Modules = [Foo]
Public = false
Order = [:type]
```
````

!!! note

    When more complex sorting is needed then use `@docs` to define it
    explicitly.

As with `@docs`, you can use `@autodocs; canonical=false` to indicate that the
`@autodocs` block in non-canonical. See [`@docs; canonical=false` block](@ref
noncanonical-block).

## [`@ref` and `@id` links](@id at-ref-at-id-links)

Used in markdown links as the URL to tell Documenter to generate a cross-reference
automatically. The text part of the link can be a code object (between backticks), header name, or GitHub PR/Issue number (`#` followed by a number).

````markdown
# Syntax

... [`makedocs`](@ref) ...

# Functions

```@docs
makedocs
```

... [Syntax](@ref) ...

... [#42](@ref) ...
````

Plain text in the "text" part of a link will either cross-reference a header, or, when it is
a number preceded by a `#`, a GitHub issue/pull request. Text wrapped in backticks will
cross-reference a docstring from a `@docs` or `@autodocs` block.

The code enclosed in the backticks for such a reference will be evaluated in the
`CurrentModule`  given in the `@meta` block of the current page (`Main` by default). For
`@ref` links inside a docstring, the `CurrentModule` is automatically set to the module
containing the docstring.

A reference that is a fully qualified name (e.g. ```[`Example.domath`](@ref)``` or `[domath](@ref Example.domath)`) will also be resolved in `Main`.
That is, loading a package in `docs/make.jl` ensures that fully qualified `@ref` links work from anywhere.

The `@ref` links may refer to docstrings or headers on different pages as well as the
current page using the same syntax.


### Named `@ref`s

It is also possible to override the destination of an `@ref`-link by adding the appropriate
label to the link, such as a docstring reference or a page heading.

```markdown
Both of the following references point to `g` found in module `Main.Other`:

* [`Main.Other.g`](@ref)
* [the `g` function](@ref Main.Other.g)

Both of the following point to the heading "On Something":

* [On Something](@ref)
* [The section about something.](@ref "On Something")
```

This can be useful to avoid having to write fully qualified names for references that
are not imported into the current module, or when the text displayed in the link is
used to add additional meaning to the surrounding text, such as

```markdown
Use [`for i = 1:10 ...`](@ref for) to loop over all the numbers from 1 to 10.
```

!!! note

    Named doc `@ref`s should be used sparingly since writing unqualified names may, in some
    cases, make it difficult to tell *which* function is being referred to in a particular
    docstring if there happen to be several modules that provide definitions with the same
    name.

### Duplicate Headers

In some cases a document may contain multiple headers with the same name, but on different
pages or of different levels. To allow `@ref` to cross-reference a duplicate header it must
be given a name as in the following example

```markdown
# [Header](@id my_custom_header_name)

...

## Header

... [Custom Header](@ref my_custom_header_name) ...
```

The link that wraps the named header is removed in the final document. The text for a named
`@ref ...` does not need to match the header that it references. Named `@ref ...`s may refer
to headers on different pages in the same way as unnamed ones do.

Duplicate docstring references do not occur since splicing the same docstring into a
document more than once is disallowed.

!!! note "Label precedence"

    Both user-defined and internally generated header reference labels take precedence over
    docstring references, in case there is a conflict.

### `@extref` link

Using the [`DocumenterInterLinks` plugin](https://github.com/JuliaDocs/DocumenterInterLinks.jl#readme),
it is possible to cross-reference the documentation of other projects whose documentation
is generated by Documenter or [Sphinx](https://www.sphinx-doc.org/en/master/), using
`@extref` links similar to the built-in `@ref` links for internal references.

See [External Cross-References](@ref) and the
[documentation of the `DocumenterInterLinks` package](https://juliadocs.org/DocumenterInterLinks.jl/stable/)
for more details.


## `@meta` block

This block type is used to define metadata key/value pairs that can be used elsewhere in the
page. Currently recognized keys:
- `CurrentModule`: module where Documenter evaluates, for example, [`@docs`-block](@ref)
  and [`@ref`-link](@ref at-ref-at-id-links)s.
- `DocTestSetup`: code to be evaluated before a doctest, see the [Setup and Teardown Code](@ref)
  section under [Doctests](@ref).
- `DocTestTeardown`: code to be evaluated after a doctest, see the [Setup and Teardown Code](@ref)
  section under [Doctests](@ref).
- `DocTestFilters`: filters to deal with, for example, unpredictable output from doctests,
  see the [Filtering Doctests](@ref) section under [Doctests](@ref).
- `EditURL`: link to where the page can be edited. This defaults to the `.md` page itself,
  but if the source is something else (for example if the `.md` page is generated as part of
  the doc build) this can be set, either as a local link, or an absolute url.
- `Description`: a page-specific description that gets displayed in search engines and
  link previews. Overrides the site-wide description in [`makedocs`](@ref).
- `Draft`: boolean for overriding the global draft mode for the page.
- `CollapsedDocStrings`: for output formats that support this (i.e. only [`HTML`](@ref Documenter.HTML) currently), if set to `true`, render all docstrings as collapsed by default.
- `ShareDefaultModule`: If set to `true`, all unnamed `@example`, `@repl` and `@setup` blocks share the same evaluation sandbox module, which is useful for writing tutorial-like documents.
  When `false` (default), unnamed blocks will each have a separate sandbox module where the code gets evaluated.
  In either case, named blocks always have their own sandbox module, shared by the blocks with the same name.

Global default values for each of these can also be set via the `meta` keyword of [`makedocs`](@ref).

Example:

````markdown
```@meta
CurrentModule = FooBar
DocTestSetup  = quote
    using MyPackage
end
DocTestFilters = [r"Stacktrace:[\s\S]+"]
EditURL = "link/to/source/file"
```
````

Note that `@meta` blocks are always evaluated in `Main`.

## `@index` block

Generates a list of links to docstrings that have been spliced into a document. Valid
settings are `Pages`, `Modules`, and `Order`. For example:

````markdown
```@index
Pages   = ["foo.md"]
Modules = [Foo, Bar]
Order   = [:function, :type]
```
````

When `Pages` or `Modules` are not provided then all pages or modules are included. `Order`
defaults to

```julia
[:module, :constant, :type, :function, :macro]
```

if not specified. `Order` and `Modules` behave the same way as in [`@autodocs` block](@ref)s
and filter out docstrings that do not match one of the modules or categories specified.

Note that the values assigned to `Pages`, `Modules`, and `Order` may be any valid Julia code
and thus can be something more complex than an array literal if required, i.e.

````markdown
```@index
Pages = map(file -> joinpath("man", file), readdir("man"))
```
````

It should be noted though that in this case `Pages` may not be sorted in the order that is
expected by the user. Try to stick to array literals as much as possible.

## `@contents` block

Generates a nested list of links to document sections. Valid settings are `Pages` and `Depth`.

````markdown
```@contents
Pages = ["foo.md"]
Depth = 5
```
````

As with `@index` if `Pages` is not provided then all pages are included. The default
`Depth` value is `2`, i.e. header levels 1 and 2 are included. `Depth` also accepts
`UnitRange`s, to make it possible to configure also the minimum header level to be shown.
`Depth = 2:3` can be used to include only headers with levels 2-3, for example.

!!! tip "Replicating sidebar"

    In some cases it might be desirable to replicate some subsection of the sidebar in an `@contents` block.
    A possible pattern to achieve this without duplicating code is to define the `pages` keyword entry through a global variable in `make.jl`, e.g.

    ```julia
    SUBSECTION_PAGES = ["subsection/a.md", "subsection/b.md"]
    makedocs(
        pages = [
            "index.md",
            "Subsection" => SUBSECTION_PAGES,
        ...
    ```

    That variable will exist in the `Main` module and can be reused in the `@contents` and other blocks, e.g.

    ````markdown
    ```@contents
    Pages = Main.SUBSECTION_PAGES
    ```
    ````

    Documenter will then list the contents of the "Subsection" pages, and they will always appear in the same order as they are in the sidebar.

## [`@example` block](@id reference-at-example)

Evaluates the code block and inserts the result of the last expression into the final document along with the
original source code. If the last expression returns `nothing`, the `stdout`
and `stderr` streams of the whole block are inserted instead. A semicolon `;`
at the end of the last line has no effect.

````markdown
```@example
a = 1
b = 2
a + b
```
````

The above `@example` block will splice the following into the final document

````markdown
```julia
a = 1
b = 2
a + b
```

```
3
```
````

Leading and trailing newlines are removed from the rendered code blocks. Trailing whitespace
on each line is also removed.

!!! note
    The working directory, `pwd`, is set to the directory in `build` where the file
    will be written to, and the paths in `include` calls are interpreted to be relative to
    `pwd`. This can be customized with the `workdir` keyword of [`makedocs`](@ref).

**Hiding Source Code**

Code blocks may have some content that does not need to be displayed in the final document.
`# hide` comments can be appended to lines that should not be rendered, i.e.

````markdown
```@example
import Random # hide
Random.seed!(1) # hide
A = rand(3, 3)
b = [1, 2, 3]
A \ b
```
````

Note that appending `# hide` to every line in an `@example` block will result in the block
being hidden in the rendered document. The results block will still be rendered though.
`@setup` blocks are a convenient shorthand for hiding an entire block, including the output.

**Empty Outputs**

When an `@example` block returns `nothing`, the results block will show instead
the `stdout` and `stderr` streams produced by the whole block. If these are
empty, the results block is not displayed at all; only the source code block
will be shown in the rendered document.

**Named `@example` Blocks**

By default `@example` blocks are run in their own anonymous `Module`s to avoid side-effects
between blocks. To share the same module between different blocks on a page the `@example`
can be named with the following syntax

````markdown
```@example 1
a = 1
```

```@example 1
println(a)
```
````

The name can be any text, not just integers as in the example above, i.e. `@example foo`.

All named `@eval`, `@example`, `@repl` and `@setup` blocks on a given page which have the same
name also share the same evaluation context.

To share a module between all unnamed blocks by default, say in a tutorial with many examples that are all connected, you can set `ShareDefaultModule = true` in a page's `@meta` block.

Named `@example` blocks can be useful when generating documentation that requires
intermediate explanation or multimedia such as plots as illustrated in the following example

````markdown
First we define some functions

```@example 1
using PyPlot # hide
f(x) = sin(2x) + 1
g(x) = cos(x) - x
```

and then we plot `f` over the interval from ``-π`` to ``π``

```@example 1
x = range(-π, π; length=50)
plot(x, f.(x), color = "red")
savefig("f-plot.svg"); nothing # hide
```

![](f-plot.svg)

and then we do the same with `g`

```@example 1
plot(x, g.(x), color = "blue")
savefig("g-plot.svg"); nothing # hide
```

![](g-plot.svg)
````

Note that `@example` blocks are evaluated within the directory of `build` where the file
will be rendered . This means that in the above example `savefig` will output the `.svg`
files into that directory. This allows the images to be easily referenced without needing to
worry about relative paths.

!!! info
    If you use [Plots.jl](https://github.com/JuliaPlots/Plots.jl) with the default backend
    [GR.jl](https://github.com/jheinen/GR.jl), you will likely see warnings like
    ```
    qt.qpa.xcb: could not connect to display
    qt.qpa.plugin: Could not load the Qt platform plugin "xcb" in "" even though it was found.
    ```
    To fix these, you need to set the environment variable `GKSwstype` to `100`. For example,
    if you use GitHub actions to build your documentation, you can modify the default script to
    ```
    - name: Build and deploy
      env:
        GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }} # For authentication with GitHub Actions token
        DOCUMENTER_KEY: ${{ secrets.DOCUMENTER_KEY }} # For authentication with SSH deploy key
        GKSwstype: "100" # https://discourse.julialang.org/t/generation-of-documentation-fails-qt-qpa-xcb-could-not-connect-to-display/60988
      run: julia --project=docs --color=yes docs/make.jl
    ```
    Alternatively, you can set this environment variable directly in Julia using
    ```julia
    ENV["GKSwstype"] = "100"
    ```

`@example` blocks automatically define `ans` which, as in the Julia REPL, is bound to the
value of the last evaluated expression. This can be useful in situations such as the
following one where binding the object returned by `plot` to a named variable would
look out of place in the final rendered documentation:

````markdown
```@example
using Gadfly # hide
plot([sin, x -> 2sin(x) + x], -2π, 2π)
draw(SVG("plot.svg", 6inch, 4inch), ans); nothing # hide
```

![](plot.svg)
````

**Color output**

`@example` blocks support colored text output by mapping [ANSI escape codes]
(https://en.wikipedia.org/wiki/ANSI_escape_code) to HTML. For example, this block:
````markdown
```@example
printstyled("Here are some colors:\n"; color=:red, bold=true)
for color in 0:15
    print("\e[38;5;$(color);48;5;$(color)m  ")
    print("\e[49m", lpad(color, 3), " ")
    color % 8 == 7 && println()
end
print("\e[m")
```
````
results in the following input and output blocks:
```@example
printstyled("Here are some colors:\n"; color=:red, bold=true)
for color in 0:15
    print("\e[38;5;$(color);48;5;$(color)m  ")
    print("\e[49m", lpad(color, 3), " ")
    color % 8 == 7 && println()
end
print("\e[m")
```

!!! note "Disable color output"
    To disable color output globally, pass `ansicolor=false` to [`Documenter.HTML`](@ref),
    and to disable locally for the block, use `ansicolor=false`, like so:

    ````markdown
    ```@example; ansicolor=false
    printstyled("hello, world"; color=:red, bold=true)
    ```
    ````

**Delayed Execution of `@example` Blocks**

`@example` blocks accept a keyword argument `continued` which can be set to `true` or `false`
(defaults to `false`). When `continued = true` the execution of the code is delayed until the
next `continued = false` `@example`-block. This is needed for example when the expression in
a block is not complete. Example:

````markdown
```@example half-loop; continued = true
for i in 1:3
    j = i^2
```
Some text explaining what we should do with `j`
```@example half-loop
    println(j)
end
```
````

Here the first block is not complete -- the loop is missing the `end`. Thus, by setting
`continued = true` here we delay the evaluation of the first block, until we reach the
second block. A block with `continued = true` does not have any output.

## `@repl` block

These are similar to `@example` blocks, but add a `julia>` prompt before each toplevel
expression and do not fail upon encountering an error.
The `# hide` syntax may be used in `@repl` blocks in the same way
as in `@example` blocks. Furthermore, a semicolon `;` at the end of a line will
suppress the output as in the Julia REPL.

````markdown
```@repl
a = 1
b = 2
a + b
```
````

will generate

````markdown
```julia
julia> a = 1
1

julia> b = 2
2

julia> a + b
3
```
````

And likewise

````markdown
```@repl
sqrt(-1)
```
````

will generate

````markdown
```julia
julia> sqrt(-1)
ERROR: DomainError with -1.0:
sqrt will only return a complex result if called with a complex argument. Try sqrt(Complex(x)).
```
````

`@repl` blocks support colored output, just like `@example` blocks. The following block
````markdown
```@repl
printstyled("hello, world"; color=:red, bold=true)
```
````
gives
```@repl
printstyled("hello, world"; color=:red, bold=true)
```
!!! note "Disable color output"
    To disable color output globally, pass `ansicolor=false` to [`Documenter.HTML`](@ref),
    and to disable locally for the block, use `ansicolor=false`, like so:

    ````markdown
    ```@repl; ansicolor=false
    printstyled("hello, world"; color=:red, bold=true)
    ```
    ````

Named `@repl <name>` blocks behave in the same way as named `@example <name>` blocks.
All named `@eval`, `@example`, `@repl` and `@setup` blocks on a given page which have the same
name also share the same evaluation context.

!!! note
    The working directory, `pwd`, is set to the directory in `build` where the file
    will be written to, and the paths in `include` calls are interpreted to be relative to
    `pwd`.  This can be customized with the `workdir` keyword of [`makedocs`](@ref).

!!! note "Soft vs hard scope"

    Julia 1.5 changed the REPL to use the _soft scope_ when handling global variables in
    `for` loops etc. When using Documenter with Julia 1.5 or above, Documenter uses the soft
    scope in `@repl`-blocks and REPL-type doctests.

## [`@setup <name>` block](@id reference-at-setup)

These are similar to `@example` blocks, but both the input and output are hidden from the
final document. This can be convenient if there are several lines of setup code that need to be
hidden.

All named `@eval`, `@example`, `@repl` and `@setup` blocks on a given page which have the same
name also share the same evaluation context.

!!! note

    Unlike `@eval`, `@example` and `@repl` blocks, `@setup` requires a `<name>` attribute to
    associate it with downstream `@eval <name>`, `@example <name>` and `@repl <name>` blocks.

````markdown
```@setup abc
using RDatasets
using DataFrames
iris = dataset("datasets", "iris")
```

```@example abc
println(iris)
```
````


## `@eval` block

Evaluates the contents of the block and inserts the resulting value into the final document,
unless the last expression evaluates to `nothing`.

In the following example we use the PyPlot package to generate a plot and display it in the
final document.

````markdown
```@eval
using PyPlot

x = range(-π, π; length=50)
y = sin.(x)

plot(x, y, color = "red")
savefig("plot.svg")

nothing
```

![](plot.svg)
````

Instead of returning `nothing` in the example above we could have returned a new
`Markdown.MD` object through `Markdown.parse`. This can be more appropriate when the
filename is not known until evaluation of the block itself.

Another example is to generate markdown tables from machine readable data formats such as CSV or JSON.

````markdown
```@eval
using CSV
using Latexify
df = CSV.read("table.csv")
mdtable(df, latex=false)
```
````

which will generate a markdown version of the CSV file table.csv and render it in the output format.

The final expression in an `@eval` block must be either `nothing` or a valid `Markdown.MD`
object. Other objects will generate a warning and will be rendered in text form as a code block,
but this behavior can change and should not be relied upon.

Named `@eval <name>` blocks behave in the same way as named `@example <name>` blocks.
All named `@eval`, `@example`, `@repl` and `@setup` blocks on a given page which have the same
name also share the same evaluation context.

Note that each `@eval` block evaluates its contents within a separate module. When
evaluating each block the present working directory, `pwd`, is set to the directory in
`build` where the file will be written to, and the paths in `include` calls are interpreted
to be relative to `pwd`.

!!! note

    In most cases `@example` is preferred over `@eval`. Just like in normal Julia code where
    `eval` should only be considered as a last resort, `@eval` should be treated in the
    same way.


## `@raw <format>` block

Allows code to be inserted into the final document verbatim. E.g. to insert custom HTML or
LaTeX code into the output.

The `format` argument is mandatory and Documenter uses it to determine whether a particular
block should be copied over to the output or not. Currently supported formats are `html`
and `latex`, used by the respective writers. A `@raw` block whose `format` is not
recognized is usually ignored, so it is possible to have a raw block for each output format
without the blocks being duplicated in the output.

The following example shows how SVG code with custom styling can be included into documents
using the `@raw` block.

````markdown
```@raw html
<svg style="display: block; margin: 0 auto;" width="5em" height="5em">
	<circle cx="2.5em" cy="2.5em" r="2em" stroke="black" stroke-width=".1em" fill="red" />
</svg>
```
````

It will show up as follows, with code having been copied over verbatim to the HTML file.

```@raw html
<svg style="display: block; margin: 0 auto;" width="5em" height="5em">
	<circle cx="2.5em" cy="2.5em" r="2em" stroke="black" stroke-width=".1em" fill="red" />
    (SVG)
</svg>
```

# Atypical Content

This page tests how the search index handles non-standard text.

α β γ

🚀 🐛

averylongunbrokenstringofcharacterstotestthesearchindex

This is a mix of Latin and Cyrillic scripts: Hello, мир.

# Test warnings in `@repl` block

Empty `@repl` block should not result in an assertion (issue #2206).
```@repl
```

Same if it consists of only a comment.
```@repl
# comment
```

Syntax errors in blocks should be a `@docerror`, not an exception (issue #2731).
```@repl
1 !in 2
```

# Structural Cases

This page tests structural variations in documents.

## An Empty Section

## A Section With Only A Code Block

```julia
function foo()
    return 42
end
```

## A Section With Only A Title

### Another heading

#### Fourth level heading

This section has a fourth level heading to test all heading levels.

##### Fifth level heading

Content under the fifth level heading.

###### Sixth level heading

The deepest level of heading supported by Markdown.

# Doctests

This page tests doctests.

## Basic Arithmetic

```jldoctest
julia> 1 + 1
2
```

```jldoctest
julia> 2 + 2
4
```

```jldoctest
julia> 3 + 3
6
```

## String Operations

```jldoctest
julia> uppercase("hello")
"HELLO"

julia> lowercase("WORLD")
"world"

julia> string("test", 123)
"test123"
```

## Array Operations

```jldoctest
julia> [1, 2, 3] .+ 1
3-element Vector{Int64}:
 2
 3
 4

julia> sum([1, 2, 3, 4, 5])
15

julia> length([10, 20, 30])
3
```

## Function Definition and Usage

```jldoctest
julia> function multiply_by_two(x)
           return x * 2
       end
multiply_by_two (generic function with 1 method)

julia> multiply_by_two(5)
10

julia> multiply_by_two(3.5)
7.0
```

## Multiple Similar Examples

```jldoctest
julia> sqrt(4)
2.0

julia> sqrt(9)
3.0

julia> sqrt(16)
4.0
```

## Error Handling Tests

```jldoctest
julia> try
           1 ÷ 0
       catch e
           typeof(e)
       end
DivideError
```

# DocsXRefTests

On the *page* (unlike in the `g` docstring) can link directly to [`AbstractSelector`](@ref) because the `CurrentModule` is `Main`.

Implicit link to a header (single word): [API](@ref).
Explicit link to a header (single word): [header link](@ref "API").
Explicit link to a header via `@id`: [header id link](@ref api-reference).
Explicit link to a header via multi-dash `@id`: [multi-dash id link](@ref multi-word-section-id).

Implicit link to a header (multiple words): [Two words](@ref).
Explicit link to a header (multiple words): [header link](@ref "Two words").

Implicit link to a non-existent header (single word): [header](@ref).
Explicit link to a non-existent header (single word): [header link](@ref "header").

Implicit link to a non-existent header (multiple words): [Multiple words](@ref).
Explicit link to a non-existent header (multiple words): [header link](@ref "Multiple words").
Explicit link to a non-existent header via `@id`: [header id link](@ref missing-header-id).
Explicit link to a non-existent dashed header via `@id`: [dashed header id link](@ref missing-header-id-with-dashes).

Implicit link to an issue: [#12345](@ref).
Explicit link to an issue: [issue link](@ref #12345).

Implicit link to a docstring: [`DocsReferencingMain.g`](@ref).
Explicit link to a docstring: [docstring link](@ref DocsReferencingMain.f).
Explicit link to a docstring with backticks: [docstring code link](@ref `DocsReferencingMain.g`).

Implicit link to a non-existent docstring: [`foobar`](@ref).
Explicit link to a non-existent docstring: [docstring link](@ref Main.foobar).
Explicit link to a non-existent docstring with backticks: [docstring code link](@ref `Main.foobar`).

Plain text naming a docstring is not a docstring reference: [DocsReferencingMain.f](@ref).
Implicit link to a name that is both a header and a docstring: [DocsReferencingMain.g](@ref).
Implicit link to a header whose title is code: [`ENVVAR`](@ref).
Implicit link that is neither a header nor a binding: [Some-Hyphenated-Target](@ref).

Conflicting header/docstring label: [conflict link](@ref DocsReferencingMain.g).
Conflicting header/docstring label with backticks: [conflict docs link](@ref `DocsReferencingMain.g`).

## API

## [API reference](@id api-reference)

```@docs
DocsReferencingMain.f
DocsReferencingMain.g
```

```@docs
Documenter.Selectors.AbstractSelector
Documenter.hide
```

## Two words

## `ENVVAR`

Something

## [Header/docstring conflict](@id DocsReferencingMain.g)

Something else

## [Multi-word section with dashes](@id multi-word-section-id)

# `@repl`, `@example`, and `@eval` have correct `LineNumberNode`s inserted

Add new things at the bottom!!

```@repl
println("@__FILE__ should be REPL[1]: ", @__FILE__)
println("@__FILE__ should be REPL[2]: ", @__FILE__)
println("@__LINE__ should be 1: ", @__LINE__)
@warn "@__FILE__ should be REPL[4] and @__LINE__ 1"
begin
    println("@__FILE__ should be REPL[5]: ", @__FILE__)
    println("@__FILE__ should be REPL[5]: ", @__FILE__)
    println("@__LINE__ should be 4: ", @__LINE__)
    @warn "@__FILE__ should be REPL[5] and @__LINE__ 5"
end
```

```@example
println("@__FILE__ should be linenumbers.md: ", @__FILE__)
println("@__LINE__ should be 20: ", @__LINE__)
@warn "@__FILE__ should be linenumbers.md and @__LINE__ 21"
begin
    println("@__FILE__ should be linenumbers.md: ", @__FILE__)
    println("@__LINE__ should be 24: ", @__LINE__)
    @warn "@__FILE__ should be linenumbers.md and @__LINE__ 25"
end
```

````@eval
import Markdown
Markdown.parse("""```
\$(@__FILE__):\$(@__LINE__) should be linenumbers.md:32: $(@__FILE__):$(@__LINE__)
\$(@__FILE__):\$(@__LINE__) should be linenumbers.md:33: $(@__FILE__):$(@__LINE__)
```
""")
````

# Docstrings

The following example docstrings come from the demo modules in `make.jl`.

```@docs
Mod.func
Mod.T
```

## An index of docstrings

The [`@index` block](@ref) can be used to generate a list of all the docstrings on a page (or even across pages) and will look as follows

```@index
Pages = ["docstrings.md"]
```

---

Missing docstring:

```@docs
this_docstring_does_not_exist
Mod.long_equations_in_docstrings
```

## at-autodocs

```@autodocs
Modules = [Main.AutoDocs]
```

This source file contains broken doctests:

```jldoctest
julia> 2 + 2
-6
```

Filtering with regex substitutions:

```jldoctest; filter = r"([0-9]+\.[0-9]{8})[0-9]+" => s"\1***"
julia> sqrt(2)
1.4142999999999
```

Testing catching errors:

```jldoctest
julia> error("0123456789")
ERROR: ABCDEFGHIJ
Stacktrace:
 [...]
```

```jldoctest; filter = r"\b[0-9]+\b"
julia> error("0123456789")
ERROR: ABCDEFGHIJ
Stacktrace:
 [...]
```

# Code block prerendering using NodeJS

```julia
function f()
    print("hello, world")
end
```

```julia-repl
julia> function f()
           print("hello, world")
       end
```

```llvm
;  @ int.jl:87 within `+'
define i64 @"julia_+_212"(i64 signext %0, i64 signext %1) {
top:
  %2 = add i64 %1, %0
  ret i64 %2
}
```

# Megabytepage

This page has more than 1MB of HTML.

```@example
using Random
for s in Base.Iterators.partition(randstring(2^20), 80)
    # Note: the join() is necessary to get strings (as opposed to Vector{Char} objects)
    # on older Julia versions, since there was a breaking-ish bugfix that changed how
    # Iterators.partition works with strings. join(::SubString) appears to basically be
    # a no-op, so it has no real effect on newer Julia versions.
    #
    # https://github.com/JuliaLang/julia/issues/45768
    # https://github.com/JuliaLang/julia/pull/46234
    #
    # Note: we _could_ also just print the vectors, but then the HTML files end up being
    # ~14 MiB.
    println(join(s))
end
```

# Duplicate header tests

Reduced from https://github.com/JuliaDocs/Documenter.jl/issues/2668.

```@docs
-(::Main.DuplicateHeaderContent.MyStruct)
Main.DuplicateHeaderContent.Stepsize
```

A reference to the ambiguous header: [Blow-Ups](@ref).

A docstring reference whose name collides with the ambiguous header: [`Main.DuplicateHeaderContent.Stepsize`](@ref).

# Testing

We test the `meta` keyword to `makedocs` by using it to set `DocTestSetup` to
code which initializes `x`. If and only if that setup block is run, the
following doctest passes.

```jldoctest
julia> x
42
```

# XRefSignatures
```@meta
CurrentModule = XRefSignatures.XRefSignaturesContent
```

This test documentation demonstrates the ability to cross-reference by signature, 
including references to:
- [specialized methods](@ref XRefSignaturesContent.g(::Float64))
- [parametric methods](@ref XRefSignaturesContent.g(::X) where X)
- [constrained parametric methods](@ref XRefSignaturesContent.g(::AbstractArray{T}) where T <: Number)

Union-all types may be equivalent without being identical. 
Thus, we can sometimes refer to them using alternative, but valid, names such as
[`g(::Y) where Y`](@ref XRefSignaturesContent.g(::Y) where Y) which is equivalent to
[`g(::X) where X`](@ref XRefSignaturesContent.g(::X) where X).

## API

```@docs
XRefSignaturesContent.g
XRefSignaturesContent.g(::Float64)
XRefSignaturesContent.g(::X) where X
XRefSignaturesContent.g(::AbstractArray{T}) where T <: Number
```

# Example stdout

Checking that `@example` output is contained in a specific HTML class.

!!! warning

    This file should contain exactly one `@example` for the test to work.

```@example
println("hello")
```

## `@example` outputs to file

```@example
Main.AT_EXAMPLE_FILES[("png", :big)]
```
```@example
Main.AT_EXAMPLE_FILES[("png", :tiny)]
```
```@example
Main.AT_EXAMPLE_FILES[("webp", :big)]
```
```@example
Main.AT_EXAMPLE_FILES[("webp", :tiny)]
```
```@example
Main.AT_EXAMPLE_FILES[("gif", :big)]
```
```@example
Main.AT_EXAMPLE_FILES[("jpeg", :tiny)]
```

### SVG output

```@example
Main.SVG_BIG
```

### `text/html` fallbacks

SVG with just `text/html` output (in practice, `DataFrame`s and such would fall into this category):

```@example
Main.SVG_HTML
```

SVG with both `text/html` and `image/svg+xml` MIME, in which case we expect to pick the image one (because text is too big) and write it to a file.

```@example
Main.SVG_MULTI
```

# Rubbish EditURL

```@meta
# TODO: a bad EditURL currently makes makedocs() error
# This should optionally be a warning.
#EditURL = "/foo/bar/baz/I/Should/Not/Exist"
```

Edit link should be missing, since it's set to a bad value.

```@meta
CurrentModule = Documenter.Selectors
```

# Second page

This page is in the context of `Documenters.Selectors`. Thus, we can directly link to [`AbstractSelector`](@ref), but we cannot link to [`DocsReferencingMain.f`](@ref). But if we use the fully qualified name, it works: [`Main.DocsReferencingMain.f`](@ref).

We can also link to [`Documenter.hide`](@ref) because of the fallback to `Main`.

# Output handling (`outputs/outputs.md`)

## `@example` outputs to file

```@example
Main.AT_EXAMPLE_FILES[("png", :big)]
```
```@example
Main.AT_EXAMPLE_FILES[("png", :tiny)]
```
```@example
Main.AT_EXAMPLE_FILES[("webp", :big)]
```
```@example
Main.AT_EXAMPLE_FILES[("webp", :tiny)]
```
```@example
Main.AT_EXAMPLE_FILES[("gif", :big)]
```
```@example
Main.AT_EXAMPLE_FILES[("jpeg", :tiny)]
```

# No `@meta` block

This page deliberately has no `@meta` block, so `CurrentModule` and `CollapsedDocStrings` can only reach it through the `meta` keyword of `makedocs`. The `@ref` below resolves only if `CurrentModule` survives into the cross-reference stage, and the docstring below is marked as collapsed only if `CollapsedDocStrings` survives into the HTML writer.

See [`unexported_function`](@ref).

```@docs
unexported_function
```

# Test warnings in `@setup` block

Empty `@repl` block should not result in an assertion
```@setup empty
```

Same if it consists of only a comment.
```@setup just-comment
# comment
```

Unsupported keyword arguments should warn and be ignored.
```@setup shared ; typo = true
x = 1  # unique placeholder so that find_block_in_file can locate this block
```

Syntax errors in blocks should be a `@docerror`, not an exception (issue #2731).
```@setup with-error
1 !in 2
```

Missing name should warn.
```@setup
x = 2  # unique placeholder so that find_block_in_file can locate this block
```

# Syntax Versioning Tests

This page tests the `syntax=` attribute for doctests.

## Per-block syntax version

This doctest uses the `syntax=` attribute to specify Julia 1.14 syntax:

```jldoctest; syntax = v"1.14"
julia> result = @label myblock begin
           for i in 1:5
               if i > 3
                   break myblock i * 10
               end
           end
           0
       end
40
```

## Verifying syntax version with @VERSION

```jldoctest; syntax = v"1.14"
julia> (Base.Experimental.@VERSION).syntax == v"1.14"
true
```

## Negative test: syntax version 1.13

This verifies that setting `syntax = v"1.13"` actually uses the 1.13 parser,
not the default one.

```jldoctest; syntax = v"1.13"
julia> (Base.Experimental.@VERSION).syntax == v"1.13"
true
```

# LaTeX backend test case: LaTeX TOC style


With the default settings of `Documenter.jl`, the section name will be displayed in the TOC.

```tex
%% TOC settings
% -- TOC depth
%   value: [part, chapter, section, subsection,
%           subsubsection, paragraph, subparagraph]
\settocdepth{section}  % show "part+chapter+section" in TOC
```

You can modify settings that related to the TOC format by add customized `preamble.tex`.

## Only show part and chapter in TOC

```tex
\settocdepth{part}  % show "part+chapter" in TOC
```

## Default style vs. custom style

Left side: default style, show "part+chapter+section" in TOC.

Right side: custom style, show "part+chapter" in TOC.

![default vs. customized](./assets/default-customized.png)

# Style showcase for ``\LaTeX``

This page showcases the various page elements that are supported by Documenter.

## Table of contents

A table of contents can be generated with an [`@contents` block](@ref).
The one for this page renders as

```@contents
Pages = ["showcase.md"]
```

## Basic Markdown

Documenter can render all the [Markdown syntax supported by the Julia Markdown parser](https://docs.julialang.org/en/v1/stdlib/Markdown/).
You can use all the usual markdown syntax, such as **bold text** and _italic text_ and `print("inline code")`.

## Code blocks

Code blocks are rendered as follows:

```
This is an non-highlighted code block.
... Rendered in monospace.
```

When the language is specified for the block, e.g. by starting the block with ````` ```julia`````, the contents gets highlighted appropriately (for the language that are supported by the highlighter).

```julia
function foo(x::Integer)
    return @show x + 1
end
```

## Mathematics

For mathematics, both inline and display equations are available.
Inline equations should be written as LaTeX between two backticks,
e.g. ``` ``A x^2 + B x + C = 0`` ```.
It will render as ``A x^2 + B x + C = 0``.

The LaTeX for display equations must be wrapped in a ````` ```math ````` code block and will render like

```math
x_{1,2} = \frac{-B \pm \sqrt{B^2 - 4 A C}}{2A}
```

By default, the HTML output renders equations with [KaTeX](https://katex.org/), but [MathJax](https://www.mathjax.org/) can optionally be used as well.

!!! warning
    Similar to LaTeX, using `$` and `$$` to escape inline and display equations
    also works. However, doing so is deprecated and this functionality may be
    removed in a future release.

## Images

Include images using basic Markdown syntax:

![Enter a descriptive caption for the image](logo.png)

The path should be relative to the directory of the current file. Alternatively,
use `./` to begin a path relative to the `src` of the documents, e.g.,
`./logo.png`.

## Admonitions

Admonitions are colorful boxes used to highlight parts of the documentation.

Each admonition begins with three `!!!`, and then the content is indented
underneath with four spaces:
```
!!! note "An optional title"
    Here is something you should pay attention to.
```

Documenter supports a range of admonition types for different circumstances.

###### Note admonition
!!! note "'note' admonition"
    Admonitions look like this. This is a `!!! note`-type admonition.

    Note that admonitions themselves can contain other block-level elements too,
    such as code blocks. E.g.

    ```julia
    f(x) = x^2
    ```

    However, you **can not** have at-blocks, docstrings, doctests etc. in an admonition.

    Headings are OK though:
    # Heading 1
    ## Heading 2
    ### Heading 3
    #### Heading 4
    ##### Heading 5
    ###### Heading 6

###### Info admonition
!!! info "'info' admonition"
    This is a `!!! info`-type admonition. This is the same as a `!!! note`-type.

###### Tip admonition
!!! tip "'tip' admonition"
    This is a `!!! tip`-type admonition.

###### Warning admonition
!!! warning "'warning' admonition"
    This is a `!!! warning`-type admonition.

###### Danger admonition
!!! danger "'danger' admonition"
    This is a `!!! danger`-type admonition.

###### Compat admonition
!!! compat "'compat' admonition"
    This is a `!!! compat`-type admonition.

###### Unknown admonition class
!!! ukw "Unknown admonition class"
    Admonition with an unknown admonition class. This is a `code example`.

## Lists

Tight lists look as follows

* Lorem ipsum dolor sit amet, consectetur adipiscing elit.
* Nulla quis venenatis justo.
* In non _sodales_ eros.

If the lists contain paragraphs or other block level elements, they look like this:

* Morbi et varius nisl, eu semper orci.

  Donec vel nibh sapien. Maecenas ultricies mauris sapien. Nunc et sem ac justo ultricies dignissim ac vitae sem.

* Nulla molestie aliquet metus, a dapibus ligula.

  Morbi pellentesque sodales sollicitudin. Fusce semper placerat suscipit. Aliquam semper tempus ex, non efficitur erat posuere in. Fusce at orci eu ex sagittis commodo.

  > Fusce tempus scelerisque egestas. Pellentesque varius nulla a varius fringilla.

  Fusce nec urna eu orci porta blandit.

Numbered lists are also supported

1. Lorem ipsum dolor sit amet, consectetur adipiscing elit.
2. Nulla quis venenatis justo.
3. In non _sodales_ eros.

As are nested lists

* Morbi et varius nisl, eu semper orci.

  Donec vel nibh sapien. Maecenas ultricies mauris sapien. Nunc et sem ac justo ultricies dignissim ac vitae sem.

  - Lorem ipsum dolor sit amet, consectetur adipiscing elit.
  - Nulla quis venenatis justo.
  - In non _sodales_ eros.

* Nulla molestie aliquet metus, a dapibus ligula.

  1. Lorem ipsum dolor sit amet, consectetur adipiscing elit.
  2. Nulla quis venenatis justo.
  3. In non _sodales_ eros.

  Fusce nec urna eu orci porta blandit.

Lists can also be included in other blocks that can contain block level items

!!! note "Bulleted lists in admonitions"

    * Lorem ipsum dolor sit amet, consectetur adipiscing elit.
    * Nulla quis venenatis justo.
    * In non _sodales_ eros.

!!! note "Large lists in admonitions"

    * Morbi et varius nisl, eu semper orci.

      Donec vel nibh sapien. Maecenas ultricies mauris sapien. Nunc et sem ac justo ultricies dignissim ac vitae sem.

      - Lorem ipsum dolor sit amet, consectetur adipiscing elit.
      - Nulla quis venenatis justo.
      - In non _sodales_ eros.

    * Nulla molestie aliquet metus, a dapibus ligula.

      1. Lorem ipsum dolor sit amet, consectetur adipiscing elit.
      2. Nulla quis venenatis justo.
      3. In non _sodales_ eros.

      Fusce nec urna eu orci porta blandit.

> * Morbi et varius nisl, eu semper orci.
>
>   Donec vel nibh sapien. Maecenas ultricies mauris sapien. Nunc et sem ac justo ultricies dignissim ac vitae sem.
>
>   - Lorem ipsum dolor sit amet, consectetur adipiscing elit.
>   - Nulla quis venenatis justo.
>   - In non _sodales_ eros.

## Tables

| object | implemented |      value |
|--------|-------------|------------|
| `A`    |      ✓      |      10.00 |
| `BB`   |      ✓      | 1000000.00 |

With explicit alignment.

| object | implemented |      value |
| :---   |    :---:    |       ---: |
| `A`    |      ✓      |      10.00 |
| `BB`   |      ✓      | 1000000.00 |
| `CC`   |      v      | 1000000.00 |

Huges tables get scaled down:

```@eval
using Markdown
nrows, ncols = 10, 50
table = Markdown.Table(
    [[[string(i, "-", j)] for j = 1:ncols] for i = 1:nrows],
    [:c for _ in 1:ncols],
)
Markdown.MD([table])
```

Including ones generated by at-example blocks with `show` methods:

```@example
using Markdown
nrows, ncols = 5, 5
table = Markdown.Table(
    [[[string(i, "-", j)] for j = 1:ncols] for i = 1:nrows],
    [:c for _ in 1:ncols],
)
Markdown.MD([table])
```

```@example
using Markdown
nrows, ncols = 10, 50
table = Markdown.Table(
    [[[string(i, "-", j)] for j = 1:ncols] for i = 1:nrows],
    [:c for _ in 1:ncols],
)
Markdown.MD([table])
```

Tables that are too long for a single page break across pages, with the header row repeated:

```@eval
using Markdown
nrows = 100
rows = Any[Any[["row"], ["value"]]]
for i in 1:nrows
    push!(rows, Any[[string(i)], [string(i^2)]])
end
Markdown.MD([Markdown.Table(rows, [:l, :r])])
```

However, tables with huge cells are not properly handled right now:

| object | implemented |      value |
| :---   |    :---:    |       ---: |
| `A`    |      ✓      |      10.00 |
| `BBBBBBBBBBBBBBBBBBBB` | ✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓✓ | 1000000000000000000000000000000000000000000000000000000.00 |

## Footnotes

Footnote references can be added with the `[^label]` syntax.[^1] The footnote definitions get collected at the bottom of the page.

The footnote label can be an arbitrary string and even consist of block-level elements.[^Clarke61]

[^1]: A footnote definition uses the `[^label]: ...` syntax in a block scope.

[^Clarke61]:
    > Any sufficiently advanced technology is indistinguishable from magic.
    Arthur C. Clarke, _Profiles of the Future_ (1961): Clarke's Third Law.

Footnote with more block contents.[^footblock]

[^footblock]:

    And a link to another footnote[^1].

    !!! note "Admonition.."

        .. in a footnote.

    And a code block:

    ```julia
    function f(x)
        return x
    end
    ```

## Headings

Finally, headings render as follows

### Heading level 3
#### Heading level 4
##### Heading level 5
###### Heading level 6

To see an example of a level 1 heading see the page title and for level 2 heading, see the one just under this paragraph.

!!! note "Headings in sidebars"
    Level 1 and 2 heading show up in the sidebar, for the current page.

## Doctesting example

Often you want to write code example such as this:

```jldoctest
julia> f(x) = x^2
f (generic function with 1 method)

julia> f(3)
9
```

If you write them as a ````` ```jldoctest ````` code block, Documenter can make sure that the doctest has not become outdated. See [Doctests](@ref) for more information.

Script-style doctests are supported too:

```jldoctest
2 + 2
# output
4
```

## Running interactive code

[`@example` block](@ref) run a code snippet and insert the output into the document.
E.g. the following Markdown

````markdown
```@example
typeof(π)
```
````

becomes the following code-output block pair

```@example
typeof(π)
```

If the last element can be rendered as `text/latex`:

```@example latexrender
struct LaTeXRender
    s :: String
end
function Base.show(io, ::MIME"text/latex", r::LaTeXRender)
    write(io, """
    Rendering \\texttt{LaTeXRender}: $(r.s)
    """)
end
nothing # hide
```

```@example latexrender
LaTeXRender("render this")
```

If the last value in an `@example` block is a `nothing`, the standard output from the blocks' evaluation gets displayed instead

```@example
println("Hello World")
```

However, do note that if the block prints to standard output, but also has a final non-`nothing` value, the standard output just gets discarded:

```@example
println("Hello World")
42
```

### at-REPL blocks

```@repl
(1 // 2)^2
```

```@repl
x = 1

x // 2

ans^2
```

## Setup blocks

`SetupNode` with `x = 5`...

```@setup foo
x = 5
```

...makes the following evaluate to...

```@example foo
x + 1
```

### Color output

Output from [`@repl` block](@ref)s and [`@example` block](@ref)s support colored output,
transforming ANSI color codes to HTML.

#### Colored `@repl` block output

**Input:**
````markdown
```@repl
printstyled("This should be in bold light cyan.", color=:light_cyan, bold=true)
```
````

**Output:**
```@repl
printstyled("This should be in bold cyan.", color=:cyan, bold=true)
```

**Locally disabled color:**
````markdown
```@repl; ansicolor=false
printstyled("This should be in bold light cyan.", color=:light_cyan, bold=true)
```
````
```@repl; ansicolor=false
printstyled("This should be in bold light cyan.", color=:light_cyan, bold=true)
```

#### Raw ANSI code output

Regardless of the color setting, when you print the ANSI escape codes directly, coloring is
enabled.
```@example
for color in 0:15
    print("\e[38;5;$color;48;5;$(color)m  ")
    print("\e[49m", lpad(color, 3), " ")
    color % 8 == 7 && println()
end
print("\e[m")
```

## Doctest showcase

Currently exists just so that there would be doctests to run in manual pages of Documenter's
manual. This page does not show up in navigation.

```jldoctest
julia> 2 + 2
4
```

The following doctests needs doctestsetup:

```jldoctest; setup=:(using Documenter)
julia> Documenter.splitexpr(:(Foo.Bar.baz))
(:(Foo.Bar), :(:baz))
```

Let's also try `@meta` blocks:

```@meta
DocTestSetup = quote
  f(x) = x^2
end
```

```jldoctest
julia> f(2)
4
```

```@meta
DocTestSetup = nothing
```

## at-raw blocks

Only one of them should end up in the output.

```@raw html
foo
```
```@raw latex
bar
```

## Cross-references

Here we link to the heading [Cross-references](@ref).
[This](@ref "Cross-references") also links there.

We can also link to other pages, such as: [An index of docstrings](@ref).

Then there are link to docstrings: [`Foo.bar`](@ref), [`foobar`](@ref Foo.bar), [foobar](@ref Foo.bar).

And issue references: [#1245](@ref)

### `@example`-block
### `@contents`-block
### `@repl`-block

## Contents

```@contents
```

This source file contains a working doctest:

```jldoctest
julia> 2 + 2
4
```

Testing catching errors:

```jldoctest
julia> error("0123456789")
ERROR: 0123456789
Stacktrace:
[...]
```

```jldoctest; filter = r"\b[0-9]+\b"
julia> error("0123456789")
ERROR: 9876543210
Stacktrace:
[...]
```

Test comments or comment-like lines:

```jldoctest
julia> f(x) = println("# output from f\n$x");

julia> f(42)
# output from f
42

julia> f(42)
       # comment line
# output from f
42
```

```jldoctest
julia> let x = 1
           println("$x")
           # comment
           println("$x")
       end
1
1

julia> println("xyz")
       # comment
xyz
```

Original issue:

```@meta
DocTestSetup = quote
    methods(args...) = Text("""
    # 1 method for generic function "f":
    [1] f() in Main at none:1
    """)
end
```
```jldoctest
julia> f()=0
f (generic function with 1 method)

julia> methods(f)
# 1 method for generic function "f":
[1] f() in Main at none:1
```
```@meta
DocTestSetup = nothing
```

Comments at the start:

```jldoctest
# Initial comments before the first julia> prompt..
# .. should be ignored.
julia> 2 + 2
4
```

Empty output:

```jldoctest
nothing
# output
```

Filtering with regex substitutions:

```jldoctest; filter = r"([0-9]+\.[0-9]{8})[0-9]+" => s"\1***"
julia> sqrt(2)
1.41421356000
```

# Markdown Syntax

This page tests complex or unusual Markdown rendering.

*   Deeply
    *   nested
        *   lists

| Tables      | Are         |
|-------------|-------------|
| complex     | to          |
| parse       | correctly   |

> A blockquote with
> > nested blockquotes
> > and other elements
> 
> * like
> * lists

!!! note "A Note Admonition"
    This is a note admonition to test how admonitions are rendered and indexed for search.

!!! warning "Warning About Complex Syntax"
    Complex markdown syntax can sometimes cause rendering issues. This warning admonition tests edge cases.

!!! tip "Useful Tip"
    Use admonitions to highlight important information in your documentation.

!!! danger "Critical Information"
    This danger admonition contains critical safety information that should be easily searchable.

# Cross-references

Basic x-refs:

* [X-ref target](@ref)
* [`Mod.func`](@ref)

Named x-refs:

* [X-ref target with an ID](@ref xreftarget)
* [docstring target](@ref Mod.func)
* [docstring target via backticks](@ref `Mod.func`)
* [string target](@ref "X-ref target")
* [inline anchor target](@ref inline-anchor-target)

Inline anchor on arbitrary (non-header) content: [an anchored phrase](@id inline-anchor-target).

## X-ref target

## [X-ref target with id](@id xreftarget)

## [x-ref with `@code` block](@id xrefcodeblock)

This should render as ```x-ref with `@code` block```: #2010, #2011.

# Testing

We set up some test code and create an object with a finalizer.

```@setup
@eval Main finalizer_count = [0]

mutable struct MyMutableStruct
  bar
  function MyMutableStruct(bar)
      x = new(bar)
      finalizer(x) do y
        Main.finalizer_count[1] += 1
      end
  end
end

a = MyMutableStruct(1)
```

Once Documenter is finished processing this page, it should remove the
reference to the object `a` and a subsequent garbage collection should free
it, which we can later test by observing the value of `Main.finalizer_count`.

# Example blocks

```@example example-1
a = 1 # simple assignment
```

```@example example-2
nothing = 1 # it is possible to use `nothing` as a variable name
a = 2
```

```@example example-3
nothing() = 3 # it is possible to use `nothing` as a function name
a = nothing()
```

```@example example-4
@static if VERSION >= v"1.8"
typed::String = "string" # it is possible to use `::` to specify the type of a variable
end
```

```@example example-5
const a = 5 # it is possible to use `const` to define a constant
```

Once Documenter is finished processing this page, it attempts to remove the 
variables defined in the example blocks. Documenter should not error when 
processing those example blocks even if it cannot remove the variables.

# JuliaValue

It is possible to create pseudo-interpolations with the `Markdown` parser: $foo.

$([1 2 3; 4 5 6])

They do not get evaluated.

They can also come from docstrings:
```@docs
WarningTests.dummyFunctionWithUnbalancedDollar
```

```@docs
DocTestFixTest.Foo.foo
```

```jldoctest
julia> Main.DocTestFixArray_2468
4×1×1 Array{Int64,3}:
[:, :, 1] =
 1
 2
 3
 4

julia> Main.DocTestFixArray_1234
4-element Array{Int64,1}:
 1
 2
 3
 4
```
```jldoctest
julia> Main.DocTestFixArray_1234
4-element Array{Int64,1}:
 1
 2
 3
 4

julia> Main.DocTestFixArray_2468
4-element Array{Int64,1}:
 1
 2
 3
 4
```
```jldoctest
julia> Main.DocTestFixArray_2468
4-element Array{Int64,1}:
 1
 2
 3
 4

julia> Main.DocTestFixArray_2468
4-element Array{Int64,1}:
 1
 2
 3
 4
```
```jldoctest
julia> begin
           Main.DocTestFixArray_2468
       end
4-element Array{Int64,1}:
 1
 2
 3
 4
```
```jldoctest
Main.DocTestFixArray_2468

# output

4-element Array{Int64,1}:
 1
 2
 3
 4
```
```jldoctest; filter = r"foo"
julia> println("  foobar")
  foobaz
```
```jldoctest
julia> 1 + 2

julia> 3 + 4
```
```jldoctest
julia> a = (1, 2)

julia> a
```
```jldoctest
# Leading comment
julia> a
ERROR: UndefVarError: `a` not defined

julia> a = Int64[1, 2]
2-element Vector{Int64}:
 1
 2

julia> b

julia> a
2-element Vector{Int64}:
 2

julia> a;
1

julia> b;

julia> a = Int64[3, 4];

julia> a
 3
 4
```
```jldoctest
julia> a = ("a", "b", "c");

julia> a
```
```jldoctest
julia> :a / :b
ERROR: MethodError: no method matching /(::Symbol, ::Symbol)
[...]
```

Blocks nested in a list are indented in the source file:

- a list item

  ```jldoctest
  julia> Main.DocTestFixArray_2468
  4-element Array{Int64,1}:
   1
   2
   3
   4
  ```

Blocks in a block quote carry a `>` marker, blank lines included:

> ```jldoctest
> julia> Main.DocTestFixArray_2468
> 4-element Array{Int64,1}:
>  1
>  2
>  3
>  4
>
> julia> Main.DocTestFixArray_1234
> 4-element Array{Int64,1}:
>  1
>  2
>  3
>  4
> ```

# Issue 491

Tests that code-like blocks are expanded in nested Markdown contexts.

- Recurse into lists:

  ```@repl
  item = nothing
  ```

  1. More than single layer of nesting as well:

     ```@repl
     item_item = nothing
     ```

!!! note
    Recurse into admonitions:
    ```@repl
    admonition = nothing
    ```
    > And also block quotes
    > ```@repl
    > admonition_blockquote = nothing
    > ```

!!! note
    Test the different types of code-like blocks:

    ```@eval
    import Markdown
    Markdown.parse("expanded_"*"eval")
    ```

    ```@example
    println("expanded_", "example")
    ```

    ```@setup setup
    var = "expanded_"*"setup"
    ```

    ```@example setup
    println(var)
    ```

    ```@raw html
    <p>expanded_raw</p>
    ```

```@docs
DocTestFixTest.Foo.foo
```

```jldoctest
julia> Main.DocTestFixArray_2468
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8

julia> Main.DocTestFixArray_1234
4×1×1 Array{Int64,3}:
[:, :, 1] =
 1
 2
 3
 4
```
```jldoctest
julia> Main.DocTestFixArray_1234
4×1×1 Array{Int64,3}:
[:, :, 1] =
 1
 2
 3
 4

julia> Main.DocTestFixArray_2468
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8
```
```jldoctest
julia> Main.DocTestFixArray_2468
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8

julia> Main.DocTestFixArray_2468
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8
```
```jldoctest
julia> begin
           Main.DocTestFixArray_2468
       end
4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8
```
```jldoctest
Main.DocTestFixArray_2468

# output

4×1×1 Array{Int64,3}:
[:, :, 1] =
 2
 4
 6
 8
```
```jldoctest; filter = r"foo"
julia> println("  foobar")
  foobar
```
```jldoctest
julia> 1 + 2
3

julia> 3 + 4
7
```
```jldoctest
julia> a = (1, 2)
(1, 2)

julia> a
(1, 2)
```
```jldoctest
# Leading comment
julia> a
ERROR: UndefVarError: `a` not defined in `Main`
Suggestion: check for spelling errors or missing imports.

julia> a = Int64[1, 2]
2-element Vector{Int64}:
 1
 2

julia> b
ERROR: UndefVarError: `b` not defined in `Main`
Suggestion: check for spelling errors or missing imports.

julia> a
2-element Vector{Int64}:
 1
 2

julia> a;

julia> b;
ERROR: UndefVarError: `b` not defined in `Main`
Suggestion: check for spelling errors or missing imports.

julia> a = Int64[3, 4];

julia> a
2-element Vector{Int64}:
 3
 4
```
```jldoctest
julia> a = ("a", "b", "c");

julia> a
("a", "b", "c")
```
```jldoctest
julia> :a / :b
ERROR: MethodError: no method matching /(::Symbol, ::Symbol)
[...]
```

Blocks nested in a list are indented in the source file:

- a list item

  ```jldoctest
  julia> Main.DocTestFixArray_2468
  4×1×1 Array{Int64,3}:
  [:, :, 1] =
   2
   4
   6
   8
  ```

Blocks in a block quote carry a `>` marker, blank lines included:

> ```jldoctest
> julia> Main.DocTestFixArray_2468
> 4×1×1 Array{Int64,3}:
> [:, :, 1] =
>  2
>  4
>  6
>  8
>
> julia> Main.DocTestFixArray_1234
> 4×1×1 Array{Int64,3}:
> [:, :, 1] =
>  1
>  2
>  3
>  4
> ```

# Cross-References

This page tests cross-referencing syntax.

[A link to the welcome page](@ref Welcome).

## Docstring References

This section tests references to documented functions and types.

See the documentation for [`func1`](@ref Main.DummyModule.func1) for more details.

You can also reference [`func2`](@ref Main.DummyModule.func2) and the custom type [`MyType`](@ref Main.DummyModule.MyType).

Here are some inline references: [`func1`](@ref Main.DummyModule.func1), [`func2`](@ref Main.DummyModule.func2), and [`MyType`](@ref Main.DummyModule.MyType).

## Mixed References

A reference to both a section [An Empty Section](@ref) and a function [`func1`](@ref Main.DummyModule.func1) in the same paragraph.

References to multiple functions: [`func1`](@ref Main.DummyModule.func1), [`func2`](@ref Main.DummyModule.func2), and [`MyType`](@ref Main.DummyModule.MyType) all in one line.

# Test warnings in `@example` block

Empty `@example` block should not result in an assertion (issue #2206).
```@example
```

Same if it consists of only a comment.
```@example
# comment
```

Syntax errors in blocks should be a `@docerror`, not an exception (issue #2731).
```@example
1 !in 2
```

# Test warnings in `@docs` block

Binding that does not exist.
```@docs
Base.nonsenseBindingThatDoesNotExist()
```

Binding that exists but has no documentation.
```@docs
Base.sin()
```

Syntax error due to invalid type in argument list.
```@docs
Base.sin(::NonsenseTypeThatDoesNotExist)
```

Syntax errors in blocks should be a `@docerror`, not an exception (issue #2731).
```@docs
1 !in 2
```

# Simple LaTeX build

This build only contains a single paragraph of text to make sure that a
near-empty LaTeX builds passes.

```julia-repl
julia> 127 % Int8
127
```
## Issue 1119

```julia
1 % 2
1 ⊻ 2
1 | 2
```

## Escaping: ~, ^, \\, ', ", _, &, %, $, #, { and }.

~, ^, \\, ', ", _, &, %, $, #, { and }.

!!! info "~, ^, \\, ', ", _, &, %, $, #, { and }."

    ~, ^, \\, ', ", _, &, %, $, #, { and }.

## Issue 1392

```julia-repl sayhello2
julia> function foo end;
```

## Issue 1401: rendering custom LaTeX

### @example block / show with `text/latex` MIME

```@example
struct Table end

Base.show(io, ::MIME"text/latex", ::Table) = write(io, raw"""
\begin{tabular}{r|ccc}
        & i & y & z\\
        \hline
        & Int64 & Char & Int64\\
        \hline
        1 & 1 & 'A' & 5 \\
        2 & 2 & 'B' & 6 \\
        3 & 3 & 'C' & 7 \\
        4 & 4 & 'D' & 8 \\
\end{tabular}
""")

Table()
```

### @raw block

```@raw latex
\begin{tabular}{r|ccc}
        & i & y & z\\
        \hline
        & Int64 & Char & Int64\\
        \hline
        1 & 1 & 'A' & 5 \\
        2 & 2 & 'B' & 6 \\
        3 & 3 & 'C' & 7 \\
        4 & 4 & 'D' & 8 \\
\end{tabular}
```

### Inline LaTeX

_Note: this should render as just text, not as a table._

\begin{tabular}{r|ccc}
        & i & y & z\\
        \hline
        & Int64 & Char & Int64\\
        \hline
        1 & 1 & 'A' & 5 \\
        2 & 2 & 'B' & 6 \\
        3 & 3 & 'C' & 7 \\
        4 & 4 & 'D' & 8 \\
\end{tabular}

## Printing LaTeX from Julia

To pretty-print LaTeX from Julia, overload `Base.show` for the
`MIME"text/latex"` type. For example:
```@example
struct LaTeXEquation
    content::String
end

function Base.show(io::IO, ::MIME"text/latex", x::LaTeXEquation)
    # Wrap in $$ for display math printing
    return print(io, "\$\$ " * x.content * " \$\$")
end

LaTeXEquation(raw"""
    \left[\begin{array}{c}
        x \\
        y
    \end{array}\right]
""")
```

```@example
struct LaTeXEquation2
    content::String
end

function Base.show(io::IO, ::MIME"text/latex", x::LaTeXEquation2)
    # Wrap in \[...\] for display math printing
    return print(io, "\\[ " * x.content * " \\]")
end

LaTeXEquation2(raw"""
    \left[\begin{array}{c}
        x \\
        y
    \end{array}\right]
""")
```

## `LineBreak` node

This sentence\
should be over **multiple\
lines**.

## Issue 2210

[Description with ~](https://link.with/~tilde)

## Issue 2300

You Shall Not Break! You Shall Not Break! You Shall Not Break!

## PR 2056

Issues: `#1521`, `#2054`, `#2399`

```@repl
x = 1 # hide
x = 2 # hide
println(x)
x
```

# Test warnings in `@eval` block

Empty `@example` block should not result in an assertion (issue #2206).
```@eval
```

Same if it consists of only a comment.
```@eval
# comment
```

Syntax errors in blocks should be a `@docerror`, not an exception (issue #2731).
```@eval
1 !in 2
```

Unsupported keyword arguments should warn and be ignored.
```@eval named ; typo = true
nothing
```

Eval block evaluates to a value with unsupported type (should be `nothing`
or `Markdown.MD`).
```@eval
"expanded_"*"eval"
```

# Test other `@eval` block behavior

Verify that `cd(path)` in an `@eval` block works as intended.
```@eval
using Test
dir = Base.pwd()
cd("..")
rel = relpath(Base.pwd(),dir)
@test rel == ".."
nothing
```
